

#ifndef _16BITCOLOR_H_INC_
#define _16BITCOLOR_H_INC_


#define BITSGREEN	6	// 5 or 6 for 555 or 565 16 bit color DIB

#if BITSGREEN == 5
	#define SHIFTRED	10
	#define ANDGREEN	31
	#define LEFTGREEN	3
#else
	#define SHIFTRED	11
	#define ANDGREEN	63
	#define LEFTGREEN	2
#endif

#define GFX_FAST 1

#ifndef GFX_FAST
	// accurate
	#define GETR(a) (((((a)>>SHIFTRED)&31)*255)/31)
	#define GETG(a) (((((a)>> 5)&ANDGREEN)*255)/ANDGREEN)
	#define GETB(a) (((((a)    )&31)*255)/31)
#else
	// Inacurate (just 3% too dark), but faster...
	#define GETR(a) ((((a)>>SHIFTRED  )&31)<<3)
	#define GETG(a) ((((a)>>5)&ANDGREEN)<<LEFTGREEN)
	#define GETB(a) ((((a)            )&31)<<3)
#endif

inline unsigned short PackColor(unsigned int r, unsigned int g, unsigned int b)
{
	return ((unsigned short)(
	(b>>3) +
	((g>>LEFTGREEN)<<5) +
	((r>>3)<<SHIFTRED))  );
}

// COLORREF to short
inline unsigned short PackColor(unsigned int c)
{
	return PackColor(c&0xff, (c>>8)&0xff, (c>>16)&0xff);
}

// short to COLORREF
inline unsigned int UnPackColor(unsigned short packed)
{
	#define unpackRGB(r,g,b)          (((unsigned long)(((unsigned char)(r)|((unsigned short)((unsigned char)(g))<<8))|(((unsigned long)(unsigned char)(b))<<16))))
	return  unpackRGB(GETR(packed), GETG(packed), GETB(packed));
	#undef  unpackRGB
}

#endif