#ifndef FRAMEWORK_H
#define FRAMEWORK_H


// - HEADERS ---------------------------------------------------

#include <windows.h>
#include "obitmap.h"
#include "okeyboard.h"
#include "omouse.h"
#include "oscreen.h"
#include "ofont.h"
//#include "osound.h"
#include "sound.h"


// - PROTOTYPES ------------------------------------------------
class oFramework
{
	struct FULLSCREEN
	{
		RECT	rtDesktop, rtInputPanel, rtSipButton, rtTaskBar;
		HWND	hWndSipButton, hWndTaskBar, hWndInputPanel;
		bool IsFullscreen;
	} m_FullScreen;

public:
	oFramework();
	~oFramework();
	int		DoFullScreen(bool show);
	bool	Init(HINSTANCE argInstance, int width, int height, bool landscape);
	bool	ShutDown();
	bool	WinMSG();		// Process messages - return 1 if you should quit

	float	ShowScreen();

	bool	m_AllowEscape;
	void VibratePhone(int duration_ms, float amplitude=1.0f);
	HWND	m_HWND;

protected:
	bool LoadDLLs();
	HINSTANCE m_hGAPI, m_hAYGSHELL;

	static void	Suspend(bool argSuspend);
private:
	static LRESULT CALLBACK WinProc(HWND argWindow, UINT argMessage, WPARAM argData1, LPARAM argData2);
};

//#ifdef _WIN32_WCE
// Dynamically load GAPI
struct GXDisplayProperties {
	DWORD cxWidth;
	DWORD cyHeight;			// notice lack of 'th' in the word height.
	long cbxPitch;			// number of bytes to move right one x pixel - can be negative.
	long cbyPitch;			// number of bytes to move down one y pixel - can be negative.
	long cBPP;				// # of bits in each pixel
	DWORD ffFormat;			// format flags.
};
#define GX_FULLSCREEN	0x01		// for OpenDisplay()
#define GX_NORMALKEYS	0x02
#define GX_LANDSCAPEKEYS	0x03

	typedef int   (*PFNGXOpenDisplay)(HWND hWnd, DWORD dwFlags);
	typedef int   (*PFNGXCloseDisplay)();
	typedef void* (*PFNGXBeginDraw)();
	typedef int   (*PFNGXEndDraw)();
	typedef int   (*PFNGXOpenInput)();
	typedef int   (*PFNGXCloseInput)();
	typedef GXDisplayProperties (*PFNGXGetDisplayProperties)();
	typedef int   (*PFNGXSuspend)();
	typedef int   (*PFNGXResume)();
	typedef int   (*PFNGXSetViewport)( DWORD dwTop, DWORD dwHeight, DWORD dwReserved1, DWORD dwReserved2 );
	typedef BOOL  (*PFNGXIsDisplayDRAMBuffer)();
    
	extern PFNGXOpenDisplay          GXOpenDisplay;
	extern PFNGXCloseDisplay         GXCloseDisplay;
	extern PFNGXBeginDraw            GXBeginDraw;
	extern PFNGXEndDraw              GXEndDraw;
	extern PFNGXOpenInput            GXOpenInput;
	extern PFNGXCloseInput           GXCloseInput;
	extern PFNGXGetDisplayProperties GXGetDisplayProperties;
	extern PFNGXSuspend              GXSuspend;
	extern PFNGXResume               GXResume;
	extern PFNGXSetViewport          GXSetViewport;
	extern PFNGXIsDisplayDRAMBuffer  GXIsDisplayDRAMBuffer;


// AYGSHELL.dll functions
	typedef struct {WORD wDuration; BYTE bAmplitude; BYTE bFrequency;} VIBRATENOTE;
	typedef enum {VDC_AMPLITUDE, VDC_FREQUENCY, VDC_LAST} VIBRATEDEVICECAPS;

	typedef int (*PFNSHFullScreen)(HWND, unsigned long);
	typedef HRESULT(*PFNVibrate)(DWORD cvn, const VIBRATENOTE * rgvn, BOOL fRepeat, DWORD dwTimeout);
	typedef HRESULT(*PFNVibrateStop)(void);
	typedef int (*PFNVibrateGetDeviceCaps)(VIBRATEDEVICECAPS vdc);
	typedef int (*PFNVibrateGetDeviceCaps)(VIBRATEDEVICECAPS vdc);
	extern PFNSHFullScreen			SHFullScreen;
	extern PFNVibrate				Vibrate;
	extern PFNVibrateStop			VibrateStop;
	extern PFNVibrateGetDeviceCaps	VibrateGetDeviceCaps;
//#endif

extern bool Terminated;  // True if the program has been terminated.
extern bool Initialized; // True if the program has been initialized.

#endif
