// - HEADERS ---------------------------------------------------
#include "Stdafx.h"
#include "OpenGLRainbows.h"
#include "Rainbows3D.h"

static long g_xDemo = 0;
static int __IsDemoVersion=FALSE;


#ifdef _WIN32_WCE
#ifndef POCKETPC
#error You must #define POCKETPC
#endif
#endif

#include "ceFramework.h"
#include <math.h>
// GLOBALS

namespace __GLBASIC__
{
	extern OpenGLRainbows*	__g_pRbow;
	extern Rainbows3D*		__g_pRbow3D;

	extern int			__g_AllowEscape;
	extern int			__g_paused;
	extern int			__g_allowPause;
	// force this a demo version
	void __SetDemoVersion()
	{
		__IsDemoVersion = TRUE;
	}
};


extern "C" void glb_do_pause(int pause);
extern "C" int glb_allow_escape();


bool Terminated;  // True if the program has been terminated.
// bool Suspended;   
bool Initialized; // True if the program has been initialized.


//#ifndef _WIN32_WCE // Desktop-PC
//	int oFramework::DoFullScreen	(bool){return 0;}
//#else // PocketPC



#define SHFS_SHOWTASKBAR	0x1
#define SHFS_HIDETASKBAR	0x2
#define SHFS_SHOWSIPBUTTON	0x4
#define SHFS_HIDESIPBUTTON	0x8
#define SHFS_SHOWSTARTICON	0x10
#define SHFS_HIDESTARTICON	0x20

int oFramework::DoFullScreen(bool show)
{
	if (show && !m_FullScreen.IsFullscreen)
	{
		m_FullScreen.IsFullscreen=true;
		SetCapture(Screen.Window); // Prevent input panel from getting taps
		if(SHFullScreen)
			SHFullScreen(Screen.Window, SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON | SHFS_HIDESTARTICON);
		if (m_FullScreen.hWndTaskBar)
		{
			// Hide the TaskBar
			ShowWindow(m_FullScreen.hWndTaskBar, SW_HIDE );
			MoveWindow(m_FullScreen.hWndTaskBar, 
					0, 
					m_FullScreen.rtDesktop.bottom, 
					m_FullScreen.rtTaskBar.right  - m_FullScreen.rtTaskBar.left, 
					m_FullScreen.rtTaskBar.bottom - m_FullScreen.rtTaskBar.top, 
					false);
		}
		// SHFullScreen will only put these in the background
		// guess what! they come back within a few seconds and
		// get topmost windows. Crap!
		// So, move these bastards below the visible screen, so
		// noone can accidentally tap 'em.
		if (m_FullScreen.hWndInputPanel)
		{
			// Reposition the input panel 
			ShowWindow(m_FullScreen.hWndInputPanel, SW_HIDE );
			MoveWindow(m_FullScreen.hWndInputPanel,
					0,
					m_FullScreen.rtDesktop.bottom, 
					m_FullScreen.rtInputPanel.right  - m_FullScreen.rtInputPanel.left, 
					m_FullScreen.rtInputPanel.bottom - m_FullScreen.rtInputPanel.top,
					false);
		}

		// Ensure the SIP button is found (Only for PocketPC)
		if (m_FullScreen.hWndSipButton)
		{
			// Hide the SIP panel 
			ShowWindow(m_FullScreen.hWndSipButton, SW_HIDE );
			MoveWindow(m_FullScreen.hWndSipButton,
					0,
					m_FullScreen.rtDesktop.bottom, 
					m_FullScreen.rtSipButton.right  - m_FullScreen.rtSipButton.left, 
					m_FullScreen.rtSipButton.bottom - m_FullScreen.rtSipButton.top,
					false);
		}

		// Now maximize my window
		#ifdef _WIN32_WCE
		SetWindowPos(Screen.Window, HWND_TOPMOST, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), SWP_SHOWWINDOW);
		#endif
		BringWindowToTop(Screen.Window);
	}
	else if(!show && m_FullScreen.IsFullscreen)
	{
		m_FullScreen.IsFullscreen=false;
		ReleaseCapture();
		if(SHFullScreen)
			SHFullScreen(Screen.Window, SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON | SHFS_SHOWSTARTICON);
		// Restore the TaskBar
		if (m_FullScreen.hWndTaskBar && ::IsWindow(m_FullScreen.hWndTaskBar))
		{
			MoveWindow(m_FullScreen.hWndTaskBar, 
					m_FullScreen.rtTaskBar.left, 
					m_FullScreen.rtTaskBar.top,
					m_FullScreen.rtTaskBar.right  - m_FullScreen.rtTaskBar.left,
					m_FullScreen.rtTaskBar.bottom - m_FullScreen.rtTaskBar.top,
					true);
			ShowWindow(m_FullScreen.hWndTaskBar, SW_SHOW);
			SetWindowPos(m_FullScreen.hWndTaskBar, HWND_TOPMOST, 0,0,0,0, SWP_NOSIZE|SWP_NOMOVE|SWP_SHOWWINDOW);
			BringWindowToTop(m_FullScreen.hWndTaskBar);
		}
		// Restore the input panel
		if (m_FullScreen.hWndInputPanel && ::IsWindow(m_FullScreen.hWndInputPanel))
		{
			MoveWindow(m_FullScreen.hWndInputPanel, 
					m_FullScreen.rtInputPanel.left,
					m_FullScreen.rtInputPanel.top,
					m_FullScreen.rtInputPanel.right - m_FullScreen.rtInputPanel.left,
					m_FullScreen.rtInputPanel.bottom - m_FullScreen.rtInputPanel.top,
					true);
			SetWindowPos(m_FullScreen.hWndInputPanel, HWND_TOPMOST, 0,0,0,0, SWP_NOSIZE|SWP_NOMOVE|SWP_SHOWWINDOW);
			BringWindowToTop(m_FullScreen.hWndInputPanel);
			ShowWindow(m_FullScreen.hWndInputPanel, SW_HIDE); // OK?
		}

		// Ensure the SIP button is found (Only for PocketPC)
		if (m_FullScreen.hWndSipButton && ::IsWindow(m_FullScreen.hWndSipButton))
		{
			// Hide the input panel 
			MoveWindow(m_FullScreen.hWndSipButton,
					m_FullScreen.rtSipButton.left,
					m_FullScreen.rtSipButton.top, 
					m_FullScreen.rtSipButton.right  - m_FullScreen.rtSipButton.left, 
					m_FullScreen.rtSipButton.bottom - m_FullScreen.rtSipButton.top,
					true);
			ShowWindow(m_FullScreen.hWndSipButton, SW_SHOW);
//				SetWindowPos(m_FullScreen.hWndSipButton, HWND_TOPMOST, 0,0,0,0, SWP_NOSIZE|SWP_NOMOVE|SWP_SHOWWINDOW);
//				BringWindowToTop(m_FullScreen.hWndSipButton);
		}
	}
	return true;
}




//#endif


oFramework::oFramework()
{
	m_AllowEscape = true;
	Terminated  = false; // True if the program has been terminated.
	glb_do_pause( false); // True if the program has been suspended.
	Initialized = false; // True if the program has been initialized.
	m_HWND = 0L;
	
	m_hGAPI=NULL;
	m_hAYGSHELL=NULL;

	// Setup Fullscreen
	m_FullScreen.IsFullscreen=false;
	m_FullScreen.hWndSipButton = FindWindow( TEXT ("MS_SIPBUTTON"), NULL );
	m_FullScreen.hWndTaskBar   = FindWindow( TEXT ("HHTaskBar"), NULL );
	m_FullScreen.hWndInputPanel= FindWindow( TEXT ("SipWndClass"), NULL );

	if (m_FullScreen.hWndInputPanel != NULL)
		// Get the original Input panel window size
		GetWindowRect(m_FullScreen.hWndInputPanel, &m_FullScreen.rtInputPanel);
	if (m_FullScreen.hWndSipButton != NULL)
		// Get the original Input panel window size
		GetWindowRect(m_FullScreen.hWndSipButton, &m_FullScreen.rtSipButton);
	if (m_FullScreen.hWndTaskBar != NULL) GetWindowRect(m_FullScreen.hWndTaskBar, &m_FullScreen.rtTaskBar);
	m_FullScreen.rtDesktop.top=0; m_FullScreen.rtDesktop.left=0; m_FullScreen.rtDesktop.right=GetSystemMetrics(SM_CXSCREEN); m_FullScreen.rtDesktop.bottom=GetSystemMetrics(SM_CYSCREEN);
}

oFramework::~oFramework()
{
	if(m_hGAPI)
		FreeLibrary(m_hGAPI);
	m_hGAPI=NULL;
	if (m_hAYGSHELL)
		FreeLibrary(m_hAYGSHELL);
	m_hAYGSHELL=NULL;
}



#define szAppName	TEXT("GLBasic Game")
#define szClassName TEXT("GLBasic")

namespace __GLBASIC__
{
#define __g_LicenseBits	OpenGLRainbows10FreeMemoriesEiiiii // harder to find in HTML5
extern int __g_LicenseBits;
extern bool		__g_DidNET;
extern bool		__g_Did3D;
};


// - FUNCTIONS -------------------------------------------------
bool oFramework::Init(HINSTANCE argInstance, int width, int height, bool landscape)
{
	LoadDLLs();

	RECT       WindowRectangle;

	// - INITIALIZE -
	// Define the window class:
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WinProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= argInstance;
    wc.hIcon			= 0;
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szClassName;
	RegisterClass(&wc);

	// Set the window dimensions:
	WindowRectangle.left   = 0;
	WindowRectangle.top    = 0;

	if(landscape)
	{
		WindowRectangle.right  = height;
		WindowRectangle.bottom = width;
	}
	else
	{
		WindowRectangle.right  = width;
		WindowRectangle.bottom = height;
	}



	// Allow only one instance of the application.
	HWND hWnd = FindWindow (szAppName, NULL);
	if (hWnd)
	{
		SetForegroundWindow((HWND)(((DWORD)hWnd) | 0x01));
		return false;
	}

	// Adjust the window dimensions to give the specified client area: WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX
	AdjustWindowRectEx(&WindowRectangle, WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, FALSE, 0);
	WindowRectangle.right  = WindowRectangle.right  - WindowRectangle.left;
	WindowRectangle.bottom = WindowRectangle.bottom - WindowRectangle.top;

	// Create the window:
	#ifdef _WIN32_WCE
		m_HWND = CreateWindow(szClassName, szAppName, WS_VISIBLE, 0, 0, WindowRectangle.right, WindowRectangle.bottom, HWND_DESKTOP, NULL, argInstance, NULL);
	#else
		m_HWND = CreateWindow(szClassName, szAppName, WS_VISIBLE|WS_CAPTION|WS_SYSMENU, 0, 0, WindowRectangle.right, WindowRectangle.bottom, HWND_DESKTOP, NULL, argInstance, NULL);
	#endif
		
	if (!m_HWND) return false;
	Screen.Create(m_HWND, (short)width, (short)height, landscape);
	DoFullScreen(true);

	// set focus to foremost child window
	// The "| 0x01" is used to bring any owned windows to the
	// foreground and activate them.
	::SetForegroundWindow((HWND)(((DWORD)m_HWND) | 0x01));
	::ShowWindow(m_HWND, SW_SHOW);
	::UpdateWindow(m_HWND);

	#ifndef _WIN32_WCE
    ::SetCursor( ::LoadCursor( NULL, IDC_ARROW ) );
	#endif

	// DoFullScreen(true); - do that before the above now?

	Keyboard.Create(m_HWND);
	Mouse.Create();
	// 640x480 -> scale mouse
	if ((width==640 && height==480) || (width==480 && height==640))
	{
		// Mouse.m_scalefac = 2;
	}

	__GLBASIC__::__g_pRbow = new OpenGLRainbows;
	__GLBASIC__::__g_pRbow->m_WND.hwnd = m_HWND; // inform about main window handle
	__GLBASIC__::__g_pRbow3D = new Rainbows3D(__GLBASIC__::__g_pRbow);
	
	Initialized = true;
	glb_do_pause( false);
	WinMSG();

	__GLBASIC__::__g_pRbow->SetMaxFPS(60, true);
	if((__g_LicenseBits & 2)==0 || (__g_Did3D && ((__g_LicenseBits & 1)==0))) // no NET
	{
		for(long i=-32; i<=0; i++)
		{
			g_xDemo = i;
			ShowScreen();
		}
	}
	return true;
}


// --------------------------------------------------------------- //
// Shut Down the System
// --------------------------------------------------------------- //
bool oFramework::ShutDown()
{
	g_debug("close screen\n");
	Screen.Close();

	g_debug("undo fullscreen\n");
	DoFullScreen(false);

	g_debug("close keyboard\n");
	Keyboard.Delete();

	if(m_HWND && ::IsWindow(m_HWND))
	{
		g_debug("destroy wnd\n");
		DestroyWindow(m_HWND);
		m_HWND = NULL;
	}

	g_debug("shut frmwrk ok\n");
	return true;
}


extern "C" void __EndProgram();

// --------------------------------------------------------------- //
// Handle Window Messages
// --------------------------------------------------------------- //
bool oFramework::WinMSG()
{
 	MSG Event;

	// clear keyboard buffer - maybe
	// while(PeekMessage(&Event, NULL,WM_KEYFIRST,WM_KEYLAST,PM_REMOVE)) {}

redo_winmsg:
	while(::PeekMessage(&Event, m_HWND, 0, 0, PM_REMOVE))
	{
		if (!Terminated)
		{
			// Keyboard.Update();
			Mouse.Update();
		}
		if(Event.message==WM_QUIT) //  || Event.message == WM_CLOSE)
		{
			g_debug("PostQuitting in WimMSG\nClose %d\nQuit %d\n",
			Event.message==WM_CLOSE,
			Event.message==WM_QUIT);
			PostQuitMessage(0);
			__EndProgram();
			exit(0);
			return true;
		}
		TranslateMessage(&Event);
  		DispatchMessage(&Event);
	}

	if(__g_paused)
	{
		Sleep(100);
		goto redo_winmsg;
	}
return false;
}

namespace __GLBASIC__
{
	char g_WinCE_Last_char='\0';
};

LRESULT CALLBACK oFramework::WinProc(HWND argWindow, UINT argMessage, WPARAM argData1, LPARAM argData2)
{
	// due to GPAI?? I get 320x240 coords for the screen
	#define UPDMOUSE() if(GXOpenDisplay){Mouse.m_WM_x = (Screen.getHeight() * LOWORD(argData2)) / (Screen.Landscape?240:320); Mouse.m_WM_y = (Screen.getWidth() * HIWORD(argData2))/(Screen.Landscape?320:240);}else{Mouse.m_WM_x = LOWORD(argData2); Mouse.m_WM_y = HIWORD(argData2);}
	switch(argMessage)
	{
		case WM_MOVE: case WM_CREATE: case WM_SIZE:
			break;

		case WM_ERASEBKGND:
			return 1;
		case WM_PAINT:
			if(Initialized && __g_paused) Screen.Show();
			break;
		case WM_KEYDOWN:
		case WM_KEYUP:
			break;
		case WM_MOUSEMOVE:
		{
			if(!__g_paused && (Mouse.Button[MOUSE_BUTTON_1] || Mouse.Button[MOUSE_BUTTON_2]))
			{
				UPDMOUSE();
				Mouse.Update(true);
			}
			break;
		}
		case WM_LBUTTONDOWN:
		{
			Mouse.Button[ MOUSE_BUTTON_1 ] = true;
			if(!__g_paused)
			{
				UPDMOUSE();
				Mouse.Update();
			}
			break;
		}
/*
	// Tap & Hold
	if (IsPenEvent(message, GetMessageExtraInfo()))
	{
		// Process pen event
		InitRC(hwnd, &rc);  // May have been done previously...
		if (Recognize(&rc) == REC_POINTEREVENT)
		{
			// Process pointer event
			if (GetAsyncKeyState(VK_LBUTTON) & 0x8000)
				// Pen is still down: TapNHold functionality
			else
				// Pen up: Tap functionality
		}
	}
	else
		// Process mouse event
*/

		case WM_LBUTTONUP:
		{
			Mouse.Button[ MOUSE_BUTTON_1 ] = false;
			if(!__g_paused)
			{
				UPDMOUSE();
				Mouse.Update();
			}
			break;
		}
	
		case WM_RBUTTONDOWN:
		{
			Mouse.Button[ MOUSE_BUTTON_2 ] = true;
			if(!__g_paused)
			{
				UPDMOUSE();
				Mouse.Update();
			}
			break;
		}
	
		case WM_RBUTTONUP:
		{
			Mouse.Button[ MOUSE_BUTTON_2 ] = false;
			if(!__g_paused)
			{
				UPDMOUSE();
				Mouse.Update();
			}
			break;
		}

		case WM_ACTIVATE:
		{
			if(LOWORD(argData1))
			{
				::SetWindowText(argWindow, TEXT("GLBasic"));
				Suspend(false);
			}
			else
			{
				::SetWindowText(argWindow, TEXT("GLBasic <pause>"));
				Suspend(true);
			}
			break;
		}	

		case WM_ENTERMENULOOP:
			Suspend(true);
			break;
		case WM_EXITMENULOOP:
			Suspend(false);
			break;
		case WM_CLOSE:
			Terminated = true;
			PostQuitMessage(0);
			__EndProgram();
			return 0;
			break;
		case WM_CHAR:
			__GLBASIC__::g_WinCE_Last_char = (char) argData1;
			if(__GLBASIC__::g_WinCE_Last_char == '\r') __GLBASIC__::g_WinCE_Last_char = '\n';
			break;
		case WM_QUIT:
		case WM_DESTROY:
			__EndProgram();
			return 0;

		case WM_HOTKEY:
			#ifdef POCKETPC
			if (argData1 == VK_LWIN)
			{
				__EndProgram();
			}
			#endif
			return 0; // I do this on my own!
	}
	return DefWindowProc(argWindow, argMessage, argData1, argData2);
}


void oFramework::Suspend(bool argSuspend)
{
/*
	if(argSuspend)
	{
		DoFullScreen(false);
	}
	else
	{
		DoFullScreen(true);
	}
*/
	// If the suspend state needs to be changed:
	glb_do_pause(argSuspend);
}


float oFramework::ShowScreen()
{
	if(__g_paused)
	{
		if(WinMSG()) return 0.0f;
		Sleep(100);
		return 100;
	}
	Mouse.m_VX = 0; Mouse.m_VY=0;

	if((__g_LicenseBits & 2)==0 || (__g_Did3D && ((__g_LicenseBits & 1)==0))) // no NET
	{
		__GLBASIC__::__g_pRbow->ShowDemo(g_xDemo,0);
	}

return (float)__GLBASIC__::__g_pRbow->FlipScreens();
}


// #ifdef _WIN32_WCE
    PFNGXOpenDisplay          GXOpenDisplay;
    PFNGXCloseDisplay         GXCloseDisplay;
    PFNGXBeginDraw            GXBeginDraw;
    PFNGXEndDraw              GXEndDraw;
    PFNGXOpenInput            GXOpenInput;
    PFNGXCloseInput           GXCloseInput;
    PFNGXGetDisplayProperties GXGetDisplayProperties;
    PFNGXSuspend              GXSuspend;
    PFNGXResume               GXResume;
    PFNGXSetViewport          GXSetViewport;
    PFNGXIsDisplayDRAMBuffer  GXIsDisplayDRAMBuffer;

	PFNSHFullScreen			SHFullScreen;
	PFNVibrate				Vibrate;
	PFNVibrateStop			VibrateStop;
	PFNVibrateGetDeviceCaps	VibrateGetDeviceCaps;
/*
	typedef HBITMAP (*PFNSHLoadImageFile)(LPCTSTR);
	PFNSHLoadImageFile		SHLoadImageFile;
*/

// --------------------------------------------------------------- //
// Load GAPI - dll
// --------------------------------------------------------------- //
bool oFramework::LoadDLLs()
{
#ifdef _WIN32_WCE
#define LINK(dll, name,import) {name = (dll) ? (PFN##name)GetProcAddressW( dll, import ) : NULL; if(!name) g_debug("%s\n", "Failed to load: " #name " in " #dll);}
    // Already loaded?
    if (m_hGAPI || m_hAYGSHELL) return true;
    
    // Load GAPI.DLL
    m_hGAPI = LoadLibraryW( TEXT("GX.dll") );
    if(!m_hGAPI)
    {
		g_debug("No GX.dll found.\n");
    }
    // Find the needed functions
    LINK(m_hGAPI, GXOpenDisplay,         TEXT("?GXOpenDisplay@@YAHPAUHWND__@@K@Z" ))
    LINK(m_hGAPI, GXCloseDisplay,        TEXT("?GXCloseDisplay@@YAHXZ" ))
    LINK(m_hGAPI, GXBeginDraw,           TEXT("?GXBeginDraw@@YAPAXXZ" ))
    LINK(m_hGAPI, GXEndDraw,             TEXT("?GXEndDraw@@YAHXZ" ))
    LINK(m_hGAPI, GXOpenInput,           TEXT("?GXOpenInput@@YAHXZ" ))
    LINK(m_hGAPI, GXCloseInput,          TEXT("?GXCloseInput@@YAHXZ" ))
    LINK(m_hGAPI, GXGetDisplayProperties,TEXT("?GXGetDisplayProperties@@YA?AUGXDisplayProperties@@XZ" ))
    LINK(m_hGAPI, GXSuspend,             TEXT("?GXSuspend@@YAHXZ" ))
    LINK(m_hGAPI, GXResume,              TEXT("?GXResume@@YAHXZ" ))
    LINK(m_hGAPI, GXSetViewport,         TEXT("?GXSetViewport@@YAHKKKK@Z" ))
    LINK(m_hGAPI, GXIsDisplayDRAMBuffer, TEXT("?GXIsDisplayDRAMBuffer@@YAHXZ" ))

	m_hAYGSHELL = LoadLibraryW(TEXT("aygshell.dll"));
	LINK(m_hAYGSHELL, SHFullScreen,			TEXT("SHFullScreen"));
	LINK(m_hAYGSHELL, Vibrate,				TEXT("Vibrate"));
	LINK(m_hAYGSHELL, VibrateStop,			TEXT("VibrateStop"));
	LINK(m_hAYGSHELL, VibrateGetDeviceCaps, TEXT("VibrateGetDeviceCaps"));
//	LINK(m_hAYGSHELL, SHLoadImageFile,      TEXT("SHLoadImageFile"));
#endif

    return true;
}

#undef LINK
//#endif



// ---------------------------------------------------------- //
// Rumble the Phone
// ---------------------------------------------------------- //
void oFramework::VibratePhone(int duration_ms, float amplitude)
{
	if(!VibrateGetDeviceCaps || !Vibrate) return;

	int i = VibrateGetDeviceCaps(VDC_AMPLITUDE);
	if(i<=0) return;
	int j = VibrateGetDeviceCaps(VDC_FREQUENCY);
VIBRATENOTE note;
	note.wDuration = duration_ms;
	note.bAmplitude = (i <=1) ? 1 : (int)(amplitude*j);
	note.bFrequency = (j <=1) ? 1 : (int)(amplitude*j);
	HRESULT hr = Vibrate(1, &note, FALSE, duration_ms);
	if(hr == 0x80004001L) // E_NOTIMPL
	{
		// this fuckphone cannot vibrate and continue
		// have to vibrate and wait for completition
		if(!Vibrate(0, NULL, TRUE, INFINITE)) // S_OK
		{
			::Sleep(duration_ms/2+1);
			VibrateStop(); 		
		}
	}
}


/* - Some goodies:

// SOFT-RESET
	#include <winioctl.h>
	#define IOCTL_HAL_REBOOT CTL_CODE(FILE_DEVICE_HAL, 15, METHOD_BUFFERED, FILE_ANY_ACCESS)
	extern "C" __declspec(dllimport) BOOL KernelIoControl(DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned);
	KernelIoControl(IOCTL_HAL_REBOOT, NULL, 0, NULL, 0, NULL);
// Sound:
	sndPlaySound
// Battery status
	SYSTEM_POWER_STATUS_EX status;
	memset(&status, 0, sizeof(status));
	st
	if (GetSystemPowerStatusEx(status, false) == 1)
	{
		status.BatteryLifePercent;
	}

*/

