// GLBasic Core Engine for Windows CE (WinCE)
// -> PPC stands for PocketPC. The input/output and initialize
//    core is totally different!


#include "Stdafx.h"
#include "Rainbows3D.h"
#include "OpenGLRainbows.h"
#include "ceFramework.h"
#include "GFRand.h"
#include "GFqueue.h"
#include <windows.h>
#include <commdlg.h> // GetOpenFilename
#include "network/clientserver.h"

#ifndef TRENKI3D
#include "GL/gl.h"
#endif


#ifdef GF_DEBUG_NEW
AllocList allocList; // glb.cpp
#endif


// for GFFilySystem.h
char __g_CurDir[MAX_PATH]="";


/*
// 5x faster, 0.22% accuracy
float qsqrt(float a)
{
float x;
   x = 0.5*(a+1.0); // Initial guess
   for (int g=0; g<8; g++)
   {
      x = (x*x + a)/(x+x);
   }
return x;
}
*/

#include "GFQueue.h"
#include <math.h>
#include "glb.h"
// #include "gf_crypt.h"

// Path finding:
#include "pathfinding/astarplanner.h"
/*
#include "pathfinding/bestplanner.h"
#include "pathfinding/dijkstraplanner.h"
#include "pathfinding/breadthplanner.h"
*/
#ifdef WANT_SHOEBOX
	#include "GFShoeBox.h"
	extern GFShoeBox *__g_ShoeBox_Data;
	extern GFShoeBox *__g_ShoeBox_Media;
#endif


// Win32 specific API
extern "C"
{
	void WINAPI ExitProcess(int status) { exit(status); }
	// size_t strlen(const char *str){size_t n=0; while(*str != '\0'){++n; ++str;} return n;}
	int WINAPI lstrlenA(const char *str){size_t n=0; while(*str != '\0'){++n; ++str;} return n;}

	float sinf (float f) {return (float)sin (f);}
	float cosf (float f) {return (float)cos	(f);}
	float tanf (float f) {return (float)tan	(f);}
	float asinf(float f) {return (float)asin(f);}
	float acosf(float f) {return (float)acos(f);}
	float atanf(float f) {return (float)atan(f);}
};








extern int DoFullScreen (bool mode);

extern int			__g_AllowEscape;
extern int			__g_paused;
extern int			__g_allowPause;

extern "C" void glb_do_pause(int pause);
extern "C" int glb_allow_escape();

namespace __GLBASIC__
{


extern GFHawkNetwork*	pGFNet;
extern OpenGLRainbows*	__g_pRbow;

oFramework*	gpFramework = NULL;
// int __nCurFont = 0;
extern DGInt __g_ThisTime, __g_LastTime, __g_FirstTime;

oBitmap			gXButtonBitmap;
// oFont			gFonts[8];
// oBitmap			gBitmaps[GLB_MAX_BITMAPS];
extern DGNat			__g_debugline;
extern DGNat			__g_error;
extern DGNat			__g_errorline;



int				__DG_SCHOOLVER;

DGInt			__HR;
extern DGStr	__g_cmdline;
int				__g_mx, __g_my;

Sound			__g_Sound;
SoundFX*		__g_SoundFX;
bool			__g_Did3D=false;
bool			__g_DidNET=false;

#define __g_LicenseBits	OpenGLRainbows10FreeMemoriesEiiiii // harder to find in HTML5
int				__g_LicenseBits; // replaced by: "XVSDVS%d", g_ProgramFeature (==3,2)
								// g_allow3D =(nfeature & 1) ? 1 : 0;
								// g_allowNET=(nfeature & 2) ? 1 : 0;


#pragma warning(disable: 4244)

// Make RGB to 565 16 bit color
inline unsigned short __ConvertColor(unsigned long col)
{
unsigned char r,g,b;
	r = (unsigned char)( col     & 0xff);
	g = (unsigned char)((col>>8) & 0xff);
	b = (unsigned char)((col>>16)& 0xff);
	return PackColor(r, g, b);
}



BOOL glb_prepare_reading_file(DGStr& filename);

#define msg(a) ::MessageBox(NULL, a, L"Test", MB_OK);


void* GLBASIC_HWND() {return (void*)gpFramework->m_HWND;}

// __GlobalInit - Create and handle Window Stuff
#define PrepLic	OpenGLRainbows10AllocMemoriesEiii // harder to find in HTML5
void PrepLic();

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
extern "C" int __GlobalInit(HINSTANCE hInst, int nCmdShow, const char* Caption)
{
	g_deldebug();
	g_debug("GlobalInit\n");
	PrepLic();

	gpFramework = new oFramework(); // &__g_MyFrame;
	
	// "landscape" rotates that thing on a portrait device. If the device is landscape, ignore that.
	gpFramework->Init(hInst, __DG_RESX, __DG_RESY, (__DG_RESX>__DG_RESY) ? (::GetSystemMetrics(SM_CXSCREEN) < ::GetSystemMetrics(SM_CYSCREEN)) : false);

	// framework first, loads GAPI dll
	__g_pRbow = new OpenGLRainbows();

	SetupAccurateTimer();

	DGStr exepath;
	GFFileSystem::GetExeDir(exepath.getbuffer(1024));
	exepath.releasebuffer();
	// Set current dir for Linux when double clicking with KDE
	// The same for Win32 when associated with a file extension
	GFFileSystem::SetCurrentDir(exepath.c_str());

	// Set .exe = default ShoeBox
	#ifdef WANT_SHOEBOX
	GFFileSystem::GetExePath(exepath.getbuffer(1024));
	exepath.releasebuffer();
	__g_ShoeBox_Data = new GFShoeBox;
	__g_ShoeBox_Media = new GFShoeBox;
	SETSHOEBOX(exepath, exepath);
	#endif

	gXButtonBitmap.XButton();

	__g_pRbow->Init(NULL, __DG_RESX, __DG_RESY, 16, __DG_FRAMERATE);
	__g_FirstTime=__g_LastTime=__g_ThisTime=GETTIMERALL();

	__g_pRbow->DefaultFont(0);

	#define CENTER(a, y) PRINT(CGStr(a), (sx-LEN(CGStr(a))*fx)/2, y);
	DGInt sx, sy, fx, fy;
	GETSCREENSIZE(sx, sy);
	if(__DG_SCHOOLVER)
	{
		GETFONTSIZE(fx, fy);
		int paused=0;
		for(DGInt alpha=0.01f; alpha<=2; alpha+=.039f)
		{
			ALPHAMODE(alpha<1 ? alpha : 2.1-alpha);
			if(alpha>=1 && !paused)
			{
				paused=1;
				ALPHAMODE(0);
			}
			CENTER("School License", (sy-fy)/2)
			CENTER("www.GLBasic.com", sy-fy);
			SHOWSCREEN();
			Sleep(20);
			if(paused==1)
			{
				paused=2;
				Sleep(500);
			}
		}
		ALPHAMODE(0);
	}
	#undef CENTER

	// load smalfont.bmp / smalfont.png


	DGStr files[4];
	files[0] = "Media/smalfont.png";
	files[1] = "Media/smalfont.bmp";
	files[2] = "smalfont.png";
	files[3] = "smalfont.bmp";

	for(int i=0; i<3; ++i)
	{
		if(glb_prepare_reading_file(files[i]))
		{
			LOADFONT(files[i].c_str(), 0);
			break;
		}
	}
	SETFONT(0);
	// SRAND
	GFsrand(GetTickCount());
	__g_Sound.open(22050, true);
	pGFNet=new GFHawkNetwork;
	__g_SoundFX=new SoundFX[2048];


	g_debug("Delay load DLLs\n");
	DLL_DELAY_LOAD_NOW();

	g_debug("Init Finalized CE\n");
	__g_FirstTime=__g_LastTime=__g_ThisTime=GETTIMERALL();
return 0;
}

void __dLn(long fn, long n)
{
g_debug("%d\n", (int)n);

__g_debugline=n;
}


// ------------------------------------------------------------- //
DGNat	KEY(DGNat key)
{
	// Keyboard.Update();
	return (DGInt)Keyboard.GetMappedKeyState((int)key);
}


// ------------------------------------------------------------- //
void	PLAYMOVIE(const DGStr& s) {}
void	LOOPMOVIE(const DGStr& s) {}




// ------------------------------------------------------------- //
static HINSTANCE ghDLL=NULL;
int* g_pSound=NULL;
BOOL gbLoop=FALSE;

#if defined(_WIN32_WCE)
	#define LINK(name,import) name = ghDLL ? (PFN##name)GetProcAddressW( ghDLL, _T(import) ) : NULL;
#else
	#define LINK(name,import) name = ghDLL ? (PFN##name)GetProcAddress( ghDLL, import ) : NULL;
#endif

#define TYPDEF(rv, name, args) typedef rv ( __stdcall* PFN##name) args; PFN##name name = NULL;

TYPDEF(DWORD,SndPlaySync, (LPCTSTR file, DWORD flags));
TYPDEF(DWORD,SndOpen,     (LPCTSTR file, int** phSound));
TYPDEF(DWORD,SndPlayAsync,(int* hSound, DWORD flags));
TYPDEF(DWORD,SndClose,    (int* hSound));
TYPDEF(DWORD,SndStop,     (int SoundScope, int* hSound));
TYPDEF(HRESULT,SndGetWaitHandle, (int* hSound, HANDLE* phDoneEvent));
#define SND_SCOPE_PROCESS						0x1
#define S_OK                                   ((HRESULT)0x00000000L)
#define S_FALSE                                ((HRESULT)0x00000001L)


void	PLAYMUSIC(const DGStr& s, DGNat bLoop)
{
	STOPMUSIC();
	if(!ghDLL) 
	{
		ghDLL = LoadLibrary(TEXT("aygshell.dll"));
		if(!ghDLL)
		{
			g_debug("Can't load aygshell.dll\n");
			return;
		}
		LINK(SndPlaySync, "SndPlaySync");
		LINK(SndOpen,     "SndOpen");
		LINK(SndPlayAsync,"SndPlayAsync");
		LINK(SndClose,    "SndClose");
		LINK(SndStop,     "SndStop");
		if(!SndPlayAsync)
		{
			g_debug("Can't link SndPlayAsync\n");
		}
	}
	if(SndOpen)
	{
	char fullpath[1024];
		GFFileSystem::MakeAbsolutePathCE(s.c_str(), fullpath);
		wchar_t path[1024];
		mbtowc(path, fullpath, strlen(fullpath)+1);
		HRESULT hr = SndOpen(path, &g_pSound);
		if(hr==S_OK)
		{
			if(SndPlayAsync(g_pSound, 0) != S_OK)
			{
				SndClose(g_pSound);
				g_pSound=NULL;
			}
			gbLoop=bLoop;
		}
	}
}

void MUSICVOLUME(DGInt volume)
{
// waveOutSetVolume
}

void	STOPMUSIC()
{
	gbLoop=FALSE;
	if(g_pSound)
	{
		SndClose(g_pSound);
		g_pSound=NULL;
		SndStop(SND_SCOPE_PROCESS, NULL);
	}
}

DGNat	ISMUSICPLAYING() // also loop after quering
{

	if(g_pSound)
	{
		HANDLE hEvent;
		if(SndGetWaitHandle(g_pSound, &hEvent) == S_OK)
		{
			DWORD dwStatus;
			dwStatus = WaitForSingleObject( hEvent, 1 );
			if( dwStatus == WAIT_TIMEOUT )
			{
				return TRUE;
			}
			else if( dwStatus == WAIT_OBJECT_0 && gbLoop )
			{
				SndPlayAsync(g_pSound, 0);
				return TRUE;
			}
		}
	}
	return FALSE;
}


// ------------------------------------------------------------- //
void	SETSCREEN(DGNat w, DGNat h, DGNat fs)
{
	__g_pRbow->SetScreen((int)w, (int)h, 0, (int)fs);
}

// ------------------------------------------------------------- //
void X_CLEAR_Z();
void	SHOWSCREEN()
{
static bool is_smartphone = (PLATFORMINFO_Str(CGStr("DEVICE")) == CGStr("SMARTPHONE"))?true:false;

	__g_DidNET=true; // PocketPC requires NET feature
/*
	// FlipScreen clears Z buffer
	if(__g_Did3D)
	{
		#ifdef TRENKI3D
		X_CLEAR_Z();
		#else
		glFlush();
		glClear(GL_DEPTH_BUFFER_BIT);
		#endif
	}
*/
	ALPHAMODE(0);

	if(gpFramework->m_AllowEscape)
	{
		// X-button
		if(!is_smartphone)
		{
			if(Screen.Landscape)
			{
				if(	Mouse.Button[MOUSE_BUTTON_1] &&
					Mouse.X()>Screen.getWidth()-14 && Mouse.Y()>Screen.getHeight()-14)
					__EndProgram();
				gXButtonBitmap.Draw(Screen.getWidth()-15, Screen.getHeight()-15);
			}
			else
			{
				if(	Mouse.Button[MOUSE_BUTTON_1] &&
					Mouse.X()>Screen.getWidth()-14 && Mouse.Y()<15)
					__EndProgram();
				gXButtonBitmap.Draw(Screen.getWidth()-15, 1);
			}
		}
		// Back-Key
		if (__GLBASIC__::KEY(1)) // BACK button on smartphone
				__EndProgram();
	}

	__g_LastTime = __g_ThisTime; __g_ThisTime = GETTIMERALL();
		__g_pRbow->FlipScreens();

	gpFramework->WinMSG();
	ISMUSICPLAYING(); // repeat music if it's playing on WM5 or greater
}

/*
void	VIEWPORT(DGInt x, DGInt y, DGInt w, DGInt h)
{
	Screen.Viewport(x,y,w,h);
	// #NEED 3D viewport!	
}
*/
const int MIN_FRAMES_BEFORE_HIBERNATE = 20; // 20x SHOWSCREEN, then allow first try to hibernate -> more fluid experience
static int __g_nFlipSinceHibernate = 0; // number of SHOWSCREENS since last HIBERNATE -> make more responsive for a short time after a mousemove
// ------------------------------------------------------------- //
void BUSY(void)
{
	__g_nFlipSinceHibernate = MIN_FRAMES_BEFORE_HIBERNATE+1;
}

// ------------------------------------------------------------- //
void	HIBERNATE(void)
{
static DGInt oldmouse[4] = {0,0,0,0};
DGInt		v1,v2,v3,v4;
int			nj, i;

	// 8*sleep(30) == 240 = 1/4 sec
	for(int t=0; t<8; ++t)
	{
		gpFramework->WinMSG();
		if(gpFramework->m_AllowEscape && 
			(__GLBASIC__::KEY(1) ||
				(Mouse.Button[MOUSE_BUTTON_1] &&
				 Mouse.X()>Screen.getWidth()-14 &&
				 Mouse.Y()<15)) )
		{
			__EndProgram();
		}

		if(__g_nFlipSinceHibernate<MIN_FRAMES_BEFORE_HIBERNATE)
		{
			return;
		}


		// KEYS
		for(nj=0; nj<255; ++nj)
		{
			if(KEY(nj)) return;
		}
		
		// MOUSE
		MOUSESTATE(v1, v2, v3, v4);
		if(v1!=oldmouse[0] || v2!=oldmouse[1] || v3!=oldmouse[2] || v4!=oldmouse[3])
		{
			oldmouse[0]=v1;
			oldmouse[1]=v2;
			oldmouse[2]=v3;
			oldmouse[3]=v4;
			return;
		}
		// JOYSTYX
		nj = (int)GETNUMJOYSTICKS();
		for(--nj; nj>=0; --nj)
		{
			for(i=0; i<32; ++i)
			{
				if(GETJOYBUTTON(nj, i)) return;
			}
			if(GETJOYX(nj)) return;
			if(GETJOYY(nj)) return;
			if(GETJOYZ(nj)) return;
			if(GETDIGIX(nj)) return;
			if(GETDIGIY(nj)) return;
		}

		// PAUSE
		Sleep(5);
	}
}


void	ALLOWESCAPE(DGInt i)
{
	gpFramework->m_AllowEscape = i ? true:false;
}
/*
// ------------------------------------------------------------- //
void	SETSCREEN(DGNat w, DGNat h, DGNat fs)
{
}
// ------------------------------------------------------------- //
DGNat	ISFULLSCREEN()
{
	return TRUE;
}

// ------------------------------------------------------------- //
void	LIMITFPS(DGInt n)
{
	gpFramework->SetMaxFPS((int)n);
}


// ------------------------------------------------------------- //
DGInt	GETTIMER(void)
{
DGInt	dt = GETTIMERALL() - __g_LastTime;
	return dt<=0 ? 1 : dt;
}

// ------------------------------------------------------------- //
DGInt	GETTIMERALL(void)
{
	return GETTIMERALL() - __g_FirstTime; // __g_ThisTime
}
*/


DGStr	__PenInput_Str(DGStr word_Str);
void	INPUT(DGInt& s, DGNat x, DGNat y, DGNat bKerning){DGStr str; INPUT(str, x,y, bKerning); s = (DGInt)str;}
void	INPUT(DGNat& s, DGNat x, DGNat y, DGNat bKerning){DGStr str; INPUT(str, x,y, bKerning); s = (DGNat)str;}
void	INPUT(DGStr& s, DGNat x, DGNat y, DGNat bKerning)
{
	__g_pRbow->GrabSurface(3);
	__g_pRbow->PasteSurface(3);
	s = __PenInput_Str(s);
	__g_pRbow->FreeSurface(3);
}

extern char g_WinCE_Last_char; // ceframework.cpp - WM_CHAR
DGStr	INKEY_Str(void)
{
	char str[2] = {g_WinCE_Last_char, '\0'};
	DGStr a = str;
	g_WinCE_Last_char = '\0';
	return a;
}
void	JOYSTATE(DGNat& jx, DGNat& jy, DGNat& b1, DGNat& b2)
{
	jx = KEY(205) - KEY(203);
	jy = KEY(208) - KEY(200);
	b1 = KEY(199);
	b2 = KEY(207);
}
void	JOYSTATE(DGInt& jx, DGInt& jy, DGInt& b1, DGInt& b2)
{
	jx = KEY(205) - KEY(203);
	jy = KEY(208) - KEY(200);
	b1 = KEY(199);
	b2 = KEY(207);
}
void	KEYWAIT(void)
{
	for(;;)
	{
		for (short i=0; i<255; i++)
		{
			if(KEY(i)) return;
		}
		HIBERNATE();
	}
}

DGNat	MOUSEAXIS(DGNat nAxis)
{
	gpFramework->WinMSG();
	Mouse.Update();
	switch((int)nAxis)
	{
		case 0: return (DGNat)Mouse.VX();
		case 1: return (DGNat)Mouse.VY();
		case 2: return 0;
		case 3: return (DGNat)Mouse.Button[MOUSE_BUTTON_1];
		case 4: return (DGNat)Mouse.Button[MOUSE_BUTTON_2];
		case 5: return 0;
	}
return 0;
}


DGNat	GETMOUSECOUNT()
{
	return 1;
}
void	SETACTIVEMOUSE(DGNat i) {}


void	MOUSESTATE(DGInt& jx, DGInt& jy, DGInt& b1, DGInt& b2)
{
	gpFramework->WinMSG();
	Mouse.Update();
	jx = (DGInt)Mouse.X();
	jy = (DGInt)Mouse.Y();
	b1 = (DGInt)Mouse.Button[MOUSE_BUTTON_1];
	b2 = (DGInt)Mouse.Button[MOUSE_BUTTON_2];
}
void	MOUSESTATE(DGNat& jx, DGNat& jy, DGNat& b1, DGNat& b2)
{
	gpFramework->WinMSG();
	Mouse.Update();
	jx = (DGNat)Mouse.X();
	jy = (DGNat)Mouse.Y();
	b1 = (DGNat)Mouse.Button[MOUSE_BUTTON_1];
	b2 = (DGNat)Mouse.Button[MOUSE_BUTTON_2];
}

// ------------------------------------------------------------- //
void	SETMOUSE(DGNat mx, DGNat my)
{
	Mouse.Set((long)mx, (long)my);
}
void	SYSTEMPOINTER(DGInt onoff) {} // can't hide the pen, can you ;/

void	MOUSEWAIT(void)
{
DGInt x,y,a,b;
	for(;;)
	{	
		MOUSESTATE(x, y, a, b);
		if(a || b || KEY(28)) continue;
		break;
	}
	for(;;)
	{	
		MOUSESTATE(x, y, a, b);
		if(a || b || KEY(28)) return;
	}
}



DGNat	GENSOUND()
{
	#ifndef GLB_CONSOLE
	for(DGNat i=0; i<MAX_WAV_SAMPLES; ++i)
	{
		if(__g_SoundFX[i].IsLoaded() == FALSE)
			return i;
	}
	#endif
	return -1;
}

void	LOADSOUND(const DGStr& s, DGNat num, DGNat buffers)
{
	DGStr file(s);
	if(!glb_prepare_reading_file(file))
		return;
	__g_SoundFX[(int)num].load(file.c_str());
}
DGNat	PLAYSOUND(DGNat num, DGInt fade, DGInt volume)
{
	__g_SoundFX[(int)num].setVolume(64.0 * volume);
	return (DGInt) __g_Sound.playSFX(&__g_SoundFX[(int)num]);
}

// ------------------------------------------------------------- //
void STOPSOUND(DGNat channel)
{
	__g_Sound.stopSFX(channel);
}



DGNat	SOUNDPLAYING(DGNat channel)						{return (DGInt) __g_Sound.isPlayingSFX((unsigned long)channel);}
void	HUSH(void){__g_Sound.stopSFX(0);}//#NEED all channels


// New Joystick Commands
DGInt	GETJOYX(DGNat nJoy){DGInt x,y,a,b; JOYSTATE(x, y, a, b); return x;}
DGInt	GETJOYY(DGNat nJoy){DGInt x,y,a,b; JOYSTATE(x, y, a, b); return y;}
DGInt	GETJOYZ(DGNat nJoy){return 0;}
DGNat	GETDIGIX(DGNat nJoy){DGInt x,y,a,b; JOYSTATE(x, y, a, b); return x;}
DGNat	GETDIGIY(DGNat nJoy){DGInt x,y,a,b; JOYSTATE(x, y, a, b); return y;}
DGNat	GETJOYBUTTON(DGNat nJoy, DGNat Button)
{
	switch((long)Button)
	{
		case 0: return KEY(199);
		case 1: return KEY(207);
		case 2: return KEY(210);
		case 3: return KEY(211);
		case 4: return KEY(29);
	}
return 0;
}
DGNat	GETNUMJOYSTICKS(void){return 1;}
DGStr	GETJOYNAME_Str(DGNat nJoy){DGStr str="PDA"; return str;}


// ------------------------------------------------------------- //
void    FORCEFEEDBACK(DGNat nJoy, DGInt duration, DGInt fx, DGInt fy)
{
	gpFramework->VibratePhone((int)duration, (float)MAX(fx, fy));
}


#if 0
#include "GLB_Filerequest.h"
#endif

// ------------------------------------------------------------- //
DGStr	FILEREQUEST_Str(DGNat open, const DGStr& filter)
// ------------------------------------------------------------- //
{
#if 0
	DGInt wx, wy;
	GETSCREENSIZE(wx, wy);
	return FileDialog_Str(filter, open, 0,0, wx, wy);

	PRINT ("Filename:", 0, 0);
	DGStr s;
	INPUT(s, 0, 20);
	return s;
#else
	DGStr			retstr;
		long			i;
	#ifdef UNICODE
		wchar_t			filt[MAX_PATH+1];
		wchar_t			dir[MAX_PATH+1];
		wchar_t			file[MAX_PATH+1];
		char			temp[MAX_PATH+1];
	#else
		char			filt[MAX_PATH+1];
		char			dir[MAX_PATH+1];
		char			file[MAX_PATH+1];
	#endif
	OPENFILENAME	ofn;
		memset(&ofn, 0, sizeof(ofn));
		memset(file, 0, (MAX_PATH+1)*sizeof(file[0]));
		memset(filt, 0, sizeof(filt[0])*(MAX_PATH+1));

		#ifdef UNICODE
			_mbstowcsz(filt, filter.c_str(), strlen(filter.c_str())+1);
		#else
			strcpy(filt, filter.c_str());
			filt[strlen(filter.c_str())+1]='\0';
		#endif
		for (i=0; i<(long)strlen(filter.c_str()); i++)
		{
			if (filt[i]==TEXT('|'))
			{
				filt[i]=TEXT('\0');
			}
		}
		ofn.lpstrFilter=filt;

		// Get CurDir
		GFFileSystem gffs;
//		::GetCurrentDirectory(MAX_PATH, dir);
		#ifdef UNICODE
			gffs.GetCurrentDir(temp);
			_mbstowcsz(dir, temp, strlen(temp)+1);
		#else
			gffs.GetCurrentDir(dir);
		#endif
		ofn.lpstrInitialDir=dir;

		ofn.lStructSize=sizeof(ofn);
		ofn.hwndOwner=Screen.Window;
		ofn.lpstrFile=file;
		ofn.nMaxFile=MAX_PATH;
		ofn.Flags=OFN_HIDEREADONLY;
	//	if (open)
	//		ofn.Flags|=OFN_FILEMUSTEXIST;
		gpFramework->DoFullScreen(false);

		if (open)
			GetOpenFileName(&ofn);
		else
			GetSaveFileName(&ofn);

		#ifdef UNICODE
			gffs.SetCurrentDir(temp);
		#else
			gffs.SetCurrentDir(dir);
		#endif

		gpFramework->DoFullScreen(true);

		#ifdef UNICODE
			int nlen=(int)wcslen(ofn.lpstrFile)+1;
			_wcstombsz(retstr.getbuffer(nlen), ofn.lpstrFile, nlen);
			retstr.releasebuffer();
		#else
			retstr=ofn.lpstrFile;
		#endif
		if (retstr[0]=='\0')
			retstr="NO_FILE";

		for (i=0; i<(long)strlen(retstr.c_str()); i++)
		{
			if (retstr[i]=='\\') retstr[i] = '/';
		}
	return retstr;
#endif
}

// ------------------------------------------------------------- // 
// -=#  DRAWKEY  #=- 
// ------------------------------------------------------------- // 
// ------------------------ //
#define DrawKey(x, y, xe, ye, col1, col2) DRAWRECT( x, y, xe-x, ye-y, col1);DRAWRECT( x+1, y+1, xe-x-2, ye-y-2, col2);

DGStr __PenInput_Str(DGStr word_Str)
{
REGISTER_VAR_DEF(DGInt, n,0);
REGISTER_VAR_DEF(DGInt, m,0);
REGISTER_VAR(DGStrArray, keys_Str);
REGISTER_VAR(DGStrArray, skeys_Str);
REGISTER_VAR_DEF(DGInt, width,0);
REGISTER_VAR_DEF(DGInt, height,0);
REGISTER_VAR_DEF(DGInt, kwidth,0);
REGISTER_VAR_DEF(DGInt, kheight,0);
REGISTER_VAR_DEF(DGInt, x,0);
REGISTER_VAR_DEF(DGInt, y,0);
REGISTER_VAR_DEF(DGInt, posy,0);
REGISTER_VAR_DEF(DGInt, dx,0);
REGISTER_VAR_DEF(DGInt, dy,0);
REGISTER_VAR_DEF(DGInt, wasup,0);
REGISTER_VAR_DEF(DGInt, shift,0);
REGISTER_VAR_DEF(DGInt, blink,0);
REGISTER_VAR_DEF(DGInt, col1,0);
REGISTER_VAR_DEF(DGInt, col2,0);
REGISTER_VAR_DEF(DGInt, col3,0);
GETSCREENSIZE( width, height);
kheight = height;
if (kheight>width )
kheight=width;
kheight = kheight/2;
posy = height - kheight;
// Bottom of 320x240 (landscape mode) screen 
height=kheight;
col1 = RGB(0x80, 0xff, 0x80) ;
col2 = RGB(0x00, 0x80, 0x80) ;
col3 = RGB(0x00, 0x48, 0x48) ;
DIM(keys_Str,11 ,4 );
DIM(skeys_Str,11 ,4 );
n=0;
m=0;
keys_Str(n,m)=CGStr("1");
n=n+1;
keys_Str(n,m)=CGStr("2");
n=n+1;
keys_Str(n,m)=CGStr("3");
n=n+1;
keys_Str(n,m)=CGStr("4");
n=n+1;
keys_Str(n,m)=CGStr("5");
n=n+1;
keys_Str(n,m)=CGStr("6");
n=n+1;
keys_Str(n,m)=CGStr("7");
n=n+1;
keys_Str(n,m)=CGStr("8");
n=n+1;
keys_Str(n,m)=CGStr("9");
n=n+1;
keys_Str(n,m)=CGStr("0");
n=n+1;
keys_Str(n,m)=CGStr("-");
n=0;
m=m+1;
keys_Str(n,m)=CGStr("q");
n=n+1;
keys_Str(n,m)=CGStr("w");
n=n+1;
keys_Str(n,m)=CGStr("e");
n=n+1;
keys_Str(n,m)=CGStr("r");
n=n+1;
keys_Str(n,m)=CGStr("t");
n=n+1;
keys_Str(n,m)=CGStr("y");
n=n+1;
keys_Str(n,m)=CGStr("u");
n=n+1;
keys_Str(n,m)=CGStr("i");
n=n+1;
keys_Str(n,m)=CGStr("o");
n=n+1;
keys_Str(n,m)=CGStr("p");
n=n+1;
keys_Str(n,m)=CGStr("[");
n=0;
m=m+1;
keys_Str(n,m)=CGStr("a");
n=n+1;
keys_Str(n,m)=CGStr("s");
n=n+1;
keys_Str(n,m)=CGStr("d");
n=n+1;
keys_Str(n,m)=CGStr("f");
n=n+1;
keys_Str(n,m)=CGStr("g");
n=n+1;
keys_Str(n,m)=CGStr("h");
n=n+1;
keys_Str(n,m)=CGStr("j");
n=n+1;
keys_Str(n,m)=CGStr("k");
n=n+1;
keys_Str(n,m)=CGStr("l");
n=n+1;
keys_Str(n,m)=CGStr(";");
n=n+1;
keys_Str(n,m)=CGStr("'");
n=0;
m=m+1;
keys_Str(n,m)=CGStr("z");
n=n+1;
keys_Str(n,m)=CGStr("x");
n=n+1;
keys_Str(n,m)=CGStr("c");
n=n+1;
keys_Str(n,m)=CGStr("v");
n=n+1;
keys_Str(n,m)=CGStr("b");
n=n+1;
keys_Str(n,m)=CGStr("n");
n=n+1;
keys_Str(n,m)=CGStr("m");
n=n+1;
keys_Str(n,m)=CGStr(",");
n=n+1;
keys_Str(n,m)=CGStr(".");
n=n+1;
keys_Str(n,m)=CGStr("?");
n=n+1;
keys_Str(n,m)=CGStr("=");
// Make Shifted keys 
for (n = 0 ; n<= 10; n++)
{
for (m = 0 ; m<= 3; m++)
{
skeys_Str(n,m) = keys_Str(n,m) ;
if (ASC(skeys_Str(n,m)) >= ASC(CGStr("a")) AND ASC(skeys_Str(n,m)) <= ASC(CGStr("z")) )
{
skeys_Str(n,m) = CHR_Str(ASC(skeys_Str(n,m)) + ASC(CGStr("A")) - ASC(CGStr("a"))) ;
}
}
}
skeys_Str(7,3)=CGStr("<");
skeys_Str(8,3)=CGStr(">");
skeys_Str(9,2)=CGStr(":");
skeys_Str(0,0)=CGStr("!") ;
skeys_Str(1,0)=CGStr("@");
skeys_Str(2,0)=CGStr("#");
skeys_Str(3,0)=CGStr("$");
skeys_Str(4,0)=CGStr("%") ;
skeys_Str(5,0)=CGStr("^");
skeys_Str(6,0)=CGStr("&");
skeys_Str(7,0)=CGStr("*");
skeys_Str(8,0)=CGStr("(");
skeys_Str(9,0)=CGStr(")");
skeys_Str(9,3)=CGStr("/");
skeys_Str(10,0)=CGStr("_");
skeys_Str(10,3)=CGStr("+");
GETFONTSIZE( dx, dy);
kwidth = width/12.5;
kheight=height/4;
dx = (kwidth-dx)/2;
dy = (kheight-dy)/2;
for(;;)
{
__g_pRbow->PasteSurface(3);

blink=blink+GETTIMER()/300;
if (MOD(blink, 2)==0)
{
PRINT( word_Str, 0, 0);
}
else
{
PRINT( word_Str+CGStr("|"), 0, 0);
}
DRAWRECT( 0,posy, width,height, col3);
for (n = 0 ; n<= 10; n++)
{
for (m = 0 ; m<= 3; m++)
{
x = n*kwidth + m*kwidth/2;
y = m*kheight+posy;
DrawKey(x, y, x+kwidth-1, y+kheight-1, col1, col2) ;
if (shift)
{
PRINT( skeys_Str(n,m), x+dx, y+dy);
}
else
{
PRINT(  keys_Str(n,m), x+dx, y+dy);
}
}
}
// Shift-key 
			x = 0;
y = 3*kheight+posy;
DrawKey( x, y, x+kwidth*1.5-1, y+kheight-1, col1, col2) ;
PRINT( CGStr("^"), x+dx+kwidth/2, y+dy);
// Enter 
			x = 10.5*kwidth;
y = kheight+posy;
DrawKey( x+kwidth/2, y+kheight-2, x+kwidth*2-1, y+kheight*2-1, col1, col2) ;
DrawKey( x, y, x+kwidth*2-1, y+kheight-1, col1, col2) ;
PRINT( CGStr("OK"), x+dx, y+dy);
// Del 
			x = 11*kwidth;
y = posy;
DrawKey( x, y, x+kwidth*1.5-1, y+kheight-1, col1, col2) ;
PRINT( CGStr("<-"), x+dx, y+dy);
// Space Bar 
			x = 0;
y = 2*kheight+posy;
DrawKey( x, y, x+kwidth-1, y+kheight-1, col1, col2) ;
PRINT( CGStr(""), x+dx, y+dy);
MOUSESTATE( x, y, n, m);
DRAWRECT( x-4, y-4, 9, 9, RGB(255, 255, 128) );
y=y-posy;
if (wasup AND n)
{
wasup=FALSE;
y = INTEGER(y/(kheight)) ;
x = x-y*kwidth/2;
if (x<=0)
{
x=INTEGER(x/kwidth)-1;
}
else
{
x = INTEGER(x/kwidth);
}
if (x>10 OR (x>9 AND (y==1 OR y==2)) )
{
if (y==1 OR y==2 )
return word_Str ;
// Enter 
					if (y==0 )
word_Str = MID_Str(word_Str, 0, LEN(word_Str)-1) ;
// Backspace 
				}
else
{
if (x<0)
{
if (y==2 )
word_Str=word_Str+CGStr(" ") ;
if (y==3 )
shift=1-shift;
}
else
{
// normal key 
						if (shift)
{
word_Str=word_Str + skeys_Str(x,y) ;
}
else
{
word_Str=word_Str+keys_Str(x,y) ;
}
shift=0;
}
}
}
if (n==FALSE )
wasup=TRUE;
SHOWSCREEN();
HIBERNATE();
}
return 0;
}

extern "C" void __GLB_close_all_filehandles();

extern "C" void __ShutDownGLBasic()
{
	static int washere=0;
	if(!washere)
	{
		washere=1;
		g_debug("call GLB_ON_QUIT\n");
		CALLBYNAME(DGStr("GLB_ON_QUIT"));
	}

	g_debug("Shut down GLB\n");
	STOPMUSIC();

	// be safe to really, really shut down the network commands
	for(int safe=0; safe<16; ++safe)
	{
		netShutdown();
	}

	g_debug("file handles\n");
	__GLB_close_all_filehandles(); // write profiler output

	g_debug("shoebox\n");
#ifdef WANT_SHOEBOX
	if (__g_ShoeBox_Data) delete __g_ShoeBox_Data;
	if (__g_ShoeBox_Data) delete __g_ShoeBox_Media;
#endif

	
	// Post Quit message
/*
	g_debug("wm close");
	PostMessage( gpFramework->m_HWND, WM_CLOSE, 0, 0 );
	gpFramework->WinMSG();
	g_debug("post quit");
	PostQuitMessage(0);
	gpFramework->WinMSG();
*/

	g_debug("del netw\n");
	if (pGFNet) delete pGFNet; pGFNet=NULL;
	g_debug("del sfx\n");
	if(__g_SoundFX) delete[] __g_SoundFX;__g_SoundFX=NULL;

	g_debug("shut frmwrk\n");
	gpFramework->ShutDown();
	g_debug("del frmwrk\n");
	if(gpFramework) delete gpFramework; gpFramework=NULL;
	g_debug("glb is shut down\n");
}


}// namespace


// ------------------------------------------------------------- //
extern "C" void __EndProgram(void) // Called in any case the PRG will be stopped
// ------------------------------------------------------------- //
{
// avoid recursion
static int shutting_down=0;
	if(shutting_down) return;
	shutting_down=1;

	g_debug("__EndProgram\n");
	PostQuitMessage(0);
	g_debug("Errorline\n");
	g_debug("%d\n", __g_errorline);
	g_debug("Last line\n");
	g_debug("%d\n", __g_debugline);
	g_debug("Code\n");
	g_debug("%d\n", __g_error);


	__ShutDownGLBasic();

	g_debug("update Desktop\n");

	Sleep(500);
	::InvalidateRect(0, NULL, TRUE);
	g_debug("terminate\n");
	ExitProcess(0); // for CE the best way they say
	TerminateProcess((HINSTANCE)GetCurrentProcess(), 0);
	g_debug("after ExitProcess()\n");
	exit(0);
	g_debug("after exit()\n");
	*(int*)0 = 0;
}

