#ifndef BITMAP_H
#define BITMAP_H

#if defined(TINYGL) || defined(TRENKI3D)

// - HEADERS ---------------------------------------------------
#include "oscreen.h"

struct OPENGL_IMAGE;

// - OBJECTS ---------------------------------------------------
class oBitmap
{
public:
	oBitmap();
	~oBitmap();
	void XButton();
	void Create(const char* filename, COLORREF cookie, RECT *argRectangle=NULL);
	bool CreateBy(OPENGL_IMAGE& img , COLORREF cookie, RECT *argRectangle=NULL);
	void Delete(void);
	oBitmap& operator=(const oBitmap& b);

	inline       unsigned short* Pixels()      {return m_Buffer;}
	inline const unsigned short* Pixels()const {return m_Buffer;}

	void CreateRotatation(float degrees, oBitmap& out);
	void DrawClip(int argX, int argY, int ClipX, int ClipY, int ClipWidth, int ClipHeight);
	inline void Draw(int argX, int argY)
										{
											DrawClip(argX, argY, 0,0, m_Width,m_Height);
										}

	void Zoom(int argX, int argY, int endX, int endY);
	void GrabFrom(int argX, int argY, int endX, int endY, COLORREF cookie);
//	unsigned short* GetPixel(int x, int y);
	void MemCpyToScreen();
	void MemCpyFromScreen();
	bool SaveBMPFile(const char* szFilename);
	void Rotate90Degs();
	void DeleteGLTexture();

	inline bool good()					{return m_Buffer ? true : false;}
	static bool Collision(oBitmap& b1, int x1, int y1, oBitmap& b2, int x2, int y2);
	static bool CollisionClip(	oBitmap& b1, int x1, int y1, int cx1, int cy1, int cw1, int ch1,
								oBitmap& b2, int x2, int y2, int cx2, int cy2, int cw2, int ch2);
#ifdef TINYGL
	unsigned int MakeGLTexture();
	unsigned int m_glTextureId;
#endif

private:
	static bool _PixelCollision(	oBitmap& b1, int x1, int y1, oBitmap& b2, int x2, int y2,
									int xs, int xe, int ys, int ye);


public:
	int				m_Width;
	int				m_Height;
	unsigned short	m_colorkey;
	bool			m_CookieInside;


private:
	unsigned short  *m_Buffer;
	unsigned char	*m_CookieInLine;

};


// - PROTOTYPES ------------------------------------------------

#endif // #if defined(TINYGL) || defined(TRENKI3D)
#endif

