
#if 0

// - HEADERS ---------------------------------------------------
#include "Stdafx.h"

#include "oBMP.h"
#include "oScreen.h"

#ifdef _WIN32_WCE
extern "C" HBITMAP SHLoadImageFile(LPCTSTR pszFileName);
#endif

// - MEMBER FUNCTIONS ------------------------------------------
oBMP::oBMP()
{
	Bitmap=NULL;
}

oBMP::~oBMP()
{
	Delete();
}




// extern HBITMAP (*SHLoadImageFile)(LPCTSTR);


void oBMP::Create(const char* szFileName)
{
BITMAP bmp;
HBITMAP hbmp=NULL;
	Delete();

	char fname[512];
	GFFileSystem::MakeAbsolutePathCE(szFileName, fname);

	#ifdef UNICODE
		wchar_t szFile[512];
		_mbstowcsz(szFile, fname, strlen(fname)+1);
	#else
		const char* szFile = fname;
	#endif


	#ifdef _WIN32_WCE
		hbmp = SHLoadImageFile(szFile);
	#else
		#ifndef LR_LOADFROMFILE
		#define LR_LOADFROMFILE 0x0010
		#endif
		hbmp = (HBITMAP)::LoadImage(NULL, szFile, IMAGE_BITMAP, 0,0, 0x0010 /*LR_LOADFROMFILE*/);
	#endif

	if(!hbmp) return;
	if (::GetObject(hbmp, sizeof(BITMAP), &bmp))
	{
	    bmp.bmHeight = abs(bmp.bmHeight);

		unsigned char* pixels;

		// Useing CreateDIBSection now
		HDC hDC = GetWindowDC(NULL);

		// Initialize the BITMAPINFOHEADER in m_DIBinfo
		BITMAPINFO bi;
		memset(&bi, 0, sizeof(bi));
		BITMAPINFOHEADER& bih= bi.bmiHeader;
		bih.biSize          = sizeof(BITMAPINFOHEADER);
		bih.biWidth         = bmp.bmWidth;
		bih.biHeight        = bmp.bmHeight;
		bih.biPlanes        = 1;  // Must always be 1 according to docs
		bih.biBitCount      = 24;
		bih.biCompression   = BI_RGB;
		bih.biSizeImage     = ALIGN_4_BYTES(bmp.bmWidth*3) * bmp.bmHeight;

		HBITMAP hTargetBitmap = CreateDIBSection(hDC, (const BITMAPINFO*)&bi, DIB_RGB_COLORS, (void**) &pixels, NULL, 0);
		ReleaseDC(NULL, hDC);		

		// Copy source bitmap into the target bitmap.
		// Create 2 device contexts 
		HDC hMemDc = ::CreateCompatibleDC(NULL);
		HDC hTargetDc = ::CreateCompatibleDC(NULL);

		// Select source bitmap into one DC, target into another
		HBITMAP hOldBitmap1 = (HBITMAP) ::SelectObject(hMemDc, hbmp);
		HBITMAP hOldBitmap2 = (HBITMAP) ::SelectObject(hTargetDc, hTargetBitmap);

		// Copy source bitmap into the target one
		::BitBlt(hTargetDc, 0, 0, bmp.bmWidth, bmp.bmHeight, hMemDc, 0, 0, SRCCOPY);

		// Restore device contexts
		::SelectObject(hMemDc, hOldBitmap1);
		::SelectObject(hTargetDc, hOldBitmap2);

		::DeleteDC(hMemDc);
		::DeleteDC(hTargetDc);

		Bitmap = new unsigned char[ bmp.bmWidth* bmp.bmHeight* 3 ];
		InfoHeader.BitDepth=24;
		InfoHeader.Width = bmp.bmWidth;
		InfoHeader.Height= bmp.bmHeight;

		unsigned char* pCur;
		for(int y=0; y<bmp.bmHeight; ++y)
		{
			unsigned char* pbPixel = pixels + y * ALIGN_4_BYTES(bmp.bmWidth*3);
			pCur = Bitmap+y*bmp.bmWidth*3;
			for (int x=0; x<bmp.bmWidth; ++x)
			{
				*pCur++ = *pbPixel++;
				*pCur++ = *pbPixel++;
				*pCur++ = *pbPixel++;
			}
		}
		DeleteObject(hTargetBitmap);
	}
}

/*
void oBMP::CreateOld(const char *argPathname)
{
	Delete();
	unsigned long A, B;
	
	GFFileSystem File;
	unsigned char* bmicolors = NULL; // color table for 8 bit bmp
	unsigned short RowWidth;
	unsigned short RowPadding;

	Flag = 0;

	// Open the file:
	if(!File.OpenIn(argPathname)) return;

	// Load the file header:
	File.Read(&FileHeader.Type,      2);
	File.Read(&FileHeader.Size,      4);
	File.Read(&FileHeader.Reserved1, 2);
	File.Read(&FileHeader.Reserved2, 2);
	File.Read(&FileHeader.Offset,    4);

	// Load the header:
	File.Read(&InfoHeader.Size, 4);
	File.Read(&InfoHeader.Width, InfoHeader.Size-4);

	// 14 + 40 + 4 * infoheader.ncolours = header.offset
	FileHeader.Offset-=(14+40); 
	if (FileHeader.Offset>0)
	{
		bmicolors = new unsigned char[FileHeader.Offset];
		File.Read(bmicolors, FileHeader.Offset);
	}

	ColorDepth = (unsigned char)(InfoHeader.BitDepth / 8);

	RowWidth   = (unsigned short)(((InfoHeader.Width * ColorDepth) + 3) & (~3));
	RowPadding = (unsigned short)(RowWidth - (InfoHeader.Width * ColorDepth));

	// Allocate the bitmap:
	Bitmap = new unsigned char[ InfoHeader.Width * InfoHeader.Height * 3 ];	

	unsigned int Offset = 0; //(InfoHeader.Height - 1) * InfoHeader.Width * ColorDepth;

	// Load the bitmap:
	int dummy;
	for(A = 0; A < (unsigned)InfoHeader.Height; A++)
	{
		for(B = 0; B < (unsigned)InfoHeader.Width; B++)
		{
			// Read the next pixel:
			switch(InfoHeader.BitDepth)
			{
			case 24:
				File.Read(&Bitmap[ Offset ], 3);
				Offset+=3;
				break;
			case 32:
				{
				File.Read(&dummy, 4); // 3 color, 1 alpha(skipped)
				memcpy(&Bitmap[ Offset ], &dummy, 3);
				Offset+=3;
				}
				break;
			case 8:
				{
				unsigned char pixl;
				File.Read(&pixl, 1);
				Bitmap[Offset++]=bmicolors[pixl*4];   // Blue
				Bitmap[Offset++]=bmicolors[pixl*4+1]; // Green
				Bitmap[Offset++]=bmicolors[pixl*4+2]; // Red
				}
			}
		}
		if (RowPadding)
			File.SeekTo(RowPadding, GFFileSystem::current);
	}
	if(bmicolors) delete[] bmicolors;
}
*/


bool oBMP::Dimensions(const char* argPathname, short* pX, short *pY)
{
	GFFileSystem File;
	// Open the file:
	if(File.OpenIn(argPathname))
	{
		// Skip the file header:
		File.SeekTo(14);
//		fseek(File, 14, SEEK_SET);
		// Load the header:
		oBMPInfoHeader header;
		File.Read(&header, sizeof(oBMPInfoHeader));
		*pX = (short)header.Width;
		*pY = (short)header.Height;
		return true;
	}
	*pX=0;
	*pY=0;
return false;
}

void oBMP::Delete(void)
{
	if(Bitmap)
	{
		InfoHeader.Height = 0;
		InfoHeader.Width = 0;
		delete[] Bitmap;
		Bitmap = NULL;
	}
}

void oBMP::XButton()
{
	Delete();
	ColorDepth=24;
	InfoHeader.Height = 14;
	InfoHeader.Width = 14;
	Bitmap = new unsigned char[InfoHeader.Height * InfoHeader.Width * 3 ];

//	unsigned short blue = PackColor(0,0,255); unsigned short white = PackColor(255,255,255);
	long j;
	for (j=0; j<InfoHeader.Height * InfoHeader.Width; j++)
	{
		Bitmap[j*3  ] = 255;
		Bitmap[j*3+1] = 0;
		Bitmap[j*3+2] = 0;
	}
	long n = InfoHeader.Height; if (InfoHeader.Width<n) n=InfoHeader.Width;
	for (j=3; j<n-3; j++)
	{
		Bitmap[(j*n+j)*3  ] = 255;
		Bitmap[(j*n+j)*3+1] = 255;
		Bitmap[(j*n+j)*3+2] = 255;

		if (j<n-1 && j>3)
		{
		Bitmap[(j*n+n-j+1)*3  ] = 255;Bitmap[(j*n+n-j+1)*3+1] = 255;Bitmap[(j*n+n-j+1)*3+2] = 255;
		}
		Bitmap[(j*n+n-j)*3  ] = 255;Bitmap[(j*n+n-j)*3+1] = 255;Bitmap[(j*n+n-j)*3+2] = 255;
	}
}

void oBMP::DefaultFont()
{
	Delete();
	ColorDepth=24;
	InfoHeader.Width = 112;
	InfoHeader.Height = 64;
	Bitmap = new unsigned char[InfoHeader.Height * InfoHeader.Width * 3 ];

// 5x6 font ;)
static unsigned int tmap[6][16] = {
	0x00000000, 0x08021080, 0x00002940, 0x15f57d40, 0x08e619c4, 0x14222140, 0x0ed114e0, 0x00001080, 0x08210880, 0x04421040, 0x09575480, 0x08471080, 0x04400000, 0x00070000, 0x08000000, 0x04222100, 
	0x00e5294e, 0x004210c4, 0x00e1390e, 0x00e4390e, 0x0084394a, 0x00e4384e, 0x00e5384e, 0x0042210e, 0x00e5394e, 0x00e4394e, 0x00020080, 0x00220080, 0x00820888, 0x000701c0, 0x00222082, 0x0040310e, 
	0x00e0b526, 0x00a5394e, 0x00e5194e, 0x00e5094e, 0x00e52946, 0x00e1384e, 0x0021384e, 0x00e5284e, 0x00a5394a, 0x00e2108e, 0x00e5210c, 0x00a5194a, 0x00e10842, 0x015ad6bf, 0x00a5294e, 0x00e5294e, 
	0x0021394e, 0x00f294a7, 0x00a5194e, 0x00e4384e, 0x0042108e, 0x00e5294a, 0x0045294a, 0x01fad6b5, 0x00a5114a, 0x0042394a, 0x00e1110e, 0x00610846, 0x01041041, 0x00621086, 0x00000144, 0x00e00000, 
	0x00000082, 0x00e53000, 0x00e53842, 0x00e13800, 0x00e53908, 0x08273800, 0x00423888, 0x08873800, 0x00a51842, 0x00421004, 0x04421004, 0x00a32842, 0x00421084, 0x015abc00, 0x00a51800, 0x00e53800, 
	0x04e51800, 0x10e53000, 0x00253800, 0x00e409c0, 0x00c23884, 0x00c52800, 0x00452800, 0x00ead400, 0x00a22800, 0x1c872800, 0x00e121c0, 0x00821888, 0x00421084, 0x00223082, 0x0002a800, 0x3f18c63f, 
	};
	for(unsigned int cx=0; cx<16; ++cx)
	{
		for(unsigned int cy=0; cy<6; ++cy)
		{
			for(unsigned int x=0; x<7; ++x)
			{
				for(unsigned int y=0; y<8; ++y)
				{
					#define PIXP(px, py) ( ((px)+cx*7)*3 + (47 - (cy*8+(py)))*112*3 )
					#define WHITE(px, py) {Bitmap[PIXP(px,py)]=255; Bitmap[PIXP(px,py)+1]=255; Bitmap[PIXP(px,py)+2]=255;}
					#define BLACK(px, py) {Bitmap[PIXP(px,py)]=8; Bitmap[PIXP(px,py)+1]=8; Bitmap[PIXP(px,py)+2]=8;}
					#define COOKIE(px, py) {Bitmap[PIXP(px,py)]=0; Bitmap[PIXP(px,py)+1]=0; Bitmap[PIXP(px,py)+2]=0;}
					#define SET(px, py) ( (px<1 || px>5 || py<1 || py>6) ? 0 : (tmap[cy][cx] & (1<<((px)+5*(py) -5-1   ))) )
					COOKIE(x,y);
					if(SET(x,y))
					{
						WHITE(x,y);
					}
					else
					{
						if     (x<7 && SET(x+1,y) ) {BLACK(x,y);}
						else if(x>0 && SET(x-1,y) ) {BLACK(x,y);}
						else if(y>0 && SET(x,y-1) ) {BLACK(x,y);}
						else if(y<7 && SET(x,y+1) ) {BLACK(x,y);}
					}
					#undef PIXP
					#undef WHITE
					#undef BLACK
					#undef SET
				}
			}
		}
	}
}

#endif


