// oFont.cpp: implementation of the oFont class.
//
//////////////////////////////////////////////////////////////////////
#if defined(TINYGL) || defined(TRENKI3D)
#include "stdafx.h"

#include "ofont.h"
#include "openglimage.h"
#include "openglrainbows.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

oFont::oFont()
{
m_cheight=m_cwidth=0;
m_charset=128;
}

oFont::~oFont()
{
}


bool oFont::CreateBy(OPENGL_IMAGE& img)
{
	Delete();
short width, height;

//	img.resize(128,64); memset(img.txdata, 255, 128*64*4);

	if(img.m_sizex >= img.m_sizey)
	{
		m_charset=128;
		width=(short)img.m_sizex/16;
		height=(short)img.m_sizey/8;
	}
	else
	{
		m_charset=256;
		width=(short)img.m_sizex/16;
		height=(short)img.m_sizey/16;
	}

	for (short n=0; n<m_charset; n++)
	{
		RECT rect;
		rect.left = (n%16) * width;
		rect.top  = (n/16) * height;
		rect.right  = rect.left+width-1;
		rect.bottom = rect.top+height-1;
		m_blocks[n].CreateBy(img, RGB(255,0,128), &rect);
	}
	m_cwidth = width;
	m_cheight = height;
return true;
}


void oFont::Delete()
{
	for (short n=0; n<m_charset; n++) m_blocks[n].Delete();
	m_cheight=m_cwidth=0;
}

void oFont::Print(const char* text, int x, int y, const GLR_FONTKERNING* pKern)
{
	if(pKern)
	{
		for(;;)
		{
			unsigned char asc = (unsigned char)(*text++);
			if(!asc) return;
			const GLR_FONTKERNING& K = pKern[asc];

			m_blocks[ asc % m_charset ].DrawClip(x,y, K.xoff, 0, K.width+K.xoff, 999);
			x+=K.width;
		}
	}
	else
	{
		while(*text)
		{
			m_blocks[ ((unsigned)*text++)%m_charset ].Draw(x, y);
			x+=m_cwidth;
		}
	}

}
#endif // #if defined(TINYGL) || defined(TRENKI3D)


