@ void do_rotated_blit (void *dst, void *src)
@ Taken from gpSP emulator for Wiz with modification for full rotation.

@ input: r2-r5
@ output: r7,r8
@ trash: r6
.macro rb_line_low
    mov     r6, r2, lsl #16
    mov     r7, r3, lsl #16
    orr     r7, r7, r6, lsr #16
    mov     r6, r4, lsl #16
    mov     r8, r5, lsl #16
    orr     r8, r8, r6, lsr #16
.endm

.macro rb_line_hi
    mov     r6, r2, lsr #16
    mov     r7, r3, lsr #16
    orr     r7, r6, r7, lsl #16
    mov     r6, r4, lsr #16
    mov     r8, r5, lsr #16
    orr     r8, r6, r8, lsl #16
.endm

.global do_rotated_blit @ void *dst, void *src
do_rotated_blit:
	stmfd   sp!, {r4-r9,lr}

	add     r0, r0, #(240*320)*2
	sub	r0, r0, #(240)*2

	mov     r9, #240/4
rotated_blit_loopy:

	mov     lr, #320/4
rotated_blit_loopx:
	ldr     r2, [r1, #320*0*2]
	ldr     r3, [r1, #320*1*2]
	ldr     r4, [r1, #320*2*2]
	ldr     r5, [r1, #320*3*2]
	rb_line_low
	stmia   r0, {r7,r8}
	sub     r0, r0, #240*2
	rb_line_hi
	stmia   r0, {r7,r8}
	sub     r0, r0, #240*2

	ldr     r2, [r1, #320*0*2+4]
	ldr     r3, [r1, #320*1*2+4]
	ldr     r4, [r1, #320*2*2+4]
	ldr     r5, [r1, #320*3*2+4]
	rb_line_low
	stmia   r0, {r7,r8}
	sub     r0, r0, #240*2
	rb_line_hi
	stmia   r0, {r7,r8}
	sub     r0, r0, #240*2

	subs    lr, lr, #1
	add     r1, r1, #8
	bne     rotated_blit_loopx

	add     r0, r0, #(240*320)*2
	add	r0, r0, #(4)*2
	add	r1, r1, #(320*3)*2

	subs	r9, r9, #1
	bne     rotated_blit_loopy

	ldmfd   sp!,{r4-r9,pc}
	