REM Must set:
REM PLATFORM     = folder within GLBasic\Compiler\platform = extension of libs
REM GCC_PREFIX   = prefix of g++.exe (path must be in "%COMPILER%\bin" )
REM GCC_ARGS     = args and more includes and defines


SET COMPILER=..\%PLATFORM%
SET PATH=%COMPILER%\bin;%COMPILER%;%SystemRoot%\System32

REM Some compilers (Android) fail on long pathes here.
SET TMPDIR=C:\Temp
IF NOT EXIST "%TMPDIR%" (
	MKDIR "%TMPDIR%"
)


ECHO ..libCxImage Platform:[%PLATFORM%]

REM CD to "GLBasic\Compiler\platform\Source"
CD /D "%~dp0"

SET GCC_CMD=%GCC_PREFIX%gcc -pipe -O3 -w -I./glbasic -isystem./SDL-1.2.11/include -I./trenki3D -I./cximage/zlib -I./cximage/png -I./cximage/jpeg -I"%COMPILER%/include" %GCC_ARGS% -c

%GCC_CMD% cximage\png\png.c cximage\png\pngerror.c cximage\png\pngget.c cximage\png\pngmem.c cximage\png\pngpread.c cximage\png\pngread.c cximage\png\pngrio.c cximage\png\pngrtran.c cximage\png\pngrutil.c cximage\png\pngset.c cximage\png\pngtrans.c cximage\png\pngwio.c cximage\png\pngwrite.c cximage\png\pngwtran.c cximage\png\pngwutil.c cximage\png\gf_png.cpp
%GCC_CMD% cximage\jpeg\jcapimin.c cximage\jpeg\jcapistd.c cximage\jpeg\jccoefct.c cximage\jpeg\jccolor.c cximage\jpeg\jcdctmgr.c cximage\jpeg\jchuff.c cximage\jpeg\jcinit.c cximage\jpeg\jcmainct.c cximage\jpeg\jcmarker.c cximage\jpeg\jcmaster.c cximage\jpeg\jcomapi.c cximage\jpeg\jcparam.c cximage\jpeg\jcphuff.c cximage\jpeg\jcprepct.c cximage\jpeg\jcsample.c cximage\jpeg\jctrans.c cximage\jpeg\jdapimin.c cximage\jpeg\jdapistd.c cximage\jpeg\jdatadst.c cximage\jpeg\jdatasrc.c cximage\jpeg\jdcoefct.c cximage\jpeg\jdcolor.c cximage\jpeg\jddctmgr.c cximage\jpeg\jdhuff.c cximage\jpeg\jdinput.c cximage\jpeg\jdmainct.c cximage\jpeg\jdmarker.c cximage\jpeg\jdmaster.c cximage\jpeg\jdmerge.c cximage\jpeg\jdphuff.c cximage\jpeg\jdpostct.c cximage\jpeg\jdsample.c cximage\jpeg\jdtrans.c cximage\jpeg\jerror.c cximage\jpeg\jfdctflt.c cximage\jpeg\jfdctfst.c cximage\jpeg\jfdctint.c cximage\jpeg\jidctflt.c cximage\jpeg\jidctfst.c cximage\jpeg\jidctint.c cximage\jpeg\jidctred.c cximage\jpeg\jmemmgr.c cximage\jpeg\jmemnobs.c cximage\jpeg\jquant1.c cximage\jpeg\jquant2.c cximage\jpeg\jutils.c cximage\jpeg\gf_jpg.cpp


%GCC_CMD% cximage\zlib\adler32.c cximage\zlib\compress.c cximage\zlib\crc32.c cximage\zlib\deflate.c cximage\zlib\gzclose.c cximage\zlib\gzlib.c cximage\zlib\gzread.c cximage\zlib\gzwrite.c cximage\zlib\infback.c cximage\zlib\inffast.c cximage\zlib\inflate.c cximage\zlib\inftrees.c cximage\zlib\trees.c cximage\zlib\uncompr.c cximage\zlib\zutil.c

REM append: "2>&1|more" to have the output in pages.


SET OBJECTS=png.o pngerror.o pngget.o pngmem.o pngpread.o pngread.o pngrio.o pngrtran.o pngrutil.o pngset.o pngtrans.o pngwio.o pngwrite.o pngwtran.o pngwutil.o gf_png.o jcapimin.o jcapistd.o jccoefct.o jccolor.o jcdctmgr.o jchuff.o jcinit.o jcmainct.o jcmarker.o jcmaster.o jcomapi.o jcparam.o jcphuff.o jcprepct.o jcsample.o jctrans.o jdapimin.o jdapistd.o jdatadst.o jdatasrc.o jdcoefct.o jdcolor.o jddctmgr.o jdhuff.o jdinput.o jdmainct.o jdmarker.o jdmaster.o jdmerge.o jdphuff.o jdpostct.o jdsample.o jdtrans.o jerror.o jfdctflt.o jfdctfst.o jfdctint.o jidctflt.o jidctfst.o jidctint.o jidctred.o jmemmgr.o jmemnobs.o jquant1.o jquant2.o jutils.o gf_jpg.o adler32.o compress.o crc32.o deflate.o gzclose.o gzlib.o gzread.o gzwrite.o infback.o inffast.o inflate.o inftrees.o trees.o uncompr.o zutil.o 

if "%LIB_EXTENSION%" == "" (
	SET LIB_EXTENSION=a
)


SET LIBPATH=%COMPILER%\lib\libCxImage%PLATFORM%.%LIB_EXTENSION%

DEL "%LIBPATH%" /Q >nul 2>&1
REM Android needs S -> no warning "internal ranlib" -> manual ranlib req.
%GCC_PREFIX%ar crlS "%LIBPATH%" %OBJECTS%

%GCC_PREFIX%ranlib "%LIBPATH%"
DEL %OBJECTS% /Q > NUL



