#include "stdafx.h"


#ifndef GLB_CONSOLE
#include "fbuffers.h"
#include "openglrainbows.h"

// Pandora:
// glBlendEquationOES = (PFNGLBLENDEQUATIONOESPROC)eglGetProcAddress("glBlendEquationOES");



// ES wrappers to have "EXT" names
#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
	#if defined(STATIC_NO_POSTFIX)
		#define GL_RENDERBUFFER_EXT GL_RENDERBUFFER
		#define GL_FRAMEBUFFER_EXT GL_FRAMEBUFFER
		#define GL_FRAMEBUFFER_COMPLETE_EXT GL_FRAMEBUFFER_COMPLETE
		#define GL_COLOR_ATTACHMENT0_EXT GL_COLOR_ATTACHMENT0
		#define GL_DEPTH_ATTACHMENT_EXT GL_DEPTH_ATTACHMENT
		#define GL_DEPTH_COMPONENT16 GL_DEPTH_COMPONENT16
		#define GL_DEPTH_COMPONENT24 GL_DEPTH_COMPONENT24
		#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME
		#define GL_FRAMEBUFFER_BINDING_EXT GL_FRAMEBUFFER_BINDING
		#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE

	#else
		#define GL_RENDERBUFFER_EXT GL_RENDERBUFFER_OES
		#define GL_FRAMEBUFFER_EXT GL_FRAMEBUFFER_OES
		#define GL_FRAMEBUFFER_COMPLETE_EXT GL_FRAMEBUFFER_COMPLETE_OES
		#define GL_COLOR_ATTACHMENT0_EXT GL_COLOR_ATTACHMENT0_OES
		#define GL_DEPTH_ATTACHMENT_EXT GL_DEPTH_ATTACHMENT_OES
		#define GL_DEPTH_COMPONENT16 GL_DEPTH_COMPONENT16_OES
		#define GL_DEPTH_COMPONENT24 GL_DEPTH_COMPONENT24_OES
		#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES
		#define GL_FRAMEBUFFER_BINDING_EXT GL_FRAMEBUFFER_BINDING_OES
		#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES
	#endif
#endif



#ifdef GF_MUST_LOAD_EXTENSIONS

#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
	#define PFNGLBINDRENDERBUFFEREXTPROC PFNGLBINDRENDERBUFFEROESPROC						
	#define PFNGLDELETERENDERBUFFERSEXTPROC PFNGLDELETERENDERBUFFERSOESPROC					
	#define PFNGLGENRENDERBUFFERSEXTPROC PFNGLGENRENDERBUFFERSOESPROC						
	#define PFNGLRENDERBUFFERSTORAGEEXTPROC PFNGLRENDERBUFFERSTORAGEOESPROC					
	#define PFNGLBINDFRAMEBUFFEREXTPROC PFNGLBINDFRAMEBUFFEROESPROC						
	#define PFNGLDELETEFRAMEBUFFERSEXTPROC PFNGLDELETEFRAMEBUFFERSOESPROC						
	#define PFNGLGENFRAMEBUFFERSEXTPROC PFNGLGENFRAMEBUFFERSOESPROC						
	#define PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC PFNGLCHECKFRAMEBUFFERSTATUSOESPROC					
	#define PFNGLFRAMEBUFFERTEXTURE2DEXTPROC PFNGLFRAMEBUFFERTEXTURE2DOESPROC					
	#define PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC PFNGLFRAMEBUFFERRENDERBUFFEROESPROC				
	#define PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVOESPROC
#endif

extern "C"{
	typedef void (APIENTRYP GF_PFNGLBINDRENDERBUFFEREXTPROC) (GLenum target, GLuint renderbuffer);
	typedef void (APIENTRYP GF_PFNGLDELETERENDERBUFFERSEXTPROC) (GLsizei n, const GLuint *renderbuffers);
	typedef void (APIENTRYP GF_PFNGLGENRENDERBUFFERSEXTPROC) (GLsizei n, GLuint *renderbuffers);
	typedef void (APIENTRYP GF_PFNGLRENDERBUFFERSTORAGEEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
	typedef void   (APIENTRYP GF_PFNGLBINDFRAMEBUFFEREXTPROC) (GLenum target, GLuint framebuffer);
	typedef void   (APIENTRYP GF_PFNGLDELETEFRAMEBUFFERSEXTPROC) (GLsizei n, const GLuint *framebuffers);
	typedef void   (APIENTRYP GF_PFNGLGENFRAMEBUFFERSEXTPROC) (GLsizei n, GLuint *framebuffers);
	typedef GLenum (APIENTRYP GF_PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC) (GLenum target);
	typedef void   (APIENTRYP GF_PFNGLFRAMEBUFFERTEXTURE2DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
	typedef void   (APIENTRYP GF_PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC) (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
	typedef void   (APIENTRYP GF_PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC) (GLenum target, GLenum attachment, GLenum pname, GLint *params);
}
#endif



// #if defined(HAVE_OPENGL) || (defined(HAVE_OPENGL_ES) && defined(_DEBUG))

#ifdef GF_MUST_LOAD_EXTENSIONS
namespace FRAMEBUFFER {
// EXT_framebuffer_object - http://oss.sgi.com/projects/ogl-sample/registry/EXT/framebuffer_object.txt

PFNGLBINDRENDERBUFFEREXTPROC glBindRenderbufferExt = NULL;
PFNGLDELETERENDERBUFFERSEXTPROC glDeleteRenderbuffersExt = NULL;
PFNGLGENRENDERBUFFERSEXTPROC glGenRenderbuffersExt = NULL;
PFNGLRENDERBUFFERSTORAGEEXTPROC glRenderbufferStorageExt = NULL;
PFNGLBINDFRAMEBUFFEREXTPROC glBindFramebufferExt = NULL;
PFNGLDELETEFRAMEBUFFERSEXTPROC glDeleteFramebuffersExt = NULL;
PFNGLGENFRAMEBUFFERSEXTPROC glGenFramebuffersExt = NULL;
PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC glCheckFramebufferStatusExt = NULL;
PFNGLFRAMEBUFFERTEXTURE2DEXTPROC glFramebufferTexture2DExt = NULL;
PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbufferExt = NULL;
PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC glGetFramebufferAttachmentParameterivExt = NULL;
// PFNGLISRENDERBUFFEREXTPROC glIsRenderbufferExt = NULL;
// PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC glGetRenderbufferParameterivExt = NULL;
// PFNGLISFRAMEBUFFEREXTPROC glIsFramebufferExt = NULL;
// PFNGLFRAMEBUFFERTEXTURE1DEXTPROC glFramebufferTexture1DExt = NULL;
// PFNGLFRAMEBUFFERTEXTURE3DEXTPROC glFramebufferTexture3DExt = NULL;
// PFNGLGENERATEMIPMAPEXTPROC glGenerateMipmapExt = NULL;

}
using namespace FRAMEBUFFER;
#endif


int gCanUseFBO = 0;

void FBUFFER::InitFrameBufferObject()
{
#ifdef GF_MUST_LOAD_EXTENSIONS
	glBindRenderbufferExt = (GF_PFNGLBINDRENDERBUFFEREXTPROC)glGFGetProcAddressArb("glBindRenderbuffer" EXTENSION_POSTFIX);
	glDeleteRenderbuffersExt = (GF_PFNGLDELETERENDERBUFFERSEXTPROC)glGFGetProcAddressArb("glDeleteRenderbuffers" EXTENSION_POSTFIX);
	glGenRenderbuffersExt = (GF_PFNGLGENRENDERBUFFERSEXTPROC)glGFGetProcAddressArb("glGenRenderbuffers" EXTENSION_POSTFIX);
	glRenderbufferStorageExt = (GF_PFNGLRENDERBUFFERSTORAGEEXTPROC)glGFGetProcAddressArb("glRenderbufferStorage" EXTENSION_POSTFIX);
	glBindFramebufferExt = (GF_PFNGLBINDFRAMEBUFFEREXTPROC)glGFGetProcAddressArb("glBindFramebuffer" EXTENSION_POSTFIX);
	glDeleteFramebuffersExt = (GF_PFNGLDELETEFRAMEBUFFERSEXTPROC)glGFGetProcAddressArb("glDeleteFramebuffers" EXTENSION_POSTFIX);
	glGenFramebuffersExt = (GF_PFNGLGENFRAMEBUFFERSEXTPROC)glGFGetProcAddressArb("glGenFramebuffers" EXTENSION_POSTFIX);
	glCheckFramebufferStatusExt = (GF_PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC)glGFGetProcAddressArb("glCheckFramebufferStatus" EXTENSION_POSTFIX);
	glFramebufferTexture2DExt = (GF_PFNGLFRAMEBUFFERTEXTURE2DEXTPROC)glGFGetProcAddressArb("glFramebufferTexture2D" EXTENSION_POSTFIX);
	glFramebufferRenderbufferExt = (GF_PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC)glGFGetProcAddressArb("glFramebufferRenderbuffer" EXTENSION_POSTFIX);
	glGetFramebufferAttachmentParameterivExt = (GF_PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC)glGFGetProcAddressArb("glGetFramebufferAttachmentParameteriv" EXTENSION_POSTFIX);
//	glIsRenderbufferExt = (GF_PFNGLISRENDERBUFFEREXTPROC)glGFGetProcAddressArb("glIsRenderbuffer" EXTENSION_POSTFIX);
//	glGetRenderbufferParameterivExt = (GF_PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC)glGFGetProcAddressArb("glGetRenderbufferParameteriv" EXTENSION_POSTFIX);
//	glIsFramebufferExt = (GF_PFNGLISFRAMEBUFFEREXTPROC)glGFGetProcAddressArb("glIsFramebuffer" EXTENSION_POSTFIX);
//	glFramebufferTexture1DExt = (GF_PFNGLFRAMEBUFFERTEXTURE1DEXTPROC)glGFGetProcAddressArb("glFramebufferTexture1D" EXTENSION_POSTFIX);
//	glFramebufferTexture3DExt = (GF_PFNGLFRAMEBUFFERTEXTURE3DEXTPROC)glGFGetProcAddressArb("glFramebufferTexture3D" EXTENSION_POSTFIX);
//	glGenerateMipmapExt = (GF_PFNGLGENERATEMIPMAPEXTPROC)glGFGetProcAddressArb("glGenerateMipmap" EXTENSION_POSTFIX);

#elif defined(STATIC_NO_POSTFIX)
	// static functions are there, but with no postfix
	#define glBindRenderbufferExt glBindRenderbuffer
	#define glDeleteRenderbuffersExt glDeleteRenderbuffers
	#define glGenRenderbuffersExt glGenRenderbuffers
	#define glRenderbufferStorageExt glRenderbufferStorage
	#define glBindFramebufferExt glBindFramebuffer
	#define glDeleteFramebuffersExt glDeleteFramebuffers
	#define glGenFramebuffersExt glGenFramebuffers
	#define glCheckFramebufferStatusExt glCheckFramebufferStatus
	#define glFramebufferTexture2DExt glFramebufferTexture2D
	#define glFramebufferRenderbufferExt glFramebufferRenderbuffer
	#define glGetFramebufferAttachmentParameterivExt glGetFramebufferAttachmentParameteriv
#elif defined(STATIC_OES_POSTFIX)
	// static functions are there, but with OES postfix
	#define glBindRenderbufferExt glBindRenderbufferOES
	#define glDeleteRenderbuffersExt glDeleteRenderbuffersOES
	#define glGenRenderbuffersExt glGenRenderbuffersOES
	#define glRenderbufferStorageExt glRenderbufferStorageOES
	#define glBindFramebufferExt glBindFramebufferOES
	#define glDeleteFramebuffersExt glDeleteFramebuffersOES
	#define glGenFramebuffersExt glGenFramebuffersOES
	#define glCheckFramebufferStatusExt glCheckFramebufferStatusOES
	#define glFramebufferTexture2DExt glFramebufferTexture2DOES
	#define glFramebufferRenderbufferExt glFramebufferRenderbufferOES
	#define glGetFramebufferAttachmentParameterivExt glGetFramebufferAttachmentParameterivOES
#elif defined(STATIC_EXT_POSTFIX)
	// static functions are there, but with OES postfix
	#define glBindRenderbufferExt glBindRenderbufferEXT
	#define glDeleteRenderbuffersExt glDeleteRenderbuffersEXT
	#define glGenRenderbuffersExt glGenRenderbuffersEXT
	#define glRenderbufferStorageExt glRenderbufferStorageEXT
	#define glBindFramebufferExt glBindFramebufferEXT
	#define glDeleteFramebuffersExt glDeleteFramebuffersEXT
	#define glGenFramebuffersExt glGenFramebuffersEXT
	#define glCheckFramebufferStatusExt glCheckFramebufferStatusEXT
	#define glFramebufferTexture2DExt glFramebufferTexture2DEXT
	#define glFramebufferRenderbufferExt glFramebufferRenderbufferEXT
	#define glGetFramebufferAttachmentParameterivExt glGetFramebufferAttachmentParameterivEXT
#endif

	gCanUseFBO = 0;

	#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
		if(glGenFramebuffersExt != NULL)
			gCanUseFBO = 1;
	#endif

	// Android shite does not have FBO support, but functions are there :/
	#if !defined(GF_MUST_LOAD_EXTENSIONS)
		#if defined(ANDROID)
		if(!strstr((const char*)glGetString(GL_EXTENSIONS), "framebuffer_object"))
		{
			static int iWarn = 0;
			if(iWarn == 0)
			{
				iWarn = 1;
				g_debug("framebuffer_object not in GL_EXTENSIONS\n");
				gCanUseFBO = 0;
			}
		}
		#endif
	#endif

#ifdef _DEBUG
//	gCanUseFBO = 0;
#endif

	if(!gCanUseFBO)
		g_debug("can't use framebuffer object\n");
}


bool FBUFFER::Create(int w, int h, unsigned int texture, bool bDepthBuffer)
{
	Clear();
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)

	if(w<=0 || h<=0)
	{
		g_debug("can't create FBO for neg dims %dx%d\n", w,h);
		return false;
	}

	#if defined(GF_MUST_LOAD_EXTENSIONS)
	if(	glGenFramebuffersExt && glGenRenderbuffersExt && glBindRenderbufferExt && glRenderbufferStorageExt && glCheckFramebufferStatusExt)
	#endif
	{
		// Create a frame-buffer object and a render-buffer object...
		glGenFramebuffersExt( 1, &m_frameBuffer );
		OPENGL_CHECK_ERRORS();
		if(!m_frameBuffer)
		{
			g_debug("glGenFramebuffersExt failed\n");
			return false;
		}

		// bind to complete
		this->Bind();

		glBindTexture(GL_TEXTURE_2D, texture); // DO bind that texture before putting in the fbo
		OPENGL_CHECK_ERRORS();

		// bind texture (2012-oct-17 moved before depth buffer)
		glFramebufferTexture2DExt( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, texture, 0 );
		OPENGL_CHECK_ERRORS();

		// optional depth storage
		if( bDepthBuffer)
		{
			glGenRenderbuffersExt( 1, &m_depthRenderBuffer );
			OPENGL_CHECK_ERRORS();
			if(!m_depthRenderBuffer)
			{
				g_debug("glGenRenderbuffersExt failed\n");
				Clear();
				return false;
			}
			// Initialize the render-buffer for usage as a depth buffer.
			// We don't really need this to render things into the frame-buffer object,
			// but without it the geometry will not be sorted properly.
			glBindRenderbufferExt( GL_RENDERBUFFER_EXT, m_depthRenderBuffer );
			OPENGL_CHECK_ERRORS();

			// order of trying the formats.
			#define GF_GL_DEPTH_COMPONENT16              0x81A5
			#define GF_GL_DEPTH_COMPONENT24              0x81A6
			#define GF_GL_DEPTH_COMPONENT32              0x81A7

			while(glGetError() != GL_NO_ERROR) {} // clear error flags

			glRenderbufferStorageExt( GL_RENDERBUFFER_EXT, GF_GL_DEPTH_COMPONENT32, w, h);
			if(glGetError() == GL_INVALID_ENUM)
			{
				g_debug("depth 32 failed, try 24\n");
				glRenderbufferStorageExt( GL_RENDERBUFFER_EXT, GF_GL_DEPTH_COMPONENT24, w, h);
			}
			if(glGetError() == GL_INVALID_ENUM)
			{
				g_debug("depth 32 failed, try 16\n");
				glRenderbufferStorageExt( GL_RENDERBUFFER_EXT, GF_GL_DEPTH_COMPONENT16, w, h);
			}

			OPENGL_CHECK_ERRORS();
			glFramebufferRenderbufferExt( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, m_depthRenderBuffer );
			OPENGL_CHECK_ERRORS();
		}

		// Check for errors after binding it
		GLenum status = glCheckFramebufferStatusExt( GL_FRAMEBUFFER_EXT );
		if(status == 0)
		{
			g_debug("glCheckFramebufferStatusExt()=0: glError=%x\n", (int)glGetError());
		}
		OPENGL_CHECK_ERRORS();

		// bind current one to avoid breaking stuff
		this->Unbind();

		if(status != GL_FRAMEBUFFER_COMPLETE_EXT)
		{
			#if defined(GF_WANT_OPENGL_DEBUG)
				#if defined(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT)
					#define ERRSTR(a) if(status == (a)) g_debug("FBO Status: %s\n", #a);
					ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT); // minion gets this on Nexus7. Might be renderbuffer invalid?
					ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT); // get this on my touchpad
					ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT);
					ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT);
					ERRSTR(GL_FRAMEBUFFER_UNSUPPORTED_EXT);
					ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT);
				#else
					g_debug("FBO Status: %x\n", status);
				#endif
			#endif

			g_debug("glBindRenderbufferExt failed %x\n", (int)status); // 8cd9 wenn tex too small..
			Clear();

			if(bDepthBuffer)
			{
				g_debug("Trying without a depth buffer as a fallback...\n"); // 8cd9 wenn tex too small..
				return Create(w, h, texture, false);
			}
			g_debug("CAN'T CREATE FRAMEBUFFER (CREATESCREEN)\n"); // 8cd9 wenn tex too small..
			return false;
		}


		m_Width=w;
		m_Height=h;
		return true;
	}
#else
	return true; // Trenki3D - no z buffer :( #NEED
#endif
return false;
}

int FBUFFER::GetActiveFrameBuffer()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
	if(!gCanUseFBO) return 0;

	GLint current = 0;
	glGetIntegerv(GL_FRAMEBUFFER_BINDING_EXT, &current);
	OPENGL_CHECK_ERRORS();
	return current;
#endif
	return 0;
}

int FBUFFER::GetActiveFrameBufferTexture()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
	if(!gCanUseFBO) return 0;

	GLint current = 0;
	if(glGetFramebufferAttachmentParameterivExt != NULL)
	{
		glGetFramebufferAttachmentParameterivExt(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
												GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT, &current);
	}
	OPENGL_CHECK_ERRORS();
	return current;
#endif
	return 0;
}

bool FBUFFER::Bind()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
	if(!gCanUseFBO)
		{return false;}

	// not currently rendering to _this_ fbo
	if(m_oldframeBuffer == -1)
	{
		// remember current FBO name - SDL e.g. uses a FBO as the back buffer
		m_oldframeBuffer=0;
		glGetIntegerv(GL_FRAMEBUFFER_BINDING_EXT, &m_oldframeBuffer);
		OPENGL_CHECK_ERRORS();
		
		// Bind the frame-buffer object and attach to it a render-buffer object 
		// set up as a depth-buffer.
		glBindFramebufferExt( GL_FRAMEBUFFER_EXT, m_frameBuffer );
		OPENGL_CHECK_ERRORS();

		return true;
	}
	else
	{
		g_debug("Trying to rebind the same FBO again. Need to end first\n");
	}
#endif
	return false;
}

bool FBUFFER::Unbind()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
	if(!gCanUseFBO) return false;

	if(m_oldframeBuffer != -1)
	{
		// Unbind the frame-buffer and render-buffer objects.
		glBindFramebufferExt( GL_FRAMEBUFFER_EXT, m_oldframeBuffer );
		OPENGL_CHECK_ERRORS();
		m_oldframeBuffer = -1;
		return true;
	}
#endif
	return false;
}


void FBUFFER::Clear()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)

	Unbind(); // just in case

	if(m_frameBuffer)
	{
		glDeleteFramebuffersExt( 1, &m_frameBuffer );
		OPENGL_CHECK_ERRORS();
		if(m_depthRenderBuffer)
			glDeleteRenderbuffersExt( 1, &m_depthRenderBuffer );
		OPENGL_CHECK_ERRORS();
	}
	m_frameBuffer = 0;
	m_depthRenderBuffer = 0;
	m_oldframeBuffer = -1;
#endif
	m_SpriteIndex = -1;
	m_Width=m_Height = 0;
}



#define GLR_EMERGENCY_TEXTURE (GLR_MAX_TEXTURES-GLR_MAX_FONT-1)

bool OpenGLRainbows::FBO_create(int iBuffer, int idSprite, int width, int height)
{
	if(iBuffer<0 || iBuffer>=GLR_MAX_FRAMEBUFFER) return false;

	this->FBO_end();
	m_FBuffer[iBuffer].Clear();

	if(idSprite >= 0)
		FreeSprite(idSprite);

	if(width<=0 || height<=0 || idSprite<0)
	{
		return false;
	}

	OPENGL_IMAGE img;
#if defined(TINYGL)  || defined(TRENKI3D)
	int		sx, sy;
	sx = width; sy  =height;
	if(!img.resize(sx,sy))
	{
		return false;
	}
	if(!m_Sprite[idSprite].CreateBy(img, m_CookieColor))
	{
		return false;
	}
#else
	int		sx, sy;
	// Create 2^n size
	sx=1; sy=1;
	do{sx<<=1;} while(sx < width);
	do{sy<<=1;} while(sy < height);

	if(!img.resize(sx,sy))
	{
		m_FBuffer[iBuffer].Clear();
		return false;
	}

	// glGenTextures( 1, &m_Texture[idTexture].mipstate[0] );
	OPENGL_CHECK_ERRORS();
	// will delete old texture and create new one (reusing id)
	if(!this->MakeTexture(img, 0,0,sx,sy,&m_Texture[idSprite].mipstate[0]))
	{
		OPENGL_CHECK_ERRORS();
		return false;
	}
	OPENGL_CHECK_ERRORS();
#endif

	m_Texture[idSprite].w =(short)sx; // Set Size of Texture
	m_Texture[idSprite].h =(short)sy;
	m_Texture[idSprite].bw=(short)width; // Set Size of BMP File
	m_Texture[idSprite].bh=(short)height;
	m_Texture[idSprite].txx=(float)m_Texture[idSprite].bw/m_Texture[idSprite].w;
	m_Texture[idSprite].txy=(float)m_Texture[idSprite].bh/m_Texture[idSprite].h;
	
	// create a depth buffer render target and a new framebuffer object
	if(!m_FBuffer[iBuffer].Create(sx,sy, m_Texture[idSprite].mipstate[0], true))
		return false;

	// store sprite index to access it later
	m_FBuffer[iBuffer].m_SpriteIndex = idSprite;

	this->FBO_end();

return true;
}


struct BACKUP_STATE
{
	int irot;
} gBackupState;

void OpenGLRainbows::FBO_start(int iBuffer)
{
	if(m_CurrentFBO>=0) FBO_end();

	if(iBuffer<0 || iBuffer>=GLR_MAX_FRAMEBUFFER) return;
	if(m_FBuffer[iBuffer].m_Width == 0)    return;

	m_CurrentFBO = iBuffer;

	int iSprite = m_FBuffer[iBuffer].m_SpriteIndex;
	int sx = m_Texture[iSprite].bw;
	int sy = m_Texture[iSprite].bh;
	
	#if defined(TRENKI3D)
		// texture is the oBitmap index
		Screen.SetDrawBuffer(m_Sprite[iSprite].Pixels(), m_Sprite[iSprite].m_Width, m_Sprite[iSprite].m_Height);
		tglSetBuffers(m_Sprite[iSprite].Pixels(), Screen.zBuffer, m_Sprite[iSprite].m_Width);
		// tglViewport(0,0,sx,sy);
		Make2DViewport(0,0,sx,sy); // you must also reload the matrix!
	#else
		if(m_FBuffer[iBuffer].Bind( ) ) // just bind to texture attached
		{
			Make2DViewport(0,0,sx,sy);
			glViewport(0, 0, sx,sy);
			OPENGL_CHECK_ERRORS();
		}
		else
		{
			// Use BackBuffer emergency fix (also for TinyGL)
			this->m_CurrentFBO = -1; // pretend we're not on FBO for X_MAKE2D
			gBackupState.irot = m_landscape;
			m_landscape = 0;
			Make2DViewport(0,0,sx,sy);
			COLORREF cc = m_CookieColor;
			m_CookieColor = 0xffffffff;
			GrabSprite(GLR_EMERGENCY_TEXTURE, 0,0,sx,sy);
			m_CookieColor = cc;
			DrawRect(0,0, sx,sy, m_CookieColor);
			DrawSprite(iSprite, 0,0);
			m_CurrentFBO = iBuffer;
		}
	#endif

	#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
	// must void the alpha pixels
	#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
		SpritePix[iSprite].Clear();
	#else
		if (SpritePix[iSprite])
			delete[] SpritePix[iSprite];
		SpritePix[iSprite]=NULL;
	#endif
	#endif
}


void OpenGLRainbows::FBO_end()
{
	if(m_CurrentFBO >=0)
	{
	#if defined(TRENKI3D)
		// texture is the oBitmap index
		Screen.SetDrawBuffer();
		tglSetBuffers(Screen.cBuffer, Screen.zBuffer, Screen.cBufferWidth);
		tglViewport(0,0,Screen.cBufferWidth, Screen.cBufferHeight);
	#else
		if(!m_FBuffer[m_CurrentFBO].Unbind())
		{
			// Backbuffer emergency fix
			int iSprite = m_FBuffer[m_CurrentFBO].m_SpriteIndex;
			GrabSprite(iSprite, 0,0, m_Texture[iSprite].bw, m_Texture[iSprite].bh);
			DrawRect(0,0, m_Texture[iSprite].w, m_Texture[iSprite].h, RGB(0,0,0) );
			DrawSprite(GLR_EMERGENCY_TEXTURE, 0,0);
			m_landscape = gBackupState.irot;
		}
	#endif
	}
	m_CurrentFBO = -1;
	Make2DViewport(0,0,0,0);
}


#else // console
	void glb_fbuffers_console_dummy() {};
#endif // GLB_CONSOLE -> drop all

