#include "stdafx.h"
#include <stdio.h> // sprintf


#if defined(WIN32) && (_WIN32_WINNT >= 0x0501)
	#define GFNET_USE_ADDRINFO
#elif defined(ANDROID)
	#define GFNET_USE_ADDRINFO
	#define GFNET_USE_IOCTL
#elif defined(POSIX)
	#define GFNET_USE_GETIFADDRS
#endif

#define NET_REAL_NONBLOCKING // use real nonblocking sockets instead of select() stuff
// select does not seem to work on iphone when recv'ing



/*

UDP:
- only one "bind()" per port! or you get a port-busy msg.
- must bind() to "listen" to a port. Otherwise packages dropped.
- must provide sockaddr_in in send_to where desitnation IP+port is stored.

conclusion:
must hold a list of udp connections for each local upd port to "read" from.

*/




// #include "gffilesystem.h" // g_debug -> remove!!



#if defined(WIN32) || defined(WIN64)
	#define NET_WIN_APP

	#define WIN32_LEAN_AND_MEAN
	#ifdef _WIN32_WCE
		#include <winsock.h>
		#include <sys/wcenetwork.h>
		#define WSAAPI FAR PASCAL
	#else
		#include <winsock2.h>
		#include <ws2tcpip.h>
	#endif
	#include <tchar.h>


	// these might differ if already defined on Win32!
	#ifdef EINPROGRESS
		#undef EINPROGRESS
		#undef EWOULDBLOCK
		#undef ECONNRESET
		#undef ENOMEM
	#endif

	// Windows error codes differ from these - I want them to have the right error string for debugging
	#define EINPROGRESS		WSAEINPROGRESS
	#define EWOULDBLOCK		WSAEWOULDBLOCK
	#define ECONNRESET		WSAECONNRESET
	#define ENOMEM			ERROR_NOT_ENOUGH_MEMORY
//	#define EAFNOSUPPORT	WSAEAFNOSUPPORT


	#define net_errno WSAGetLastError()
#else
	#include <sys/types.h>
	#include <sys/socket.h>
	#include <netdb.h>
	#include <sys/ioctl.h>
	#include <errno.h>

	#include <arpa/inet.h>

	#ifndef INVALID_SOCKET
	#define INVALID_SOCKET (-1)
	#endif
	#ifndef SOCKET_ERROR 
	#define SOCKET_ERROR  (-1)
	#endif
	
	#ifndef SOCKET
	typedef int SOCKET;
	#endif

	inline int closesocket(int sock) {return close(sock);} // unix way
	#ifndef TCHAR
		#ifdef _UNICODE
			typedef wchar_t TCHAR;
			#define TEXT(a) L##a
			#define _stprintf wsprintf
		#else
			typedef char TCHAR;
			#define TEXT(a) a
			#define _stprintf sprintf
		#endif
	#endif

	#define net_errno errno
	
#endif

	#ifdef PALM_WEBOS
		extern "C" int PDL_SetFirewallPortStatus(int port, int Open);
	#endif






#include "gf_sockets.h" // hopefully sockaddr_storage is defined, here


//// START gf_inet_ntop //////

/* This is from the BIND 4.9.4 release, modified to compile by itself */

/* Copyright (c) 1996 by Internet Software Consortium.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
 * CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */

#define	IN6ADDRSZ	16
#define	INT16SZ		 2


/*
 * WARNING: Don't even consider trying to compile this on a system where
 * sizeof(int) < 4.  sizeof(int) > 4 is fine; all the world's not a VAX.
 */

/* const char *
 * inet_ntop4(src, dst, size)
 *	format an IPv4 address, more or less like inet_ntoa()
 * return:
 *	`dst' (as a const)
 * notes:
 *	(1) uses no statics
 *	(2) takes a u_char* not an in_addr as input
 * author:
 *	Paul Vixie, 1996.
 */
static const char *
gf_inet_ntop4(
	const u_char *src,
	char *dst,
	size_t size)
{
	sprintf(dst, "%u.%u.%u.%u", src[0], src[1], src[2], src[3]);
	return (dst);
}

/* const char *
 * inet_ntop6(src, dst, size)
 *	convert IPv6 binary address into presentation (printable) format
 * author:
 *	Paul Vixie, 1996.
 */
static const char *
gf_inet_ntop6(
	const u_char *src,
	char *dst,
	size_t size)
{
	/*
	 * Note that int32_t and int16_t need only be "at least" large enough
	 * to contain a value of the specified size.  On some systems, like
	 * Crays, there is no such thing as an integer variable with 16 bits.
	 * Keep this in mind if you think this function should have been coded
	 * to use pointer overlays.  All the world's not a VAX.
	 */
	struct { int base, len; } best, cur;
	u_int words[IN6ADDRSZ / INT16SZ];

	/*
	 * Preprocess:
	 *	Copy the input (bytewise) array into a wordwise array.
	 *	Find the longest run of 0x00's in src[] for :: shorthanding.
	 */
	memset(words, 0, sizeof words);
	for (int i = 0; i < IN6ADDRSZ; i++)
		words[i / 2] |= (src[i] << ((1 - (i % 2)) << 3));
	best.base = -1;
	cur.base = -1;
	for (int i = 0; i < (IN6ADDRSZ / INT16SZ); i++) {
		if (words[i] == 0) {
			if (cur.base == -1)
				cur.base = i, cur.len = 1;
			else
				cur.len++;
		} else {
			if (cur.base != -1) {
				if (best.base == -1 || cur.len > best.len)
					best = cur;
				cur.base = -1;
			}
		}
	}
	if (cur.base != -1) {
		if (best.base == -1 || cur.len > best.len)
			best = cur;
	}
	if (best.base != -1 && best.len < 2)
		best.base = -1;

	/*
	 * Format the result.
	 */
	char* tp = dst;
	for(int i = 0; i < (IN6ADDRSZ / INT16SZ); i++) {
		/* Are we inside the best run of 0x00's? */
		if (best.base != -1 && i >= best.base &&
		    i < (best.base + best.len)) {
			if (i == best.base)
				*tp++ = ':';
			continue;
		}
		/* Are we following an initial run of 0x00s or any real hex? */
		if (i != 0)
			*tp++ = ':';
		/* Is this address an encapsulated IPv4? */
		if (i == 6 && best.base == 0 &&
		    (best.len == 6 || (best.len == 5 && words[5] == 0xffff))) {
			if (!gf_inet_ntop4(src+12, tp, sizeof dst - (tp - dst)))
				return (NULL);
			tp += strlen(tp);
			break;
		}
		sprintf(tp, "%x", words[i]);
		tp += strlen(tp);
	}
	/* Was it a trailing run of 0x00's? */
	if (best.base != -1 && (best.base + best.len) == (IN6ADDRSZ / INT16SZ))
		*tp++ = ':';
	*tp++ = '\0';

	return (dst);
}

/* char *
 * inet_ntop(af, src, dst, size)
 *	convert a network format address to presentation format.
 * return:
 *	pointer to presentation format address (`dst'), or NULL (see errno).
 * author:
 *	Paul Vixie, 1996.
 */
const char *
gf_inet_ntop(
	int af,
	const void *src,
	char *dst,
	size_t size)
{
	if(af == AF_INET6) {
		return (gf_inet_ntop6((const u_char *)src, dst, size));
	}
	return (gf_inet_ntop4((const u_char *)src, dst, size));
}
//// END gf_inet_ntop //////



















/*
What I've learned:
sockaddr - and variations
-------------------------
sockaddr is the generic term for a variety of sockaddr_xx.
As such, a "struct sockaddr" isn't really something you would declare (or "instantiate").
Declare your address to be of type "struct sockaddr_in" and cast its 
address into a "struct sockaddr *" when you need the latter.
Note that a "struct sockaddr" is *not* a union of all "struct sockaddr_xx"s
*/


static int gNumInit = 0;
static int gNetIPversion = AF_INET; // AF_INET(=2): IPv4, AF_INET6(=23): IPv6

// track errors at given positions
static int gNetErrNo = 0;
inline void netStoErr()
{
	gNetErrNo = net_errno;
}
	
void netStoErr(int err)
{
	gNetErrNo = err;
	// g_debug("net last err: %s\n", netLastError());
}



#define MAX_NET_SOCKS	1024
struct NET_SOCKS
{
	NET_SOCKS() {sock = INVALID_SOCKET;}
	SOCKET			sock;
//	sockaddr_in		addr; // IPv4 remote IP+port (in network format)
	sockaddr_storage addr; // IPv4+IPv6 storage structure (in network format)

	void* get_ip() const
	{
		if(addr.ss_family == AF_INET6)
		{
			return &((sockaddr_in6*)&addr)->sin6_addr;
		}
		else
		{
			return &((sockaddr_in*)&addr)->sin_addr;
		}
	}
	unsigned short get_port() const
	{
		if(addr.ss_family == AF_INET6)
		{
			return ((sockaddr_in6*)&addr)->sin6_port;
		}
		else
		{
			return ((sockaddr_in*)&addr)->sin_port;
		}
	}


	bool			udp;
	#ifndef NET_REAL_NONBLOCKING
		bool			blocking;
	#endif
} gNetSocks[MAX_NET_SOCKS];


// ----------------------------------------- //
// NETaddress :: get_family_ofIPv
// ----------------------------------------- //
int NETaddress::get_family_ofIPv(int v)
{
	if(v == 6)
		return AF_INET6;
	return AF_INET;
}

// ----------------------------------------- //
// NETaddress :: assign
// ----------------------------------------- //
void NETaddress::assign(int iFamily, const void* pIP, unsigned short port_hostmachine_format)
{
	m_ipFamily=iFamily;
	m_port=htons(port_hostmachine_format);
	if(pIP)
	{
		if(iFamily == AF_INET6)
		{
			memcpy(m_ip, pIP, 16);
		}
		else
		{
			memcpy(m_ip, pIP, 4);
		}
	}
	else
	{
		memset(m_ip, 0, sizeof(m_ip));
	}
}


// ----------------------------------------- //
// NETaddress :: assign
// ----------------------------------------- //
void NETaddress::assign(LP_SOCKADDR_STORAGE ptr_sockaddr_storage)
{
	if(((sockaddr_storage*)ptr_sockaddr_storage)->ss_family == AF_INET6)
	{
		sockaddr_in6* pin = (sockaddr_in6*)ptr_sockaddr_storage;

		m_ipFamily = pin->sin6_family;
		memcpy(m_ip, &pin->sin6_addr, 16);
		m_port = pin->sin6_port;
	}
	else
	{
		sockaddr_in* pin = (sockaddr_in*)ptr_sockaddr_storage;

		m_ipFamily = pin->sin_family;
		memcpy(m_ip, &pin->sin_addr, 4);
		m_port = pin->sin_port;
	}

}


// ----------------------------------------- //
// NETaddress :: fill_sockaddr_storage
// ----------------------------------------- //
void NETaddress::fill_sockaddr_storage(LP_SOCKADDR_STORAGE ptr_sockaddr_storage)const
{
	if(m_ipFamily == AF_INET6)
	{
		sockaddr_in6* pin = (sockaddr_in6*)ptr_sockaddr_storage;
		memset(pin, 0, sizeof(*pin));

		pin->sin6_family = AF_INET6;
		memcpy(&pin->sin6_addr, m_ip, 16);
		pin->sin6_port = m_port;
	}
	else
	{
		sockaddr_in* pin = (sockaddr_in*)ptr_sockaddr_storage;
		memset(pin, 0, sizeof(*pin));

		pin->sin_family = AF_INET;
		memcpy(&pin->sin_addr, m_ip, 4);
		pin->sin_port = m_port;
	}

}



// ----------------------------------------- //
// ----------------------------------------- //
NETsocket net_internGetFreeSocket()
{
	for(NETsocket i=0; i<MAX_NET_SOCKS; ++i)
	{
		if(gNetSocks[i].sock == INVALID_SOCKET)
			return i;
	}

	netStoErr(ENOMEM);
	return NET_INVALID;
}

#ifdef POSIX
void sigpipe_handler(int)
{
    // g_debug("SIGPIPE caught\n");
}
#endif

// ----------------------------------------- //
// ----------------------------------------- //
bool netInit()
{
#ifdef NET_WIN_APP
	WSADATA wsaData;
	if(!gNumInit)
	{
		if(WSAStartup(MAKEWORD(1, 1), &wsaData) != 0)
		{
			netStoErr();
			return false;
		}
	}
#endif

	#ifdef SIGPIPE
	// instal sigpipe handler
	signal(SIGPIPE,sigpipe_handler);
	#endif

	// clear all sockets at frist start
	if(!gNumInit)
	{
		memset(gNetSocks, 0, sizeof(gNetSocks));
		for(int i=0; i<MAX_NET_SOCKS; ++i)
		{
			gNetSocks[i].sock = INVALID_SOCKET;
		}
	}
	++gNumInit;
	netStoErr();
	return true;
}

// ----------------------------------------- //
// Set IPv4 or IPv6 mode
// only accepted values are 4: IPv4 and 6: IPv6
// ----------------------------------------- //
void netSetVersion(int iv)
{
	#ifdef AF_INET6
	switch(iv)
	{
		case 6:  gNetIPversion = AF_INET6; break;
		default: gNetIPversion = AF_INET;  break;
	}
	#endif
}

// ----------------------------------------- //
// ----------------------------------------- //
void netShutdown()
{
	--gNumInit;
	if(gNumInit<=0)
	{
		// clear all other sockets, too
		for(int i=0; i<MAX_NET_SOCKS; ++i)
		{
			if(gNetSocks[i].sock != INVALID_SOCKET)
			{
				netCloseSocket(i);
			}
		}
		gNumInit=0;

#ifdef NET_WIN_APP
		WSACleanup();
#endif
		netStoErr();
	}
}


// ----------------------------------------- //
// ADDRESS
// ----------------------------------------- //
NETaddress netAddress(const char* server, unsigned short port)
{
	bool bWantIPv6 = (gNetIPversion == AF_INET6)?true:false;

	hostent* hostentry = NULL;
	if(server && server[0] != '\0')
	{
	#ifdef GFNET_USE_ADDRINFO
		struct addrinfo hints, *res=NULL;
		int status;

		memset(&hints, 0, sizeof(hints));
		// TODO(gf) IPv6
		hints.ai_family = gNetIPversion; // AF_INET (IPv4) or AF_INET6 (IPv6) to force version
		hints.ai_family = bWantIPv6 ? AF_INET6 : AF_UNSPEC; // ip4 or ip6 - no care
		hints.ai_socktype = SOCK_STREAM;
		hints.ai_protocol = IPPROTO_TCP;

		if ((status = getaddrinfo(server, NULL, &hints, &res)) != 0)
		{
			netStoErr();

			const char* pErr = netLastError();
			return NET_ADDR_INVALID;
		}


		NETaddress na_ret = NET_ADDR_INVALID;
		for(struct addrinfo* ptr=res; ptr != NULL; ptr=ptr->ai_next)
		{
			sockaddr_storage storage;
			memset(&storage, 0, sizeof(storage));
			switch (ptr->ai_family)
			{
			case AF_INET:
				na_ret.assign((LP_SOCKADDR_STORAGE)ptr->ai_addr);
				na_ret.m_port = htons(port);
				if(!bWantIPv6)
					return na_ret;
				break;
			case AF_INET6:
				na_ret.assign((LP_SOCKADDR_STORAGE)ptr->ai_addr);
				na_ret.m_port = htons(port);
				if(bWantIPv6)
					return na_ret;
				break;
			}
		}
		return na_ret;

	#else
		hostentry = gethostbyname(server);
		if(hostentry != NULL)
		{
			NETaddress addr;
			addr.assign(gNetIPversion, hostentry->h_addr_list[0], port);

			// addr.m_port = htons(port);
			// addr.ip = *(unsigned long*)hostentry->h_addr_list[0]; // network format
			return addr;
		}
	#endif
    }
    else // get a localhost IP
    {
		// this fails on linux
		/*
		hostentry = gethostbyname("localhost");
		*/
		int count=0;
		const char* pHostName = netGetLocalIPs(&count, "\n");
		if(count && pHostName)
		{
			char tmp[1024];
			strncpy(tmp, pHostName, 1023);
			tmp[1023] = '\0';
			for(int i=0; i<1023; ++i)
			{
				if (tmp[i]=='\n')
				{
					tmp[i]='\0';
					break;
				}
			}
			return netAddress(tmp, port);
			// hostentry = gethostbyname(tmp);
		}
		
		NETaddress addr;
		addr = bWantIPv6 ? netAddress("::1", port) : netAddress("127.0.0.1", port);
		if(addr != NET_ADDR_INVALID)
			return addr;
		addr =netAddress("localhost.local", port);
		if(addr != NET_ADDR_INVALID)
			return addr;
		addr =netAddress("localhost", port);
		return addr;
    }

	netStoErr();
	return NET_ADDR_INVALID;
}

// ----------------------------------------- //
// ----------------------------------------- //
NETaddress netAddressIP4(unsigned char ip1, unsigned char ip2, unsigned char ip3, unsigned char ip4, unsigned short port)
{
	NETaddress addr;
	unsigned char ipv4[4]; ipv4[0]=ip1; ipv4[1]=ip2; ipv4[2]=ip3; ipv4[3]=ip4;
    
	unsigned long ipV4 = htonl(*(unsigned long*)ipv4);
	addr.assign(AF_INET, &ipV4, port);

	return addr;
}

// ----------------------------------------- //
// Find remote connection (or last UDP recv)
// ----------------------------------------- //
NETaddress netGetRemoteAddress(NETsocket isock)
{
	NET_SOCKS& s = gNetSocks[isock];
	if(s.sock != INVALID_SOCKET)
	{
		NETaddress addr;

		addr.assign(s.addr.ss_family, s.get_ip(), (unsigned short)ntohl(s.get_port()) );
		// addr.ip =   s.addr.sin_addr.s_addr;
		// addr.port = s.addr.sin_port;
		return addr;
	}
	return NET_ADDR_INVALID;
}


// ----------------------------------------- //
// ----------------------------------------- //
void netSetBlocking(NETsocket isock, bool block)
{
	#ifdef NET_REAL_NONBLOCKING
		if(gNetSocks[isock].sock != INVALID_SOCKET)
		{
			// If iCtlMode != 0, non-blocking mode is enabled.
			unsigned long iCtlMode = block ? 0 : 1;
			#ifdef NET_WIN_APP
				ioctlsocket(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
			#else
				ioctl(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
			#endif
		}
		netStoErr();
	#else
		gNetSocks[isock].blocking = block;
	#endif

	#if defined(SO_NOSIGPIPE)
		int set = 1;
		setsockopt(gNetSocks[isock].sock, SOL_SOCKET, SO_NOSIGPIPE, (void *)&set, sizeof(int));
	#endif
}

// ----------------------------------------- //
// create a socket that listens to a port
// returns socket index, or NET_INVALID if error
// ----------------------------------------- //
NETsocket netListen(unsigned short port)
{
	// create a wrapper socket
	NETsocket isock = net_internGetFreeSocket();
	if (isock<0)
	{
		return NET_INVALID;
	}

	SOCKET sockfd;
	// make a socket, bind it, and listen on it:
	sockfd = socket(gNetIPversion, SOCK_STREAM, IPPROTO_TCP);
	if(sockfd == INVALID_SOCKET)
	{
		netStoErr();
		return NET_INVALID;
	}


	// The sockaddr_in structure specifies the address family,
	// IP address, and port for the socket that is being bound.
	// sockaddr_in service; // IPv4
	sockaddr_storage service; // IPv4 and IPv6 storage

	NETaddress na_service = NET_ADDR_ANY; // TODO(gf) optionally use an IP address here, to decide what network card to use (tunnel, wifi, 3G, ..)
	na_service.m_port = htons(port);
	na_service.m_ipFamily = gNetIPversion;
	na_service.fill_sockaddr_storage(&service);

	/*
	memset(&service, 0, sizeof(service));
	service.sin_family = gNetIPversion;
	service.sin_addr.s_addr = INADDR_ANY; // (unsigned long)htonl(0x7f000001); // = inet_addr("127.0.0.1");
	service.sin_port = htons(port);
	*/

	// ignore if that port is still open from an old session
	const int reuse=1;
	setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, (const char*)&reuse, sizeof(reuse));

	#ifdef PALM_WEBOS
		PDL_SetFirewallPortStatus(port, 1);
	#endif
	
	// bind to ip/port (what device and port to use for next listen/connect call)
	if(bind(sockfd, (sockaddr*)&service, sizeof(service)) == SOCKET_ERROR)
	{
		netStoErr();
		closesocket(sockfd);
		return NET_INVALID;
	}

	// listen
	if(listen(sockfd, 10) == SOCKET_ERROR)
	{
		netStoErr();
		closesocket(sockfd);
		return NET_INVALID;
	}
	
	gNetSocks[isock].sock = sockfd;
	memcpy(&gNetSocks[isock].addr, &service, sizeof(service));
	gNetSocks[isock].udp  = false;
	
	netSetBlocking(isock, false);
	return isock;
}

// ----------------------------------------- //
// ----------------------------------------- //
NETsocket netAccept(NETsocket isock, NETaddress* pAddress)
{
	if(gNetSocks[isock].udp)
	{
		netStoErr(0); // #NEED better error
		return NET_INVALID; // only for tcp streams
	}

	#ifndef NET_REAL_NONBLOCKING
		int n = netSelect(isock);
		if(n!=1) return NET_INVALID;
	#endif

	// sockaddr_in addr; // IPv4
	sockaddr_storage addr; // IPv6 compatible
	socklen_t szadd = sizeof(addr);

	SOCKET sock = accept(gNetSocks[isock].sock, (sockaddr*)&addr, &szadd);
	netStoErr();

	if (sock != INVALID_SOCKET)
	{
		netStoErr(ENOMEM);
		NETsocket iFree = net_internGetFreeSocket();
		if(iFree == -1)
		{
			closesocket(sock);
			return NET_INVALID;
		}
		gNetSocks[iFree] = gNetSocks[isock];
		
		gNetSocks[iFree].sock = sock;
		memcpy(&gNetSocks[iFree].addr, &addr, sizeof(addr)); // [isock] - war falsch, oder?
		
		if(pAddress)
		{
			pAddress->assign(&addr);
			/*
			pAddress->ip   = addr.sin_addr.s_addr;
			pAddress->port = addr.sin_port;
			*/
		}
	
		netSetBlocking(iFree, false);
		return iFree;
	}
	return NET_INVALID;
}


// ----------------------------------------- //
// returns socket index, or -1 if error
// ----------------------------------------- //
NETsocket netConnect(const NETaddress& server, int timeout_ms)
{
	if(server == NET_ADDR_INVALID) return NET_INVALID;

	// create a wrapper socket
	NETsocket isock = net_internGetFreeSocket();
	netStoErr();
	if (isock<0)
	{
		return NET_INVALID;
	}

	
	// make a socket:
	SOCKET sockfd;
	sockfd = socket(server.m_ipFamily, SOCK_STREAM, IPPROTO_TCP);
	if(sockfd == INVALID_SOCKET)
	{
		netStoErr();
		return NET_INVALID;
	}

	// sockaddr_in service; // IPv4
	sockaddr_storage service; // IPv6 compatible
	server.fill_sockaddr_storage(&service);
/*
	memset(&service, 0, sizeof(service));
	service.sin_family      = gNetIPversion;
	service.sin_addr.s_addr = (int)server.ip;
	service.sin_port        = server.port;
*/
	// no need to bind.
	// we only care where we are going. The system will assign a local port for us.
	gNetSocks[isock].sock = sockfd;
	memcpy(&gNetSocks[isock].addr, &service, sizeof(service) );
	gNetSocks[isock].udp  = false;

#if defined(_WIN32_WCE)
	// This call will return immediately, coz our socket is non-blocking
	int Ret = connect(sockfd, (const sockaddr*)&service, sizeof(service));

	if(Ret == SOCKET_ERROR)
	{
		netStoErr();
		// g_debug("connect rv:%d - %s\n", Ret, netLastError());
		// g_debug("%s:%d, sock=%d\n", netGetIPstr(server), netGetPort(server), (int)sockfd);
		
		netCloseSocket(isock);
		return NET_INVALID;
	}
	netSetBlocking(isock, false);
	return isock;
#else
	;
	
	// we need a real non-blocking socket here!
	// If iCtlMode != 0, non-blocking mode is enabled.
	unsigned long iCtlMode = 1;
	#ifdef NET_WIN_APP
		ioctlsocket(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
	#else
		ioctl(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
	#endif

	int ok=0;

	// This call will return immediately, coz our socket is non-blocking
	int Ret = connect(sockfd, (const sockaddr*)&service, sizeof(service));

	// If connected, it will return 0, or error
	if (Ret == SOCKET_ERROR)
	{
		int iErr = net_errno;

		// Check if the error was WSAEWOULDBLOCK, where we'll wait.
		if (iErr == EWOULDBLOCK || iErr==EINPROGRESS)
		{
			// g_debug("\nConnect() returned WSAEWOULDBLOCK. Need to Wait..");
			fd_set  fdWrite, fdErr;
			timeval Timeout;

			FD_ZERO(&fdWrite);
			FD_ZERO(&fdErr);
			FD_SET(sockfd, &fdWrite);
			FD_SET(sockfd, &fdErr);

			if (timeout_ms <= 0 || timeout_ms>30000)
				timeout_ms = 30000;
			Timeout.tv_sec  = timeout_ms/1000;
			Timeout.tv_usec = timeout_ms * 1000 - (timeout_ms/1000) * 1000000; // your timeout

			Ret = select((int)sockfd+1, NULL, &fdWrite, &fdErr, &Timeout);
			if (Ret == 0)
			{
				netCloseSocket(isock);
				netStoErr(EINPROGRESS);
				// g_debug("\nConnect Timeout (%d ms).", timeout_ms);
				return NET_INVALID;
			}
			else
			{
				if (FD_ISSET(sockfd, &fdWrite))
				{
					// g_debug("\nConnected...");
					netStoErr();
					ok = 1;
				}
				if (FD_ISSET(sockfd, &fdErr))
				{
					// g_debug("\nSelect() Error.");
				}
			}
		}
		else
		{
			 // g_debug("\nConnect Error %d\n", iErr);
		}
	}
	else
	{
		// printf("\nWoooo!! got connected with NO Waiting!!");
		ok = 1;
	}

	if(ok)
	{
		// restore blocking mode, for the virtual nonblocking mode
		iCtlMode = 0;
		#ifdef NET_WIN_APP
			ioctlsocket(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
		#else
			ioctl(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
		#endif
		
		// set nonblocking as implemented for default sockets
		netSetBlocking(isock, false);
		return isock;
	}

	netStoErr();
	netCloseSocket(isock);
	return NET_INVALID;
#endif
}



// ----------------------------------------- //
// convert network style address to IP string
// ----------------------------------------- //
static void sprintf_IP4(char* str, in_addr* addr)
{
	int split[4];
	unsigned long ip;
	unsigned long *x = (unsigned long*)addr;

// TODO(gf) IPv6
	ip = ntohl(*x);
	split[0] = (ip & 0xff000000) >> 24;
	split[1] = (ip & 0x00ff0000) >> 16;
	split[2] = (ip & 0x0000ff00) >> 8;
	split[3] = (ip & 0x000000ff);
	sprintf(str, "%d.%d.%d.%d", split[0], split[1], split[2], split[3]);
}



// for better debugging
const char* netGetIPstr(const NETaddress& address)
{
#ifdef AF_INET6
	static char tmp[128];
	#ifdef _DEBUG
		if(address.m_ipFamily == AF_INET6)
		{
			sockaddr_storage addr;
			addr.ss_family = address.m_ipFamily;
			// fe80::d64:c6d0:8271:6d28%20
			memcpy(&((sockaddr_in6*)&addr)->sin6_addr, address.m_ip, sizeof(((sockaddr_in6*)&addr)->sin6_addr) );
			int pause=1;
		}
		else
		{
			sockaddr_storage addr;
			addr.ss_family = address.m_ipFamily;
			memcpy(&((sockaddr_in*)&addr)->sin_addr, address.m_ip, sizeof(((sockaddr_in*)&addr)->sin_addr));
			int pause=1;
		}
	#endif
	gf_inet_ntop(address.m_ipFamily, (void*)address.m_ip, tmp, sizeof(tmp));
	return tmp;
#else
	static char tmp[32];
	sprintf_IP4(tmp, (in_addr*) &address);
	return tmp;
#endif
}

// TODO(gf)
/*
unsigned long  netGetIP (const NETaddress& address) // in host format
{
	return ntohl(address.ip);
}
*/

unsigned short netGetPort(const NETaddress& address) // in local format
{
	return ntohs(address.m_port);
}



// ----------------------------------------- //
// Create a new socket, used to send and receive to/from another
// computer.
// ----------------------------------------- //
NETsocket netSocketUdp(unsigned short port)
{
	int isock = net_internGetFreeSocket();
	if(isock<0) return NET_INVALID;
	
	#ifdef PALM_WEBOS
		PDL_SetFirewallPortStatus(port, 1);
	#endif


	NET_SOCKS& mysock = gNetSocks[isock];
	NETaddress na_any = NET_ADDR_ANY;
	na_any.m_port = htons(port);
	na_any.m_ipFamily = gNetIPversion;
	na_any.fill_sockaddr_storage(&mysock.addr);

	mysock.udp = true;
/*
	mysock.addr.sin_family      = gNetIPversion;
	mysock.addr.sin_addr.s_addr = INADDR_ANY;
	mysock.addr.sin_port        = htons(port);
*/
	
	

	SOCKET sock = socket(gNetIPversion, SOCK_DGRAM, IPPROTO_UDP);
	netStoErr();
	if(sock == INVALID_SOCKET)
	{
		return NET_INVALID;
	}
	mysock.sock = sock;
	
	// ignore if that port is still open from an old session
	const int reuse=1;
	setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (const char*)&reuse, sizeof(reuse));
	
	// bind to port
	if(port >  0 && bind(sock, (sockaddr*)&mysock.addr, sizeof(mysock.addr)) == SOCKET_ERROR)
	{
		netStoErr();
		closesocket(sock);
		return NET_INVALID;
	}

	// remove "red button saftety cap" for broadcasts
	const int broadcast = 1;
	if (setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (const char*) &broadcast, sizeof(broadcast) ) == SOCKET_ERROR)
	{
		// Beej suggests this might be neccessary sometimes!?
		char cbroadcast = '1';
		setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (const char*) &cbroadcast, sizeof(cbroadcast) );
	}

	netSetBlocking(isock, false);
	return isock;
}


// ----------------------------------------- //
// Close the cocket, if it is no UDP socket
// 0 = OK, SOCKET_ERROR = failed.
// ----------------------------------------- //
int netCloseSocket(NETsocket isock)
{
	SOCKET sock = gNetSocks[isock].sock;
	gNetSocks[isock].sock = INVALID_SOCKET; // set unusable, also UDP "sockets", but not "the" UDP sock
	
//	if(gNetSocks[isock].udp) return 0; // OK, don't close my UDP socket, I just have one.
	
//	#if !defined(EMSCRIPTEN)
		linger ling;
		ling.l_linger = 0;
		ling.l_onoff = 0;
		setsockopt(sock, SOL_SOCKET, SO_LINGER, (const char*)&ling, sizeof(ling));
//	#endif

	shutdown(sock, 0x02); // SD_BOTH=0x02
	int rv = closesocket(sock);
	netStoErr();
	return rv;
}


// ----------------------------------------- //
// -1 : error
//  n,0: ok, sent all.
// ----------------------------------------- //
int netSend(NETsocket isock, const char* buf, int len, NETaddress* pUDPtarget)
{
	NET_SOCKS& nsock = gNetSocks[isock];
	int total = 0; // how many bytes we've sent
	int bytesleft = len; // how many we have left to send
	int n;

	// sockaddr_in addr; // IPv4
	sockaddr_storage addr; // IPv6+IPv4
	if(gNetSocks[isock].udp)
	{
		if(!pUDPtarget || *pUDPtarget == NET_ADDR_INVALID)
			return -1;

		memcpy(&addr, &nsock.addr, sizeof(nsock.addr));
		pUDPtarget->fill_sockaddr_storage(&addr);

		/*
		addr.sin_addr.s_addr = (int)pUDPtarget->ip;
		addr.sin_port        = pUDPtarget->port;
		*/
	}

	while(total < len)
	{
		if(gNetSocks[isock].udp)
		{
			// sock - information: where does this send come from (IP+port)
			// addr - information: where to send that package to  (IP+port)
			n = (int)sendto(nsock.sock, buf+total, bytesleft, 0, (sockaddr*)&addr, sizeof(nsock.addr));
		}
		else
		{
			n = (int)send  (nsock.sock, buf+total, bytesleft, 0);
		}
		netStoErr();
		if (n < 0)
		{
			// non blocking not ready -> wait until you can write it all
			if(net_errno == EWOULDBLOCK)
			{
				continue;
			}
			return -1;
		}
		total += n;
		bytesleft -= n;
	}
	return total; // return -1 on failure, number sent on success
}


// ----------------------------------------- //
// See if the socket is ready to read
// Returns:
//  1: ok
// -1: error
// -2: would block
// ----------------------------------------- //
int netSelect(NETsocket isock)
{
	const NET_SOCKS& nsock = gNetSocks[isock];
	timeval timevalInfo;
	timevalInfo.tv_sec = 0;
	timevalInfo.tv_usec = 0;
	//made fd_set struct
	fd_set Sockets = {1, nsock.sock}; // contains list of sockets for select

	// not all compilers have that
	// Sockets.fd_count = 1; // one socket
	// Sockets.fd_array[0] = nsock.sock; // add it
	// call select to determine readability of function
	int readycount = select((int)(nsock.sock+1), &Sockets, NULL, NULL, &timevalInfo);
	
	if(readycount < 0)
	{
		netStoErr();
		return -1;
	}
	else if(readycount == 0) // time expired
		return -2;

#if !defined(_WIN32_WCE)
	// ok, seems to be ready.
	if (FD_ISSET(nsock.sock, &Sockets))
		return 1; // yes, data is there
#endif

return -2; // no data to read
}

// ----------------------------------------- //
// -2 : EWOULDBLOCK -> just ignore for non blocking reads
// -1 : error
//  0 : sender quit
//  n : ok, recieved "n" bytes.
// ----------------------------------------- //
int netRecv(NETsocket isock, char* buf, int len, bool force_read_all)
{
	NET_SOCKS& nsock = gNetSocks[isock];
	int n;

	if(nsock.udp)
	{
		NETaddress na_any = NET_ADDR_ANY;
		na_any.m_ipFamily = gNetIPversion;
		na_any.fill_sockaddr_storage(&nsock.addr);

		/*
		nsock.addr.sin_addr.s_addr = INADDR_ANY;
		nsock.addr.sin_port = 0;
		*/
	}

	#ifndef NET_REAL_NONBLOCKING
	if(!nsock.blocking)
	{
		n = netSelect(isock);
		if(n!=1) return n;
	}
	#endif


	if(force_read_all)
	{
		int nread=len;
		while(len > 0)
		{
			if(nsock.udp)
			{
				// UDP - remote IP
				socklen_t szadd = sizeof(nsock.addr);
				n = (int)recvfrom(nsock.sock, buf, len, 0, (sockaddr*)&nsock.addr, &szadd);
			}
			else
			{
				n = (int)recv(nsock.sock, buf, len, 0);
			}

			netStoErr();
			if (n>0) // positive read
			{
				len-=n;
				buf+=n;
			}
			else if(n<0)
			{
				if(net_errno == EWOULDBLOCK)
				{
					// no data to read, and not started to read, yet
					if(len == nread)
					{
						return -2;
					}
					continue;
				}
				if(net_errno == ECONNRESET)
					return 0;
				// real error
				return -1;
			}
			else if (n==0) // connection closed
			{
				return 0;
			}
		}
		return nread;
	}
	else
	{
		if(nsock.udp)
		{
			socklen_t szadd = sizeof(nsock.addr);
			n = (int)recvfrom(nsock.sock, buf, len, 0, (sockaddr*)&nsock.addr, &szadd);
		}
		else
		{
			n = (int)recv(nsock.sock, buf, len, 0);
		}
		netStoErr();

		if(n<0)
		{
			int iErr = net_errno;
			switch(net_errno)
			{
			case ECONNRESET:
				return 0;
			case EWOULDBLOCK:
				return -2;
			default:
				return n;
			}
		}
		return n;
	}
}

#ifdef GFNET_USE_GETIFADDRS
	#include <ifaddrs.h>
	#include <arpa/inet.h>
	void netGetLocalIPs_getifaddrs(char* pOut, int* count, const char* delimiter)
	{
		int has_loopback = 0;
		*pOut='\0';
		*count=0;
		struct ifaddrs *interfaces = NULL;
		struct ifaddrs *temp_addr = NULL;
		int success = 0;
		
		// retrieve the current interfaces - returns 0 on success
		success = getifaddrs(&interfaces);
		if (success == 0)
		{
			// Loop through linked list of interfaces
			temp_addr = interfaces;
			while(temp_addr != NULL)
			{
				if( temp_addr->ifa_addr // can be NULL!!
					&& temp_addr->ifa_addr->sa_family == gNetIPversion)
				{
					// Check if interface is en0 which is the wifi connection on the iPhone
					// -> you can't be sure!!
					// if([[NSString stringWithUTF8String:temp_addr->ifa_name] isEqualToString:@"en0"])
					{
						// const char* pIP = inet_ntoa(((struct sockaddr_in *)temp_addr->ifa_addr)->sin_addr);
						char buffer[512];
						gf_inet_ntop(gNetIPversion, &temp_addr->ifa_addr, buffer, sizeof(buffer));
						const char* pIP = buffer;
						if(strcmp(pIP, "127.0.0.1")==0 || strcmp(pIP, "0:0:0:0:0:0:0:1")==0 || strcmp(pIP, "::1")==0 )
							has_loopback=1;
						else if(pIP)
						{
							strcat(pOut, pIP);
							strcat(pOut, delimiter);
							(*count)++;
						}
					}
				}
				temp_addr = temp_addr->ifa_next;
			}
		}
		else
		{
			netStoErr();
		}
		
		// make that the last one
		if(has_loopback)
		{
			strcat(pOut, "127.0.0.1");
			strcat(pOut, delimiter);
			(*count) ++;
		}
		// printf("alternative: %d %s\n", (int)*count, pOut);
		// Free memory
		freeifaddrs(interfaces);
	}
#endif


// Using ioctl instead of getifaddrs
#ifdef GFNET_USE_IOCTL
#include <sys/socket.h>
#include <netinet/in.h>
#include <linux/if.h>
#include <linux/sockios.h>
#include <arpa/inet.h>
void netGetLocalIPs_ioclt(char* pOut, int* count, const char* delimiter)
{
	// here PF_INET instead of AF_INET should be used, but they are a relict and have the same value.
    SOCKET fd = socket(gNetIPversion, SOCK_STREAM, IPPROTO_TCP);

#ifdef _AIX
    int cmd = CSIOCGIFCONF;
#else
    int cmd = SIOCGIFCONF;
#endif
    ifconf ifc;
    int numaddrs = 10;
    int old_ifc_len = 0;

    // Need to call ioctl multiple times since we do not know up front
    // how many addresses there will be, and thus how large a buffer we need.
    // We keep increasing the buffer size until subsequent calls return
    // the same length, meaning we have all the addresses.
    while(true)
    {
        int bufsize = numaddrs * sizeof(ifreq);
        ifc.ifc_len = bufsize;
        ifc.ifc_buf = new char[bufsize];
        int rs = ioctl(fd, cmd, &ifc);
        if(rs == SOCKET_ERROR)
        {
			netStoErr();
            delete[] ifc.ifc_buf;
            closesocket(fd);
			return;
        }
        else if(ifc.ifc_len == old_ifc_len)
        {
            // Returned same length twice in a row, finished.
			// (sufficient memory allocated)
            break;
        }
        else
        {
            old_ifc_len = ifc.ifc_len;
        }
		// allocation was insufficient
        numaddrs += 10;
        delete[] ifc.ifc_buf;
    }

    numaddrs = ifc.ifc_len / sizeof(ifreq);
    ifreq* ifr = ifc.ifc_req;

	bool has_loopback=false;
    for(int i = 0; i < numaddrs; ++i)
    {
        if(ifr[i].ifr_addr.sa_family == gNetIPversion && !(ifr[i].ifr_flags & IFF_LOOPBACK))
        {
            struct sockaddr_in* addr = reinterpret_cast<struct sockaddr_in*>(&ifr[i].ifr_addr);
            if(addr->sin_addr.s_addr != 0)
            {
				// const char* pIP = inet_ntoa(( addr )->sin_addr);
				char buffer[512];
				gf_inet_ntop(gNetIPversion, &( addr )->sin_addr, buffer, sizeof(buffer));
				const char* pIP = buffer;


				if(strcmp(pIP, "127.0.0.1")==0 || strcmp(pIP, "0:0:0:0:0:0:0:1")==0 || strcmp(pIP, "::1")==0 )
					has_loopback=1;
				else if(pIP)
				{
					strcat(pOut, pIP);
					strcat(pOut, delimiter);
					(*count)++;
				}
            }
        }
    }

 	// make that the last one
	if(has_loopback)
	{
	#ifdef AF_INET6
		if(gNetIPversion == AF_INET6)
		{
			strcat(pOut, "0:0:0:0:0:0:0:1");
		}
		else
	#endif
		{
			strcat(pOut, "127.0.0.1");
		}
		strcat(pOut, delimiter);
		(*count) ++;
	}
	delete[] ifc.ifc_buf;
    closesocket(fd);
    return;
}
#endif

// ----------------------------------------- //
// ----------------------------------------- //
const char* netGetLocalIPs(int* count, const char* delimiter)
{
#define MAXHOSTNAMELEN 128 // 64+1 on linux
	*count = 0;

    const int max_length=MAXHOSTNAMELEN * 16;
	static char alladdr[max_length];
	alladdr[0]='\0';

	// Try the better methods first
	#ifdef GFNET_USE_GETIFADDRS
		netGetLocalIPs_getifaddrs(alladdr, count, delimiter);
		if (count) return alladdr;
	#endif

	#ifdef GFNET_USE_IOCTL
		netGetLocalIPs_ioclt(alladdr, count, delimiter);
		if(count) return alladdr;
	#endif


	#ifdef GFNET_USE_ADDRINFO
		struct addrinfo hints, *res=NULL;
		int status;
		// TODO(gf) IPv6
		if(gethostname(alladdr, MAXHOSTNAMELEN) == SOCKET_ERROR)
		{
			netStoErr();
			return NULL;
		}

		memset(&hints, 0, sizeof(hints));
		// TODO(gf) IPv6
		hints.ai_family = gNetIPversion; // AF_INET (IPv4) or AF_INET6 (IPv6) to force version
		hints.ai_socktype = SOCK_STREAM;

		if ((status = getaddrinfo(alladdr, NULL, &hints, &res)) != 0)
		{
			netStoErr();
			return NULL;
		}
	#else
		if(gethostname(alladdr, MAXHOSTNAMELEN) == SOCKET_ERROR)
		{
			netStoErr();
			return NULL;
		}
		alladdr[MAXHOSTNAMELEN - 1] = '\0';

		hostent* local = gethostbyname(alladdr);
		netStoErr();
		if(local == NULL)
		{
			return NULL;
		}
	#endif
    
    // fill in the addresses
    alladdr[0] = '\0';
	char tmp[256];
	int curlen = 0;
	int delimlen=(int)strlen(delimiter);
	bool has_loopback=false;

	#ifdef GFNET_USE_ADDRINFO
		for(struct addrinfo *p = res;p != NULL; p = p->ai_next)
		{
			sockaddr_storage* sain = (sockaddr_storage*)p->ai_addr;

			NETaddress nad;
			nad.assign(sain);
			strcpy(tmp, netGetIPstr(nad));

			// sprintf_IP4(tmp, &sain->sin_addr);
	#else
		for(int i=0; local->h_addr_list[i] != NULL; ++i)
		{
		// TODO(gf) IPv6
			sprintf_IP4(tmp, (in_addr*)local->h_addr_list[i]);
	#endif
			int addlen = (int)strlen(tmp) + delimlen;
			if(curlen + addlen >= max_length)
				break;
			curlen += addlen;
			// skip 127.xxx address, that's not of any interest

			if(strcmp(tmp, "127.0.0.1")==0  || strcmp(tmp, "0:0:0:0:0:0:0:1")==0 || strcmp(tmp, "::1")==0 )
			{
				has_loopback=true;
				continue;
			}
			(*count)++;
			strcat(alladdr, tmp);
			strcat(alladdr, delimiter);
		}
	#ifdef GFNET_USE_ADDRINFO
		freeaddrinfo(res);
	#endif

	// make that the last one
	if(has_loopback)
	{
		(*count) ++;
		if(gNetIPversion == AF_INET6)
			strcat(alladdr, "::1");
		else
			strcat(alladdr, "127.0.0.1");
		strcat(alladdr, delimiter);
	}
    return alladdr;
}


// Get the error and a description
const char* netLastError()
{
#ifdef NET_WIN_APP
	#ifndef _UNICODE
		TCHAR errmsg[512];
		static TCHAR fullerr[512];
		int err = gNetErrNo;
		if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,0,err,0,errmsg,511,NULL))
		{
			sprintf(fullerr, "%d %s", err, errmsg);
			return fullerr;
		}
	#endif
	return "";
#else
	static char fullerr[512];
	sprintf(fullerr, "%d %s", gNetErrNo, strerror(gNetErrNo));
	return fullerr;
#endif
}

int netLastErrNum(){ return gNetErrNo;}
