// 3D Commands
// ------------------------------------------------------- //

#define VC_EXTRALEAN
#define _NO_OLDNAMES // Allow _yn() but not yn() in Math.h
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "glb.h"
#include "glb3d.h"

#ifndef GLB_CONSOLE
	#include "rainbows3d.h"
	#include "openglrainbows.h"

	#include <math.h>
	#include <stdlib.h>
	#include <stdio.h>


	#include "gfini.h"


	#include "glstate.h"

	#ifdef WANT_SHOEBOX
		#include "gfshoebox.h"
		extern GFShoeBox *__g_ShoeBox_Data;
		extern GFShoeBox *__g_ShoeBox_Media;
	#endif
#endif


namespace __GLBASIC__
{
// From DINGS_MAIN.cpp
#ifndef GLB_CONSOLE
	extern OpenGLRainbows*	__g_pRbow;
	extern bool				__g_Did3D;

	// Global Object for 3D
	extern Rainbows3D*	__g_pRbow3D;
	struct TEXSTATE3D
	{
		TEXSTATE3D() {num=num_multi=-1; mipmapstate=0;}
		int num, num_multi, mipmapstate;
	}__g_TexState3D;
#endif


// ------------------------------------------------------- //
void	X_MAKE2D(void)
{
#ifndef GLB_CONSOLE
	#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
		__g_pRbow3D->DoShadows(false);
	#endif
	__g_pRbow->Make2DMode();
#endif
}

void	X_MAKE3D(DGInt znear, DGInt zfar, DGInt fov)
{
#ifndef GLB_CONSOLE
	#if !defined(TINYGL) && !defined(TRENKI3D)
	X_CLEAR_Z();
	#endif
	__g_Did3D=true;
	__g_pRbow3D->Make3DViewport((float)znear, (float)zfar, (float) fov);
	X_CULLMODE(0);
	__g_pRbow3D->LightsOff();

	// do this manually again, since I store texture state in glb3d.cpp now
	X_SETTEXTURE(-1, -1);
#endif
}

void	X_MIPMAPPING(DGNat state)
{
#ifndef GLB_CONSOLE
	#if defined (HAVE_OPENGL) // not for ES enabled
		__g_TexState3D.mipmapstate=(int)state;
	#endif
#endif
}


void	X_SETTEXTURE(DGNat num, DGNat num_multi)
{
#ifndef GLB_CONSOLE
	__g_TexState3D.num = (int)num;
	__g_TexState3D.num_multi = (int)num_multi;
	__g_pRbow->SetTexture3D(__g_TexState3D.num, __g_TexState3D.num_multi, __g_TexState3D.mipmapstate);
	__g_pRbow->ApplySmoothShading(); // might want blocky 3D
	if(__g_pRbow3D->IsShaderActive())
	{
		const char* pTex1 = "TextureID1", *pTex2="TextureID2";
		__g_pRbow3D->PutShaderUniform1i(pTex1, 0);
		__g_pRbow3D->PutShaderUniform1i(pTex2, 1);
	}
#endif
}
void	X_SETTEXTUREOFFSET(DGInt du, DGInt dv)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetTextureOffset((float)du, (float)dv);
#endif
}

void	X_AMBIENT_LT(DGNat num, DGNat col)
{
#ifndef GLB_CONSOLE
#ifndef POCKETPC
		__g_pRbow3D->AmbientLt((int)num, (COLORREF)col);
	#endif
#endif
}
void	X_SPOT_LT(DGNat num, DGNat col, DGInt x, DGInt y, DGInt z, DGInt dirx, DGInt diry, DGInt dirz, DGInt cutoff)
{
#ifndef GLB_CONSOLE
#ifndef POCKETPC
	__g_pRbow3D->SpotLt((int)num, (COLORREF)col, (float)x, (float)y, (float)z, (float)dirx, (float)diry, (float)dirz, (float)cutoff, __DG_DEBUG);
#endif
#endif
}
void	X_DRAWAXES(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->DrawCoordAxis((float)x, (float)y, (float)z);
#endif
}
void	X_AUTONORMALS(DGNat mode)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->UserObjectAutoNormalMode((long)mode);
#endif
}
void	X_OBJSTART(DGNat num)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->UserObjectStart((int)num);
#endif
}

void    X_OBJSETFRAME(DGNat num)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->UserObjectSetFrame((int)num);
#endif
}

void	X_OBJADDVERTEX_NORMAL(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->UserObjectSetNormal((float)x, (float)y, (float)z);
#endif
}
void	X_OBJADDVERTEX(DGInt x, DGInt y, DGInt z, DGInt tx, DGInt ty, DGNat col)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->UserObjectAddVertex((float)x, (float)y, (float)z, (float)tx, (float)ty, (unsigned long)col);
#endif
}
void	X_OBJNEWGROUP(void)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->UserObjectNewGroup();
#endif
}
void	X_OBJEND(void)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->UserObjectEnd();
#endif
}
void	X_SAVEOBJ(DGStr s, DGNat n)
{
#ifndef GLB_CONSOLE
	__g_Did3D=true;
	__g_pRbow3D->SaveObject(s.c_str(), (int)n);
#endif
}


DGNat	GENX_OBJ()
{
	#ifndef GLB_CONSOLE
	for(DGNat i=(DGNat)__g_pRbow3D->m_Objects.Size()-1; i>=0; --i)
	{
		if(__g_pRbow3D->m_Objects[i].is_loaded == false)
			return i;
	}
	#endif
	return -1;
}



void	X_LOADOBJ(const DGStr& s, DGNat n)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->LoadObject("", n);
	DGStr file(s);
	__g_Did3D=true;

	if(!glb_prepare_reading_file(file))
		return;
	__g_pRbow3D->LoadObject(file.c_str(), (int)n);
#endif
}

void X_OBJFREEEXTRA(DGNat n)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->FreeExtraObject(n);
#endif
}

void	X_DRAWANIM(DGNat num, DGNat from, DGNat to, DGInt per_mille, DGNat full_anim)
{
#ifndef GLB_CONSOLE
	__g_pRbow->SetTexture3D(__g_TexState3D.num, __g_TexState3D.num_multi, __g_TexState3D.mipmapstate);
	__g_pRbow3D->RenderAnim((int)num, (int)from ,(int)to, (float)per_mille, full_anim?true:false);
#endif
}
void	X_DRAWOBJ(DGNat num, DGNat frame)
{
#ifndef GLB_CONSOLE
	__g_pRbow->SetTexture3D(__g_TexState3D.num, __g_TexState3D.num_multi, __g_TexState3D.mipmapstate);
	__g_pRbow3D->RenderAnim((int)num, (int)frame, (int)frame, 0.0f, false);
#endif
}
void	X_CAMERAUP(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetCameraUp((float)x,(float)y,(float)z);
#endif
}
void	X_CAMERA(DGInt x, DGInt y, DGInt z, DGInt px, DGInt py, DGInt pz)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetCamera((float)x,(float)y,(float)z,(float)px,(float)py,(float)pz);
#endif
}
void	X_ROTATION(DGInt angle, DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetRotation((float)angle, (float)x, (float)y, (float)z);
#endif
}
void	X_MOVEMENT(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetTranslation((float)x, (float)y, (float)z);
#endif
}
void	X_SCALING(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetScaling((float)x, (float)y, (float)z);
#endif
}
int	__current_cullmode;
void	X_CULLMODE(DGNat mode)
{
#ifndef GLB_CONSOLE
	__current_cullmode = (mode == 0 ? 0 : (mode > 0  ? 1 : -1));
	__g_pRbow3D->CullMode( __current_cullmode);
#endif
}
void	X_SPRITE(DGNat num, DGInt x, DGInt y, DGInt z, DGInt scale)
{
#ifndef GLB_CONSOLE
	if(num < 0) return;
	__g_pRbow3D->CullMode(-1);
	__g_pRbow->DrawBillboard((short)num, (float)x, (float)y, (float)z, (float)scale);
	__g_pRbow3D->CullMode(__current_cullmode);
#endif
}

void	X_FOG(DGInt col, DGInt exp_mode, DGInt p1, DGInt p2)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->Fog((COLORREF)col, (int)exp_mode, (float)p1, (float)p2);
#endif
}

void X_WORLD2SCREEN(DGInt objx, DGInt objy, DGInt objz, DGInt& sx, DGInt& sy, DGInt& sz)
{
#ifndef GLB_CONSOLE
static float winx, winy, winz;
	if (GFglu_Project((float)objx, (float) objy, (float) objz, &winx, &winy, &winz, __g_pRbow->RotatedViewport(), __g_pRbow3D->m_ProjectionMatrix, __g_pRbow3D->m_ModelViewCameraMatrix ))
	{
		sx=(DGInt)winx; sy=(DGInt)winy; sz=(DGInt)winz;
	}
#endif
}

void	X_SCREEN2WORLD(DGInt winx, DGInt winy, DGInt winz, DGInt& sx, DGInt& sy, DGInt& sz)
{
#ifndef GLB_CONSOLE
static float ox,oy,oz;
	if(GFglu_UnProject((float)winx, __g_pRbow->m_WND.height-1-(float)winy, (float)winz, &ox, &oy, &oz, __g_pRbow->RotatedViewport(), __g_pRbow3D->m_ProjectionMatrix, __g_pRbow3D->m_ModelViewCameraMatrix ))
	{
		sx=(DGInt)ox; sy=(DGInt)oy; sz=(DGInt)oz;
	}
#endif
}


DGNat	X_COLLISION(DGNat num, DGNat frame, DGInt radius, DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
	if (__DG_DEBUG)
	{
		DGNat rv = __g_pRbow3D->CollisionSphere((int)num, (int)frame, (float)radius, (float)x, (float)y, (float)z) ? 1: 0;
		float sphere[3];
		sphere[0]=(float)x; sphere[1]=(float)y; sphere[2]=(float)z;
		__g_pRbow3D->DrawSphereGrid(sphere, (float)radius, (unsigned long)(rv ? RGB(255,0,0) : RGB(0,255,0)), rv?5:1);
		return rv;
	}
	else
		return __g_pRbow3D->CollisionSphere((int)num, (int)frame, (float)radius, (float)x, (float)y, (float)z) ? 1: 0;
#else
	return 0;
#endif
}

DGNat	X_COLLISIONAABB(DGNat num, DGNat frame, DGInt xc, DGInt yc, DGInt zc, DGInt wx, DGInt wy, DGInt wz)
{
#ifndef GLB_CONSOLE
/*
4 point defined AABB
  _____
 /|   /|
4 |  / |
|---|  |
| 3_|__/
|/  | /
|---|/
1   2
*/
float c1[3], c2[3], c3[3], c4[3];
	c1[0]=(float)xc;	c1[1]=(float)yc;	c1[2]=(float)zc;   // position
	c2[0]=(float)wx/2.;	c2[1]=0;			c2[2]=0;           // x-axis
	c3[0]=0;			c3[1]=0;			c3[2]=(float)wz/2.;// y-axis
	c4[0]=0;			c4[1]=(float)wy/2.;	c4[2]=0;           // z-axis
	if (__DG_DEBUG)
	{
		DGNat rv = (DGNat)(__g_pRbow3D->CollisionAABB((int)num, (int)frame, c1, c2, c3, c4) ? 1:0);
		__g_pRbow3D->DrawAABB(c1, c2, c3, c4, (unsigned long)(rv ? RGB(255,0,0) : RGB(0,255,0)), rv?5:1);
		return rv;
	}
	else
		return (DGNat)(__g_pRbow3D->CollisionAABB((int)num, (int)frame, c1, c2, c3, c4) ? 1:0);
#else
	return 0;
#endif
}

DGNat X_COLLISIONSPHEREBOX(DGInt xc, DGInt yc, DGInt zc, DGInt r, DGInt bx, DGInt by, DGInt bz)
{
#ifndef GLB_CONSOLE
	return __g_pRbow3D->CollisionSphereBox((float)xc, (float)yc, (float)zc, (float)r, (float)bx/2., (float)by/2., (float)bz/2.) ? 1:0;
#else
	return 0;
#endif
}


DGInt 	X_COLLISIONRAY(DGNat num, DGNat frame, DGInt x, DGInt y, DGInt z, DGInt dirx, DGInt diry, DGInt dirz)
{
#ifndef GLB_CONSOLE
	if (__DG_DEBUG)
	{
		float rv = __g_pRbow3D->CollisionRay((int) num, (int) frame, (float) x, (float) y, (float) z, (float) dirx, (float) diry, (float) dirz);
		float c1[3], c2[3];
		c1[0]=(float)x; c1[1]=(float)y; c1[2]=(float)z;
		float len = (rv==0.0 ? 1000 : rv) / (float)((dirx*dirx + diry*diry + dirz*dirz) * (dirx*dirx + diry*diry + dirz*dirz));

		c2[0]=(float)(x+dirx*len); c2[1]=(float)(y+diry*len); c2[2]=(float)(z+dirz*len);
		__g_pRbow3D->DrawLine(c1, c2, (unsigned long)(rv ? (rv<0 ? RGB(255,255,0) : RGB(0,255,0)) : RGB(255,0,0)), rv ? 5.0f : 1.0f);
		return rv;
	}
	else
		return (DGInt)__g_pRbow3D->CollisionRay((int) num, (int) frame, (float) x, (float) y, (float) z, (float) dirx, (float) diry, (float) dirz);
#else
	return 0.0;
#endif
}

extern int __nCurFont;
void	X_PRINT(DGStr text, DGInt x, DGInt y, DGInt z, DGInt scale, DGNat kerning)
{
#ifndef GLB_CONSOLE
	__g_pRbow->Text3D((int)__nCurFont, text.c_str(), (float)x, (float)y, (float)z, (float)scale, kerning);
#endif
}

void	X_CLEAR_Z()
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->ClearZBuffer();
#endif
}

void	X_ENABLE_Z(DGNat enable)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetDepthTesting(enable?true:false);
#endif
}




void X_LINE(DGInt xa, DGInt ya, DGInt za, DGInt xb, DGInt yb, DGInt zb, DGInt width, DGInt col)
{
#ifndef GLB_CONSOLE
static float A[3], B[3];
	A[0]=(float)xa; A[1]=(float)ya; A[2]=(float)za;
	B[0]=(float)xb; B[1]=(float)yb; B[2]=(float)zb;
	if (width<1)   width=1;
	if (width>512) width=512;
	__g_pRbow3D->DrawLine(A, B, (unsigned long) col, (float) width);
#endif
}

void X_DOT(DGInt xa, DGInt ya, DGInt za, DGInt size, DGNat col)
{
#ifndef GLB_CONSOLE
static float A[3];
	A[0]=(float)xa; A[1]=(float)ya; A[2]=(float)za;
	if (size<1) size=1;
	if (size>512) size=512;
	__g_pRbow3D->DrawDot(A, (unsigned long) col, (float) size);
#endif
}

void	X_PUSHMATRIX()
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->PushTransformation();
#endif
}
void	X_POPMATRIX()
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->PopTransformation();
#endif
}

void	X_SPHEREMAPPING(DGNat onoff)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SphereMapping(onoff ? true : false);
#endif
}


void gf_err_debug(const char* err)
{
	#ifdef _DEBUG
		printf("%s\n", err);
	#else
		if(__GLBASIC__::__DG_DEBUG)
		{
			WIN32_ONLY( DEBUG(DGStr(err)+CGStr("\n")) );
		}
	#endif
}

void X_SETSHADER(DGNat index)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->SetShader((int) index);
#endif
}

DGNat X_LOADSHADER(DGNat index, DGStr vert, DGStr frag)
{
#ifndef GLB_CONSOLE
	return __g_pRbow3D->LoadShader((int) index, vert.c_str(), frag.c_str(), gf_err_debug) ? TRUE : FALSE;
#else
	return 0;
#endif
}
void X_PUTSHADER(const DGStr& name, DGInt value)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->PutShaderUniform1f(name.c_str(), (float)value, gf_err_debug);
#endif
}


void X_SETCELSHADES(DGIntArray& vals)
{
#ifndef GLB_CONSOLE
	int num = vals.max1;
	DGArray<unsigned char> ca;
	DIM(ca, num);
	for(int i=0; i<num; ++i)
	{
		ca(i) = (unsigned char)(vals(i) * 255.0);
	}
	__g_pRbow3D->SetCelShades(&ca(0), num);
#endif
}

void X_MULTMATRIX(DGIntArray& mat)
{
#ifndef GLB_CONSOLE
//  a0  a4  a8 a12
//  a1  a5  a9 a13
//  a2  a6 a10 a14
//  a3  a7 a11 a15
	// must be 4x4 matrix
	if(mat.max1!=16 || mat.max2!=0) return;
	float m[16];
	float* pM = &m[0]; const DGInt* pM2 = &mat(0);
	*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
	*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
	*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
	*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
	__g_pRbow3D->SetMultMatrix(m);
#endif
}

void X_GETMATRIX(DGIntArray& mat)
{
#ifndef GLB_CONSOLE
//  a0  a4  a8 a12
//  a1  a5  a9 a13
//  a2  a6 a10 a14
//  a3  a7 a11 a15
	// must be 4x4 matrix
	if(mat.max1!=16 || mat.max2!=0)
	{
		DIM(mat, 16);
	}
	const float* m = __g_pRbow3D->GetFinalMatrix();

	DGInt* pM = &mat(0); const float* pM2 = &m[0];
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
#endif
}


void X_GETCAMERAMATRIX(DGIntArray& mat)
{
#ifndef GLB_CONSOLE
//  a0  a4  a8 a12
//  a1  a5  a9 a13
//  a2  a6 a10 a14
//  a3  a7 a11 a15
	// must be 4x4 matrix
	if(mat.max1!=16 || mat.max2!=0)
	{
		DIM(mat, 16);
	}
	const float* m = __g_pRbow3D->GetCameraMatrix();

	DGInt* pM = &mat(0); const float* pM2 = &m[0];
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
	*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
#endif
}


DGNat X_NUMFACES(DGNat obj)
{
#ifndef GLB_CONSOLE
int sz=0;
	X_WORLD& wld = __g_pRbow3D->m_Objects[(int)obj];
	int n = (int)wld.m_objects.Size();
	for (int i=0; i<n; ++i)
	{
		if(wld.m_objects[i].obj.m_Frames.Size())
			sz+=(int)wld.m_objects[i].obj.m_Frames[0].triangles.Size(); // vertex count. 3 verts = 1 triangle
	}
return (DGNat)(sz/3);
#else
	return 0;
#endif
}

DGNat X_GETCOLLISIONFACE()
{
#ifndef GLB_CONSOLE
	// -1 if none
	return CollisionGetLastCollisionTriangleIndex();
#else
	return -1;
#endif
}


void X_GETFACE(DGNat obj, DGNat frame, DGNat nface, DGIntArray& face)
{
#ifndef GLB_CONSOLE
	DIM(face, 3, 9);
	int sz=0, osz=0;
	X_WORLD& wld = __g_pRbow3D->m_Objects[(int)obj];
	for (int i=0; i<(int)wld.m_objects.Size(); ++i)
	{
		MeshObjectX& mesh = wld.m_objects[i].obj;
		if(mesh.m_Frames.Size())
		{
			sz+=mesh.m_Frames[(int)frame].triangles.Size();
			if(sz>nface)
			{
				nface-=osz;
				POLY_NODE* pN = &mesh.m_Frames[(int)frame].triangles[(int)nface*3];
				face(0,0) = pN->pos[0];    face(0,1) = pN->pos[1];    face(0,2) = pN->pos[2];
				face(0,3) = pN->tex[0];    face(0,4) = pN->tex[1];    face(0,5) = pN->dwcol;
				face(0,6) = pN->normal[0]; face(0,7) = pN->normal[1]; face(0,8) = pN->normal[2];
				++pN;
				face(1,0) = pN->pos[0];    face(1,1) = pN->pos[1];    face(1,2) = pN->pos[2];
				face(1,3) = pN->tex[0];    face(1,4) = pN->tex[1];    face(1,5) = pN->dwcol;
				face(1,6) = pN->normal[0]; face(1,7) = pN->normal[1]; face(1,8) = pN->normal[2];
				++pN;
				face(2,0) = pN->pos[0];    face(2,1) = pN->pos[1];    face(2,2) = pN->pos[2];
				face(2,3) = pN->tex[0];    face(2,4) = pN->tex[1];    face(2,5) = pN->dwcol;
				face(2,6) = pN->normal[0]; face(2,7) = pN->normal[1]; face(2,8) = pN->normal[2];
				return;
			}
			osz=sz;
		}
	}
#endif
}

void X_SCALEMODEL(DGNat id, DGInt sx, DGInt sy, DGInt sz)
{
#ifndef GLB_CONSOLE
	__g_pRbow3D->m_Objects[(int)id].Scale(sx, sy, sz);
#endif
}

}; // namespace __GLBASIC__




//------------------------------------------------------------------//
// Load an Object in DDW - Format
	// .DDW - World format
	// ____________________
	// ;DDW
	// [objects]
	// count=2
	// 1=a.ddd
	// 1ta=1 ; Texture 1
	// 1tb=-1; Texture 2
	// 2=b.dd
	// [textures]
	// count=2
	// 1=a.bmp
	// 2=b.bmp
//------------------------------------------------------------------//
#ifndef GLB_CONSOLE
bool Load_DDW(const char* filename, X_WORLD& world, COLORREF cookiecol)
{
	world.is_loaded=true;
	world.is_multiworld=true;
	
	GFini ini;
	ini.Read(filename);
	int numtex = (int)ini.GetVal(CGStr("textures"), CGStr("count"), DGStr(0)).natural();
	world.m_textures.SetSize(numtex);
	char fn[1024];
	char directory[1024];
	strcpy(directory, filename);
	char* pEnd = directory + strlen(directory)-1;
	while(*pEnd!='\\' && *pEnd!='/' && pEnd>directory) --pEnd;
	if(*pEnd=='\\'  || *pEnd=='/') ++pEnd;
	*pEnd='\0';
	DGStr dir = directory;
	
	for(int i=0; i<numtex; ++i)
	{
		__g_ShoeBox_Data->FindOrExtract( (dir + ini.GetVal(CGStr("textures"), DGStr(i+1), DGStr(0))).c_str(), fn, true);
		OPENGL_IMAGE image;
		if(image.LoadImageBMP(fn, cookiecol) || image.LoadImagePNG(fn, cookiecol) || image.LoadImageJPG(fn))
		{
			if(!image.m_bSourceHadAlpha)
				image.FixNeighbourAlpha();

			#if defined(TINYGL) || defined(TRENKI3D)
				oBitmap bmp;
				bmp.CreateBy(image, (COLORREF)-1);
				#ifdef TINYGL
					world.m_textures[i]=bmp.MakeGLTexture();
				#endif
			#else
				OpenGLRainbows::MakeTexture(image, 0,0,0,0, (GLuint*)&world.m_textures[i], NULL, false, false);
			#endif
		}
	}
	
	int num = (int)ini.GetVal(CGStr("objects"), CGStr("count"), DGStr(0)).natural();
	world.m_objects.SetSize(num);
	for (int i=0; i<num; ++i)
	{
		__g_ShoeBox_Data->FindOrExtract( (dir + ini.GetVal(CGStr("objects"), DGStr(i+1), DGStr(0)) ).c_str(), fn, true);
		world.m_objects[i].obj.Load(fn);
		world.m_objects[i].gl_tex = (int)ini.GetVal(CGStr("objects"), DGStr(i+1)+CGStr("ta"), DGStr(0)).natural();
		world.m_objects[i].gl_tex2= (int)ini.GetVal(CGStr("objects"), DGStr(i+1)+CGStr("tb"), DGStr(0)).natural();
		if(world.m_objects[i].gl_tex > 0) --world.m_objects[i].gl_tex;
		if(world.m_objects[i].gl_tex2> 0) --world.m_objects[i].gl_tex2;

		world.m_objects[i].obj.PrepareTriangles(); // For VBO rendering
	//	PreRenderObject(ID);		// Display list
		world.m_objects[i].obj.CalcMaxRadius();
	}
return true;
}
#endif



