// OpenGLRainbows.h: Schnittstelle fr die Klasse OpenGLRainbows.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPENGLRAINBOWS_H__266EBDA0_35ED_11D4_9493_F737DDF20444__INCLUDED_)
#define AFX_OPENGLRAINBOWS_H__266EBDA0_35ED_11D4_9493_F737DDF20444__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#undef GLX_GLXEXT_PROTOTYPES // I make my own prototypes!

// How to deal with extensions
#ifdef HAVE_OPENGL
	#if defined(EMSCRIPTEN)
			#define GF_MUST_LOAD_EXTENSIONS
			#define EXTENSION_POSTFIX		"EXT"
			// #define STATIC_EXT_POSTFIX // static functions are called "EXT" instead of "Ext"
	#else
		#define GF_MUST_LOAD_EXTENSIONS
		#define EXTENSION_POSTFIX		"EXT"
	#endif
	// #define STATIC_OES_POSTFIX // static functions are called "OES" instead of "EXT"
#elif defined(HAVE_OPENGL_ES)
	#if defined(TARGET_OS_IPHONE) || defined(PALM_WEBOS) || defined(ANDROID) || defined(RASPBERRY_PI)
		// #define GF_MUST_LOAD_EXTENSIONS // static functions
		// #define EXTENSION_POSTFIX		"OES"
		#define STATIC_OES_POSTFIX OES// static functions are called "OES" instead of "EXT"
	#elif defined(EMSCRIPTEN)
		// #define GF_MUST_LOAD_EXTENSIONS
		// #define EXTENSION_POSTFIX		"EXT"
		// #define STATIC_EXT_POSTFIX // static functions are called "EXT" instead of "Ext"
		#define STATIC_NO_POSTFIX     // static functions are called "" instead of "EXT"

	#elif defined(PANDORA)
		#define GF_MUST_LOAD_EXTENSIONS
		#define EXTENSION_POSTFIX		"OES"
		// #define STATIC_OES_POSTFIX // static functions are called "OES" instead of "EXT"
		#define APIENTRYP *
	#elif defined(_DEBUG) // debug the ES code on windows
		#define GF_MUST_LOAD_EXTENSIONS
		#define EXTENSION_POSTFIX		"EXT"

	#endif
#endif


#include "glb.h"
#include "gffilesystem.h"
#include <math.h>
#include <stdlib.h> // rand
#include "gfqueue.h"
#include "fbuffers.h"
#include "openglimage.h"


#ifndef GL_BGRA_EXT // iOS has it not. I need it really.
// #define GL_BGR_EXT                        0x80E0
#define GL_BGRA_EXT                       0x80E1
#endif

// not supported internal storage? Use the default thing. (iOS)
#ifndef GL_RGBA8
#define GL_RGBA8 GL_RGBA
#endif




#if defined(TINYGL) || defined(TRENKI3D)
#include "oFont.h"
#endif

#if defined(TARGET_OS_IPHONE)
	#include <OpenGLES/ES1/gl.h>
	#include <OpenGLES/ES1/glext.h>
#endif

#if !defined(WANT_SDL) && defined(WIN32)
	#include <windows.h>
	#include <mmsystem.h>
	#ifdef HAVE_OPENGL
		#include <GL/gl.h>			// Header File For The OpenGL32 Library
	#endif
	#if defined(HAVE_OPENGL_ES) && !defined(WIN32)
		#include <OpenGLES/egl.h>
	#endif
#endif

#if defined(POSIX)
	#include <sys/time.h>
#endif
#if 0 // stdafx.h
#ifdef WANT_SDL
	#include <SDL/SDL.h>
	#ifdef HAVE_OPENGL_ES
	#include <SDL/SDL_opengles.h>
	#endif
#endif
#endif

#ifndef WIN32
	#if (defined(_M_IX86) || defined(_M_IA64) || defined(_M_AMD64)) && !defined(MIDL_PASS)
		#define DECLSPEC_IMPORT __declspec(dllimport)
	#else
		#define DECLSPEC_IMPORT
	#endif

	#define WINGDIAPI DECLSPEC_IMPORT
	#ifndef APIENTRY
	#define APIENTRY _stdcall
	#endif
#endif

#if !defined(_WINDOWS_) && !defined(_WIN32_WCE)
	typedef struct tagSIZE
	{
	int cx, cy;
	} SIZE;
#endif

#define GLR_MAX_TEXTURES	0x10000
#define GLR_MAX_SURFACE		0x0008
#define GLR_MAX_FONT		0x0020

#define GLR_MAX_SPRITE_SLOTS (GLR_MAX_TEXTURES - GLR_MAX_FONT)

#define GLR_MAX_FRAMEBUFFER 0x0020


// SEARCH_GLB_ENABLE
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
	struct GLB_ENABLE_STATE
	{
		GLB_ENABLE_STATE() {clear();}
		#define GLB_ENABLE_FOO(code)	int m_ ##code; void glbEnableFeature ##code(char bEnable) { if(bEnable != m_ ##code) {if(bEnable){ glEnable(code);} else {glDisable(code);} m_ ##code = bEnable;} }


		GLB_ENABLE_FOO(GL_BLEND)
		GLB_ENABLE_FOO(GL_ALPHA_TEST)

		GLB_ENABLE_FOO(GL_VERTEX_ARRAY)
		GLB_ENABLE_FOO(GL_NORMAL_ARRAY)
		GLB_ENABLE_FOO(GL_COLOR_ARRAY)
		GLB_ENABLE_FOO(GL_TEXTURE_COORD_ARRAY)

		GLB_ENABLE_FOO(GL_COLOR_MATERIAL)
		// GLB_ENABLE_FOO(GL_TEXTURE_2D) take care of glActiveTextureArb !!!
		GLB_ENABLE_FOO(GL_CULL_FACE)
		GLB_ENABLE_FOO(GL_LIGHTING)
		GLB_ENABLE_FOO(GL_STENCIL_TEST)
		GLB_ENABLE_FOO(GL_DEPTH_TEST)
		GLB_ENABLE_FOO(GL_FOG)
		GLB_ENABLE_FOO(GL_DITHER)

		GLB_ENABLE_FOO(GL_LINE_SMOOTH)
		GLB_ENABLE_FOO(GL_POINT_SMOOTH)
		GLB_ENABLE_FOO(GL_NORMALIZE)

	#if defined(HAVE_OPENGL)
		GLB_ENABLE_FOO(GL_COLOR)
		GLB_ENABLE_FOO(GL_POLYGON_SMOOTH)
		GLB_ENABLE_FOO(GL_POLYGON_OFFSET_POINT)
		GLB_ENABLE_FOO(GL_AUTO_NORMAL)
		GLB_ENABLE_FOO(GL_TEXTURE_GEN_S)
		GLB_ENABLE_FOO(GL_TEXTURE_GEN_T)
	#endif
		#undef GLB_ENABLE_FOO
		
		void clear() {memset(this, 0x7f, sizeof(GLB_ENABLE_STATE)); }
	};
	extern GLB_ENABLE_STATE __g_EnableState;



	#if 1
		#define glbUnEnableAll() {__g_EnableState.clear();}
		#define glbEnable(code)  {__g_EnableState.glbEnableFeature ##code(TRUE);}
		#define glbDisable(code) {__g_EnableState.glbEnableFeature ##code(FALSE);}
		static void glbColor4f(float r, float g, float b, float a)
		{
			static float _or=-1.0f, _og=-1.0f, _ob=-1.0f, _oa=-1.0f;
			if(_or!=r || _og!=g || _ob!=b || _oa!=a)
			{
				_or=r; _og=g; _ob=b; _oa=a;
				glColor4f(r,g,b,a);
			}
		}

	#else
		#define glbUnEnableAll() {}
		#define glbEnable glEnable
		#define glbDisable glDisable
		#define glbColour4f glColour4f
	#endif
#endif



// ProcAddress wrappers
inline void* glGFGetProcAddressArb(const char* fooname)
{
	#ifdef GF_MUST_LOAD_EXTENSIONS
		#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
			#if defined(WIN32)
				void* pFoo = (void*)wglGetProcAddress(fooname);
			#elif defined( WANT_SDL)
				void* pFoo = (void*)SDL_GL_GetProcAddress(fooname);
			#elif defined(HAVE_OPENGL_ES)
				void* pFoo = (void*)eglGetProcAddress(fooname);
			#else
				void* pFoo=NULL;
			#endif
			if(!pFoo)
				g_debug("ext: %-35s   [FAILED]", fooname);
			return pFoo;
		#endif
	#endif
return NULL;
}


#define MAKEGRAYCOLOR(a) {int b=(int)((GetRValue(a)*0.30) + (GetGValue(a)*0.59) + (GetBValue(a)*0.11)); a=RGB(b,b,b);}
#ifndef ZeroStruct
	#define ZeroStruct(a) ::memset(&a, 0, sizeof(a))
#endif


// Font Kerning structure
struct GLR_FONTKERNING
{
	GLR_FONTKERNING(): xoff(0), width(0), txa(0.0f), txe(0.0f) {}
	unsigned char xoff, width; // from character
	float txa, txe;
};



struct FONTCHAR
{
	struct FONTVEC{float x,y;};
	struct FONTTRI{int   i,j,k;};
	Queue<FONTVEC> vec;
	Queue<FONTTRI> tri;
	float minx, miny, maxx, maxy;

	float width() const {return maxx-minx;}
	float height()const {return maxy-miny;}
};
struct TTF_FONT
{
	TTF_FONT(){Clear();}
	Queue< FONTCHAR > chars;
	void Clear() {chars.Clear(); max_ascender=max_char_width=max_descender = 0.0f;}
	bool IsLoaded() const {return chars.Size() ? true:false;}
	float max_char_width;
	float max_ascender;
	float max_descender;
};


class Rainbows3D;

class OpenGLRainbows  
{
/////////////////////////////////////////////////////////////////////////////////////////
// FUNCTIONS
/////////////////////////////////////////////////////////////////////////////////////////
public:

	OpenGLRainbows();
	virtual ~OpenGLRainbows();
	
	unsigned int WinMessages( void(*peekmsg)() = NULL, bool allow_to_sleep=false); // Handle Windows Messges
	bool	Init(HINSTANCE hInst, int width, int height, int bpp=0, unsigned int fps=5, int multisamples=0, bool fullscreen=false); // Init OpenGLRainbows. Returns GLR_OK if OK.
	void	Close();
	BOOL	IsActive()			{return m_IsActive;}		// Can perform rendering?
	void	SetMaxFPS(int maxfps, bool bVsync);
	void	ChangeSize(int w, int h);// Change viewing volume and viewport.  Called when window is resized
	void	SetColorKey(COLORREF col);
	bool	DoFullscreen();
	bool	DoWindowed();
	bool	HideWindow();
	void	ClearScreen(COLORREF col);
	bool    LoadSaveTextureToTmp(bool bLoad);

	const char* TmpFileForTextureStore();

private:
	void MakeAutoStereo();
	void MakeAutoStereoTexture(int width, int height, int slice, void* pZBuffer, int bits_per_Z, int bits_per_Color, void* pColorBuffer);


// Sprite Operations
///////////////////////////////////////////////////////////////////
public:	
	int GenSprite();
	int GenFont();
	int GenFBuffer();

	///////////////////////////////////////////////////////////////////
	//              ALPHA - BLENDING + TESTING
	///////////////////////////////////////////////////////////////////

	void SetAlphaTesting(float greaterthen = 1.0f); // 1.0 -> all solid, no testing

	//---------------------------------------------------------------//
	inline void DoAlpha(float alpha)
	{
		#if defined(TRENKI3D) || defined (TINYGL)
			if(alpha==0 || alpha<-0.95) // -0.99 is just alpha testing
			{
				Screen.Alphamode(0);
				tglSetAlphaFunc(NULL);
				// alpha"blending" of -1 is SLOW! Same effect with testing!
				if(alpha < -0.95)
					Screen.alpha_testing = true;
			}
			else if(alpha<0)
			{
				Screen.Alphamode(min(-1, (short)(alpha*255.0f)));
				tglSetAlphaFunc(Screen.m_BlendFunc);
			}
			else
			{
				Screen.Alphamode(max(1, (short)(alpha*255.0f)));
				tglSetAlphaFunc(Screen.m_BlendFunc);
			}
		#else

			#if 0 // do this manually. You can't draw holes, otherwise.
			if(alpha==0.0f && m_fAlphaTestingGTH >= 1.0f) // no cookie cut - fake by blending! (Much faster on EGL)
			{
				alpha = -1.0;
			}
			#endif

			// glbEnable(GL_BLEND);
			if(alpha==0.0f)
			{
				glbDisable(GL_BLEND);
			}
			else if (alpha>0.0f)
			{
				glbEnable(GL_BLEND);
				glBlendFunc(GL_SRC_ALPHA, GL_ONE); // Alpha Blending
			}
			else // if(alpha<0.0f)
			{
				glbEnable(GL_BLEND); // GL_ONE, GL_SRC_COLOR
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			}
		#endif
		
		if(alpha==0.0f)
			alpha=1.0f;
		if(alpha<0.0f) alpha=-alpha;
		if(alpha>1.0f) alpha=1.0;
		m_falpha=alpha; // Factor for colors when drawing lines/rects...
		#if defined (HAVE_OPENGL) || defined (HAVE_OPENGL_ES)
			glbColor4f(1.0f, 1.0f, 1.0f, alpha); // Color & Alpha
		#endif
	}
	

//	int m_DesktopSize[2] SDL: GetVideoInfo


//	long LoadSprite(GLuint num, const char* szFileName, COLORREF colorkey);
	SIZE GetSpriteSize(int num);
	SIZE GetFontSize(int num);

	// Draw with Vertex Arrays
	#if !defined(TINYGL) && !defined(TRENKI3D)
		static void DrawQuad(const float* pXYUV);
	#endif

	struct VERTEX{
		float x,y,z,u,v;
		inline void assign(float ix, float iy, float iz, float iu, float iv) {x=ix; y=iy; z=iz; u=iu; v=iv;}
		inline void assign(float* pXYZ, float iu, float iv) {x=pXYZ[0]; y=pXYZ[1]; z=pXYZ[2]; u=iu; v=iv;}
	};
	Queue<VERTEX> m_VertexArray;
	void DrawVertexArray(unsigned int iMode);

	void DrawSprite(int num, int x, int y); // Draws a Single Sprite with Cookie
	void StretchSprite(int num, int x, int y, int wx, int wy); // Zooms Sprite to new extents
	void RotoSprite(int num, int x, int y, float angle, float scale);// Draws a Sprite with Rotation
	void TileSprite(int iSprite, int width, int height);
	void DrawTile(int num, int iTile, int x, int y);
	void RotoZoomTile(int num, int iTile, int x, int y, float phi, float scale);
	void StretchTile(int num, int iTile, int x, int y, int w, int h);

	void DrawBillboard(int num, float x, float y, float z, float scale); // Draw a billboard sprite

	int  Text2DWidth(int num_font, const char* text, int kerning=false); // width with kerning
	void Text2D(int num_font/*0*/, const char* text, float x, float y, float z=0.0f, int kerning=FALSE, int apply_scaling=FALSE);
	void Text3D(int nFont, const char* szText, float x, float y, float z, float scale, int kerning=FALSE); // Draw Text in 3D space
	void TextTTF(int nFont, const char* szText, float x, float y, int kerning=FALSE);


//	void DrawSpriteFX(int num, float x, float y, OPENGL_SPRITEFX& fx); // Draw Sprotes with FX

#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
	static bool MakeTexture(OPENGL_IMAGE& image, int startx, int starty,
						int sizex, int sizey,
						GLuint* pTextureID, GLuint* pTextureIDMipMap=NULL,
						bool IsBumpHeightMap=false, bool IsFont=false);
	void GetSpritePixels(int n); // Get the pixels from the card into SpritePix data
#endif

	void SetScreen(int w, int h, int bpp, int fullscreen);
	void DefaultFont(int num);

//	SIZE GetBMPSize(const char* szFileName); // Get the Dimensions of a BMP File
	bool LoadSprite(int num, const char* szFileName, COLORREF colorkey, bool IsBumpHeightmap); // Load a Texture as a Sprite
	bool LoadSprite(int num, OPENGL_IMAGE& image, COLORREF colorkey, bool IsBumpHeightmap); // Load a Texture as a Sprite
	bool LoadSurface(int num, const char* szFileName, bool bGrayScale=false); // Load a Background Surface
	bool LoadFontPIX(int num, const char* szFileName);
	bool LoadFontTTF(int num, const short* packed_ttf);
	void PasteSurface(int num); // Show a Background Surface
	bool SaveBMPFile (const char* szFilename); // Save the back buffer as a bmp file
	bool GetSpriteRGBA(int nSprite, OPENGL_IMAGE& img);
	bool SaveBMPSprite( int nSprite, const char* szFilename); // Save the sprite's texture (visible size) as a bmp file
	bool SaveImageFile(	const char* szFilename, OPENGL_IMAGE& img);
	unsigned int GetTrueCookieColor(); // Get cookie color, fix 16 bit interpolation issues
	void SetSmoothShading(bool smooth);
	void ApplySmoothShading();

	int FlipScreens(void (*peekmsg)(void) = NULL); // Flip Screens, Kill WinMessages, Return 1=OK, 0=Exit
	void PrepareBackbuffer();

	// Collision
	bool SpriteCollision(int n1, int n2, int x1, int y1, int x2, int y2);
	bool TileCollision(  int n1, int tile1, int x1, int y1, int n2, int tile2, int x2, int y2);
	bool _PixelCollision(int n1, int x1, int y1, int n2, int x2, int y2, int xs, int ys, int xe, int ye);

/////////////////////////////////////////////////////////////////////////////////////////
// DATA
/////////////////////////////////////////////////////////////////////////////////////////
public:
#ifdef TRENKI3D
	void SetTexture3D(int num, int num_multi, int usemipmapping);
#else
	void SetTexture3D(int num, int num_multi, int usemipmapping, GLuint* pTextures=NULL);
#endif

	void Make2DMode();
	void Make2DViewport(int x=0, int y=0, int w=0, int h=0, float scale=1.0f);
	void FreeAll();
	void FreeSurface(int num);
	void FreeSprite(int num);
	void PolyStart(int nTexture=-1, int iMode=0);
	void PolyPoint(float sx, float sy, float tx, float ty, COLORREF col=RGB(0xff, 0xff, 0xff));
	void PolyNewStrip();
	void PolyEnd(void);
	
	void DrawPixel(int sx, int sy, COLORREF col);
	void DrawLine (int sx, int sy, int ex, int ey, COLORREF col);
	void DrawLinef(float sx, float sy, float ex, float ey, COLORREF col) {DrawLine(int(sx), int(sy), int(ex), int(ey), col);}
	void DrawRect (int sx, int sy, int ex, int ey, COLORREF col);
	COLORREF GetPixel(int x, int y);
	bool GrabSprite(int num, int x, int y, int wx, int wy);
	void GrabSurface(int num);
	
	//void FixAlphaPixels(int n); // Fix transparent pixels after a GrabSprite

	void ShowDemo(int xpos, float alpha);

	// GLuint	m_Texture[GLR_MAX_TEXTURES][2];	// OpenGL TextureID[nr][0=normal, 1=mipmap]
	int		m_Texture3D[3]; // [idNormal, idMultitexturing, UsesMipmapping]
	struct GLR_TEXTURE
	{
		GLR_TEXTURE(): txx(0.0f), txy(0.0f), w(0), h(0), bw(0), bh(0), tw(0), th(0) { mipstate[0]=mipstate[1]=0; }
		unsigned int mipstate[2]; // 0=normal, 1=mipmapping
		float	txx, txy; // bw/w and bh/h
		short	w,h;   // texture size
		short	bw,bh; // bitmap (sprite) pixel dimensions
		short	tw,th; // tile width/height
	};
	
	GLR_FONTKERNING m_FontKerning[GLR_MAX_FONT][256];
	float           m_FontScaling[GLR_MAX_FONT];
	TTF_FONT        m_ttf_fonts  [GLR_MAX_FONT];
	COLORREF        m_TextColor; // for TTF

	void BuildFontTTF(const short* ck, TTF_FONT& font);



	unsigned int GetOpenGLTextureIndex(int idSprite)
	{
		if(idSprite<0) return 0;
		return m_Texture[idSprite].mipstate[0];
	}
	
	GLR_TEXTURE* m_Texture;

	#ifdef _DEBUG
	int		m_Texture3D_id_for_chanel[2];
	#endif

	float	m_falpha;
	float   m_fAlphaTestingGTH;
	bool	m_bHasClearColor;
	bool	m_bDirtyZBuffer; // drawn to Z buffer?
	bool    m_bSupportBGRA_ext; // faster on all

	// Framebuffer support
	FBUFFER m_FBuffer[GLR_MAX_FRAMEBUFFER]; // FBuffer handles
	int     m_CurrentFBO; // -1: real screen. 0...x off-screen
	bool FBO_create(int iBuffer, int idSprite, int width, int height);
	void FBO_start(int iBuffer);
	void FBO_end();
	
#if defined(TINYGL) || defined(TRENKI3D)
	oBitmap	m_Sprite[GLR_MAX_TEXTURES];
	oBitmap	m_Surface[GLR_MAX_SURFACE];
	oFont	m_Font[GLR_MAX_FONT];
#else

	#ifdef _DEBUG
		#define SPRITE_ALPHA_PIX_AS_VECTOR
	#endif

	#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
		Queue<BYTE>		SpritePix[GLR_MAX_TEXTURES+1]; // Pixels for Sprcoll
	#else
		BYTE*			SpritePix[GLR_MAX_TEXTURES+1]; // Pixels for Sprcoll
	#endif


// #define GLB_SURFACE_OLDSCHOOL // tiny textures (that's 2000 A.D. OpenGL 1.0 style)
#ifdef GLB_SURFACE_OLDSCHOOL
	struct OPENGL_RAINBOWS_SURFACE
	{
		OPENGL_RAINBOWS_SURFACE() {clear();}
		void clear()
		{
			memset(this, 0, sizeof(OPENGL_RAINBOWS_SURFACE));
		}
		GLuint	txt [8][8]; // Textures
		short	sizx[8][8]; // Size of each Texture X
		short	sizy[8][8]; // Size of each Texture Y
		short	sizbx[8][8]; // size of bitmap X
		short	sizby[8][8]; // size of bitmap Y
		char	usex;			// Used Texture-Panels X
		char	usey;			// Used Texture-Panels Y
	};
	OPENGL_RAINBOWS_SURFACE m_Surface[GLR_MAX_SURFACE];
#else // jus use a sprite
	int m_BackSurfaceSpriteID[GLR_MAX_SURFACE]; // -1: none

#endif
	bool	m_SmoothShading;
#endif

	// Viewport
	struct VIEWPORT_RECT
	{
		int x, y, width, height;
	};

	// Window Definition
	struct OPENGL_RAINBOWS_WINDOW
	{

	#ifdef WIN32
		HWND	hwnd; // has a window - either created, or pointer to external (PocketPC)
	#endif

	#if defined(HAVE_OPENGL_ES)
		#if defined(PANDORA)
			// nop
		#elif defined(WANT_SDL)
			#if SDL_VERSION_ATLEAST(2,0,0)
			/* SDL window */
			SDL_Window*    sdl_window;
			/* SDL GL ES context, bound to SDL window */
			SDL_GLContext sdl_glcontext;
			SDL_Renderer* sdl_renderer;
			#endif
		#elif defined(GPHWIZ)
			NativeWindowType hNativeWnd; // A handle to the window we will create.
			EGLDisplay glesDisplay;  // EGL display
			EGLSurface glesSurface;	 // EGL rendering surface
			EGLContext glesContext;	 // EGL rendering context
		#endif
	#endif

		int		width;  // of physical display screen (or desktop)
		int		height; // of physical display screen (or desktop)
		int		virtw, virth; // virtual display size (prescaler) 0: use width/height

		int		bpp;
		bool	fullscreen;
		int		multisample;
		VIEWPORT_RECT	viewport; // physical screen pixels
	};
	OPENGL_RAINBOWS_WINDOW m_WND;

	const int*  RotatedViewport()const;

	int  m_physical_device_screen_is_landscape; // webos touchpad is landscape by default, pre is not!
	int	 m_landscape; // 0=original[^], 1=90CCW [>], 2=180 [v], 3=90CW [<]
	void Rot_Screen2Display(int x, int y, int* pX, int* pY)const; // screen->touch
	void Rot_Screen2Display(int x, int y, int w, int h, int* pX, int* pY, int* pW, int* pH)const; // rect: screen->touch
	void Rot_Gravity2Display(int x, int y, int* pX, int* pY)const;


	void Rot_Display2Screen(int x, int y, int* pX, int* pY)const; // touch->screen
	void Rot_Display2Screen(int x, int y, int w, int h, int* pX, int* pY, int* pW, int* pH)const; // rect: touch->screen


	COLORREF	m_CookieColor, m_CookieFont;
	Rainbows3D* m_pRbow3D;

private:
	COLORREF m_clear_color;
	BOOL	m_IsActive;					// Can perform Rendering, OpenGL initialized
	DGInt	m_next_time, m_FrameRate;

#if ! (defined( WANT_SDL ) || defined(TINYGL) || defined(TRENKI3D) ) && defined(WIN32)
	private:
		HINSTANCE m_hinstance;
		HGLRC	m_hRC;						// Permenant Rendering context
#endif

};


// Emscripten drop-outs
#if defined(EMSCRIPTEN)
#define glLightModelf(a,b) {}
#define glTexEnvf(a,b,c)   {}
#define glTexEnvi(a,b,c)   {}
#endif


#if defined(EMSCRIPTEN) && !defined(HAVE_OPENGL_ES)
	#define glVertex2i(x,y)			glVertex3f((float)(x), (float)(y), 0.0f)
	#define glVertex4f(x,y,z,w)		glVertex3f((x), (y), (z))
#endif


/// EGL Wrappers
#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
	#define GL_QUADS                          0x0007
	#define GL_STREAM_DRAW_ARB	GL_DYNAMIC_DRAW // not supported on ES
	#define GL_DYNAMIC_DRAW_ARB	GL_DYNAMIC_DRAW
	#define GL_STATIC_DRAW_ARB	GL_STATIC_DRAW
	inline  void glMultiTexCoord2fArb(GLenum target, GLfloat u, GLfloat v)
												{glMultiTexCoord4f(target, u, v, 0.0f, 1.0f);}
	inline void glBindBufferArb(GLenum target, GLuint buffer)
												{glBindBuffer(target, buffer);}

	#define GL_TEXTURE1_ARB GL_TEXTURE1
	#define GL_TEXTURE0_ARB GL_TEXTURE0

	inline void glClientActiveTextureArb(GLenum texture) {glClientActiveTexture(texture);}

	#define GL_ARRAY_BUFFER_ARB GL_ARRAY_BUFFER
	#define GL_BUFFER_SIZE_ARB	GL_BUFFER_SIZE

	#define glGenBuffersArb				glGenBuffers
	#define glBufferDataArb				glBufferData
	#define glDeleteBuffersArb			glDeleteBuffers
	#define glClientActiveTetureArb		glClientActiveTexture
	#define glActiveTextureArb			glActiveTexture

	#define glOrtho	  glOrthof
	#define glFrustum glFrustumf
	
	void eglBegin(int mode);
	void eglEnd();
	void eglVertex3fv(const float* pv);
	void eglVertex4fv(const float* pv);
	void eglVertex4f(float x, float y, float z, float w);
	#define glBegin eglBegin
	#define glEnd eglEnd
	#define glVertex3fv eglVertex3fv
	#define glVertex4f  eglVertex4f
	#define glVertex3f(x,y,z) eglVertex4f(x,y,z,1.0f)
	#define glVertex2i(x,y)   eglVertex4f((float)(x), (float)(y), 0.0f, 1.0f)
	#define glNormal3fv(v)    glNormal3f((v)[0], (v)[1], (v)[2])

/*	WIZ crap EGL
//	void eglColor4f(float r, float g, float b, float a);
//	void eglColor4ub(unsigned char r, unsigned char g, unsigned char b, unsigned char a);
	#define glColor4f(r,g,b,a)  eglColor4f((r),(g),(b),(a));
*/
/*
	// Buggy wrappers (WIZ)
	#define	EGL_PRECISION_D	16
	const unsigned int EGL_PRECISION = EGL_PRECISION_D;
	const GLfixed EGL_ONE  = 1 << EGL_PRECISION_D;
	const GLfixed EGL_ZERO = 0;
	inline GLfixed FixedFromInt(int value) {return value << EGL_PRECISION;};
	inline GLfixed FixedFromFloat(float value) {return GLfixed(value * (EGL_ONE));};        // FP op!
	inline GLfixed FixedFromIntColor(int value) {return (value << EGL_PRECISION) / 255;};

	#define glColor4f(a,b,c,d)  glColor4x(FixedFromFloat(a), FixedFromFloat(b), FixedFromFloat(c), FixedFromFloat(d));
	#define glColor3f(a,b,c )   glColor4x(FixedFromFloat(a), FixedFromFloat(b), FixedFromFloat(c), EGL_ZERO);
	#define glColor4ub(a,b,c,d) glColor4x(FixedFromIntColor(a), FixedFromIntColor(b), FixedFromIntColor(c), FixedFromIntColor(d));
	#define glColor3ub(a,b,c)   glColor4x(FixedFromIntColor(a), FixedFromIntColor(b), FixedFromIntColor(c), EGL_ZERO);
*/

#endif


#if defined(_DEBUG)
	#define GF_WANT_OPENGL_DEBUG
#endif


#if defined(GF_WANT_OPENGL_DEBUG)
	#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)

	static int gf_glInBegin = 0;
	static void gf_glError(const char* pFile=NULL, int line=0)
	{
		if(gf_glInBegin) return;
		GLenum ec = glGetError();
		if (ec == GL_NO_ERROR) return;

		char err[1024];
		sprintf(err, "%s(%d) : error OGL%d: ", pFile?pFile:"", line, (int)ec);
		switch(ec)
		{
		case GL_NO_ERROR: return;
		case GL_INVALID_ENUM: strcat(err, "An unacceptable value is specified for an enumerated argument. The offending function is ignored, having no side effect other than to set the error flag."); break;
		case GL_INVALID_VALUE: strcat(err, "A numeric argument is out of range. The offending function is ignored, having no side effect other than to set the error flag."); break;
		case GL_INVALID_OPERATION:strcat(err, "The specified operation is not allowed in the current state. The offending function is ignored, having no side effect other than to set the error flag."); break;
		case GL_STACK_OVERFLOW: strcat(err, "This function would cause a stack overflow. The offending function is ignored, having no side effect other than to set the error flag."); break;
		case GL_STACK_UNDERFLOW: strcat(err, "This function would cause a stack underflow. The offending function is ignored, having no side effect other than to set the error flag."); break;
		case GL_OUT_OF_MEMORY: strcat(err, "There is not enough memory left to execute the function. The state of OpenGL is undefined, except for the state of the error flags, after this error is recorded."); break;
		#ifdef GL_TABLE_TOO_LARGE
			case GL_TABLE_TOO_LARGE: strcat(err, "The specified table exceeds the implementation's maximum supported table size. The offending command is ignored and has no other side effect than to set the error flag."); break;
		#endif

		default:
			strcat(err, "unknown error."); break;
		}
		strcat(err, "\n");
		#ifdef _DEBUG
			::OutputDebugString(err);
		#else
			g_debug("%s", err);
		#endif
		gf_glError(pFile, line); // recurse until GL_NO_ERROR!
	}
	#define OPENGL_CHECK_ERRORS() {gf_glError(__FILE__, __LINE__);}

	#if defined(HAVE_OPENGL)
		#define glBegin(a)						{gf_glError(); gf_glInBegin = 1; glBegin(a);}
		#define glEnd()							{glEnd(); gf_glInBegin = 0; gf_glError(__FILE__, __LINE__);}
	#endif

	#define glEnable(a)							{glEnable(a); gf_glError(__FILE__, __LINE__);}
	#define glDisable(a)						{glDisable(a); gf_glError(__FILE__, __LINE__);}
	#define glEnableClientState(a)				{glEnableClientState(a); gf_glError(__FILE__, __LINE__);}
	#define glDisableClientState(a)				{glDisableClientState(a); gf_glError(__FILE__, __LINE__);}
	#define glVertexPointer(a,b,c,d)			{glVertexPointer(a,b,c,d); gf_glError(__FILE__, __LINE__);}
	#define glDrawArrays(a,b,c)					{glDrawArrays(a,b,c); gf_glError(__FILE__, __LINE__);}
	#ifdef HAVE_OPENGL_ES
		#define glTexParameterf(a,b,c)			{}// who cares (GL_CLAMP is not supported on Pi e.g.)
	#else
		#define glTexParameterf(a,b,c)			{glTexParameterf(a,b,c); gf_glError(__FILE__, __LINE__);}
	#endif
	#define glMultMatrixf(a)					{glMultMatrixf(a); gf_glError(__FILE__, __LINE__);}
	#define glPushMatrix()						{glPushMatrix(); gf_glError(__FILE__, __LINE__);}
	#define glPopMatrix()						{glPopMatrix(); gf_glError(__FILE__, __LINE__);}
	#define glPopMatrix()						{glPopMatrix(); gf_glError(__FILE__, __LINE__);}
	#define glLightfv(a,b,c)					{glLightfv(a,b,c); gf_glError(__FILE__, __LINE__);}
	#define glLightf(a,b,c)						{glLightf(a,b,c); gf_glError(__FILE__, __LINE__);}
	#define glTexImage2D(a,b,c,d,e,f,g,h,i)		{glTexImage2D(a,b,c,d,e,f,g,h,i); gf_glError(__FILE__, __LINE__);}
	#define glBindTexture(a,b)					{glBindTexture(a,b); gf_glError(__FILE__, __LINE__);}
	#define glCopyTexSubImage2D(a,b,c,d,e,f,g,h){glCopyTexSubImage2D(a,b,c,d,e,f,g,h); gf_glError(__FILE__, __LINE__);}
	#define glReadPixels(a,b,c,d,e,f,g)			{glReadPixels(a,b,c,d,e,f,g); gf_glError(__FILE__, __LINE__);}

	#endif

#endif // _DEBUG

#ifndef OPENGL_CHECK_ERRORS
	#define OPENGL_CHECK_ERRORS() {}
#endif




#endif // !defined(AFX_OPENGLRAINBOWS_H__266EBDA0_35ED_11D4_9493_F737DDF20444__INCLUDED_)

