#ifndef BREADTHPLANNER_H
#define BREADTHPLANNER_H
/**
  @class BreadthPlanner
  @brief "Breadth-first" path-finding algorithm.

  In "breadth-first" path-finding, each possible node is put into a list of
  "open" nodes and checked on a first-in, first-out basis.

  Copyright (C) 2003 Ted Cipicchio <ted@thereisnospork.com>

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to
  deal in the Software without restriction, including without limitation the
  rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
  sell copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
  IN THE SOFTWARE.

  @date  Created: Sun Mar 23 2003
*/

#include "planner.h"

//----------------------------------------------------------------------------
class BreadthPlanner : public Planner
{
public:
	//------------------------------------------------------------------------
	/** @name Running */
	//@{

	/// Initialize the path-finding algorithm.
	virtual void initialize ();
	/// Run a single time slice of the path-finding algorithm.
	virtual bool run ();

	//@}
};

#endif	// BREADTHPLANNER_H
