/*

File: AppController.m
Abstract: The UIApplication  delegate class, which is the central controller of
the application.
*/

#import "iPhoneAppController.h"
#import "iPhoneEAGLView.h"
#import <UIKit/UIScreen.h>
#import <AudioToolbox/AudioToolbox.h>
#import <UIKit/UIDevice.h>
#import <CoreMotion/CoreMotion.h>

// find free mem
#import <mach/mach.h>
#import <mach/mach_host.h>

//CONSTANTS:
#define SYSTEM_VERSION_EQUAL_TO(v)                  ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedSame)
#define SYSTEM_VERSION_GREATER_THAN(v)              ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedDescending)
#define SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(v)  ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] != NSOrderedAscending)
#define SYSTEM_VERSION_LESS_THAN(v)                 ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] == NSOrderedAscending)
#define SYSTEM_VERSION_LESS_THAN_OR_EQUAL_TO(v)     ([[[UIDevice currentDevice] systemVersion] compare:v options:NSNumericSearch] != NSOrderedDescending)
#define kAccelerometerFrequency			30 //Hz
static float gAccX=0.0f, gAccY=0.0f, gAccZ=0.0f;


#ifdef __cplusplus
extern "C"
#endif

int pausedsafe = 0;
int gKillProgramNow = 0;
void glb_do_pause(int pause);
int glb_allow_escape();
int defaultorientation=0;
int nrewrotation = 1; // 1 using UIVIEWCONTROLLER, 0 not using it.
int ismficontrollerconnected=0; // Space Fractal
UIInterfaceOrientation interfaceOrienation; // Space Fractal
float controlvalues[32]; // Space Fractal
void __glb_set_cmd_line(const char* pcmd);

// Variables to help control orientation /* DaCarSoft */
Boolean UIInterfaceOrientationPortraitSupported; /* DaCarSoft */
Boolean UIInterfaceOrientationPortraitUpsideDownSupported; /* DaCarSoft */
Boolean UIInterfaceOrientationLandscapeRightSupported; /* DaCarSoft */
Boolean UIInterfaceOrientationLandscapeLeftSupported; /* DaCarSoft */

iPhoneViewController* gpiPhoneViewControllerWithRotation=NULL; /* DaCarSoft: create global extern pointer to the view controller */

iCadeReaderView* gpiCadeView = NULL;
EAGLView* gpimainView = NULL;


size_t get_free_memory() {
	mach_port_t host_port;
	mach_msg_type_number_t host_size;
	vm_size_t pagesize;
	host_port = mach_host_self();
	host_size = sizeof(vm_statistics_data_t) / sizeof(integer_t);
	host_page_size(host_port, &pagesize);
	vm_statistics_data_t vm_stat;
	if (host_statistics(host_port, HOST_VM_INFO, (host_info_t)&vm_stat, &host_size) != KERN_SUCCESS) {
		NSLog(@"Failed to fetch vm statistics");
		return 0;
	}
	/* Stats in bytes */
	size_t mem_free = vm_stat.free_count * pagesize;
	return mem_free;
}


/*
#ifdef __cplusplus
extern "C"
#endif
int GLB_iPhone_call_main(int argc, char *argv[])
{
    gpArgv=argv;
    gArgc=argc;
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
    int retVal = UIApplicationMain(argc, argv, nil, @"AppController");
    [pool release];
    return retVal;
}
*/

void			*gpGLB_MainWnd=NULL;


@implementation AppController

@synthesize window;
@synthesize glView;


- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url
{
    if (!url) {  return NO; }
 
    NSString *URLString; /* DaCarSoft: obtain the argument at app launch in a valid encoding */
    NSData* tmpURLEncoded = [[NSData alloc] init]; /* DaCarSoft */
    tmpURLEncoded = [[url absoluteString] dataUsingEncoding:NSWindowsCP1252StringEncoding allowLossyConversion:YES]; /* DaCarSoft */
    URLString = [[NSString alloc] initWithData:tmpURLEncoded encoding:NSWindowsCP1252StringEncoding]; /* DaCarSoft */
    tmpURLEncoded = nil; /* DaCarSoft */
    
    __glb_set_cmd_line([URLString cStringUsingEncoding:NSWindowsCP1252StringEncoding]); /* DaCarSoft */
    printf("set commandline to URL:\n    %s\n", [URLString cStringUsingEncoding:NSWindowsCP1252StringEncoding]); /* DaCarSoft */

    return YES;
}

/*
- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url
{
    if (!url) {  return NO; }

    NSString *URLString = [url absoluteString];

	printf("set commandline to URL:\n    %s\n", [URLString UTF8String]);
    __glb_set_cmd_line([URLString UTF8String] );
    return YES;
}
*/


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
	// Now hide the status bar, and don't animate to the style.
	[application setStatusBarHidden:YES withAnimation:UIStatusBarAnimationFade]; /* DaCarSoft */
   
    // iPhone MFI controller support
    if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0"))
    {   [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(controllerStateChanged) name:GCControllerDidConnectNotification object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(controllerStateChanged) name:GCControllerDidDisconnectNotification object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(controllerStateChanged) name:GCControllerDidDisconnectNotification object:nil];
        [GCController startWirelessControllerDiscoveryWithCompletionHandler:^{ [self controllerStateChanged]; }];
    }
    
    // Read from the info.plist all the supported orientations and stores each one /* DaCarSoft */
    NSArray* SupportedUIOrientations = [[NSBundle mainBundle] objectForInfoDictionaryKey:@"UISupportedInterfaceOrientations"]; /* DaCarSoft */
    for (NSString* iObject in SupportedUIOrientations) {
        if ([iObject isEqualToString: @"UIInterfaceOrientationPortrait"]) {
            UIInterfaceOrientationPortraitSupported = YES;
        }
        if ([iObject isEqualToString: @"UIInterfaceOrientationPortraitUpsideDown"]) {
            UIInterfaceOrientationPortraitUpsideDownSupported = YES;
        }
        if ([iObject isEqualToString: @"UIInterfaceOrientationLandscapeLeft"]) {
            UIInterfaceOrientationLandscapeLeftSupported = YES;
        }
        if ([iObject isEqualToString: @"UIInterfaceOrientationLandscapeRight"]) {
            UIInterfaceOrientationLandscapeRightSupported = YES;
        }
    }
    
    [[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications]; /* DaCarSoft: start accelerometer notifications on device orientation changes */
    if (SYSTEM_VERSION_LESS_THAN(@"8.0")) // orienation system for iOS5 only
    {   printf("setup old orientation system \n");
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(deviceOrientationChanged:) name:UIDeviceOrientationDidChangeNotification object:nil]; /* DaCarSoft: register the observer that fires the code that controls the orientation changes */
    }
	
    // create bounds // Space Fractal: fix for iOS8 landscape issue
    interfaceOrienation = [[UIApplication sharedApplication] statusBarOrientation];
   
	CGRect bounds = [self boundsForOrientation];
    
	//Create a full-screen window
	window = [[UIWindow alloc] initWithFrame:bounds];
    [window setBackgroundColor:[UIColor blackColor]];
	
	gpGLB_MainWnd = (void*)window;
	
	// ## iPhone View Controller## /* DaCarSoft */
    //Create a view controller to let wrappers and iOS UI elements work in all orientations  /* DaCarSoft */
    iPhoneViewControllerWithRotation = [[iPhoneViewController alloc] init]; /* DaCarSoft */
	if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0"))
	{	[window addSubview:iPhoneViewControllerWithRotation.view];
        gpiPhoneViewControllerWithRotation = iPhoneViewControllerWithRotation;
    	self.window.rootViewController = gpiPhoneViewControllerWithRotation;
        [gpiPhoneViewControllerWithRotation.view setMultipleTouchEnabled: YES];
        gpiPhoneViewControllerWithRotation.view.bounds = bounds;
    }

    
	// ## iCade View ## // removed by now.
    iCadeView = [[iCadeReaderView alloc] initWithFrame:CGRectMake(0, 0, 0, 0)]; /* DaCarSoft: dimensions to "0" to avoid iOS problems */
    [window addSubview:iCadeView];  /* DaCarSoft */
    [iPhoneViewControllerWithRotation.view addSubview:iCadeView]; /* DaCarSoft: link iCadeView to the view controller to let rotate it */
    iCadeView.active = YES;
	//iCadeView.delegate = self;
	gpiCadeView = iCadeView; // store global pointer

	// ## OpenGL View ##
	//Create the OpenGL drawing view and add it to the window
	glView = [[EAGLView alloc] initWithFrame:bounds];
	[glView setMultipleTouchEnabled: YES];
	[window addSubview:glView];
    gpimainView = glView;

	[window makeKeyAndVisible];
    [self startAccelerometerData];

	//Configure and enable the accelerometer
	//[[UIAccelerometer sharedAccelerometer] setUpdateInterval:(1.0 / kAccelerometerFrequency)];
	//[[UIAccelerometer sharedAccelerometer] setDelegate:self];
	
	glView.animationInterval = 1.0 / 60.0; //wie setzt der das, wenn glView=NULL ist?

	iPhonePumpEvents(0);
	[glView startAnimation];
	// iPhoneMain(); bad here

	NSURL *url = [launchOptions objectForKey: UIApplicationLaunchOptionsURLKey];
	if ([url isMemberOfClass: [NSURL class]])
	{
        NSString *URLString; /* DaCarSoft: obtain the argument at app launch in a valid encoding */
        NSData* tmpURLEncoded = [[NSData alloc] init]; /* DaCarSoft */
        tmpURLEncoded = [[url absoluteString] dataUsingEncoding:NSWindowsCP1252StringEncoding allowLossyConversion:YES]; /* DaCarSoft */
        URLString = [[NSString alloc] initWithData:tmpURLEncoded encoding:NSWindowsCP1252StringEncoding]; /* DaCarSoft */
        tmpURLEncoded = nil; /* DaCarSoft */
        
		__glb_set_cmd_line([URLString cStringUsingEncoding:NSWindowsCP1252StringEncoding]); /* DaCarSoft */
		printf("Launch with URL:\n    %s\n", [URLString cStringUsingEncoding:NSWindowsCP1252StringEncoding]); /* DaCarSoft */
	}
printf("slaunch ok\n");


    return YES;
}


-(void)controllerStateChanged { // Space Fractal :: MFI Controller support.
    if ([GCController class])
    {   ismficontrollerconnected=0;
        self.controllerType=0;
        if ([[GCController controllers] count] > 0) {
            self.controllerConnected = YES;
        
            self.gameController = [GCController controllers][0];
            if (self.gameController.extendedGamepad == nil) {
                self.controllerType = 1;
            } else {
                self.controllerType = 2;
            }
            ismficontrollerconnected=self.controllerType;        
            
            self.gameController.controllerPausedHandler = ^(GCController *gameController)
            {
                controlvalues[0]=1;
            };
        } else {
            self.controllerConnected = NO;
        ismficontrollerconnected=0;
            return;
        }
    }
}

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application{

	/* Allocate the remaining amount of free memory, minus 2 megs */
	size_t freem = get_free_memory();
	printf("-applicationDidReceiveMemoryWarning - free mem=%d kB\n", (int)freem/1024 );
/*
	if(freem>2048 && freem<1024*8)
	{
		printf("Trying to free memory\n");
		size_t size = freem - 2048;
		void *allocation = malloc(size);
		memset(allocation, 0, size);
		free(allocation);
	}
*/
   
	if (freem>0 && freem<=512)
		gKillProgramNow = 1;
}



// power button or a CALL!!!
// -> enable GPS!!!
// -> home button 1x
- (void)applicationWillResignActive:(UIApplication *)application {
	printf("-applicationWillResignActive   -> pause\n" );
    [iCadeView resignFirstResponder]; /* DaCarSoft: fix iCade problem when enter to background */
    if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0"))
    {   [iPhoneViewControllerWithRotation.view resignFirstResponder];
    }
	pausedsafe=2;
}


// after a call, maybe?
// when multitasking re-enabled
- (void)applicationDidBecomeActive:(UIApplication *)application {
	printf("-applicationDidBecomeActive    -> unpause\n" );
    [iCadeView becomeFirstResponder]; /* DaCarSoft: fix iCade problem when enter to background */
    if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0"))
    {   [iPhoneViewControllerWithRotation.view becomeFirstResponder];
    }
	static bool first=true;
	if(first)
		first=false;
	else
		pausedsafe=1;
}

// -> start background multitasking (1x home gedrckt)
- (void)applicationDidEnterBackground:(UIApplication *)application
{
	printf("-applicationDidEnterBackground -> pause\n" );
	if(glb_allow_escape())
	{
		gKillProgramNow = 1;
	}
}

// -> start aus Multitasking-Schlaf -> dannach did go active
- (void)applicationWillEnterForeground:(UIApplication *)application
{
	printf("-applicationWillEnterForeground-> do nothing\n" );
    pausedsafe=2;
}


// YIKES - the user pressed the HOME button. Shut down now
- (void)applicationWillTerminate:(UIApplication *)application {
	gKillProgramNow = 1;
    [motionManager stopAccelerometerUpdates];
    motionManager = nil;
	printf("-applicationWillTerminate\n" );
//	__EndProgram(); // OK, shut down
}
- (void)dealloc {
	[window release];
	[glView release];

    gpiPhoneViewControllerWithRotation = NULL; /* DaCarSoft */
    [iPhoneViewControllerWithRotation release]; /* DaCarSoft */
    iPhoneViewControllerWithRotation = nil; /* DaCarSoft */

	// iCade
	gpiCadeView = NULL;
    [iCadeView release];
	iCadeView = nil;

//    [[UIDevice currentDevice] endGeneratingDeviceOrientationNotifications]; /* DaCarSoft: stop accelerometer notifications on device orientation changes */
    [[NSNotificationCenter defaultCenter] removeObserver:self]; /* DaCarSoft: unregister the observer that fires the code that controls the orientation changes */

	[super dealloc];
}


- (void)startAccelerometerData {
    printf("startAccelerometerData\n");
    motionManager = [[CMMotionManager alloc] init];
    motionManager.accelerometerUpdateInterval = 1/60.0;

    [motionManager startAccelerometerUpdatesToQueue:[NSOperationQueue currentQueue]
                                        withHandler:^(CMAccelerometerData *accelerometerData, NSError *error) {	
		gAccX = accelerometerData.acceleration.x;
		gAccY = accelerometerData.acceleration.y;
		gAccZ = accelerometerData.acceleration.z;
    } ];
}


// ***** orig change *********
- (void)deviceOrientationChanged:(NSNotification *)notification { /* DaCarSoft: void to adjust the iOS orientation for the application according to the device orientation */
    if (([[UIDevice currentDevice] orientation] == UIDeviceOrientationPortrait) & (UIInterfaceOrientationPortraitSupported == YES)) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait];
        defaultorientation=0;
        
    }
    if (([[UIDevice currentDevice] orientation] == UIDeviceOrientationLandscapeLeft) & (UIInterfaceOrientationLandscapeRightSupported == YES)) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeRight];
        defaultorientation=1;
    }
    if (([[UIDevice currentDevice] orientation] == UIDeviceOrientationPortraitUpsideDown) & (UIInterfaceOrientationPortraitUpsideDownSupported == YES)) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortraitUpsideDown];
        defaultorientation=2;

    }
    if (([[UIDevice currentDevice] orientation] == UIDeviceOrientationLandscapeRight) & (UIInterfaceOrientationLandscapeLeftSupported == YES)) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeLeft];
        defaultorientation=3;
    }
}

-(CGRect)boundsForOrientation{
	CGSize screenSize = [[UIScreen mainScreen] bounds].size;
	if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0"))
    {
        CGRect bounds = CGRectMake(0, 0, screenSize.width, screenSize.height);
        return bounds;
    }
	else
    {
		screenSize = UIInterfaceOrientationIsPortrait(interfaceOrienation) ? CGSizeMake(screenSize.width, screenSize.height) : screenSize;
        CGRect bounds = CGRectMake(0, 0, screenSize.width, screenSize.height);
        return bounds;
    }
    return CGRectMake(0, 0, screenSize.width, screenSize.height);
}

@end



// EXPORT:
#ifdef __cplusplus
extern "C"
{
#endif




// ----------------------
// iCade / BT keyboard
// ----------------------
unsigned int iPhoneGetICadeInfo()
{
    if(ismficontrollerconnected>0) return 2;
	if(gpiCadeView )
		return (int)gpiCadeView ->_iCadeState;
return 0;
}
int iPhoneIsICadeAttached()
{
    if(ismficontrollerconnected>0) return 1;
	if(gpiCadeView)
		return (int)gpiCadeView ->_iCadeAttached;
return 0;
}

char iPhoneGetInkeyStr()
{
	char c = 0;
	if(gpiCadeView)
	{
		c = gpiCadeView ->_last_character;
		gpiCadeView ->_last_character = 0; // reset after reading
	}
return c;
}


// ----------------------
// TEST ALERT
// ----------------------
void iPhoneAlert()
{
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Really reset?" message:@"Do you really want to reset this game?" delegate:nil cancelButtonTitle:@"Cancel" otherButtonTitles:nil];
    // optional - add more buttons:
    [alert addButtonWithTitle:@"Yes"];
    [alert show];

}


// ----------------------
// ACCELERATIONS
// ----------------------
void iPhoneGetAcceleration(float* x, float* y, float* z)
{
	*x = gAccX;
	*y = gAccY;
	*z = gAccZ;
}


// pump events, act like sleep()
void iPhonePumpEvents(unsigned long milliseconds)
{
#ifdef GLB_IN_A_THREAD
    SInt32 result;
    do 
    {
        result = CFRunLoopRunInMode(kCFRunLoopDefaultMode, 0, TRUE);
    }
    while(result == kCFRunLoopRunHandledSource);
	if(milliseconds)
		htThreadSleep((int)milliseconds);
#else
   
     if(milliseconds==0)
     {
          SInt32 result;
          do 
          {
               result = CFRunLoopRunInMode(kCFRunLoopDefaultMode, 0, TRUE);
          }
          while(result == kCFRunLoopRunHandledSource);
     }
     else
     {
          CFRunLoopRunInMode(kCFRunLoopDefaultMode,(double)(milliseconds)/1000.0, FALSE);
     }
#endif
}

void iPhoneRumble()
{
	AudioServicesPlaySystemSound(kSystemSoundID_Vibrate);
}

int isIphone()
{
    if (SYSTEM_VERSION_LESS_THAN(@"8.0"))return 3;
	NSString *deviceType = [UIDevice currentDevice].model;
	if([deviceType isEqualToString:@"iPhone"])
	{
		return 1;
	}
	if([deviceType isEqualToString:@"iPad"])
	{
		return 2;
	}
return 0;
}


// "2.2.1" e.g.
char gSomePath[1024]="";
const char* iPhoneVersion()
{
	NSString *deviceUDID = [[UIDevice currentDevice] systemVersion];
	strcpy(gSomePath, [deviceUDID UTF8String]);
	return gSomePath;
}

// no longer allowed!
/*
const char* iPhoneDeviceID()
{
	NSString *deviceUDID = [[UIDevice currentDevice] uniqueIdentifier];
	strcpy(gSomePath, [deviceUDID UTF8String]);
	return gSomePath;
}
*/


// 0.0 ... 1.0
float iPhoneBattery()
{
	// OS 3.0b and later!!!
	UIDevice *myDevice = [UIDevice currentDevice];

	[myDevice setBatteryMonitoringEnabled:YES];
	float level = (float)[myDevice batteryLevel];
	if(level<0.0f) level=0.0f;
	if(level>1.0f) level=1.0f;
	[myDevice setBatteryMonitoringEnabled:NO];
	return level;
}

#include <unistd.h>
const char* iPhoneGetExePath()
{
	static char pwd[1024]="";
	NSString *path = [[NSBundle mainBundle] executablePath];
	
	if (path == nil)
	{
		NSString *path = [[NSBundle mainBundle] bundlePath]; // /var/mobile/Applications/B8FA7A79-FB40-4238-A5E8-FDC5BEF716CC/Launcher.app/KaotikTest.bundle
		if(pwd[0]==0) 
		{
			getcwd(pwd, 1023);
		}
		strcpy(gSomePath, [path UTF8String]);

	}
	else
		strcpy(gSomePath, [path UTF8String]);
	return gSomePath;
}

const char* iPhoneGetDocumentsPath()
{
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *path = [paths objectAtIndex:0];
	strcpy(gSomePath, [path UTF8String]);
	return gSomePath;
}


const char* iPhoneGetTempPath()
{	
	NSString *path = NSTemporaryDirectory();
	strcpy(gSomePath, [path UTF8String]);
	return gSomePath;
}

// change the ?id=... according to your app
void iPhoneOpenUrl(const char* pUrl)
{
    NSString *stringFromChar = [[NSString alloc] initWithUTF8String:pUrl];
	NSURL *appStoreUrl = [NSURL URLWithString: stringFromChar];
	[[UIApplication sharedApplication] openURL:appStoreUrl];
}


#include <CoreFoundation/CFLocale.h>
#include <CoreFoundation/CFBase.h>

/* write the country code into the string ptr. ISO 3166 is the relevant source
 * here; see http://www.unicode.org/onlinedat/countries.html for details.
 * Using the 3 character Alpha-3 codes */
void	iPhoneGetCountryInto(char * str)
{
	CFLocaleRef		userLocaleRef;
	CFStringRef		stringRef;
	char			buffer[4];
	userLocaleRef = CFLocaleCopyCurrent();
	stringRef = CFLocaleGetValue(userLocaleRef, kCFLocaleCountryCode);
	CFStringGetCString(stringRef, buffer, 4,kCFStringEncodingMacRoman);	
	memcpy(str,buffer,3);
	CFRelease(userLocaleRef);
}

#import <CoreLocation/CoreLocation.h>
/* GPS - positioning */
CLLocationManager* locman;

// Call this early on:
void iPhoneLocation_Init()
{
	locman = [[CLLocationManager alloc] init];
	locman.delegate = nil;
	locman.distanceFilter =  kCLDistanceFilterNone;
	locman.desiredAccuracy = kCLLocationAccuracyBest;
	// locman.headingFilter = 1.0;
	// locman.headingAvailable = TRUE;
}

int iPhoneLocation_Enable(int enable)
{
  if (enable) {
	if(! [CLLocationManager locationServicesEnabled])
		return 0;
  
    [locman startUpdatingLocation];
	[locman startUpdatingHeading];
  } else {
    [locman stopUpdatingLocation];
	[locman stopUpdatingHeading];
  }
  return 1;
}

float g_iPhoneAccuracy = -1.0;
float iPhoneLocation_Accuracy()
{
	return g_iPhoneAccuracy;
}


int iPhoneLocation_Poll(float* latitude, float* longitude, float* altitude, float* speed, float* heading)
{
	CLLocation* locn = locman.location;
	/*
		... test locn to see if it's valid; you probably want to
		reject it if the timestamp is too old, if it is nil, if the
		horizontalAccuracy is too poor etc ...)
	*/

	if(locn.horizontalAccuracy < 0.0 ) // || locn.horizontalAccuracy>500.0)
	{
		return 0;
	}

	//if(locn.verticalAccuracy < 0.0 ) // || locn.verticalAccuracy>500.0)
	//{
	//	return 0;
	//}

	g_iPhoneAccuracy = locn.horizontalAccuracy; //  + locn.verticalAccuracy) * 0.5; // vertical=altitude!!
	
	NSDate* eventDate = locn.timestamp;
	NSTimeInterval howRecent = fabs([eventDate timeIntervalSinceNow]);

	if (howRecent > 10.0) // > 10 seconds of age is bad
	{
		return 0;
	}
	*latitude  = locn.coordinate.latitude;
	*longitude = locn.coordinate.longitude;
	*altitude  = locn.altitude;
	*speed     = locn.speed;
	*heading   = locn.course;
	return 1;
}

void iPhoneKeepAwake(int bKeepAwake)
{
	if(bKeepAwake)
		[UIApplication sharedApplication].idleTimerDisabled = YES;
	else
		[UIApplication sharedApplication].idleTimerDisabled = NO;
}

int iPhonePausemode() {
    int rt=pausedsafe;
        pausedsafe=0;
    return rt;
}

int iPhoneSETORIENTATION(int orig) {
	if(orig==-1) {
		if (SYSTEM_VERSION_LESS_THAN(@"8.0"))
        {   return defaultorientation;
        }
        return 0;
	}
		
    if(orig==0) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait];
        if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0")) {
			[[UIDevice currentDevice] setValue:[NSNumber numberWithInteger:UIInterfaceOrientationPortraitUpsideDown] forKey:@"orientation"];
        }
    }
    
	if(orig==1) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeRight];
        if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0")) {
			[[UIDevice currentDevice] setValue:[NSNumber numberWithInteger:UIDeviceOrientationLandscapeLeft] forKey:@"orientation"];
        }
    }
    
	if(orig==2) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortraitUpsideDown];
        if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0")) {
			[[UIDevice currentDevice] setValue:[NSNumber numberWithInteger:UIDeviceOrientationPortrait] forKey:@"orientation"];
        }
    }
    
    if(orig==3) {
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeLeft];
        if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0")) {
			[[UIDevice currentDevice] setValue:[NSNumber numberWithInteger:UIDeviceOrientationLandscapeRight] forKey:@"orientation"];
        }
    }
    return orig;
}

void iPhoneGetMouseData(int iMouse, int* x, int* y, int* button)
{
    iPhonePumpEvents(0); /* mousewait hangs, else */
    if(!gpimainView)
    {
        *button=0;
        return;
    }
        
#ifdef GLB_IN_A_THREAD
    if(htMutexLock(&gMainMutex)==0)
#endif
    {
        if(SYSTEM_VERSION_LESS_THAN(@"8.0"))
        {   struct GLBMOUSE* pM = &gpimainView->mice[iMouse];
            //int width=(int)gpimainView.bounds.size.width;
            //int height=(int)gpimainView.bounds.size.height;
            //if (defaultorientation==0) { *x = pM->x; *y = pM->y; }
            //if (defaultorientation==1) { *x = pM->y; *y = pM->x; *y=width-*y; }
            //if (defaultorientation==2) { *x = pM->x; *y = pM->y; *x=width-*x; *y=height-*y; }
            //if (defaultorientation==3) { *x = pM->y; *y = pM->x; *x=height-*x; }
            *x = pM->x; *y = pM->y;
            *button = pM->button;
        }


        if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0"))
        {   struct GLBMOUSEVIEW* pM = &gpiPhoneViewControllerWithRotation->mice[iMouse];
            *x = pM->x;
            *y = pM->y;
            *button = pM->button;
        }
        
#ifdef GLB_IN_A_THREAD
        htMutexUnlock(&gMainMutex);
#endif
    }
}

#define CSCRYPT_MAX_LEN 64
#define CRYPT(name, str) char c_ ##name[] = { csCRYPT32_(str "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0") }; \
							typedef struct {int constraint_ ##name: ((sizeof(str)/sizeof(c_ ##name[0]))<=CSCRYPT_MAX_LEN) ? 1 : -1024;}  \
							                    constraint_ ##name[ ((sizeof(str)/sizeof(c_ ##name[0]))<=CSCRYPT_MAX_LEN) ? 1 : -1024 ]; \
							csUNCRYPT((char*) c_ ##name ); const char* name = c_ ##name;
#define csCRYPT32_(str) (str)[ 0]^0x55,   (str)[ 1]^0x56,   (str)[ 2]^0x55,   (str)[ 3]^0x56,   (str)[ 4]^0x55,   (str)[ 5]^0x56,   (str)[ 6]^0x55,   (str)[ 7]^0x56,   (str)[ 8]^0x55,   (str)[ 9]^0x56,   (str)[10]^0x55,   (str)[11]^0x56,\
						(str)[12]^0x55,   (str)[13]^0x56,   (str)[14]^0x55,   (str)[15]^0x56,   (str)[16]^0x55,   (str)[17]^0x56,   (str)[18]^0x55,   (str)[19]^0x56,   (str)[20]^0x55,   (str)[21]^0x56,   (str)[22]^0x55,   (str)[25]^0x56,\
						(str)[26]^0x55,   (str)[27]^0x56,   (str)[28]^0x55,   (str)[29]^0x56,   (str)[30]^0x55,   (str)[31]^0x56,   (str)[32+ 0]^0x55,(str)[32+ 1]^0x56,(str)[32+ 2]^0x55,(str)[32+ 3]^0x56,(str)[32+ 4]^0x55,(str)[32+ 5]^0x56,\
						(str)[32+ 6]^0x55,(str)[32+ 7]^0x56,(str)[32+ 8]^0x55,(str)[32+ 9]^0x56,(str)[32+10]^0x55,(str)[32+11]^0x56,(str)[32+12]^0x55,(str)[32+13]^0x56,(str)[32+14]^0x55,(str)[32+15]^0x56,(str)[32+16]^0x55,(str)[32+17]^0x56,\
						(str)[32+18]^0x55,(str)[32+19]^0x56,(str)[32+20]^0x55,(str)[32+21]^0x56,(str)[32+22]^0x55,(str)[32+25]^0x56,(str)[32+26]^0x55,(str)[32+27]^0x56,(str)[32+28]^0x55,(str)[32+29]^0x56,(str)[32+30]^0x55,(str)[32+31]^0x56,\
						'\0'
void csUNCRYPT(char* pstr) {int cm=0;do{ *pstr^=(0x55 + (cm++ % 2));}while(*pstr++);}


int iPhoneIsCracked()
{
	NSDictionary* info = [[NSBundle mainBundle] infoDictionary];
	CRYPT(csSigident, "SignerIdentity"); // const char* csSigident="SignerIdentity";

	NSString* csIdent = [[NSString alloc]initWithUTF8String:csSigident];
	if([info objectForKey: csIdent] == nil)
	{
		return 0;
	}
// app is pirated
return 1;
}

#ifdef __cplusplus
} // extern "C" 
#endif


#import "MediaPlayer/MediaPlayer.h"

/*
void iPhonePlayMovie(const char* pMoviePath)
{
	NSString* thePath = [NSString stringWithCString:pMoviePath length:strlen(pMoviePath)];;

	MPMoviePlayerController *theMovie = [[MPMoviePlayerController alloc]initWithContentURL:[NSURL fileURLWithPath:thePath]];
	theMovie.scalingMode = MPMovieScalingModeAspectFill;

//	theMovie.movieControlMode = MPMovieControlModeHidden;

	[theMovie play];
}
*/

int iPhone_MovieEnded = 0;	




@interface PlayMovie : NSObject {
int ended;
}
-(void)movieEnd:(NSNotification*)theNotification;
-(void)initMovie:(NSString*)thePath;
@end


@implementation PlayMovie


-(void)initMovie:(NSString*)thePath {    
		
	//NSString *thePath = [[NSBundle mainBundle]pathForResource:@"movie" ofType:@"m4v"];
	
	MPMoviePlayerController* theMovie = [[MPMoviePlayerController alloc]initWithContentURL:[NSURL fileURLWithPath:thePath]];
	theMovie.scalingMode = MPMovieScalingModeFill;
	
//	theMovie.movieControlMode = MPMovieControlModeHidden;
	
	[[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(movieEnd:) name: MPMoviePlayerPlaybackDidFinishNotification object:theMovie];
	[theMovie play];
	
}

-(void)movieEnd:(NSNotification*)theNotification {
	MPMoviePlayerController* theMovie = [theNotification object];
	[[NSNotificationCenter defaultCenter]removeObserver:self name:MPMoviePlayerPlaybackDidFinishNotification object:theMovie];
	[theMovie release];
	iPhone_MovieEnded = 1;
}
@end


#ifdef __cplusplus
extern "C"
{
#endif

void iPhonePlayMovie(const char* file) {
	iPhone_MovieEnded=0;
	NSString* pathToMovie = [[NSString alloc]initWithUTF8String:file];
	
	PlayMovie* myVideo = [[PlayMovie alloc]init];
	[myVideo initMovie:pathToMovie];

	while(!iPhone_MovieEnded)
	{
		iPhonePumpEvents(20);
	}
}

#ifdef __cplusplus
} // extern "C" 
#endif

// mfi game controller support // Space Fractal
#ifdef __cplusplus
extern "C"
{
#endif
    int iOSVersion() {
        if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"5.0")) return 5;
        if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"6.0")) return 6;
        if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0")) return 7;
        if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"8.0")) return 8;
        return 0;
        
    }
    
    int controllerconnected() {
        if (ismficontrollerconnected>0) return ismficontrollerconnected+1;
        return (int)iPhoneIsICadeAttached();
    }
    
    void setgamecontrollerfloat(int button, float value)
    {   if(button>-1 && button<32)
        { controlvalues[button]=value;
        }
        
    }
    
    float getgamecontrollerfloat(int button) {
        if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0"))  {
            if(button==-1)  {
                AppController* iOSAppDelegate = (AppController*)[[UIApplication sharedApplication] delegate];
                GCController *myController=[iOSAppDelegate gameController];
                myController.playerIndex=0;
                return 0;
            }
        }
        if (button<0 || button>31) return 0;
        return controlvalues[button];
        
    }
    
    int updateiosgamecontroller() {
        if (SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0"))  {
            if (ismficontrollerconnected>0) {
                AppController* iOSAppDelegate = (AppController*)[[UIApplication sharedApplication] delegate];
                if([iOSAppDelegate controllerConnected] == 1) {
                    if ([iOSAppDelegate controllerType] == 1 ) {
                        GCController *myController=[iOSAppDelegate gameController];
                        GCGamepad *profile = myController.gamepad;
                        if(profile.dpad.left.isPressed)       {  controlvalues[1]=1; }  else  {  controlvalues[1]=0; }
                        if(profile.dpad.right.isPressed)      {  controlvalues[2]=1; }   else {  controlvalues[2]=0; }
                        if(profile.dpad.up.isPressed)         {  controlvalues[3]=1; }  else  {  controlvalues[3]=0; }
                        if(profile.dpad.down.isPressed)       {  controlvalues[4]=1; }   else {  controlvalues[4]=0; }
                        if(profile.buttonA.isPressed)         {  controlvalues[5]=1; }   else {  controlvalues[5]=0; }
                        if(profile.buttonB.isPressed)         {  controlvalues[6]=1; }   else {  controlvalues[6]=0; }
                        if(profile.buttonX.isPressed)         {  controlvalues[7]=1; }   else {  controlvalues[7]=0; }
                        if(profile.buttonY.isPressed)         {  controlvalues[8]=1; }   else {  controlvalues[8]=0; }
                        if(profile.leftShoulder.isPressed)    {  controlvalues[9]=1; }   else {  controlvalues[9]=0; }
                        if(profile.rightShoulder.isPressed)   {  controlvalues[10]=1; }  else {  controlvalues[10]=0; }
                    }

                    if ([iOSAppDelegate controllerType] == 2) {
                        GCController *myController=[iOSAppDelegate gameController];
                        GCExtendedGamepad *profile = myController.extendedGamepad;
                        controlvalues[1]=profile.dpad.left.value;
                        controlvalues[2]=profile.dpad.right.value;
                        controlvalues[3]=profile.dpad.up.value;
                        controlvalues[4]=profile.dpad.down.value;
                        controlvalues[5]=profile.buttonA.value;
                        controlvalues[6]=profile.buttonB.value;
                        controlvalues[7]=profile.buttonX.value;
                       controlvalues[8]=profile.buttonY.value;
                        controlvalues[9]=profile.leftShoulder.value;
                        controlvalues[10]=profile.rightShoulder.value;
                        controlvalues[11]=profile.leftTrigger.value;
                        controlvalues[12]=profile.rightTrigger.value;
                        controlvalues[13]=profile.leftThumbstick.left.value;
                        controlvalues[14]=profile.leftThumbstick.right.value;
                        controlvalues[15]=profile.leftThumbstick.up.value;
                        controlvalues[16]=profile.leftThumbstick.down.value;
                        controlvalues[17]=profile.rightThumbstick.left.value;
                        controlvalues[18]=profile.rightThumbstick.right.value;
                        controlvalues[19]=profile.rightThumbstick.up.value;
                        controlvalues[20]=profile.rightThumbstick.down.value;
                    }
                }
            }
        }
        return ismficontrollerconnected;
    }

#ifdef __cplusplus
} // extern "C"
#endif

// insert GameCenter here



#if 0 /////////////////



	#import <GameKit/GameKit.h>

	@interface GLB_Game_Center : NSObject {
		int playerID;
		int isLoggedIn;
		NSString *userName;
		GKPlayer *myPlayer;
	}
	@property (nonatomic, retain) NSString *userName;

	- (void)_glb_gamecenter_init;
	- (void)_glb_gamecenter_setplayer:(NSString*)strName;
	- (NSString*)_glb_gamecenter_getplayer:(int)id;
	- (int)_glb_gamecenter_getnumberoffriends;
	- (int)_glb_gamecenter_login;
	- (int)_glb_gamecenter_logout;

	@end


	@implementation GLB_Game_Center

	@synthesize userName;

	- (void)_glb_gamecenter_init {
		GKPlayer *newPlayer = [[GKPlayer alloc]init];
		NSString *userName = [[NSString alloc]init];
		playerID = 0;
		isLoggedIn = 0;
		
		playerID = [[newPlayer playerID]intValue];
		
		if(!playerID) {
			NSLog(@"Init failed");
			return;
		}
		
		isLoggedIn = 1;
	}

	- (void)_glb_gamecenter_setplayer:(NSString*)strName {
		if(isLoggedIn) {
			GKPlayer *tmpPlayer = (GKPlayer*)myPlayer;
			// <---- todo with 4.1 GoldenMaster
		}
	}
	- (NSString*)_glb_gamecenter_getplayer:(int)id { return @"";}
	- (int)_glb_gamecenter_getnumberoffriends { return 0;}
	- (int)_glb_gamecenter_login { return 0;}
	- (int)_glb_gamecenter_logout { return 0;}

	@end
#endif

