/*
File: EAGLView.h
*/

#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import <UIKit/UIEvent.h>
#import <UIKit/UITouch.h>

#define MAX_SIMULTANEOUS_TOUCHES	(5)


// in a thread? YES, WANT THAT!
//#define GLB_IN_A_THREAD


#ifdef GLB_IN_A_THREAD
	#include "hawkthreads.h"
#endif



// EXPORTS:
#ifdef __cplusplus
extern "C"
{
#endif
	int  iPhoneGetMaxMice();
	void iPhoneSwapBuffers();
#ifdef __cplusplus
} // extern "C"
#endif

extern char** gpArgv;
extern int    gArgc;

//CLASSES:

@interface EAGLView : UIView {
    
@private
    UIView                  *mouseView;
    /* The pixel dimensions of the backbuffer */
    GLint backingWidth;
    GLint backingHeight;
    
    EAGLContext *context;
    
    /* OpenGL names for the renderbuffer and framebuffers used to render to this view */
    GLuint viewRenderbuffer, viewFramebuffer;
    
    /* OpenGL name for the depth buffer that is attached to viewFramebuffer, if it exists (0 if it does not exist) */
    GLuint depthRenderbuffer;
    
    NSTimer *animationTimer;
    NSTimeInterval animationInterval;



@public
    int touchactive;
	struct GLBMOUSE
	{
		void* driverdata;
		int id;
		int x,y,button, dx,dy;
	} mice[MAX_SIMULTANEOUS_TOUCHES];

}

@property NSTimeInterval animationInterval;
@property (nonatomic) CGPoint center;

- (id) initWithFrame:(CGRect)frame; //These also set the current context
- (id) initWithFrame:(CGRect)frame pixelFormat:(GLuint)format;
- (id) initWithFrame:(CGRect)frame pixelFormat:(GLuint)format depthFormat:(GLuint)depth preserveBackbuffer:(BOOL)retained;

- (void)startAnimation;
/* - (void)stopAnimation; */
/* - (void)drawView; */
- (void)swapBuffers;
- (void)setActive:(BOOL)value;
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event;
@end
