#ifndef INC_PBUFFERS_H
#define INC_PBUFFERS_H


class FBUFFER
{
public:
	FBUFFER() : m_Width(0),
				m_Height(0),
				m_SpriteIndex(-1)
				#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
					,m_frameBuffer(0),
					m_depthRenderBuffer(0),
					m_oldframeBuffer(-1)
				#endif
				{ }
	~FBUFFER() {Clear();}
	static void InitFrameBufferObject();
	static int  GetActiveFrameBuffer(); // see if we're rendering to a FBO currently
	static int  GetActiveFrameBufferTexture(); // get texture id0 of currently bound fbo

	// Create PBuffer Object - make sure it's 2^n x 2^m size you request
	bool Create(int w, int h, unsigned int texture, bool bDepthBuffer); // create+bind texture. TEXTURE MUST EXIST!
	bool Bind(); // bind fbo
	bool Unbind(); // unbind fbo - replace with pre-start target
	void Clear();
private:
	#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
		GLuint m_frameBuffer;
		GLuint m_depthRenderBuffer;
		GLint  m_oldframeBuffer;  // restore this at StopRendering(). -1: not within start/stoprendering
	#endif

public:
    int    m_Width; // ==0 -> invalid
    int    m_Height;
	int    m_SpriteIndex; // sprite (not texture) store for external use
};

#endif // INC_PBUFFERS_H
