
#ifndef _TRENKI3D_H_INC_
#define _TRENKI3D_H_INC_


#define GL_NONE     0
#define GL_FRONT	0x0404
#define GL_BACK		0x0405

#define GL_TRIANGLES		0x0004
#define GL_TRIANGLE_STRIP	0x0005
#define GL_TRIANGLE_FAN		0x0006



// glWRAPPERS
void tglInit(unsigned short* pPix, unsigned short* pZBuf, unsigned int width);
void tglSetBuffers(unsigned short* pPix, unsigned short* pZBuf, int buffer_w);
void tglEnableDepthTest(int ok);
int  tglIsEnabledDepthTest();
void tglViewport(int x, int y, int w, int h);
void tglCullFace(int mode);

void tglSetCookieColor(unsigned short packed_color, bool do_check);
void tglLookAt(float eyex, float eyey, float eyez, float centerx, float centery, float centerz, float upx, float upy, float upz);
void tglOrtho(int l, int r, int b, int t, float n, float f);
void tglLoadIdentity();

void tglFrustum(float l, float r, float b, float t, float n, float f);
void tgluPerspective(float fov, float aspect, float zNear, float zFar);
void tglPushMatrix();
void tglPopMatrix();
void tglMultMatrixf(float* mat);
void tglBindTexture(unsigned short* pTex, int width, int height);

// draw an array of vertices
// float {x,y,[z], u,v} [unsigned char {r,g,b[,a] }] // hasXXX to remove [], UseXX to ignore them (but must store), rgba is unsigned char!!
void tglDrawArraysXYZ_UV_RGBA(const int type, const int count, const float* pData, const int hasZ, const int hasNormal, const int UseUV, const int UseRGBA, const int hasRGBA);
void tglSetAlphaFunc(	void (*BlendFunc)(unsigned short* pdest, unsigned short src) ); // enable alpha blending

// dummy display lists
int tglGenLists(int size);
void tglNewList(int iList);
void tglEndList();
void tglCallLists(int iFirst, int count);


// GP2X Memory wrappers
void  gl_free(void *p);
void* gl_malloc(int size);
void* gl_zalloc(int size);

#endif


