#pragma once
#ifndef STDAFX_H_INC
#define STDAFX_H_INC
#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS

	#define WANT_SHOEBOX
	#define EXCLUDE_SHOEBOX_PACKING

	#define BLOWFISH_ALLOW_ENCODE // allow encoding


// platform specific stuff
#ifdef WIN32
	#define WIN32_ONLY(a) a
#else
	#define WIN32_ONLY(a) {}
#endif

#ifdef LINUX
	#if !defined( POSIX )
		#error Must defines POSIX, too
	#endif
#endif

#ifdef MACOSX
#endif

#ifdef GP2X
#endif

#ifdef GPHWIZ
#endif

#ifdef CAANOO
#endif

#ifdef TARGET_OS_IPHONE
    #define IPHONE
    #define HAVE_OPENGL_ES
    #define POSIX
	#define APPLE_COREAUDIO
    #undef WIN32
#endif

#ifdef EMSCRIPTEN
	#include "emscripten_fix.h"
#endif

#ifdef PANDORA
	#define GLREAD_POWER_OF_2 // crashes on glReadPixels with non power of 2 size
#endif

#ifdef PALM_WEBOS
	#define GLREAD_POWER_OF_2 // crashes on glReadPixels with non power of 2 size
#endif

#ifdef PALM_PIXI
//	#define GLREAD_POWER_OF_2 // crashes on glReadPixels with non power of 2 size
#endif

#ifdef ANDROID
//	#define GLREAD_POWER_OF_2 // crashes on glReadPixels with non power of 2 size
#endif

#ifdef USESTEAM
	#pragma comment(lib, "../steam/redistributable_bin/steam_api.lib")
	#include "../steam/steam_api.h"
//	#include "../steam/isteamuserstats.h"
//	#include "../steam/isteamremotestorage.h"
#endif




//#if defined(WANT_SDL) && !defined(WANT_SDL_MIXER) && !defined(WANT_NOSOUND) 
//	#define WANT_SDL_MIXER
//#endif

	#ifdef TRENKI3D
		#include "trenki3d.h"
	#endif

#ifdef POCKETPC
	#define WIN32_LEAN_AND_MEAN
	#include <windows.h>
	#include <windef.h>
	#ifndef TRENKI3D
	#include <GL/gl.h>
	#include <GL/glext.h>
	#endif
#else // Not POCKETPC
	#ifdef WANT_SDL
		// #define GL_GLEXT_PROTOTYPES
		#define NO_SDL_GLEXT
		#include <SDL/SDL.h>
		#if defined(HAVE_OPENGL)
			#include <SDL/SDL_opengl.h>
		#endif
	#endif

	#ifdef WIN32
		#ifndef WINVER
		#define WINVER 0x0600 // Vista and above
		#endif
			#define WIN32_LEAN_AND_MEAN
			#include <windows.h>
			#include <commdlg.h>
		#if defined(HAVE_OPENGL) || (defined(HAVE_OPENGL_ES) && defined(_DEBUG))
			#include <GL/gl.h>
			#include <GL/glext.h>
		#endif
		#if defined(HAVE_OPENGL_ES) && !defined(WIN32)
			#include <OpenGLES/egl.h>
		#endif
	#else // WANT_SDL
		#if defined(HAVE_OPENGL)
			#include <GL/gl.h>
			#include <GL/glext.h>
		#endif
		
		#ifdef HAVE_OPENGL_ES
			#if defined(GPHWIZ)
				#include <OpenGLES/egl.h>
			#elif defined(TARGET_OS_IPHONE)
				#include <OpenGLES/ES1/gl.h>
				#include <OpenGLES/ES1/glext.h>
			#elif defined(PALM_WEBOS) || defined(ANDROID)
				#define GL_GLEXT_PROTOTYPES
				#include <GLES/gl.h>
				#include <GLES/glext.h>
			#elif defined(PANDORA) || defined(RASPBERRY_PI)
				#include <EGL/egl.h>
				#include <GLES/gl.h>
				#define GL_GLEXT_PROTOTYPES
				#include <GLES/glext.h>
			#elif defined(EMSCRIPTEN)
				#define GL_GLEXT_PROTOTYPES
				#include <GL/gl.h>
				#include <GL/glext.h>
			#elif defined( WANT_SDL )
				#include <SDL/SDL.h>
				#ifndef PANDORA
					#include <SDL/SDL_opengles.h>
				#endif
			#else
				#include <OpenGLES/egl.h>
			#endif
		#endif
		
		#include <stdio.h>
		#include <sys/time.h>

		#ifndef DIK_ESCAPE
		#define DIK_ESCAPE 1
		#endif
		
		struct RECT
		{
			int left, right, top, bottom;
		};

		#ifndef DECLARE_HANDLE // Might be Linux or Mac
			#ifndef NULL
				#define NULL (0L)
			#endif
			#define DWORD	unsigned long
			#define LPWSTR	short*
			#define LPCWSTR	const short*
			typedef const char* LPCTSTR;
			typedef char* LPSTR;
			typedef unsigned char   BYTE;
			typedef unsigned short  WORD;
			typedef long		LONG;
			#define TRUE	1
			#define	FALSE	0
			typedef DWORD   COLORREF;
			// #define RGB(r,g,b)          ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))
			#ifndef MAX_PATH
			#define MAX_PATH 260
			#endif
			typedef int BOOL;
			
			// Must be compatible to glb.h
			typedef void* HANDLE;
			#define DECLARE_HANDLE(name) typedef struct name##__{int i;}*name
			DECLARE_HANDLE(HINSTANCE);
			DECLARE_HANDLE(HWND);
		#endif

		#ifndef WIN32
			// #pragma pack(2) // was 2 on PocketPC!?
			// packing crashes for read on android -> don't pack, but save each member individually to files!
			typedef struct tagBITMAPINFOHEADER{
			DWORD  biSize;
			LONG   biWidth;
			LONG   biHeight;
			WORD   biPlanes;
			WORD   biBitCount;
			DWORD  biCompression;
			DWORD  biSizeImage;
			LONG   biXPelsPerMeter;
			LONG   biYPelsPerMeter;
			DWORD  biClrUsed;
			DWORD  biClrImportant;
			} BITMAPINFOHEADER, *PBITMAPINFOHEADER;

			typedef struct tagBITMAPFILEHEADER {
			WORD    bfType;
			DWORD   bfSize;
			WORD    bfReserved1;
			WORD    bfReserved2;
			DWORD   bfOffBits;
			} BITMAPFILEHEADER, *PBITMAPFILEHEADER;

			typedef struct tagRGBQUAD {
			BYTE    rgbBlue;
			BYTE    rgbGreen;
			BYTE    rgbRed;
			BYTE    rgbReserved;
			} RGBQUAD;
			// #pragma pack()

			typedef struct tagBITMAPINFO {
			BITMAPINFOHEADER bmiHeader;
			RGBQUAD          bmiColors[1];
			} BITMAPINFO, *PBITMAPINFO;
			#define BI_RGB 0L
			#define BI_RLE8 1L
			#define BI_RLE4 2L
			#define GetRValue(rb) ((BYTE)(rb))
			#define GetGValue(rb) ((BYTE)(((WORD)(rb))>>8))
			#define GetBValue(rb) ((BYTE)((rb)>>16))
			#define RGB(r,g,b)    ((COLORREF)((BYTE)(r)|((BYTE)(g)<<8)|((BYTE)(b)<<16)))
		#endif
	#endif // !WANT_SDL

	#include "gffilesystem.h"
	#include "math.h"

#endif // POCKETPC

#ifdef _DEBUG
// #define GF_WANT_DEBUG_NEW
#endif



	#ifndef GF_WANT_DEBUG_NEW
		#ifdef _MSC_VER
			#define _CRTDBG_MAP_ALLOC
			#include <stdlib.h>
			#include <crtdbg.h>

			#ifdef _DEBUG
			   #ifndef DBG_NEW
				  #define DBG_NEW new ( _NORMAL_BLOCK , __FILE__ , __LINE__ )
				  #define new DBG_NEW
				  #define MSVC_DEBUG_NEW_USED
			   #endif
			#endif  // _DEBUG
		#endif
	#endif

	#if defined(_DEBUG) && defined(GF_WANT_DEBUG_NEW)
		#define DEBUG_NEW new(__FILE__, __LINE__)
		#define new DEBUG_NEW
		#define GF_DEBUG_NEW

		#include <map>

		#ifndef WIN32
			#define OutputDebugString sprintf
		#endif
		struct ALLOC_INFO
		{
			public:
			ALLOC_INFO():size(0), line(0) {}
			ALLOC_INFO(const ALLOC_INFO& i){*this=i;}
			const ALLOC_INFO& operator=(const ALLOC_INFO& i){size=i.size; file=i.file; line=i.line;return *this;}
			DWORD	size;
			std::string	file;
			DWORD	line;
		};

		typedef std::map<void*, ALLOC_INFO>AllocList;
		extern AllocList allocList; // glb.cpp
		inline void __debug_new_AddTrack(void* addr,  DWORD asize,  const char *fname, DWORD lnum)
		{
			ALLOC_INFO info;
			info.file = fname;
			info.line = lnum;
			info.size = asize;
			allocList[addr] = info;
	//		char buf[1024];
	//			sprintf(buf, "%-70s(%d) : \t\tADDRESS 0x%p\t%d allocated\n",
	//				info.file, info.line, addr, lnum);
	//		OutputDebugString(buf);
		};

		inline void __debug_new_RemoveTrack(void* addr)
		{
			AllocList::iterator i = allocList.find(addr);
			if(i!=allocList.end())
				allocList.erase(i);
			else
			{
				char buf[1024];
				sprintf(buf, "free unknown at: %p\n", addr);
				OutputDebugString(buf);
			}	
		};

		inline void __debug_new_DumpUnfreed()
		{
			char buf[1024];
			sprintf(buf, "-------- MEMORY LEAKS? ------------------\n");
			OutputDebugString(buf);
			AllocList::iterator i;
			DWORD totalSize = 0;
			for(i = allocList.begin(); i != allocList.end(); i++) {
				sprintf(buf, "%-70s(%d) : \t\tADDRESS 0x%p\t%d unfreed\n",
					i->second.file.c_str(), i->second.line, i->first, i->second.size);
				OutputDebugString(buf);
				totalSize += i->second.size;
			}
			sprintf(buf, "-----------------------------------------------------------\n");
			OutputDebugString(buf);
			sprintf(buf, "Total Unfreed: %d bytes\n", totalSize);
			OutputDebugString(buf);
		};
	

		static void * __cdecl operator new(unsigned int size, const char *file, int line)
		{
			void *ptr = malloc(size);
			__debug_new_AddTrack(ptr, size, file, line);
			return(ptr);
		};
		static void * __cdecl operator new[](unsigned int size, const char *file, int line)
		{
			void *ptr = malloc(size);
			__debug_new_AddTrack(ptr, size, file, line);
			return(ptr);
		};
		static void __cdecl operator delete(void *p, const char *file, int line)
		{
			__debug_new_RemoveTrack(p);
			free(p);
		};
		static void __cdecl operator delete[](void *p, const char *file, int line)
		{
			__debug_new_RemoveTrack(p);
			free(p);
		};

/*
		#ifdef  __cplusplus
		extern "C" {
		#endif
			static void* __cdecl gf_malloc(size_t sz, const char* func)				{return (void*)(operator new((unsigned int)sz, func, 0));}
			static void* __cdecl gf_calloc(size_t sz, size_t s2, const char* func)	{sz*=s2; void* p = (operator new((unsigned int)sz, func, 0)); memset(p, 0, sz); return p;}
			static void* __cdecl gf_realloc(void* p, size_t sz, const char* func)	{void* pc=(operator new((unsigned int)sz, func, 0)); memcpy(pc, p, sz); delete[] p; p=pc; return pc;}
			static void  __cdecl gf_free(void* p, const char* func)					{operator delete(p, func, 0);}
		#ifdef  __cplusplus
		}
		#endif

		#define malloc(a) gf_malloc(a,__FUNCTION__)
		#define calloc(a) gf_calloc(a,__FUNCTION__)
		#define realloc(a,b) gf_realloc(a,b,__FUNCTION__)
		#define free(a) gf_free(a,__FUNCTION__)
*/
	#endif


	// g_trace
	#if defined(_DEBUG) && !defined(UNICODE)
		#include <stdio.h>
		#include <stdarg.h>
		inline void g_trace(const char* lpszFormat, ...)
		{
			static char tmp[2048];
			va_list	argptr;
			va_start(argptr, lpszFormat);
			::vsprintf(tmp, lpszFormat, argptr);
			va_end(argptr);
			::OutputDebugString(tmp);
		}
	#else
		inline void g_trace(...) {}
	#endif
	
	// min/max
	#ifndef min
	#define min(a,b) ((a)<(b) ? (a) : (b))
	#endif
	#ifndef max
	#define max(a,b) ((a)>(b) ? (a) : (b))
	#endif


#define DEBUG_POS() printf("@%s, %d\n", __FILE__, __LINE__);

#ifdef _DEBUG
//#include "vld.h"
#endif


#endif // STDAFX_H_INC


