#define HAVE_OPENGL
#define _WINDOWS_
#define NDEBUG
// Implementation of GLBasic commands
#include "stdafx.h" // #include "stdafx.h"
#include <time.h>
#include <locale.h>
#include <ctype.h>
#include <wchar.h>

#ifdef _WIN32_WCE
#define UNICODE_ONLY
#include <sys/wcebase.h>
#include <windows.h>
#define WINSHELLAPI
#include <shellapi.h> // ShellExecuteEx
#elif defined (WIN32)
#ifndef _WIN32_IE
#define _WIN32_IE 0x0400
#endif
#include <shlobj.h> // SHGetSpecialFolderPath
#include <shellapi.h> // ShellExecuteEx
#endif

#ifndef GLB_CONSOLE
#include "openglrainbows.h" // #include "openglrainbows.h"
#include "rainbows3d.h" // #include "rainbows3d.h"

// PLATFORMINFO - requires F200 touchscreen knowledge
#ifdef GP2X
#include "dxinput.h" // #include "dxinput.h"
namespace __GLBASIC__
{
extern DXInput*		pDXin;
};
#endif
#else
#ifndef WIN32
// get console size
#include <sys/ioctl.h>
#include <stdio.h>
#endif
#endif


#ifdef WANT_SHOEBOX
#include "gfshoebox.h" // #include "gfshoebox.h"
extern GFShoeBox *__g_ShoeBox_Data;
extern GFShoeBox *__g_ShoeBox_Media;
#endif

#ifndef WANT_SDL
#ifdef WIN32
#ifndef POCKETPC
#define VC_EXTRALEAN
#define _NO_OLDNAMES // Allow _yn() but not yn() in Math.h
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Video playback
#ifndef GLB_CONSOLE
#define NOMMREG
#define NOMSACM
#include <vfw.h>
#pragma comment(lib, "VFW32.lib")
#endif
#define strlen	lstrlen // winAPI instead of stdlib
#endif
#endif
#else
#ifndef GLB_CONSOLE
//	#include <process.h> // system() -> stdio.h / stdlib.h??
#pragma comment (lib, "SDL.lib")
#pragma comment (lib, "SDL_mixer.lib")
#pragma comment (lib, "SDLmain.lib")
//	#pragma comment (lib, "mikmod.lib")
//	#pragma comment (lib, "native_midi.lib")
//	#pragma comment (lib, "ogg_static.lib")
//	#pragma comment (lib, "timidity.lib")
//	#pragma comment (lib, "vorbis_static.lib")
//	#pragma comment (lib, "vorbisfile_static.lib")
#endif
#include <SDL/SDL.h>
#endif
#ifdef WANT_SDL_MIXER
#ifndef GLB_CONSOLE
#pragma comment (lib, "SDL_mixer.lib")
#endif
#endif


#include <math.h>
#include "gfshoebox.h" // #include "gfshoebox.h"
#include "gffilesystem.h" // #include "gffilesystem.h"
#include "gfqueue.h" // #include "gfqueue.h"

// #include "gfrand.h"
extern void GFsrand(unsigned long any_number);
extern unsigned long GFrand();

// Networking
#include "network/clientserver.h" // #include "network/clientserver.h"

// Path finding:
#include "pathfinding/astarplanner.h" // #include "pathfinding/astarplanner.h"
/*
#include "pathfinding/bestplanner.h" // #include "pathfinding/bestplanner.h"
#include "pathfinding/dijkstraplanner.h" // #include "pathfinding/dijkstraplanner.h"
#include "pathfinding/breadthplanner.h" // #include "pathfinding/breadthplanner.h"
*/

#include "glb.h" // #include "glb.h"
#ifndef GLB_CONSOLE
#include "glb3d.h" // #include "glb3d.h"
#endif
#include "gfini.h" // #include "gfini.h"
#include "3dmath.h" // #include "3dmath.h"
#include "blowfish.h" // #include "blowfish.h"

#ifdef WIN32
#ifdef POCKETPC
extern char* gcvt(double,int,char *);
#define _gcvt gcvt

inline char* _itoa(int value, char *buffer, int /*radix = 10 */)
{
char tmp[33];
char *tp = tmp;
int i;
unsigned v;
int sign;
char *sp;

sign = (value < 0);
if (sign)
v = -value;
else
v = (unsigned)value;
while (v || tp == tmp)
{
i = v % 10;
v = v / 10;
// if (i < 10)
*tp++ = i+'0';
// else *tp++ = i + 'a' - 10;
}
sp = buffer;

if (sign)
*sp++ = '-';
while (tp > tmp)
*sp++ = *--tp;
*sp = 0;
return buffer;
}

#else // WIN32-PC
#endif // POCKETPC

#else // Linux - std-C
char * _gcvt (double value, int ndigits, char *buf)
{
char *p = buf;

sprintf(buf, "%-#.*g", ndigits, value);

/* It seems they expect us to return .XXXX instead of 0.XXXX  */
if (*p == '-')
p++;
if (*p == '0' && p[1] == '.')
memmove (p, p + 1, strlen (p + 1) + 1);

/* They want Xe-YY, not X.e-YY, and XXXX instead of XXXX.  */
p = strchr (buf, 'e');
if (!p)
{
p = buf + strlen (buf);
/* They don't want trailing zeroes.  */
while (p[-1] == '0' && p > buf + 2)
*--p = '\0';
}
if (p > buf && p[-1] == '.')
memmove (p - 1, p, strlen (p) + 1);
return buf;
}

inline void _itoa(int num, char* data, int base)
{
sprintf(data, "%d", num);
}
#endif
inline void floattochar(double f, char* data)
{
_gcvt(f, 10, data);
// linux bug
if(data[0]=='.' && data[1]=='0' && data[2]=='\0')
{
data[0]='0'; data[1]='\0';
return;
}
if(data[strlen(data)-1]=='.')
data[strlen(data)-1]='\0';
}

#ifdef WANT_SHOEBOX
GFShoeBox *__g_ShoeBox_Data;
GFShoeBox *__g_ShoeBox_Media;
#endif

//  *** DLLCALL ***
#if defined(POSIX) || defined(LINUX)
#include <dlfcn.h>
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO) || defined(PALM_WEBOS) // webos - disallows that
#define LoadLibrary(a)      NULL
#define GetProcAddress(a,b) NULL
#define FreeLibrary(a)      {}
#else
#define LoadLibrary(a)      dlopen(a, RTLD_LAZY)
#define GetProcAddress(a,b) dlsym(a,b)
#define FreeLibrary(a)      dlclose(a);
#endif
#define HMODULE   void*
#define HINSTANCE void*
#endif

// GP2X memory registers
#ifdef GP2X
extern volatile unsigned short *gp2x_memreg16;
#endif



// ---------- __GLBASIC__ ------------------
namespace __GLBASIC__
{
int				__DG_RESX=0; // window screen res
int				__DG_RESY=0;
int				__DG_DESKTOPX=0;
int				__DG_DESKTOPY=0;
int				__DG_MULTISAMPLE=0;
int				__DG_DEBUG=0;
int				__DG_FRAMERATE=0;
int				__DG_WANTMOUSE=0;
int				__DG_FULLSCREEN=0;
int             __IS_INITDONE=0; // Space Fractal - Required by Android


DGInt			__g_FirstTime;	// The time the program has started
DGInt			__g_LastTime;	// To get the time elapsed within the SHOWSCREEN cmds
DGInt			__g_ThisTime;	// To get the time elapsed within the SHOWSCREEN cmds
#ifdef ANDROID
// SPACE FRACTAL: Gernot, on Android, This >MUST< ALLWAYS been false, which is REQUIRED by newer Android versions and by some venders (Amazon AppStore).
// We need to could monitor BACK button manually and required let programmer implement this button in correct way. Android is NOT Windows!!!
int				__g_AllowEscape = FALSE; 
#else
int				__g_AllowEscape = TRUE; // GF: Must be this way. Don't break backwards compatibility. USE ALLOWESCAPE FALSE in your GLB source code instead.
#endif
int				__g_paused=FALSE;
int				__g_allowPause=TRUE;
int				__g_CurrentScreen=-1; // USESCREEN arg

GLB_PRESCALER	__g_Prescaler;

extern bool		__g_DidNET;
extern bool		__g_Did3D;
int				__nCurFont;
GFHawkNetwork*	pGFNet=NULL;

#ifndef GLB_CONSOLE
OpenGLRainbows*	__g_pRbow;
Rainbows3D*		__g_pRbow3D;
HINSTANCE		__g_HInstance;
#endif

/* PUSHSTATE
struct glb_engine_state
{
DGNat vpx, vpy, vpw, vph; // viewport size (GETVIEWPORT)
DGNat smoothshading;
DGNat usescreen;
DGStr currentdir;
DGNat font;
DGNat orientation;
DGInt alphamode;
DGNat transparency;

};
*/
void    glb_showscreen_finish_frame();
void    glb_showscreen_init_next_frame();


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
extern "C" int glb_load_save_textures_to_tmp(int bLoad)
{
#ifndef GLB_CONSOLE
return __g_pRbow->LoadSaveTextureToTmp(bLoad?true:false) ? 1:0;
#endif
return 0;
}



// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
extern "C" void glb_do_pause(int pause)
{
if(!__g_allowPause)
pause = FALSE;

if(__g_paused != (pause?TRUE:FALSE) )
{
__g_paused = pause?TRUE:FALSE;
if(pause)
{
CALLBYNAME(DGStr("GLB_ON_PAUSE"));
}
else
{
CALLBYNAME(DGStr("GLB_ON_RESUME"));
}
}
__g_paused = pause?TRUE:FALSE;
}

extern "C" int glb_allow_escape()
{
return __g_AllowEscape ? TRUE:FALSE;
}


extern "C" void glbasic_notify_screen_change(int w, int h)
{
g_debug("glb_notify_screen_size %dx%d\n",w ,h);
__DG_DESKTOPX = w;
__DG_DESKTOPY = h;
__DG_RESX = w;
__DG_RESY = h;

#ifndef GLB_CONSOLE
if(__g_pRbow)
{
__g_pRbow->m_WND.width = w;
__g_pRbow->m_WND.height= h;
//	__g_pRbow->SetScreen(w,h,0, __g_pRbow->m_WND.fullscreen); // would change rotation
}
#endif
}

extern "C" void glbasic_get_screen_size(int* w, int* h)
{
if(w) *w = __DG_RESX;
if(h) *h = __DG_RESY;
}



// ------------------------------------------------------------- //
// unpack/unzip the file before you try to read access it
BOOL glb_prepare_reading_file(DGStr& filename)
{	if(filename.len()==0)
return FALSE;

// STDOUT(CGStr("glb_prepare_reading_file: ")+filename);
#ifdef WANT_SHOEBOX
DGStr TempFileName;
if(!__g_ShoeBox_Data->FindOrExtract(filename, TempFileName.getbuffer(1024), true))
{
#ifdef ANDROID
TempFileName.releasebuffer();
DGStr checkfilename=filename;
// GF: 2016-08-11 absolute path check is done in CheckAssetFile()
//				checkfilename=REPLACE_Str(GETCURRENTDIR_Str()+filename, DGStr(android_files_dir()), CGStr(""));
//				checkfilename=REPLACE_Str(checkfilename, CGStr("//"), CGStr("/"));
//				checkfilename=REPLACE_Str(checkfilename, CGStr("/Media/"), CGStr("Media/"));
//STDOUT(checkfilename);
if(!DOESFILEEXIST(checkfilename)) // This will unpack the file from the APK, if fails to extract from above.
{	return FALSE;
}
//STDOUT(CGStr("3: "));
return TRUE;
#else
TempFileName.releasebuffer();
//STDOUT(CGStr("2: "));
return FALSE;
#endif
}

TempFileName.releasebuffer();
filename = TempFileName;
#endif

return TRUE;
}




// ------------------------------------------------------------- //
void	AUTOPAUSE(DGNat mode)
{
#if defined (TARGET_OS_IPHONE)
mode=TRUE; // AUTOPAUSE REQUIRED TO BEEN OFF ON IOS TO AVOID RESUME ISSUES!!!
#endif
__g_allowPause = mode ? TRUE:FALSE;

if(!__g_allowPause && __g_paused)
glb_do_pause(FALSE);
}




// ERROR HANDLING
// -------------------------------------------
/*
#define	CMP_OK					(0x00000)
#define	CMP_FOR_WITHOUT_NEXT	(0x00001)
#define	CMP_SYNTAX_ERROR		(0x00002)
#define CMP_NO_FILE				(0x00003)
#define CMP_WRONG_ARGUMENT		(0x00004)
#define CMP_STRING_TOO_LONG		(0x00005)
#define CMP_DIVISION_BY_ZERO	(0x00006)
#define CMP_OUT_OF_MEMORY		(0x00007)
#define CMP_WRONG_DIMENSION		(0x00008)
#define CMP_OUT_OF_DIMENSION	(0x00009)
#define CMP_OUT_OF_DATA			(0x00014)
*/
DGNat			__g_debugline;
DGNat			__g_error = CMP_OK;
DGNat			__g_errorline;

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGNat	__Error(DGNat code)
{
if(code != CMP_OK)
{	__g_error=code; // Set for GETLASTERROR()
__g_errorline=__g_debugline;
#ifdef WIN32 // Space Fractal :: This can been insanly annoying on iOS and Android, due there can been many of those. So Windos only
STDOUT(DGStr("error: ") + HEX_Str(code) + DGStr("\n"));
#endif
}

return code;
}


void	CLEARERROR()
{
__g_error=CMP_OK;
}

DGStr	GETLASTERROR_Str()
{
const char* pMsg="unknown error";
switch(__g_error)
{
case CMP_OK:      pMsg="success"; break;
case CMP_NO_FILE: pMsg="no such file"; break;
case CMP_OUT_OF_DIMENSION: pMsg="out of bounds"; break;
case CMP_OUT_OF_MEMORY: pMsg="out of memory"; break;
case CMP_OUT_OF_DATA: pMsg="out of data"; break;
}
char err[1024];
sprintf(err, "%.4d %s", __g_error, pMsg);
return DGStr(err);
}

//  *** DLLCALL ***
struct __DELAY_DLL
{
const char* dll, *func;
void** pPointer;
};

class __DLLCALLS
{
public:
__DLLCALLS(){}
~__DLLCALLS()
{
links.Clear();
for(int i=0; i<modules.Size(); ++i)
{
FreeLibrary((HINSTANCE)modules[i]);
}
modules.Clear();
}
Queue<void*> modules;
Queue<DGStr> dlls;
Queue<__DELAY_DLL> links;
};
__DLLCALLS& __dll_calls()
{
static __DLLCALLS ddd;
return ddd; 
}

void DLLCALL(const char* dll, const char* func, void** pPointer)
{
__g_Did3D = true;
__g_DidNET= true;
*pPointer = NULL;
__DELAY_DLL lnk;
lnk.dll=dll;
lnk.func=func;
lnk.pPointer=pPointer;
__dll_calls().links.Push(lnk);
}

void DLL_DELAY_CALL(const char* dll, const char* func, void** pPointer)
{
HMODULE pDll=NULL;
// No case in Win32
DGStr lowerdll = LCASE_Str(CGStr(dll));
// Find the dll already loaded
for(int i=0; i<__dll_calls().dlls.Size(); ++i)
{
if(*__dll_calls().dlls.GetAt(i) == lowerdll)
{
pDll = (HMODULE)*__dll_calls().modules.GetAt(i);
break;
}
}

char* pFuncName=(char*)func;
#ifdef UNICODE
wchar_t pDllName[1024];
wchar_t pFuncNameW[256];
mbstowcs(pDllName,  dll, strlen(dll)+1);
mbstowcs(pFuncNameW, func, strlen(func)+1);
#else
const char* pDllName = dll;
#endif
// must load dll
if(!pDll)
{
pDll = LoadLibrary(pDllName);

#ifdef MACOSX
if(!pDll)
{
char exe[1024];
GFFileSystem::GetExeDir(exe);
strcat(exe, "/Contents/MacOS/");
strcat(exe, pDllName);
pDll = LoadLibrary(exe);
if(!pDll)
{
g_debug("Error: %d %s\n", errno, strerror(errno));
g_debug("Retry: %s = %p\n", exe, pDll);
}
}
#endif


// loaded? store pointer to it and get proc address
if(pDll)
{
__dll_calls().modules.Push(pDll);
__dll_calls().dlls.Push(lowerdll);
#if defined( _DEBUG)
g_debug("LoadLibrary: %s = %p\n", dll, pDll);
#endif
}
else
{
DGStr err = CGStr("DECLARE module not found: ") + lowerdll;
WIN32_ONLY( DEBUG(err+CGStr("\n")) );
g_debug("%s\n", err.c_str());
}
}
if(pDll)
{
#if defined(UNICODE) && defined(_WIN32_WCE)
*pPointer = (void*)GetProcAddressW(pDll, pFuncNameW);
#else
*pPointer = (void*)GetProcAddress(pDll, pFuncName);
#endif
if(!*pPointer)
{
DGStr err = CGStr("DECLARE entry not found: ")+CGStr(func);
WIN32_ONLY( DEBUG(err+CGStr("\n")) );
g_debug("%s\n", err.c_str());
#if defined( _DEBUG) || !defined(WIN32)
g_debug("Can't find \"%s\" in %s\n", pFuncName, pDllName);
#ifdef _DEBUG
GFFileSystem::StrLastError();
#endif
#endif
}
}
}
void DLL_DELAY_LOAD_NOW()
{
if(__dll_calls().links.Size())
{
g_debug("Delay load DLLs\n");
for(int i=0; i<__dll_calls().links.Size(); ++i)
{
__DELAY_DLL* call = __dll_calls().links.GetAt(i);
DLL_DELAY_CALL(call->dll, call->func, call->pPointer);
}
}
}
// ERROR_ALREADY_EXISTS
// 0x000000b7

DGStr __Bytes2Hex(const unsigned char* pHex, int nBytes, int bUppercase=TRUE)
{
DGStr str;
if(!nBytes) return str;

str.alloc(nBytes*2, false);
const char *hexs;
if(bUppercase)
hexs = "0123456789ABCDEF";
else
hexs = "0123456789abcdef";
char a_word[3]; a_word[2]='\0';
int j=0;
for(int i=0; i<(int)nBytes; ++i)
{
str[j++] = hexs[(*pHex>>4)];
str[j++] = hexs[*pHex & 0x0f];
++pHex;
}
str[j] = '\0';
str.releasebuffer();
return str;
}


extern const char* GLB_LIC_MAIL; // = "allen.edward.webb@googlemail.com";
// code : abcd is: ba0dc0 (0=0 character)
extern const char* GLB_LIC_CODE; // = "61156fd561821633999dfd33259570f73d64c795cb18ea98ed43b143e53e8250f4cbf06cdffdc549";



#define __g_LicenseBits	OpenGLRainbows10FreeMemoriesEiiiii // harder to find in HTML5
extern int __g_LicenseBits;

// CF072101E981B41ADEFB6C617216EB4DFEE462B33934A0AD  = 48
#define PrepLic	OpenGLRainbows10AllocMemoriesEiii // harder to find in HTML5
void PrepLic()
{
int len, stlen;

stlen=(int)strlen(GLB_LIC_CODE);
if(stlen == 0) return;

len=(stlen*2)/3;
len+=(len%8);
BYTE* text=new BYTE[len*4];

memset(text, 0, len*4);
for(int i=0; i<stlen/3; i++)
{
int n=0;
#define HEXOF(a) ((a)>'9' ? ((a)-'a'+10) : ((a)-'0'))
n=HEXOF(GLB_LIC_CODE[i*3+1])*16 + HEXOF(GLB_LIC_CODE[i*3]); // Code has each byte flipped
text[i]=(BYTE)n;
}
#undef HEXOF

CBlowFish fish;
BYTE code[32];
memcpy(code, "dP~P.3+"  "\xd6" "\xdf" /*""*/ , 9+1); // "d9~R.E+"
code[1]='9';
code[3]='R';
code[5]='E';

fish.Initialize(code, 9);
fish.Decode(text, text, len/2);

__g_LicenseBits = 0;

char* mail = new char[strlen(GLB_LIC_MAIL)/2+1];
for(int i=0; i<(int)strlen(GLB_LIC_MAIL)/2; i++)
{
mail[i] = GLB_LIC_MAIL[i+i];
mail[i+1]='\0';
}

if(stricmp((const char*)(text+4), mail)==0)
{
// D3D,D3N,DNC,DNT,SCO
// 3D:  3N,3D
// NET: 3N,NT
if(strncmp((const char*)(text), "SCO", 3)==0)
{
__DG_SCHOOLVER = 1;
__g_LicenseBits |= 3;
}
if(text[1] == '3') // 3D
__g_LicenseBits |= 1;
if(text[1] == 'N' || text[2] == 'N') // NET
__g_LicenseBits |= 2;
}
delete [] mail;
delete [] text;
}

DGStr ENCRYPT_Str(DGStr code, DGStr text)
{
DGStr out;
CBlowFish fish;
//	code += CGStr("x"); // you no make glbasic license code
fish.Initialize((const BYTE*)code.c_str(), code.len());
int len = (int)fish.GetOutputLength(text.len()+1);

BYTE* pOut = (BYTE*)out.getbuffer(len+1);
len = (int)fish.Encode((BYTE*)text.c_str(), pOut, text.len());
pOut[len] = '\0';
out.setlength(len);
out = __Bytes2Hex((const BYTE*)out.c_str(), len, FALSE);
return out;
}

DGStr DECRYPT_Str(DGStr code, DGStr text)
{
text.lower();
//	code += CGStr("x");

// Hex to binary
int stlen=text.len();
int len=stlen/2;
len+=(len%8);
BYTE* btext=new BYTE[len*4];

memset(btext, 0, len*4);
for(int i=0; i<stlen/2; i++)
{
int n=0;
#define HEXOF(a) ((a)>'9' ? ((a)-'a'+10) : ((a)-'0'))
n=HEXOF(text.c_str()[i*2])*16 + HEXOF(text.c_str()[i*2+1]);
btext[i]=(BYTE)n;
}
#undef HEXOF

CBlowFish fish;
fish.Initialize((const BYTE*)code.c_str(), code.len());

DGStr out;
fish.Decode((BYTE*)btext, (BYTE*)btext, len);
btext[len] = '\0';
out.assign((const char*)btext);
return out;
}


int __gf_TwoHex2Int(char c1, char c2) {
int Hi = c1, Lo = c2 , Result;

if ('0'<=Hi && Hi<='9')      Hi -= '0';
else if ('a'<=Hi && Hi<='f') Hi -= ('a'-10);
else if ('A'<=Hi && Hi<='F') Hi -= ('A'-10);

if ('0'<=Lo && Lo<='9')      Lo -= '0';
else if ('a'<=Lo && Lo<='f') Lo -= ('a'-10);
else if ('A'<=Lo && Lo<='F') Lo -= ('A'-10);

Result = Lo + 16*Hi;
return Result;
}

inline bool __gf_isxdigit(char a)
{
return ((a>='0' && a<='9') || (a>='a'&&a<='f') || (a>='A'&&a<='F'));
}





// http://www.cl.cam.ac.uk/~mgk25/unicode.html#utf-8
void _utf8decode_glb(DGStr& str)
{
DGStr dest;
int i = 0;
const char* s = str.c_str();

while (i<(int)str.len())
{
const wchar_t c = (wchar_t)(unsigned char)s[i++];

// U-0 to U-7F 
if ((c&0x80) == 0x00)
{
dest.addchar((char)c);
continue;
}

// U-80 to U-7FF
else if ((c&0xE0) == 0xC0)
{
if (i<(int)str.len())
{
const wchar_t d = s[i++];
dest.addchar(( (c&0x1f)<<6 | (d&0x3f) ) );
continue;
}
}

// U-800 to U-FFFF
else if ((c&0xF0) == 0xE0)
{
if (i+1<(int)str.len())
{
const wchar_t d = s[i++];
const wchar_t e = s[i++];
dest.addchar(( (c&0x0f)<<12 | (d&0x3f)<<6 | (e&0x3f) ));
continue;
}
}
// three continuation (U-10000 to U-10ffff) - required for greek!
else if ((c & 0xF8) == 0xF0)
{
if (i+2<(int)str.len())
{
const wchar_t d = s[i++];
const wchar_t e = s[i++];
const wchar_t f = s[i++];
dest.addchar(( ((c&0x0f)<<18 | (d&0x3f)<<12 | (e&0x3f)<<6 | (f&0x3f)) + 655536 ));
continue;
}
}
}
str=dest;
}





DGStr URLENCODE_Str(const DGStr& SrcString)
{
DGStr DestString;

int len = LEN(SrcString);
for(int i=0; i<len; i++)
{
unsigned char c = (unsigned char)SrcString[i];
//if( isalnum(c) )  // Alpha Numeric Char
if (  (c>=48 && c<= 57) || ( c>= 65 && c<= 90) || (c>= 97 && c<= 122) ) {
DestString.addchar(c);
} 
//        else if(c == ' ') { // Space Char
//            DestString.addchar('+');
//        } 
else {              // Other Char (also space goes %20 )
char temp[16];
if(c > 127)
{
// simple ISO8859-1 to utf-8
sprintf(temp, "%%%02x%%%02x", 0xc2 + (c > 0xbf), (c & 0x3f)+0x80);
DestString += temp;
}
else
{
sprintf(temp, "%%%02x", (unsigned char)c);
DestString += temp;
}
}
}
return DestString;
}

DGStr URLDECODE_Str(const DGStr& SrcString)
{
DGStr DestString;
int len = LEN(SrcString);
for(int i=0; i<len; i++)
{
if(SrcString[i]== '%'){      // Non Alpha Numeric Char
i++;
if (__gf_isxdigit(SrcString[i]) && __gf_isxdigit(SrcString[i+1])) {
unsigned char code = __gf_TwoHex2Int(SrcString[i], SrcString[i+1]);
DestString.addchar(code);
i++;
}
}
else if(SrcString[i]=='+') { // Space Char - old style
DestString.addchar(' ');
}
else {                       // Other Char
DestString.addchar(SrcString[i]);
}
}
_utf8decode_glb(DestString);
return DestString;
}






#if defined(EMSCRIPTEN)
#define mymemcpy memcpy
#else
#pragma warning(disable: 4311)
static void* mymemcpy(void* dst0, const void* src0, size_t len0)
{
// Nonzero if either X or Y is not aligned on a "long" boundary.
#define MEMCPY_UNALIGNED(X, Y) \
(((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))

// How many bytes are copied each iteration of the 4X unrolled loop.
#define MEMCPY_BIGBLOCKSIZE    (sizeof (long) << 2)

// How many bytes are copied each iteration of the word copy loop.
#define MEMCPY_LITTLEBLOCKSIZE (sizeof (long))
// Threshhold for punting to the byte copier.
#define MEMCPY_TOO_SMALL(LEN)  ((LEN) < MEMCPY_BIGBLOCKSIZE)

char *dst = (char*)dst0;
const char *src = (const char*)src0;
long *aligned_dst;
const long *aligned_src;
int   len =  (int)len0;

// If the size is small, or either SRC or DST is unaligned,
// then punt into the byte copy loop.  This should be rare.
if (!MEMCPY_TOO_SMALL(len) && !MEMCPY_UNALIGNED (src, dst))
{
aligned_dst = (long*)dst;
aligned_src = (long*)src;

// Copy 4X long words at a time if possible.
while (len >= MEMCPY_BIGBLOCKSIZE)
{
*aligned_dst++ = *aligned_src++;
*aligned_dst++ = *aligned_src++;
*aligned_dst++ = *aligned_src++;
*aligned_dst++ = *aligned_src++;
len -= MEMCPY_BIGBLOCKSIZE;
}

// Copy one long word at a time if possible.
while (len >= MEMCPY_LITTLEBLOCKSIZE)
{
*aligned_dst++ = *aligned_src++;
len -= MEMCPY_LITTLEBLOCKSIZE;
}

// Pick up any residual with a byte copier.
dst = (char*)aligned_dst;
src = (char*)aligned_src;
}
while (len--)
*dst++ = *src++;

return dst0;
}
#endif


#if defined(__arm__)
#define STR_BLOCK_SIZE	2 // *4 bits to shift (4 chars)
#else
#define STR_BLOCK_SIZE	4 // *16 (16 chars)
#endif


static char DGSTR_NULL[4] = {'\0', '\0', '\0', '\0'};


// faster than the create temp and swap (can reuse old memory a lot)
DGStr& DGStr::operator=(const DGStr& a)
{
if(a.m_dat == this->m_dat)
return *this;

if(a.m_length)
{
alloc(a.m_length, false);
m_length=a.m_length;
mymemcpy(m_dat, a.m_dat, m_length+1);
}
else
{
if(m_dat != DGSTR_NULL)
m_dat[0] = '\0';
m_length=0;
}
return *this;
}

// not supported - ignore, just put it in
#if 1
// #if defined(ANDROID) || defined(EMSCRIPTEN) || defined(PANDORA) || defined(RASPBERRY_PI) || defined(TARGET_OS_IPHONE)

// taken from http://source.winehq.org/source/dlls/ntdll/string.c
char * _i64toa(
int64 value,    /* [I] Value to be converted */
char *str,      /* [O] Destination for the converted value */
int radix)      /* [I] Number base for conversion */
{
uint64 val;
int negative;
char buffer[65];
char *pos;
int digit;

if (value < 0 && radix == 10) {
negative = 1;
val = -value;
} else {
negative = 0;
val = value;
} /* if */

pos = &buffer[64];
*pos = '\0';

do {
digit = val % radix;
val = val / radix;
if (digit < 10) {
*--pos = '0' + digit;
} else {
*--pos = 'a' + digit - 10;
} /* if */
} while (val != 0L);

if (negative) {
*--pos = '-';
} /* if */

memcpy(str, pos, &buffer[64] - pos + 1);
return str;
}

int64 _atoi64( const char *str )
{
int64 RunningTotal = 0;
char bMinus = 0;

while (*str == ' ' || (*str >= '\011' && *str <= '\015')) {
str++;
} /* while */

if (*str == '+') {
str++;
} else if (*str == '-') {
bMinus = 1;
str++;
} /* if */

while (*str >= '\0' && *str <= '9') {
RunningTotal = RunningTotal * 10 + *str; // - '';
str++;
} /* while */

return bMinus ? -RunningTotal : RunningTotal;
}

#endif


DGStr::DGStr()				:m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{} // don't !! memcpy the '\0' character. Might break some times!?
DGStr::DGStr(const char* c)	:m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{unsigned int nlen=(unsigned int)strlen(c);        if(nlen){alloc(nlen,false);      m_length=nlen;        mymemcpy(m_dat, c,         m_length); m_dat[m_length]='\0';}}
DGStr::DGStr(const wchar_t* c):m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{assign(c);}
DGStr::DGStr(CGStr a)		:m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{unsigned int nlen=(unsigned int)strlen(a.c_str());if(nlen){alloc(nlen, false);     m_length=nlen;        mymemcpy(m_dat, a.c_str(), m_length); m_dat[m_length]='\0';}}
DGStr::DGStr(const DGStr& a):m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{if(a.m_length){alloc(a.m_length,false); m_length=a.m_length; mymemcpy(m_dat, a.m_dat,   m_length); m_dat[m_length]='\0';}  }
DGStr::DGStr(int a)			:m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{alloc(15,false); _itoa(a,m_dat, 10);   releasebuffer();}
DGStr::DGStr(int64 a)		:m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{alloc(63,false); _i64toa(a,m_dat, 10);   releasebuffer();}
DGStr::DGStr(float a)		:m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{alloc(63,false); floattochar(a,m_dat); releasebuffer();} // gcvt(a, b, c) == sprintf(c, "%bg", a);
DGStr::DGStr(double a)		:m_length(0),m_buflen(0),m_dat(DGSTR_NULL)	{alloc(63,false); floattochar(a,m_dat); releasebuffer();}

void DGStr::clear()														{
if(m_dat!=DGSTR_NULL) delete[]m_dat;
m_dat = DGSTR_NULL;
m_length=0; m_buflen=0;
}
void DGStr::releasebuffer()
{
for(m_length=0; m_dat[m_length]!='\0' && m_length<m_buflen; ++m_length)
{}
if(m_length>=m_buflen) // uh-oh! non 0 terminated string!
{
#ifdef _DEBUG
*(long*)0=42;
#endif
if(m_length>0)
m_dat[ --m_length ] = '\0';
}
}



void DGStr::alloc(unsigned int n, bool keep_content)
{
if(n<=0)
return;
++n; // space for '\0' character
if(m_buflen<n)
{
m_buflen = (((n)>>STR_BLOCK_SIZE)+1) << STR_BLOCK_SIZE;  // (1+n/STR_BLOCK_SIZE) * STR_BLOCK_SIZE;
char* pD = new char[m_buflen];
if(m_length==0 || !keep_content)
{
#if STR_BLOCK_SIZE>1
*(long*)pD = 0;
#else
*pD='\0';
#endif
}
else
{
mymemcpy(pD, m_dat, m_length); // strcpy(pD, dat);
pD[m_length] = '\0';
}
if(m_dat!=DGSTR_NULL)
{
delete[] m_dat;
}
m_dat = pD;
}
}

void DGStr::assignlowmem(const char* c)	{
if(m_dat!=DGSTR_NULL) delete[]m_dat;
m_length = (unsigned int)strlen(c);
if(m_length)
{
m_buflen=m_length+1;
m_dat=new char[m_buflen];
mymemcpy(m_dat, c, m_length);
m_dat[m_length]='\0';
}
else
{
m_dat = DGSTR_NULL;
m_buflen=0;
}
}


#ifdef _DEBUG
char DGStr::operator[](int n)const
{
if(n && n>=(int)m_buflen)
*(int*)0=42;
return m_dat[n];
}
char& DGStr::operator[](int n)
{
if(n && n>=(int)m_buflen)
*(int*)0=42;
return m_dat[n];
}
#endif


void DGStr::upper()
{
char* pEnd = m_dat + m_length;
for (char* pC = m_dat; pC<pEnd; ++pC)
{
*pC = toupper(*pC);
}
}

void DGStr::lower()
{
char* pEnd = m_dat + m_length;
for (char* pC = m_dat; pC<pEnd; ++pC)
{
*pC = tolower(*pC);
}
}

/* - others seem faster
DGStr& DGStr::operator=(CGStr a)		{m_length=(unsigned int)strlen(a.c_str()); if(m_length) {alloc(m_length,false); memcpy(m_dat, a.c_str(), m_length+1);}else{clear();} return *this;}
DGStr& DGStr::operator=(const char* c)	{m_length=(unsigned int)strlen(c);         if(m_length) {alloc(m_length,false); memcpy(m_dat, c, m_length+1);        }else{clear();} return *this;}
DGStr& DGStr::operator=(int a)			{alloc(16,false); _itoa(a, m_dat, 10);  releasebuffer(); return *this;}
DGStr& DGStr::operator=(float a)		{alloc(64,false); floattochar(a, m_dat);releasebuffer(); return *this;} // gcvt(a, b, c) == sprintf(c, "%bg", a);
DGStr& DGStr::operator=(double a)		{alloc(64,false); floattochar(a, m_dat);releasebuffer(); return *this;}
*/

// the DGStr a operator seems faster
// DGStr& DGStr::operator=(const DGStr& a)	{m_length=a.m_length;                      if(m_length) {alloc(m_length,false); memcpy(m_dat, a.m_dat, m_length+1);  }else{clear();} return *this;}

#define MK_OPERATOR_CL(zz) \
DGStr& DGStr::operator zz(const char* str){unsigned int slen = (unsigned int)strlen(str); \
if(slen)  {alloc(m_length+slen,      true);mymemcpy(m_dat+m_length, str,     slen);       m_length+=slen;       m_dat[m_length]='\0';} return *this;} \
DGStr& DGStr::operator zz(const DGStr& a) {if(a.len()){alloc(m_length+a.m_length,true);mymemcpy(m_dat+m_length, a.m_dat, a.m_length); m_length+=a.m_length; m_dat[m_length]='\0';} return *this;} \
DGStr& DGStr::operator zz(CGStr a)		  {*this += a.m_dat; return *this;} \
DGStr& DGStr::operator zz(int a)		  {DGStr b(a); *this+=b; return *this;} \
DGStr& DGStr::operator zz(int64 a)		  {DGStr b(a); *this+=b; return *this;} \
DGStr& DGStr::operator zz(float a)		  {DGStr b(a); *this+=b; return *this;} \
DGStr& DGStr::operator zz(double a)		  {DGStr b(a); *this+=b; return *this;}
MK_OPERATOR_CL(+=)
MK_OPERATOR_CL(-=)
MK_OPERATOR_CL(*=)
MK_OPERATOR_CL(/=)
MK_OPERATOR_CL(^=)

//DGStr operator+(DGStr& a, const CGStr& b) {strcat(a.dat, b.dat); DGStr c; c = (DGStr)b; return c;}
#define MK_OPERATOR(zz, zzz) \
DGStr operator zz (int a, CGStr b)			{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (int a, const DGStr& b)	{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (int64 a, CGStr b)		{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (int64 a, const DGStr& b)	{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (float a, CGStr b)		{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (float a, const DGStr& b)	{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (double a, CGStr b)		{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (double a, const DGStr& b){DGStr c(a); c zzz b; return c;} \
DGStr operator zz (CGStr a, CGStr b)		{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (CGStr a, const DGStr& b)	{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (CGStr a, int b)			{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (CGStr a, int64 b)		{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (CGStr a, float b)		{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (CGStr a, double b)		{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (const DGStr& a, CGStr b)	{DGStr c(a); c zzz b;  return c;} \
DGStr operator zz (const DGStr& a, const DGStr& b){DGStr c(a); c zzz b; return c;} \
DGStr operator zz (const DGStr& a, int b)	{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (const DGStr& a, int64 b)	{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (const DGStr& a, float b)	{DGStr c(a); c zzz b; return c;} \
DGStr operator zz (const DGStr& a, double b){DGStr c(a); c zzz b; return c;}
MK_OPERATOR(+, +=)
MK_OPERATOR(-, -=)
MK_OPERATOR(*, *=)
MK_OPERATOR(/, /=)
MK_OPERATOR(^, ^=)

#define NUMNUM(zz)	return a zz b ? 1 : 0;
#define STRNUM(zz)	return a.number() zz b ? 1 : 0;
#define STRNAT(zz)	return a.natural() zz b ? 1 : 0;
#define STRNAT64(zz)return a.natural64() zz b ? 1 : 0;
#define NUMSTR(zz)	return a zz b.number() ? 1 : 0;
#define NATSTR(zz)	return a zz b.natural() ? 1 : 0;
#define NAT64STR(zz)return a zz b.natural64() ? 1 : 0;
#define STRSTR(zz)	return (strcmp(a.c_str(), b.c_str()) zz 0) ? 1 : 0;
#define STRNSTR(zz, nn)	return (memcmp(a.c_str(), b.c_str(), nn) zz 0) ? 1 : 0;

#undef MK_OPERATOR
#define MK_OPERATOR(zz) \
bool operator zz (int a, CGStr b)			{NATSTR(zz)} \
bool operator zz (int a, const DGStr& b)	{NATSTR(zz)} \
bool operator zz (int64 a, CGStr b)			{NAT64STR(zz)} \
bool operator zz (int64 a, const DGStr& b)	{NAT64STR(zz)} \
bool operator zz (float a, CGStr b)			{NUMSTR(zz)} \
bool operator zz (float a, const DGStr& b)	{NUMSTR(zz)} \
bool operator zz (double a, CGStr b)		{NUMSTR(zz)} \
bool operator zz (double a, const DGStr& b)	{NUMSTR(zz)} \
bool operator zz (CGStr a, CGStr b)			{STRSTR(zz)} \
bool operator zz (CGStr a, const DGStr& b)	{STRSTR(zz)} \
bool operator zz (CGStr a, int b)			{STRNAT(zz)} \
bool operator zz (CGStr a, int64 b)			{STRNAT64(zz)} \
bool operator zz (CGStr a, float b)			{STRNUM(zz)} \
bool operator zz (CGStr a, double b)		{STRNUM(zz)} \
bool operator zz (const DGStr& a, CGStr b)	{STRSTR(zz)} \
bool operator zz (const DGStr& a, const DGStr& b)	{STRSTR(zz)} \
bool operator zz (const DGStr& a, int b)	{STRNAT(zz)} \
bool operator zz (const DGStr& a, int64 b)	{STRNAT64(zz)} \
bool operator zz (const DGStr& a, float b)	{STRNUM(zz)} \
bool operator zz (const DGStr& a, double b)	{STRNUM(zz)}
MK_OPERATOR(<=)
MK_OPERATOR(>=)
MK_OPERATOR(!=)
MK_OPERATOR(<)
MK_OPERATOR(>)
#undef MK_OPERATOR

// The == operator should check for equal length first - much faster!
bool operator == (const DGStr& a, const DGStr& b)	{if(a.len()!=b.len()) return 0; STRNSTR(==, a.len());}
bool operator == (CGStr a, const DGStr& b)			{if(a.len()!=b.len()) return 0; STRNSTR(==, a.len());}
bool operator == (const DGStr& a, CGStr b)			{if(a.len()!=b.len()) return 0; STRNSTR(==, a.len());}
bool operator == (int a, CGStr b)			{NATSTR(==)}
bool operator == (int a, const DGStr& b)	{NATSTR(==)}
bool operator == (int64 a, CGStr b)			{NAT64STR(==)}
bool operator == (int64 a, const DGStr& b)	{NAT64STR(==)}
bool operator == (float a, CGStr b)			{NUMSTR(==)}
bool operator == (float a, const DGStr& b)	{NUMSTR(==)}
bool operator == (double a, CGStr b)		{NUMSTR(==)}
bool operator == (double a, const DGStr& b)	{NUMSTR(==)}
bool operator == (CGStr a, CGStr b)			{STRSTR(==)}
bool operator == (CGStr a, int b)			{STRNAT(==)}
bool operator == (CGStr a, int64 b)			{STRNAT64(==)}
bool operator == (CGStr a, float b)			{STRNUM(==)}
bool operator == (CGStr a, double b)		{STRNUM(==)}
bool operator == (const DGStr& a, int b)	{STRNAT(==)}
bool operator == (const DGStr& a, int64 b)	{STRNAT64(==)}
bool operator == (const DGStr& a, float b)	{STRNUM(==)}
bool operator == (const DGStr& a, double b)	{STRNUM(==)}

// returns a static temp buffer -> don't use twice in one call!
static wchar_t g_w_str_buffer[512];
const wchar_t* DGStr::w_str()const
{
mbstowcs(g_w_str_buffer, c_str(), len()+1);
return g_w_str_buffer;
}

// DGStr::operator const char*()const	{return this->dat;}
void	DGStr::left(long i)				{if((int)i>=0 && (int)i<(long)m_length) {m_dat[(int)i]='\0'; m_length=(int)i;} }

char*	DGStr::getbuffer(unsigned int size) {alloc(size,true); return m_dat;}

int		DGStr::compare(const char* s)const	{return strcmp(m_dat, s);}
int		DGStr::compare(DGInt i)const	{DGInt a=(DGInt)this->number();  if(a<i) return -1; else if(a>i) return 1; return 0;}
int		DGStr::compare(DGNat i)const	{DGNat a=(DGNat)this->natural(); if(a<i) return -1; else if(a>i) return 1; return 0;}

void	DGStr::trimright()
{
if(m_length<=0) return;
signed int i, end; // SIGNED!!
end=m_length-1;
for(i=end; i>=0; --i)
{
if ((unsigned)m_dat[i]<32) // trim any non visible characters
{
m_dat[i]='\0';
--m_length;
}
else
break;
}
}
DGInt CGStr::number()const					{return (DGInt)atof(m_dat);}
DGInt DGStr::number()const					{return (DGInt)atof(m_dat);}
DGNat CGStr::natural()const					{return (DGNat)atoi(m_dat);}
DGNat DGStr::natural()const					{return (DGNat)atoi(m_dat);}
int64 CGStr::natural64()const				{return (int64)_atoi64(m_dat);}
int64 DGStr::natural64()const				{return (int64)_atoi64(m_dat);}
unsigned int CGStr::len()const				{return (unsigned int)strlen(m_dat);}

void  DGStr::assign(const char* c)			{DGStr tmp(c); swap(tmp);}
void DGStr::assign(const wchar_t* c)
{
unsigned int len = (unsigned)wcslen((const wchar_t*)c) + 1;
alloc(len, false);
_wcstombsz(m_dat, (const wchar_t*)c, len);
m_length=len;
}
// append a single character
void DGStr::addchar(char c)
{
alloc(m_length+1, true);
m_dat[m_length++]=c;
m_dat[m_length]='\0';
}



/* - can't do '\0' characters
inline const char* __qstrstr(const char *phaystack, const char *pneedle)
{
register const unsigned char *haystack, *needle;
register unsigned b, c;

haystack = (const unsigned char *) phaystack;
needle = (const unsigned char *) pneedle;

b = *needle;
if (b != '\0')
{
haystack--;				// possible ANSI violation
do
{
c = *++haystack;
if (c == '\0')
goto ret0;
}
while (c != b);

c = *++needle;
if (c == '\0')
goto foundneedle;
++needle;
goto jin;

for (;;)
{
register unsigned a;
register const unsigned char *rhaystack, *rneedle;

do
{
a = *++haystack;
if (a == '\0')
goto ret0;
if (a == b)
break;
a = *++haystack;
if (a == '\0')
goto ret0;
shloop:;    }
while (a != b);

jin:	  a = *++haystack;
if (a == '\0')
goto ret0;

if (a != c)
goto shloop;

rhaystack = haystack-- + 1;
rneedle = needle;
a = *rneedle;

if (*rhaystack == a)
do
{
if (a == '\0')
goto foundneedle;
++rhaystack;
a = *++needle;
if (*rhaystack != a)
break;
if (a == '\0')
goto foundneedle;
++rhaystack;
a = *++needle;
}
while (*rhaystack == a);

needle = rneedle;		   // took the register-poor approach

if (a == '\0')
break;
}
}
foundneedle:
return (const char*) haystack;
ret0:
return NULL;
}
*/

inline int __qmemcmp(const unsigned char* p1, const unsigned char* p2, unsigned int len)
{
const unsigned int* pi1=(const unsigned int*)p1;
const unsigned int* pi2=(const unsigned int*)p2;
while(len>3)
{
if(*pi1++ != *pi2++)
return 1;
len-=4;
}
if(len > 0)
{
p1=(const unsigned char*)pi1;
p2=(const unsigned char*)pi2;

if(*p1 != *p2) return 1;
--len; ++p1; ++p2;
if(len > 0)
{
if(*p1 != *p2) return 1;
--len; ++p1; ++p2;
if(len > 0)
{
if(*p1 != *p2) return 1;
}
}
}
return 0;
}

/* The constant UCHAR_MAX is assumed to contain the maximum
* value of the input character type. Typically it's 255.
* size_t is an unsigned type for representing sizes.
* If your system doesn't have it, replace with
* unsigned int.
*/

/* Returns a pointer to the first occurrence of "needle"
* within "haystack", or NULL if not found. Works like 
* memmem().
*/



int __qmemmem(const unsigned char* haystack, unsigned int hlen, const unsigned char* needle, unsigned int  nlen)
{
/* Sanity checks on the parameters */
if (nlen <= 0 || !haystack || !needle)
return -1;

unsigned int scan = 0;
unsigned int bad_char_skip[0xff + 1]; /* Officially called:
* bad character shift */

if(hlen==0) return  0;
if(nlen>hlen)  return -1;
if(hlen == nlen)
return __qmemcmp(haystack, needle, nlen)==0 ?  0 : -1;

const unsigned char* start=haystack;

/* ---- Preprocess ---- */
/* Initialize the table to default value */
/* When a character is encountered that does not occur
* in the needle, we can safely skip ahead for the whole
* length of the needle.
*/
for (scan = 0; scan <= 0xff; scan++)
bad_char_skip[scan] = nlen;

/* C arrays have the first byte at [0], therefore:
* [nlen - 1] is the last byte of the array. */
unsigned int last = nlen - 1;

/* Then populate it with the analysis of the needle */
for (scan = 0; scan < last; scan++)
bad_char_skip[needle[scan]] = last - scan;

/* ---- Do the matching ---- */

/* Search the haystack, while the needle can still be within it. */
while (hlen >= nlen)
{
/* scan from the end of the needle */
for (scan = last; haystack[scan] == needle[scan]; scan = scan - 1)
if (scan == 0) /* If the first byte matches, we've found it. */
return (int)(haystack-start);

/* otherwise, we need to skip some bytes and start again. 
Note that here we are getting the skip value based on the last byte
of needle, no matter where we didn't match. So if needle is: "abcd"
then we are skipping based on 'd' and that value will be 4, and
for "abcdd" we again skip on 'd' but the value will be only 1.
The alternative of pretending that the mismatched character was 
the last character is slower in the normal case (Eg. finding 
"abcd" in "...azcd..." gives 4 by using 'd' but only 
4-2==2 using 'z'. */
hlen     -= bad_char_skip[haystack[last]];
haystack += bad_char_skip[haystack[last]];
}

return -1;
}






// find c2 in c1, starting at nskip in c1
inline int __qinstr(const char* c1, int len1, const char* c2, int len2, int nskip=0)
{
if(nskip >= len1) return -1;

int pos = __qmemmem((const unsigned char*)c1+nskip, len1-nskip, (const unsigned char*)c2, len2);
if(pos==-1) return -1;
return (int) pos+ nskip;
}

// reverse find c2 in c1, starting at nskip in c1
inline int __rev_qinstr(const char* c1, int len1, const char* c2, int len2, int iafter=-1)
{
if(iafter <0) iafter = len1-len2;
if(iafter<0) return -1; // needle>haystack

int ibest=-1;
int istart=0;
for(;;)
{

//  0123456789012345678901234567890123456789012 // 43 len
// "the quick brown fox jumps over the lazy dog"

int pos = __qmemmem((const unsigned char*)c1+istart, len1-istart, (const unsigned char*)c2, len2);
if(pos<0) break;
pos+=istart;
if(pos>iafter) break;
ibest=pos;
istart=pos+1;
}
return ibest;
}


// replace in this. Keep *this untouched
DGStr DGStr::replace(const DGStr& sOld, const DGStr& sNew)const
{
DGStr str(*this);
int	pos=0;
int qpos;

unsigned int	lold=sOld.len();
unsigned int	lnew=sNew.len();
const bool onebyte = (lold==1 && lnew==1) ? true : false;
for(;;)
{
qpos = __qinstr(str.c_str() + pos, str.len()-pos,  sOld.c_str(), lold);
if (qpos != -1)
{
pos+=qpos;
if(onebyte)
{
str.m_dat[pos] = sNew.m_dat[0];
++pos;
}
else if (lold==lnew)
{
mymemcpy(str.m_dat+pos, sNew.c_str(), lnew);
pos+=(lnew);
}
else
{
str = MID_Str(str, 0, pos) + sNew + MID_Str(str, pos+lold, str.len());
pos+=(lnew-lold+1);
}
}
else
break;
}
return str;
}



// ------------------------------------------------------------- //
// find string in string
// ------------------------------------------------------------- //
DGNat INSTR(CGStr        haystack, CGStr        needle, DGNat start) {return __qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
DGNat INSTR(CGStr        haystack, const DGStr& needle, DGNat start) {return __qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
DGNat INSTR(const DGStr& haystack, CGStr        needle, DGNat start) {return __qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
DGNat INSTR(const DGStr& haystack, const DGStr& needle, DGNat start) {return __qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
// can't handle '\0':
//DGNat INSTR(const char* s1, const char* s2, DGNat start)		{return __qinstr(s1, s2, start);}



// ------------------------------------------------------------- //
// reverse find string in string
// ------------------------------------------------------------- //
DGNat REVINSTR(CGStr        haystack, CGStr        needle, DGNat start)		{return __rev_qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
DGNat REVINSTR(CGStr        haystack, const DGStr& needle, DGNat start)		{return __rev_qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
DGNat REVINSTR(const DGStr& haystack, CGStr        needle, DGNat start)		{return __rev_qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
DGNat REVINSTR(const DGStr& haystack, const DGStr& needle, DGNat start)		{return __rev_qinstr(haystack.c_str(), haystack.len(), needle.c_str(), needle.len(), start);}
// can't handle '\0':
//DGNat INSTR(const char* s1, const char* s2, DGNat start)		{return __rev_qinstr(s1, s2, start);}



// ------------------------------------------------------------- //
// find first char in string
// ------------------------------------------------------------- //
const char* __findOneOf(const char* str, const char* fnd)
{
while(*str!='\0')
{
const char* nfnd = fnd;
do
{
if(*str == *nfnd++) return str;
} while(*nfnd!='\0');
++str;
};
return NULL;
}

// ------------------------------------------------------------- //
// find first char not in string
// ------------------------------------------------------------- //
const char* __findOneNotOf(const char* str, const char* fnd)
{
while(*str!='\0')
{
const char* nfnd = fnd;
do
{
if(*str == *nfnd++) goto skip;
} while(*nfnd!='\0');
return str;
skip:
++str;
};
return NULL;
}

// ------------------------------------------------------------- //
// Split String into Array
// ------------------------------------------------------------- //
DGNat SPLITSTR(const DGStr& instr, DGStrArray& arr, const DGStr& splitter, DGNat bSkipEmtpy)
{
const char* pCur, *pEnd, *pTotalEnd;
// Queue<DGStr> vals;
static DGStr		 tmp, str;	
str = instr;
pCur = str.c_str();
pEnd = pCur;
// avoid byte garbage if str==""
arr.dim=0;
arr.max1=0;
arr.max2=0;
arr.max3=0;
arr.max4=0;
arr.fac2=0;
arr.fac3=0;
arr.fac4=0;
arr.count=0;
// DIM(arr,0);

pTotalEnd = pCur + str.len();
for( ;pCur<pTotalEnd; )
{
// skip splitters
if(bSkipEmtpy)
pEnd = __findOneNotOf(pCur, splitter.c_str());
else
pEnd = pCur;
if(pEnd) pCur = pEnd;

// find next splitter
pEnd = __findOneOf(pCur, splitter.c_str());
if(pEnd)
{
// *pEnd = '\0';
if(*pCur!='\0')
{
int len = (int)(pEnd - pCur);
if(len || !bSkipEmtpy)
{
mymemcpy(tmp.getbuffer(len+1), pCur, len);
tmp[len] = '\0';
tmp.setlength(len);

// tmp = pCur;
DIMPUSH(arr, tmp);
// vals.Push(tmp);
}
}
pCur = ++pEnd;
}
else
{
if(pCur && *pCur !='\0')
{
tmp = pCur;
DIMPUSH(arr, tmp);
// vals.Push(tmp);
}
break;
}
}
/*
DIM(arr, vals.Size());
for(unsigned int i=0; i<vals.Size(); ++i)
{
arr(i) = *vals.GetAt(i);
}
*/
return LEN(arr);
}
//DGInt SPLITSTR(CGStr str, DGStrArray& arr, CGStr splitter) {return SPLITSTR(str, arr, splitter);}

DGStr UCASE_Str(const DGStr& org)
{
DGStr rv = org;
rv.upper();
return rv;
}

DGStr LCASE_Str(const DGStr& org)
{
DGStr rv = org;
rv.lower();
return rv;
}


#if defined(LINUX) || defined(GPHWIZ) || defined(CAANOO) || defined(PALM_WEBOS)||defined(PALM_PIXI)
extern "C" int ioctl(int fildes, unsigned long request, ...);
extern "C" int open(const char *path, int flags, unsigned int mode=0);
#define	O_RDONLY	 0
#define O_RDWR       2
#define I2C_RDWR 0x0707
#define O_NONBLOCK	 04000
#define HDIO_GET_IDENTITY 0x307
struct hd_driveid {
unsigned int	config;			unsigned int	cyls;			unsigned int	reserved2;		unsigned int	heads;		
unsigned int	track_bytes;	unsigned int	sector_bytes;	unsigned int	sectors;		unsigned int	vendor0;	
unsigned int	vendor1;		unsigned int	vendor2;		unsigned char	serial_no[20];	unsigned int	buf_type;
unsigned int	buf_size;		unsigned int	ecc_bytes;		unsigned char	fw_rev[8];		unsigned char	model[40];	
unsigned char	max_multsect;	unsigned char	vendor3;		unsigned int	dword_io;		unsigned char	vendor4;	
unsigned char	capability;		unsigned int	reserved50;		unsigned char	vendor5;		unsigned char	tPIO;		
unsigned char	vendor6;		unsigned char	tDMA;			unsigned int	field_valid;	unsigned int	cur_cyls;	
unsigned int	cur_heads;		unsigned int	cur_sectors;	unsigned int	cur_capacity0;	unsigned int	cur_capacity1;	
unsigned char	multsect;		unsigned char	multsect_valid;	unsigned int	lba_capacity;	unsigned int	dma_1word;	
unsigned int	dma_mword;		unsigned int  eide_pio_modes;	unsigned int  eide_dma_min;	unsigned int  eide_dma_time;	
unsigned int  eide_pio;       unsigned int  eide_pio_iordy;	unsigned int	words69_70[2];	unsigned int	words71_74[4];	
unsigned int  queue_depth;	unsigned int  words76_79[4];	unsigned int  major_rev_num;	unsigned int  minor_rev_num;	
unsigned int  command_set_1;	unsigned int  command_set_2;	unsigned int  cfsse;			unsigned int  cfs_enable_1;	
unsigned int  cfs_enable_2;	unsigned int  csf_default;	unsigned int  dma_ultra;		unsigned int	word89;		
unsigned int	word90;			unsigned int	CurAPMvalues;	unsigned int	word92;			unsigned int	hw_config;	
unsigned int  words94_125[32];unsigned int	last_lun;		unsigned int	word127;		unsigned int	dlf;
unsigned int  csfo;			unsigned int	words130_155[26];unsigned int	word156;		unsigned int	words157_159[3];
unsigned int	words160_255[95];
};

static int linux_battery_level()
{
int blevel=100;
FILE *battery;
int i;
char b[128];

battery = fopen ("/proc/apm", "r");
if(battery != NULL)
{
int bloading; // is loading?
fscanf(battery, "%s %s %s %x %s %x %d%% %s %s",
b, b, b, &bloading, b, &i, &blevel, b, b);
//     1.16 1.2 0x03 0x01      0x00 0x01 99%      -1  ?
fclose(battery);

// Bit 7 is set if we have a battery (laptop).
if ((i & 0x80) != 0) blevel = 100;
}
return blevel;
}
#endif // LINUX battery level

#ifdef GP2X
#define I2CCON   (0xD00>>1)
#define I2CSTAT  (0xD02>>1)
#define I2CADDR  (0xD04>>1)
#define I2CDATA  (0xD06>>1)

#define DEVICE  0xA0

int WaitOnI2CInterrupt()
{int n = 10000000;while(n > 0){if(gp2x_memreg16[I2CCON] & 0x10) // wait for interrupt pending flag
return 1; n--;}return 0;}


// returns 1 on success, 0 on failure
int FetchGP2XSerial(char *pszSerial)
{
unsigned short usCount = 0;

// initialize registers
gp2x_memreg16[I2CCON] = 0xEF; // set clocks, enable interrupt, clear pending flag
gp2x_memreg16[I2CADDR] = DEVICE; // set address
gp2x_memreg16[I2CSTAT] = 0x10; // enable I2C

*pszSerial = 0;

// tell the eeprom what address we're interested in
gp2x_memreg16[I2CDATA] = DEVICE;
gp2x_memreg16[I2CSTAT] = 0xF0; // Master mode, data write
if(WaitOnI2CInterrupt())
{
gp2x_memreg16[I2CDATA] = 0x00; // high byte of address
gp2x_memreg16[I2CCON] = 0xEF;
if(WaitOnI2CInterrupt())
{
gp2x_memreg16[I2CDATA] = 0x20; // address of serial number
gp2x_memreg16[I2CCON] = 0xEF;
if(WaitOnI2CInterrupt())
{
// issue the read command
gp2x_memreg16[I2CDATA] = DEVICE;
gp2x_memreg16[I2CSTAT] = 0xB0; // Master mode, data read
gp2x_memreg16[I2CCON] = 0xEF;
if(WaitOnI2CInterrupt())
{
// read the data bytes
for(usCount = 0; usCount < 24; usCount++)
{
gp2x_memreg16[I2CCON] = 0xEF;
if(!WaitOnI2CInterrupt())
break;
*pszSerial++ = (char) gp2x_memreg16[I2CDATA];
*pszSerial = 0;
}
}
}
}
}
// shut down
gp2x_memreg16[I2CSTAT] = 0x90;
gp2x_memreg16[I2CCON] = 0xEF;
usleep(10000);
// leave the I2C in a quiet state
gp2x_memreg16[I2CCON] = 0x40; // disable interrupt
gp2x_memreg16[I2CSTAT] = 0x00; // disable I2C

if(usCount == 24)
return 1;
return 0;
}
#endif

#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
int gp2x_wiz_battery()
{
int devbatt;
unsigned short batt=0;
devbatt = open("/dev/batt", O_RDONLY);
if(devbatt<0) // failed (F220 e.g.)
{
typedef struct
{
unsigned short batt;
unsigned short remocon;
} MMSP2ADC;

// The value batt has one of the following:
#define BATT_LEVEL_HIGH 0
#define BATT_LEVEL_MID 1
#define BATT_LEVEL_LOW 2
#define BATT_LEVEL_EMPTY 3

int rv;
MMSP2ADC val;
val.batt=BATT_LEVEL_EMPTY;
devbatt = open("/dev/mmsp2adc", O_RDONLY);
read (devbatt, &val, sizeof(MMSP2ADC));
close(devbatt);
switch(val.batt)
{
case BATT_LEVEL_HIGH: return 100;
case BATT_LEVEL_MID: return 67;
case BATT_LEVEL_LOW: return 33;
}
return 0;
}
read (devbatt, &batt, 2);
close (devbatt);

/*
>900 - AC Adapter 
>745 - Full batteries
678-745 - Medium batteries
<678    - Empty batteries
*/
// above 745 -> return "full"
if(batt>745) return 100;
// between full and empty -> linear interpolation
if(batt>678)
{
return 100.0f * ((float)batt-745.0f) / (745.0f - 678.0f);
}
return 0; // empty
}
#endif


#if defined (TARGET_OS_IPHONE)
extern "C"
{
int   isIphone();
const char* iPhoneVersion(); // "2.2.1" e.g.
//const char* iPhoneDeviceID();
float iPhoneBattery();
void  iPhoneGetCountryInto(char * str);
const char* iPhoneGetDocumentsPath();
const char* iPhoneGetTempPath();
int   iphone_get_dpi();
}
#endif


#ifdef PALM_WEBOS
extern "C"
{
typedef enum
{
PDL_NOERROR         = 0,
PDL_EMEMORY,        /* Memory failure */
PDL_ECONNECTION,    /* Connection error */
PDL_INVALIDINPUT,   /* Problem with the sent-in params */
PDL_EOTHER,         /* Other error */
PDL_UNINIT,         /* The function relies on a client-called init function that has never been called */
PDL_NOTALLOWED,     /* A configurable option prevents the operation from succeeding (Ex: Location Services disabled by user = GPS won't work) */
PDL_LICENSEFAILURE, /* The license of the application is invalid or missing. */
PDL_STRINGTOOSMALL, /* A sent-in string that was to be filled was too small for the data needed */
PDL_SYSTEMERROR_FILE, /* A OS data file or database external to PDL is missing or malformed*/
PDL_SYSTEMERROR_NET,  /* Networking is disabled or inavailable*/
PDL_APPINFO      	 /* PDL was unable to find the appinfo.json file, and thus does know know any of 
the information therein, nor does it know the top level of the app's directory tree. */
} PDL_Err;
const char *PDL_GetHardware();
PDL_Err PDL_GetUniqueID(char *buffer, int bufferLen);
PDL_Err PDL_GetDataFilePath(const char *dataFileName, char *buffer, int bufferLen);
PDL_Err PDL_GetLanguage(char *buffer, int bufferLen);
PDL_Err PDL_LaunchBrowser(const char* Url);
PDL_Err PDL_Init(unsigned int flags);
void PDL_Quit();
}
#endif

#ifdef ANDROID
extern "C"
{	int android_battery_level();
const char* android_device_id();
const char* android_lang();
const char* android_ext_storage_pub_dir();
int android_keyboard();
int android_get_dpi();
const char*  android_JAVACALL(const char* string); // Space Fractal
DGInt CheckAssetFile(DGStr, int); // Space Fractal
DGStr JavaCall_Str(DGStr); // Space Fractal
}
#endif

#ifdef MACOSX
extern "C" const char* MacGetDocumentsPath();
extern "C" const char* MacSettingsDir();
#endif


// -------------------------------------
// PLATFORMINFO$()
// -------------------------------------
DGStr PLATFORMINFO_Str(DGStr WhatInfo)
{
DGStr origInfo = WhatInfo;
WhatInfo = UCASE_Str(WhatInfo);
if(WhatInfo[0] == '\0')
{
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
return DGStr("GP2X");
#elif defined(PANDORA)
return DGStr("PANDORA");
#elif defined(RASPBERRY_PI)
return DGStr("ARM-LINUX-EGL");
#elif defined(POCKETPC)
return DGStr("WINCE");
#elif defined(TARGET_OS_IPHONE)
return DGStr("IPHONE");
#elif defined(MACOSX)
return DGStr("MACOSX");
#elif defined(PALM_WEBOS)
return DGStr("WEBOS");
#elif defined(ANDROID)
return DGStr("ANDROID");
#elif defined(LINUX)
return DGStr("LINUX");
#elif defined(EMSCRIPTEN)
return DGStr("JAVASCRIPT");
#else
return DGStr("WIN32");
#endif
}
else if(WhatInfo.compare("DEVICE")==0)
{
#ifdef POCKETPC
unsigned char szPlatform[512];
#ifndef SPI_GETPLATFORMTYPE
#define SPI_GETPLATFORMTYPE 257
#endif
if(SystemParametersInfo(SPI_GETPLATFORMTYPE, 512, szPlatform, 0))
{
DGStr platform;
#ifdef UNICODE
platform.assign((const wchar_t*)szPlatform);
#else
platform.assign((const char*)szPlatform);
#endif
if(platform== CGStr("Smartphone")) return DGStr("SMARTPHONE");
if(platform== CGStr("PocketPC"))   return DGStr("POCKETPC");
}
return DGStr("WINCE");
#elif defined(GP2X)
if(pDXin->dev_touchscreen >= 0)
{
return DGStr("F200");
}
else
{
return DGStr("F100");
}
#elif defined(GPHWIZ)
return DGStr("WIZ");
#elif defined(CAANOO)
return DGStr("CAANOO");
#elif defined(TARGET_OS_IPHONE) // SPACE FRACTAL
switch(isIphone())
{
case 1:
return DGStr("IPHONE");
case 2:
return DGStr("IPAD");
case 3:
return DGStr("OLDIOS");
case 4:
return DGStr("TVOS");
}
return DGStr("IPOD TOUCH");
#elif defined(PALM_WEBOS)
DGStr hw = UCASE_Str(DGStr(PDL_GetHardware()));
if (hw == CGStr("UNKNOWN"))
{
// can be veer, pre2, pre3 or touchpad. PDL_GetHardwareID since SDK 2.0 - shit!
DGNat sx, sy;
GETSCREENSIZE(sx, sy);
if(sx>700 && sy>700)
return DGStr("TOUCHPAD"); // easy.
if(sx>400 || sy>400) // not a pixi/veer
return DGStr("PRE");
return DGStr("PIXI");
}
return hw;
#elif defined(ANDROID)
if(android_keyboard() )
return DGStr("KEYBOARD");
return DGStr("TOUCHSCREEN");
#else
return DGStr("DESKTOP");
#endif
}
else if( strncmp(WhatInfo.c_str(), "GLEXT:",6) == 0)
{
#ifndef GLB_CONSOLE
void* pFoo = (void*)glGFGetProcAddressArb(origInfo.c_str() + 6);
if(pFoo != NULL)
return DGStr("1");
#endif
return DGStr("0");
}
else if(WhatInfo.compare("ID")==0)
{
#if defined(_WIN32_WCE)
// #define CTL_CODE(DeviceType, Function, Method, Access) (((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method))
// #define IOCTL_HAL_GET_DEVICEID CTL_CODE(FILE_DEVICE_HAL, 21, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_HAL_GET_DEVICEID 0x01010054

unsigned char buffer[512];
DWORD bytesReturned=0;
DGStr retval;
// extern BOOL __stdcall KernelIoControl(DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned);
HINSTANCE hi = LoadLibraryW(TEXT("coredll.dll"));
if(hi)
{
typedef BOOL (*KernelIoControlptr)(DWORD, LPVOID, DWORD, LPVOID, DWORD, LPDWORD);
KernelIoControlptr KernelIoControl = (KernelIoControlptr) GetProcAddressW(hi, (LPSTR)TEXT("KernelIoControl"));
if(KernelIoControl)
{
if(!KernelIoControl(IOCTL_HAL_GET_DEVICEID, NULL, 0, (void*)buffer, 512, &bytesReturned))
{
// Some older PPC devices only return the ID if the buffer == 16 bytes long
if(!KernelIoControl(IOCTL_HAL_GET_DEVICEID, 0, 0, (void*)buffer, 16, &bytesReturned)) retval = DGStr("FA17ED");
else retval = __Bytes2Hex(buffer, bytesReturned);
}
else retval = __Bytes2Hex(buffer, bytesReturned);
}
FreeLibrary(hi);
return retval;
}
#elif defined(GP2X)
char buffer[32]; memset(buffer, 0, 32);
if(FetchGP2XSerial(buffer))
return CGStr(buffer);
#elif defined(GPHWIZ) || defined(CAANOO)
{
GFFileSystem fs;
int rnd = (unsigned short)(GETTIMERALL() + 0x194ad2f3);
if(fs.OpenIn("/etc/devid"))
{
fs.ReadLong(rnd);
fs.Close();
}
else
{
if(fs.OpenOut("/etc/devid"))
{
fs.WriteLong(rnd);
}
}
return DGStr(rnd);
}
#elif defined(PALM_WEBOS)
DGStr buf;
PDL_GetUniqueID(buf.getbuffer(255), 255);
buf.releasebuffer();
if(LEN(buf))
return buf;
#elif defined(LINUX)
hd_driveid id;
int fd = open("/dev/hda", O_RDONLY|O_NONBLOCK);
if (fd >= 0 && !ioctl(fd, HDIO_GET_IDENTITY, &id))
{
return DGStr((const char*)id.serial_no);
}
#elif defined(WIN32) // win32
DWORD dwSerial=0;
::GetVolumeInformation(_T("C:"), NULL, 0, &dwSerial, NULL, NULL, NULL, 0);
if(dwSerial)
{
dwSerial ^= 0x194ad2f3;
return __Bytes2Hex((unsigned char*)&dwSerial, 4);
}
//		#elif defined(TARGET_OS_IPHONE)
//			return DGStr( iPhoneDeviceID()); - no longer allowed by Apple
#elif defined(ANDROID)
return DGStr(android_device_id());
#elif defined(EMSCRIPTEN)
return DGStr("NO_DATA"); // GF_TODO
#endif

// x-platform fallback: use a random number stored in a file in APPDATA (per App on iOS)
DGStr tmpfile = PLATFORMINFO_Str(CGStr("APPDATA")) + CGStr("/glbasic.deviceid");
GFFileSystem fs;
if(DOESFILEEXIST(tmpfile))
{
if(fs.OpenIn(tmpfile))
{
DGStr id;
int sz = (int)fs.GetSize();
fs.Read(id.getbuffer(sz+1), sz);
id.getbuffer(sz+1)[sz]='\0';
id.releasebuffer();
id  =TRIM_Str(id);
fs.Close();
if(id.len()) return id;
}
}
DGStr a,b,c,d;
DGNat n = (rand()<<16) | RND(32767);
a=__Bytes2Hex((unsigned char*)&n, 4);
time_t long_time;
time( &long_time );                /* Get time as long integer. */
b=__Bytes2Hex((unsigned char*)&long_time, 4);
n = (RND(32767)<<16) | rand();
c=__Bytes2Hex((unsigned char*)&n, 4);
n = (DGNat)GETTIMERALL() + (RND(32767)<<16);
d=__Bytes2Hex((unsigned char*)&n, 4);
a = a+b+c+d;

if(fs.OpenOut(tmpfile))
{
if(fs.Write(a.c_str(), a.len()))
{
fs.Close();
return a;
}
}

// nothing worked :(
return DGStr("FA17ED");
}
else if(WhatInfo.compare("TIME")==0)
{
struct tm *newtime;
time_t long_time;
time( &long_time );                /* Get time as long integer. */
newtime = localtime( &long_time ); /* Convert to local time. */

#define FORMAT2DIGITS(a) (INTEGER(a)>9 ? DGStr(INTEGER(a)) : (DGStr("0")+DGStr(INTEGER(a))))

return DGStr(1900+newtime->tm_year)+CGStr("-")+FORMAT2DIGITS(newtime->tm_mon+1)+CGStr("-")+FORMAT2DIGITS(newtime->tm_mday)+
CGStr(" ")+FORMAT2DIGITS(newtime->tm_hour)+DGStr(":")+FORMAT2DIGITS(newtime->tm_min)+CGStr(":")+FORMAT2DIGITS(newtime->tm_sec);
#undef FORMAT2DIGITS
}
else if(WhatInfo.compare("UTCTIME")==0)
{
struct tm *newtime;
time_t long_time;
time( &long_time );                /* Get time as long integer. */
newtime = gmtime( &long_time );    /* Convert to universal time. */

#define FORMAT2DIGITS(a) (INTEGER(a)>9 ? DGStr(INTEGER(a)) : (DGStr("0")+DGStr(INTEGER(a))))

return DGStr(1900+newtime->tm_year)+CGStr("-")+FORMAT2DIGITS(newtime->tm_mon+1)+CGStr("-")+FORMAT2DIGITS(newtime->tm_mday)+
CGStr(" ")+FORMAT2DIGITS(newtime->tm_hour)+DGStr(":")+FORMAT2DIGITS(newtime->tm_min)+CGStr(":")+FORMAT2DIGITS(newtime->tm_sec);
#undef FORMAT2DIGITS
}
else if (WhatInfo.compare("BATTERY")==0)
{
#if defined(_WIN32_WCE)
SYSTEM_POWER_STATUS_EX2 pwr;
GetSystemPowerStatusEx2(&pwr, sizeof(pwr), TRUE);
return DGStr(MIN(100, DGNat(pwr.BatteryLifePercent)));
#elif defined(WIN32)
SYSTEM_POWER_STATUS pwr;
GetSystemPowerStatus(&pwr);
return DGStr(MIN(100, DGNat(pwr.BatteryLifePercent)));
#elif defined(GP2X)
return DGStr(DGNat(gp2x_wiz_battery()));
#elif defined(TARGET_OS_IPHONE)
return DGStr((DGNat)(iPhoneBattery()*100.0));
#elif defined(ANDROID)
return DGStr((DGNat)android_battery_level());
#elif defined(EMSCRIPTEN)
return DGStr("NO_DATA"); // GF_TODO
#elif defined(LINUX) || defined(GPHWIZ) || defined(CAANOO)
return DGStr(DGNat(linux_battery_level() ));
#endif
return DGStr(100);
}
else if (WhatInfo.compare("COMPILED")==0)
{
return __CompileTime();
}
else if (WhatInfo.compare("HOSTID")==0)
{
return __BuildSerial();
}
else if(WhatInfo.compare("VERSION")==0)
{
return __GetPrpjectVersionGLB();
}
else if(WhatInfo.compare("LOCALE")==0)
{
const char* pLang="us";
#if defined(TARGET_OS_IPHONE)
char cco[4];
cco[0]='\0';
iPhoneGetCountryInto(cco);
pLang = cco;
#elif defined(PALM_WEBOS)
DGStr buf;
int rv = PDL_GetLanguage(buf.getbuffer(64), 63);
if(PDL_NOERROR != buf)
{
buf="us";
}
buf.releasebuffer();
return buf;
#elif defined(WIN32)
#ifdef _WIN32_WCE
unsigned int id = 0x0c09; // "en" #NEED - missing in header
#else
unsigned int id = GetSystemDefaultUILanguage();
#endif

switch(id)
{
case 0x0436: pLang = "AF"; break;
case 0x041c: pLang = "SQ"; break;
case 0x1401: pLang = "AR"; break;
case 0x3c01: pLang = "AR"; break;
case 0x0c01: pLang = "AR"; break;
case 0x0801: pLang = "AR"; break;
case 0x2c01: pLang = "AR"; break;
case 0x3401: pLang = "AR"; break;
case 0x3001: pLang = "AR"; break;
case 0x1001: pLang = "AR"; break;
case 0x1801: pLang = "AR"; break;
case 0x2001: pLang = "AR"; break;
case 0x4001: pLang = "AR"; break;
case 0x0401: pLang = "AR"; break;
case 0x2801: pLang = "AR"; break;
case 0x1c01: pLang = "AR"; break;
case 0x3801: pLang = "AR"; break;
case 0x2401: pLang = "AR"; break;
case 0x042b: pLang = "HY"; break;
case 0x044d: pLang = "AS"; break;
case 0x082c: pLang = "AZ"; break;
case 0x042c: pLang = "AZ"; break;
case 0x042d: pLang = "EU"; break;
case 0x0423: pLang = "BE"; break;
case 0x0445: pLang = "BE"; break;
case 0x0402: pLang = "BG"; break;
case 0x0403: pLang = "CA"; break;
case 0x0c04: pLang = "ZH"; break;
case 0x1404: pLang = "ZH"; break;
case 0x0804: pLang = "CH"; break;
case 0x1004: pLang = "ZH"; break;
case 0x0404: pLang = "CH"; break;
case 0x0827: pLang = "LT"; break;
case 0x041a: pLang = "HR"; break;
case 0x0405: pLang = "CS"; break;
case 0x0406: pLang = "DA"; break;
case 0x0465: pLang = "DI"; break;
case 0x0813: pLang = "NL"; break;
case 0x0413: pLang = "NL"; break;
case 0x0c09: pLang = "EN"; break;
case 0x2809: pLang = "EN"; break;
case 0x1009: pLang = "EN"; break;
case 0x2409: pLang = "EN"; break;
case 0x1809: pLang = "EN"; break;
case 0x2009: pLang = "EN"; break;
case 0x1409: pLang = "EN"; break;
case 0x3409: pLang = "EN"; break;
case 0x1c09: pLang = "EN"; break;
case 0x2c09: pLang = "EN"; break;
case 0x0809: pLang = "EN"; break;
case 0x0409: pLang = "UK"; break; // wibble on uk computer - should be us
case 0x3009: pLang = "EN"; break;
case 0x0425: pLang = "ET"; break;
case 0x0438: pLang = "FO"; break;
case 0x0429: pLang = "FA"; break;
case 0x040b: pLang = "FI"; break;
case 0x080c: pLang = "FR"; break;
case 0x0c0c: pLang = "FR"; break;
case 0x040c: pLang = "FR"; break;
case 0x140c: pLang = "FR"; break;
case 0x180c: pLang = "FR"; break;
case 0x100c: pLang = "FR"; break;
case 0x042f: pLang = "MK"; break;
case 0x0456: pLang = "GL"; break;
case 0x0437: pLang = "KA"; break;
case 0x0c07: pLang = "DE"; break;
case 0x0407: pLang = "DE"; break;
case 0x1407: pLang = "DE"; break;
case 0x1007: pLang = "DE"; break;
case 0x0807: pLang = "DE"; break;
case 0x0408: pLang = "EL"; break;
case 0x0447: pLang = "GU"; break;
case 0x040d: pLang = "HE"; break;
case 0x0439: pLang = "HI"; break;
case 0x040e: pLang = "HU"; break;
case 0x040f: pLang = "IS"; break;
case 0x0421: pLang = "IN"; break;
case 0x0410: pLang = "IT"; break;
case 0x0810: pLang = "IT"; break;
case 0x0411: pLang = "JP"; break;
case 0x044b: pLang = "KA"; break;
case 0x043f: pLang = "KK"; break;
case 0x0457: pLang = "KN"; break;
case 0x0412: pLang = "KO"; break;
case 0x0440: pLang = "KY"; break;
case 0x0426: pLang = "LV"; break;
case 0x0427: pLang = "LT"; break;
case 0x083e: pLang = "MS"; break;
case 0x043e: pLang = "MS"; break;
case 0x044c: pLang = "MA"; break;
case 0x044e: pLang = "MA"; break;
case 0x0450: pLang = "MO"; break;
case 0x0414: pLang = "NO"; break;
case 0x0814: pLang = "NO"; break;
case 0x0448: pLang = "OR"; break;
case 0x0415: pLang = "PL"; break;
case 0x0416: pLang = "PT"; break;
case 0x0816: pLang = "PT"; break;
case 0x0446: pLang = "PA"; break;
case 0x0418: pLang = "RO"; break;
case 0x0419: pLang = "RU"; break;
case 0x044f: pLang = "SA"; break;
case 0x0c1a: pLang = "SR"; break;
case 0x081a: pLang = "SR"; break;
case 0x041b: pLang = "SK"; break;
case 0x0424: pLang = "SL"; break;
case 0x2c0a: pLang = "ES"; break;
case 0x400a: pLang = "ES"; break;
case 0x340a: pLang = "ES"; break;
case 0x240a: pLang = "ES"; break;
case 0x140a: pLang = "ES"; break;
case 0x1c0a: pLang = "ES"; break;
case 0x300a: pLang = "ES"; break;
case 0x440a: pLang = "ES"; break;
case 0x100a: pLang = "ES"; break;
case 0x480a: pLang = "ES"; break;
case 0x080a: pLang = "ES"; break;
case 0x4c0a: pLang = "ES"; break;
case 0x180a: pLang = "ES"; break;
case 0x3c0a: pLang = "ES"; break;
case 0x280a: pLang = "ES"; break;
case 0x500a: pLang = "ES"; break;
case 0x040a: pLang = "ES"; break;
case 0x0c0a: pLang = "ES"; break;
case 0x380a: pLang = "ES"; break;
case 0x200a: pLang = "ES"; break;
case 0x0441: pLang = "SW"; break;
case 0x081d: pLang = "SV"; break;
case 0x041d: pLang = "SV"; break;
case 0x045a: pLang = "SY"; break;
case 0x0449: pLang = "TA"; break;
case 0x0444: pLang = "TT"; break;
case 0x044a: pLang = "TE"; break;
case 0x041e: pLang = "TH"; break;
case 0x041f: pLang = "TR"; break;
case 0x0422: pLang = "UK"; break;
case 0x0420: pLang = "UR"; break;
case 0x0820: pLang = "UR"; break;
case 0x0843: pLang = "UZ"; break;
case 0x0443: pLang = "UZ"; break;
case 0x042a: pLang = "VI"; break;
}
#elif defined(ANDROID)
pLang = android_lang();
#else
pLang = getenv("LANG");
if(!pLang) pLang="us";
#endif
DGStr c = pLang;
c.lower();

if(c=="eng" || c=="english-uk") c="uk";
c.left(2);
if(c == "c")  c="us";
if(c == "el") c="gr";
if(c == "du") c="nl";
if(c == "am") c="us"; // america or armenia?
if(c == "en") c="us"; // any english -> go usa
if(c == "ja") c="jp";
if(c == "po") c="pl";
if(c.len()!=2) return "us";
return c;
}
else if(WhatInfo.compare("DOCUMENTS")==0)
{
#if defined(_WIN32_WCE)
return DGStr("/My Documents");
#elif defined(WIN32)
DGStr path;
#ifdef UNICODE
wchar_t wpath[1024];
BOOL ok = SHGetSpecialFolderPath((HWND)GLBASIC_HWND(), wpath, CSIDL_PERSONAL, FALSE);
path.assign((const wchar_t*)wpath);
#else
BOOL ok = SHGetSpecialFolderPath((HWND)GLBASIC_HWND(), path.getbuffer(1024), CSIDL_PERSONAL, FALSE);
path.releasebuffer();
#endif
if(!ok) return DGStr("NO_DATA");
path = REPLACE_Str(path, CGStr("\\"), CGStr("/"));
return path;
#elif defined(TARGET_OS_IPHONE)
return DGStr(iPhoneGetDocumentsPath());
#elif defined(MACOSX)
return DGStr(MacGetDocumentsPath());
#elif defined(ANDROID)
return DGStr(android_ext_storage_pub_dir());
#elif defined(EMSCRIPTEN)
return DGStr("/tmp"); // GF_TODO
#elif defined(POSIX)
DGStr home = GETENV_Str("HOME");

#if defined(PALM_WEBOS)
if (home == CGStr("/home/root")) // started with root shell
{
GFFileSystem::GetExeDir(home.getbuffer(1024)); // Yikes!!
home.releasebuffer();
home = RTRIM_Str(home, "/");
}
#endif
if(LEN(home)==0)
return DGStr("~");
return home;
#endif
}
else if(WhatInfo.compare("APPDATA")==0)
{
DGStr path;
#if defined(WIN32) && !defined(_WIN32_WCE)
#ifdef UNICODE
wchar_t wpath[1024];
BOOL ok = SHGetSpecialFolderPath((HWND)GLBASIC_HWND(), wpath, CSIDL_LOCAL_APPDATA, FALSE);
path.assign((const wchar_t*)wpath);
#else
BOOL ok = SHGetSpecialFolderPath((HWND)GLBASIC_HWND(), path.getbuffer(1024), CSIDL_LOCAL_APPDATA, FALSE);
path.releasebuffer();
#endif
if(!ok) return DGStr("NO_DATA");
path = REPLACE_Str(path, CGStr("\\"), CGStr("/"));
path += CGStr("/GLBasic");
#elif defined(MACOSX)
path = DGStr(MacSettingsDir());
#elif defined(ANDROID)
path = DGStr(android_files_dir()) + CGStr("/.glbasic");
#else
// Default to documents directory
path = PLATFORMINFO_Str(CGStr("DOCUMENTS")) + CGStr("/.glbasic");
#endif

if(!GFFileSystem::DoesDirExist(path.c_str()) )
GFFileSystem::MkDir(path.c_str());
return path;
}
else if(WhatInfo.compare("TEMP")==0)
{
DGStr path;
#ifdef WIN32
#ifdef UNICODE
wchar_t wpath[1024] = L"";
::GetTempPathW(1024, wpath);
path.assign((const wchar_t*)wpath);
#else
::GetTempPathA(1024, path.getbuffer(1024));
path.releasebuffer();
#endif
if(LEN(path)==0)
{
GFFileSystem::MkDir("C:\\Temp");
return DGStr("C:/Temp");
}
path = REPLACE_Str(path, CGStr("\\"), CGStr("/"));
return path;
#elif defined(TARGET_OS_IPHONE)
return DGStr(iPhoneGetTempPath() );
#elif defined(ANDROID)
return DGStr( android_cache_dir() );
#elif defined(GPHWIZ) || defined(GP2X) || defined(CAANOO)
return DGStr("/mnt/sd"); // don't write to nand
#elif defined(PALM_WEBOS)
DGStr tmp = PLATFORMINFO_Str(DGStr("DOCUMENTS")) + CGStr("/temp");
GFFileSystem::MkDir(tmp.c_str());
return tmp;
#elif defined(EMSCRIPTEN)
return DGStr("/tmp");
#elif defined(MACOSX) || defined(POSIX) // would also work on iPhone, but better be safe
DGStr tmp = GETENV_Str(CGStr("TMPDIR"));
if(LEN(tmp)==0)
return DGStr("/tmp");
return tmp;
#else
#error no TEMP preprocessor define in platforminfo
#endif
}
else if(WhatInfo.compare("DPI")==0)
{
DGNat dpi = 96;
#if defined( WIN32) && !defined(GLB_CONSOLE)
HDC screen = ::GetDC(0);
dpi = GetDeviceCaps (screen, LOGPIXELSX);
::ReleaseDC (0, screen);
#elif defined(TARGET_OS_IPHONE)
dpi = iphone_get_dpi();
#elif defined(ANDROID)
dpi = android_get_dpi();
#elif defined(GPHWIZ) || defined(GP2X) || defined(CAANOO)
dpi = 114;
#elif defined(PALM_WEBOS)
dpi = 186;
#elif defined(MACOSX) || defined(POSIX) // would also work on iPhone, but better be safe
#else // GF_TODO EMSCRIPTEN
#endif

if(dpi < 96) dpi = 96; // that's a bug obviously! MAC from 1987 had 72

return DGStr(dpi);
}
return DGStr("NO_DATA");
}



extern "C"
{
#if defined (POSIX)
extern char **environ;
#define envptr environ
#elif defined (_WIN32_WCE)
extern char **environ;
#define envptr environ
#else
extern char **_environ;
#define envptr _environ
#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGStr   GETENV_Str(DGStr name)
{
if(LEN(name)==0)
{
char **next = envptr;
DGStr all;
while (*next) 
{
all+=*next;
all+=CGStr("\n");
++next;
}
return all;
}
else
{
char* pEnv = getenv(name.c_str());
if(!pEnv)
return DGStr("");
return DGStr((const char*)pEnv);
}
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void	PUTENV(DGStr name, DGStr value)
{
#ifdef _WIN32
#define putenv _putenv
#endif
name += CGStr("=") + value;
putenv(name);
}


////////////////////////
// DISC ACCESS FUNCTIONS
////////////////////////

// ------------------------------------------------------------- //
// Attaching a shoebox
// ------------------------------------------------------------- //
void SETSHOEBOX(const DGStr& data, const DGStr& media)
{ // Space Fractal, if the shoebox file is in the apk, make sure its got extracted from that.
#ifdef ANDROID
DOESFILEEXIST(data);
DOESFILEEXIST(media);
#endif

#ifdef WANT_SHOEBOX
__g_ShoeBox_Data->SetBox(data.c_str());
__g_ShoeBox_Media->SetBox(media.c_str());
#endif
}

// ------------------------------------------------------------- //
// Class for buffered file access
// ------------------------------------------------------------- //
class FAST_FILE
{
public:
FAST_FILE()			{m_filename[0]='\0'; FillBuffer(NULL);}
~FAST_FILE()		{FillBuffer(NULL);}
// ------------------------------------------------------------- //
// Read file to a buffer if buffer is different to file
// ------------------------------------------------------------- //
DGInt FillBuffer(const char* filename)
{
CLEARERROR();
if (filename == NULL || strcmp(m_filename, filename)!=0)
{
GFFileSystem	file;
// Write changed Data - not updated in shoebox, data get's void
if (m_filename != NULL && strlen(m_filename) && m_changed)
{
if(file.OpenOut(m_filename))
{
for(long i=0; i<=m_maxline; i++)
file.WriteLine(m_buffer[i]);
file.Close();
}
}

// Clear Data
memset(m_buffer, 0, sizeof(m_buffer));
m_changed=0;
m_maxline=0;
m_filename[0] = '\0';
if(filename!=NULL)
strcpy(m_filename, filename);
else
return CMP_OK; // Accessing the file that's already in buffer

// Read Data - even from shoebox

char TempFileName[1024];
strcpy(TempFileName, m_filename);

if (file.OpenIn(TempFileName))
{
long i=0;
for(;;)
{
if (!file.ReadLine(m_buffer[i], 1024))
break;
m_maxline=i;
i++;
if (i>255) break;
}
file.Close();
}
else
{
return __Error(CMP_NO_FILE);
}
}
return CMP_OK;
}

char m_filename[1024];
char m_buffer[256][1024];
long m_maxline;
char m_changed;
};

inline FAST_FILE& __get_FastFile(){static FAST_FILE ff; return ff;}
#define __g_FastFile __get_FastFile()


// PUTFILE
// ------------------------------------------------------------- //
DGInt PutFile(const char* filename, int line, const DGStr& data)
{
CLEARERROR();
if (line > 255 || line < 0) return __Error(CMP_OUT_OF_MEMORY);

__g_FastFile.FillBuffer(filename);

strcpy(__g_FastFile.m_buffer[line], data.c_str());
if (line>__g_FastFile.m_maxline)
__g_FastFile.m_maxline = line;
__g_FastFile.m_changed=1;
return CMP_OK;
}

// GETFILE
// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGInt GetFile(const char* filename, int line, DGStr& data)
{	
CLEARERROR();
if (line > 255 || line < 0)
{
data="NO_DATA";
return __Error(CMP_OUT_OF_MEMORY);
}



DGInt nerr=__g_FastFile.FillBuffer(filename);
if (nerr!=CMP_OK)
{
data="NO_FILE";
return nerr;
}

data=(const char*)__g_FastFile.m_buffer[line];
data.trimright();
if(data.len()==0 || data[0]=='\0')
data="NO_DATA";
return CMP_OK;
}

// ------------------------------------------------------------- //
// New File IO
// ------------------------------------------------------------- //
// number of file handles (OPENFILE)
#define MAX_IO_FILES	8
GFFileSystem __g_Files[MAX_IO_FILES];

DGNat	GENFILE()
{
for(int channel=0; channel<MAX_IO_FILES; ++channel)
{
if(!__g_Files[channel].IsOpen())
return channel;
}
return -1;
}


int64	GETFILESIZE(const DGStr& file)
{	
CLEARERROR();
GFFileSystem fs;
if(fs.OpenIn(file.c_str()))
{
return (int64) fs.GetSize();
}
else
{
__Error(CMP_NO_FILE);
}
return 0;
}

DGStr	GETFILETIME_Str(const DGStr& str)
{
CLEARERROR();
GFFileSystem fs;
DGStr ss = fs.GetFileTime(str.c_str());
if(ss.len() == 0)
{
__Error(CMP_NO_FILE);
}
return ss;
}

DGNat	ENDOFFILE(DGNat channel)
{

if(!__g_Files[(int)channel].IsOpen())
{
__Error(CMP_NO_FILE);
}
return (DGNat)__g_Files[(int)channel].Eof();
}

DGNat	OPENFILE(DGNat channel, const DGStr& file, DGNat mode)
{
CLEARERROR();
if(channel>=MAX_IO_FILES || channel<0)
{
__Error(CMP_OUT_OF_MEMORY);
return 0;
}
__g_Files[(int)channel].Close();
if(mode>0) // READ
{
DGStr s(file);
if(!glb_prepare_reading_file(s))
{
__Error(CMP_NO_FILE);
return FALSE;
}
bool rv = __g_Files[(int)channel].OpenIn(s.c_str());
return rv ? TRUE : FALSE;	
}
else // WRITE/APPEND
{
if (mode==0) // append
{
int rv = __g_Files[(int)channel].OpenOut(file.c_str());
if(!rv)
__Error(CMP_NO_FILE);
return rv;
}
else
{
int rv = __g_Files[(int)channel].OpenAppend(file.c_str());
if(!rv)
__Error(CMP_NO_FILE);
return rv;
}
}
}



void	CLOSEFILE(DGNat channel)
{
CLEARERROR();
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
__g_Files[(int)channel].Close();
#ifdef GP2X
system("sync");
#endif
}

void	READBYTE(DGNat channel, DGNat& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
signed char b=0;
if(!__g_Files[(int)channel].Read(&b, 1)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGNat) b;
}

void	READWORD(DGNat channel, DGNat& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
signed short b=0;
if(!__g_Files[(int)channel].ReadWord(b)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGNat) b;
}

void	READLONG(DGNat channel, DGNat& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
signed long b=0;
if(!__g_Files[(int)channel].ReadLong(b)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGNat) b;
}

void	READUBYTE(DGNat channel, DGNat& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
unsigned char b=0;
if(!__g_Files[(int)channel].Read(&b, 1)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGNat) b;
}

void	READUWORD(DGNat channel, DGNat& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
unsigned short b=0;
if(!__g_Files[(int)channel].ReadWord(b)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGNat) b;
}

void	READULONG(DGNat channel, DGNat& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
unsigned long b=0;
if(!__g_Files[(int)channel].ReadLong(b)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGNat) b;
}

void	READIEEE(DGNat channel, DGInt& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
double b=0;
if(!__g_Files[(int)channel].ReadDbl(b)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGInt) b;
}

void	READSHORTIEEE(DGNat channel, DGInt& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
float b=0;
if(!__g_Files[(int)channel].ReadFlt(b)) {__Error(CMP_NO_FILE); __EndProgram();}
v=(DGInt) b;
}


void	READSTR(DGNat channel, DGStr& v, DGNat nchar)
{
if(nchar<=0)
{
v=CGStr(""); return;
}
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}

memset(v.getbuffer(nchar+32), 0, nchar+32);
if(!__g_Files[(int)channel].Read(v.getbuffer(nchar+32), nchar)) {__Error(CMP_NO_FILE); __EndProgram();}
v.releasebuffer();
v.setlength(nchar); // allow \0 characters
}


void READLINE(DGNat channel, DGStr& v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
memset(v.getbuffer(1024), 0, 1024);
if(!__g_Files[(int)channel].ReadLine(v.getbuffer(1024), 1024)) {__Error(CMP_NO_FILE); __EndProgram();}
v.releasebuffer();
}

void READLINE(DGNat channel, DGInt& v)
{
DGStr str;
READLINE(channel, str);
v = (DGInt) str;
}
void READLINE(DGNat channel, DGNat& v)
{
DGStr str;
READLINE(channel, str);
v = (DGNat) str;
}


void	WRITEBYTE(DGNat channel, DGNat v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
char b=(char) v;
if(!__g_Files[(int)channel].Write(&b, 1)) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITEWORD(DGNat channel, DGNat v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
short b=(short) v;
if(!__g_Files[(int)channel].WriteWord(b)) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITELONG(DGNat channel, DGNat v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
long b=(long) v;
if(!__g_Files[(int)channel].WriteLong(b)) {__Error(CMP_NO_FILE); __EndProgram();}
}
void	WRITEUBYTE(DGNat channel, DGNat v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
unsigned char b=(unsigned char) v;
if(!__g_Files[(int)channel].Write(&b, 1)) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITEUWORD(DGNat channel, DGNat v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
unsigned short b=(unsigned short) v;
if(!__g_Files[(int)channel].WriteWord(b)) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITEULONG(DGNat channel, DGNat v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
unsigned long b=(unsigned long) v;
if(!__g_Files[(int)channel].WriteLong(b)) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITEIEEE(DGNat channel, DGInt v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
double b=(double) v;
if(!__g_Files[(int)channel].WriteDbl(b)) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITESHORTIEEE(DGNat channel, DGInt v)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
float b=(float) v;
if(!__g_Files[(int)channel].WriteFlt(b)) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITESTR(DGNat channel, const DGStr& str)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
if(!__g_Files[(int)channel].Write((void*)str.c_str(), str.len())) {__Error(CMP_NO_FILE); __EndProgram();}
}

void	WRITELINE(DGNat channel, const DGStr& str)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
if(		!__g_Files[(int)channel].Write((void*)str.c_str(), str.len())
||	!__g_Files[(int)channel].Write((void*)"\r\n", 2)) {__Error(CMP_NO_FILE); __EndProgram();}
}


int64	FILEPOSITION(DGNat channel)
{
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}
return __g_Files[(int)channel].Tell();
}

void	FILESEEK(DGNat channel, int64 bytes, DGNat direction)
{
// direction: -1=from end, 0=from start, 1=from current position
if(channel>=MAX_IO_FILES || channel<0){__Error(CMP_OUT_OF_MEMORY);__EndProgram();}

GFFileSystem::SEEK_FROM dir = GFFileSystem::seek_start;
if(direction<0)
dir = GFFileSystem::seek_end;
else if(direction>0)
dir=GFFileSystem::seek_current;
__g_Files[(int)channel].SeekTo(bytes, dir);
}



// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void ReverseSlashes(DGStr& str)
{
for (int i=0; i<(int)strlen(str.c_str()); i++)
{
if (str[i]=='\\')
str[i] = '/';
}
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void	KILLFILE(const DGStr& file)
{
GFFileSystem::Delete(file.c_str());
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGNat CREATEDIR(const DGStr& dir)
{
return GFFileSystem::MkDir(dir.c_str()) ? TRUE:FALSE;
}

//---------------------------------------------------------------//
//---------------------------------------------------------------//
DGStr REPLACE_Str(DGStr str, const DGStr& sOld, const DGStr& sNew)
{
return str.replace(sOld, sNew);
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void	COPYFILE(const DGStr& src, const DGStr& dst)
{
CLEARERROR();
GFFileSystem in, out;

DGStr thefile(src);
if(!glb_prepare_reading_file(thefile))
return;

if (in.OpenIn(thefile.c_str()) && out.OpenOut(dst.c_str()))
{
unsigned long sz = (unsigned long)in.GetSize();
const int bufsz = 4096;
char buffer[bufsz];
for(unsigned long i=0; i<sz; i+=bufsz)
{
unsigned long nread = bufsz;
if(i+nread>=sz) nread=sz-i;
if(!in.Read(buffer, (int)nread) || !out.Write(buffer, (int)nread))
{
in.Close();
out.Close();
GFFileSystem::Delete(dst.c_str());
}
}
}
else
{
__Error(CMP_NO_FILE);
}
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void MOVEFILE(const DGStr & src, const DGStr & dst)
{
CLEARERROR();
GFFileSystem fs;
if(!fs.MoveFile(src.c_str(), dst.c_str()))
{
__Error(CMP_NO_FILE);
}
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGNat	DOESFILEEXIST(const DGStr& file)
{
#if defined(ANDROID) // Copy AssestFile from APK if required.
int filesize=CheckAssetFile(file, 0); if (filesize>0) return TRUE;
filesize=CheckAssetFile(file, 0); if (filesize>0) return TRUE;
return GFFileSystem::DoesFileExist(file.c_str()) ? TRUE:FALSE;
#else
return GFFileSystem::DoesFileExist(file.c_str()) ? TRUE:FALSE;
#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGNat	DOESDIREXIST(const DGStr& dir)
{	
#if defined(ANDROID)
DGStr thedir = RTRIM_Str(dir, "/"); // Trailing slash is bad for Android
int	ok=CGStr(JavaCall_Str(CGStr("dircopy:")+thedir));
#endif

return GFFileSystem::DoesDirExist(dir.c_str()) ? TRUE:FALSE;
}



// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGStr	GETCURRENTDIR_Str()
{
DGStr			str;
char			dir[MAX_PATH+1];
GFFileSystem::GetCurrentDir(dir);
str=(const char*)dir;
for (int i=0; i<(int)strlen(str.c_str()); i++)
{
if (str[i]=='\\')
str[i] = '/';
}
ReverseSlashes(str);
if (str[(int)strlen(dir)-1]!='/') str+="/";
//	STDOUT(DGStr("GETCURRENTDIR:")+str+DGStr("\n"));
return str;
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGInt	SETCURRENTDIR(DGStr dir)
{
CLEARERROR();
#if defined(ANDROID) // Space Fractal - required to prevent crash in DOESFILEEXIST
if (dir==CGStr("Media") OR dir==CGStr("Media/"))
{	int ok=CREATEDIR(CGStr("Media"));
}
CREATEDIR(CGStr(dir)); // Space Fractal - Needs create dir, since its can been empty, if not extracted from APK.
#endif

#if defined(TARGET_OS_IPHONE)
CREATEDIR(CGStr(dir)); // Space Fractal - Odd, but seen this was required, because im did have some strange GETCURRENTDIR() bug.
#endif

#if defined(WIN32)
dir = dir.replace(DGStr("/"), DGStr("\\"));
#endif

int rv = GFFileSystem::SetCurrentDir(dir.c_str());
if(rv)
{
return TRUE;
}
else
{
__Error(CMP_NO_FILE);
return FALSE;
}
}

#if 0
// ------------------------------------------------------------- //
// check if a wildcard match is valid
// for *.* return all files, even w/o '.'
// ------------------------------------------------------------- //
bool szWildMatch(const char* pat, const char* str)
{
#define GF_lower(a) ((a>='A' && a<='Z') ? ((a)+'a'-'A') : (a))
const char* s, *p;
bool star = false;

// for *.*, return everything
if(pat[0]=='*' && pat[1]=='.' && pat[2]=='*' && pat[3]=='\0')
return true;

loopStart:
for (s=str,p=pat; *s; ++s,++p)
{
switch (*p)
{
case '?':
if (*s == '.') goto starCheck;
break;
case '*':
star = true;
str = s, pat = p;
do { ++pat; } while (*pat == '*');
if (!*pat) return true;
goto loopStart;
default:
if (GF_lower(*s) != GF_lower(*p))
goto starCheck;
break;
} /* endswitch */
} /* endfor */
while (*p == '*') ++p;
return (!*p);
starCheck:
if (!star) return false;
str++;
goto loopStart;
}
#else // much better version

//---------------------------------------------------------------//
// This function compares text strings, one of which can have wildcards ('*').
// http://www.drdobbs.com/architecture-and-design/matching-wildcards-an-algorithm/210200888
//---------------------------------------------------------------//
bool szWildMatch(
const char* pWildText,            // A (potentially) corresponding string with wildcards
const char* pTameText             // A string without wildcards
)
{
#define GF_lower(a) ((a>='A' && a<='Z') ? ((a)+'a'-'A') : (a))

// for * and *.*, return everything
if(pWildText[0]=='*' && pWildText[1]=='\0')
return true;
if(pWildText[0]=='*' && pWildText[1]=='.' && pWildText[2]=='*' && pWildText[3]=='\0')
return true;


bool bMatch = TRUE;
const char* pAfterLastWild = NULL; // The location after the last '*', if weve encountered one
const char* pAfterLastTame = NULL; // The location in the tame string, from which we started after last wildcard
char t, w;

// Walk the text strings one character at a time.
for(;;)
{
t = *pTameText;
w = *pWildText;

// How do you match a unique text string?
if (!t)
{
// Easy: unique up on it!
if (!w )
{
break;                                   // "x" matches "x"
}
else if (w == '*')
{
pWildText++;
continue;                           // "x*" matches "x" or "xy"
}
else if (pAfterLastTame)
{
if (!(*pAfterLastTame))
{
bMatch = false;
break;
}
pTameText = pAfterLastTame++;
pWildText = pAfterLastWild;
continue;
}

bMatch = false;
break;                                           // "x" doesn't match "xy"
}
else
{
// Lowercase the characters to be compared.
t = GF_lower(t);
w = GF_lower(w);

// How do you match a tame text string?
if (t != w)
{
// The tame way: unique up on it!
if (w == '*')
{
pAfterLastWild = ++pWildText;
pAfterLastTame = pTameText;
w = *pWildText;

if (!w )
{
break;                           // "*" matches "x"
}
continue;                           // "*y" matches "xy"
}
else if (pAfterLastWild)
{
if (pAfterLastWild != pWildText)
{
pWildText = pAfterLastWild;
w = *pWildText;

w = GF_lower(w);

if (t == w)
{
pWildText++;
}
}
pTameText++;
continue;                           // "*sip*" matches "mississippi"
}
else
{
bMatch = false;
break;                                   // "x" doesn't match "y"
}
}
}

pTameText++;
pWildText++;
}

return bMatch;
}

#endif



#ifndef WIN32
long IsDirectory(const char* path)
{
struct stat stbuf;
if( stat(path, &stbuf) )
return 0;
return ((stbuf.st_mode & S_IFMT)==S_IFDIR) ? 1:0;
}
#endif


DGInt __CompareNoCase(DGStr& a, DGStr& b)
{
return (DGNat)stricmp(a.c_str(), b.c_str());
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGInt	GETFILELIST(const DGStr& wildcard, DGStrArray& files)
{
Queue<DGStr>	qfiles, qdirs;
DGStr			str;
str.alloc(1024,false);



#ifdef WIN32
HANDLE			hfnd;
WIN32_FIND_DATA	fnd;

#if defined(_WIN32_WCE) || defined(POCKETPC)// no relative paths
DGStr csdir;
GFFileSystem::GetCurrentDir(csdir.getbuffer(1024));
csdir.releasebuffer();
csdir = csdir.replace(DGStr("/"), DGStr("\\"));
csdir += DGStr("\\*.*");
#ifdef UNICODE
wchar_t wdir[512]=_T("*.*");
mbstowcs(wdir, csdir.c_str(), 512);
#else
const char* wdir = csdir.c_str();
#endif
hfnd = FindFirstFile(wdir, &fnd);
#else
DGStr cur_dir = GETCURRENTDIR_Str(); // has appended "/"
cur_dir.replace(DGStr("/"), DGStr("\\"));
hfnd = FindFirstFile((cur_dir + CGStr("*.*")).c_str(), &fnd);

// this might be a reparse point that denies access to directory listing
// to prevent legacy apps to double backup that dir.
if(hfnd == INVALID_HANDLE_VALUE)
{
// no UNICODE here - we're on Win32
DWORD att = ::GetFileAttributes(cur_dir.c_str());

// It's a reparse point - see if we can list the target
if(att!=INVALID_FILE_ATTRIBUTES && (att & FILE_ATTRIBUTE_REPARSE_POINT) )
{
HANDLE hDir = ::CreateFile(cur_dir.c_str(), FILE_READ_ATTRIBUTES, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_OPEN_REPARSE_POINT | FILE_FLAG_BACKUP_SEMANTICS, NULL);
BYTE* buf = new BYTE[16*1024]; // We need a large buffer
DWORD dwRet=0;

// #define FSCTL_GET_REPARSE_POINT 0x000900A8
if (::DeviceIoControl(hDir, 0x000900A8, NULL, 0, buf, 16*1024, &dwRet, NULL))
{
LPCWSTR pPath = (LPCWSTR)(buf+16); // ReparseBuffer.ReparseTarget;
if (wcsncmp(pPath, L"\\??\\", 4) == 0) pPath += 4;  // Skip 'non-parsed' prefix
::WideCharToMultiByte(CP_ACP, 0, pPath, -1, cur_dir.getbuffer(1024), 1024, NULL, NULL);
cur_dir.releasebuffer();
cur_dir += CGStr("\\");
}
delete[] buf; buf=NULL;
::CloseHandle(hDir);
}
FindClose(hfnd);
hfnd = FindFirstFile((cur_dir + CGStr("*.*")).c_str(), &fnd);
}
#endif

#ifdef _DEBUG
if(hfnd == INVALID_HANDLE_VALUE)
GFFileSystem::StrLastError();
#endif

while(hfnd!=INVALID_HANDLE_VALUE)
{
#ifdef UNICODE
int nlen=(int)wcslen(fnd.cFileName)+1;
_wcstombsz(str.getbuffer(nlen), fnd.cFileName, nlen);
str.releasebuffer();
#else
str = (const char*)fnd.cFileName;
#endif

if (fnd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
{
//if((fnd.dwFileAttributes & FILE_ATTRIBUTE_REPARSE_POINT) == 0)
qdirs.Push(str);
}
else if (szWildMatch(wildcard.c_str(), str.c_str()))
{
qfiles.Push(str);
}
if (FindNextFile(hfnd, &fnd) == 0)
{
FindClose(hfnd);
break;
}
}
#else // Linux

#if defined(ANDROID)
DGStr cdir = RTRIM_Str(GETCURRENTDIR_Str(), DGStr("/") );
STDOUT(DGStr("GETFILELIST(\"") + cdir + DGStr("\")\n") );
DGNat bDoesDirExist = DOESDIREXIST( cdir ); // prepare unpacking stuff from APK (in Media folder...)
STDOUT(DGStr("DOESDIREXIST() = ") + DGStr( bDoesDirExist ) + DGStr("\n") );
#endif

#if (!defined TARGET_OS_IPHONE)
struct stat stbuf;
#endif

DIR*	dirp;
dirp = opendir(".");
if (dirp)
{
struct dirent *dp;
while ((dp = readdir (dirp)) != NULL)
{
str = (const char*)dp->d_name;
if (IsDirectory(str.c_str()))
{
qdirs.Push(str);
}
else if (szWildMatch(wildcard.c_str(), str.c_str() ))
{
qfiles.Push(str);
}
}
closedir (dirp);
}
#endif

if(qdirs.Size())
sortarray(&qdirs[0], &qdirs[qdirs.Size()-1], ADDRESSOF(__CompareNoCase));
if(qfiles.Size())
sortarray(&qfiles[0], &qfiles[qfiles.Size()-1], ADDRESSOF(__CompareNoCase));

DIM(files, qfiles.Size()+qdirs.Size());
long i;
for (i=0; i<(long)qdirs.Size(); i++)
{
files((int)i) = *qdirs.GetAt((int)i);
}
for (i=0; i<(long)qfiles.Size(); i++)
{
files((int)i+qdirs.Size()) = *qfiles.GetAt((int)i);
}
return (65536*qdirs.Size() + qfiles.Size());
}


// INI File Handling
static GFini&	__g_Ini()
{
static GFini ini; return ini;
}


void	INIOPEN(const DGStr& filename)
{
// Write last file's changes before opening a new file
if(__g_Ini().m_changed)
{
__g_Ini().Write();
#ifdef GP2X
system("sync");
#endif
}

if( LEN(filename ) )
{
__g_Ini().Read(filename);
}
else
{
__g_Ini().Clear();
}
}

DGStr	INIGET_Str(const DGStr& section, const DGStr& key, DGStr nodata)
{
return __g_Ini().GetVal(section, key, nodata);
}


void	INIPUT(const DGStr& section, const DGStr& key, const DGStr& value)
{
if(LEN(key)==0)
{
__g_Ini().RemoveSection(section);
}
else
{
__g_Ini().SetVal(section, key, value);
}
}

// SIN / COS / KEY / RND
DGInt	SIN(DGInt angle)
{
#ifdef _DEBUG
DGInt cc= (DGInt)(sin((double)angle*BOG_INV));
return cc;
#else
return (DGInt)(sin((double)angle*BOG_INV));
#endif
}

DGInt	COS(DGInt angle)
{
#ifdef _DEBUG
DGInt cc= (DGInt)(cos((double)angle*BOG_INV));
return cc;
#else
return (DGInt)(cos((double)angle*BOG_INV));
#endif
}

DGInt	TAN(DGInt angle)
{
return (DGInt)(tan((double)angle*BOG_INV));
}


void SEEDRND(DGNat seed)
{
GFsrand((long)seed);
}


DGNat	RND(DGNat max)
{
if(max<=0) return 0;
return (DGNat)(GFrand()%((unsigned long)max+1));
}

// strlen
DGNat	LEN(DGInt s)
{
return (DGNat)((DGStr)s).len();
}
// strlen
DGNat	LEN(DGNat s)
{
return (DGNat)((DGStr)s).len();
}
// MATH-Stuff
DGInt	POW(DGInt n, DGInt e)
{
return (DGInt)pow((double)n, (double)e);
}
DGNat	MOD(DGNat n, DGNat m)
{
if (m==0) return 0;
return n % m;
}
DGInt	FMOD(DGInt n, DGInt m)
{
if (m==0) return 0;
return (DGInt) fmod(n, m);
}

DGInt	FLOOR(DGInt n)  {return (DGInt)floor(n);}
DGInt	CEIL(DGInt n)	{return (DGInt)ceil(n);}


DGInt	ATAN(DGInt dx, DGInt dy)
{
return (DGInt) (BOG*atan2((double)dx, (double)dy));
}
DGInt	ASIN(DGInt n)
{
// Disallow overflow problems
if (n>=1.0) return 90.0;
if (n<=-1.0) return -90.0;
return (DGInt) (BOG*asin((double)n));
}
DGInt	ACOS(DGInt n)
{
// Disallow overflow problems
if (n>=1.0) return 0.0;
if (n<=-1.0) return 180.0;
return (DGInt) (BOG*acos((double)n));
}
DGInt	SQR(DGInt n)
{
return (DGInt) sqrt((double)n);
}
DGInt	LOGN(DGInt n)
{
return (DGInt)log( n );
}





// ------------------------------------------------------------- //
// Copy array
// ------------------------------------------------------------- //
DGIntArray& DGIntArray::operator=(const DGIntArray& a)
{
DIM(*this, a.max1, a.max2, a.max3, a.max4);
int	siz=(int)(max1*MAX(1,max2)*MAX(1,max3)*MAX(1,max4));
this->count = siz;
const DGInt* pR=a.pData;
DGInt* pW=this->pData;
while(siz)
{
*pW++ = *pR++; --siz;
}
// memcpy(pData, a.pData, sizeof(DGInt)*siz);
return *this;
}
DGNatArray& DGNatArray::operator=(const DGNatArray& a)
{
DIM(*this, a.max1, a.max2, a.max3, a.max4);
int	siz=(int)(max1*MAX(1,max2)*MAX(1,max3)*MAX(1,max4));
this->count = siz;
const DGNat* pR=a.pData;
DGNat* pW=this->pData;
while(siz)
{
*pW++ = *pR++; --siz;
}
// memcpy(pData, a.pData, sizeof(DGNat)*siz);
return *this;
}


// ------------------------------------------------------------- //
// Determine DIM bounds
// ------------------------------------------------------------- //
DGNat	BOUNDS(const DGIntArray& arr, DGNat nDim)
{
switch((int)nDim)
{
case 0: return arr.max1; break;
case 1: return arr.max2; break;
case 2: return arr.max3; break;
case 3: return arr.max4; break;
}
return 0;
}
DGNat	BOUNDS(const DGNatArray& arr, DGNat nDim)
{
switch(nDim)
{
case 0: return arr.max1; break;
case 1: return arr.max2; break;
case 2: return arr.max3; break;
case 3: return arr.max4; break;
}
return 0;
}



void	FIXDIM(DGIntArray& arr, DGNat xt1, DGNat xt2, DGNat xt3, DGNat xt4)
{
int clr=0;
if (xt1<1)
{
xt1=0; // xt2=0; xt3=0; xt4=0;
clr=1;
}
int	siz=(int)(xt1*MAX(1,xt2)*MAX(1,xt3)*MAX(1,xt4));
if (siz>arr.mem || clr)
{
if (arr.pData!=NULL
#if DGARRAY_STATIC_SIZE>0
&& arr.pData!=&arr.pDataStatic[0]
#endif
) delete [] arr.pData;

#if DGARRAY_STATIC_SIZE>0
if (siz<=DGARRAY_STATIC_SIZE)
{
arr.pData = &arr.pDataStatic[0];
arr.mem=DGARRAY_STATIC_SIZE;
}
else
#endif
{
arr.pData=new DGInt[(int)siz];
if (arr.pData==NULL) {__Error(CMP_OUT_OF_MEMORY); __EndProgram();}
arr.mem=siz;
}
}
DGInt* pW=arr.pData; while(siz) {*pW++=DGInt(0); --siz;}
// memset(arr.pData, 0, sizeof(DGInt)*(int)arr.mem);
if (xt4) arr.dim=4; else if (xt3) arr.dim=3; else if (xt2) arr.dim=2; else if(xt1) arr.dim=1; else arr.dim=0;
arr.fac2=(int)xt1;
arr.fac3=arr.fac2*(int)xt2;
arr.fac4=arr.fac3*(int)xt3;
arr.max1=(int)xt1; arr.max2=(int)xt2; arr.max3=(int)xt3; arr.max4=(int)xt4;
arr.count = arr.max1*MAX(1,arr.max2)*MAX(1,arr.max3)*MAX(1,arr.max4);
}

void	FIXDIM(DGNatArray& arr, DGNat xt1, DGNat xt2, DGNat xt3, DGNat xt4)
{
int clr=0;
if (xt1<1)
{
xt1=0; // xt2=0; xt3=0; xt4=0;
clr=1;
}
int	siz=(int)(xt1*MAX(1,xt2)*MAX(1,xt3)*MAX(1,xt4));
if (siz>arr.mem || clr)
{
if (arr.pData!=NULL
#if DGARRAY_STATIC_SIZE>0
&& arr.pData!=&arr.pDataStatic[0]
#endif
) delete [] arr.pData;

#if DGARRAY_STATIC_SIZE>0
if (siz<=DGARRAY_STATIC_SIZE)
{
arr.pData = &arr.pDataStatic[0];
arr.mem=DGARRAY_STATIC_SIZE;
}
else
#endif
{
arr.pData=new DGNat[siz];
if (arr.pData==NULL) {__Error(CMP_OUT_OF_MEMORY); __EndProgram();}
arr.mem=siz;
}
}
DGNat* pW=arr.pData; while(siz) {*pW++=(0); --siz;}
// memset(arr.pData, 0, sizeof(DGNat)*(int)arr.mem);
if (xt4) arr.dim=4; else if (xt3) arr.dim=3; else if (xt2) arr.dim=2; else if(xt1) arr.dim=1; else arr.dim=0;
arr.fac2=(int)xt1;
arr.fac3=arr.fac2*(int)xt2;
arr.fac4=arr.fac3*(int)xt3;
arr.max1=(int)xt1; arr.max2=(int)xt2; arr.max3=(int)xt3; arr.max4=(int)xt4;
arr.count = arr.max1*MAX(1,arr.max2)*MAX(1,arr.max3)*MAX(1,arr.max4);
}

void	DIM(DGIntArray& arr, DGNat xt1, DGNat xt2, DGNat xt3, DGNat xt4)
{
int clr=0;
if (xt1<1)
{
xt1=0; // xt2=0; xt3=0; xt4=0;
clr=1;
}
int	siz=(int)(xt1*MAX(1,xt2)*MAX(1,xt3)*MAX(1,xt4));
if (siz>arr.mem || clr)
{
if (arr.pData!=NULL
#if DGARRAY_STATIC_SIZE>0
&& arr.pData!=&arr.pDataStatic[0]
#endif
) delete [] arr.pData;

#if DGARRAY_STATIC_SIZE>0
if (siz<=DGARRAY_STATIC_SIZE)
{
arr.pData = &arr.pDataStatic[0];
arr.mem=DGARRAY_STATIC_SIZE;
}
else
#endif
{
siz=((int)(siz/8)+1 )*8;
arr.pData=new DGInt[siz];
if (arr.pData==NULL) {__Error(CMP_OUT_OF_MEMORY); __EndProgram();}
arr.mem=siz;
}
}
DGInt* pW=arr.pData; while(siz) {*pW++=DGInt(0); --siz;}
// memset(arr.pData, 0, sizeof(DGInt)*(int)arr.mem);
if (xt4) arr.dim=4; else if (xt3) arr.dim=3; else if (xt2) arr.dim=2; else if(xt1) arr.dim=1; else arr.dim=0;
arr.fac2=(int)xt1;
arr.fac3=arr.fac2*(int)xt2;
arr.fac4=arr.fac3*(int)xt3;
arr.max1=(int)xt1; arr.max2=(int)xt2; arr.max3=(int)xt3; arr.max4=(int)xt4;
arr.count = arr.max1*MAX(1,arr.max2)*MAX(1,arr.max3)*MAX(1,arr.max4);
}

void	DIM(DGNatArray& arr, DGNat xt1, DGNat xt2, DGNat xt3, DGNat xt4)
{
int clr=0;
if (xt1<1)
{
xt1=0; // xt2=0; xt3=0; xt4=0;
clr=1;
}
int	siz=(int)(xt1*MAX(1,xt2)*MAX(1,xt3)*MAX(1,xt4));
if (siz>arr.mem || clr)
{
if (arr.pData!=NULL
#if DGARRAY_STATIC_SIZE>0
&& arr.pData!=&arr.pDataStatic[0]
#endif
) delete [] arr.pData;
#if DGARRAY_STATIC_SIZE>0
if (siz<=DGARRAY_STATIC_SIZE)
{
arr.pData = &arr.pDataStatic[0];
arr.mem=DGARRAY_STATIC_SIZE;
}
else
#endif
{
siz=((int)(siz/8)+1 )*8;
arr.pData=new DGNat[siz];
if (arr.pData==NULL) {__Error(CMP_OUT_OF_MEMORY); __EndProgram();}
arr.mem=siz;
}
}
DGNat* pW=arr.pData; while(siz) {*pW++=0; --siz;}
// memset(arr.pData, 0, sizeof(DGNat)*(int)arr.mem);
if (xt4) arr.dim=4; else if (xt3) arr.dim=3; else if (xt2) arr.dim=2; else if(xt1) arr.dim=1; else arr.dim=0;
arr.fac2=(int)xt1;
arr.fac3=arr.fac2*(int)xt2;
arr.fac4=arr.fac3*(int)xt3;
arr.max1=(int)xt1; arr.max2=(int)xt2; arr.max3=(int)xt3; arr.max4=(int)xt4;
arr.count = arr.max1*MAX(1,arr.max2)*MAX(1,arr.max3)*MAX(1,arr.max4);
}

void	REDIM(DGIntArray& arr, DGNat xt1, DGNat xt2, DGNat xt3, DGNat xt4)
{
// just reset dimensions
if(xt1<=0)
{
arr.max1=0; arr.max2=0; arr.max3=0; arr.max4=0; arr.fac2=0; arr.fac3=0; arr.fac4=0; arr.dim=0; arr.count=0;
return;
}
DGIntArray tmp;
DGInt*     ptr=NULL;
DIM(tmp, xt1, xt2, xt3, xt4);

int ma, mb, mc, md;
ma = (int)MIN(arr.max1, xt1); mb = (int)MIN(arr.max2, xt2); mc = (int)MIN(arr.max3, xt3); md = (int)MIN(arr.max4, xt4);

for(int a=0; a<ma; ++a)
{
if(mb)
for(int b=0; b<mb; ++b)
{
if(mc)
for(int c=0; c<mc; ++c)
{
if(md)
for(int d=0; d<md; ++d)
{
tmp(a,b,c,d) = arr(a,b,c,d);
}
else
tmp(a,b,c) = arr(a,b,c);
}
else
tmp(a,b) = arr(a,b);
}
else
tmp(a) = arr(a);
}

#if DGARRAY_STATIC_SIZE>0
if(arr.pData==&arr.pDataStatic[0] || tmp.pData==&tmp.pDataStatic[0])
{
// need a full copy, one of the pointers is static
arr = tmp;
}
else
#endif
{
// they are dynamical - copy the variables, only
arr.dim  = tmp.dim;
arr.mem  = tmp.mem;
arr.fac2 = tmp.fac2; arr.fac3 = tmp.fac3; arr.fac4 = tmp.fac4;
arr.max1 = tmp.max1; arr.max2 = tmp.max2; arr.max3 = tmp.max3; arr.max4 = tmp.max4;
arr.count= tmp.count;
// can't do that on static memory...
ptr = arr.pData; arr.pData=tmp.pData; tmp.pData=ptr;
}
}

void	REDIM(DGNatArray& arr, DGNat xt1, DGNat xt2, DGNat xt3, DGNat xt4)
{
// just reset dimensions
if(xt1<=0)
{
arr.max1=0; arr.max2=0; arr.max3=0; arr.max4=0; arr.fac2=0; arr.fac3=0; arr.fac4=0; arr.dim=0; arr.count=0;
return;
}
DGNatArray tmp;
DGNat*     ptr=NULL;
DIM(tmp, xt1, xt2, xt3, xt4);

int ma, mb, mc, md;
ma = (int)MIN(arr.max1, xt1); mb = (int)MIN(arr.max2, xt2); mc = (int)MIN(arr.max3, xt3); md = (int)MIN(arr.max4, xt4);

for(int a=0; a<ma; ++a)
{
if(mb)
for(int b=0; b<mb; ++b)
{
if(mc)
for(int c=0; c<mc; ++c)
{
if(md)
for(int d=0; d<md; ++d)
{
tmp(a,b,c,d) = arr(a,b,c,d);
}
else
tmp(a,b,c) = arr(a,b,c);
}
else
tmp(a,b) = arr(a,b);
}
else
tmp(a) = arr(a);
}

#if DGARRAY_STATIC_SIZE>0
if(arr.pData==&arr.pDataStatic[0] || tmp.pData==&tmp.pDataStatic[0])
{
// need a full copy, one of the pointers is static
arr = tmp;
}
else
#endif
{
// they are dynamical - copy the variables, only
arr.dim  = tmp.dim;
arr.mem  = tmp.mem;
arr.fac2 = tmp.fac2; arr.fac3 = tmp.fac3; arr.fac4 = tmp.fac4;
arr.max1 = tmp.max1; arr.max2 = tmp.max2; arr.max3 = tmp.max3; arr.max4 = tmp.max4;
arr.count= tmp.count;
// can't do that on static memory...
ptr = arr.pData; arr.pData=tmp.pData; tmp.pData=ptr;
}
}

// *** DATA ***
void DIMDATA(DGIntArray& arr, int count, DGInt* pData)
{
DIM(arr, count);
for(int i=0; i<count; ++i)
arr(i) = pData[i];
}
void DIMDATA(DGNatArray& arr, int count, DGNat* pData)
{
DIM(arr, count);
for(int i=0; i<count; ++i)
arr(i) = pData[i];
}

GFDataStoreageContainer* __gpDataContainer=NULL;
void RESTORE(GFDataStoreageContainer& container)
{
__gpDataContainer=&container;
__gpDataContainer->index=0;
}

void READ(DGStr& str)
{
if(__gpDataContainer && __gpDataContainer->index < __gpDataContainer->count)
{

if(__gpDataContainer->data[__gpDataContainer->index].pC)
str= DGStr(CGStr(__gpDataContainer->data[__gpDataContainer->index].pC));
else
str= DGStr(__gpDataContainer->data[__gpDataContainer->index].n);
++__gpDataContainer->index;
}
else
{
__Error(CMP_OUT_OF_DATA); __EndProgram();
}
}

void READ(DGInt& i)
{
if(__gpDataContainer && __gpDataContainer->index < __gpDataContainer->count)
{
if(__gpDataContainer->data[__gpDataContainer->index].pC)
i= DGInt(DGStr(__gpDataContainer->data[__gpDataContainer->index].pC));
else
i= __gpDataContainer->data[__gpDataContainer->index].n;
++__gpDataContainer->index;
}
else
{
__Error(CMP_OUT_OF_DATA); __EndProgram();
}
}

void READ(DGNat& i)
{
if(__gpDataContainer && __gpDataContainer->index < __gpDataContainer->count)
{
if(__gpDataContainer->data[__gpDataContainer->index].pC)
i= DGNat(DGStr(__gpDataContainer->data[__gpDataContainer->index].pC));
else
i= DGNat(__gpDataContainer->data[__gpDataContainer->index].n);
++__gpDataContainer->index;
}
else
{
__Error(CMP_OUT_OF_DATA); __EndProgram();
}
}


// PRG CONTROL
// ------------------------------------------------------------- //
void	END()
// ------------------------------------------------------------- //
{
SETLOOPSUB(DGStr(""));
__Error(CMP_OK);
__EndProgram();
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
extern const char* __g_pSubCalls[];
void*	GETSUBADDRESS(const DGStr& sub_name)
{
const char** pC = __g_pSubCalls;
while(*pC)
{
void* pSub = (void*)*pC++;
const char* pName = *pC++;
if(sub_name == CGStr(pName))
{
return pSub;
}
}
return NULL;
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGNat	CALLBYNAME(const DGStr& sub_name)
{
typedef void (*a_sub)();
a_sub mysub = (a_sub)GETSUBADDRESS(sub_name);

if(mysub)
{
mysub();
return TRUE;
}
else
{
// Some info for this bad crash
if(sub_name == CGStr("GLB_ON_QUIT")) return FALSE;
if(sub_name == CGStr("GLB_ON_HIDE")) return FALSE;
if(sub_name == CGStr("GLB_WIN32_MSG")) return FALSE;

WIN32_ONLY( DEBUG(CGStr("CALLBYNAME \"") + sub_name + CGStr("\" *** failed ***\n")) );
return FALSE;
}
}



#if defined(EMSCRIPTEN)
extern "C"
{
extern void emscripten_set_main_loop(void (*func)(), int fps);
extern void emscripten_pause_main_loop();
extern void emscripten_resume_main_loop();
extern void emscripten_cancel_main_loop();
}


typedef void (*a_sub)();
a_sub glb_cur_main_sub = NULL;
void glb_emscripten_loop_wrapper()
{
static int is_running = 0;
if(is_running)
{
g_debug("skipping loop frame - too slow\n");
return;
}
is_running = 1;
if(glb_cur_main_sub)
{

#if defined(TRENKI3D)
glb_cur_main_sub();
// SHOWSCREEN as desired
#else
glb_showscreen_finish_frame(); // this is not really required, I think
glb_showscreen_init_next_frame();
glb_cur_main_sub();
#endif

// I had this with WebGL and it worked... Required?
//	SHOWSCREEN(FALSE); // do the dummy initializing _before_ the new loop.

//	#if defined(TRENKI3D)
//		SHOWSCREEN(TRUE); // SDL+canvas, please swap
//	#endif
}
is_running = 0;
}

// ------------------------------------------------------------- //
// SetLoopSub
// ------------------------------------------------------------- //
void	SETLOOPSUB(const DGStr& sub_name)
{
glb_cur_main_sub = (a_sub)GETSUBADDRESS(sub_name);
if(glb_cur_main_sub)
{
g_debug("emsc-loop: %s\n", sub_name.c_str() );
emscripten_set_main_loop(glb_emscripten_loop_wrapper, 60); // sub, fps
}
else
{
emscripten_set_main_loop(NULL, 2000); // sub, fps
}
}

#else
DGStr __g_NextLoopSub;
DGStr __g_CurLoopSub;
// ------------------------------------------------------------- //
// SetLoopSub
// ------------------------------------------------------------- //
void	SETLOOPSUB(const DGStr& sub_name)
{
if(__g_CurLoopSub.len() )
{
__g_NextLoopSub = sub_name;
__g_CurLoopSub.clear();
return; // the current run loop must do this
}

__g_NextLoopSub.clear();
__g_CurLoopSub = sub_name;

// ok, just wanted to clear
if(!__g_CurLoopSub.len() )
return;


typedef void (*a_sub)();
a_sub mysub = (a_sub)GETSUBADDRESS(__g_CurLoopSub);


while(mysub != NULL)
{
mysub();

if(__g_CurLoopSub.len() == 0)
{
__g_CurLoopSub = __g_NextLoopSub;
if(__g_CurLoopSub.len() == 0)
return; // called SETLOOPSUB("")
mysub = (a_sub)GETSUBADDRESS(__g_CurLoopSub);
}
}
}
#endif



// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGStr	MID_Str(const DGStr& s, DGNat start, DGNat len)
{
DGStr	mid;
int slen=(int)s.len();
if(len < 0) len = slen; // mid(...-1) -> until the end
if ((int)(len+start)>slen) len=slen-start;
if (len<=0 || start>=slen || start<0) {return mid;}// return empty str

mymemcpy(mid.getbuffer(len+1), s.c_str()+start, len);
mid.setlength(len);
mid[len] = '\0';
return mid;
}


DGStr	LTRIM_Str(const DGStr& str, const DGStr& trim)
{
//int itrim = -1;
const char* pC = str.c_str();
unsigned int lstr = str.len();
for(unsigned int i=0; i<lstr; ++i)
{
for(unsigned int j=0; j<trim.len(); ++j)
{
if(*pC == trim[j])
goto do_trim;
}
// no more char to trim found!
if(i>0)
{
return MID_Str(str, i);
}
// string unchanged
return str;
do_trim:
++pC;
}
// reached end -> return empty string
return DGStr("");
}

DGStr	RTRIM_Str(const DGStr& str, const DGStr& trim)
{
//int itrim = -1;
int lstr = str.len();
const char* pC = &(str.c_str()[lstr-1]);
for(int i=lstr-1; i>=0; --i)
{
for(unsigned int j=0; j<trim.len(); ++j)
{
if(*pC == trim[j])
goto do_trim;
}
// no more char to trim found!
if(i<lstr-1)
{
return MID_Str(str, 0, i+1);
}
// string unchanged
return str;
do_trim:
--pC;
}
// reached start -> return empty string
return DGStr("");
}




// ------------------------------------------------------------- //
// ASC
// ------------------------------------------------------------- //
DGNat ASC(const DGStr& s)
{
return (DGNat)(unsigned char)s.c_str()[0];
}
DGNat ASC(const DGStr& s, DGNat index)
{
if(index<0 || index>=(DGNat)s.len())
return 0;
return (DGNat)(unsigned char)s.c_str()[index];
}

// ------------------------------------------------------------- //
// CHR$
// ------------------------------------------------------------- //
DGStr CHR_Str(DGNat i)
{
static DGStr s("x"); // len=1, buffer=2
s[0] = (char)((unsigned char)i);
return s;
}

// ------------------------------------------------------------- //
// HEX$
// ------------------------------------------------------------- //
DGStr	HEX_Str(DGNat n)
{
DGStr str;
sprintf(str.getbuffer(16), "%x", (int)n);
str.releasebuffer();
return str;
}

// ------------------------------------------------------------- //
// FORMAT$
// ------------------------------------------------------------- //
DGStr FORMAT_Str(DGInt minchars, DGInt numaftercomma, DGInt i)
{
static char fmt[32];
static DGStr str;
sprintf(fmt, "%%%d.%df", (int)minchars, (int)numaftercomma);

#ifdef _DEBUG
int ireq = _scprintf(fmt, i);
if(ireq >= 128 )
*(int*)0=42;
#endif
sprintf(str.getbuffer(128), fmt, i);
str.releasebuffer();
return str;
}

DGStr	FORMAT_Str(DGInt minchars, DGInt numaftercomma, DGNat i)
{
static char fmt[32];
static DGStr str;
sprintf(fmt, "%%%dd", (int)minchars);

#ifdef _DEBUG
int ireq = _scprintf(fmt, i);
if(ireq >= 128 )
*(int*)0=42;
#endif
sprintf(str.getbuffer(128), fmt, i);
str.releasebuffer();
return str;
}


DGStr	FORMAT_Str(DGInt minchars, DGInt numaftercomma, int64 i)
{
static char fmt[32];
static DGStr str;
sprintf(fmt, "%%%dlld", (int)minchars);

#ifdef _DEBUG
int ireq = _scprintf(fmt, i);
if(ireq >= 128 )
*(int*)0=42;
#endif
sprintf(str.getbuffer(128), fmt, i);
str.releasebuffer();
return str;
}



// ------------------------------------------------------------- //
// Print to GLBasic output window (This command CANNOT been used on iPHONE at all, its allready defined and used by Apple)
// ------------------------------------------------------------- //
#if defined(WIN32) && !defined(POCKETPC)
extern "C" int __stdcall IsDebuggerPresent();
#endif

// #ifndef TARGET_OS_IPHONE // GF: 2016-10-20
void DEBUG(const DGStr& s)
{
#if defined(WIN32) && !defined(POCKETPC)
if (IsDebuggerPresent())
{
DGStr text = CGStr("TX") + s;
::OutputDebugStringA(text.c_str());
}

#ifdef _DEBUG
printf("%s", s.c_str());
#endif

#else
#ifdef POSIX
printf("%s", s.c_str());
#else
g_debug("%s", s.c_str());
#endif
#endif
}
// #endif

// ------------------------------------------------------------- //
void	ASSERT(DGNat eq)
{
if(eq) return;
WIN32_ONLY( DEBUG(CGStr("Assertion: Value = ") + DGStr(eq) + CGStr("\n")) );

__Error(CMP_ASSERTION_FAILED);
__EndProgram();
}



// FILE IO
// ------------------------------------------------------------- //
void	GETFILE(const DGStr& file, DGInt line, DGInt& num)
{
DGStr thefile(file);
if(!glb_prepare_reading_file(thefile))
return;
DGStr	s;	::GetFile(thefile.c_str(), (int)line, s);	num=(DGInt) s;
}
void	GETFILE(const DGStr& file, DGInt line, DGNat& num)
{
DGStr thefile(file);
if(!glb_prepare_reading_file(thefile))
return;
DGStr	s;	::GetFile(thefile.c_str(), (int)line, s);	num=(DGNat) s;
}

// ------------------------------------------------------------- //
void	GETFILE(const DGStr& file, DGInt line, DGStr& str)
{
DGStr thefile(file);
if(!glb_prepare_reading_file(thefile))
return;
::GetFile(thefile.c_str(), (int)line, str);
}

// ------------------------------------------------------------- //
void	PUTFILE(const DGStr& file, DGInt line, DGInt num)
{
DGStr	str;
str=num;
::PutFile(file.c_str(), (int)line, str);
}

// ------------------------------------------------------------- //
void	PUTFILE(const DGStr& file, DGInt line, DGStr str)
{
::PutFile(file.c_str(), (int)line, str);
}

DGStr&			__glb_cmdline(){static DGStr s; return s;}
DGStr&			__glb_AppName(){static DGStr s; return s;}

// iphone fix way to handle urls
extern "C" void __glb_set_cmd_line(const char* pcmd)
{
__glb_cmdline() = pcmd;
}

// ------------------------------------------------------------- //
DGStr	GETCOMMANDLINE_Str()
{
return __glb_cmdline();
}


// ------------------------------------------------------------- //
DGNat BOXCOLL(DGNat x1, DGNat y1, DGNat w1, DGNat h1, DGNat x2, DGNat y2, DGNat w2, DGNat h2)
{
#define qmax_(a, b) (a>b ? a : b)
#define qmin_(a, b) (a<b ? a : b)

DGNat xe1=x1+w1, xe2=x2+w2, ye1=y1+h1, ye2=y2+h2;
if(w1>0) --xe1; else if(w1<0) ++xe1;
if(w2>0) --xe2; else if(w2<0) ++xe2;
if(h1>0) --ye1; else if(h1<0) ++ye1;
if(h2>0) --ye2; else if(h2<0) ++ye2;

if(
(qmax_(qmin_(x1, xe1), qmin_(x2, xe2)) <= qmin_(qmax_(x1, xe1), qmax_(x2, xe2))) \
&&	(qmax_(qmin_(y1, ye1), qmin_(y2, ye2)) <= qmin_(qmax_(y1, ye1), qmax_(y2, ye2)))
)
return TRUE;
return FALSE;

#undef qmax_
#undef qmin_
#undef __RectRectIntersection
}

// ------------------------------------------------------------- //
// GLBasic Console
// ------------------------------------------------------------- //

// ------------------------------------------------------------- //
void	STDOUT(const DGStr& str)
{
#ifdef ANDROID
g_debug("%s", str.c_str()); // log print
#else
printf("%s", str.c_str());
fflush(stdout);
#endif
}

// ------------------------------------------------------------- //
void	STDERR(const DGStr& str)
{
#ifdef ANDROID
g_debug("%s", str.c_str()); // log print
#else
fprintf(stderr, "%s", str.c_str());
fflush(stderr);
#endif
}

// ------------------------------------------------------------- //
DGStr	STDIN_Str()
{
char buffer[4096];
buffer[0] = '\0';
// cin.getline(buffer, 4095, '\n');
fgets(buffer, 4095, stdin);
DGStr str(buffer);

// remove '\n' character
if(str.len() && str[str.len()-1]=='\n')
{
// --str.length;
str.setlength(str.len()-1);
str[str.len()] = '\0';
}
return str;
}





// ------------------------------------------------------------- //
// GLBasic NX
// ------------------------------------------------------------- //

// ------------------------------------------------------------- //
DGNat	NETHOSTGAME(DGNat port_tcp)
{
__g_DidNET = true;

if(port_tcp<=0) port_tcp = DEFAULT_PORT;

if(!pGFNet->StartServer((unsigned short)port_tcp) )
return 0;
return 1;
}

// ------------------------------------------------------------- //
DGNat	NETJOINGAME(const DGStr& address, DGNat port_tcp)
{
__g_DidNET = true;

if(port_tcp<=0) port_tcp = DEFAULT_PORT;

if(!pGFNet->ConnectClient(address.c_str(), (unsigned short)port_tcp ))
return 0;
return 1;
}

// ------------------------------------------------------------- //
void	NETSHUTDOWN()
{
pGFNet->Stop();
}


// ------------------------------------------------------------- //
void	NETALLOWJOINING(DGNat allow)
{
pGFNet->AllowJoining(allow ? true:false);
}

// ------------------------------------------------------------- //
DGNat	NETCREATEPLAYER(const DGStr& Name)
{
DGNat	id;
id = (DGNat)pGFNet->CreatePlayer(Name.c_str());
return id;
}

// ------------------------------------------------------------- //
void	NETDESTROYPLAYER(DGNat Player)
{
pGFNet->DeletePlayer((unsigned short)Player);
}

// ------------------------------------------------------------- //
DGNat	NETSENDMSG(DGNat Player, DGNat Recipent, const DGStr& Messy)
{
if (Recipent==0)
Recipent=ID_ALL_PLAYERS;
return (DGNat) pGFNet->SendASCIIMessage((unsigned short)Player, (unsigned short)Recipent, Messy.c_str());
}


static long __g_last_msg_sender=0;
// ------------------------------------------------------------- //
DGStr	NETGETMSG_Str(DGNat Player)
{
GFHawkNetwork::Message msg;
if(pGFNet->PopMessage((unsigned short)Player, msg))
{
__g_last_msg_sender=msg.id_from;
DGStr s = msg.pBuffer;
return s;
}
return DGStr("");
}

// ------------------------------------------------------------- //
DGNat	NETGETSENDER()
{
return (DGNat)__g_last_msg_sender;
}

// ------------------------------------------------------------- //
DGStr	NETPLAYERNAME_Str(DGNat Player)
{
DGStr	s;
if(pGFNet->GetPlayerName((unsigned short)Player, s.getbuffer(256)))
s.releasebuffer();
else
s="NO_DATA";
return s;
}

// ------------------------------------------------------------- //
DGNat	NETNUMPLAYERS()
{
return pGFNet->NumPlayers();
}

// ------------------------------------------------------------- //
DGNat	NETGETQUITPLAYER()
{
return (DGNat)pGFNet->GetQuitPlayer();
}

// ------------------------------------------------------------- //
DGNat	NETGETPLAYERID(DGNat num)
{
return (DGNat)pGFNet->GetPlayerIdByIndex((unsigned short)num);
}

// ------------------------------------------------------------- //
DGStr	NETGETIP_Str()
{
char* pNames = new char[4096];
DGStr s;
int n = pGFNet->GetLocalIPs(pNames, 4096);

if(n)
s = pNames;
delete [] pNames;
return s;	
}

// ------------------------------------------------------------- //
DGStr	NETGETLASTERROR_Str()
{
return (DGStr)netLastError();
}

// ------------------------------------------------------------- //
DGNat	NETWEBGET(const DGStr& server, const DGStr& path, DGNat port, const DGStr& local, DGNat timeout_ms)
{
return (DGNat)pGFNet->WGet(server.c_str(), path.c_str(), (int)port, local.c_str(), NULL, 0, timeout_ms);
}

// ------------------------------------------------------------- //
DGStr	NETWEBGET_Str(const DGStr& server, const DGStr& path, DGNat port, DGNat max_length, DGNat timeout_ms)
{
DGStr	str;
pGFNet->WGet(server.c_str(), path.c_str(), (unsigned short)port, NULL, str.getbuffer(max_length+2), max_length+1, timeout_ms);
str.releasebuffer();
return str;
}

#if defined(TARGET_OS_IPHONE)
extern "C" void iPhoneOpenUrl(const char* pUrl);
#endif
#if defined(ANDROID)
extern "C" int android_openURL(DGStr url);
#endif

extern "C" void __ShutDownGLBasic();
// ------------------------------------------------------------- //
void	NETWEBEND(DGStr url)
{
if(glb_allow_escape())
__ShutDownGLBasic();

#ifdef WIN32
#if defined(UNICODE)
wchar_t pUrl[1024];
// convert from multibyte char string to wide char string
mbstowcs(pUrl, (const char *)url.c_str(), url.len()+1);
#else
const char* pUrl = url.c_str();
#endif
SHELLEXECUTEINFO cShellExecuteInfo;
memset(&cShellExecuteInfo, 0, sizeof(SHELLEXECUTEINFO));
cShellExecuteInfo.cbSize = sizeof(SHELLEXECUTEINFO);
cShellExecuteInfo.fMask = SEE_MASK_NOCLOSEPROCESS;
cShellExecuteInfo.hwnd = NULL;
cShellExecuteInfo.lpVerb = _T("Open");
#if defined(_WIN32_WCE)
cShellExecuteInfo.lpFile = _T("\\Windows\\IExplore.exe");
cShellExecuteInfo.lpParameters = pUrl;
#else
cShellExecuteInfo.lpFile =pUrl;
#endif
cShellExecuteInfo.nShow = SW_SHOWNORMAL;
ShellExecuteEx(&cShellExecuteInfo);
#elif defined(TARGET_OS_IPHONE)
printf("exiting with url %s\nIgnore the bad exec that will come now ;)", url.c_str());
iPhoneOpenUrl(url.c_str());
// exit(0);
#elif defined(PALM_WEBOS)
int rv = PDL_LaunchBrowser(url.c_str());
printf("exiting with url %s\nIgnore the segfault that will come now ;)", url.c_str());
#elif defined(ANDROID)
int rv = android_openURL(url);
g_debug("check url back");
//		g_debug("open url: %s %s\n", url, rv?"ok":"fail");
#elif defined(LINUX)
const char* browser = "/usr/bin/sensible-browser";
execl(browser, browser, url.c_str(), NULL);
#elif defined(MACOSX)
const char* browser = "/usr/bin/open";
execl(browser, browser, url.c_str(), NULL);
#endif

if(glb_allow_escape())
__EndProgram();
}

// ------------------------------------------------------------- //
DGNat   NETISACTIVE()
{
return pGFNet->Running() ? TRUE:FALSE;
}

// ------------------------------------------------------------- //
// Socket commands TCP
// ------------------------------------------------------------- //

static NETaddress glb_netaddress_from_dgstr(const DGStr& ip, DGNat port)
{
NETaddress addr;
if(ip.len() == 4)
{
addr.assign(NETaddress::get_family_ofIPv(4), (void*)ip.c_str(), port );
}
else if(ip.len() == 16)
{
addr.assign(NETaddress::get_family_ofIPv(6), (void*)ip.c_str(), port );
}
else
{
__Error(CMP_WRONG_ARGUMENT);
return NET_ADDR_INVALID;
}
return addr;
}

static DGStr glb_ipstr_from_netaddress(const NETaddress& add)
{
DGStr out;
if(add.m_ipFamily == NETaddress::get_family_ofIPv(6))
{
memcpy(out.getbuffer(17), add.m_ip, 16);
out.setlength(16);
}
else
{
memcpy(out.getbuffer(5), add.m_ip, 4);
out.setlength(4);
}
return out;
}


// ------------------------------------------------------------- //
void  SOCK_SET_IP_VERSION(DGNat ipV)
{
if(ipV!=4 && ipV!=6)
{
__Error(CMP_WRONG_ARGUMENT);
ipV=4;
}	
netSetVersion(ipV);
}

// ------------------------------------------------------------- //
DGNat SOCK_TCPLISTEN(DGNat port)
{return (DGNat)netListen((unsigned short) port);}

// ------------------------------------------------------------- //
DGNat SOCK_TCPCONNECT(const DGStr& server, DGNat port, DGNat timeout)
{
NETaddress sv = netAddress(server.c_str(), port);
if(sv== NET_ADDR_INVALID)
return NET_INVALID;
return (DGNat)netConnect(sv, timeout);
}

// ------------------------------------------------------------- //
// return ip in host format
// port in host format
DGNat SOCK_TCPACCEPT(DGNat socket, DGStr& ip)
{
ip.clear();

NETaddress addr;
NETsocket sock = netAccept(socket, &addr);
if(sock!=NET_INVALID)
{
ip = glb_ipstr_from_netaddress(addr);
// ip = ne148tGetIPstr(addr); // readable form

// ip = FromBigEndian((unsigned long)netGetIP(addr));
// ip = (int)netGetIP(addr); // already _is_ local format
}
return (DGNat)sock;
}

// ------------------------------------------------------------- //
DGNat SOCK_TCPSEND(DGNat sock_to, const DGStr& msg)
{
return netSend(sock_to, msg.c_str(), msg.len());
}


// ------------------------------------------------------------- //
// Socket commands UDP
// ------------------------------------------------------------- //

// ------------------------------------------------------------- //
DGNat SOCK_UDPOPEN(DGNat port)
{
return (DGNat) netSocketUdp((unsigned short) port);
}


// ip in host format -> use SOCK_GETIP
// port in host format
// ------------------------------------------------------------- //
DGNat SOCK_UDPSEND(DGNat sock, const DGStr& msg, DGStr ip, DGNat port)
{
NETaddress addr = glb_netaddress_from_dgstr(ip, port);
return netSend(sock, msg.c_str(), msg.len(), &addr);
}


// ------------------------------------------------------------- //
DGNat SOCK_RECV(DGNat sock_from, DGStr& msg, DGNat length)
{
int rv = netRecv(sock_from, msg.getbuffer(length+1), length);
if(rv>0)
{
msg[rv] = '\0';
//		msg.releasebuffer(); // that's just plain slow - might need to check against rv>=length?
msg.setlength(rv); // you can include '\0' characters in GLB!
}
else
{
msg.releasebuffer();
msg.assign("");
msg.setlength(0);
}
return rv;
}

// ------------------------------------------------------------- //
// Socket commands TCP/UDP
// ------------------------------------------------------------- //


// ------------------------------------------------------------- //
// "glbasic.com" -> binary IP
DGStr SOCK_GETHOSTIP_Str(const DGStr& server)
{
NETaddress add = netAddress(server.c_str());
return glb_ipstr_from_netaddress(add);
}

// ------------------------------------------------------------- //
// binary IP -> readable format
DGStr SOCK_GETIP_Str(const DGStr& ip)
{
NETaddress add = glb_netaddress_from_dgstr(ip, 0);
return DGStr(netGetIPstr(add));
}

// ------------------------------------------------------------- //
DGStr SOCK_GETREMOTEIP_Str(DGNat sock)
{
DGStr out;
NETaddress add = netGetRemoteAddress(sock);

return glb_ipstr_from_netaddress(add);
}

// ------------------------------------------------------------- //
DGNat SOCK_GETREMOTEPORT(DGNat sock)
{
return (DGNat)FromBigEndian((unsigned short)netGetRemoteAddress(sock).m_port);
}


// ------------------------------------------------------------- //
DGNat SOCK_CLOSE(DGNat socket)
{
return netCloseSocket(socket) == 0 ? TRUE:FALSE;
}


// ------------------------------------------------------------- //
void SOCK_SETBLOCKING(DGNat socket, DGNat block)
{
netSetBlocking(socket, block?true:false);
}

// ------------------------------------------------------------- //
DGNat SOCK_INIT()
{
__g_DidNET= true;
return netInit() ? TRUE:FALSE;
}

// ------------------------------------------------------------- //
void SOCK_SHUTDOWN()
{
netShutdown();
}


// natural array for map
DGNat FINDPATH(DGNatArray& map, DGNatArray& solutions, DGInt heuristic, DGNat xstart, DGNat ystart, DGNat xend, DGNat yend)
{
DGIntArray fmap;
DIM(fmap, LEN(map), BOUNDS(map,1));
for(int x=0; x<LEN(map); ++x)
for(int y=0; y<BOUNDS(map,1); ++y)
{
fmap(x,y) = map(x,y);
}
return FINDPATH(fmap, solutions, heuristic, xstart, ystart, xend, yend);
}

// DGInt array for return values
DGNat FINDPATH(DGIntArray& map, DGIntArray& solutions, DGInt heuristic, DGNat xstart, DGNat ystart, DGNat xend, DGNat yend)
{
DGNatArray nsol;
DGNat rv = FINDPATH(map, nsol, heuristic, xstart, ystart, xend, yend);
DIM(solutions, LEN(nsol), 2);
for(int i=0; i<LEN(nsol); ++i)
{
solutions(i,0) = nsol(i,0);
solutions(i,1) = nsol(i,1);
}
return rv;
}

// ------------------------------------------------------------- //
// FINDPATH - fastest method
// ------------------------------------------------------------- //
DGNat FINDPATH(DGIntArray& map, DGNatArray& solutions, DGInt heuristic, DGNat xstart, DGNat ystart, DGNat xend, DGNat yend)
{
AStarPlanner			p1;
Planner::Description	desc;
memset(&desc, 0, sizeof(desc));

desc.bDiagonalCost=true;

desc.startX = (int)xstart;
desc.startY = (int)ystart;
desc.endX = (int)xend;
desc.endY = (int)yend;

desc.width =map.max1;
desc.height=map.max2;

desc.hashPrecision = 8;
desc.heuristicWeight = (float)MAX(0.0, MIN(heuristic, 1.0));

desc.can_walk_diagonally = false;

#ifdef __arm__
// DGInt != double
double* pDataTmp = NULL;
pDataTmp = new double[map.max1*map.max2+1];
int j=0;
for (int x=0; x<map.max1; ++x)
for (int y=0; y<map.max2; ++y)
{pDataTmp[j] = map.pData[j]; ++j;}
desc.pMapData = pDataTmp;
#else
desc.pMapData = (double*)map.pData;
#endif

DGNat rv=0;
if(!p1.createMap(desc)) return FALSE;

p1.initialize();
if (p1.run())
{
const Node* pNode = p1.getGoal();
int numnodes = 0;
while(pNode)
{
numnodes++;
pNode = pNode->pParent;
}
if (numnodes==0)
{
DIM(solutions, 0);
rv = 0;
goto okay;
}
DIM(solutions, (int)numnodes, 2);
pNode = p1.getGoal();
while(pNode)
{
numnodes--;
solutions((int)numnodes, 0) = pNode->x;
solutions((int)numnodes, 1) = pNode->y;
pNode = pNode->pParent;
}
p1.cleanup();
rv = solutions.max1;
goto okay;
}
p1.cleanup();

okay:
#ifdef __arm__
if(pDataTmp) delete [] pDataTmp;
#endif

return rv;
}



// ------------------------
// GRAPHICS
// ------------------------

// ------------------------------------------------------------- //

void	CLEARSCREEN(DGNat col)
{
#ifndef GLB_CONSOLE
__g_pRbow->FreeSurface(0);
__g_pRbow->ClearScreen(col);
#else
#ifdef WIN32
system("cls");
#else
system("clear");
#endif
#endif
}

// ------------------------------------------------------------- //
void	BLENDSCREEN(const DGStr& s, DGNat msecs)
{
CLEARERROR();
#ifndef GLB_CONSOLE
DGStr file(s);

if(!glb_prepare_reading_file(file))
{
__Error(CMP_NO_FILE);
CLEARSCREEN();
return;
}

__g_pRbow->GrabSurface(2);
__g_pRbow->LoadSurface(1, file.c_str());
CLEARSCREEN();


float fade;
const float fulltime = msecs;

float endtime = (float)GETTIMERALL() + fulltime;
fade=0.9f;
while(fade<1.0 && fade>0)
{
ALPHAMODE(fade);
__g_pRbow->PasteSurface(2);
ALPHAMODE(1.0f-fade);
__g_pRbow->PasteSurface(1);
SHOWSCREEN();
fade = (float)((endtime - GETTIMERALL()) / fulltime);
}

ALPHAMODE(0);
__g_pRbow->PasteSurface(1);
USEASBMP();

__g_pRbow->FreeSurface(1);
__g_pRbow->FreeSurface(2);

SHOWSCREEN();
#endif
}


// ------------------------------------------------------------- //
void	PRINT(const DGStr& s, DGInt x, DGInt y, DGNat kerning)
{
#ifndef GLB_CONSOLE
__g_pRbow->Text2D((int)__nCurFont, s.c_str(), (float)x, (float)y, 0.0f, kerning, TRUE);
#endif
}


// Drawing text width
DGNat	LEN(const DGStr& s, DGNat kerning)
{
#ifndef GLB_CONSOLE
return __g_pRbow->Text2DWidth((int)__nCurFont, s.c_str(), kerning);
#endif
return LEN(s);
}

DGNat	LEN(const CGStr& s, DGNat kerning)
{
#ifndef GLB_CONSOLE
return __g_pRbow->Text2DWidth((int)__nCurFont, s.c_str(), kerning);
#endif
return LEN(s);
}



// ------------------------------------------------------------- //
void	LOADANIM(DGStr s, DGNat n, DGNat width, DGNat height)
{
#ifndef GLB_CONSOLE
LOADSPRITE(s, n);
if(__g_pRbow->GetSpriteSize((int)n).cx>0)
__g_pRbow->TileSprite((int)n, (int)width, (int)height);
#endif
}

// ------------------------------------------------------------- //
void	SETSPRITEANIM(DGNat n, DGNat width, DGNat height)
{
#ifndef GLB_CONSOLE
if(__g_pRbow->GetSpriteSize((int)n).cx>0)
__g_pRbow->TileSprite((int)n, (int)width, (int)height);
#endif
}

// ------------------------------------------------------------- //
void	DRAWANIM(DGNat num, DGNat iTile, DGNat x, DGNat y)
{
#ifndef GLB_CONSOLE
__g_pRbow->DrawTile(num, iTile, x,y);
#endif
}

// ------------------------------------------------------------- //
void	ROTOZOOMANIM(DGNat num, DGNat itile, DGNat x, DGNat y, DGInt phi, DGInt scale)
{
#ifndef GLB_CONSOLE
__g_pRbow->RotoZoomTile((int)num, (int)itile, (int)x, (int)y, (float)phi, (float)scale);
#endif
}


void	STRETCHANIM(DGNat num, DGNat itile, DGNat x, DGNat y, DGNat w, DGNat h)
{
#ifndef GLB_CONSOLE
__g_pRbow->StretchTile((int)num, (int)itile, (int)x, (int)y, (int)w, (int)h);
#endif
}


// ------------------------------------------------------------- //
DGNat	ANIMCOLL(DGNat ani1, DGNat tile1, DGNat x1, DGNat y1,  DGNat ani2, DGNat tile2, DGNat x2, DGNat y2)
{
#ifndef GLB_CONSOLE
return __g_pRbow->TileCollision((int)ani1, (int)tile1, (int)x1, (int)y1,
(int)ani2, (int)tile2, (int)x2, (int)y2);
#else
return 0;
#endif
}

// ------------------------------------------------------------- //
void	SMOOTHSHADING(DGNat smooth)
{
#ifndef GLB_CONSOLE
__g_pRbow->SetSmoothShading(smooth ? true:false);
#endif
}

// ------------------------------------------------------------- //
void	ALPHAMODE(DGInt alpha)
{
#ifndef GLB_CONSOLE
__g_pRbow->DoAlpha((float)alpha);
#endif
}

// ------------------------------------------------------------- //
void	ALPHATESTING(DGInt alpha)
{
#ifndef GLB_CONSOLE
__g_pRbow->SetAlphaTesting((float)alpha);
#endif
}

// ------------------------------------------------------------- //
void	ROTOSPRITE(DGNat num, DGNat x, DGNat y, DGInt angle)
{
#ifndef GLB_CONSOLE
__g_pRbow->RotoSprite((int)num, (int)x, (int)y, (float)angle, 1.0f);
#endif
}

// ------------------------------------------------------------- //
void	ROTOZOOMSPRITE(DGNat num, DGNat x, DGNat y, DGInt angle, DGInt size) // size[%]
{
#ifndef GLB_CONSOLE
__g_pRbow->RotoSprite((int)num, (int)x, (int)y, (float)angle, (float)size);
#endif
}

// ------------------------------------------------------------- //
void	DRAWSPRITE(DGNat num, DGNat x, DGNat y)
{
#ifndef GLB_CONSOLE
__g_pRbow->DrawSprite(num, x, y);
#endif
}

// ------------------------------------------------------------- //
void STRETCHSPRITE (DGNat num, DGNat px1, DGNat py1, DGNat wx, DGNat wy)
{
#ifndef GLB_CONSOLE
__g_pRbow->StretchSprite((int)num, (int)px1, (int)py1, (int)wx, (int)wy);
#endif
}

// ------------------------------------------------------------- //
void	ZOOMSPRITE(DGNat num, DGNat x, DGNat y, DGInt xsize, DGInt ysize)
{
#ifndef GLB_CONSOLE
xsize=((xsize*__g_pRbow->m_Texture[(int)num].bw));
ysize=((ysize*__g_pRbow->m_Texture[(int)num].bh));

x-=((DGNat)(xsize-(DGInt)__g_pRbow->m_Texture[(int)num].bw)/2);
y-=((DGNat)(ysize-(DGInt)__g_pRbow->m_Texture[(int)num].bh)/2);

__g_pRbow->StretchSprite((int)num, (int)x, (int)y, (int)xsize, (int)ysize);
#endif
}

// ------------------------------------------------------------- //
void GRABSPRITE(DGNat num, DGNat x, DGNat y, DGNat wx, DGNat wy)
{
#ifndef GLB_CONSOLE
if(__g_Prescaler.scale > 1.0f)
{
int spx=wx, spy=wy;
x+=__g_Prescaler.offx;
y+=__g_Prescaler.offy;
wx = (int)(float(wx + 0.99) * __g_Prescaler.scale);
wy = (int)(float(wy + 0.99) * __g_Prescaler.scale);


int dmy = GENSPRITE();

__g_pRbow->GrabSprite(dmy, x, y, wx, wy);
int fbo = GENSCREEN();
CREATESCREEN(fbo, num, spx, spy);
USESCREEN(fbo);
ALPHAMODE(-1);
ALPHATESTING(1); // solid
STRETCHSPRITE(dmy, 0,0,spx,spy);
USESCREEN(-1);
LOADSPRITE(DGStr(""), dmy); // clear dummy
}
else // no prescaler
{
__g_pRbow->GrabSprite((int)num, (int)x, (int)y, (int)wx, (int)wy);
}

#endif
}

// ------------------------------------------------------------- //
void	USEASBMP()
{
#ifndef GLB_CONSOLE
__g_pRbow->GrabSurface(0);
#endif
}

// ------------------------------------------------------------- //
void	LOADBMP(const DGStr& s)
{
CLEARERROR();

#ifndef GLB_CONSOLE
DGStr file(s);

if(!glb_prepare_reading_file(file))
{
__Error(CMP_NO_FILE);
CLEARSCREEN();
return;
}

if (!__g_pRbow->LoadSurface(0, file.c_str()))
{
__Error(CMP_NO_FILE);
CLEARSCREEN();
return;
}
__g_pRbow->PasteSurface(0);
#endif
}

// ------------------------------------------------------------- //
void	SETFONT(DGNat i, DGInt scale)
{
#ifndef GLB_CONSOLE
if(i<0 || i>=GLR_MAX_FONT)
{
__Error(CMP_OUT_OF_MEMORY);
return;
}
__nCurFont = i;
__g_pRbow->m_FontScaling[i] = scale;
#endif
}
// ------------------------------------------------------------- //
DGNat	GETCURRENTFONT() { return __nCurFont;}


// ------------------------------------------------------------- //
void	SETTRANSPARENCY(DGNat col)
{
#ifndef GLB_CONSOLE
__g_pRbow->SetColorKey((COLORREF) col);
#endif
}


// ------------------------------------------------------------- //
void	LOADFONT(const DGStr& s, DGNat num)
{
CLEARERROR();

#ifndef GLB_CONSOLE

if(LEN(s) == 0)
{
// clear the font out - not visible anymore
__g_pRbow->LoadFont(num, "");
return;
}

SETFONT(num, 1.0);
DGStr file(s);
if(!glb_prepare_reading_file(file))
{
__Error(CMP_NO_FILE);
__g_pRbow->DefaultFont((int)num);
return;
}

if (!__g_pRbow->LoadFont(__nCurFont, file.c_str()))
{
__Error(CMP_NO_FILE);
__g_pRbow->DefaultFont((int)num);
return;
}
#endif
}

// ------------------------------------------------------------- //
void	LOADSPRITE(const DGStr& s, DGNat n)
{
CLEARERROR();
#ifndef GLB_CONSOLE
DGStr file(s);
__g_pRbow->FreeSprite((int)n);

if(s.len() == 0)
{
return;
}
if(!glb_prepare_reading_file(file))
{
__Error(CMP_NO_FILE);
return;
}

if(!__g_pRbow->LoadSprite((int)n, file.c_str(), __g_pRbow->m_CookieColor, false))
{
__Error(CMP_NO_FILE);
}


#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
DGNat	MEM2SPRITE(DGNatArray& pixRGBA, DGNat num, DGNat w, DGNat h)
{
#ifdef GLB_CONSOLE
return FALSE;
#else
int sz = w*h;
if(LEN(pixRGBA) != sz) return FALSE;

OPENGL_IMAGE img;
img.resize(w,h);
unsigned char* pOut = img.m_txdata;
const DGNat* pIn = &pixRGBA(0);
for(int i=0; i<sz; ++i)
{
unsigned int pixl = *pIn++;

// printf("Rgba: %x %x %x %x\n", (pixl & 0xff), ((pixl>>8) & 0xff), ((pixl>>16) & 0xff), ((pixl>>24) & 0xff));
*pOut++ = (pixl & 0xff);
*pOut++ = ((pixl>>8) & 0xff);
*pOut++ = ((pixl>>16) & 0xff);
*pOut++ = ((pixl>>24) & 0xff);
}
// printf("\n");
return __g_pRbow->LoadSprite(num, img, __g_pRbow->m_CookieColor, false) ? TRUE:FALSE;
#endif
}


// ------------------------------------------------------------- //
DGNat SPRITE2MEM(DGNatArray& pixRGBA, DGNat num)
{
#ifdef GLB_CONSOLE
return FALSE;
#else
DGNat w, h;
GETSPRITESIZE(num, w,h);
int sz = w*h;
if(sz==0)
return FALSE;
OPENGL_IMAGE img; // keep memory for next run

bool ok = __g_pRbow->GetSpriteRGBA(num, img);
if(!ok)
return FALSE;

FIXDIM(pixRGBA, sz);

const unsigned char* pOut = img.m_txdata;
DGNat* pIn = &pixRGBA(0);
for(int i=0; i<sz; ++i)
{
int r = *pOut++;
int g = *pOut++;
int b = *pOut++;
int a = *pOut++;
// printf("rgba: %x %x %x %x\n", r,g,b,a);
*pIn++ = r+(g<<8)+(b<<16)+(a<<24);
}
// printf("\n");
return TRUE;
#endif
}


// ------------------------------------------------------------- //
DGNat LOADSPRITEMEM(const DGStr& s, DGNat& w, DGNat& h, DGNatArray& pixRGBA)
{
#ifdef GLB_CONSOLE
return FALSE;
#else
DGStr file(s);
if(!glb_prepare_reading_file(file))
{
__Error(CMP_NO_FILE);
return FALSE;
}

OPENGL_IMAGE img;
if(!img.LoadImageBMP(file.c_str(), __g_pRbow->m_CookieColor) && !img.LoadImagePNG(file.c_str(), __g_pRbow->m_CookieColor) && !img.LoadImageJPG(file.c_str()))
{
return FALSE;
}
if(!img.m_bSourceHadAlpha)
img.FixNeighbourAlpha();

w = img.m_sizex;
h = img.m_sizey;
DGNat sz = w*h;	

if(sz==0)
return FALSE;

FIXDIM(pixRGBA, sz);

const unsigned char* pOut = img.m_txdata;
DGNat* pIn = &pixRGBA(0);
for(int i=0; i<sz; ++i)
{
int r = *pOut++;
int g = *pOut++;
int b = *pOut++;
int a = *pOut++;
*pIn++ = r+(g<<8)+(b<<16)+(a<<24);
}
return TRUE;
#endif
}



// ------------------------------------------------------------- //
#ifndef GLB_CONSOLE
unsigned int get_sprite_texture(int id)
{
return (unsigned int)__g_pRbow->m_Texture[id].mipstate[0];
}
#endif

// ------------------------------------------------------------- //
void	LOADBUMPTEXTURE(const DGStr& s, DGNat n)
{
CLEARERROR();
#ifndef GLB_CONSOLE
__g_pRbow->FreeSprite((int)n);
DGStr file(s);
if(!glb_prepare_reading_file(file))
{
__Error(CMP_NO_FILE);
return;
}

if(!__g_pRbow->LoadSprite((int)n, file.c_str(), __g_pRbow->m_CookieColor, true))
{
__Error(CMP_NO_FILE);
}
#endif
}
// ------------------------------------------------------------- //
void	SAVEBMP(const DGStr& s)
{
CLEARERROR();
#ifndef GLB_CONSOLE
if(!__g_pRbow->SaveBMPFile(s.c_str()))
{
__Error(CMP_NO_FILE);
}
#endif
}

// ------------------------------------------------------------- //
void	SAVESPRITE(const DGStr& s, DGNat n)
{
CLEARERROR();
#ifndef GLB_CONSOLE
if(!__g_pRbow->SaveBMPSprite((int)n, s.c_str()))
{
__Error(CMP_NO_FILE);
}
#endif
}

// ------------------------------------------------------------- //
DGNat	SPRCOLL(DGNat n1, DGNat x1, DGNat y1, DGNat n2, DGNat x2, DGNat y2)
{
#ifndef GLB_CONSOLE
return __g_pRbow->SpriteCollision((int)n1, (int)n2, (int)x1, (int)y1, (int)x2, (int)y2);
#else
return 0;
#endif
}

// ------------------------------------------------------------- //
void	DRAWLINE(DGNat sx, DGNat sy, DGNat ex, DGNat ey, DGNat col)
{
#ifndef GLB_CONSOLE
__g_pRbow->DrawLine((int)sx, (int)sy, (int)ex, (int)ey, (COLORREF)col);
#endif
}

// ------------------------------------------------------------- //
void	SETPIXEL(DGNat x,  DGNat y,  DGNat col)
{
#ifndef GLB_CONSOLE
__g_pRbow->DrawPixel((int)x, (int)y, (COLORREF)col);
#endif
}

// ------------------------------------------------------------- //
void	DRAWRECT(DGNat sx, DGNat sy, DGNat wx, DGNat wy, DGNat col)
{
#ifndef GLB_CONSOLE
__g_pRbow->DrawRect((int)sx,
(int)sy,
(int)wx,
(int)wy,
(COLORREF)col);
#endif
}

DGNat	GETPIXEL(DGNat x, DGNat y)
{
#ifndef GLB_CONSOLE
return (DGNat) __g_pRbow->GetPixel((int)x, (int)y);
#else
return 0;
#endif
}


// ------------------------------------------------------------- //
void	GETSPRITESIZE(DGInt id, DGInt& wx, DGInt& wy)
{
#ifndef GLB_CONSOLE
wx = (DGInt)__g_pRbow->GetSpriteSize((int)id).cx;
wy = (DGInt)__g_pRbow->GetSpriteSize((int)id).cy;
#endif
}
// ------------------------------------------------------------- //
void	GETSPRITESIZE(DGNat id, DGNat& wx, DGNat& wy)
{
#ifndef GLB_CONSOLE
wx = (DGNat)__g_pRbow->GetSpriteSize((int)id).cx;
wy = (DGNat)__g_pRbow->GetSpriteSize((int)id).cy;
#endif
}

// ------------------------------------------------------------- //
void	GETFONTSIZE(DGInt& wx, DGInt& wy)
{
#ifndef GLB_CONSOLE
SIZE sz = __g_pRbow->GetFontSize(__nCurFont);
float sc = __g_pRbow->m_FontScaling[__nCurFont];
wx = (DGInt) (sz.cx*sc); wy = (DGInt) (sz.cy*sc);
#endif
}
// ------------------------------------------------------------- //
void	GETFONTSIZE(DGNat& wx, DGNat& wy)
{
#ifndef GLB_CONSOLE
SIZE sz = __g_pRbow->GetFontSize(__nCurFont);
float sc = __g_pRbow->m_FontScaling[__nCurFont];
wx = (DGNat) (sz.cx*sc); wy = (DGNat) (sz.cy*sc);
#endif
}

// ------------------------------------------------------------- //
void	GETSCREENSIZE(DGInt& wx, DGInt& wy)
{
DGNat w, h;
GETSCREENSIZE(w,h);
wx=w; wy=h;
}
// ------------------------------------------------------------- //
void	GETSCREENSIZE(DGNat& wx, DGNat& wy)
{
#ifndef GLB_CONSOLE

// GETSCREENSIZE_SEE_ALSO
if(__g_pRbow->m_CurrentFBO<0)
{
if(__g_pRbow->m_landscape==1 || __g_pRbow->m_landscape==3)
{
wy = (DGNat)__g_pRbow->m_WND.virtw;
wx = (DGNat)__g_pRbow->m_WND.virth;
}
else
{
wx = (DGNat)__g_pRbow->m_WND.virtw;
wy = (DGNat)__g_pRbow->m_WND.virth;
}
}
else
{
wx = __g_pRbow->m_Texture[__g_pRbow->m_FBuffer[__g_pRbow->m_CurrentFBO].m_SpriteIndex].bw;
wy = __g_pRbow->m_Texture[__g_pRbow->m_FBuffer[__g_pRbow->m_CurrentFBO].m_SpriteIndex].bh;
}

#else
#ifdef WIN32
CONSOLE_SCREEN_BUFFER_INFO info;
::GetConsoleScreenBufferInfo(::GetStdHandle(STD_OUTPUT_HANDLE), &info);
wx = info.dwMaximumWindowSize.X;
wy = info.srWindow.Bottom-info.srWindow.Top+1;
#else
// at least this
wx=80;
wy=24;

winsize ws;
if (ioctl(0,TIOCGWINSZ,&ws)==0)
{
wx = ws.ws_row;
wy = ws.ws_col;
}
#endif
#endif
}

void	SETORIENTATION(DGNat imode)
{
#if defined(ANDROID) // SPACE FRACTAL - Fix Orientation on Android when -1 is used).
if (imode==-1)
{	SETORIENTATION(JavaCall_Str(CGStr("getOrientation:")));
}
#endif


#ifndef GLB_CONSOLE
__g_pRbow->m_landscape = MAX(0, MIN(3, imode) );
VIEWPORT(0,0,0,0);
#endif
}

DGNat	GETORIENTATION()
{
#ifndef GLB_CONSOLE
return __g_pRbow->m_landscape;
#endif
return 0;
}


// ------------------------------------------------------------- //
void	GETDESKTOPSIZE(DGInt& wx, DGInt& wy)
{wx = __DG_DESKTOPX; wy=__DG_DESKTOPY;}
void	GETDESKTOPSIZE(DGNat& wx, DGNat& wy)
{wx = __DG_DESKTOPX; wy=__DG_DESKTOPY;}


void STDCOLOR(DGNat iForeground, DGNat iBackground)
{
#ifdef GLB_CONSOLE
static int map_col[] = {0,4,2,6,1,5,3,7,
100,104,102,106,101,105,103,107};
if(iForeground<0 || iForeground>15)
iForeground = 15;
if(iBackground<0 || iBackground>15)
iBackground=0;

#ifdef WIN32
// 0=black, 1=blue,        2=green,        3=cyan,        4=red,        5=purple,        6=yellow,        7=ltgray
// 8=gray   9=light blue, 10=light green, 11=light cyan, 12=light red, 13=light purple, 14=light yellow, 15=white
SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), iForeground+iBackground*16);
#else
/*
const char *const green = "\033[0;40;32m";

\033[30m set foreground color to black
\033[31m set foreground color to red
\033[32m set foreground color to green
\033[33m set foreground color to yellow
\033[34m set foreground color to blue
\033[35m set foreground color to magenta (purple)
\033[36m set foreground color to cyan
\033[37m set foreground color to white

\033[40m set background color to black
\033[41m set background color to red
\033[42m set background color to green
\033[43m set background color to yellow
\033[44m set background color to blue
\033[45m set background color to magenta (purple)
\033[46m set background color to cyan
\033[47m set background color to white

\033[1;30m set foreground color to dark gray
\033[1;31m set foreground color to light red
\033[1;32m set foreground color to light green
\033[1;33m set foreground color to yellow
\033[1;34m set foreground color to light blue
\033[1;35m set foreground color to light magenta (purple)
\033[1;36m set foreground color to light cyan
\033[1;37m set foreground color to white

\033[1;40m set background color to dark gray
\033[1;41m set background color to light red
\033[1;42m set background color to light green
\033[1;43m set background color to yellow
\033[1;44m set background color to light blue
\033[1;45m set background color to light magenta (purple)
\033[1;46m set background color to light cyan
\033[1;47m set background color to white
*/
int icol = map_col[iForeground];
if(icol<99)
printf("\033[%dm", icol+30);
else
printf("\033{1;%dm", icol+30-100);
icol = map_col[iBackground];
if(icol<99)
printf("\033[%dm", icol+40);
else
printf("\033{1;%dm", icol+40-100);
#endif
#endif
}





// ------------------------------------------------------------- //
void PRESCALER(DGInt dx, DGInt dy)
{
#ifndef GLB_CONSOLE
#ifdef TRENKI3D
return;
#endif

if(dx>0 && dy>0)
{
__g_Prescaler.scale = 0.0f; // act with real device
DGInt deskx, desky;
USESCREEN(-1);
GETSCREENSIZE(deskx, desky);
float sc = MIN(deskx/dx, desky/dy);

if(sc >= 10.0f) sc = floor(sc);
else if(sc >= 8.0f) sc=8.0f;
else if(sc >= 4.0f) sc=4.0f;
else if(sc >= 3.0f) sc=3.0f;
else if(sc >= 2.0f) sc=2.0f;
else if(sc >= 1.5f) sc=1.5f;
else sc = 1.0f; // I won't DOWNSCALE!

__g_Prescaler.offx = (deskx - sc*dx) / 2.0f;
__g_Prescaler.offy = (desky - sc*dy) / 2.0f;
__g_Prescaler.dx = dx;
__g_Prescaler.dy = dy;
__g_Prescaler.scale=sc;
__g_pRbow->m_WND.virtw = dx;
__g_pRbow->m_WND.virth = dy;
}
else
{
__g_pRbow->m_WND.virth = 0;
__g_pRbow->m_WND.virtw = 0;
__g_Prescaler.scale=0.0;
}
VIEWPORT(0,0,0,0); // OK, apply this
#endif
}

// ------------------------------------------------------------- //
void	VIEWPORT(DGNat x, DGNat y, DGNat w, DGNat h)
{
#ifndef GLB_CONSOLE
float scale=1.0f;
if(__g_Prescaler.scale != 0.0f && __g_CurrentScreen==-1)
{
if(w<=0)
{
w = __g_Prescaler.dx;
h = __g_Prescaler.dy;
}

x*=__g_Prescaler.scale;
y*=__g_Prescaler.scale;
x+=__g_Prescaler.offx;
y+=__g_Prescaler.offy;

w*=__g_Prescaler.scale;
h*=__g_Prescaler.scale;
scale = __g_Prescaler.scale;
}

#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
__g_pRbow3D->DoShadows(false); // finish shadows if any
#endif
__g_pRbow->Make2DViewport((int)x, (int)y, (int)w, (int)h, scale);
#endif
}

// ------------------------------------------------------------- //
void	GETVIEWPORT(DGNat& x, DGNat& y, DGNat& w, DGNat& h)
{
#ifndef GLB_CONSOLE
x = __g_pRbow->m_WND.viewport.x;
y = __g_pRbow->m_WND.viewport.y;
w = __g_pRbow->m_WND.viewport.width;
h = __g_pRbow->m_WND.viewport.height;
if(__g_Prescaler.scale != 0.0f && __g_CurrentScreen==-1)
{
w/=__g_Prescaler.scale;
h/=__g_Prescaler.scale;
x-=__g_Prescaler.offx;
y-=__g_Prescaler.offy;
}
#endif
}
void	GETVIEWPORT(DGInt& x, DGInt& y, DGInt& w, DGInt& h)
{
#ifndef GLB_CONSOLE
x = (DGInt)__g_pRbow->m_WND.viewport.x;
y = (DGInt)__g_pRbow->m_WND.viewport.y;
w = (DGInt)__g_pRbow->m_WND.viewport.width;
h = (DGInt)__g_pRbow->m_WND.viewport.height;
if(__g_Prescaler.scale != 0.0f && __g_CurrentScreen==-1)
{
w/=__g_Prescaler.scale;
h/=__g_Prescaler.scale;
x-=__g_Prescaler.offx;
y-=__g_Prescaler.offy;
}
#endif
}



// ------------------------------------------------------------- //
void	CREATESCREEN(DGNat iScreen, DGNat iSprite, DGNat width, DGNat height)
{
#ifndef GLB_CONSOLE
__g_pRbow->FBO_create((int)iScreen, (int)iSprite, (int)width, (int)height);
#endif
}

// ------------------------------------------------------------- //
void	USESCREEN(DGNat iScreen)
{
#ifndef GLB_CONSOLE
if(iScreen<0)
{
__g_CurrentScreen=-1;
__g_pRbow->FBO_end();
}
else
{
__g_CurrentScreen = iScreen;
__g_pRbow->FBO_start((int)iScreen);
}
VIEWPORT(0,0,0,0); // this calls the prescaler // __g_pRbow->Make2DMode();
#endif
}


// ------------------------------------------------------------- //
void	STARTPOLY(DGNat nTexture, DGNat bMode)
{
#ifndef GLB_CONSOLE
__g_pRbow->PolyStart((int)nTexture, bMode);
#endif
}

// ------------------------------------------------------------- //
void	POLYVECTOR(DGInt x, DGInt y, DGInt tx, DGInt ty, DGNat col)
{
#ifndef GLB_CONSOLE
__g_pRbow->PolyPoint((float)x, (float)y, (float)tx, (float)ty, (COLORREF)col);
#endif
}

// ------------------------------------------------------------- //
void	POLYNEWSTRIP()
{
#ifndef GLB_CONSOLE
__g_pRbow->PolyNewStrip();
#endif
}


// ------------------------------------------------------------- //
void	ENDPOLY()
{
#ifndef GLB_CONSOLE
__g_pRbow->PolyEnd();
#endif
}


// Get an empty slot for objects
DGNat	GENSPRITE()
{
#ifndef GLB_CONSOLE
return __g_pRbow->GenSprite();
#endif
return -1;
}

DGNat	GENFONT()
{
#ifndef GLB_CONSOLE
return __g_pRbow->GenFont();
#endif
return -1;
}

DGNat	GENSCREEN()
{
#ifndef GLB_CONSOLE
return __g_pRbow->GenFBuffer();
#endif
return -1;
}



// ------------------------------------------------------------- //
void	LIMITFPS(DGInt n, DGNat bVsync)
{
#ifndef GLB_CONSOLE
__g_pRbow->SetMaxFPS((int)n, bVsync?true:false);
#endif
}

// ------------------------------------------------------------- //
DGNat	ISFULLSCREEN()
{
#ifndef GLB_CONSOLE
return __g_pRbow->m_WND.fullscreen ? TRUE:FALSE;
#else
return 0;
#endif
}

// ------------------------------------------------------------- //
DGInt	GETTIMER()
{
// that might be much too short: __g_pRbow->AccurateTime() - __g_ThisTime
DGInt	dt = __g_ThisTime - __g_LastTime;
return dt<=0 ? 1 : dt;
}

// ------------------------------------------------------------- //
DGInt	GETTIMERALL()
{
return ::AccurateTime() - __g_FirstTime; // __g_ThisTime
}


#if defined (TARGET_OS_IPHONE)
}
extern "C"
{
void iPhonePumpEvents(unsigned long ms);
}
namespace __GLBASIC__ {
#endif


// ------------------------------------------------------------- //
void	SLEEP(DGNat ms)
{
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
DGInt end=GETTIMERALL() + ms;
while(GETTIMERALL() < end) {};
#elif defined(TARGET_OS_IPHONE)
iPhonePumpEvents(ms);
#else
msleep((int)ms);
#endif
}


// ------------------------------------------------------------- //
//  SHELLEND - execute and exit
// ------------------------------------------------------------- //
// extern "C" int execl(const char*, const char*, ...);
void	SHELLEND(DGStr cmd)
{
__ShutDownGLBasic();

#ifdef WIN32
// win32-pc
DGInt retval;
SHELLCMD(cmd, FALSE, TRUE, retval);
exit(0);
#else
// *** SPACE FRACTAL FIXES 2017.3.1 ****
#ifndef TVOS // SPACE FRACTAL, Not supported on TVOS.
execl(cmd.c_str(), cmd.c_str(), NULL);

g_debug("failed to call: %s\n", cmd.c_str());

// ok, guys, that point should not be reached at all
exit(0);
#endif
#endif
}


// ------------------------------------------------------------- //
//  SHELLCMD - execute something new
// ------------------------------------------------------------- //
DGInt	SHELLCMD(DGStr cmd, DGInt wait, DGInt show, DGInt& retval)
{
#ifdef WIN32
#ifdef UNICODE
wchar_t pCmd[1024];
// convert from multibyte char string to wide char string
mbstowcs(pCmd, (const char *)cmd.c_str(), cmd.len()+1);
#else
char* pCmd = cmd.getbuffer(1024);
#endif


// win32-pc
STARTUPINFO			si;
PROCESS_INFORMATION	pi;
DGNat furet = TRUE;
retval=0;
memset(&si, 0, sizeof(STARTUPINFO));
si.cb=sizeof(STARTUPINFO);
si.dwFlags=STARTF_USESHOWWINDOW;
si.wShowWindow=show ? SW_SHOWNORMAL : SW_HIDE;

#ifndef GLB_CONSOLE
bool was_fs = 0;
if(__g_pRbow && __g_pRbow->m_WND.fullscreen)
{
was_fs=true;
__g_pRbow->DoWindowed();
}
#endif

if (::CreateProcess(NULL, pCmd, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &si, &pi))
{
cmd.releasebuffer(); // just to be safe in multibyte mode
::CloseHandle(pi.hThread);
if (wait)
{
DWORD dwCode = STILL_ACTIVE;
while(dwCode==STILL_ACTIVE)
{
::WaitForSingleObject(pi.hProcess, INFINITE);
GetExitCodeProcess(pi.hProcess, &dwCode);
// if (dwCode!=STILL_ACTIVE) Sleep(1000);
retval = dwCode;
}
}
::CloseHandle(pi.hProcess);
}
else
furet = FALSE;

if(show)
{
::SetActiveWindow( (HWND)GLBASIC_HWND() );
::SetFocus( (HWND)GLBASIC_HWND() );
}
#ifndef GLB_CONSOLE
if(was_fs && __g_pRbow)
__g_pRbow->DoFullscreen();
#endif

return furet;
#else
#ifndef GLB_CONSOLE
bool was_fs = __g_pRbow->m_WND.fullscreen;
__g_pRbow->DoWindowed();
#endif

int rv=1;
if(!wait)
{
cmd+=CGStr(" &"); // "/bin/sh text.sh &" (do not wait)
}

#if !defined(TARGET_OS_IPHONE)
retval = system(cmd.c_str());
#endif

#ifndef GLB_CONSOLE
if(was_fs)
__g_pRbow->DoFullscreen();
#endif
return rv;
#endif
}




}; // namepsace GLBASIC


// -------- WIN32 --------
#ifdef WIN32
static DGInt	g_perf_cnt=0.0;				    // performance timer frequency
static BOOL		g_perf_flag=FALSE;				// flag determining which timer to use
//---------------------------------------------------------------//
// Replacement to timeGetTime if available
//---------------------------------------------------------------//
DGInt AccurateTime()
{
#if defined(POCKETPC) || defined(_WIN32_WCE)
static DWORD starttime = 0;
if(starttime == 0)
starttime = GetTickCount();
return (DGInt)(GetTickCount()-starttime);
#else
static double starttime = 0.0;
LONGLONG cur_time;       // current time
// use the appropriate method to get time
if (g_perf_flag)
{
QueryPerformanceCounter((LARGE_INTEGER *) &cur_time);
if(starttime == 0)
{
starttime = (double)(cur_time*1000)/g_perf_cnt;
}
return (double)(cur_time*1000)/g_perf_cnt - starttime;
}
if(starttime == 0)
starttime = GetTickCount();
return (double)GetTickCount() - starttime;
#endif
}
// -------- WIZ --------
#elif defined(GPHWIZ)
extern "C" unsigned int wiz_timer_get_ticks_us();
DGInt AccurateTime()
{
static unsigned long starttime= 0;
if(starttime == 0) starttime = wiz_timer_get_ticks_us();
return 	(DGInt)( (wiz_timer_get_ticks_us()-starttime)/1000.0f);
}
// -------- SDL --------
#elif defined(WANT_SDL)
DGInt AccurateTime()
{
static unsigned long starttime= 0;
if(starttime == 0) starttime = SDL_GetTicks();
return (DGInt)(SDL_GetTicks()-starttime);
}
// -------- GP2X --------
#else
DGInt AccurateTime()
{
static long starttime = 0;
timeval now;
gettimeofday(&now, NULL);
if(starttime==0) starttime = now.tv_sec;

return DGInt( (now.tv_sec-starttime)*1000.0f + now.tv_usec * 0.001f ); // usec = microsecs
}
#endif

//---------------------------------------------------------------//
// Setup HP Timer
//---------------------------------------------------------------//
void SetupAccurateTimer()
{
// -------- WIN32 --------
#if defined(WIN32) && !defined(POCKETPC) && !defined(_WIN32_WCE)
g_perf_flag=FALSE;
LONGLONG	cnt;
// is there a performance counter available?
if (QueryPerformanceFrequency((LARGE_INTEGER *) &cnt))
{
if (cnt>0)
{
g_perf_cnt = (double)cnt;
g_perf_flag=TRUE;
}
}
// -------- WIZ/CAANOO --------
#elif defined(GPHWIZ) || defined(CAANOO)

// -------- SDL --------
#elif defined(WANT_SDL)
// SDL_Init(SDL_INIT_TIMER);  - global call now

// -------- Linux -------
#elif defined(POSIX)


#endif
}


void __GQuitNProfile(); // write profile file on demand (gpc_temp0.cpp)

// close all file handles
extern "C" void __GLB_close_all_filehandles()
{
for(int channel=0; channel<MAX_IO_FILES; ++channel)
{
__g_Files[channel].Close();
}
__GQuitNProfile();
}


// ENTRY POINTS
namespace __GLBASIC__
{
extern int __MainGameSub_();
void __AllocConsole();
}


#if (defined( WIN32 ) || defined(_WIN32_WCE) )&& !defined( GLB_CONSOLE )
#if defined(__cplusplus) // || defined(MACOSX) || defined(TARGET_OS_IPHONE)
extern "C"
#endif
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
#ifdef _WIN32_WCE
#ifdef UNICODE
__glb_cmdline().assign((const wchar_t*)lpCmdLine);
#else
__glb_cmdline().assign(lpCmdLine);
#endif
__glb_cmdline()=CGStr("glbasic.exe ") + __glb_cmdline();
#else
#ifdef UNICODE
__glb_cmdline().assign((const wchar_t*)::GetCommandLine());
#else
__glb_cmdline().assign(::GetCommandLine());
#endif
#endif


__GLB_Defaults();
__GlobalInit(hInst, nCmdShow, __glb_AppName().c_str());

__g_debugline=__g_error=__g_errorline=0;
int rv = __MainGameSub_();

DGStr glb_on_loop = "GLB_ON_LOOP";
if(GETSUBADDRESS(glb_on_loop) != NULL)
{
SETLOOPSUB(glb_on_loop);
}
__EndProgram();

return rv;
}

int APIENTRY DllMain(HINSTANCE hInst, DWORD reason, LPVOID /*reserved*/)
{
__GLB_Defaults();
__GlobalInit(hInst, SW_SHOWNORMAL, __glb_AppName().c_str());

__g_debugline=__g_error=__g_errorline=0;
return TRUE;
}

#else
#if defined(TARGET_OS_IPHONE)
#define main iPhoneMain // make a "main" callback from this main, and call from the real main()
#endif

#if defined(__cplusplus) || defined(MACOSX) || defined(TARGET_OS_IPHONE) || defined(ANDROID)
extern "C"
#endif
int main(int argc, char* argv[])
{
for (long nc=0; nc<argc; nc++)
{
if(nc==0 || strchr(argv[nc], ' ')!=NULL) // has space in argument, or is first argument
{
__glb_cmdline()+=CGStr("\"") + DGStr(argv[nc]) + CGStr("\"");
}
else
{
__glb_cmdline()+=argv[nc];
}
if(nc<argc-1)
__glb_cmdline()+=" ";
}

#ifdef PALM_WEBOS
PDL_Init(0);
#endif

__GLB_Defaults();

__GlobalInit(0L, 0, __glb_AppName().c_str());
__g_debugline=__g_error=__g_errorline=0;
int rv = __MainGameSub_();

DGStr glb_on_loop = "GLB_ON_LOOP";
if(GETSUBADDRESS(glb_on_loop) != NULL)
{
SETLOOPSUB(glb_on_loop);
}

// emscripten has set the main loop sub and must return here - don't tear engine down!
#if defined(EMSCRIPTEN)
return 0;
#else
__EndProgram();
#endif


return rv;
}
#endif

#include "stdafx.h" // #include "stdafx.h"


#ifndef GLB_CONSOLE
#include "fbuffers.h" // #include "fbuffers.h"
#include "openglrainbows.h" // #include "openglrainbows.h"

// Pandora:
// glBlendEquationOES = (PFNGLBLENDEQUATIONOESPROC)eglGetProcAddress("glBlendEquationOES");



// ES wrappers to have "EXT" names
#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
#if defined(STATIC_NO_POSTFIX)
#define GL_RENDERBUFFER_EXT GL_RENDERBUFFER
#define GL_FRAMEBUFFER_EXT GL_FRAMEBUFFER
#define GL_FRAMEBUFFER_COMPLETE_EXT GL_FRAMEBUFFER_COMPLETE
#define GL_COLOR_ATTACHMENT0_EXT GL_COLOR_ATTACHMENT0
#define GL_DEPTH_ATTACHMENT_EXT GL_DEPTH_ATTACHMENT
#define GL_DEPTH_COMPONENT16 GL_DEPTH_COMPONENT16
#define GL_DEPTH_COMPONENT24 GL_DEPTH_COMPONENT24
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME
#define GL_FRAMEBUFFER_BINDING_EXT GL_FRAMEBUFFER_BINDING
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE

#else
#define GL_RENDERBUFFER_EXT GL_RENDERBUFFER_OES
#define GL_FRAMEBUFFER_EXT GL_FRAMEBUFFER_OES
#define GL_FRAMEBUFFER_COMPLETE_EXT GL_FRAMEBUFFER_COMPLETE_OES
#define GL_COLOR_ATTACHMENT0_EXT GL_COLOR_ATTACHMENT0_OES
#define GL_DEPTH_ATTACHMENT_EXT GL_DEPTH_ATTACHMENT_OES
#define GL_DEPTH_COMPONENT16 GL_DEPTH_COMPONENT16_OES
#define GL_DEPTH_COMPONENT24 GL_DEPTH_COMPONENT24_OES
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES
#define GL_FRAMEBUFFER_BINDING_EXT GL_FRAMEBUFFER_BINDING_OES
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES
#endif
#endif



#ifdef GF_MUST_LOAD_EXTENSIONS

#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
#define PFNGLBINDRENDERBUFFEREXTPROC PFNGLBINDRENDERBUFFEROESPROC						
#define PFNGLDELETERENDERBUFFERSEXTPROC PFNGLDELETERENDERBUFFERSOESPROC					
#define PFNGLGENRENDERBUFFERSEXTPROC PFNGLGENRENDERBUFFERSOESPROC						
#define PFNGLRENDERBUFFERSTORAGEEXTPROC PFNGLRENDERBUFFERSTORAGEOESPROC					
#define PFNGLBINDFRAMEBUFFEREXTPROC PFNGLBINDFRAMEBUFFEROESPROC						
#define PFNGLDELETEFRAMEBUFFERSEXTPROC PFNGLDELETEFRAMEBUFFERSOESPROC						
#define PFNGLGENFRAMEBUFFERSEXTPROC PFNGLGENFRAMEBUFFERSOESPROC						
#define PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC PFNGLCHECKFRAMEBUFFERSTATUSOESPROC					
#define PFNGLFRAMEBUFFERTEXTURE2DEXTPROC PFNGLFRAMEBUFFERTEXTURE2DOESPROC					
#define PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC PFNGLFRAMEBUFFERRENDERBUFFEROESPROC				
#define PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVOESPROC
#endif

extern "C"{
typedef void (APIENTRYP GF_PFNGLBINDRENDERBUFFEREXTPROC) (GLenum target, GLuint renderbuffer);
typedef void (APIENTRYP GF_PFNGLDELETERENDERBUFFERSEXTPROC) (GLsizei n, const GLuint *renderbuffers);
typedef void (APIENTRYP GF_PFNGLGENRENDERBUFFERSEXTPROC) (GLsizei n, GLuint *renderbuffers);
typedef void (APIENTRYP GF_PFNGLRENDERBUFFERSTORAGEEXTPROC) (GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
typedef void   (APIENTRYP GF_PFNGLBINDFRAMEBUFFEREXTPROC) (GLenum target, GLuint framebuffer);
typedef void   (APIENTRYP GF_PFNGLDELETEFRAMEBUFFERSEXTPROC) (GLsizei n, const GLuint *framebuffers);
typedef void   (APIENTRYP GF_PFNGLGENFRAMEBUFFERSEXTPROC) (GLsizei n, GLuint *framebuffers);
typedef GLenum (APIENTRYP GF_PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC) (GLenum target);
typedef void   (APIENTRYP GF_PFNGLFRAMEBUFFERTEXTURE2DEXTPROC) (GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
typedef void   (APIENTRYP GF_PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC) (GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
typedef void   (APIENTRYP GF_PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC) (GLenum target, GLenum attachment, GLenum pname, GLint *params);
}
#endif



// #if defined(HAVE_OPENGL) || (defined(HAVE_OPENGL_ES) && defined(_DEBUG))

#ifdef GF_MUST_LOAD_EXTENSIONS
namespace FRAMEBUFFER {
// EXT_framebuffer_object - http://oss.sgi.com/projects/ogl-sample/registry/EXT/framebuffer_object.txt

PFNGLBINDRENDERBUFFEREXTPROC glBindRenderbufferExt = NULL;
PFNGLDELETERENDERBUFFERSEXTPROC glDeleteRenderbuffersExt = NULL;
PFNGLGENRENDERBUFFERSEXTPROC glGenRenderbuffersExt = NULL;
PFNGLRENDERBUFFERSTORAGEEXTPROC glRenderbufferStorageExt = NULL;
PFNGLBINDFRAMEBUFFEREXTPROC glBindFramebufferExt = NULL;
PFNGLDELETEFRAMEBUFFERSEXTPROC glDeleteFramebuffersExt = NULL;
PFNGLGENFRAMEBUFFERSEXTPROC glGenFramebuffersExt = NULL;
PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC glCheckFramebufferStatusExt = NULL;
PFNGLFRAMEBUFFERTEXTURE2DEXTPROC glFramebufferTexture2DExt = NULL;
PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC glFramebufferRenderbufferExt = NULL;
PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC glGetFramebufferAttachmentParameterivExt = NULL;
// PFNGLISRENDERBUFFEREXTPROC glIsRenderbufferExt = NULL;
// PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC glGetRenderbufferParameterivExt = NULL;
// PFNGLISFRAMEBUFFEREXTPROC glIsFramebufferExt = NULL;
// PFNGLFRAMEBUFFERTEXTURE1DEXTPROC glFramebufferTexture1DExt = NULL;
// PFNGLFRAMEBUFFERTEXTURE3DEXTPROC glFramebufferTexture3DExt = NULL;
// PFNGLGENERATEMIPMAPEXTPROC glGenerateMipmapExt = NULL;

}
using namespace FRAMEBUFFER;
#endif


int gCanUseFBO = 0;

void FBUFFER::InitFrameBufferObject()
{
#ifdef GF_MUST_LOAD_EXTENSIONS
glBindRenderbufferExt = (GF_PFNGLBINDRENDERBUFFEREXTPROC)glGFGetProcAddressArb("glBindRenderbuffer" EXTENSION_POSTFIX);
glDeleteRenderbuffersExt = (GF_PFNGLDELETERENDERBUFFERSEXTPROC)glGFGetProcAddressArb("glDeleteRenderbuffers" EXTENSION_POSTFIX);
glGenRenderbuffersExt = (GF_PFNGLGENRENDERBUFFERSEXTPROC)glGFGetProcAddressArb("glGenRenderbuffers" EXTENSION_POSTFIX);
glRenderbufferStorageExt = (GF_PFNGLRENDERBUFFERSTORAGEEXTPROC)glGFGetProcAddressArb("glRenderbufferStorage" EXTENSION_POSTFIX);
glBindFramebufferExt = (GF_PFNGLBINDFRAMEBUFFEREXTPROC)glGFGetProcAddressArb("glBindFramebuffer" EXTENSION_POSTFIX);
glDeleteFramebuffersExt = (GF_PFNGLDELETEFRAMEBUFFERSEXTPROC)glGFGetProcAddressArb("glDeleteFramebuffers" EXTENSION_POSTFIX);
glGenFramebuffersExt = (GF_PFNGLGENFRAMEBUFFERSEXTPROC)glGFGetProcAddressArb("glGenFramebuffers" EXTENSION_POSTFIX);
glCheckFramebufferStatusExt = (GF_PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC)glGFGetProcAddressArb("glCheckFramebufferStatus" EXTENSION_POSTFIX);
glFramebufferTexture2DExt = (GF_PFNGLFRAMEBUFFERTEXTURE2DEXTPROC)glGFGetProcAddressArb("glFramebufferTexture2D" EXTENSION_POSTFIX);
glFramebufferRenderbufferExt = (GF_PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC)glGFGetProcAddressArb("glFramebufferRenderbuffer" EXTENSION_POSTFIX);
glGetFramebufferAttachmentParameterivExt = (GF_PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC)glGFGetProcAddressArb("glGetFramebufferAttachmentParameteriv" EXTENSION_POSTFIX);
//	glIsRenderbufferExt = (GF_PFNGLISRENDERBUFFEREXTPROC)glGFGetProcAddressArb("glIsRenderbuffer" EXTENSION_POSTFIX);
//	glGetRenderbufferParameterivExt = (GF_PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC)glGFGetProcAddressArb("glGetRenderbufferParameteriv" EXTENSION_POSTFIX);
//	glIsFramebufferExt = (GF_PFNGLISFRAMEBUFFEREXTPROC)glGFGetProcAddressArb("glIsFramebuffer" EXTENSION_POSTFIX);
//	glFramebufferTexture1DExt = (GF_PFNGLFRAMEBUFFERTEXTURE1DEXTPROC)glGFGetProcAddressArb("glFramebufferTexture1D" EXTENSION_POSTFIX);
//	glFramebufferTexture3DExt = (GF_PFNGLFRAMEBUFFERTEXTURE3DEXTPROC)glGFGetProcAddressArb("glFramebufferTexture3D" EXTENSION_POSTFIX);
//	glGenerateMipmapExt = (GF_PFNGLGENERATEMIPMAPEXTPROC)glGFGetProcAddressArb("glGenerateMipmap" EXTENSION_POSTFIX);

#elif defined(STATIC_NO_POSTFIX)
// static functions are there, but with no postfix
#define glBindRenderbufferExt glBindRenderbuffer
#define glDeleteRenderbuffersExt glDeleteRenderbuffers
#define glGenRenderbuffersExt glGenRenderbuffers
#define glRenderbufferStorageExt glRenderbufferStorage
#define glBindFramebufferExt glBindFramebuffer
#define glDeleteFramebuffersExt glDeleteFramebuffers
#define glGenFramebuffersExt glGenFramebuffers
#define glCheckFramebufferStatusExt glCheckFramebufferStatus
#define glFramebufferTexture2DExt glFramebufferTexture2D
#define glFramebufferRenderbufferExt glFramebufferRenderbuffer
#define glGetFramebufferAttachmentParameterivExt glGetFramebufferAttachmentParameteriv
#elif defined(STATIC_OES_POSTFIX)
// static functions are there, but with OES postfix
#define glBindRenderbufferExt glBindRenderbufferOES
#define glDeleteRenderbuffersExt glDeleteRenderbuffersOES
#define glGenRenderbuffersExt glGenRenderbuffersOES
#define glRenderbufferStorageExt glRenderbufferStorageOES
#define glBindFramebufferExt glBindFramebufferOES
#define glDeleteFramebuffersExt glDeleteFramebuffersOES
#define glGenFramebuffersExt glGenFramebuffersOES
#define glCheckFramebufferStatusExt glCheckFramebufferStatusOES
#define glFramebufferTexture2DExt glFramebufferTexture2DOES
#define glFramebufferRenderbufferExt glFramebufferRenderbufferOES
#define glGetFramebufferAttachmentParameterivExt glGetFramebufferAttachmentParameterivOES
#elif defined(STATIC_EXT_POSTFIX)
// static functions are there, but with OES postfix
#define glBindRenderbufferExt glBindRenderbufferEXT
#define glDeleteRenderbuffersExt glDeleteRenderbuffersEXT
#define glGenRenderbuffersExt glGenRenderbuffersEXT
#define glRenderbufferStorageExt glRenderbufferStorageEXT
#define glBindFramebufferExt glBindFramebufferEXT
#define glDeleteFramebuffersExt glDeleteFramebuffersEXT
#define glGenFramebuffersExt glGenFramebuffersEXT
#define glCheckFramebufferStatusExt glCheckFramebufferStatusEXT
#define glFramebufferTexture2DExt glFramebufferTexture2DEXT
#define glFramebufferRenderbufferExt glFramebufferRenderbufferEXT
#define glGetFramebufferAttachmentParameterivExt glGetFramebufferAttachmentParameterivEXT
#endif

gCanUseFBO = 0;

#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if((long)glGenFramebuffersExt)
gCanUseFBO = 1;
#endif

// Android shite does not have FBO support, but functions are there :/
#if !defined(GF_MUST_LOAD_EXTENSIONS)
#if defined(ANDROID)
if(!strstr((const char*)glGetString(GL_EXTENSIONS), "framebuffer_object"))
{
static int iWarn = 0;
if(iWarn == 0)
{
iWarn = 1;
g_debug("framebuffer_object not in GL_EXTENSIONS\n");
gCanUseFBO = 0;
}
}
#endif
#endif

#ifdef _DEBUG
//	gCanUseFBO = 0;
#endif

if(!gCanUseFBO)
g_debug("can't use framebuffer object\n");
}


bool FBUFFER::Create(int w, int h, unsigned int texture, bool bDepthBuffer)
{
Clear();
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)

if(w<=0 || h<=0)
{
g_debug("can't create FBO for neg dims %dx%d\n", w,h);
return false;
}

#if defined(GF_MUST_LOAD_EXTENSIONS)
if(	glGenFramebuffersExt && glGenRenderbuffersExt && glBindRenderbufferExt && glRenderbufferStorageExt && glCheckFramebufferStatusExt)
#endif
{
// Create a frame-buffer object and a render-buffer object...
glGenFramebuffersExt( 1, &m_frameBuffer );
OPENGL_CHECK_ERRORS();
if(!m_frameBuffer)
{
g_debug("glGenFramebuffersExt failed\n");
return false;
}

// bind to complete
this->Bind();

glBindTexture(GL_TEXTURE_2D, texture); // DO bind that texture before putting in the fbo
OPENGL_CHECK_ERRORS();

// bind texture (2012-oct-17 moved before depth buffer)
glFramebufferTexture2DExt( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, texture, 0 );
OPENGL_CHECK_ERRORS();

// optional depth storage
if( bDepthBuffer)
{
glGenRenderbuffersExt( 1, &m_depthRenderBuffer );
OPENGL_CHECK_ERRORS();
if(!m_depthRenderBuffer)
{
g_debug("glGenRenderbuffersExt failed\n");
Clear();
return false;
}
// Initialize the render-buffer for usage as a depth buffer.
// We don't really need this to render things into the frame-buffer object,
// but without it the geometry will not be sorted properly.
glBindRenderbufferExt( GL_RENDERBUFFER_EXT, m_depthRenderBuffer );
OPENGL_CHECK_ERRORS();

// order of trying the formats.
#define GF_GL_DEPTH_COMPONENT16              0x81A5
#define GF_GL_DEPTH_COMPONENT24              0x81A6
#define GF_GL_DEPTH_COMPONENT32              0x81A7

while(glGetError() != GL_NO_ERROR) {} // clear error flags

glRenderbufferStorageExt( GL_RENDERBUFFER_EXT, GF_GL_DEPTH_COMPONENT32, w, h);
if(glGetError() == GL_INVALID_ENUM)
{
g_debug("depth 32 failed, try 24\n");
glRenderbufferStorageExt( GL_RENDERBUFFER_EXT, GF_GL_DEPTH_COMPONENT24, w, h);
}
if(glGetError() == GL_INVALID_ENUM)
{
g_debug("depth 32 failed, try 16\n");
glRenderbufferStorageExt( GL_RENDERBUFFER_EXT, GF_GL_DEPTH_COMPONENT16, w, h);
}

OPENGL_CHECK_ERRORS();
glFramebufferRenderbufferExt( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, m_depthRenderBuffer );
OPENGL_CHECK_ERRORS();
}

// Check for errors after binding it
GLenum status = glCheckFramebufferStatusExt( GL_FRAMEBUFFER_EXT );
if(status == 0)
{
g_debug("glCheckFramebufferStatusExt()=0: glError=%x\n", (int)glGetError());
}
OPENGL_CHECK_ERRORS();

// bind current one to avoid breaking stuff
this->Unbind();

if(status != GL_FRAMEBUFFER_COMPLETE_EXT)
{
#if defined(GF_WANT_OPENGL_DEBUG)
#if defined(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT)
#define ERRSTR(a) if(status == (a)) g_debug("FBO Status: %s\n", #a);
ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT); // minion gets this on Nexus7. Might be renderbuffer invalid?
ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT); // get this on my touchpad
ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT);
ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT);
ERRSTR(GL_FRAMEBUFFER_UNSUPPORTED_EXT);
ERRSTR(GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT);
#else
g_debug("FBO Status: %x\n", status);
#endif
#endif

g_debug("glBindRenderbufferExt failed %x\n", (int)status); // 8cd9 wenn tex too small..
Clear();

if(bDepthBuffer)
{
g_debug("Trying without a depth buffer as a fallback...\n"); // 8cd9 wenn tex too small..
return Create(w, h, texture, false);
}
g_debug("CAN'T CREATE FRAMEBUFFER (CREATESCREEN)\n"); // 8cd9 wenn tex too small..
return false;
}


m_Width=w;
m_Height=h;
return true;
}
#else
return true; // Trenki3D - no z buffer :( #NEED
#endif
return false;
}

int FBUFFER::GetActiveFrameBuffer()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if(!gCanUseFBO) return 0;

GLint current = 0;
glGetIntegerv(GL_FRAMEBUFFER_BINDING_EXT, &current);
OPENGL_CHECK_ERRORS();
return current;
#endif
return 0;
}

int FBUFFER::GetActiveFrameBufferTexture()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if(!gCanUseFBO) return 0;

GLint current = 0;
if((long)glGetFramebufferAttachmentParameterivExt)
glGetFramebufferAttachmentParameterivExt(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT, &current);
OPENGL_CHECK_ERRORS();
return current;
#endif
return 0;
}

bool FBUFFER::Bind()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if(!gCanUseFBO)
{return false;}

// not currently rendering to _this_ fbo
if(m_oldframeBuffer == -1)
{
// remember current FBO name - SDL e.g. uses a FBO as the back buffer
m_oldframeBuffer=0;
glGetIntegerv(GL_FRAMEBUFFER_BINDING_EXT, &m_oldframeBuffer);
OPENGL_CHECK_ERRORS();

// Bind the frame-buffer object and attach to it a render-buffer object 
// set up as a depth-buffer.
glBindFramebufferExt( GL_FRAMEBUFFER_EXT, m_frameBuffer );
OPENGL_CHECK_ERRORS();

return true;
}
else
{
g_debug("Trying to rebind the same FBO again. Need to end first\n");
}
#endif
return false;
}

bool FBUFFER::Unbind()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if(!gCanUseFBO) return false;

if(m_oldframeBuffer != -1)
{
// Unbind the frame-buffer and render-buffer objects.
glBindFramebufferExt( GL_FRAMEBUFFER_EXT, m_oldframeBuffer );
OPENGL_CHECK_ERRORS();
m_oldframeBuffer = -1;
return true;
}
#endif
return false;
}


void FBUFFER::Clear()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)

Unbind(); // just in case

if(m_frameBuffer)
{
glDeleteFramebuffersExt( 1, &m_frameBuffer );
OPENGL_CHECK_ERRORS();
if(m_depthRenderBuffer)
glDeleteRenderbuffersExt( 1, &m_depthRenderBuffer );
OPENGL_CHECK_ERRORS();
}
m_frameBuffer = 0;
m_depthRenderBuffer = 0;
m_oldframeBuffer = -1;
#endif
m_SpriteIndex = -1;
m_Width=m_Height = 0;
}



#define GLR_EMERGENCY_TEXTURE (GLR_MAX_TEXTURES-GLR_MAX_FONT-1)

bool OpenGLRainbows::FBO_create(int iBuffer, int idSprite, int width, int height)
{
if(iBuffer<0 || iBuffer>=GLR_MAX_FRAMEBUFFER) return false;

this->FBO_end();
m_FBuffer[iBuffer].Clear();

if(idSprite >= 0)
FreeSprite(idSprite);

if(width<=0 || height<=0 || idSprite<0)
{
return false;
}

OPENGL_IMAGE img;
#if defined(TINYGL)  || defined(TRENKI3D)
int		sx, sy;
sx = width; sy  =height;
if(!img.resize(sx,sy))
{
return false;
}
if(!m_Sprite[idSprite].CreateBy(img, m_CookieColor))
{
return false;
}
#else
int		sx, sy;
// Create 2^n size
sx=1; sy=1;
do{sx<<=1;} while(sx < width);
do{sy<<=1;} while(sy < height);

if(!img.resize(sx,sy))
{
m_FBuffer[iBuffer].Clear();
return false;
}

// glGenTextures( 1, &m_Texture[idTexture].mipstate[0] );
OPENGL_CHECK_ERRORS();
// will delete old texture and create new one (reusing id)
if(!this->MakeTexture(img, 0,0,sx,sy,&m_Texture[idSprite].mipstate[0]))
{
OPENGL_CHECK_ERRORS();
return false;
}
OPENGL_CHECK_ERRORS();
#endif

m_Texture[idSprite].w =(short)sx; // Set Size of Texture
m_Texture[idSprite].h =(short)sy;
m_Texture[idSprite].bw=(short)width; // Set Size of BMP File
m_Texture[idSprite].bh=(short)height;
m_Texture[idSprite].txx=(float)m_Texture[idSprite].bw/m_Texture[idSprite].w;
m_Texture[idSprite].txy=(float)m_Texture[idSprite].bh/m_Texture[idSprite].h;

// create a depth buffer render target and a new framebuffer object
if(!m_FBuffer[iBuffer].Create(sx,sy, m_Texture[idSprite].mipstate[0], true))
return false;

// store sprite index to access it later
m_FBuffer[iBuffer].m_SpriteIndex = idSprite;

this->FBO_end();

return true;
}


struct BACKUP_STATE
{
int irot;
} gBackupState;

void OpenGLRainbows::FBO_start(int iBuffer)
{
if(m_CurrentFBO>=0) FBO_end();

if(iBuffer<0 || iBuffer>=GLR_MAX_FRAMEBUFFER) return;
if(m_FBuffer[iBuffer].m_Width == 0)    return;

m_CurrentFBO = iBuffer;

int iSprite = m_FBuffer[iBuffer].m_SpriteIndex;
int sx = m_Texture[iSprite].bw;
int sy = m_Texture[iSprite].bh;

#if defined(TRENKI3D)
// texture is the oBitmap index
Screen.SetDrawBuffer(m_Sprite[iSprite].Pixels(), m_Sprite[iSprite].m_Width, m_Sprite[iSprite].m_Height);
tglSetBuffers(m_Sprite[iSprite].Pixels(), Screen.zBuffer, m_Sprite[iSprite].m_Width);
// tglViewport(0,0,sx,sy);
Make2DViewport(0,0,sx,sy); // you must also reload the matrix!
#else
if(m_FBuffer[iBuffer].Bind( ) ) // just bind to texture attached
{
Make2DViewport(0,0,sx,sy);
glViewport(0, 0, sx,sy);
OPENGL_CHECK_ERRORS();
}
else
{
// Use BackBuffer emergency fix (also for TinyGL)
this->m_CurrentFBO = -1; // pretend we're not on FBO for X_MAKE2D
gBackupState.irot = m_landscape;
m_landscape = 0;
Make2DViewport(0,0,sx,sy);
COLORREF cc = m_CookieColor;
m_CookieColor = 0xffffffff;
GrabSprite(GLR_EMERGENCY_TEXTURE, 0,0,sx,sy);
m_CookieColor = cc;
DrawRect(0,0, sx,sy, m_CookieColor);
DrawSprite(iSprite, 0,0);
m_CurrentFBO = iBuffer;
}
#endif

#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
// must void the alpha pixels
#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
SpritePix[iSprite].Clear();
#else
if (SpritePix[iSprite])
delete[] SpritePix[iSprite];
SpritePix[iSprite]=NULL;
#endif
#endif
}


void OpenGLRainbows::FBO_end()
{
if(m_CurrentFBO >=0)
{
#if defined(TRENKI3D)
// texture is the oBitmap index
Screen.SetDrawBuffer();
tglSetBuffers(Screen.cBuffer, Screen.zBuffer, Screen.cBufferWidth);
tglViewport(0,0,Screen.cBufferWidth, Screen.cBufferHeight);
#else
if(!m_FBuffer[m_CurrentFBO].Unbind())
{
// Backbuffer emergency fix
int iSprite = m_FBuffer[m_CurrentFBO].m_SpriteIndex;
GrabSprite(iSprite, 0,0, m_Texture[iSprite].bw, m_Texture[iSprite].bh);
DrawRect(0,0, m_Texture[iSprite].w, m_Texture[iSprite].h, RGB(0,0,0) );
DrawSprite(GLR_EMERGENCY_TEXTURE, 0,0);
m_landscape = gBackupState.irot;
}
#endif
}
m_CurrentFBO = -1;
Make2DViewport(0,0,0,0);
}


#else // console
void glb_fbuffers_console_dummy() {};
#endif // GLB_CONSOLE -> drop all

// 3D Commands
// ------------------------------------------------------- //

#define VC_EXTRALEAN
#define _NO_OLDNAMES // Allow _yn() but not yn() in Math.h
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h" // #include "stdafx.h"
#include "glb.h" // #include "glb.h"
#include "glb3d.h" // #include "glb3d.h"

#ifndef GLB_CONSOLE
#include "rainbows3d.h" // #include "rainbows3d.h"
#include "openglrainbows.h" // #include "openglrainbows.h"

#include <math.h>
#include <stdlib.h>
#include <stdio.h>


#include "gfini.h" // #include "gfini.h"


#include "glstate.h" // #include "glstate.h"

#ifdef WANT_SHOEBOX
#include "gfshoebox.h" // #include "gfshoebox.h"
extern GFShoeBox *__g_ShoeBox_Data;
extern GFShoeBox *__g_ShoeBox_Media;
#endif
#endif


namespace __GLBASIC__
{
// From DINGS_MAIN.cpp
#ifndef GLB_CONSOLE
extern OpenGLRainbows*	__g_pRbow;
extern bool				__g_Did3D;

// Global Object for 3D
extern Rainbows3D*	__g_pRbow3D;
struct TEXSTATE3D
{
TEXSTATE3D() {num=num_multi=-1; mipmapstate=0;}
int num, num_multi, mipmapstate;
}__g_TexState3D;
#endif


// ------------------------------------------------------- //
void	X_MAKE2D(void)
{
#ifndef GLB_CONSOLE
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
__g_pRbow3D->DoShadows(false);
#endif
__g_pRbow->Make2DMode();
#endif
}

void	X_MAKE3D(DGInt znear, DGInt zfar, DGInt fov)
{
#ifndef GLB_CONSOLE
#if !defined(TINYGL) && !defined(TRENKI3D)
X_CLEAR_Z();
#endif
__g_Did3D=true;
__g_pRbow3D->Make3DViewport((float)znear, (float)zfar, (float) fov);
X_CULLMODE(0);
__g_pRbow3D->LightsOff();

// do this manually again, since I store texture state in glb3d.cpp now
X_SETTEXTURE(-1, -1);
#endif
}

void	X_MIPMAPPING(DGNat state)
{
#ifndef GLB_CONSOLE
#if defined (HAVE_OPENGL) // not for ES enabled
__g_TexState3D.mipmapstate=(int)state;
#endif
#endif
}


void	X_SETTEXTURE(DGNat num, DGNat num_multi)
{
#ifndef GLB_CONSOLE
__g_TexState3D.num = (int)num;
__g_TexState3D.num_multi = (int)num_multi;
__g_pRbow->SetTexture3D(__g_TexState3D.num, __g_TexState3D.num_multi, __g_TexState3D.mipmapstate);
__g_pRbow->ApplySmoothShading(); // might want blocky 3D
if(__g_pRbow3D->IsShaderActive())
{
const char* pTex1 = "TextureID1", *pTex2="TextureID2";
__g_pRbow3D->PutShaderUniform1i(pTex1, 0);
__g_pRbow3D->PutShaderUniform1i(pTex2, 1);
}
#endif
}
void	X_SETTEXTUREOFFSET(DGInt du, DGInt dv)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetTextureOffset((float)du, (float)dv);
#endif
}

void	X_AMBIENT_LT(DGNat num, DGNat col)
{
#ifndef GLB_CONSOLE
#ifndef POCKETPC
__g_pRbow3D->AmbientLt((int)num, (COLORREF)col);
#endif
#endif
}
void	X_SPOT_LT(DGNat num, DGNat col, DGInt x, DGInt y, DGInt z, DGInt dirx, DGInt diry, DGInt dirz, DGInt cutoff)
{
#ifndef GLB_CONSOLE
#ifndef POCKETPC
__g_pRbow3D->SpotLt((int)num, (COLORREF)col, (float)x, (float)y, (float)z, (float)dirx, (float)diry, (float)dirz, (float)cutoff, __DG_DEBUG);
#endif
#endif
}
void	X_DRAWAXES(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->DrawCoordAxis((float)x, (float)y, (float)z);
#endif
}
void	X_AUTONORMALS(DGNat mode)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->UserObjectAutoNormalMode((long)mode);
#endif
}
void	X_OBJSTART(DGNat num)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->UserObjectStart((int)num);
#endif
}

void    X_OBJSETFRAME(DGNat num)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->UserObjectSetFrame((int)num);
#endif
}

void	X_OBJADDVERTEX_NORMAL(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->UserObjectSetNormal((float)x, (float)y, (float)z);
#endif
}
void	X_OBJADDVERTEX(DGInt x, DGInt y, DGInt z, DGInt tx, DGInt ty, DGNat col)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->UserObjectAddVertex((float)x, (float)y, (float)z, (float)tx, (float)ty, (unsigned long)col);
#endif
}
void	X_OBJNEWGROUP(void)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->UserObjectNewGroup();
#endif
}
void	X_OBJEND(void)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->UserObjectEnd();
#endif
}
void	X_SAVEOBJ(DGStr s, DGNat n)
{
#ifndef GLB_CONSOLE
__g_Did3D=true;
__g_pRbow3D->SaveObject(s.c_str(), (int)n);
#endif
}


DGNat	GENX_OBJ()
{
#ifndef GLB_CONSOLE
for(DGNat i=(DGNat)__g_pRbow3D->m_Objects.Size()-1; i>=0; --i)
{
if(__g_pRbow3D->m_Objects[i].is_loaded == false)
return i;
}
#endif
return -1;
}



void	X_LOADOBJ(const DGStr& s, DGNat n)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->LoadObject("", n);
DGStr file(s);
__g_Did3D=true;

if(!glb_prepare_reading_file(file))
return;
__g_pRbow3D->LoadObject(file.c_str(), (int)n);
#endif
}

void X_OBJFREEEXTRA(DGNat n)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->FreeExtraObject(n);
#endif
}

void	X_DRAWANIM(DGNat num, DGNat from, DGNat to, DGInt per_mille, DGNat full_anim)
{
#ifndef GLB_CONSOLE
__g_pRbow->SetTexture3D(__g_TexState3D.num, __g_TexState3D.num_multi, __g_TexState3D.mipmapstate);
__g_pRbow3D->RenderAnim((int)num, (int)from ,(int)to, (float)per_mille, full_anim?true:false);
#endif
}
void	X_DRAWOBJ(DGNat num, DGNat frame)
{
#ifndef GLB_CONSOLE
__g_pRbow->SetTexture3D(__g_TexState3D.num, __g_TexState3D.num_multi, __g_TexState3D.mipmapstate);
__g_pRbow3D->RenderAnim((int)num, (int)frame, (int)frame, 0.0f, false);
#endif
}
void	X_CAMERAUP(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetCameraUp((float)x,(float)y,(float)z);
#endif
}
void	X_CAMERA(DGInt x, DGInt y, DGInt z, DGInt px, DGInt py, DGInt pz)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetCamera((float)x,(float)y,(float)z,(float)px,(float)py,(float)pz);
#endif
}
void	X_ROTATION(DGInt angle, DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetRotation((float)angle, (float)x, (float)y, (float)z);
#endif
}
void	X_MOVEMENT(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetTranslation((float)x, (float)y, (float)z);
#endif
}
void	X_SCALING(DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetScaling((float)x, (float)y, (float)z);
#endif
}
int	__current_cullmode;
void	X_CULLMODE(DGNat mode)
{
#ifndef GLB_CONSOLE
__current_cullmode = (mode == 0 ? 0 : (mode > 0  ? 1 : -1));
__g_pRbow3D->CullMode( __current_cullmode);
#endif
}
void	X_SPRITE(DGNat num, DGInt x, DGInt y, DGInt z, DGInt scale)
{
#ifndef GLB_CONSOLE
if(num < 0) return;
__g_pRbow3D->CullMode(-1);
__g_pRbow->DrawBillboard((short)num, (float)x, (float)y, (float)z, (float)scale);
__g_pRbow3D->CullMode(__current_cullmode);
#endif
}

void	X_FOG(DGInt col, DGInt exp_mode, DGInt p1, DGInt p2)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->Fog((COLORREF)col, (int)exp_mode, (float)p1, (float)p2);
#endif
}

void X_WORLD2SCREEN(DGInt objx, DGInt objy, DGInt objz, DGInt& sx, DGInt& sy, DGInt& sz)
{
#ifndef GLB_CONSOLE
static float winx, winy, winz;
if (GFglu_Project((float)objx, (float) objy, (float) objz, &winx, &winy, &winz, __g_pRbow->RotatedViewport(), __g_pRbow3D->m_ProjectionMatrix, __g_pRbow3D->m_ModelViewCameraMatrix ))
{
sx=(DGInt)winx; sy=(DGInt)winy; sz=(DGInt)winz;
}
#endif
}

void	X_SCREEN2WORLD(DGInt winx, DGInt winy, DGInt winz, DGInt& sx, DGInt& sy, DGInt& sz)
{
#ifndef GLB_CONSOLE
static float ox,oy,oz;
if(GFglu_UnProject((float)winx, __g_pRbow->m_WND.height-1-(float)winy, (float)winz, &ox, &oy, &oz, __g_pRbow->RotatedViewport(), __g_pRbow3D->m_ProjectionMatrix, __g_pRbow3D->m_ModelViewCameraMatrix ))
{
sx=(DGInt)ox; sy=(DGInt)oy; sz=(DGInt)oz;
}
#endif
}


DGNat	X_COLLISION(DGNat num, DGNat frame, DGInt radius, DGInt x, DGInt y, DGInt z)
{
#ifndef GLB_CONSOLE
if (__DG_DEBUG)
{
DGNat rv = __g_pRbow3D->CollisionSphere((int)num, (int)frame, (float)radius, (float)x, (float)y, (float)z) ? 1: 0;
float sphere[3];
sphere[0]=(float)x; sphere[1]=(float)y; sphere[2]=(float)z;
__g_pRbow3D->DrawSphereGrid(sphere, (float)radius, (unsigned long)(rv ? RGB(255,0,0) : RGB(0,255,0)), rv?5:1);
return rv;
}
else
return __g_pRbow3D->CollisionSphere((int)num, (int)frame, (float)radius, (float)x, (float)y, (float)z) ? 1: 0;
#else
return 0;
#endif
}

DGNat	X_COLLISIONAABB(DGNat num, DGNat frame, DGInt xc, DGInt yc, DGInt zc, DGInt wx, DGInt wy, DGInt wz)
{
#ifndef GLB_CONSOLE
/*
4 point defined AABB
_____
/|   /|
4 |  / |
|---|  |
| 3_|__/
|/  | /
|---|/
1   2
*/
float c1[3], c2[3], c3[3], c4[3];
c1[0]=(float)xc;	c1[1]=(float)yc;	c1[2]=(float)zc;   // position
c2[0]=(float)wx/2.;	c2[1]=0;			c2[2]=0;           // x-axis
c3[0]=0;			c3[1]=0;			c3[2]=(float)wz/2.;// y-axis
c4[0]=0;			c4[1]=(float)wy/2.;	c4[2]=0;           // z-axis
if (__DG_DEBUG)
{
DGNat rv = (DGNat)(__g_pRbow3D->CollisionAABB((int)num, (int)frame, c1, c2, c3, c4) ? 1:0);
__g_pRbow3D->DrawAABB(c1, c2, c3, c4, (unsigned long)(rv ? RGB(255,0,0) : RGB(0,255,0)), rv?5:1);
return rv;
}
else
return (DGNat)(__g_pRbow3D->CollisionAABB((int)num, (int)frame, c1, c2, c3, c4) ? 1:0);
#else
return 0;
#endif
}

DGNat X_COLLISIONSPHEREBOX(DGInt xc, DGInt yc, DGInt zc, DGInt r, DGInt bx, DGInt by, DGInt bz)
{
#ifndef GLB_CONSOLE
return __g_pRbow3D->CollisionSphereBox((float)xc, (float)yc, (float)zc, (float)r, (float)bx/2., (float)by/2., (float)bz/2.) ? 1:0;
#else
return 0;
#endif
}


DGInt 	X_COLLISIONRAY(DGNat num, DGNat frame, DGInt x, DGInt y, DGInt z, DGInt dirx, DGInt diry, DGInt dirz)
{
#ifndef GLB_CONSOLE
if (__DG_DEBUG)
{
float rv = __g_pRbow3D->CollisionRay((int) num, (int) frame, (float) x, (float) y, (float) z, (float) dirx, (float) diry, (float) dirz);
float c1[3], c2[3];
c1[0]=(float)x; c1[1]=(float)y; c1[2]=(float)z;
float len = (rv==0.0 ? 1000 : rv) / (float)((dirx*dirx + diry*diry + dirz*dirz) * (dirx*dirx + diry*diry + dirz*dirz));

c2[0]=(float)(x+dirx*len); c2[1]=(float)(y+diry*len); c2[2]=(float)(z+dirz*len);
__g_pRbow3D->DrawLine(c1, c2, (unsigned long)(rv ? (rv<0 ? RGB(255,255,0) : RGB(0,255,0)) : RGB(255,0,0)), rv ? 5.0f : 1.0f);
return rv;
}
else
return (DGInt)__g_pRbow3D->CollisionRay((int) num, (int) frame, (float) x, (float) y, (float) z, (float) dirx, (float) diry, (float) dirz);
#else
return 0.0;
#endif
}

extern int __nCurFont;
void	X_PRINT(DGStr text, DGInt x, DGInt y, DGInt z, DGInt scale, DGNat kerning)
{
#ifndef GLB_CONSOLE
__g_pRbow->Text3D((int)__nCurFont, text.c_str(), (float)x, (float)y, (float)z, (float)scale, kerning);
#endif
}

void	X_CLEAR_Z()
{
#ifndef GLB_CONSOLE
__g_pRbow3D->ClearZBuffer();
#endif
}

void	X_ENABLE_Z(DGNat enable)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetDepthTesting(enable?true:false);
#endif
}




void X_LINE(DGInt xa, DGInt ya, DGInt za, DGInt xb, DGInt yb, DGInt zb, DGInt width, DGInt col)
{
#ifndef GLB_CONSOLE
static float A[3], B[3];
A[0]=(float)xa; A[1]=(float)ya; A[2]=(float)za;
B[0]=(float)xb; B[1]=(float)yb; B[2]=(float)zb;
if (width<1)   width=1;
if (width>512) width=512;
__g_pRbow3D->DrawLine(A, B, (unsigned long) col, (float) width);
#endif
}

void X_DOT(DGInt xa, DGInt ya, DGInt za, DGInt size, DGNat col)
{
#ifndef GLB_CONSOLE
static float A[3];
A[0]=(float)xa; A[1]=(float)ya; A[2]=(float)za;
if (size<1) size=1;
if (size>512) size=512;
__g_pRbow3D->DrawDot(A, (unsigned long) col, (float) size);
#endif
}

void	X_PUSHMATRIX()
{
#ifndef GLB_CONSOLE
__g_pRbow3D->PushTransformation();
#endif
}
void	X_POPMATRIX()
{
#ifndef GLB_CONSOLE
__g_pRbow3D->PopTransformation();
#endif
}

void	X_SPHEREMAPPING(DGNat onoff)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SphereMapping(onoff ? true : false);
#endif
}


void gf_err_debug(const char* err)
{
#ifdef _DEBUG
printf("%s\n", err);
#else
if(__GLBASIC__::__DG_DEBUG)
{
WIN32_ONLY( DEBUG(DGStr(err)+CGStr("\n")) );
}
#endif
}

void X_SETSHADER(DGNat index)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->SetShader((int) index);
#endif
}

DGNat X_LOADSHADER(DGNat index, DGStr vert, DGStr frag)
{
#ifndef GLB_CONSOLE
return __g_pRbow3D->LoadShader((int) index, vert.c_str(), frag.c_str(), gf_err_debug) ? TRUE : FALSE;
#else
return 0;
#endif
}
void X_PUTSHADER(const DGStr& name, DGInt value)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->PutShaderUniform1f(name.c_str(), (float)value, gf_err_debug);
#endif
}


void X_SETCELSHADES(DGIntArray& vals)
{
#ifndef GLB_CONSOLE
int num = vals.max1;
DGArray<unsigned char> ca;
DIM(ca, num);
for(int i=0; i<num; ++i)
{
ca(i) = (unsigned char)(vals(i) * 255.0);
}
__g_pRbow3D->SetCelShades(&ca(0), num);
#endif
}

void X_MULTMATRIX(DGIntArray& mat)
{
#ifndef GLB_CONSOLE
//  a0  a4  a8 a12
//  a1  a5  a9 a13
//  a2  a6 a10 a14
//  a3  a7 a11 a15
// must be 4x4 matrix
if(mat.max1!=16 || mat.max2!=0) return;
float m[16];
float* pM = &m[0]; const DGInt* pM2 = &mat(0);
*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
*pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++; *pM++ = (float)*pM2++;
__g_pRbow3D->SetMultMatrix(m);
#endif
}

void X_GETMATRIX(DGIntArray& mat)
{
#ifndef GLB_CONSOLE
//  a0  a4  a8 a12
//  a1  a5  a9 a13
//  a2  a6 a10 a14
//  a3  a7 a11 a15
// must be 4x4 matrix
if(mat.max1!=16 || mat.max2!=0)
{
DIM(mat, 16);
}
const float* m = __g_pRbow3D->GetFinalMatrix();

DGInt* pM = &mat(0); const float* pM2 = &m[0];
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
#endif
}


void X_GETCAMERAMATRIX(DGIntArray& mat)
{
#ifndef GLB_CONSOLE
//  a0  a4  a8 a12
//  a1  a5  a9 a13
//  a2  a6 a10 a14
//  a3  a7 a11 a15
// must be 4x4 matrix
if(mat.max1!=16 || mat.max2!=0)
{
DIM(mat, 16);
}
const float* m = __g_pRbow3D->GetCameraMatrix();

DGInt* pM = &mat(0); const float* pM2 = &m[0];
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
*pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++; *pM++ = (DGInt)*pM2++;
#endif
}


DGNat X_NUMFACES(DGNat obj)
{
#ifndef GLB_CONSOLE
int sz=0;
X_WORLD& wld = __g_pRbow3D->m_Objects[(int)obj];
int n = (int)wld.m_objects.Size();
for (int i=0; i<n; ++i)
{
if(wld.m_objects[i].obj.m_Frames.Size())
sz+=(int)wld.m_objects[i].obj.m_Frames[0].triangles.Size(); // vertex count. 3 verts = 1 triangle
}
return (DGNat)(sz/3);
#else
return 0;
#endif
}

DGNat X_GETCOLLISIONFACE()
{
#ifndef GLB_CONSOLE
// -1 if none
return CollisionGetLastCollisionTriangleIndex();
#else
return -1;
#endif
}


void X_GETFACE(DGNat obj, DGNat frame, DGNat nface, DGIntArray& face)
{
#ifndef GLB_CONSOLE
DIM(face, 3, 9);
int sz=0, osz=0;
X_WORLD& wld = __g_pRbow3D->m_Objects[(int)obj];
for (int i=0; i<(int)wld.m_objects.Size(); ++i)
{
MeshObjectX& mesh = wld.m_objects[i].obj;
if(mesh.m_Frames.Size())
{
sz+=mesh.m_Frames[(int)frame].triangles.Size();
if(sz>nface)
{
nface-=osz;
POLY_NODE* pN = &mesh.m_Frames[(int)frame].triangles[(int)nface*3];
face(0,0) = pN->pos[0];    face(0,1) = pN->pos[1];    face(0,2) = pN->pos[2];
face(0,3) = pN->tex[0];    face(0,4) = pN->tex[1];    face(0,5) = pN->dwcol;
face(0,6) = pN->normal[0]; face(0,7) = pN->normal[1]; face(0,8) = pN->normal[2];
++pN;
face(1,0) = pN->pos[0];    face(1,1) = pN->pos[1];    face(1,2) = pN->pos[2];
face(1,3) = pN->tex[0];    face(1,4) = pN->tex[1];    face(1,5) = pN->dwcol;
face(1,6) = pN->normal[0]; face(1,7) = pN->normal[1]; face(1,8) = pN->normal[2];
++pN;
face(2,0) = pN->pos[0];    face(2,1) = pN->pos[1];    face(2,2) = pN->pos[2];
face(2,3) = pN->tex[0];    face(2,4) = pN->tex[1];    face(2,5) = pN->dwcol;
face(2,6) = pN->normal[0]; face(2,7) = pN->normal[1]; face(2,8) = pN->normal[2];
return;
}
osz=sz;
}
}
#endif
}

void X_SCALEMODEL(DGNat id, DGInt sx, DGInt sy, DGInt sz)
{
#ifndef GLB_CONSOLE
__g_pRbow3D->m_Objects[(int)id].Scale(sx, sy, sz);
#endif
}

}; // namespace __GLBASIC__




//------------------------------------------------------------------//
// Load an Object in DDW - Format
// .DDW - World format
// ____________________
// ;DDW
// [objects]
// count=2
// 1=a.ddd
// 1ta=1 ; Texture 1
// 1tb=-1; Texture 2
// 2=b.dd
// [textures]
// count=2
// 1=a.bmp
// 2=b.bmp
//------------------------------------------------------------------//
#ifndef GLB_CONSOLE
bool Load_DDW(const char* filename, X_WORLD& world, COLORREF cookiecol)
{
world.is_loaded=true;
world.is_multiworld=true;

GFini ini;
ini.Read(filename);
int numtex = (int)ini.GetVal(CGStr("textures"), CGStr("count"), DGStr(0)).natural();
world.m_textures.SetSize(numtex);
char fn[1024];
char directory[1024];
strcpy(directory, filename);
char* pEnd = directory + strlen(directory)-1;
while(*pEnd!='\\' && *pEnd!='/' && pEnd>directory) --pEnd;
if(*pEnd=='\\'  || *pEnd=='/') ++pEnd;
*pEnd='\0';
DGStr dir = directory;

for(int i=0; i<numtex; ++i)
{
__g_ShoeBox_Data->FindOrExtract( (dir + ini.GetVal(CGStr("textures"), DGStr(i+1), DGStr(0))).c_str(), fn, true);
OPENGL_IMAGE image;
if(image.LoadImageBMP(fn, cookiecol) || image.LoadImagePNG(fn, cookiecol) || image.LoadImageJPG(fn))
{
if(!image.m_bSourceHadAlpha)
image.FixNeighbourAlpha();

#if defined(TINYGL) || defined(TRENKI3D)
oBitmap bmp;
bmp.CreateBy(image, (COLORREF)-1);
#ifdef TINYGL
world.m_textures[i]=bmp.MakeGLTexture();
#endif
#else
OpenGLRainbows::MakeTexture(image, 0,0,0,0, (GLuint*)&world.m_textures[i], NULL, false, false);
#endif
}
}

int num = (int)ini.GetVal(CGStr("objects"), CGStr("count"), DGStr(0)).natural();
world.m_objects.SetSize(num);
for (int i=0; i<num; ++i)
{
__g_ShoeBox_Data->FindOrExtract( (dir + ini.GetVal(CGStr("objects"), DGStr(i+1), DGStr(0)) ).c_str(), fn, true);
world.m_objects[i].obj.Load(fn);
world.m_objects[i].gl_tex = (int)ini.GetVal(CGStr("objects"), DGStr(i+1)+CGStr("ta"), DGStr(0)).natural();
world.m_objects[i].gl_tex2= (int)ini.GetVal(CGStr("objects"), DGStr(i+1)+CGStr("tb"), DGStr(0)).natural();
if(world.m_objects[i].gl_tex > 0) --world.m_objects[i].gl_tex;
if(world.m_objects[i].gl_tex2> 0) --world.m_objects[i].gl_tex2;

world.m_objects[i].obj.PrepareTriangles(); // For VBO rendering
//	PreRenderObject(ID);		// Display list
world.m_objects[i].obj.CalcMaxRadius();
}
return true;
}
#endif



// --------------------------------------------------------------
// OpenGLRainbows.cpp: Implementierung der Klasse OpenGLRainbows.
// --------------------------------------------------------------

#include "stdafx.h" // #include "stdafx.h"
#ifndef GLB_CONSOLE

#ifdef TINYGL
#include <GL/zgl.h>
#endif


#if defined(GPHWIZ)
#include <sys/mman.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#endif


#include "openglrainbows.h" // #include "openglrainbows.h"
#include "rainbows3d.h" // #include "rainbows3d.h"
#include "gfqueue.h" // #include "gfqueue.h"
#include "3dmath.h" // #include "3dmath.h"
#include "vectormath.h" // #include "vectormath.h"

#define GLB_MIN_TEX_SIZE 16 // 16 required for iPhone - can't get alpha for 1x1 images, else

#if defined(TINYGL) || defined(TRENKI3D)
#include "16bitcolor.h" // #include "16bitcolor.h"
#endif

#ifndef POCKETPC
#define HAS_PNG_LIB
#endif


#if defined(WIN32) && (defined(HAVE_OPENGL) || (defined(HAVE_OPENGL_ES) && defined(_DEBUG)))
#pragma comment(lib, "OpenGL32.lib")
#pragma warning(disable: 4100) // unref. formal param
#endif

#include <stdlib.h> // rand

#if defined(HAVE_OPENGL) || (defined(HAVE_OPENGL_ES) && defined(_DEBUG))
// Don't use the glext.h name! Make lowercase "Arb" e.g.
// otherwise linker errors on OS-X...



// OpenGL extension functions
PFNGLACTIVETEXTUREARBPROC	glActiveTextureArb		=NULL;
PFNGLMULTITEXCOORD2FARBPROC	glMultiTexCoord2fArb	=NULL;
PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureArb				=NULL;

typedef BOOL (APIENTRYP PFWGL_SWAP_CTRL) (int onoff);
PFWGL_SWAP_CTRL gf_wglSwapIntervalEXT=NULL;



// VBO Extension Function Pointers
PFNGLGENBUFFERSARBPROC glGenBuffersArb = NULL;					// VBO Name Generation Procedure
PFNGLBINDBUFFERARBPROC glBindBufferArb = NULL;					// VBO Bind Procedure
PFNGLBUFFERDATAARBPROC glBufferDataArb = NULL;					// VBO Data Loading Procedure
PFNGLDELETEBUFFERSARBPROC glDeleteBuffersArb = NULL;			// VBO Deletion Procedure
PFNGLMAPBUFFERARBPROC	glMapBufferArb = NULL;
PFNGLUNMAPBUFFERARBPROC	glUnmapBufferArb = NULL;
PFNGLGETBUFFERPARAMETERIVARBPROC	glGetBufferParameterivArb = NULL;

// GLSL
PFNGLCREATEPROGRAMOBJECTARBPROC     glCreateProgramObjectArb = NULL;
PFNGLDELETEOBJECTARBPROC            glDeleteObjectArb = NULL;
PFNGLCREATESHADEROBJECTARBPROC      glCreateShaderObjectArb = NULL;
PFNGLSHADERSOURCEARBPROC            glShaderSourceArb = NULL;
PFNGLCOMPILESHADERARBPROC           glCompileShaderArb = NULL;
PFNGLGETOBJECTPARAMETERIVARBPROC    glGetObjectParameterivArb = NULL;
PFNGLATTACHOBJECTARBPROC            glAttachObjectArb = NULL;
PFNGLGETINFOLOGARBPROC              glGetInfoLogArb = NULL;
PFNGLLINKPROGRAMARBPROC             glLinkProgramArb = NULL;
PFNGLUSEPROGRAMOBJECTARBPROC        glUseProgramObjectArb = NULL;
PFNGLGETUNIFORMLOCATIONARBPROC      glGetUniformLocationArb = NULL;
PFNGLUNIFORM1FARBPROC               glUniform1fArb = NULL;
PFNGLUNIFORM1IARBPROC               glUniform1iArb = NULL;
PFNGLGETATTRIBLOCATIONARBPROC       glGetAttribLocationArb = NULL;
PFNGLVERTEXATTRIB1FARBPROC          glVertexAttrib1fArb = NULL;
#endif

#if defined(HAVE_OPENGL_ES) && defined(GPHWIZ)
#if !defined( WANT_SDL) && !defined(TARGET_OS_IPHONE)
extern "C"
{
void OS_InitFakeOS( void) ;
NativeWindowType OS_CreateWindow();
}
#endif
#endif




// SEARCH_GLB_ENABLE
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
GLB_ENABLE_STATE __g_EnableState;
#endif


extern DGInt AccurateTime(); // in glb-full.cpp



// fails on Raspberry GF_TODO #NEED
#ifndef TRENKI3D
void my_glOrtho(float left, float right, float bottom, float top, float nearZ, float farZ)
{
//glOrtho(left, right, bottom, top, nearZ, farZ);
//return;
float m[16];
#define M(row,col)  m[col*4+row]
M(0,0) = 2.0F / (right-left);
M(0,1) = 0.0F;
M(0,2) = 0.0F;
M(0,3) = -(right+left) / (right-left);

M(1,0) = 0.0F;
M(1,1) = 2.0F / (top-bottom);
M(1,2) = 0.0F;
M(1,3) = -(top+bottom) / (top-bottom);

M(2,0) = 0.0F;
M(2,1) = 0.0F;
M(2,2) = -2.0F / (farZ-nearZ);
M(2,3) = -(farZ+nearZ) / (farZ-nearZ);

M(3,0) = 0.0F;
M(3,1) = 0.0F;
M(3,2) = 0.0F;
M(3,3) = 1.0F;
#undef M
//glLoadMatrixf(m); NO! result is M*Original!
glMultMatrixf(m);
}
#endif

#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
//	#define glOrtho glOrthof // openGL|ES
#define glOrtho my_glOrtho // openGL|ES
#endif




//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------//
//---------------------------------------------------------------//
OpenGLRainbows::OpenGLRainbows()
{
m_physical_device_screen_is_landscape = 0;
m_landscape=0;
m_CookieColor = 0x008000ff; // RGB(255,0,128);
m_CookieFont  = 0x00000000;

m_Texture = new GLR_TEXTURE[GLR_MAX_TEXTURES+1]; // +1 for FBO emergency mode

#if ! (defined( WANT_SDL ) || defined(TINYGL) || defined(TRENKI3D) ) && defined(WIN32)
m_hRC=NULL;
#endif

#if !defined(TINYGL) && !defined(TRENKI3D)
// m_IsActive=false;
// No Crash when releasing a texture
// memset(m_Texture, 0, sizeof(GLR_TEXTURE) * GLR_MAX_TEXTURES);
#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
#else
memset(SpritePix, 0, sizeof(BYTE*) * (GLR_MAX_TEXTURES+1));
#endif

// BYTE*			SpritePix[GLR_MAX_TEXTURES+1]; // Pixels for Sprcoll
// memset(this->m_Surface, 0, sizeof(OPENGL_RAINBOWS_SURFACE)*GLR_MAX_SURFACE);
m_SmoothShading = true;

#ifdef GLB_SURFACE_OLDSCHOOL
#else // jus use a sprite
for(int i=0; i<GLR_MAX_SURFACE; ++i) m_BackSurfaceSpriteID[i] = -1;
#endif

#endif

memset(&m_WND, 0, sizeof(m_WND) );

#ifdef WIN32
m_WND.hwnd=NULL;
#endif




// this->FreeAll();
m_falpha = 0.0f;
m_CurrentFBO=-1;
m_bHasClearColor = true; // black is default
m_bDirtyZBuffer = true;
m_bSupportBGRA_ext = false;
m_pRbow3D=NULL;


// delete the tmp file from last crash?!
GFFileSystem::Delete(	TmpFileForTextureStore() );

}

//---------------------------------------------------------------//
//---------------------------------------------------------------//
OpenGLRainbows::~OpenGLRainbows()
{
// delete the tmp file for the next run!
GFFileSystem::Delete(	TmpFileForTextureStore() );

// (SDL is already closed!)

FBO_end(); for(int i=0; i<GLR_MAX_FRAMEBUFFER; ++i){m_FBuffer[i].Clear();}

Close();

#if !(defined( WANT_SDL ) || defined(TINYGL) || defined(TRENKI3D) ) && defined(WIN32) && defined(HAVE_OPENGL)
if(m_hRC)
wglDeleteContext(m_hRC);
#endif

if(m_Texture)
delete[]m_Texture;
m_Texture=NULL;
}

#if (defined(PANDORA) || defined(RASPBERRY_PI) )   && defined(HAVE_OPENGL_ES)
extern "C" 
{
void NativeEGLInitParams(int set_width, int set_height);
void NativeEGLInfo(int* pwidth, int* pheight);

int  NativeEGLInitOpenGL();
void NativeEGLTerminateOpenGL();
int  NativeEGLSwapBuffers();
void glb_pi_test();

}
#endif



//---------------------------------------------------------------//
//---------------------------------------------------------------//
void OpenGLRainbows::Close()
{
FreeAll();

#if (defined(PANDORA) || defined(RASPBERRY_PI) ) && defined(HAVE_OPENGL_ES)
NativeEGLTerminateOpenGL();
#elif defined(TARGET_OS_IPHONE)
// move along

#elif defined( WANT_SDL)
#if SDL_VERSION_ATLEAST(2,0,0) 
#if defined(HAVE_OPENGL_ES)
SDL_GL_DeleteContext(m_WND.sdl_glcontext);
#endif
SDL_DestroyWindow(m_WND.sdl_window);
#endif
#else

#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
if(m_WND.glesDisplay)
{
eglMakeCurrent(m_WND.glesDisplay, 0, 0, 0);  
if(m_WND.glesContext) eglDestroyContext(m_WND.glesDisplay, m_WND.glesContext);
if(m_WND.glesSurface) eglDestroySurface(m_WND.glesDisplay, m_WND.glesSurface);
eglTerminate(m_WND.glesDisplay);
m_WND.glesContext=NULL;
m_WND.glesSurface=NULL;
m_WND.glesDisplay=NULL;
}  
#endif

#ifdef WIN32
this->DoWindowed();
#if defined(HAVE_OPENGL)
wglMakeCurrent(::GetDC(m_WND.hwnd), NULL);
#endif
::InvalidateRect(0, NULL, TRUE);
::DestroyWindow(m_WND.hwnd);
m_WND.hwnd=NULL;
m_WND.width=0;
m_WND.height=0;
m_WND.hwnd = NULL;
#endif
#endif

}


#ifdef WANT_SDL
extern "C" void glb_do_pause(int pause);

//---------------------------------------------------------------//
//---------------------------------------------------------------//
int HandleEvent(SDL_Event *event)
{
int done;

done = 0;
switch( event->type ) {
#ifndef ANDROID
case SDL_ACTIVEEVENT: // deprecated in 2.0 use SDL_WINDOWEVENT
// printf("SDL_ACTIVEVENT\n");
glb_do_pause(event->active.gain ? 0 : 1);

// See what happened
/*
printf( "app %s ", event->active.gain ? "gained" : "lost" );
if ( event->active.state & SDL_APPACTIVE ) {
printf( "active " );
} else if ( event->active.state & SDL_APPMOUSEFOCUS ) {
printf( "mouse " );
} else if ( event->active.state & SDL_APPINPUTFOCUS ) {
printf( "input " );
}
printf( "focus\n" );
break;
*/
break;
#endif

/*
case SDL_KEYDOWN: // - showscreen does that! Takes care of allowesc
if ( event->key.keysym.sym == SDLK_ESCAPE)
{
done = 1;
}
break;
*/
case SDL_QUIT:
done = 1;
break;
}
return(done);
}
#endif


#if defined (TARGET_OS_IPHONE)
extern "C"
{
void iPhonePumpEvents(unsigned long ms);
void iPhoneSwapBuffers();
char iPhoneGetInkeyStr();
}
#endif


//---------------------------------------------------------------//
// return: 0: Exit app, 1:run
//---------------------------------------------------------------//
#ifdef TARGET_OS_IPHONE
extern "C" int gKillProgramNow;
#endif

#if !defined(POCKETPC)
namespace __GLBASIC__ {
extern void DXinp_push_inkey(char ic);
}
#endif

unsigned int OpenGLRainbows::WinMessages( void(*peekmsg)() , bool allow_to_sleep)
{
#ifdef WANT_SDL
// Check if there's a pending event.
SDL_Event event;
int icount=0;
while(SDL_PollEvent( &event ) && ++icount<256)
{
switch(event.type)
{
case SDL_KEYDOWN:
switch(event.key.keysym.sym)
{
case SDLK_BACKSPACE: //SDLK_DELETE should be SDLK_BACKSPACE. But on the Mac it's twisted :/
DXinp_push_inkey('\b'); break;
break;

// non-inkey$ keys:
case SDLK_UP:
case SDLK_DOWN:
case SDLK_RIGHT:
case SDLK_LEFT:
case SDLK_INSERT:
case SDLK_HOME:
case SDLK_END:
case SDLK_PAGEUP:
case SDLK_PAGEDOWN:
case 14:  // backspace 2nd key?
case 211: // del
break;
default:
if((event.key.keysym.unicode & 0xff00) == 0)
DXinp_push_inkey(event.key.keysym.unicode & 0x00ff);
}
break;
case SDL_QUIT:
g_debug("SDL_QUIT event\n");
return 0; // Exit App
}

/*
if(HandleEvent(&event))
{
return 0; // Exit App
}
*/
}

if(allow_to_sleep)
{
if(SDL_WaitEvent(&event))
{
SDL_PushEvent(&event);
return WinMessages(peekmsg, false); // handle the event
}
}


#elif defined (TARGET_OS_IPHONE)
if(gKillProgramNow)
return 0;
char ke = iPhoneGetInkeyStr();
if (ke)
DXinp_push_inkey(ke);
iPhonePumpEvents(0);
#elif defined(WIN32) && !defined(POCKETPC) // WinCE has it's own message loop for WM_CHAR!

if(allow_to_sleep)
::WaitMessage();

// Peek & Translate Win Message
MSG		m;
if(peekmsg != NULL)
{
while(::PeekMessage(&m, m_WND.hwnd, 0, 0, PM_NOREMOVE))
{
peekmsg();
::PeekMessage(&m, m_WND.hwnd, 0, 0, PM_REMOVE);
if(m.message == WM_CHAR) DXinp_push_inkey(m.wParam & 0xff);
if(m.message == WM_KEYDOWN) TranslateMessage(&m); // sends WM_CHAR
DispatchMessage(&m);
}
}
else
{
while(::PeekMessage(&m, m_WND.hwnd, 0, 0, PM_REMOVE))
{
// printf("Msg: %d %x\n", m.message, m.message);
if(m.message == WM_CHAR) DXinp_push_inkey(m.wParam&0xff);
if(m.message == WM_KEYDOWN) TranslateMessage(&m); // sends WM_CHAR
DispatchMessage(&m);
}
}
#endif
return 1;
}


#if defined(POSIX)
void Sleep(unsigned long msec); // glb_pc.cpp
#endif



//---------------------------------------------------------------//
// get temp filename
//---------------------------------------------------------------//
const char* OpenGLRainbows::TmpFileForTextureStore()
{
static long app_id = (long)(void*)this + rand();
#ifdef ANDROID
// /tmp is app-specific.
app_id = 0;
#endif
static char tmp[1024];
char tmp2[1024]="/tmp";
GFFileSystem::GetTempFolder(1024, tmp2);
sprintf(tmp, "%sglbtxs%x.bin", tmp2, (int)app_id);
return tmp;
}


//---------------------------------------------------------------//
// save texture when app looses focus. Free memory, too
//---------------------------------------------------------------//
bool OpenGLRainbows::LoadSaveTextureToTmp(bool bLoad)
{
GFFileSystem fs;

if(bLoad)
{
g_debug("restoring textures from temp file\n");
if(!fs.OpenIn(TmpFileForTextureStore())) return false;
}
else
{
g_debug("move textures from mem to temp file\n   \"%s\"\n", TmpFileForTextureStore());
if(!fs.OpenOut(TmpFileForTextureStore())) return false;
}

OPENGL_IMAGE img;
for(int i=0; i<GLR_MAX_TEXTURES; ++i)
{
if(bLoad)
{
if(fs.Eof()) break;
int j=0, dx=0, dy=0;
fs.Read(&j, sizeof(int));
fs.Read(&dx, sizeof(int));
fs.Read(&dy, sizeof(int));
img.resize(dx, dy);
fs.Read(img.m_txdata, dx*dy*4);
this->LoadSprite(j, img, this->m_CookieColor, false);
}
else
{
if(this->GetSpriteSize(i).cx > 0)
{
fs.Write(&i, sizeof(int));
this->GetSpriteRGBA(i, img);
int dx = img.m_sizex, dy=img.m_sizey;
fs.Write(&dx, sizeof(int));
fs.Write(&dy, sizeof(int));
fs.Write(img.m_txdata, img.m_sizex*img.m_sizey*4);
// this->FreeSprite(i); // no. I'm bad!
}
}
}
fs.Close();

if(bLoad)
{
fs.Delete(TmpFileForTextureStore());
}
g_debug("   ...done\n");
return true;
}


//---------------------------------------------------------------//
// Prepare the back and Z buffers for the next frame
//---------------------------------------------------------------//
void OpenGLRainbows::PrepareBackbuffer()
{
#if defined(TINYGL) || defined(TRENKI3D)
if(m_Surface[0].m_Height)
{
m_Surface[0].MemCpyToScreen();
}
else
{
if(m_bHasClearColor)
{
Screen.Clear();
}
}
#ifdef TRENKI3D
if(m_bDirtyZBuffer)
{
m_bDirtyZBuffer=false;
Screen.ClearZBuffer();
}
#endif

#else // GL or EGL
#ifdef PALM_WEBOS
// glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_FALSE);
#endif


#ifdef GLB_SURFACE_OLDSCHOOL
// background image or clear color?
if(m_Surface[0].usex>0)
{
if(m_bDirtyZBuffer)
{
m_bDirtyZBuffer=false; glClear(GL_DEPTH_BUFFER_BIT);
}
PasteSurface(0);
}
else if(m_bHasClearColor || m_bDirtyZBuffer)
{
GLbitfield bits=0;
if(m_bHasClearColor)  bits |= GL_COLOR_BUFFER_BIT;
if(m_bDirtyZBuffer)  {bits |= GL_DEPTH_BUFFER_BIT; 	m_bDirtyZBuffer=false;}
glClear(bits);
}
#else // just use a sprite
if(m_BackSurfaceSpriteID[0] != -1)
{
PasteSurface(0);
}
else if(m_bHasClearColor || m_bDirtyZBuffer)
{
GLbitfield bits=0;
if(m_bHasClearColor)  bits |= GL_COLOR_BUFFER_BIT;
if(m_bDirtyZBuffer)  {bits |= GL_DEPTH_BUFFER_BIT; 	m_bDirtyZBuffer=false;}
glClear(bits);
}
#endif


#endif
}


//---------------------------------------------------------------//
//---------------------------------------------------------------//
int OpenGLRainbows::FlipScreens(void (*peekmsg)(void) )
{
// Make sure FBO access is finished
FBO_end();

#if defined(TINYGL) || defined(TRENKI3D)
Screen.Show();
#else // GL or EGL
//	MakeAutoStereo();
#ifdef WANT_SDL
#if (defined(PANDORA) || defined(RASPBERRY_PI) ) && defined(HAVE_OPENGL_ES)
NativeEGLSwapBuffers();

#elif SDL_VERSION_ATLEAST(2,0,0)
// SDL20
// http://wiki.libsdl.org/moin.cgi/SDL_GL_CreateContext?highlight=%28%5CbCategoryVideo%5Cb%29%7C%28CategoryEnum%29%7C%28CategoryStruct%29%7C%28SGFunctions%29
//#elif defined(ANDROID) SDL2.0  // #elif defined( HAVE_OPENGL_ES)
SDL_GL_SwapWindow(m_WND.sdl_window);
#else
// Linux/Mac
#if defined( HAVE_OPENGL) ||  defined( HAVE_OPENGL_ES)
SDL_GL_SwapBuffers( );
#endif
#endif
#else
#if defined(TARGET_OS_IPHONE)
iPhoneSwapBuffers();
#elif defined(HAVE_OPENGL_ES) && !defined(_DEBUG)
eglSwapBuffers(m_WND.glesDisplay, m_WND.glesSurface);
#else
static HDC hDC = ::GetDC(m_WND.hwnd);
SwapBuffers(hDC);
// ::ReleaseDC(m_WND.hwnd, hDC);
#endif
#endif

#endif

PrepareBackbuffer();


DGInt	cur_time;
DGInt slp=0;
// is it time to render the frame?
do
{
if (!this->WinMessages(peekmsg, false))
{
return 0; // Exit was pressed
}
cur_time=AccurateTime();

slp = m_next_time - cur_time;
if(slp>7)
{
#if defined(TARGET_OS_IPHONE)
iPhonePumpEvents((int)slp-3); // give more response to the GUI if we can
#else
slp -= 3;
::Sleep( (DWORD)slp );
#endif				
cur_time+=slp;
}
}while(slp > 1);


// If we get more than a frame ahead, allow us to drop one
// Otherwise, we will never catch up if we let the error
// accumulate, and message handling will suffer
if(m_FrameRate>0)
{
#if 1
// set time for next frame
m_next_time += m_FrameRate;
if(m_next_time < cur_time)
{
m_next_time += m_FrameRate;
// too big skip required
if(m_next_time < cur_time)
m_next_time = cur_time + m_FrameRate;
}
#else
// set time for next frame
m_next_time += m_FrameRate;
// If we get more than a frame ahead, allow us to drop one
// Otherwise, we will never catch up if we let the error
// accumulate, and message handling will suffer
if(m_FrameRate>0)
{
while(m_next_time < cur_time)
m_next_time += m_FrameRate;
}
#endif
}
return 1;
}

#if defined(HAVE_OPENGL) && defined(WIN32)
// wglext.h
#define WGL_STENCIL_BITS_ARB           0x2023
#define WGL_DEPTH_BITS_ARB             0x2022
#define WGL_SUPPORT_OPENGL_ARB         0x2010
#define WGL_ACCELERATION_ARB           0x2003
#define WGL_FULL_ACCELERATION_ARB      0x2027
#define WGL_COLOR_BITS_ARB             0x2014
#define WGL_ALPHA_BITS_ARB             0x201B
#define WGL_DEPTH_BITS_ARB             0x2022
#define WGL_STENCIL_BITS_ARB           0x2023
#define WGL_DRAW_TO_WINDOW_ARB         0x2001
#define WGL_DOUBLE_BUFFER_ARB          0x2011
#define WGL_STEREO_ARB                 0x2012
#ifndef WGL_ARB_multisample
#define WGL_SAMPLE_BUFFERS_ARB         0x2041
#define WGL_SAMPLES_ARB                0x2042
#endif




bool WGLisExtensionSupported(const char *extension)
{
const size_t extlen = strlen(extension);
const char *supported = NULL;

// Try To Use wglGetExtensionStringARB On Current DC, If Possible
PROC wglGetExtString = (PROC) glGFGetProcAddressArb("wglGetExtensionsStringARB");

if (wglGetExtString)
supported = ((char*(__stdcall*)(HDC))wglGetExtString)(wglGetCurrentDC());

// If That Failed, Try Standard Opengl Extensions String
if (supported == NULL)
supported = (char*)glGetString(GL_EXTENSIONS);

// If That Failed Too, Must Be No Extensions Supported
if (supported == NULL)
return false;

// Begin Examination At Start Of String, Increment By 1 On False Match
for (const char* p = supported; ; p++)
{
// Advance p Up To The Next Possible Match
p = strstr(p, extension);
if (p == NULL)
return false;						// No Match
if ((p==supported || p[-1]==' ') && (p[extlen]=='\0' || p[extlen]==' '))
return true;						// Match
}
}

// find a pixelformat
int ChooseMultisamplePixelFormat(HDC hDC,PIXELFORMATDESCRIPTOR pfd, int multisamples)
{  
// See If The String Exists In WGL!
if (!WGLisExtensionSupported("WGL_ARB_multisample"))
{
return 0;
}

#ifndef PFNWGLCHOOSEPIXELFORMATARBPROC
typedef BOOL (WINAPI * PFNWGLCHOOSEPIXELFORMATARBPROC) (HDC hdc, const int *piAttribIList, const FLOAT *pfAttribFList, UINT nMaxFormats, int* piFormats, UINT* nNumFormats);
#endif
// Get Our Pixel Format
PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatArb =
(PFNWGLCHOOSEPIXELFORMATARBPROC)glGFGetProcAddressArb("wglChoosePixelFormatARB");

if (!wglChoosePixelFormatArb)
{
// We Didn't Find Support For Multisampling, Set Our Flag And Exit Out.
return 0;
}

int pixelFormat;
BOOL valid;
UINT numFormats;
float fAttributes[] = {0,0};

// These Attributes Are The Bits We Want To Test For In Our Sample
// Everything Is Pretty Standard, The Only One We Want To 
// Really Focus On Is The SAMPLE BUFFERS ARB And WGL SAMPLES
// These Two Are Going To Do The Main Testing For Whether Or Not
// We Support Multisampling On This Hardware
int iAttributes[] = { WGL_DRAW_TO_WINDOW_ARB,GL_TRUE,
WGL_SUPPORT_OPENGL_ARB,GL_TRUE,
WGL_ACCELERATION_ARB,WGL_FULL_ACCELERATION_ARB,
WGL_COLOR_BITS_ARB,24,
WGL_ALPHA_BITS_ARB,8,
WGL_DEPTH_BITS_ARB,24,
WGL_STENCIL_BITS_ARB,8,
WGL_DOUBLE_BUFFER_ARB,GL_TRUE,
WGL_SAMPLE_BUFFERS_ARB,GL_TRUE,
WGL_SAMPLES_ARB, multisamples,						// Check For 4x Multisampling
0,0};

// First We Check To See If We Can Get A Pixel Format For 4 Samples
valid = wglChoosePixelFormatArb(hDC,iAttributes,fAttributes,1,&pixelFormat,&numFormats);

// if We Returned True, And Our Format Count Is Greater Than 1
if (valid && numFormats >= 1)
return pixelFormat;

// Our Pixel Format With 4 Samples Failed, Test For 2 Samples
while(iAttributes[19]/2)
{
iAttributes[19]>>=1;
valid = wglChoosePixelFormatArb(hDC,iAttributes,fAttributes,1,&pixelFormat,&numFormats);
if (valid && numFormats >= 1)
return pixelFormat;
}
return  0;
}
#endif


//---------------------------------------------------------------//
//---------------------------------------------------------------//
#if !defined( WANT_SDL) && defined(WIN32)
namespace __GLBASIC__
{
LRESULT CALLBACK __WndProc_(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
};
#endif


#ifdef WANT_SDL
#if SDL_VERSION_ATLEAST(2,0,0) 
static int GetVideoDisplay()
{
const char *variable = SDL_getenv("SDL_VIDEO_FULLSCREEN_DISPLAY");
if ( !variable ) {
variable = SDL_getenv("SDL_VIDEO_FULLSCREEN_HEAD");
}
if ( variable ) {
return SDL_atoi(variable);
} else {
return 0;
}
}
#endif
#endif






bool OpenGLRainbows::Init(HINSTANCE hInst, int width, int height, int bpp, unsigned int fps, int multisamples, bool fullscreen)
{
static int	been_here=0;
m_clear_color = RGB(0,0,0);

SetMaxFPS(fps, false);

#if !defined( WANT_SDL) && defined(WIN32) && !defined(POCKETPC)

if(!been_here)
{
#define STR_GLBASIC	"GLBasic"
WNDCLASS        wc;
wc.style                = /*CS_HREDRAW | CS_VREDRAW |*/ CS_BYTEALIGNWINDOW|CS_BYTEALIGNCLIENT|CS_OWNDC;
wc.lpfnWndProc          = (WNDPROC) __GLBASIC__::__WndProc_;
wc.cbClsExtra           = 0;
wc.cbWndExtra           = 0;
wc.hInstance            = hInst;
wc.hIcon                = ::LoadIcon(hInst, MAKEINTRESOURCE(101));
wc.hCursor              = NULL;
wc.hbrBackground        = NULL;
wc.lpszMenuName         = NULL;
wc.lpszClassName        = STR_GLBASIC; // Must be same as below!!!

if(RegisterClass(&wc) == 0)
return 0;	//  | WS_CLIPCHILDREN | WS_CLIPSIBLINGS
been_here = 1;
}
m_hinstance = hInst;
#endif

// store for later use
m_WND.multisample = multisamples;


#ifndef POCKETPC
#if defined(HAVE_OPENGL_ES) && defined(GPHWIZ) // OpenGL|ES w/o SDL - Wiz, maybe
g_debug("OGL video GPHWIZ\n");
__DG_DESKTOPX=320; __DG_DESKTOPY=240;
m_physical_device_screen_is_landscape = 1;
// Initialize native OS
OS_InitFakeOS();
// Create native window.
m_WND.hNativeWnd = OS_CreateWindow();	                  
if(!m_WND.hNativeWnd)
{
g_debug("OS_CreateWindow failed\n");
}

EGLConfig configs[10];
EGLint matchingConfigs;	

/*configAttribs is a integers list that holds the desired format of 
our framebuffer. We will ask for a framebuffer with 24 bits of 
color and 16 bits of z-buffer. We also ask for a window buffer, not 
a pbuffer or pixmap buffer*/	
const EGLint configAttribs[] =
{
EGL_SURFACE_TYPE,   EGL_WINDOW_BIT,
EGL_NONE,           EGL_NONE
};

m_WND.glesDisplay = eglGetDisplay(EGL_DEFAULT_DISPLAY);	 //Ask for an available display

//Display initialization (we don't care about the OGLES version numbers)
if(!eglInitialize(m_WND.glesDisplay, 0, 0)) 
return false;

/*Ask for the framebuffer confiburation that best fits our 
parameters. At most, we want 10 configurations*/
if(!eglChooseConfig(m_WND.glesDisplay, configAttribs, &configs[0], 10,  &matchingConfigs)) 
return false;

//If there isn't any configuration enough good
if (matchingConfigs < 1)  return false;	  

/*eglCreateWindowSurface creates an onscreen EGLSurface and returns 
a handle  to it. Any EGL rendering context created with a 
compatible EGLConfig can be used to render into this surface.*/
m_WND.glesSurface = eglCreateWindowSurface(m_WND.glesDisplay, configs[0], m_WND.hNativeWnd, configAttribs);	
if(!m_WND.glesSurface) return false;

// Let's create our rendering context
m_WND.glesContext=eglCreateContext(m_WND.glesDisplay,configs[0],0,configAttribs);

if(!m_WND.glesContext) return false;

//Now we will activate the context for rendering	
eglMakeCurrent(m_WND.glesDisplay, m_WND.glesSurface, m_WND.glesSurface, m_WND.glesContext); 

glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
eglSwapBuffers(m_WND.glesDisplay, m_WND.glesSurface);

// Padora-EGL by X11
#elif defined(PANDORA) && defined(HAVE_OPENGL_ES)
g_debug("sdl init video PANDORA\n");
// if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) {  - global call now
//	g_debug("Couldn't initialize SDL: %s\n", SDL_GetError());
//	exit( 1 );
// }
NativeEGLInitOpenGL();

const SDL_VideoInfo* info = SDL_GetVideoInfo(); 
__DG_DESKTOPX = info->current_w; 
__DG_DESKTOPY = info->current_h;
g_debug ("SDL_GetVideoInfo = %dx%d @ %d bpp\n", __DG_DESKTOPX, __DG_DESKTOPY, info->vfmt->BitsPerPixel);
m_physical_device_screen_is_landscape = __DG_DESKTOPX > __DG_DESKTOPY ? 1:0;
/*
// also works on OMAP-3 - don't hardcode it
__DG_DESKTOPX=800; __DG_DESKTOPY=480;
width=800;
height=480;
*/

SetScreen(width, height, 16, TRUE);

//		height = m_WND.height;
//		width = m_WND.width;
m_WND.height=height;
m_WND.width=width;
g_debug("%dx%d sdl\n",width,height);

#elif defined(RASPBERRY_PI) && defined(HAVE_OPENGL_ES)
g_debug("sdl init video RaspberryPi\n");


SDL_Surface* myVideoSurface = SDL_SetVideoMode(0,0, 32,  SDL_SWSURFACE);
NativeEGLInitParams(width, height);
NativeEGLInitOpenGL();
int ix=0, iy=0;
NativeEGLInfo(&ix, &iy);
__DG_DESKTOPX = ix; 
__DG_DESKTOPY = iy;
g_debug ("NativeEGLInfo = %dx%d\n", __DG_DESKTOPX, __DG_DESKTOPY);
m_physical_device_screen_is_landscape = __DG_DESKTOPX > __DG_DESKTOPY ? 1:0;


/*
if ( SDL_SetVideoMode( ix, iy, 0, SDL_SWSURFACE|SDL_NOFRAME ) == NULL )
{
g_debug("SDL - SetVideoMode failed: %s\n", SDL_GetError());
}
*/


OPENGL_CHECK_ERRORS();
SetScreen(width, height, 32, TRUE);
OPENGL_CHECK_ERRORS();

//		height = m_WND.height;
//		width = m_WND.width;
m_WND.height=height;
m_WND.width=width;
g_debug("%dx%d sdl\n",width,height);


// -------- SDL --------
#elif defined(WANT_SDL)
g_debug("SDL_init video\n");
Uint32 video_flags=0;
int rgb_size[3];
int done = 0;
// if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) {  - global call now
//	g_debug("Couldn't initialize SDL_VIDEO: %s\n", SDL_GetError());
//	exit( 1 );
//}

int desktop_bits = 0;
#if SDL_VERSION_ATLEAST(2,0,0) 
SDL_DisplayMode mode;
SDL_GetDesktopDisplayMode(GetVideoDisplay(), &mode);
__DG_DESKTOPX = mode.w;
__DG_DESKTOPY = mode.h;
SDL_PixelFormat* sdl_vfmt = SDL_AllocFormat(mode.format);
if(sdl_vfmt)
{
desktop_bits = sdl_vfmt->BitsPerPixel;
SDL_FreeFormat(sdl_vfmt);
}
#else
const SDL_VideoInfo* info = SDL_GetVideoInfo(); 
__DG_DESKTOPX = info->current_w; 
__DG_DESKTOPY = info->current_h;
desktop_bits = info->vfmt->BitsPerPixel;
#endif

#if defined(ANDROID)
// these are totally silly if the main window is not moved or scaled. At least give full drawing area access
width  = __DG_RESX = __DG_DESKTOPX;
height = __DG_RESY = __DG_DESKTOPY;
#endif
m_physical_device_screen_is_landscape = __DG_DESKTOPX > __DG_DESKTOPY ? 1:0;
g_debug ("SDL_GetVideoInfo = %dx%d @ %d bpp. Screen %dx%d\n", __DG_DESKTOPX, __DG_DESKTOPY, desktop_bits, __DG_RESX, __DG_RESY);


// *** SDL 2.0 ***
// -------------
#if SDL_VERSION_ATLEAST(2,0,0) 
g_debug("SDL 2.x mode\n");
// Sets up OpenGL ES double buffering and visual parameters
SDL_GL_SetAttribute(SDL_GL_CONTEXT_MAJOR_VERSION, 1); // OpenGL|ES 1.1
SDL_GL_SetAttribute(SDL_GL_CONTEXT_MINOR_VERSION, 1); // OpenGL|ES 1.1
SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5); // minimum
SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 6);
SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);
SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);

g_debug("C++ calling SDL_CreateWindow (fs:%d)\n", fullscreen);

m_WND.sdl_window=SDL_CreateWindow("GLBasic", 0, 0,
width, height,
fullscreen
? (                       SDL_WINDOW_OPENGL | SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS)
: (SDL_WINDOW_RESIZABLE | SDL_WINDOW_OPENGL | SDL_WINDOW_SHOWN)
);
if(m_WND.sdl_window == NULL)
{
g_debug("Can't create window: %s\n", SDL_GetError());
exit(-1);
}


/*
m_WND.sdl_renderer = SDL_CreateRenderer(m_WND.sdl_window, -1, SDL_RENDERER_ACCELERATED|SDL_RENDERER_TARGETTEXTURE);
if (m_WND.sdl_renderer==NULL)
{
g_debug("Can't create renderer: %s\n", SDL_GetError());
return false;
}
*/

// SDL_CreateRenderer(m_WND.window, 0, 0);
// alternaitive
m_WND.sdl_glcontext=SDL_GL_CreateContext(m_WND.sdl_window);
if (m_WND.sdl_glcontext==NULL)
{
g_debug("Can't create OpenGL ES context: %s\n", SDL_GetError());
return false;
}

int status=SDL_GL_MakeCurrent(m_WND.sdl_window, m_WND.sdl_glcontext);
if (status<0)
{
g_debug("Can't set current OpenGL ES context: %s\n", SDL_GetError());
return false;
}

// Enable swap on VSYNC
SDL_GL_SetSwapInterval(1);

/*
SDL_SetRenderDrawColor(m_WND.sdl_renderer, 0,0,0,255);
SDL_RenderClear(m_WND.sdl_renderer);
SDL_RenderPresent(m_WND.sdl_renderer);
*/

g_debug("C++ SDL_CreateWindow stuff finished\n");

// *** SDL 1.2 ***
// -------------
#else // SDL 1.2
g_debug("SDL 1.2 mode\n");

// See if we should detect the display depth
if ( bpp == 0 )
{
//		if ( SDL_GetVideoInfo()->vfmt->BitsPerPixel <= 8 )
//			bpp = 8;
//		else
bpp = 24;  // More doesn't seem to work
bpp = max(bpp, desktop_bits); // desktop might be 32!
}
#if defined(GPHWIZ) || defined(GP2X) || defined(PANDORA)
bpp = 16;
#endif

/* Set the flags we want to use for setting the video mode */
#if defined( MACOSX ) || defined(TARGET_OS_IPHONE) || defined(PANDORA) || defined(GP2X) || defined(GPHWIZ)
if(fullscreen)
{
g_debug("Request fullscreen = %d\n", SDL_FULLSCREEN);
video_flags|=SDL_FULLSCREEN; // Mac problem
}
#endif

#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
g_debug("Request SDL_OPENGL = %d\n", SDL_OPENGL);
video_flags |= SDL_OPENGL;

g_debug("Request double buffer\n");
SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );;
#endif



#if defined( HAVE_OPENGL)
g_debug("set up SDL for OpenGL mode\n");
#if defined(EMSCRIPTEN)
g_debug(" -WebGL mode: 32 bits, SDL_OPENGL=!0x04000000!\n");
bpp = 32;
video_flags = /* SDL_compat.h #define SDL_OPENGL        */  0x04000000 | SDL_OPENGL;
#endif
#elif defined(HAVE_OPENGL_ES)
g_debug("set up SDL for OpenGL-ES mode\n");
SDL_GL_SetAttribute(SDL_GL_CONTEXT_MAJOR_VERSION, 1); // OpenGL|ES 1.1

//** Set depth buffer size to 16 bits 
SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 ); // minimum - can be 24 or 32
//** Set stencil buffer size to 16 bits 
// SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 16 );

#ifdef PALM_WEBOS
int want_landscape = width > height ? 1:0;

g_debug("   want landscape %d,%d: %d\n   device landscape: %d\n", width, height, want_landscape, m_physical_device_screen_is_landscape);

// 320x480  pre
// 320x400  pixi
// 1024x768 touchpad
m_landscape = 0;
if(m_physical_device_screen_is_landscape != want_landscape)
{
m_landscape=1; // rotate by 90 - palm pre, so "top" is right edge
}

width=0;
height=0;

bpp=0; // that's what's returned when you put sdl_setvidmode(0,0,0)
video_flags = SDL_OPENGL; // nothing more
#endif
#ifdef ANDROID
width= __DG_DESKTOPX;
height=__DG_DESKTOPY;
bpp = info->vfmt->BitsPerPixel; // SDL_RESIZABLE
video_flags = SDL_OPENGL|SDL_FULLSCREEN; // SDL_SWSURFACE|SDL_DOUBLEBUF|;
#endif

#elif defined(EMSCRIPTEN) // Canvas - SDL + Trenki3D mode
bpp = 32;
video_flags = SDL_SWSURFACE;
g_debug("Emscripten: 32 bits, SDL_SWSURFACE\n");

#else // TRENKI3D, e.g.
g_debug("set up SDL for framebuffer mode\n");
video_flags |= SDL_DOUBLEBUF;
bpp = 16;
#endif

#ifdef _DEBUG // SDL
bpp = 32;
video_flags = SDL_SWSURFACE;
#endif


/* Initialize the display */
switch (bpp)
{
case 8:
rgb_size[0] = 3;
rgb_size[1] = 3;
rgb_size[2] = 2;
break;
case 15:
rgb_size[0] = 5;
rgb_size[1] = 5;
rgb_size[2] = 5;
break;
case 16:
rgb_size[0] = 5;
rgb_size[1] = 6;
rgb_size[2] = 5;
break;
default:
rgb_size[0] = 8;
rgb_size[1] = 8;
rgb_size[2] = 8;
break;
}

#if defined(HAVE_OPENGL)
g_debug("set up SDL for OpenGL mode RGBA=%d,%d,%d,%d; Depth=24, Stencil=8, DoubleBuffer=1\n", rgb_size[0], rgb_size[1], rgb_size[2], (bpp==32)?8:0);
SDL_GL_SetAttribute( SDL_GL_RED_SIZE,   rgb_size[0]);
SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, rgb_size[1]);
SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE,  rgb_size[2]);
if(bpp==32)
{
SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 8);
}
SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 24);
SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 8);
SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1);

if(multisamples)
{
g_debug("multisamples x%d\n", multisamples);
SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, multisamples);
}
#endif

//	video_flags |= SDL_NOFRAME; // Make as fast as possible - ugly flickering
g_debug("Setting video mode: %dx%dx%d vidflags=0x%x\n", width, height, bpp, video_flags);
bool ok=true;
if ( SDL_SetVideoMode( width, height, bpp, video_flags ) == NULL )
{
g_debug("SetVideoMode failed: %s\n", SDL_GetError());
#if !defined(TINYGL) && !defined(TRENKI3D) && !defined(HAVE_OPENGL_ES)
ok=false;
if(multisamples)
{
g_debug("INIT: Unable to create video surface that supports FSAA; trying without.\n");
SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 0);
SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 0);
if ( SDL_SetVideoMode( width, height, bpp, video_flags ) )
ok=true;
}
#endif
}
if(!ok)
{

g_debug("INIT: Unable to create video surface that supports requested details; trying SDL_ANYFORMAT.\n");
if ( SDL_SetVideoMode( width, height, bpp, SDL_ANYFORMAT | video_flags) )
ok=true;


g_debug("INIT: Unable to create BPP -> trying 16.\n");
// retry with 16 bit mode
if(bpp!=16)
{
bpp = 16;
rgb_size[0] = 5;
rgb_size[1] = 6;
rgb_size[2] = 5;
if ( SDL_SetVideoMode( width, height, bpp, video_flags ) != NULL )
{
ok=true;
}
else
{
g_debug("INIT: Unable to create video surface that supports requested details; trying SDL_ANYFORMAT.\n");
if ( SDL_SetVideoMode( width, height, bpp, SDL_ANYFORMAT | video_flags) )
ok=true;
}
}
}
if(!ok)
{
g_debug("Couldn't set GL mode: %s\n", SDL_GetError());
// SDL_Quit(); - endprogram does?
return false;
}
g_debug("SDL_SetVideoMode seems to be %d\n", ok);

#if defined(HAVE_OPENGL) && defined(EMSCRIPTEN)
g_debug("Testing glCommands\n");
glEnable(GL_TEXTURE_2D);
glDisable(GL_TEXTURE_2D);
g_debug("OpenGL is ready for use\n");
#endif



// Set the screen size again - I put 0 to get "fullscreen" on Palm
#ifdef PALM_WEBOS
// 320x480 pre
// 320x400 pixi
bpp=32; // had a peek above ;)

int ilandscape = m_landscape;

// __DG_DESKTOPX=800; __DG_DESKTOPY=480; - eaglview did it
if(m_landscape==1 || m_landscape==3) // wanted to rotate by 90
{
int swp = __DG_DESKTOPX; __DG_DESKTOPX=__DG_DESKTOPY; __DG_DESKTOPY=swp;
g_debug("swap deskx, desky to %d,%d - landscape mode %d\n", __DG_DESKTOPX, __DG_DESKTOPY, m_landscape);
}
SetScreen(__DG_DESKTOPX, __DG_DESKTOPY, bpp,1);

// The HP touchpad would rotate portrait more to 1, which is upside down -> toggle to 3
if(m_physical_device_screen_is_landscape != want_landscape)
{
if(m_physical_device_screen_is_landscape)
m_landscape=3; // rotate by 270 - touchpad so "top" is at camera
else
m_landscape=1; // rotate by 90 - palm pre, so "top" is right edge
}


height = m_WND.height;
width = m_WND.width;

SDL_Delay(200); // Fix the "hanging" of the touchpad with black screen? (swap waits for vsync)
#endif

#endif // SDL 1.2



#if defined( HAVE_OPENGL)
g_debug("Screen BPP: %d\n", SDL_GetVideoSurface()->format->BitsPerPixel);
g_debug("\n");
g_debug( "Vendor     : %s\n", glGetString( GL_VENDOR ) );
g_debug( "Renderer   : %s\n", glGetString( GL_RENDERER ) );
g_debug( "Version    : %s\n", glGetString( GL_VERSION ) );
g_debug( "Extensions : %s\n", glGetString( GL_EXTENSIONS ) );
g_debug("\n");

#if defined(EMSCRIPTEN)
g_debug("skipping size tests\n");
#else
int value;
SDL_GL_GetAttribute( SDL_GL_RED_SIZE, &value );
g_debug( "SDL_GL_RED_SIZE: requested %d, got %d\n", rgb_size[0],value);
SDL_GL_GetAttribute( SDL_GL_GREEN_SIZE, &value );
g_debug( "SDL_GL_GREEN_SIZE: requested %d, got %d\n", rgb_size[1],value);
SDL_GL_GetAttribute( SDL_GL_BLUE_SIZE, &value );
g_debug( "SDL_GL_BLUE_SIZE: requested %d, got %d\n", rgb_size[2],value);
SDL_GL_GetAttribute( SDL_GL_DEPTH_SIZE, &value );
g_debug( "SDL_GL_DEPTH_SIZE: requested %d, got %d\n", bpp, value );
SDL_GL_GetAttribute( SDL_GL_DOUBLEBUFFER, &value );
g_debug( "SDL_GL_DOUBLEBUFFER: requested 1, got %d\n", value );
#endif

#endif

#ifndef TRENKI3D // try to fix a Palm Pre startup issue - didn't work :/
OPENGL_CHECK_ERRORS();
ClearScreen(0);

OPENGL_CHECK_ERRORS();
m_bDirtyZBuffer=true;
FlipScreens(NULL);
OPENGL_CHECK_ERRORS();
m_bDirtyZBuffer=true;
FlipScreens(NULL);
#endif

this->Make2DMode();

// -------- WIN32 --------
#elif defined(WIN32) && (defined(HAVE_OPENGL) || (defined(HAVE_OPENGL_ES) && defined(_DEBUG)) )
g_debug("WIN32 init video\n");
__DG_DESKTOPX=::GetSystemMetrics(SM_CXSCREEN);
__DG_DESKTOPY=::GetSystemMetrics(SM_CYSCREEN);

HDC hDC;
RECT	rect;
m_WND.hwnd = CreateWindow(STR_GLBASIC, STR_GLBASIC, WS_CAPTION,
0, 0,
// (::GetSystemMetrics(SM_CXSCREEN)-width)/2,
// (::GetSystemMetrics(SM_CYSCREEN)-height)/2,
width, height+::GetSystemMetrics(SM_CYCAPTION)+::GetSystemMetrics(SM_CYBORDER)*6,
NULL, NULL, hInst, NULL);

if(m_WND.hwnd == NULL) return false;

::GetWindowRect(m_WND.hwnd, &rect);
if (bpp==0) bpp=::GetDeviceCaps(::GetDC(NULL), BITSPIXEL);
if (width==0) width=abs(rect.right-rect.left);
if (height==0) height=abs(rect.bottom-rect.top);
m_WND.bpp=bpp;
m_WND.height=height;
m_WND.width=width;
m_WND.fullscreen=false;
hDC=::GetDC(m_WND.hwnd);
// Set Viewport
//	this->ChangeSize(width, height);
// Select the pixel format
int nPixelFormat=0;

#ifndef PFD_SUPPORT_COMPOSITION
#define PFD_SUPPORT_COMPOSITION 0x00008000
#endif

PIXELFORMATDESCRIPTOR pfd = {
sizeof(PIXELFORMATDESCRIPTOR),  // Size of this structure
1,                              // Version of this structure
PFD_DRAW_TO_WINDOW |// Format Must Support Window
PFD_SUPPORT_OPENGL |// Format Must Support OpenGL
PFD_SUPPORT_COMPOSITION| // composition (for accelerated OpenGL on Vista)
PFD_DOUBLEBUFFER,	// Must Support Double Buffering
PFD_TYPE_RGBA,		// Request An RGBA Format
(BYTE)min(24,m_WND.bpp),  // color bits, excluding alpha
0, 0, 0, 0, 0, 0,	// Color Bits Ignored (?)
8,					// No Alpha Buffer
0,					// Shift Bit Ignored (?)
0,					// No Accumulation Buffer
0, 0, 0, 0,			// Accumulation Bits Ignored (?)
24,					// 24 Bit Z-Buffer (Depth Buffer)
8,					// 8 Bit Stencil Buffer
0,					// No Auxiliary Buffer (?)
PFD_MAIN_PLANE,		// Main Drawing Layer
0,					// Reserved (?)
0, 0, 0};			// Layer Masks Ignored (?)

// Choose a pixel format that best matches that described in pfd
nPixelFormat = ChoosePixelFormat(hDC, &pfd);
SetPixelFormat(hDC, nPixelFormat, &pfd);

// Try to share this context
if(!m_hRC)
m_hRC = wglCreateContext(hDC);
// share failed - recreate
if(!wglMakeCurrent(hDC, m_hRC))
{
wglDeleteContext(m_hRC);
m_hRC = wglCreateContext(hDC);
wglMakeCurrent(hDC, m_hRC);
}
::ReleaseDC(m_WND.hwnd, hDC);

// We support multisampling!
m_WND.multisample = 0;
#if defined(HAVE_OPENGL)
if(multisamples && (nPixelFormat = ChooseMultisamplePixelFormat(hDC, pfd, m_WND.multisample)))
{
Close();

m_WND.hwnd = CreateWindow(STR_GLBASIC, STR_GLBASIC, WS_CAPTION,
0, 0,
// (::GetSystemMetrics(SM_CXSCREEN)-width)/2,
// (::GetSystemMetrics(SM_CYSCREEN)-height)/2,
width, height+::GetSystemMetrics(SM_CYCAPTION)+::GetSystemMetrics(SM_CYBORDER)*6,
NULL, NULL, hInst, NULL);

if(m_WND.hwnd == NULL) return false;
hDC=::GetDC(m_WND.hwnd);
SetPixelFormat(hDC, nPixelFormat, &pfd);
m_hRC = wglCreateContext(hDC);
wglMakeCurrent(hDC, m_hRC);
::ReleaseDC(m_WND.hwnd, hDC);
}
#endif

// Check for HW support
static int did_warn=0;
if(!did_warn)
if (DescribePixelFormat(hDC, nPixelFormat, sizeof(PIXELFORMATDESCRIPTOR), &pfd))
{
static const char* pRenderer = (const char*)glGetString(GL_RENDERER);
if (pfd.dwFlags & PFD_GENERIC_FORMAT || strcmp(pRenderer, "Mesa Windows GDI Driver")==0)
{
did_warn=1;
g_debug("*** OpenGL Software Emulation - update driver!\n");
GFFileSystem fs;
char msg[2048]="";
memset(msg, 0, 2048);
if(fs.OpenIn("opengldriver.txt"))
{
fs.Read(msg, 2047);
fs.Close();
}
if(strlen(msg)>0)
{
MessageBox(NULL, msg, "No OpenGL Hardware Drivers", MB_OK|MB_ICONWARNING);
}
else
{
MessageBox(NULL, "Please update your GFX adapter's driver\nso it can render OpenGL by HARDWARE\n\n\nBitte aktualisieren Sie Ihren\nGrafkkartentreiber, damit er OpenGL\nper HARDWARE untersttzt!",
"No OpenGL Hardware Drivers", MB_OK|MB_ICONWARNING);
}
}
}

glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

// *** SPACE FRACTAL FIXES 2017.3.1 ****
#elif defined(TARGET_OS_IPHONE)
// nothing to do, move along
// all done in iPhoneAppController.m
// m_physical_device_screen_is_landscape = __DG_DESKTOPX > __DG_DESKTOPY ? 1:0;


// SPACEFRACTAL:
// No Orientation swap should been done now from iOS8. Otherwice, you might start
// the app in a wrong size or orientation instead. You can still use software
// orientation by setting LANDSCAPE RIGHT only support in the XCODE setting.
SetScreen(width, height, 16, TRUE);
height = m_WND.height;
width = m_WND.width;

// __DG_DESKTOPX=800; __DG_DESKTOPY=480; - eaglview did it
// if(m_landscape==1 || m_landscape==3) // landscape mode
// {
// 		int swp = __DG_DESKTOPX; __DG_DESKTOPX=__DG_DESKTOPY; __DG_DESKTOPY=swp;
// }
g_debug("phy dev is landscape: %d. m_landscape:%d\n", m_physical_device_screen_is_landscape, m_landscape);
g_debug("desk: %dx%d; screen %dx%d\n", __DG_DESKTOPX, __DG_DESKTOPY, m_WND.width, m_WND.height);

#elif defined(TRENKI3D) // just trenki3D, no SDL. Use /dev/fb0 or whatever. -> GP2X, e.g.
g_debug("video init Trenki3D\n");
// OK, you may pass
#if defined( GP2X ) || defined(GPHWIZ) || defined(CAANOO)
__DG_DESKTOPX=320; __DG_DESKTOPY=240;
#else
#error screen resolution, please?
#endif
#else
#error no Rainbows Initalized
#endif


m_WND.bpp=bpp;
m_WND.height=height;
m_WND.width=width;
m_WND.virtw=0;
m_WND.virth=0;
m_WND.fullscreen=false;

// debug landscape on iPad mode
#if defined(_DEBUG) && defined(WIN32) && defined(HAVE_OPENGL_ES)
m_WND.height=max(height, width);
m_WND.width=min(height, width);
SetScreen(m_WND.width, m_WND.height, 32, false);
#endif

#if defined(TINYGL) || defined(TRENKI3D)
Screen.Create(NULL, m_WND.width, m_WND.height, false);
#endif

#else // POCKETPC
m_WND.bpp=bpp;
m_WND.height=height;
m_WND.width=width;
m_WND.fullscreen=false;
#endif

g_debug("get accurate timer - 1st call\n");
m_next_time=AccurateTime();

g_debug("flip - 1st call\n");
this->FlipScreens(); // no glGetString on iOS, otherwise

// const char* pVendor = (const char*)glGetString( GL_VENDOR );
// OpenGL extension loading
#if defined(HAVE_OPENGL)
{
char *strExtensions = (char*)glGetString(GL_EXTENSIONS);

if(strExtensions && strstr(strExtensions, "WGL_EXT_swap_control")!=0)
{
gf_wglSwapIntervalEXT = (PFWGL_SWAP_CTRL) glGFGetProcAddressArb("wglSwapIntervalEXT");
}

if( strExtensions && strstr(strExtensions, "GL_ARB_multitexture") != 0)
{
glActiveTextureArb	=(PFNGLACTIVETEXTUREARBPROC)  glGFGetProcAddressArb("glActiveTextureARB");
glMultiTexCoord2fArb=(PFNGLMULTITEXCOORD2FARBPROC)glGFGetProcAddressArb("glMultiTexCoord2fARB");
glClientActiveTextureArb = (PFNGLCLIENTACTIVETEXTUREARBPROC) glGFGetProcAddressArb("glClientActiveTextureARB");

// VBO Extension Function Pointers
glGenBuffersArb = (PFNGLGENBUFFERSARBPROC)glGFGetProcAddressArb("glGenBuffersARB");
glBindBufferArb = (PFNGLBINDBUFFERARBPROC)glGFGetProcAddressArb("glBindBufferARB");
glBufferDataArb = (PFNGLBUFFERDATAARBPROC)glGFGetProcAddressArb("glBufferDataARB");
glDeleteBuffersArb = (PFNGLDELETEBUFFERSARBPROC)glGFGetProcAddressArb("glDeleteBuffersARB");
glMapBufferArb = (PFNGLMAPBUFFERARBPROC)glGFGetProcAddressArb("glMapBufferARB");
glUnmapBufferArb = (PFNGLUNMAPBUFFERARBPROC)glGFGetProcAddressArb("glUnmapBufferARB");
glGetBufferParameterivArb = (PFNGLGETBUFFERPARAMETERIVARBPROC)glGFGetProcAddressArb("glGetBufferParameterivARB");
}
if( strExtensions && strstr(strExtensions, "GL_ARB_fragment_program") != 0)
{
glCreateProgramObjectArb=	(PFNGLCREATEPROGRAMOBJECTARBPROC     ) glGFGetProcAddressArb("glCreateProgramObjectARB");
glDeleteObjectArb=			(PFNGLDELETEOBJECTARBPROC            ) glGFGetProcAddressArb("glDeleteObjectARB");
glCreateShaderObjectArb=	(PFNGLCREATESHADEROBJECTARBPROC      ) glGFGetProcAddressArb("glCreateShaderObjectARB");
glShaderSourceArb=			(PFNGLSHADERSOURCEARBPROC            ) glGFGetProcAddressArb("glShaderSourceARB");
glCompileShaderArb=			(PFNGLCOMPILESHADERARBPROC           ) glGFGetProcAddressArb("glCompileShaderARB");
glGetObjectParameterivArb=	(PFNGLGETOBJECTPARAMETERIVARBPROC    ) glGFGetProcAddressArb("glGetObjectParameterivARB");
glAttachObjectArb=			(PFNGLATTACHOBJECTARBPROC            ) glGFGetProcAddressArb("glAttachObjectARB");
glGetInfoLogArb=			(PFNGLGETINFOLOGARBPROC              ) glGFGetProcAddressArb("glGetInfoLogARB");
glLinkProgramArb=			(PFNGLLINKPROGRAMARBPROC             ) glGFGetProcAddressArb("glLinkProgramARB");
glUseProgramObjectArb=		(PFNGLUSEPROGRAMOBJECTARBPROC        ) glGFGetProcAddressArb("glUseProgramObjectARB");
glGetUniformLocationArb=	(PFNGLGETUNIFORMLOCATIONARBPROC      ) glGFGetProcAddressArb("glGetUniformLocationARB");
glUniform1fArb=				(PFNGLUNIFORM1FARBPROC               ) glGFGetProcAddressArb("glUniform1fARB");
glUniform1iArb=				(PFNGLUNIFORM1IARBPROC               ) glGFGetProcAddressArb("glUniform1iARB");
glGetAttribLocationArb=		(PFNGLGETATTRIBLOCATIONARBPROC       ) glGFGetProcAddressArb("glGetAttribLocationARB");
glVertexAttrib1fArb=		(PFNGLVERTEXATTRIB1FARBPROC          ) glGFGetProcAddressArb("glVertexAttrib1fARB");
}
}
#endif


#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
{
char *strExtensions = (char*)glGetString(GL_EXTENSIONS);

m_bSupportBGRA_ext = false;
if( strExtensions && strstr(strExtensions, /*GL_IMG, GL_APPLE*/"_texture_format_BGRA8888") != 0)
m_bSupportBGRA_ext = true;
if( strExtensions && strstr(strExtensions, "GL_EXT_bgra") != 0)
m_bSupportBGRA_ext = true;

#ifdef PALM_WEBOS // Pixi crashes with GL_RGBA, but works with GL_BGRA_EXT - no extension signaled, though (bug)
m_bSupportBGRA_ext = true;
#endif

if(m_bSupportBGRA_ext)
{
g_debug("BGRA ext supported\n");
}
else
{
g_debug("BGRA ext NOT supported\n%s\n", strExtensions);
}

int				max_tex;
glGetIntegerv(GL_MAX_TEXTURE_SIZE, &max_tex);
g_debug("Texture size limit: %d\n", max_tex);
}
#endif

g_debug("init fbo\n");
// Initialize the FrameBuffer extension if available
FBUFFER::InitFrameBufferObject();

#if !defined( WANT_SDL) && defined(WIN32) && !defined(POCKETPC)
UpdateWindow(m_WND.hwnd);
ShowWindow(m_WND.hwnd, SW_HIDE);
#endif

// Setup OpenGL State
//	this->DoWindowed();
g_debug("2D VP\n");
this->Make2DMode();
//pi_test(); exit(0);
g_debug("OGRB init [OK]\n");
return true;
}

//---------------------------------------------------------------//
//---------------------------------------------------------------//
void OpenGLRainbows::SetMaxFPS(int maxfps, bool bVsync)
{
#if defined(EMSCRIPTEN)
// not implemented
#elif defined(WANT_SDL) && (defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES))
#if SDL_VERSION_ATLEAST(1,3,0) 
SDL_GL_SetSwapInterval( bVsync ? 1:0 ); 
#else /* SDL_VERSION_ATLEAST(1,3,0) */ 
#ifdef SDL_GL_SWAP_CONTROL 
SDL_GL_SetAttribute(SDL_GL_SWAP_CONTROL, bVsync ? 1:0 ); 
#else /* SDL_GL_SWAP_CONTROL */ 
g_debug("VSync unsupported on old SDL versions (before 1.2.10).\n");
#endif /* SDL_GL_SWAP_CONTROL */ 
#endif /* SDL_VERSION_ATLEAST(1,3,0) */
#elif defined(WIN32) && !defined(_WIN32_WCE) && !defined(TRENKI3D)
if(gf_wglSwapIntervalEXT) gf_wglSwapIntervalEXT(bVsync ? 1:0);
#endif

if (maxfps<=0.0)
{
m_FrameRate = 2.0; // 500 fps = max
}
else
{
m_FrameRate=DGInt(DGInt(1000.0)/ DGInt(maxfps));
}
}


//---------------------------------------------------------------//
//---------------------------------------------------------------//
void OpenGLRainbows::SetScreen(int w, int h, int bpp, int fullscreen)
{
#if defined( GP2X ) || defined(GPHWIZ) || defined(PANDORA) || defined(RASPBERRY_PI) || defined(CAANOO)
return;
#endif

// *** SPACE FRACTAL FIXES 2017.3.1 ****
// Orientation needs ALLWAYS to been started on 0, regaardless of start orientation.
// This is due orientation changes in iOS8.
#if defined(TARGET_OS_IPHONE)
m_WND.width = __DG_DESKTOPX; // allways start in orientation 0
m_WND.height= __DG_DESKTOPY;
m_landscape=0;
return;
#endif

#if defined(PALM_WEBOS) || defined(ANDROID)
g_debug("Rbow::SetScreen( %d,%d)\n", w,h);
if(		(w>h &&  m_physical_device_screen_is_landscape) // screen fits orientation, no rotations required
||	(h>w && !m_physical_device_screen_is_landscape)
)
{
m_landscape=0;
}
else
{
m_landscape=1;
}
// m_WND.width=320; m_WND.height=480; // NOT ON IPAD!!

// m_WND.width = min(w,h);
// m_WND.height= max(w,h);

if(m_physical_device_screen_is_landscape)
{
m_WND.width = max(__DG_DESKTOPX, __DG_DESKTOPY); // physical size of device
m_WND.height= min(__DG_DESKTOPX, __DG_DESKTOPY);
}
else
{
m_WND.width = min(__DG_DESKTOPX, __DG_DESKTOPY);
m_WND.height= max(__DG_DESKTOPX, __DG_DESKTOPY);
}


return;
#endif


if(w) m_WND.width = w;
if(h) m_WND.height = h;
if(bpp) m_WND.bpp = bpp;
m_WND.virth=0; m_WND.virtw=0; // reset - will be set on next viewport call.

#ifndef POCKETPC

// Go into windowed mode just to be safe
DoWindowed();


#ifdef WANT_SDL
if(w || h || bpp)
{
#if SDL_VERSION_ATLEAST(2,0,0)
SDL_SetWindowFullscreen(m_WND.sdl_window, SDL_FALSE);
SDL_SetWindowSize(m_WND.sdl_window, m_WND.width, m_WND.height);
#else
Uint32 video_flags=0;
#if (defined(TINYGL) || defined(TRENKI3D) )
video_flags |= SDL_DOUBLEBUF;
bpp = 16;
#else
video_flags = SDL_OPENGL;
#endif
SDL_SetVideoMode(m_WND.width, m_WND.height, m_WND.bpp, video_flags);
#endif
}
#endif

if(fullscreen)
DoFullscreen();
else
DoWindowed();

#if defined(TINYGL) || defined(TRENKI3D)
HWND hwnd=NULL;
#if !defined( WANT_SDL) && defined(WIN32)
hwnd = m_WND.hwnd;
#endif
Screen.Create((HWND)hwnd, w,h, w>h ? 1:0);
#endif

#endif
}



//---------------------------------------------------------------//
//---------------------------------------------------------------//
bool OpenGLRainbows::DoFullscreen()
{
// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
// -------- Pandora --------
#elif defined(PANDORA) || defined(RASPBERRY_PI)
// -------- SDL --------
#elif defined(WANT_SDL)
#if !defined( TARGET_OS_IPHONE) && !defined(PALM_WEBOS) && !defined(ANDROID)
#if SDL_VERSION_ATLEAST(2,0,0)
SDL_SetWindowFullscreen(m_WND.sdl_window, SDL_TRUE);
#else
SDL_Surface *screen;
screen = SDL_GetVideoSurface();
if (!(screen->flags&SDL_FULLSCREEN))
SDL_WM_ToggleFullScreen(screen);
#endif
#endif
#elif defined(MACOSX)
return true;
#elif defined(POCKETPC)
return true;
// -------- WIN32 --------
#elif defined(WIN32)
DEVMODE	dm;
int		CurrBPP;
HDC		hdc;
memset(&dm, 0, sizeof(dm));
dm.dmSize = sizeof(dm);

dm.dmPelsWidth  = m_WND.width;
dm.dmPelsHeight = m_WND.height;
dm.dmFields     = DM_PELSWIDTH | DM_PELSHEIGHT;

hdc=::GetDC(NULL);
CurrBPP=::GetDeviceCaps(hdc, BITSPIXEL);
ReleaseDC(NULL, hdc);
if (m_WND.bpp != CurrBPP && m_WND.bpp != 0)
{
dm.dmBitsPerPel = m_WND.bpp;
dm.dmFields |= DM_BITSPERPEL;
}

if(ChangeDisplaySettings(&dm, CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
{
dm.dmFields=DM_PELSWIDTH | DM_PELSHEIGHT; // No Color Depth Change
if (ChangeDisplaySettings(&dm, CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
{
::MessageBeep(MB_ICONEXCLAMATION);
g_debug("No Fullscreen Mode available\n");
this->DoWindowed();
return false;
}
}

OpenGLRainbows::OPENGL_RAINBOWS_WINDOW wnd = m_WND;
//		Close(); // would destroy context

#if 0 // GF: 2015.08.15 this would destroy the old window? We just need to change size and params!
// (re)store window text
char wtext[512];
::GetWindowText(m_WND.hwnd, wtext, 512);
if(!Init(m_hinstance, wnd.width, wnd.height, wnd.bpp, m_FrameRate>0 ? (int)(1000/m_FrameRate) : 5, wnd.multisample))
{
return false;
}
else
{
::SetWindowText(m_WND.hwnd, wtext);
::DestroyWindow(wnd.hwnd);
}
#endif

this->ChangeSize(m_WND.width, m_WND.height);
::SetWindowLong(m_WND.hwnd,GWL_STYLE,WS_POPUP|WS_MAXIMIZE);
::ShowWindow(m_WND.hwnd,SW_RESTORE);
::UpdateWindow(m_WND.hwnd);
::SetForegroundWindow(m_WND.hwnd);
::SetFocus(m_WND.hwnd);
::SetWindowPos(m_WND.hwnd,HWND_TOPMOST,0,0, m_WND.width, m_WND.height, 0);

this->Make2DViewport();


#endif

m_WND.fullscreen=true;
return true;
}


#ifdef WIN32
#if ! (defined( WANT_SDL ) || defined(POCKETPC) )

#define MAX_WINDOWS 256
static int num_windows = 0;
static HWND window_hwnd[MAX_WINDOWS];
static WINDOWPLACEMENT placement[MAX_WINDOWS];

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
if(num_windows < MAX_WINDOWS)
{
if(IsWindowVisible(hwnd))
{
placement[num_windows].length = sizeof(WINDOWPLACEMENT);
if(GetWindowPlacement(hwnd, &placement[num_windows]) != 0)
{
window_hwnd[num_windows] = hwnd;
num_windows++;
}
}
}
return TRUE;
}


void save_desktop(void)
{
num_windows = 0;
EnumWindows(EnumWindowsProc, 0);
}

void restore_desktop1(void)
{
int i;
for(i = 0; i < num_windows; i++)
{
HWND hwnd = window_hwnd[i];
if(IsWindow(hwnd))
{
SetWindowPlacement(hwnd, &placement[i]);
}
}
}

void restore_desktop(void)
{
/* Okay, this may look strange. I don't like it either.
We are always calling this right after ChangeDisplaySettings(),
and it seems that the mode change may still be taking place,
as sometimes the windows aren't restored. The more delay I
put, the more likely it is that it will work. But if there
is much delay, the window movement is clearly visible. And
delay isn't very robust way to do anything. But I couldn't
find a reliable way to check if it worked or not.
*/

restore_desktop1();
Sleep(500);
restore_desktop1();
}
#endif
#endif

/*
void CenterWindow(HWND hwnd)
{
int x, y;
HWND hwndDeskTop;
CRect rcWnd, rcDeskTop;
// Get a handle to the desktop window

hwndDeskTop = ::GetDesktopWindow();
// Get dimension of desktop in a rect

::GetWindowRect(hwndDeskTop, &rcDeskTop);
// Get dimension of main window in a rect

::GetWindowRect(hwnd, &rcWnd);
// Find center of desktop

x = rcDeskTop.Width() / 2;
y = rcDeskTop.Height() / 2;
x -= rcWnd.Width() / 2;
y -= rcWnd.Height() / 2;
// Set top and left to center main window on desktop

::SetWindowPos(hwnd, HWND_TOP, x, y, 0, 0, SWP_NOSIZE);
}
*/


//---------------------------------------------------------------//
//---------------------------------------------------------------//
bool OpenGLRainbows::DoWindowed()
{
// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)

// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
// -------- Pandora --------
#elif defined(PANDORA) || defined(RASPBERRY_PI)

// -------- SDL --------
#elif defined(WANT_SDL)
#if !defined( TARGET_OS_IPHONE) && !defined(PALM_WEBOS) && !defined(ANDROID)
#if SDL_VERSION_ATLEAST(2,0,0)
SDL_SetWindowFullscreen(m_WND.sdl_window, SDL_FALSE);
#else
SDL_Surface *screen;
screen = SDL_GetVideoSurface();
if (screen->flags&SDL_FULLSCREEN)
SDL_WM_ToggleFullScreen(screen);
#endif
#endif
#elif defined(MACOSX)
return true;
#elif defined(POCKETPC)
return true;
// -------- WIN32 --------
#elif defined(WIN32)
if (m_WND.fullscreen)
{
::ChangeDisplaySettings(NULL, 0);
restore_desktop();
}

::SetWindowLong(m_WND.hwnd, GWL_EXSTYLE, 0);
::SetWindowLong(m_WND.hwnd, GWL_STYLE, WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX); // | WS_CLIPCHILDREN | WS_CLIPSIBLINGS);
::UpdateWindow(m_WND.hwnd);

WINDOWPLACEMENT	wpl;
if(0  ) // !::GetWindowPlacement(m_WND.hwnd, &wpl)) // Win98 will fail this here...
{
wpl.rcNormalPosition.left=0;
wpl.rcNormalPosition.top=0;
wpl.rcNormalPosition.right=m_WND.width;
wpl.rcNormalPosition.bottom=m_WND.height;
::OffsetRect(&wpl.rcNormalPosition, (::GetSystemMetrics(SM_CXSCREEN)-m_WND.width)/2, (::GetSystemMetrics(SM_CYSCREEN)-m_WND.width)/2);
}
else
{
RECT rcCenter, rcArea;
::GetWindowRect(m_WND.hwnd, &rcCenter);
HMONITOR hMonitor = MonitorFromRect(&rcCenter, MONITOR_DEFAULTTONEAREST);
if(hMonitor)
{
MONITORINFO MonitorInfo = { sizeof MonitorInfo };
GetMonitorInfo(hMonitor, &MonitorInfo);
rcArea = MonitorInfo.rcWork;
}
else
::SystemParametersInfo(SPI_GETWORKAREA, 0, &rcArea, 0);

wpl.rcNormalPosition.left=0;
wpl.rcNormalPosition.top=0;
wpl.rcNormalPosition.right=m_WND.width                                   +::GetSystemMetrics(SM_CXBORDER)*6;
wpl.rcNormalPosition.bottom=m_WND.height+::GetSystemMetrics(SM_CYCAPTION)+::GetSystemMetrics(SM_CYBORDER)*6;
::OffsetRect(&wpl.rcNormalPosition, ((rcArea.right-rcArea.left)-m_WND.width)/2, ((rcArea.bottom-rcArea.top)-m_WND.height)/2);
}

::SetWindowPos(m_WND.hwnd, HWND_NOTOPMOST,
wpl.rcNormalPosition.left,
wpl.rcNormalPosition.top,
wpl.rcNormalPosition.right - wpl.rcNormalPosition.left,
wpl.rcNormalPosition.bottom- wpl.rcNormalPosition.top,
SWP_SHOWWINDOW);
::ShowWindow(m_WND.hwnd, SW_SHOWNORMAL);

// update desktop
::InvalidateRect(0, NULL, TRUE);

::UpdateWindow(m_WND.hwnd);
::BringWindowToTop(m_WND.hwnd);

// if (m_WND.fullscreen) ::ShowCursor(TRUE);
this->Make2DViewport();
#endif

m_WND.fullscreen=false;
return true;
}

//---------------------------------------------------------------//
// Hide window
//---------------------------------------------------------------//
bool OpenGLRainbows::HideWindow()
{
// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
// -------- Pandora --------
#elif defined(PANDORA)||defined(RASPBERRY_PI)
// -------- SDL --------
#elif defined(WANT_SDL)
// #NEED SDL
#elif defined(MACOSX)
return true;
#elif defined(POCKETPC)
return true;
// -------- WIN32 --------
#elif defined(WIN32)
if (m_WND.fullscreen) ::ChangeDisplaySettings(NULL, 0);

::SetWindowLong(m_WND.hwnd, GWL_EXSTYLE, 0);
::SetWindowLong(m_WND.hwnd, GWL_STYLE, WS_OVERLAPPED | WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

//	::MoveWindow(m_WND.hwnd, 0, 0, m_WND.width, m_WND.height, TRUE);
::ShowWindow(m_WND.hwnd, SW_HIDE);
::UpdateWindow(m_WND.hwnd);

//	if (m_WND.fullscreen) ::ShowCursor(TRUE);
m_WND.fullscreen=false;
this->WinMessages();
#endif
return true;
}


#ifndef POCKETPC
//---------------------------------------------------------------//
//---------------------------------------------------------------//
void OpenGLRainbows::ChangeSize(int w, int h)
{
m_WND.height=h; m_WND.width=w;
Make2DViewport();
}
#endif



///////////////////////////////////////////////////////////////////
//  POLY WORK
///////////////////////////////////////////////////////////////////


class POLY_POINT2D
{
public:
float pos[2];
float tex[2];
unsigned char col[4]; // must be 4 bytes! TRENKI_COL_PRT (sizeof(float))

POLY_POINT2D() {}
POLY_POINT2D(const POLY_POINT2D& pp) {*this=pp;}
inline POLY_POINT2D& operator=(const POLY_POINT2D& pp)
{
// might be faster!?
if(sizeof(POLY_POINT2D) == 5*sizeof(int))
{
unsigned int* pP = (unsigned int*) this;
const unsigned int* pS = (const unsigned int*) &pp;
*pP++ = *pS++;
*pP++ = *pS++;
*pP++ = *pS++;
*pP++ = *pS++;
*pP++ = *pS++;
}
else
{
pos[0]=pp.pos[0]; pos[1]=pp.pos[1];
tex[0]=pp.tex[0]; tex[1]=pp.tex[1];
*(int*)&col = *(int*)&pp.col;
}
return *this;
}
};
Queue<POLY_POINT2D> g_PolyPoints;
int		g_nTexture=0; // the value you pass to X_MAKE3D(here, ...)
int     g_PolyMode=0;
int     g_PolyHasColor=0;
float   g_FtxInv, g_FtyInv;
int		g_bLastPolyStripGroup=0;

//---------------------------------------------------------------//
// Start a poly
//---------------------------------------------------------------//
void OpenGLRainbows::PolyStart(int nTexture, int iMode)
{
//g_nTexture=nTexture;
SetTexture3D(nTexture, -1, 0);
g_PolyPoints.Clear(false);
g_PolyPoints.AllocAtLeast(2); // 480x320 screen with 32x32 tiles ;)
g_PolyMode=iMode;
g_PolyHasColor=0;
if(nTexture>=0)
{
g_FtxInv = 1.0f / m_Texture[nTexture].w;
g_FtyInv = 1.0f / m_Texture[nTexture].h;
}
g_bLastPolyStripGroup=0;
}

//---------------------------------------------------------------//
// Add Points to Poly
//---------------------------------------------------------------//
void OpenGLRainbows::PolyPoint(float sx, float sy, float tx, float ty, COLORREF col)
{
int num = g_PolyPoints.Size();
g_PolyPoints.SetSize(num + 1 + g_bLastPolyStripGroup );
POLY_POINT2D& pp = g_PolyPoints[num];
pp.pos[0]=sx; pp.pos[1]=sy;

// tx/ty come in _PIXELs_, not in texture coords
// and the user don't fucking care about non power of 2
// texture sizes!!!
if(g_nTexture>=0)
{
pp.tex[0]=tx* g_FtxInv; pp.tex[1]=((float)m_Texture[g_nTexture].bh - ty)*g_FtyInv;
}
if(col==0xffffff)
{
pp.col[0]=pp.col[1]=pp.col[2]=255;
}
else
{
g_PolyHasColor=1;
pp.col[0] = GetRValue(col);
pp.col[1] = GetGValue(col);
pp.col[2] = GetBValue(col);
}
if(col == m_CookieColor)
pp.col[3] =0;
else if (m_falpha == 1.0f)
pp.col[3] = 255;
else
pp.col[3] = (unsigned char)(m_falpha*255.0f);

if(g_bLastPolyStripGroup)
{
g_PolyPoints[num+1] = pp;
g_bLastPolyStripGroup = 0;
}
POLY_POINT2D p2;
p2 = pp;

}

//---------------------------------------------------------------//
// Add a degenerated poly strip for a new "group" of strips
//---------------------------------------------------------------//
void OpenGLRainbows::PolyNewStrip(void)
{
int num = g_PolyPoints.Size();
if(num && !g_bLastPolyStripGroup)
{
g_bLastPolyStripGroup = 1;

g_PolyPoints.SetSize(num+1);
g_PolyPoints[num] = g_PolyPoints[num-1];
}
}

/*
Mode = 0 (FAN)
Alle Punkte werden mit dem ersten Punkt erbunden.
1_____0______4
\    / \    /
\  /   \  /
\/_____\/
2       3

Mode = 1 (TRINGLES)
Jeweils 3 Punkte bilden ein eigenstndiges Dreieck.
1_____0  3______5
\    /    \    /
\  /      \  /
\/        \/
2          4

Mode = 1 (STRIP)
// Jeweils 2 Punkte Bilden ein Vieweck.
0_____2______4
\    / \    /
\  /   \  /
\/_____\/
1       3
*/

//---------------------------------------------------------------//
// Finish a Poly
//---------------------------------------------------------------//
void OpenGLRainbows::PolyEnd(void)
{
#if defined(TRENKI3D)

switch(g_PolyMode)
{
case 0:
tglDrawArraysXYZ_UV_RGBA(GL_TRIANGLE_FAN, g_PolyPoints.Size(), &g_PolyPoints.GetAt(0)->pos[0], 0, 0, g_nTexture>=0 ? 1:0, 1, 1);
break;
case 1:
tglDrawArraysXYZ_UV_RGBA(GL_TRIANGLES, g_PolyPoints.Size(), &g_PolyPoints.GetAt(0)->pos[0], 0, 0, g_nTexture>=0 ? 1:0, 1, 1);
break;
case 2:
if(g_PolyHasColor || m_falpha != 1.0f)
{
tglDrawArraysXYZ_UV_RGBA(GL_TRIANGLE_STRIP, g_PolyPoints.Size(), &g_PolyPoints.GetAt(0)->pos[0], 0, 0, g_nTexture>=0 ? 1:0, 1, 1);
}
else
{
tglDrawArraysXYZ_UV_RGBA(GL_TRIANGLE_STRIP, g_PolyPoints.Size(), &g_PolyPoints.GetAt(0)->pos[0], 0, 0, g_nTexture>=0 ? 1:0, 0, 1);
}
break;
}
#else

// Enable Pointers
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer(  2, GL_FLOAT, sizeof(POLY_POINT2D), (char*)&g_PolyPoints.GetAt(0)->pos[0]);
if(g_nTexture>=0)
{
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_POINT2D), (char*)&g_PolyPoints.GetAt(0)->tex[0]);
}

if(g_PolyHasColor || m_falpha != 1.0f)
{
g_PolyHasColor=1;
//glbEnable(GL_COLOR_MATERIAL);
glbEnable(GL_DITHER);
glShadeModel(GL_SMOOTH);
glEnableClientState(GL_COLOR_ARRAY);
glColorPointer(4, GL_UNSIGNED_BYTE, sizeof(POLY_POINT2D), (char*)&g_PolyPoints.GetAt(0)->col[0]);
}

ApplySmoothShading();


// Draw All Of The Triangles At Once
switch(g_PolyMode)
{
case 0:
glDrawArrays(GL_TRIANGLE_FAN, 0, g_PolyPoints.Size());
break;
case 1:
glDrawArrays( GL_TRIANGLES, 0, g_PolyPoints.Size());
break;
case 2:
glDrawArrays( GL_TRIANGLE_STRIP, 0, g_PolyPoints.Size());
break;
}
// Disable Pointers
glDisableClientState( GL_VERTEX_ARRAY );					// Disable Vertex Arrays
glDisableClientState( GL_TEXTURE_COORD_ARRAY );				// Disable Texture Coord Arrays


if(g_PolyHasColor)
{
glbColor4f(1.0f, 1.0f, 1.0f, m_falpha);
glDisableClientState( GL_COLOR_ARRAY );						// Disable Color Arrays

glShadeModel(GL_FLAT);
glbDisable(GL_DITHER);
//glbDisable(GL_COLOR_MATERIAL);
}
#endif
}


//---------------------------------------------------------------//
// Enable smooth shading mode
//---------------------------------------------------------------//
void OpenGLRainbows::SetSmoothShading(bool smooth)
{
#if !defined(TRENKI3D) && !defined(TINYGL)
m_SmoothShading = smooth;
#endif
}

//---------------------------------------------------------------//
// Enable smooth shading mode
//---------------------------------------------------------------//
void OpenGLRainbows::ApplySmoothShading()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if(m_SmoothShading)
{
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
}
else
{
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
}
#endif
}


//---------------------------------------------------------------//
// 1.0 -> all solid, no testing
//---------------------------------------------------------------//
void OpenGLRainbows::SetAlphaTesting(float greaterthen)
{
#if defined(TINYGL) || defined(TRENKI3D)
Screen.AlphaTesting(greaterthen < 1.0f ? true:false);
#else
if(greaterthen >= 1.0f)
{
glbDisable(GL_ALPHA_TEST);
m_fAlphaTestingGTH = 1.0f;
}
else
{
// Bug in webgl port, so far
#if defined(EMSCRIPTEN)
greaterthen = 1.0f;
DoAlpha(-1.0);
#else
glbEnable(GL_ALPHA_TEST);
glAlphaFunc(GL_GREATER, greaterthen); // 0.5
#endif
m_fAlphaTestingGTH = greaterthen;
}
#endif
}



#if !defined(TINYGL) && !defined(TRENKI3D)
//---------------------------------------------------------------//
// Draw a 4 noded 2D object (Sprite)
//---------------------------------------------------------------//
void OpenGLRainbows::DrawQuad(const float* pXYUV)
{
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer( 2, GL_FLOAT, 4*sizeof(float), (char*)pXYUV);
if(g_nTexture>=0)
{
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, 4*sizeof(float), (char*)&pXYUV[2]);
}

// Render
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

glDrawArrays(GL_TRIANGLE_FAN, 0, 4);	// Draw All Of The Triangles At Once

// Disable Pointers
glDisableClientState( GL_VERTEX_ARRAY );					// Disable Vertex Arrays
if(g_nTexture>=0)
glDisableClientState( GL_TEXTURE_COORD_ARRAY );			// Disable Texture Coord Arrays
}
#endif

//---------------------------------------------------------------//
// Draw the vertex array prepared before (3d text / Billboard)
//---------------------------------------------------------------//
void OpenGLRainbows::DrawVertexArray(unsigned int iMode)
{
#ifdef TRENKI3D
//	Trenkti3d();
// #NEED
#else
if(m_VertexArray.Size())
{
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer( 3, GL_FLOAT, sizeof(OpenGLRainbows::VERTEX), (char*)&m_VertexArray[0].x);
if(g_nTexture>=0)
{
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(OpenGLRainbows::VERTEX), (char*)&m_VertexArray[0].u);
}
// Render GL_TRIANGLES
glDrawArrays(iMode, 0, m_VertexArray.Size());	// Draw All Of The Triangles At Once
// Disable Pointers
glDisableClientState( GL_VERTEX_ARRAY );					// Disable Vertex Arrays
glDisableClientState( GL_TEXTURE_COORD_ARRAY );				// Disable Texture Coord Arrays
}
#endif
}




//---------------------------------------------------------------//
// Set Texture for 3D Objects
//---------------------------------------------------------------//
#ifdef TRENKI3D
void OpenGLRainbows::SetTexture3D(int num, int num_multi, int usemipmapping)
{
g_nTexture = num;
if(num>=0)
{
tglBindTexture(   m_Sprite[g_nTexture].Pixels(), m_Sprite[g_nTexture].m_Width, m_Sprite[g_nTexture].m_Height);
tglSetCookieColor(m_Sprite[g_nTexture].m_colorkey, m_Sprite[g_nTexture].m_CookieInside);
}
else
{
tglBindTexture(NULL,0,0);
}
}
#else
void OpenGLRainbows::SetTexture3D(int num, int num_multi, int usemipmapping, GLuint* pTextures)
{
/* polyvector - all white?
static int o_num=-99, o_num_multi=-99, o_usemipmapping=-99;
static GLuint* po_Textures=NULL;
if(o_num==num && num_multi==o_num_multi && usemipmapping==o_usemipmapping && pTextures==po_Textures)
return;
o_num=num; num_multi=o_num_multi; usemipmapping=o_usemipmapping; pTextures=po_Textures;
*/

g_nTexture = num;
usemipmapping = usemipmapping ? 1 : 0;
#if defined(TINYGL) || defined(TRENKI3D)
usemipmapping=0;
#endif
m_Texture3D[0] = num;
m_Texture3D[1] = num_multi;
m_Texture3D[2] = usemipmapping;

#if defined(TINYGL)
m_Texture3D[2] = 0;
if (num >=0 && m_Sprite[num].good() && m_Sprite[num].m_glTextureId==0)
{
unsigned int tx = m_Sprite[num].MakeGLTexture();
m_Texture[num].mipstate[0] = tx;
}
#elif defined(TRENKI3D)
trenki_set_texture
#endif

#if defined(HAVE_OPENGL)
if (glActiveTextureArb) // Can do MultiTexturing
{
glActiveTextureArb(GL_TEXTURE1_ARB);
if (num_multi>=0 && num>=0) // Set both? Enable 2nd texture
{
#ifdef _DEBUG
m_Texture3D_id_for_chanel[1]=num;
#endif
if(pTextures)
{
glBindTexture(GL_TEXTURE_2D, pTextures[num]);
}
else
{
glBindTexture(GL_TEXTURE_2D, this->m_Texture[num].mipstate[usemipmapping]);
}
glEnable(GL_TEXTURE_2D);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
}
else
{
#ifdef _DEBUG
m_Texture3D_id_for_chanel[1]=-1;
#endif
//			glBindTexture(GL_TEXTURE_2D, 1);
glDisable(GL_TEXTURE_2D);
}

glActiveTextureArb(GL_TEXTURE0_ARB);
if (num>=0) // Set image texture
{
if (num_multi>=0)
{
if(pTextures)
{
glBindTexture(GL_TEXTURE_2D, pTextures[num_multi]);
}
else
{
glBindTexture(GL_TEXTURE_2D, m_Texture[num_multi].mipstate[usemipmapping]);
}
#ifdef _DEBUG
m_Texture3D_id_for_chanel[0]=num_multi;
#endif
}
else
{
if(pTextures)
{
glBindTexture(GL_TEXTURE_2D, pTextures[num]);
}
else
{
glBindTexture(GL_TEXTURE_2D, m_Texture[num].mipstate[usemipmapping]);
}
#ifdef _DEBUG
m_Texture3D_id_for_chanel[0]=num;
#endif
}
glEnable(GL_TEXTURE_2D);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
}
else
{
#ifdef _DEBUG
m_Texture3D_id_for_chanel[0]=-1;
#endif
//			glBindTexture(GL_TEXTURE_2D, 1);
glDisable(GL_TEXTURE_2D);
}
// Active Texture = 0 (Std. Texture)
}
else // vanilla opengl
#endif
{
if (num>=0)
{
if(pTextures)
{
glBindTexture(GL_TEXTURE_2D, pTextures[num]);
}
else
{
glBindTexture(GL_TEXTURE_2D, m_Texture[num].mipstate[usemipmapping]);
}
glEnable(GL_TEXTURE_2D);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
}
else
{
glDisable(GL_TEXTURE_2D);
glbEnable(GL_COLOR_MATERIAL);
}
}
}
#endif


///////////////////////////////////////////////////////////////////
//            S P R I T E - O P E R A T I O N S
///////////////////////////////////////////////////////////////////

//---------------------------------------------------------------//
//---------------------------------------------------------------//
void OpenGLRainbows::DrawSprite(int num, int x, int y)
{
#if defined(TINYGL) || defined(TRENKI3D)
m_Sprite[num].Draw((int)x,(int)y);
#else
const GLR_TEXTURE& tex = this->m_Texture[num];
SetTexture3D(num, -1, 0);

ApplySmoothShading();
const float pos[] = {	
(float)(x+tex.bw), (float)y, (float)tex.txx, (float)tex.txy,
(float)x, (float)y, 0.0f, (float)tex.txy,
(float)x,(float)(y+tex.bh), 0.0f, 0.0f,
(float)(x+tex.bw), (float)(y+tex.bh), (float)tex.txx, 0.0f
};
DrawQuad(pos);
#endif
}


//---------------------------------------------------------------//
//---------------------------------------------------------------//
void OpenGLRainbows::StretchSprite(int num, int x, int y, int wx, int wy)
{
#if defined(TINYGL) || defined(TRENKI3D)
m_Sprite[num].Zoom((int)x,(int)y,(int)(x+wx), (int)(y+wy));
#else
static int	sx, sy;
const GLR_TEXTURE& tex = this->m_Texture[num];
sx=((wx+m_Texture[num].w)/2);
sy=((wy+m_Texture[num].h)/2);
SetTexture3D(num, -1, 0);

const float pos[] = {	(float)(x),    (float)(y+wy), 0.0f,    0.0f,
(float)(x+wx), (float)(y+wy), tex.txx, 0.0f,
(float)(x+wx), (float)(y),    tex.txx, tex.txy,
(float)(x),    (float)(y),    0.0f,    tex.txy};
ApplySmoothShading();
DrawQuad(pos);
#endif
}

//---------------------------------------------------------------//
void OpenGLRainbows::RotoSprite(int num, int x, int y, float angle, float scale)
//---------------------------------------------------------------//
{
#if defined(TINYGL) || defined(TRENKI3D)
static oBitmap bmp;
m_Sprite[num].CreateRotatation(angle, bmp);
if(scale==1.0f)
{
bmp.Draw((int)x - (bmp.m_Width-m_Sprite[num].m_Width)/2, (int)y - (bmp.m_Height-m_Sprite[num].m_Height)/2);
}
else
{
int xsize=(int)fabs(scale*bmp.m_Width );
int ysize=(int)fabs(scale*bmp.m_Height);

x-=(xsize-m_Sprite[num].m_Width)/2;
y-=(ysize-m_Sprite[num].m_Height)/2;
bmp.Zoom((int)x, (int)y, (int)x+(int)xsize, (int)y+(int)ysize);
}

#else

static float	sx, sy;
float txx, txy;
float t0x, t0y;
txx=((float)this->m_Texture[num].bw-.5f)/(float)this->m_Texture[num].w;
txy=((float)this->m_Texture[num].bh-.5f)/(float)this->m_Texture[num].h;
t0x = 0.5f/(float)m_Texture[num].w;
t0y = 0.5f/(float)m_Texture[num].h;

sx=scale*m_Texture[num].bw/2.0f;
sy=scale*m_Texture[num].bh/2.0f;
SetTexture3D(num, -1, 0);
glPushMatrix(); // Due to Rotation save the current matrix
glTranslatef((GLfloat)(x+(m_Texture[num].bw>>1)), (GLfloat)(y+(m_Texture[num].bh>>1)), 0); // Move to Origin of Sprite
glRotatef(angle, 0.0f, 0.0f, -1.0f); // Rotate around origin

float pos[] = {
-sx, sy, t0x, t0y,
sx,  sy, txx, t0y, 
sx, -sy, txx, txy,
-sx,-sy, t0x, txy
};
ApplySmoothShading();
DrawQuad(pos);
glPopMatrix(); // Restore the current matrix
#endif
}

//---------------------------------------------------------------//
// Set Tiling sizes for a texture
//---------------------------------------------------------------//
void OpenGLRainbows::TileSprite(int iSprite, int width, int height)
{
m_Texture[iSprite].tw = (short)width;
m_Texture[iSprite].th = (short)height;
}


//---------------------------------------------------------------//
// Draw a Tile from a tile texture
//---------------------------------------------------------------//
void OpenGLRainbows::DrawTile(int num, int iTile, int x, int y)
{
if(m_Texture[num].tw==0 || m_Texture[num].th==0) return;
int nperline = m_Texture[num].bw / m_Texture[num].tw;
int tilex, tiley=0;
if (nperline==0)
{
tilex = iTile;
}
else
{
tilex = iTile % nperline;
tiley = iTile / nperline;
}


#if defined(TINYGL) || defined(TRENKI3D)
int cx = tilex*m_Texture[num].tw, cy = tiley*m_Texture[num].th;
m_Sprite[num].DrawClip((int)x,(int)y, cx,cy, m_Texture[num].tw+cx, m_Texture[num].th+cy);
#else
// texture coord width/height for one tile
float onepix_w = 1.0f / (float)m_Texture[num].w;
float onepix_h = 1.0f / (float)m_Texture[num].h;

float txx, txy;
// width of a tile
txx=(float)m_Texture[num].tw/(float)m_Texture[num].w;
txy=(float)m_Texture[num].th/(float)m_Texture[num].h;

// pixel value of upper point
tiley = m_Texture[num].bh-m_Texture[num].th*(tiley+1);
// true texture coords
#if 0
float tx1 = 0.5f*onepix_w + txx*(float)tilex;
float ty1 = 0.5f*onepix_h + (float)tiley / m_Texture[num].h;
float tx2 = tx1+txx-onepix_w;
float ty2 = ty1+txy-onepix_h;
#else
float tx1 = txx*(float)tilex;
float ty1 = (float)tiley / m_Texture[num].h;
float tx2 = tx1+txx;
float ty2 = ty1+txy;
#endif

SetTexture3D(num, -1, 0);

ApplySmoothShading();
#if defined(HAVE_OPENGL)
glBegin(GL_QUADS);
glTexCoord2f(tx2, ty2); glVertex2i(x+m_Texture[num].tw, y);
glTexCoord2f(tx1, ty2); glVertex2i(x, y);
glTexCoord2f(tx1, ty1); glVertex2i(x,y+m_Texture[num].th);
glTexCoord2f(tx2, ty1); glVertex2i(x+m_Texture[num].tw, y+m_Texture[num].th);
glEnd();
#endif

#if defined(HAVE_OPENGL_ES)
float xyuv[] ={	(float)(x+m_Texture[num].tw), (float)y,                     (float)tx2, (float)ty2,
(float)x, (float)y,                                         (float)tx1, (float)ty2,
(float)x, (float)(y+m_Texture[num].th),                     (float)tx1, (float)ty1,
(float)(x+m_Texture[num].tw), (float)(y+m_Texture[num].th), (float)tx2, (float)ty1};
DrawQuad(xyuv);

#endif

#endif
}


//---------------------------------------------------------------//
// Rotozoom a tile
//---------------------------------------------------------------//
void OpenGLRainbows::RotoZoomTile(int num, int iTile, int x, int y, float phi, float scale)
{
if(m_Texture[num].tw==0 || m_Texture[num].th==0) return;

int nperline = m_Texture[num].bw / m_Texture[num].tw;
int tilex, tiley=0;
if (nperline==0)
{
tilex = iTile;
}
else
{
tilex = iTile % nperline;
tiley = iTile / nperline;
}
// texture coord width/height for one tile
float onepix_w = 1.0f / (float)m_Texture[num].w;
float onepix_h = 1.0f / (float)m_Texture[num].h;

float txx, txy;
// width of a tile
txx=(float)m_Texture[num].tw/(float)m_Texture[num].w;
txy=(float)m_Texture[num].th/(float)m_Texture[num].h;

// pixel value of upper point
tiley = m_Texture[num].bh-m_Texture[num].th*(tiley+1);
// true texture coords

#if 1
// I had that uncommented, but it seems to work really nice with a 67x18 bmp, 16x16 tiled.
// Same for 15x15 tiled. Smooth shading true or false.
// Only if you scale 1x and no rotation, it looks "blurry". (smoothshading FALSE helps, though)
float tx1 = 0.5f*onepix_w + txx*(float)tilex;
float ty1 = 0.5f*onepix_h + (float)tiley / m_Texture[num].h;
float tx2 = tx1+txx-onepix_w;
float ty2 = ty1+txy-onepix_h;
#else
float tx1 = txx*(float)tilex;
float ty1 = (float)tiley / m_Texture[num].h;
float tx2 = tx1+txx;
float ty2 = ty1+txy;
#endif



float sphi,cphi;
float dx,dy;

scale*=0.5f; // half width

dx=m_Texture[num].tw*scale;
dy=m_Texture[num].th*scale;
x+=(m_Texture[num].tw/2);
y+=(m_Texture[num].th/2);

sphi = sinf(phi * BOG_INV_F);
cphi = cosf(phi * BOG_INV_F);

SetTexture3D(num, -1, 0);
float xyuv[] ={
((float)x- cphi*dx-sphi*dy), ((float)y-cphi*dy+sphi*dx), tx1,ty2,
((float)x- cphi*dx+sphi*dy), ((float)y+cphi*dy+sphi*dx), tx1,ty1,
((float)x+ cphi*dx+sphi*dy), ((float)y+cphi*dy-sphi*dx), tx2,ty1,
((float)x+ cphi*dx-sphi*dy), ((float)y-cphi*dy-sphi*dx), tx2,ty2};

#ifdef TRENKI3D
// void tglDrawArraysXYZ_UV_RGBA(const int type, const int count, const float* pData, const int hasZ, const int hasNormal, const int UseUV, const int UseRGBA, const int hasRGBA);
tglDrawArraysXYZ_UV_RGBA(GL_TRIANGLE_FAN, 4, xyuv,                                0,              0,                   1,               0,                 0);
#elif defined(TINYGL)

#else
ApplySmoothShading();
DrawQuad(xyuv);
#endif
}

void OpenGLRainbows::StretchTile(int num, int iTile, int x, int y, int w, int h)
{
if(m_Texture[num].tw==0 || m_Texture[num].th==0) return;

int nperline = m_Texture[num].bw / m_Texture[num].tw;
int tilex, tiley=0;
if (nperline==0)
{
tilex = iTile;
}
else
{
tilex = iTile % nperline;
tiley = iTile / nperline;
}
// texture coord width/height for one tile
float txx, txy;
txx=(float)m_Texture[num].tw/(float)(m_Texture[num].w);
txy=(float)m_Texture[num].th/(float)(m_Texture[num].h);
// pixel value of upper point
tiley = m_Texture[num].bh-m_Texture[num].th*(tiley+1);
// true texture coords
float ty1 = (float)tiley / m_Texture[num].h;
float tx1 = txx*(float)tilex;
float tx2 = tx1+txx;
float ty2 = ty1+txy;

float fx=(float)x;
float fy=(float)y;
float fh=(float)h;
float fw=(float)w;

float xyuv[] ={
fx      ,  fy       , tx1,ty2,
fx      ,  fy+fh+.1f, tx1,ty1,
fx+fw+.1f, fy+fh+.1f, tx2,ty1,
fx+fw+.1f, fy       , tx2,ty2
};
SetTexture3D(num, -1, 0);
#ifdef TRENKI3D
// void tglDrawArraysXYZ_UV_RGBA(const int type, const int count, const float* pData, const int hasZ, const int hasNormal, const int UseUV, const int UseRGBA, const int hasRGBA);
tglDrawArraysXYZ_UV_RGBA(GL_TRIANGLE_FAN, 4, xyuv, 0, 0, 1, 0, 0);
#elif defined(TINYGL)

#else
ApplySmoothShading();
DrawQuad(xyuv);
#endif
}


//---------------------------------------------------------------//
// return the viewport with respect to rotations
//---------------------------------------------------------------//
const int* OpenGLRainbows::RotatedViewport() const
{
static int vp[4];
vp[0]=m_WND.viewport.x;
vp[1]=m_WND.viewport.y;
vp[2]=m_WND.viewport.width;
vp[3]=m_WND.viewport.height;
return vp;
}


//---------------------------------------------------------------//
// Draw 3D Text with constant height and z-buffer
//---------------------------------------------------------------//
void OpenGLRainbows::Text3D(int nFont, const char* szText, float x, float y, float z, float scale, int kerning)
{
#ifndef TRENKI3D
static float winx, winy, winz;

//static int viewport[4];
static float in[4], out[4];
bool culling = false;
bool lighting=false;

if(glIsEnabled(GL_CULL_FACE))
{
culling = true;
glbDisable(GL_CULL_FACE);
}
if(glIsEnabled(GL_LIGHTING))
{
lighting=true;
glbDisable(GL_LIGHTING);
}
// first load the matrices for the project call.
// glGetFloatv( GL_MODELVIEW_MATRIX,  model);
const float* model = m_pRbow3D->m_ModelViewCameraMatrix;

// Font stays constant size - good readability
if(scale == 0.0f)
{
// glGetFloatv  ( GL_PROJECTION_MATRIX, proj );
const float* proj = m_pRbow3D->m_ProjectionMatrix;
//glGetIntegerv( GL_VIEWPORT,         viewport );
const int* viewport = RotatedViewport();

in[0]=x; in[1]=y; in[2]=z; in[3]=1.0;

transform_point(out,model,in);
transform_point(in,proj,out);

if (in[3]==0.0f) return;

// Normalize between -1 and 1 :
in[0]/=in[3];in[1]/=in[3];in[2]/=in[3];

// In screen coordinates :
winx = viewport[0]+(1+in[0])*viewport[2]/2;
winy = viewport[3] - (viewport[1]+(1+in[1])*viewport[3]/2); // GLBasic origin = top, (+) goes down
winz = -in[2]; // [-1; +1]

//		glViewport(m_WND.viewport.x, m_WND.height-m_WND.viewport.height-m_WND.viewport.y, m_WND.viewport.width, m_WND.viewport.height);
glMatrixMode(GL_PROJECTION);
glPushMatrix();
glLoadIdentity();
glOrtho(0.0f, (float)m_WND.viewport.width, (float)m_WND.viewport.height, 0.0f, -1.0f, 1.0f); // Move to upper left corner 0,0

glMatrixMode(GL_MODELVIEW);
glPushMatrix();
glLoadIdentity();

// alignment = bottom center
float len = (float)strlen(szText);
Text2D(nFont, szText,	winx-(float)(m_Texture[(GLR_MAX_TEXTURES - GLR_MAX_FONT)].bw>>4)*len*.5f-viewport[0],
winy-(float)(m_Texture[(GLR_MAX_TEXTURES - GLR_MAX_FONT)].bh>>3)+viewport[1],
winz, kerning, FALSE); //winx, winy, winz);
glMatrixMode(GL_PROJECTION);
glPopMatrix();	
glMatrixMode(GL_MODELVIEW);
glPopMatrix();
}
else // font will be scaled - billboard sprite
{
float up[3], right[3];
right[0] = model[0];
right[1] = model[4];
right[2] = model[8];

up[0] = model[1];
up[1] = model[5];
up[2] = model[9];
float		tx, ty, txs, tys, cx, cy;
unsigned int		asc;

nFont = nFont + GLR_MAX_TEXTURES - GLR_MAX_FONT;
SetTexture3D(nFont, -1, 0);

int			charset=128, yoff=7;

txs= (m_Texture[nFont].txx) / 16.0f;
cx = (float)(m_Texture[nFont].bw>>4);
if(m_Texture[nFont].bw<m_Texture[nFont].bh)
{
yoff=15;
charset=256; // FONT_CHARSET
tys= (m_Texture[nFont].txy) / 16.0f;
cy = (float)(m_Texture[nFont].bh>>4);
}
else
{
tys= (m_Texture[nFont].txy) /  8.0f;
cy = (float)(m_Texture[nFont].bh>>3);
}
gMultVertex(up, cx*scale);
// gMultVertex(right, scale); // *cx or pixels for kering
// 4 3
// 1 2
float p1[3], p2[3], p3[3], p4[3];


p1[0] = x; p1[1]=y; p1[2]=z;
// alignment: bottom center
unsigned int str_l = (unsigned int)strlen(szText);

#if defined(HAVE_OPENGL_ES) // quick workaround - dirty!
m_VertexArray.SetSize(4);
#else
m_VertexArray.SetSize(str_l*4);
#endif
OpenGLRainbows::VERTEX* pV = &m_VertexArray[0];

// 3D
if(kerning)
{
const GLR_FONTKERNING* pKern = m_FontKerning[nFont];
gMultVertex(right, scale); // * pixels for kering
gAddVertex(p1, up);
float len = 0.0f;
for(unsigned int i=0; i<str_l; ++i)
len += (float) (pKern[(unsigned int)(szText[i]%charset) ].width);
len *= 0.5f; // str_l/2.0f;
p1[0]-=(len*right[0]);
p1[1]-=(len*right[1]);
p1[2]-=(len*right[2]);

// calc p2,p3,p4
gSubVertex(p1, up); gCopyVertex(p2, p1); gAddVertex(p2, right); gCopyVertex(p3, p2);
gAddVertex(p3, up); gDiffVertex(p4, p3, right);
// 4 3
// 1 2
for (int i=0; szText[i]!='\0'; i++)
{
asc=(unsigned)szText[i]%charset;	// Ignore Extended AscII Format - It's Just Shit like 
const GLR_FONTKERNING& K = pKern[asc];
tx = (asc%16)*txs;
ty = tys * (yoff - (asc/16));

gCopyVertex(p3,p4);
gCopyVertex(p2,p1);
// use "up" as a temp for right*width
gCopyVertex(up, right);
gMultVertex(up, K.width);
gAddVertex(p3, up);
gAddVertex(p2, up);
// Top left
(pV++)->assign(p4, K.txa, ty+tys);
// Bottom left
(pV++)->assign(p1, K.txa, ty);
// Top right
(pV++)->assign(p3, K.txe, ty+tys);
// Bottom right
(pV++)->assign(p2, K.txe, ty);

// Destination
gCopyVertex(p1, p2);
gCopyVertex(p4, p3);
}
}
else
{
gMultVertex(right, cx*scale); // prepare right vector with fixed font size
gAddVertex(p1, up);
float len = (float)str_l/2.0f;
p1[0]-=(len*right[0]);
p1[1]-=(len*right[1]);
p1[2]-=(len*right[2]);

// calc p2,p3,p4
gSubVertex(p1, up); gCopyVertex(p2, p1); gAddVertex(p2, right); gCopyVertex(p3, p2);
gAddVertex(p3, up); gDiffVertex(p4, p3, right);
for (int i=0; szText[i]!='\0'; i++)
{
asc=(unsigned)szText[i]%charset;	// Ignore Extended AscII Format - It's Just Shit like 
tx = (asc%16)*txs;
ty = tys * (yoff - (asc/16));

// Top left
(pV++)->assign(p4, tx, ty+tys);
// Bottom left
(pV++)->assign(p1, tx, ty);
// Top right
(pV++)->assign(p3, tx+txs, ty+tys);
// Bottom right
(pV++)->assign(p2, tx+txs, ty);

// Destination
gAddVertex(p1, right);
gAddVertex(p2, right);
gAddVertex(p3, right);
gAddVertex(p4, right);
}
}
DrawVertexArray(GL_TRIANGLE_STRIP);
}
if(culling) glbEnable(GL_CULL_FACE);
if(lighting) glbEnable(GL_LIGHTING);
#endif
}

//---------------------------------------------------------------//
// Draw a billboard sprite
//---------------------------------------------------------------//
void OpenGLRainbows::DrawBillboard(int num, float x, float y, float z, float scale)
{
#ifndef TRENKI3D
float up[3], right[3], normal[3], modelview[16], a[3], b[3], c[3], d[3], center[3];
// #NEED Get face culling and set to 1 - fixed in glb3d.cpp
glGetFloatv(GL_MODELVIEW_MATRIX, modelview);

right[0] = modelview[0];
right[1] = modelview[4];
right[2] = modelview[8];

up[0] = modelview[1];
up[1] = modelview[5];
up[2] = modelview[9];

normal[0] = modelview[ 2];
normal[1] = modelview[ 6];
normal[2] = modelview[10];

glNormal3fv(normal);

center[0]=x; center[1]=y; center[2]=z;

/*
d-----c
|     |
a--c--b
e
nter
*/
float bx, by;
bx = scale * (m_Texture[num].bw >> 2);
by = scale * (m_Texture[num].bh >> 1);
for (char n=0; n<3; n++)
{
a[n] = center[n] - right[n] * bx;
b[n] = center[n] + right[n] * bx;
c[n] = center[n] + right[n] * bx + up[n] * by;
d[n] = center[n] - right[n] * bx + up[n] * by;
}

float txx, txy;
float pxo, pyo;
pxo = 1.0f/(float)this->m_Texture[num].w;
pyo = 1.0f/(float)this->m_Texture[num].h;
txx=((float)this->m_Texture[num].bw-.5f)*pxo;
txy=((float)this->m_Texture[num].bh-.5f)*pyo;
pxo=0;//*=0.55f;
pyo=0;//*=0.55f;

SetTexture3D(num, -1, 0);

m_VertexArray.SetSize(4);
OpenGLRainbows::VERTEX* pV = &m_VertexArray[0];
(pV++)->assign(a, pxo,pyo);
(pV++)->assign(b, txx,pyo);
(pV++)->assign(c, txx,txy);
(pV++)->assign(d, pxo,txy);

glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
DrawVertexArray(GL_TRIANGLE_FAN);
#endif
}


//---------------------------------------------------------------//
// width with kerning
//---------------------------------------------------------------//
int  OpenGLRainbows::Text2DWidth(int num_font, const char* text, int kerning)
{
int width=0;
if(kerning)
{
const GLR_FONTKERNING* pKern = m_FontKerning[num_font];
for (int i=0; ; ++i)
{
unsigned char asc=((unsigned char)text[i]);
if (asc==0) break;
const GLR_FONTKERNING& K = pKern[asc];
width+=K.width;
}
return (int)(width * m_FontScaling[num_font]);
}
else
{
const GLR_TEXTURE& txtr = m_Texture[num_font + GLR_MAX_TEXTURES - GLR_MAX_FONT];
return (int)( (strlen(text) * (txtr.bw>>4)) * m_FontScaling[num_font]);
}
}


//---------------------------------------------------------------//
// Draw text in 2D mode
//---------------------------------------------------------------//
void OpenGLRainbows::Text2D(int num_font, const char* text, float x, float y, float z, int kerning, int apply_scaling)
{
#if defined(TINYGL) || defined(TRENKI3D)
const GLR_FONTKERNING* pKern = m_FontKerning[num_font];
m_Font[num_font].Print(text, (int)x,(int)y, kerning ? pKern:NULL);
#else
unsigned int str_l = (unsigned int) strlen(text);
if(!str_l) return;
m_VertexArray.SetSize(str_l*4);
OpenGLRainbows::VERTEX* pV = &m_VertexArray[0];

float		tx, ty, txs, tys;
int			i;
float		cx, cy; // char width + height (no kerning)
unsigned int asc;
int			charset=128, yoff=7;
int num_texture = num_font + GLR_MAX_TEXTURES - GLR_MAX_FONT;
SetTexture3D(num_texture, -1, 0);


const GLR_TEXTURE& txtr = m_Texture[num_texture];

txs= (txtr.txx) / 16.0f;
cx = (float)(txtr.bw>>4);
if(txtr.bw<txtr.bh)
{
yoff=15;
charset=256; // FONT_CHARSET
tys= (txtr.txy) / 16.0f;
cy = (float)(txtr.bh>>4);
}
else
{
tys= (txtr.txy) /  8.0f;
cy = (float)(txtr.bh>>3);
}

x = ceilf(x);
y = ceilf(y);

float fscale = 1.0;
if(apply_scaling)
{
fscale = m_FontScaling[num_font];
cx*=fscale;
cy*=fscale;
}


if(kerning)
{
const GLR_FONTKERNING* pKern = m_FontKerning[num_font];
for (i=0; ; ++i)
{
asc=((unsigned)text[i]%charset);
if (asc==0) break;
ty = tys * (yoff - (asc/16));
const GLR_FONTKERNING& K = pKern[asc];

float kw = (float)K.width * fscale;

// Top left
(pV++)->assign(x,    y+cy, z,    K.txa,     ty);
// Bottom left			      
(pV++)->assign(x,    y,    z,    K.txa,     ty+tys);
// Top right					      
(pV++)->assign(x+kw, y+cy, z,    K.txe, ty);
// Bottom right					      
(pV++)->assign(x+kw, y,    z,    K.txe, ty+tys);

// Destination
x += kw; // no additional space here!! would need a new poly group
}
}
else
{
for (i=0; ; ++i)
{
asc=((unsigned)text[i]%charset);
if (asc==0) break;
tx = txs * (asc%16);
ty = tys * (yoff - (asc/16));
// Top left
(pV++)->assign(x,    y+cy, z,tx,     ty);
// Bottom left
(pV++)->assign(x,    y,    z,tx,     ty+tys);
// Top right
(pV++)->assign(x+cx, y+cy, z,tx+txs, ty);
// Bottom right
(pV++)->assign(x+cx, y,    z,tx+txs, ty+tys);


// Destination
x+=cx;
}
}
DrawVertexArray(GL_TRIANGLE_STRIP);
#endif
}


///////////////////////////////////////////////////////////////////
//             P A S T E   S U R F A C E S
///////////////////////////////////////////////////////////////////

//---------------------------------------------------------------//
//---------------------------------------------------------------//
void OpenGLRainbows::PasteSurface(int num)
{
#if defined(TINYGL) || defined(TRENKI3D)
m_Surface[num].Draw(0,0);
#else
#ifdef GLB_SURFACE_OLDSCHOOL
if(m_Surface[num].usex == 0) return;

float	sx=0, sy;
int		y;


// GF_TODO the prescaler is not taken care of, yet
DoAlpha(0.0); // disable blending
SetAlphaTesting(); // no cookie
glbDisable(GL_ALPHA_TEST); // No Cookie
glbDisable(GL_BLEND); // No blend

// Multi Texturing allowed? Disable Texture 1 and Use Texture 0
#if defined(HAVE_OPENGL)
if (glActiveTextureArb)
{
glActiveTextureArb(GL_TEXTURE1_ARB);
glDisable(GL_TEXTURE_2D);

glActiveTextureArb(GL_TEXTURE0_ARB);
}
#endif
glEnable(GL_TEXTURE_2D);

g_nTexture = 0; // otherwise DrawQuad fails
for (int x=0; x<m_Surface[num].usex; x++)
{
sy=0; //(float)this->m_Surface[num].sizy[0][0]; // 0-...
for (y=0; y<m_Surface[num].usey; y++)
{
glBindTexture(GL_TEXTURE_2D, m_Surface[num].txt[x][y]);

// hard interpolation
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

float txx, txy;
txx=(float)m_Surface[num].sizbx[x][y]/(float)m_Surface[num].sizx[x][y];
txy=(float)m_Surface[num].sizby[x][y]/(float)m_Surface[num].sizy[x][y];
float xyuv[] = {sx, sy+m_Surface[num].sizby[x][y],                           0.0f, 0.0f,
sx+m_Surface[num].sizbx[x][y], sy+m_Surface[num].sizby[x][y], txx, 0.0f,
sx+m_Surface[num].sizbx[x][y], sy,                            txx, txy ,
sx, sy,                                                      0.0f, txy  };
DrawQuad(xyuv);
sy+=m_Surface[num].sizy[x][y+1];
}
sx+=m_Surface[num].sizx[x][y-1];
}
SetTexture3D(-1, -1, 0);
ApplySmoothShading(); // restore old state

DoAlpha(0.0f); // might enable blending if no cookie

// glbEnable(GL_ALPHA_TEST);
#else // just use a sprite
if(__g_Prescaler.scale> 1.0f)
{
// clear, because stuff outside the viewport might flicker.
// GF_TODO how can you draw outside the viewport!?!?! Must fix that!
#if defined(TINYGL) || defined(TRENKI3D)
Screen.Clear();
#else // GL or EGL
glClear(GL_COLOR_BUFFER_BIT);
#endif
}

DrawSprite(m_BackSurfaceSpriteID[num], 0,0);
#endif
#endif
}

// --------------------------------------------------------------- //
// Set Cookie Colors
// --------------------------------------------------------------- //
void OpenGLRainbows::SetColorKey(COLORREF col)
{
m_CookieFont = m_CookieColor = col;
}



// --------------------------------------------------------------- //
// Load Font
// --------------------------------------------------------------- //
bool OpenGLRainbows::LoadFont(int num, const char* szFileName)
{
m_FontScaling[num] = 1.0f;

OPENGL_IMAGE image;
if(!image.LoadImageBMP(szFileName, m_CookieFont) && !image.LoadImagePNG(szFileName, m_CookieFont))
{
// not for fonts
// if(!img.m_bSourceHadAlpha) img.FixNeighbourAlpha();

#if defined(TINYGL) || defined(TRENKI3D)
m_Font[num].Delete();
#else
FreeSprite(num+GLR_MAX_TEXTURES-GLR_MAX_FONT);
#endif
return false;
}


// Create 2^n size
int sx=GLB_MIN_TEX_SIZE/2; int sy=GLB_MIN_TEX_SIZE/2;
do{sx<<=1;} while(sx < image.m_sizex);
do{sy<<=1;} while(sy < image.m_sizey);
float txw=(float)sx, txh=(float)sy; // texture dimensions


// build kerning table
int charset=128;
int cy, cx = image.m_sizex >> 4;
if(image.m_sizex < image.m_sizey)// FONT_CHARSET
{
charset=256; // FONT_CHARSET
cy = image.m_sizey >> 4;
}
else
{
cy = image.m_sizey >> 3;
}


for(int ic = 0; ic<charset; ++ic)
{
int xoff=0, width=0;
int x = ic % 16;
int y = ic / 16;
GLR_FONTKERNING& K = m_FontKerning[num][ic];

K.width = 0;
K.xoff  = 0;
for(int px=0; px<cx; ++px)
for(int py=0; py<cy; ++py)
{
int alpha = image[(x*cx + px + (y*cy+py)*image.m_sizex)*4 + 3];
if(alpha>0)
{
xoff = px;
goto rightnow;
}
}
rightnow:
for(int px=cx-1; px>=xoff; --px)
for(int py=0; py<cy; ++py)
{
int alpha = image[(x*cx + px + (y*cy+py)*image.m_sizex)*4 + 3];
if(alpha>0)
{
width = px - xoff + 1;
goto stopnow;
}
}
stopnow:

/*
printf("\n\nCharacter: %d[%c].\nxoff=%d width=%d\n", ic, ic, xoff, width);
for(int py=0; py<cy; ++py)
{
for(int px=0; px<cx; ++px)
{
int alpha = image[(x*cx + px + (y*cy+py)*image.m_sizex)*4 + 3];
printf("%c", alpha ? '#':' ');

}
printf("\n");
}
*/

if(width<=0)
{
K.xoff =0;
K.width=cx;
}
else
{
if(width+xoff < cx) ++width; // nice - we have one pixel for spacing available
K.xoff =xoff;
K.width=width;
}
K.txa = (float)(xoff       + x*cx) / txw;
K.txe = (float)(xoff+width + x*cx) / txw;

// fix space - make width of "j"
if (ic == (int)'j')
{
GLR_FONTKERNING& spc = m_FontKerning[num][32];

spc.width = K.width;
spc.txa = 0.0f;
spc.txe = K.txe - K.txa;
}

if(charset<256)
{
m_FontKerning[num][ic+128] = K;
}
}

#if defined(TINYGL) || defined(TRENKI3D)
return m_Font[num].CreateBy(image);
#else
return LoadSprite(num+GLR_MAX_TEXTURES-GLR_MAX_FONT, image, m_CookieFont, false); // Load a Texture as a Sprite
#endif
}


// --------------------------------------------------------------- //
// Load Sprite from file
// --------------------------------------------------------------- //
bool OpenGLRainbows::LoadSprite(int num, const char* szFileName, COLORREF colorkey, bool IsBumpHeightmap)
{
int inscreen = -1;
for(int i=0; i<GLR_MAX_FRAMEBUFFER; ++i)
{
if(m_FBuffer[i].m_SpriteIndex == num)
{
inscreen = i; break;
}
}

FreeSprite(num);
if(szFileName==NULL || szFileName[0]=='\0')
return false;

OPENGL_IMAGE image;
if(!image.LoadImageBMP(szFileName, colorkey) && !image.LoadImagePNG(szFileName, colorkey) && !image.LoadImageJPG(szFileName))
{
return false;
}
if(!image.m_bSourceHadAlpha)
image.FixNeighbourAlpha();
bool ok = LoadSprite(num, image, colorkey, IsBumpHeightmap); // Load a Texture as a Sprite

if(ok && inscreen>=0)
{
if(m_FBuffer[inscreen].Create(m_Texture[num].w, m_Texture[num].h, m_Texture[num].mipstate[0], true))
m_FBuffer[inscreen].m_SpriteIndex = num;
}
return ok;
}

// --------------------------------------------------------------- //
// Load Sprite from memory
// --------------------------------------------------------------- //
bool OpenGLRainbows::LoadSprite(int num, OPENGL_IMAGE& image, COLORREF colorkey, bool IsBumpHeightmap) // Load a Texture as a Sprite
{
int inscreen = -1;
for(int i=0; i<GLR_MAX_FRAMEBUFFER; ++i)
{
if(m_FBuffer[i].m_SpriteIndex == num)
{
inscreen = i; break;
}
}

FreeSprite(num);
if (image.m_sizex==0 || image.m_sizey==0) return false;

#if defined(TINYGL) || defined(TRENKI3D)
if(!m_Sprite[num].CreateBy(image, colorkey))
return false;
this->m_Texture[num].w =(short)image.m_sizex;
this->m_Texture[num].h =(short)image.m_sizey;
this->m_Texture[num].bw=(short)image.m_sizex;
this->m_Texture[num].bh=(short)image.m_sizey;

this->m_Texture[num].txx=1.0f;
this->m_Texture[num].txy=1.0f;
return true;
#else

int		sx, sy;
// Create 2^n size - MUST EQUAL TO MakeTexture!!
sx=GLB_MIN_TEX_SIZE/2; sy=GLB_MIN_TEX_SIZE/2;
do{sx<<=1;} while(sx < image.m_sizex);
do{sy<<=1;} while(sy < image.m_sizey);

// file, startx, starty, sizex, sizey, &num
// #NPBUFFER
bool ok = true;
if(num>=GLR_MAX_TEXTURES-GLR_MAX_FONT) // is font
ok = MakeTexture(image, 0, 0, 0, 0, &m_Texture[num].mipstate[0], NULL, false, true);
else
ok = MakeTexture(image, 0, 0, 0, 0, &m_Texture[num].mipstate[0], &m_Texture[num].mipstate[1], IsBumpHeightmap, false);

m_Texture[num].w=sx; // Set Size of Texture
m_Texture[num].h=sy;
m_Texture[num].bw=image.m_sizex; // Set Size of BMP File
m_Texture[num].bh=image.m_sizey;
m_Texture[num].txx=(float)m_Texture[num].bw/m_Texture[num].w;
m_Texture[num].txy=(float)m_Texture[num].bh/m_Texture[num].h;
if(!ok) FreeSprite(num);

if(ok && inscreen>=0)
{
if(m_FBuffer[inscreen].Create(m_Texture[num].w, m_Texture[num].h, m_Texture[num].mipstate[0], true))
m_FBuffer[inscreen].m_SpriteIndex = num;
}
return ok;


return ok;
#endif
}


#if defined(HAVE_OPENGL)
// --------------------------------------------------------------- //
// Create a normal map from a grayscale image
// --------------------------------------------------------------- //
void build_detail_normalmap(OPENGL_IMAGE& image)
{
OPENGL_IMAGE out;
out.resize(image.m_sizex, image.m_sizey);
int x, y;
float dX, dY, nX, nY, nZ, len;

for(y=0;y<image.m_sizey;y++)
{
for(x=0;x<image.m_sizey;x++)
{
dY =((float)image[4*(((y+1)%image.m_sizey)*image.m_sizex+((x-1+image.m_sizex)%image.m_sizex))+2])/255.0f*-1.0f;
dY+=((float)image[4*(((y+1)%image.m_sizey)*image.m_sizex+x%image.m_sizex)+2])/255.0f*-2.0f;
dY+=((float)image[4*(((y+1)%image.m_sizey)*image.m_sizex+((x+1)%image.m_sizex))+2])/255.0f*-1.0f;
dY+=((float)image[4*(((y-1+image.m_sizey)%image.m_sizey)*image.m_sizex+((x-1+image.m_sizex)%image.m_sizex))+2])/255.0f*1.0f;
dY+=((float)image[4*(((y-1+image.m_sizey)%image.m_sizey)*image.m_sizex+(x%image.m_sizex))+2])/255.0f*2.0f;
dY+=((float)image[4*(((y-1+image.m_sizey)%image.m_sizey)*image.m_sizex+((x+1)%image.m_sizex))+2])/255.0f*1.0f;

dX =((float)image[4*(((y-1+image.m_sizey)%image.m_sizey)*image.m_sizex+((x-1+image.m_sizex)%image.m_sizex))+2])/255.0f*-1.0f;
dX+=((float)image[4*((y%image.m_sizey)*image.m_sizex+((x-1+image.m_sizex)%image.m_sizex))+2])/255.0f*-2.0f;
dX+=((float)image[4*(((y+1)%image.m_sizey)*image.m_sizex+((x-1+image.m_sizex)%image.m_sizex))+2])/255.0f*-1.0f;
dX+=((float)image[4*(((y-1+image.m_sizey)%image.m_sizey)*image.m_sizex+((x+1)%image.m_sizex))+2])/255.0f*1.0f;
dX+=((float)image[4*((y%image.m_sizey)*image.m_sizex+((x+1)%image.m_sizex))+2])/255.0f*2.0f;
dX+=((float)image[4*(((y+1)%image.m_sizey)*image.m_sizex+((x+1)%image.m_sizex))+2])/255.0f*1.0f;

nX=-dX;
nY=-dY;
nZ=1;

len=1.0f/((float)sqrt((nX*nX)+(nY*nY)+(nZ*nZ)));
nX*=len;
nY*=len;
nZ*=len;

out[4*(y*image.m_sizex+x)+3]=image[4*(y*image.m_sizex+x)+3];
out[4*(y*image.m_sizex+x)  ]=(unsigned char)((nX+1.0f)/2.0f*255.0f);
out[4*(y*image.m_sizex+x)+1]=(unsigned char)((nY+1.0f)/2.0f*255.0f);
out[4*(y*image.m_sizex+x)+2]=(unsigned char)((nZ+1.0f)/2.0f*255.0f);
}
}
//    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, dataout);
// now swap pointers
unsigned char* pS = image.m_txdata;
image.m_txdata = out.m_txdata;
out.m_txdata = pS;
// memcpy(datain, dataout, width*height*4);
}
#endif


///////////////////////////////////////////////////////////////////////////////
// OPENGL_IMAGE - functions
///////////////////////////////////////////////////////////////////////////////

// Make a small font (5x6 px) -> 16x8 chars
void OPENGL_IMAGE::MakeDefFont()
{
OPENGL_IMAGE& img = *this;
// 5x6 font ;)
static unsigned int tmap[6][16] = {
0x00000000, 0x08021080, 0x00002940, 0x15f57d40, 0x08e619c4, 0x14222140, 0x0ed114e0, 0x00001080, 0x08210880, 0x04421040, 0x09575480, 0x08471080, 0x04400000, 0x00070000, 0x08000000, 0x04222100, 
0x00e5294e, 0x004210c4, 0x00e1390e, 0x00e4390e, 0x0084394a, 0x00e4384e, 0x00e5384e, 0x0042210e, 0x00e5394e, 0x00e4394e, 0x00020080, 0x00220080, 0x00820888, 0x000701c0, 0x00222082, 0x0040310e, 
0x00e0b526, 0x00a5394e, 0x00e5194e, 0x00e5094e, 0x00e52946, 0x00e1384e, 0x0021384e, 0x00e5284e, 0x00a5394a, 0x00e2108e, 0x00e5210c, 0x00a5194a, 0x00e10842, 0x015ad6bf, 0x00a5294e, 0x00e5294e, 
0x0021394e, 0x00f294a7, 0x00a5194e, 0x00e4384e, 0x0042108e, 0x00e5294a, 0x0045294a, 0x01fad6b5, 0x00a5114a, 0x0042394a, 0x00e1110e, 0x00610846, 0x01041041, 0x00621086, 0x00000144, 0x00e00000, 
0x00000082, 0x00e53000, 0x00e53842, 0x00e13800, 0x00e53908, 0x08273800, 0x00423888, 0x08873800, 0x00a51842, 0x00421004, 0x04421004, 0x00a32842, 0x00421084, 0x015abc00, 0x00a51800, 0x00e53800, 
0x04e51800, 0x10e53000, 0x00253800, 0x00e409c0, 0x00c23884, 0x00c52800, 0x00452800, 0x00ead400, 0x00a22800, 0x1c872800, 0x00e121c0, 0x00821888, 0x00421084, 0x00223082, 0x0002a800, 0x3f18c63f, 
};

img.resize(128,64);
for(unsigned int cx=0; cx<16; ++cx)
{
for(unsigned int cy=0; cy<6; ++cy)
{
for(unsigned int x=0; x<7; ++x)
{
for(unsigned int y=0; y<8; ++y)
{
// RGBA
#define PIXP(px, py) ( ((px)+cx*8 + ((cy+2)*8+(py))*128) *4 )     // ( ((px)+cx*7)*4 + (47+ (cy*8+(py)))*128*4 )
#define WHITE(px, py) {int pp = PIXP(px,py); img[pp++]=255; img[pp++]=255; img[pp++]=255; img[pp]=255;}
#define BLACK(px, py) {int pp = PIXP(px,py); img[pp++]=8; img[pp++]=8; img[pp++]=8; img[pp]=255;}
#define IS_SET(px, py) ( (px<1 || px>5 || py<1 || py>6) ? 0 : (tmap[cy][cx] & (1<<((px)+5*(py) -5-1   ))) )

if(IS_SET(x,y))
{
WHITE(x,y);
}
else
{
if     (x<7 && IS_SET(x+1,y) ) {BLACK(x,y);}
else if(x>0 && IS_SET(x-1,y) ) {BLACK(x,y);}
else if(y>0 && IS_SET(x,y-1) ) {BLACK(x,y);}
else if(y<7 && IS_SET(x,y+1) ) {BLACK(x,y);}
}
#undef PIXP
#undef WHITE
#undef BLACK
#undef SET
}
}
}
}
}

// scale by 2x2
void OPENGL_IMAGE::ScaleX2()
{
OPENGL_IMAGE img;
img.resize(m_sizex*2, m_sizey*2);
unsigned int* pSrc = (unsigned int*)m_txdata;
unsigned int* pDst = (unsigned int*)img.m_txdata;
for(int line=0; line<m_sizey; ++line)
{
for(int src=0; src<m_sizex; ++src)
{
pDst[0] = *pSrc;
pDst[1] = *pSrc;
pDst[img.m_sizex  ] = *pSrc;
pDst[img.m_sizex+1] = *pSrc;
pDst+=2;
++pSrc;
}
pDst+=img.m_sizex;
}
*this = img;
}


// #ifndef POCKETPC
#if defined(HAS_PNG_LIB)
int gf_png_open(const char* szFileName, int* width, int* height, int* rowbytes, int* channels);
void gf_png_read(unsigned char* buffer, unsigned char** row_pointers);
void gf_png_close();
int gf_write_png(const char *file_name, const unsigned char* pixels32, int width, int height);
#endif

int gf_jpeg_read(const char* data, int len, int* pWidth, int* pHeight, int* pChannels, unsigned char** pRGB);
int gf_write_jpeg(const char *file_name, const unsigned char* pixels32, int width, int height);


bool OPENGL_IMAGE::LoadImageJPG(const char* szFileName)
{
unsigned char* pRGB=NULL;
int width=0, height=0, channels=0;
// GF: use GFFileSystem to be able to load from shoebox
GFFileSystem fs;
if(!fs.OpenIn(szFileName))
return false;

size_t filelen = (size_t)fs.GetSize();
char* buffer = new char[filelen+1]; buffer[0]='\0';
bool bReadOK =false;
bReadOK = fs.Read(buffer, filelen);

if(bReadOK)
bReadOK = (gf_jpeg_read(buffer, filelen, &width, &height, &channels, &pRGB)==0)?false:true;

if(!bReadOK)
{
if(pRGB) delete[] pRGB; // might return 0 after allocation
delete[] buffer;
return false;
}


switch(channels)
{
case 4:
case 3:
case 1:
break;
default:
g_debug("JPEG: Channels: %d not supported!\n", channels);
if(pRGB) delete[] pRGB;
return false;
}

// allocate the memory to hold the image using the fields of png_info.
OPENGL_IMAGE& image = *this;
image.resize(width, height);

if(channels != 4) // no alpha in image
image.m_bSourceHadAlpha = false;

unsigned char R=0,G=0,B=0,A=255;
for(int row = 0; row < height; row++)
{
unsigned char *ptr = pRGB + ( width*channels * row);
unsigned char* pdest = &image[row*image.m_sizex*4];
for(int x=0; x<width; x++)
{
switch(channels)
{
case 4:
R=ptr[0]; G=ptr[1]; B=ptr[2]; A=ptr[3]; break;
case 3:
R=ptr[0]; G=ptr[1]; B=ptr[2]; A=255; break;
case 1:
R=ptr[0]; G=ptr[0]; B=ptr[0]; A=255; break;
}

*pdest++ = R;
*pdest++ = G;
*pdest++ = B;
*pdest++ = A;

ptr += channels;
}
}
delete[] pRGB;
delete[] buffer;
return true;
}


/* read a png file.  You may want to return an error code if the read
fails (depending upon the failure). */
bool OPENGL_IMAGE::LoadImagePNG(const char* szFileName, COLORREF cookie)
{
#if defined(HAS_PNG_LIB)
int width, height, rowbytes, channels;

OPENGL_IMAGE& image = *this;

if(gf_png_open(szFileName, &width, &height, &rowbytes, &channels))
{
if(channels != 4) // no alpha in image
image.m_bSourceHadAlpha = false;

unsigned char** row_pointers = new unsigned char*[height];
unsigned char*  buffer = new unsigned char[height*rowbytes+8+64];
if (buffer!=NULL && row_pointers!=NULL)
{
gf_png_read(buffer, row_pointers);

// allocate the memory to hold the image using the fields of png_info.
image.resize(width, height);
// this->resize(,info_ptr->channels);

unsigned char R=0,G=0,B=0,A=255;
for(int row = 0; row < height; row++)
{
unsigned char *ptr = row_pointers[row];
unsigned char* pdest = &image[row*image.m_sizex*4];
for(int x=0; x<width; x++)
{
switch(channels)
{
case 4:
R=ptr[0]; G=ptr[1]; B=ptr[2]; A=ptr[3];
break;
case 3:
R=ptr[0]; G=ptr[1]; B=ptr[2]; A=255;
if(cookie!=(COLORREF)-1 && RGB(R,G,B) == cookie)
{
R=0; G=0; B=0; A=0;
}
break;
case 1:
R=ptr[0]; G=ptr[0]; B=ptr[0]; A=255;
break;
}

*pdest++ = R;
*pdest++ = G;
*pdest++ = B;
*pdest++ = A;

ptr += channels;
}
}
}
else
{
if(row_pointers)
delete[] row_pointers;
if(buffer)
delete[] buffer;
// not enough memory
return false;
}

delete[] row_pointers;
delete[] buffer;
gf_png_close();
}
else
return false;

return true;
#else
return false;
#endif // HAS_PNG_LIB
}


// -------------------------------- //
// Load BMP image to RGBA (endianess aware)
// -------------------------------- //
bool OPENGL_IMAGE::LoadImageBMP(const char* szFileName, COLORREF cookie)
{
OPENGL_IMAGE& image = *this;
char type_B='x', type_M='x';
RGBQUAD* pPalette = NULL;
BITMAPINFO		*pBitmapInfo = NULL;
unsigned long	lInfoSize = 0;
unsigned long	lBitSize = 0;
BYTE			*pBitmapData = NULL;
BITMAPFILEHEADER bitmapHeader;
int				BytesPerLine;
int				BytesPerPixel;
int i,j, shiftj;
bool flip_vertical = true;

int dmy=0;
// Open the Bitmap file
GFFileSystem file;
if(!file.OpenIn(szFileName))
goto fail;
#define BITMAPFILEHEADERSIZE 0x0000000e

if(!file.Read(&type_B, 1) || !file.Read(&type_M, 1))
goto fail;
if(type_B !='B' || type_M!='M')
goto fail;

if(!file.ReadLong(dmy)) goto fail;
bitmapHeader.bfSize=dmy; // android crash on direct read - very silly.

if(!file.ReadWord(bitmapHeader.bfReserved1)) goto fail;
if(!file.ReadWord(bitmapHeader.bfReserved2)) goto fail;
if(!file.ReadLong(dmy)) goto fail;
bitmapHeader.bfOffBits=dmy;


// Check format of bitmap file
#ifndef BF_TYPE_BITMAP
#define BF_TYPE_BITMAP	'M'*256+'B'
#endif
//		if(bitmapHeader.bfType != BF_TYPE_BITMAP) goto fail;

// Read in bitmap information structure
lInfoSize = bitmapHeader.bfOffBits - BITMAPFILEHEADERSIZE;
pBitmapInfo = (BITMAPINFO *) new BYTE[lInfoSize];
memset(pBitmapInfo, 0, lInfoSize);

// if(!file.Read(pBitmapInfo, lInfoSize)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biSize)) goto fail;

switch(pBitmapInfo->bmiHeader.biSize)
{
case 12: // OS/2 V1 header. Minon brought this....
if(!file.ReadWord(pBitmapInfo->bmiHeader.biWidth)) goto fail;
if(!file.ReadWord(pBitmapInfo->bmiHeader.biHeight)) goto fail;
if(!file.ReadWord(pBitmapInfo->bmiHeader.biPlanes)) goto fail;
if(!file.ReadWord(pBitmapInfo->bmiHeader.biBitCount)) goto fail;
break;
case 40:
if(!file.ReadLong(pBitmapInfo->bmiHeader.biWidth)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biHeight)) goto fail;
if(!file.ReadWord(pBitmapInfo->bmiHeader.biPlanes)) goto fail;
if(!file.ReadWord(pBitmapInfo->bmiHeader.biBitCount)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biCompression)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biSizeImage)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biXPelsPerMeter)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biYPelsPerMeter)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biClrUsed)) goto fail;
if(!file.ReadLong(pBitmapInfo->bmiHeader.biClrImportant)) goto fail;
// 40 bytes for that block
break;
default:
goto fail;
}


if(pBitmapInfo->bmiHeader.biHeight < 0)
{
flip_vertical = false;
pBitmapInfo->bmiHeader.biHeight = - pBitmapInfo->bmiHeader.biHeight;
}

// read palette if any
if(lInfoSize>40)
{
if(pBitmapInfo->bmiHeader.biSize == 12)
{
// V1 header - only full size palette
int cols = 1<<pBitmapInfo->bmiHeader.biBitCount;
pPalette = new RGBQUAD[cols];
BYTE* pRGB = new BYTE[3 * cols];
if(!file.Read(pRGB, cols*3))
{
goto fail;
}
BYTE* pPal = (BYTE*)pPalette;
for(int ii=0; ii<cols; ++ii)
{
*pPal++ = pRGB[ii*3];
*pPal++ = pRGB[ii*3+1];
*pPal++ = pRGB[ii*3+2];
*pPal++ = 0;
}
delete[] pRGB;
}
else
{
pPalette = new RGBQUAD[ (lInfoSize-40) / sizeof(RGBQUAD) + 1];
if(!file.Read(pPalette, (int)lInfoSize-40))
{
goto fail;
}
}
}

pBitmapInfo->bmiHeader.biHeight=abs((int)pBitmapInfo->bmiHeader.biHeight);

// Only supported: 24 Bit & 8 Bit
if (pBitmapInfo->bmiHeader.biBitCount!=1 &&
pBitmapInfo->bmiHeader.biBitCount!=4 &&
pBitmapInfo->bmiHeader.biBitCount!=8 &&
pBitmapInfo->bmiHeader.biBitCount!=24 &&
pBitmapInfo->bmiHeader.biBitCount!=16 &&
pBitmapInfo->bmiHeader.biBitCount!=32)// Num of bytes per pixel
goto fail;

// Bits Per Single Line / SinglePixel
// 4Byte alignment even in 256 Color Image
BytesPerPixel=pBitmapInfo->bmiHeader.biBitCount/8;
/*
if (BytesPerPixel==0)
{
printf("BytePerP = 0\n");
goto fail;
}
*/
if(pBitmapInfo->bmiHeader.biWidth%4 == 0)
{
BytesPerLine=(int)( pBitmapInfo->bmiHeader.biWidth * pBitmapInfo->bmiHeader.biBitCount ) / 8;
}
else
{
BytesPerLine=(int)( pBitmapInfo->bmiHeader.biWidth * pBitmapInfo->bmiHeader.biBitCount ) / 8;
//	BytesPerLine=  pBitmapInfo->bmiHeader.biWidth * BytesPerPixel;
if(BytesPerLine%4)
{
BytesPerLine+=(4-(BytesPerLine%4));
}
}
lBitSize=BytesPerLine*pBitmapInfo->bmiHeader.biHeight;

// Allocate space for the actual bitmap
pBitmapData = new BYTE[lBitSize];
if(!pBitmapData) goto fail;

// Read in the bitmap bits
if(!file.Read(pBitmapData, (int)lBitSize))
goto fail;
file.Close();

// Convert BMP to GLTexture RGBA
if(!image.resize((int)pBitmapInfo->bmiHeader.biWidth, (int)pBitmapInfo->bmiHeader.biHeight))
goto fail;

shiftj = pBitmapInfo->bmiHeader.biBitCount/8;
for (int y=0; y<image.m_sizey; ++y) // For each Pixel in BMP
{
i=y*image.m_sizex*4;
// Source Pixel
j=(int)(pBitmapInfo->bmiHeader.biHeight-y-1)*BytesPerLine;
for (int x=0; x<image.m_sizex; ++x)
{
image[i+3]=255;
switch(pBitmapInfo->bmiHeader.biBitCount)
{
case 24:
case 32:
image[i  ]=pBitmapData[j+2];	// Red
image[i+1]=pBitmapData[j+1];	// Green
image[i+2]=pBitmapData[j];	// Blue
break;

case 16: // RGB 5 5 5
{
unsigned short col16 = *(unsigned short*)&pBitmapData[j];
image[i  ]=(((((col16)>>10)&31)*255)/31);	// Red
image[i+1]=(((((col16)>> 5)&31)*255)/31);	// Green
image[i+2]=(((((col16)    )&31)*255)/31);	// Blue
}
break;


case 8:
{
RGBQUAD& colquad=pPalette[pBitmapData[j]];
image[i  ]=colquad.rgbRed;   // Red
image[i+1]=colquad.rgbGreen; // Green
image[i+2]=colquad.rgbBlue;  // Blue
}
break;
case 4:
{
int index = pBitmapData[j + x/2];
if(x & 0x01)
{
index &=0x0f;
}
else
{
index>>=4;
}
RGBQUAD& colquad=pPalette[ index ];
image[i  ]=colquad.rgbRed;   // Red
image[i+1]=colquad.rgbGreen; // Green
image[i+2]=colquad.rgbBlue;  // Blue
}
break;
case 1:
{
int index = (pBitmapData[j + x/8] & ( 1<<(7-(x%8)) ) ) ? 1:0;
RGBQUAD& colquad=pPalette[ index ];
image[i  ]=colquad.rgbRed;   // Red
image[i+1]=colquad.rgbGreen; // Green
image[i+2]=colquad.rgbBlue;  // Blue
}
break;
}
// remove cookie color
if(cookie!=(COLORREF)-1 && RGB(image[i], image[i+1], image[i+2]) == cookie)
{
image[i  ]=0;
image[i+1]=0;
image[i+2]=0;
image[i+3]=0;
}
j+=shiftj; i+=4;
}
}

if(!flip_vertical)
image.flipy();


if(pPalette)    delete [] pPalette;
if(pBitmapInfo) delete [] pBitmapInfo;
if(pBitmapData) delete [] pBitmapData;

image.m_bSourceHadAlpha = false; // BMP is solid/cookie coloured
return true;
fail:
if(pPalette)    delete [] pPalette;
if(pBitmapInfo) delete [] pBitmapInfo;
if(pBitmapData) delete [] pBitmapData;
image.clear();
return false;
}


// -------------------------------- //
// for cookie-coloured images
// -------------------------------- //
void OPENGL_IMAGE::FixNeighbourAlpha()
{
// For transparent pixels:
// get neighbour pixel color and make mix this into RGB components, if it has no alpha!
#define ADDFROM(x,y)	if((x)>0 && (y)>0 && (x)<m_sizex-1 && (y)<+m_sizey-1)\
{\
unsigned char* pN = &m_txdata[((x) + (y)*m_sizex)*4]; \
if (pN[3]!=0)\
{ \
div=div+1;\
red+=(float)pN[0]; green+=(float)pN[1]; blue+=(float)pN[2]; \
} \
}
for (int y=0; y<m_sizey; y++) // For each Pixel in BMP
{
for (int x=0; x<m_sizex; x++)
{
float div=0;
float red=0; float green=0; float blue=0;
unsigned char* pPixl;
pPixl = &m_txdata[ (x + y*m_sizex)*4]; //i=(x+(tex.sizey-y-1-(image.m_sizey-tex.sizey))*sx)*4];
if(pPixl[3]==0) // transparent pixel
{
ADDFROM(x-1,y-1);
ADDFROM(x  ,y-1);
ADDFROM(x+1,y-1);
ADDFROM(x-1,y  );
ADDFROM(x+1,y  );
ADDFROM(x-1,y+1);
ADDFROM(x  ,y+1);
ADDFROM(x+1,y+1);
if(div!=0)
{
red/=div;
green/=div;
blue/=div;
pPixl[0] = (unsigned char) red;
pPixl[1] = (unsigned char) green;
pPixl[1] = (unsigned char) blue;
}
else
{
pPixl[0] = 0; pPixl[1]=0; pPixl[2]=0; // somewhere in the void
}
}
}
}
}

#if 0 // Old PocketPC code - CE 6.x has no AygShell.dll (LoadImage/SHLoadImagegFile)
// Get 4 byte aligned width
#define ALIGN_4_BYTES(a) ( ((a) + 3) & ~3 )
#ifdef _WIN32_WCE
extern "C" HBITMAP SHLoadImageFile(LPCTSTR);
#endif

bool OPENGL_IMAGE::LoadImageJPG(const char* szFileName)
{
return LoadImageBMP(szFileName, -1);
}
bool OPENGL_IMAGE::LoadImagePNG(const char* szFileName, COLORREF cookie)
{
return LoadImageBMP(szFileName, cookie);
}

bool OPENGL_IMAGE::LoadImageBMP(const char* szFileName, COLORREF cookie)
{
BITMAP bmp;
HBITMAP hbmp=NULL;
clear();

char fname[512];
GFFileSystem::MakeAbsolutePathCE(szFileName, fname);

#ifdef UNICODE
wchar_t szFile[512];
_mbstowcsz(szFile, fname, strlen(fname)+1);
#else
const char* szFile = fname;
#endif


#ifdef _WIN32_WCE
hbmp = SHLoadImageFile(szFile);
#else
#ifndef LR_LOADFROMFILE
#define LR_LOADFROMFILE 0x0010
#endif
hbmp = (HBITMAP)::LoadImage(NULL, szFile, IMAGE_BITMAP, 0,0, 0x0010 /*LR_LOADFROMFILE*/);
#endif

if(!hbmp) return false;
if (::GetObject(hbmp, sizeof(BITMAP), &bmp))
{
bmp.bmHeight = abs(bmp.bmHeight);

unsigned char* pixels;

// Useing CreateDIBSection now
HDC hDC = GetWindowDC(NULL);

// Initialize the BITMAPINFOHEADER in m_DIBinfo
BITMAPINFO bi;
memset(&bi, 0, sizeof(bi));
BITMAPINFOHEADER& bih= bi.bmiHeader;
bih.biSize          = sizeof(BITMAPINFOHEADER);
bih.biWidth         = bmp.bmWidth;
bih.biHeight        = bmp.bmHeight;
bih.biPlanes        = 1;  // Must always be 1 according to docs
bih.biBitCount      = 24;
bih.biCompression   = BI_RGB;
bih.biSizeImage     = ALIGN_4_BYTES(bmp.bmWidth*3) * bmp.bmHeight;

HBITMAP hTargetBitmap = CreateDIBSection(hDC, (const BITMAPINFO*)&bi, DIB_RGB_COLORS, (void**) &pixels, NULL, 0);
ReleaseDC(NULL, hDC);		

// Copy source bitmap into the target bitmap.
// Create 2 device contexts 
HDC hMemDc = ::CreateCompatibleDC(NULL);
HDC hTargetDc = ::CreateCompatibleDC(NULL);

// Select source bitmap into one DC, target into another
HBITMAP hOldBitmap1 = (HBITMAP) ::SelectObject(hMemDc, hbmp);
HBITMAP hOldBitmap2 = (HBITMAP) ::SelectObject(hTargetDc, hTargetBitmap);

// Might only get 16bpp instead of 24??
if(cookie!=-1)
{
::SetPixel(hMemDc, 0,0,cookie);
cookie = ::GetPixel(hMemDc, 0,0);
}

// Copy source bitmap into the target one
::BitBlt(hTargetDc, 0, 0, bmp.bmWidth, bmp.bmHeight, hMemDc, 0, 0, SRCCOPY);

// Restore device contexts
::SelectObject(hMemDc, hOldBitmap1);
::SelectObject(hTargetDc, hOldBitmap2);

::DeleteDC(hMemDc);
::DeleteDC(hTargetDc);

resize(bmp.bmWidth, bmp.bmHeight);
unsigned char* pCur;
unsigned char R,G,B;
for(int y=0; y<bmp.bmHeight; ++y)
{
// HBITMAP is upside down
unsigned char* pbPixel = pixels + (bmp.bmHeight-y-1) * ALIGN_4_BYTES(bmp.bmWidth*3);
pCur = this->m_txdata + y*bmp.bmWidth*4;
for (int x=0; x<bmp.bmWidth; ++x)
{
B = *pbPixel++;
G = *pbPixel++;
R = *pbPixel++;
*pCur++ = R;
*pCur++ = G;
*pCur++ = B;
if(cookie == RGB(R,G,B))
{
*pCur++ = 0;
}
else
{
*pCur++ = 255;
}
}
}
DeleteObject(hTargetBitmap);
}
return true;
}
#endif // POCKETPC


#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
// --------------------------------------------------------------- //
// BMP -> Texture
// --------------------------------------------------------------- //
bool OpenGLRainbows::MakeTexture(OPENGL_IMAGE& image, int startx, int starty,
int sizex, int sizey,
GLuint* pTextureID, GLuint* pTextureIDMipMap,
bool IsBumpHeightMap, bool IsFont)
{
int				max_tex;
int				sx, sy;
long			res=FALSE;

glGetIntegerv(GL_MAX_TEXTURE_SIZE, &max_tex);

if(sizex==0) sizex=image.m_sizex-startx;
if(sizey==0) sizey=image.m_sizey-starty;
if(sizex<=0 || sizey<=0) return false;

sizex=min(sizex, max_tex);
sizey=min(sizey, max_tex);

// Create 2^n size
int yoffset = 0;
sx=GLB_MIN_TEX_SIZE/2; sy=GLB_MIN_TEX_SIZE/2;
do{sx<<=1;} while(sx < sizex);
do{sy<<=1;} while(sy < sizey);
yoffset = sy - sizey;

OPENGL_IMAGE tex;
if(!tex.resize(sx, sy)) return false;

for(int x=max(0,startx); x<min(startx+sx, image.m_sizex); ++x) // bmp coords
for(int y=max(0,starty); y<min(starty+sy, image.m_sizey); ++y)
{
if(x-startx<sizex && y-starty<sizey)
{
int t, b;
t = (x-startx + ( sy-(y-starty)-1-yoffset )*sx)*4; // texture
b = (x + y*image.m_sizex)*4; // bitmap
tex[t++] = image[b++];
tex[t++] = image[b++];
tex[t++] = image[b++];
tex[t  ] = image[b  ];
}
}


// Now make a GLtexture and free stuff
// This is specific to the binary format of the data read in.
glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
#if defined(HAVE_OPENGL) && !defined(EMSCRIPTEN)
glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);
#endif

// get new Id if none given or free mem
if(*pTextureID==0)
glGenTextures(1, pTextureID);
else
glDeleteTextures(1, pTextureID);

glBindTexture(GL_TEXTURE_2D, *pTextureID);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
if(!IsFont)
{
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
}
else
{
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
}

#if defined(HAVE_OPENGL)
if (IsBumpHeightMap)
build_detail_normalmap(tex);
//		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, tex.m_sizex, tex.m_sizey, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex.m_txdata);
//	#elif defined(HAVE_OPENGL_ES)
//		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA , tex.m_sizex, tex.m_sizey, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex.m_txdata);
#endif

GLint  intformat = GL_RGBA8;
#if defined(HAVE_OPENGL_ES) || defined(EMSCRIPTEN)
intformat = GL_RGBA;
#endif
glTexImage2D(GL_TEXTURE_2D, 0, intformat , tex.m_sizex, tex.m_sizey, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex.m_txdata);

// Now build MipMaps
#if defined(HAVE_OPENGL)
long components[4];
if (pTextureIDMipMap)
{
glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
#if defined(HAVE_OPENGL) && !defined(EMSCRIPTEN)
glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);
#endif
glGenTextures(1, pTextureIDMipMap);
glBindTexture(GL_TEXTURE_2D, *pTextureIDMipMap);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR); // Trilinear Mipmapping
int sxn=tex.m_sizex, syn=tex.m_sizey, i=0, x, y, j, compo, pixl;

// Attention! Mipmap levels must be SQUARE!
while(sxn> syn) // too wide, half size
{
sxn>>=1;
for (y=0; y<syn; ++y)
for (x=0; x<sxn; ++x)
{
for(j=0; j<4; j++) // RGBA
{
tex[x*4 + y*sxn*4 + j] = (tex[x*8 + y*sxn*8 + j]+tex[x*8 +4 + y*sxn*8 + j])>>1;
}
}
}

while(syn> sxn) // too high, half size
{
syn>>=1;
for (y=0; y<syn; ++y)
for (x=0; x<sxn; ++x)
{
for(j=0; j<4; j++) // RGBA
{
tex[x*4 + y*sxn*4 + j] = (tex[x*4 + y*sxn*8 + j]+tex[x*4 + y*sxn*8 +sxn*4 + j])>>1;
}
}
}

while(true)
{
glTexImage2D(GL_TEXTURE_2D, i++, intformat, sxn, syn, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex.m_txdata);
sxn/=2; syn/=2;
if (sxn<1 && syn<1)  break;
for (y=0; y<max(syn, 1); y++)
for (x=0; x<max(sxn, 1); x++)
{
for(j=0; j<4; j++) // RGBA
{
compo=1;
components[0] = tex[x*8 + y*sxn*16 + j];
if (x<sxn-1)
{
components[compo]=tex[x*8+4 + y*sxn*16 + j]; compo++;
if (y<syn-1)
{
components[compo]=tex[x*8+4 + (y+1)*sxn*16 + j]; compo++;
}
}
if (y<syn-1)
{
components[compo]=tex[x*8 + (y+1)*sxn*16 + j]; compo++;
}
// The weight of my pixel is double to each horz or vert.
// The diagonal pixel is one fourth
switch(compo)
{
case 1: pixl=components[0]; break;
case 2: pixl=(components[0]*2+components[1])/3; break;
case 4: pixl=(components[0]*4+components[1]*2+components[2]*2+components[3])/9; break;
}
tex[x*4 + y*sxn*4 + j]=(unsigned char)(pixl);
}
}
}
}
#endif // mipmap

return true;
}

//---------------------------------------------------------------//
// Get the pixels from the card into SpritePix data
// (for pixel based collisions)
//---------------------------------------------------------------//
void OpenGLRainbows::GetSpritePixels(int n)
{
// OpenGL|ES has no GL_ALPHA for glReadPixels
// must read full RGBA

// Use a PBuffer an glReadPixels
#if defined(HAVE_OPENGL) && !defined(EMSCRIPTEN)
#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
if(!SpritePix[n].Size() )
#else
if (!SpritePix[n])
#endif
{
GLint width=m_Texture[n].w, height=m_Texture[n].h;
glBindTexture(GL_TEXTURE_2D, m_Texture[n].mipstate[0]);
#ifndef EMSCRIPTEN // not for HTML5
glGetTexLevelParameteriv(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH,  &width);
glGetTexLevelParameteriv(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT, &height);
#endif

#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
SpritePix[n].SetSize(max(8*8, width*height) );
#else
SpritePix[n] = new BYTE [ max(8*8, width*height) ];
#endif
glGetTexImage(GL_TEXTURE_2D, 0, GL_ALPHA, GL_UNSIGNED_BYTE, &SpritePix[n][0]);
OPENGL_CHECK_ERRORS();
#if 0
printf("Alpha pixels: ID=%d\n", n);
for(int y=0; y<m_Texture[n].h; ++y)
{
for(int x=0; x<m_Texture[n].w; ++x)
{
printf("%c", SpritePix[n][x + y*m_Texture[n].w]? '#':'_');
}
printf("\n");
}
#endif
}
#elif defined(HAVE_OPENGL_ES) || defined(EMSCRIPTEN)
// Use a PBuffer and glReadPixels
#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
if(!SpritePix[n].Size() )
#else
if (!SpritePix[n])
#endif
{
/* if only you had glReadPixels(GL_ALPHA) ...
FBUFFER pbuffer;
if(pbuffer.Create(m_Texture[n].w, m_Texture[n].h, false))
{
SpritePix[n] = new BYTE [m_Texture[n].w*m_Texture[n].h];
pbuffer.StartRendering(m_Texture[n].mipstate[0]); // bind mip-mapping texture
glReadPixels(0,0,m_Texture[n].w, m_Texture[n].h, GL_ALPHA, GL_UNSIGNED_BYTE, SpritePix[n]);
pbuffer.StopRendering();
}
*/

FBUFFER pbuffer;
if(pbuffer.Create(m_Texture[n].w, m_Texture[n].h, m_Texture[n].mipstate[0], false))
{
#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
SpritePix[n].SetSize(m_Texture[n].w*m_Texture[n].h);
Queue<BYTE> pTemp; pTemp.SetSize(m_Texture[n].w*m_Texture[n].h*4);
#else
SpritePix[n] = new BYTE [m_Texture[n].w*m_Texture[n].h];
BYTE* pTemp = new BYTE[m_Texture[n].w*m_Texture[n].h*4];
#endif
// memset(pTemp, 0, 4*m_Texture[n].w*m_Texture[n].h);

if(!pbuffer.Bind()) // bind mip-mapping texture
{
g_debug("fail bind FBO on tex %d=%d\n", n, m_Texture[n].mipstate[0]);
}

glReadPixels(0,0,m_Texture[n].w, m_Texture[n].h, GL_RGBA, GL_UNSIGNED_BYTE, &pTemp[0]);
if(!pbuffer.Unbind())
{
g_debug("fail Unbind FBO on tex %d=%d\n", n, m_Texture[n].mipstate[0]);
}


#if defined( SPRITE_ALPHA_PIX_AS_VECTOR)
int dest=0;
int src=3;
for(int y=0; y<m_Texture[n].h; ++y)
{
for(int x=0; x<m_Texture[n].w; ++x)
{
SpritePix[n][dest] = pTemp[src];
++dest;
src+=4;
}
}
#else
BYTE* pSrc  = pTemp + 3;
BYTE* pDest = SpritePix[n];
for(int y=0; y<m_Texture[n].h; ++y)
{
for(int x=0; x<m_Texture[n].w; ++x)
{
*pDest = *pSrc;
++pDest;
pSrc+=4;
}
}
delete[] pTemp;
#endif

#if 0
printf("RGBA pixels: ID=%d\n", n);
for(int y=0; y<m_Texture[n].h; ++y)
{
for(int x=0; x<m_Texture[n].w; ++x)
{
printf("%x", *(int*)(&pTemp[(x + y*m_Texture[n].w)*4]));
}
printf("\n");
}
printf("Alpha pixels: ID=%d\n", n);
for(int y=0; y<m_Texture[n].h; ++y)
{
for(int x=0; x<m_Texture[n].w; ++x)
{
printf("%c", SpritePix[n][x + y*m_Texture[n].w]? '#':'_');
}
printf("\n");
}
#endif
}
}
if(!SpritePix)
g_debug("can't get alpha pixels\n");
#endif
}
#endif



// Rect Collision?
#define qmax_(a, b) ((a)>(b) ? (a) : (b))
#define qmin_(a, b) ((a)<(b) ? (a) : (b))
#define __RectRectIntersection(x1, y1, xe1, ye1, x2, y2, xe2, ye2) \
(qmax_(qmin_(x1, xe1), qmin_(x2, xe2)) <= qmin_(qmax_(x1, xe1), qmax_(x2, xe2))) \
&&	(qmax_(qmin_(y1, ye1), qmin_(y2, ye2)) <= qmin_(qmax_(y1, ye1), qmax_(y2, ye2)))
// For normalized rects
#define __NormRectRectIntersection(x1, y1, xe1, ye1, x2, y2, xe2, ye2) \
((qmax_(x1, x2) <= qmin_(xe1, xe2)) \
&& (qmax_(y1, y2) <= qmin_(ye1, ye2)))
//---------------------------------------------------------------//
// Sprite Collision (Pixel based)
//---------------------------------------------------------------//
bool	OpenGLRainbows::SpriteCollision(int n1, int n2, int x1, int y1, int x2, int y2)
{
#if defined(TINYGL) || defined(TRENKI3D)
return oBitmap::Collision(m_Sprite[n1], x1,y1, m_Sprite[n2], x2,y2);
#else
if (!__NormRectRectIntersection(x1, y1, x1+m_Texture[n1].bw, y1+m_Texture[n1].bh, x2, y2, x2+m_Texture[n2].bw, y2+m_Texture[n2].bh)) return false;

// Find Overlapping Rect
int xs, ys, xe, ye;
xs=qmax_(x1, x2); ys=qmax_(y1, y2);
xe=qmin_(x1+m_Texture[n1].bw, x2+m_Texture[n2].bw); ye=qmin_(y1+m_Texture[n1].bh, y2+m_Texture[n2].bh);
return _PixelCollision(n1,x1,y1, n2,x2,y2, xs,ys,xe,ye);
#endif
}

//---------------------------------------------------------------//
// Sprite-Animation Collision (Pixel based)
//---------------------------------------------------------------//
bool OpenGLRainbows::TileCollision(  int n1, int tile1, int x1, int y1, int n2, int tile2, int x2, int y2)
{
int tx1, ty1, tx2, ty2; // xy position for tile
int w1, h1, w2, h2; // width

if(m_Texture[n1].tw==0)
{
tx1 = 0;
ty1 = 0;
w1 = m_Texture[n1].bw;
h1 = m_Texture[n1].bh;
}
else
{
int nperline = m_Texture[n1].bw / m_Texture[n1].tw;
if(nperline==0) nperline=1;
tx1=(   tile1 % nperline)*m_Texture[n1].tw;
ty1=(0+ tile1 / nperline)*m_Texture[n1].th;
w1 = m_Texture[n1].tw;
h1 = m_Texture[n1].th;
}

if(m_Texture[n2].tw==0)
{
tx2 = 0;
ty2 = 0;
w2 = m_Texture[n2].bw;
h2 = m_Texture[n2].bh;
}
else
{
// w=336; 
int nperline = m_Texture[n2].bw / m_Texture[n2].tw;
if(nperline==0) nperline=1;
tx2=(   tile2 % nperline)*m_Texture[n2].tw;
ty2=(0+ tile2 / nperline)*m_Texture[n2].th;
w2 = m_Texture[n2].tw;
h2 = m_Texture[n2].th;
}



#if defined(TINYGL) || defined(TRENKI3D)
return oBitmap::CollisionClip(	m_Sprite[n1], x1,y1,tx1,ty1,w1,h1,
m_Sprite[n2], x2,y2,tx2,ty2,w2,h2);
#else
if (!__NormRectRectIntersection(x1, y1, x1+w1, y1+h1,
x2, y2, x2+w2, y2+h2)) return false;

// Find Overlapping Rect
int xs, ys, xe, ye;
xs=qmax_(x1, x2); ys=qmax_(y1, y2);
xe=qmin_(x1+w1, x2+w2); ye=qmin_(y1+h1, y2+h2);
return _PixelCollision(n1,x1-tx1,y1-ty1, n2,x2-tx2,y2-ty2, xs,ys,xe,ye);

#endif
}



//---------------------------------------------------------------//
// Pixel-Range Collision of Sprites
//---------------------------------------------------------------//
bool OpenGLRainbows::_PixelCollision(int n1, int x1, int y1, int n2, int x2, int y2, int xs, int ys, int xe, int ye)
{
if(ys==ye || xs==xe) return false; // no pixels - quick shot fails otherwise

#if !defined(TINYGL) && !defined(TRENKI3D)
BYTE	*pBits1, *pBits2;
int		x, y;

// Get alpha bits, only in SX, SY dimension (2^n x 2^m)
GetSpritePixels(n1);
GetSpritePixels(n2);

pBits1 = &SpritePix[n1][0];
pBits2 = &SpritePix[n2][0];

// please, don't crash
if(!pBits1 || !pBits2)
return false;

// splitting even/odd rows for even more speed
BYTE* pRow1, *pRow2;

#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
#define VALID_ALPHA(ispr, pos) {BYTE b = SpritePix[(ispr)][(pos)];}
#else
#define VALID_ALPHA(ispr, pos)
#endif
#ifdef _DEBUG
#define DBG {if(*pRow1 && *pRow2) this->DrawPixel(x,y,RGB(0,255,0)); else if(*pRow1) this->DrawPixel(x,y,RGB(0,0,255)); else if (*pRow2) this->DrawPixel(x,y,RGB(0,255,255)); else DrawPixel(x,y,RGB(255,255,0)); \
VALID_ALPHA(n1, (int)(pRow1-pBits1)); VALID_ALPHA(n2, (int)(pRow2-pBits2));}
#else
#define DBG {}
#endif

#if 0
if(n1==0)
{
printf("Collision Range x %d, y %d----\n", xs-x1, ys-y1);
for (y=ys; y<ye; y++)
{
// pBits[x][y] = pBits[x + y*w]
pRow1 = pBits1 + xs - x1 + (m_Texture[n1].bh -1 - (y-y1) )*m_Texture[n1].w;
pRow2 = pBits2 + xs - x2 + (m_Texture[n2].bh -1 - (y-y2) )*m_Texture[n2].w;
for (x=xs; x<xe; x++)
{
char out='.';
if(*pRow1) out='1';
if(*pRow2) out='2';
if (*pRow1 && *pRow2)
out='X';
printf("%c", out);
pRow1++; pRow2++;
}
printf("\n");
}
printf("\n");
}
#endif

// very quick shot - center of overlapping
x = xs+(xe-xs)/2; y=ys+(ye-ys)/2;
pRow1 = pBits1 - x1 + (m_Texture[n1].bh-1 - (y-y1) )*m_Texture[n1].w + x;
pRow2 = pBits2 - x2 + (m_Texture[n2].bh-1 - (y-y2) )*m_Texture[n2].w + x;
DBG
if (*pRow1 && *pRow2) return true;// Got Collision on both bits

for (y=ys; y<ye; y+=2)
{
// pBits[x][y] = pBits[x + y*w]
pRow1 = pBits1 + xs - x1 + (m_Texture[n1].bh-1 - (y-y1) )*m_Texture[n1].w;
pRow2 = pBits2 + xs - x2 + (m_Texture[n2].bh-1 - (y-y2) )*m_Texture[n2].w;
for (x=xs; x<xe; x+=2)
{
DBG
if (*pRow1 && *pRow2) return true;// Got Collision on both bits
pRow1+=2; pRow2+=2;
}
}

// even rows
// even pixel cols
for (y=ys; y<ye; y+=2)
{
// pBits[x][y] = pBits[x + y*w]
pRow1 = pBits1 + xs - x1 + (m_Texture[n1].bh-1 - (y-y1) )*m_Texture[n1].w;
pRow2 = pBits2 + xs - x2 + (m_Texture[n2].bh-1 - (y-y2) )*m_Texture[n2].w;
for (x=xs; x<xe; x+=2)
{
DBG
if (*pRow1 && *pRow2) return true;// Got Collision on both bits
pRow1+=2; pRow2+=2;
}
}

// odd cols
++xs;
for (y=ys; y<ye; y+=2)
{
// pBits[x][y] = pBits[x + y*w]
pRow1 = pBits1 + xs - x1 + (m_Texture[n1].bh-1 - (y-y1) )*m_Texture[n1].w;
pRow2 = pBits2 + xs - x2 + (m_Texture[n2].bh-1 - (y-y2) )*m_Texture[n2].w;
for (x=xs; x<xe; x+=2)
{
DBG
if (*pRow1 && *pRow2) return true;// Got Collision on both bits
pRow1+=2; pRow2+=2;
}
}

// odd rows
--xs;
++ys;
// even pixel cols
for (y=ys; y<ye; y+=2)
{
// pBits[x][y] = pBits[x + y*w]
pRow1 = pBits1 + xs - x1 + (m_Texture[n1].bh-1 - (y-y1) )*m_Texture[n1].w;
pRow2 = pBits2 + xs - x2 + (m_Texture[n2].bh-1 - (y-y2) )*m_Texture[n2].w;
for (x=xs; x<xe; x+=2)
{
DBG
if (*pRow1 && *pRow2) return true;// Got Collision on both bits
pRow1+=2; pRow2+=2;
}
}
// odd cols
++xs;
for (y=ys; y<ye; y+=2)
{
// pBits[x][y] = pBits[x + y*w]
pRow1 = pBits1 + xs - x1 + (m_Texture[n1].bh-1 - (y-y1) )*m_Texture[n1].w;
pRow2 = pBits2 + xs - x2 + (m_Texture[n2].bh-1 - (y-y2) )*m_Texture[n2].w;
for (x=xs; x<xe; x+=2)
{
DBG
if (*pRow1 && *pRow2) return true;// Got Collision on both bits
pRow1+=2; pRow2+=2;
}
}
#undef DBG
#endif
return false;
}



//---------------------------------------------------------------//
//---------------------------------------------------------------//
bool OpenGLRainbows::LoadSurface(int num, const char* szFileName, bool bGrayScale)
{
OPENGL_IMAGE image;
if(!image.LoadImageBMP(szFileName, (COLORREF)-1) && !image.LoadImagePNG(szFileName, (COLORREF)-1) && !image.LoadImageJPG(szFileName))
{
return false;
}
if (image.m_sizex==0 || image.m_sizey==0) return false;

#if defined(TINYGL) || defined(TRENKI3D)
m_Surface[num].CreateBy(image, (COLORREF)-1);
#else
#ifdef GLB_SURFACE_OLDSCHOOL
int			tx, ty;
int			sztex;
int			bx, by;

glGetIntegerv(GL_MAX_TEXTURE_SIZE, &sztex);
sztex=min(512, sztex); // don't make too big, otherwise "grabbing" takes so so long.

tx=ty=0;
this->FreeSurface(num);
for (by=0; by<image.m_sizey; by+=sztex)
{
for (bx=0; bx<image.m_sizex; bx+=sztex)
{
if (!MakeTexture(image, bx, by, sztex, sztex, &this->m_Surface[num].txt[tx][ty], NULL, false, false))
return false;
m_Surface[num].sizx [tx][ty]=sztex;
m_Surface[num].sizy [tx][ty]=sztex;
m_Surface[num].sizbx[tx][ty]=sztex;
m_Surface[num].sizby[tx][ty]=sztex;
tx++;
}
this->m_Surface[num].usex=max(tx, this->m_Surface[num].usex);
ty++;
tx=0;
}
this->m_Surface[num].usey=ty;
#else // jus use a sprite
if(m_BackSurfaceSpriteID[num] == -1)
FreeSprite(m_BackSurfaceSpriteID[num]);

m_BackSurfaceSpriteID[num] = this->GenSprite();
if(!this->LoadSprite(m_BackSurfaceSpriteID[num], image, -1, false))
{
m_BackSurfaceSpriteID[num] = -1;
return false;
}
#endif
#endif
return true;
}

// --------------------------------------------------------------- //
// Get cookie color and fix the 16 bit rounding error
// returned as BIG endian
// --------------------------------------------------------------- //
unsigned int OpenGLRainbows::GetTrueCookieColor()
{
// pixels = 0x 80 00 ff 00 - BGRA
// pP     = 0x 00 ff 00 80 - ARGB (Little Endian on x86)
unsigned long cookie;
if(m_CookieColor != 0)
{
COLORREF old= GetPixel(4,4);
DrawPixel(4,4,m_CookieColor);
cookie = GetPixel(4,4);
cookie = ToBigEndian((unsigned long)cookie);
DrawPixel(4,4,old);
}
else
cookie = ToBigEndian((unsigned long)m_CookieColor);
return (int)cookie;
}


// --------------------------------------------------------------- //
// Grab a Sprite from BackBuffer
// --------------------------------------------------------------- //
bool OpenGLRainbows::GrabSprite(int num, int x, int y, int wx, int wy)
{
//	this->FreeSprite(num); // might want to reuse the texture

m_Texture[num].th = m_Texture[num].tw = 0;

#if defined(TINYGL) || defined(TRENKI3D)
m_Texture[num].w =(short)wx; // Set Size of Texture
m_Texture[num].h =(short)wy;
m_Texture[num].bw=(short)wx; // Size of grabbed image
m_Texture[num].bh=(short)wy;
m_Texture[num].txx=1.0f;
m_Texture[num].txy=1.0f;

m_Sprite[num].GrabFrom(x,y,x+wx, y+wy, m_CookieColor);
return true;
#else

// Force clearing of collision pixels!!
#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
SpritePix[num].Clear();
#else
if (SpritePix[num]) delete[] SpritePix[num];
SpritePix[num]=NULL;
#endif

if(wx==0 || wy==0)
{
FreeSprite(num);
return true;
}

int	sx, sy;
// Create 2^n size
sx=GLB_MIN_TEX_SIZE/2; sy=GLB_MIN_TEX_SIZE/2;
do{sx<<=1;} while(sx < wx);
do{sy<<=1;} while(sy < wy);


// do not reallocate if not neccessary!
if (m_Texture[num].w != sx || m_Texture[num].h != sy)
{
if(m_Texture[num].mipstate[0])
glDeleteTextures(1, &m_Texture[num].mipstate[0]);
if(m_Texture[num].mipstate[1])
glDeleteTextures(1, &m_Texture[num].mipstate[1]);
m_Texture[num].mipstate[0]=0;
m_Texture[num].mipstate[1]=0;

// This is specific to the binary format of the data
glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
#if defined(HAVE_OPENGL) && !defined(EMSCRIPTEN)
glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);
#endif
// Generate & Bind into Memory
glGenTextures(1, &m_Texture[num].mipstate[0]);
glBindTexture(GL_TEXTURE_2D, m_Texture[num].mipstate[0]);
// Set Texture mapping parameters
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

GLenum format = GL_RGBA;
GLint  intformat = GL_RGBA8;
#if defined(HAVE_OPENGL_ES) || defined(EMSCRIPTEN)
intformat = GL_RGBA;
#endif
// OpenGL|ES does not have BGRA_EXT
if(m_bSupportBGRA_ext)
{
format = GL_BGRA_EXT;
}
// must use RGBA, BGRA is not supported
// glTexImage2D(...      GL_UNSIGNED_SHORT_5_6_5, NULL);
glTexImage2D(GL_TEXTURE_2D, 0, intformat , sx, sy, 0, format    , GL_UNSIGNED_BYTE, NULL);
}
else
{
glBindTexture(GL_TEXTURE_2D, m_Texture[num].mipstate[0]);
}

m_Texture[num].w =(short)sx; // Set Size of Texture
m_Texture[num].h =(short)sy;
m_Texture[num].bw=(short)wx; // Size of grabbed image
m_Texture[num].bh=(short)wy;
m_Texture[num].txx=(float)m_Texture[num].bw/m_Texture[num].w;
m_Texture[num].txy=(float)m_Texture[num].bh/m_Texture[num].h;


#if 0 // crap! glGetTexLevelParameteriv missing on iPhone
// #iPhone SDL has a Frambuffer instead of a screen
//         -> also make GRASPRITE work from within USESCREEN
GLint curr_fbo = FBUFFER::GetActiveFrameBuffer();
if(curr_fbo)
{
FBUFFER fbo;
fbo.Create(sx,sy, false); // no depth buffer
if(fbo.StartRendering(m_Texture[num].mipstate[0]))
{
Make2DViewport(0,0,sx,sx);
glViewport(0, 0, sx,sy);

// curr_fbo is the texture index for the texture to grab from
// find the size
GLint org_w=0,  org_h=0;
glGetTexLevelParameteriv(GL_TEXTURE_2D, 0, GL_TEXTURE_WIDTH,  &org_w);
glGetTexLevelParameteriv(GL_TEXTURE_2D, 0, GL_TEXTURE_HEIGHT, &org_h);
// render the quad
GLfloat   xy[] = {
wx, 0,
0 , 0,
0 , wy,
wx, wy
};
GLfloat   uv[] = {
(GLfloat)(x+wx)/org_w, (GLfloat)(wy-y)/org_h,
(GLfloat)     x/org_w, (GLfloat)(wy-y)/org_h,
(GLfloat)     x/org_w, (GLfloat)(org_h-wy-y   )/org_h,
(GLfloat)(x+wx)/org_w, (GLfloat)(org_h-wy-y   )/org_h
};
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer( 2, GL_FLOAT,    0, (char*)xy);
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, 0, (char*)uv);
glbEnable(GL_TEXTURE_2D);
glBindTexture(GL_TEXTURE_2D, curr_fbo);

glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_BORDER);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_BORDER);
glDrawArrays(GL_TRIANGLE_FAN, 0, 4);	// Draw All Of The Triangles At Once

// Disable Pointers
glDisableClientState( GL_VERTEX_ARRAY );				// Disable Vertex Arrays
glDisableClientState( GL_TEXTURE_COORD_ARRAY );			// Disable Texture Coord Arrays

fbo.StopRendering(); // restore old frame buffer
Make2DViewport(0,0,0,0);
}
return true;
}
#endif


static int has_alpha=-1;
if(has_alpha == -1)
{
glGetIntegerv(GL_ALPHA_BITS, &has_alpha); // 8 bits usually
}



int quickmode = 0;

#ifndef PALM_PIXI // pixi won't do glCopyTexSubImage2D here :(
if(has_alpha && m_landscape==0)
quickmode=1;
#endif


if(quickmode)
{
// Here comes the magic
// glCopy/glRead had x,y(0,0) = bottom left corner - forced
//  x,y,w,h = 0,368,32,32
glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, x, m_WND.height-y-wy, wx, wy);
}
else // no alpha bits -> fix transparancy for compatibility
{
static OPENGL_IMAGE img; // saves a lot re-allocations

// WHAT A MESS! From now on, flip "sx,sy", grab at new screen position and rotate image later
int xgrab = x;
int ygrab = m_WND.height-y-wy;

if(m_landscape)
{
if(m_landscape==1)
{
// this case is very special because of grab!=pow2
int nx, ny;
nx = m_WND.width - y - wy;
ny = x;
x=nx;
y=ny;
nx = sx; sx=sy; sy=nx;
nx = wx; wx=wy; wy=nx;

// fix grab positions
xgrab = x;
ygrab = m_WND.height-sy-y;
}
else
{
int xend=xgrab+sx-1;
int yend=ygrab+sy-1;
Rot_Display2Screen(xgrab, ygrab, &xgrab, &ygrab);
Rot_Display2Screen(xend,  yend,  &xend,  &yend);
if(xend<xgrab)
{
int swp = xend; xend=xgrab; xgrab=swp;
}
if(yend<ygrab)
{
int swp = yend; yend=ygrab; ygrab=swp;
}
wx = xend-xgrab+1;
wy = yend-ygrab+1;
sx=GLB_MIN_TEX_SIZE/2; sy=GLB_MIN_TEX_SIZE/2;
do{sx<<=1;} while(sx < wx);
do{sy<<=1;} while(sy < wy);
}
}

int readx = wx, ready=wy;
#ifdef GLREAD_POWER_OF_2
readx = sx;
ready = sy;
#endif

img.resize(readx, ready);

if(m_bSupportBGRA_ext)
{
glReadPixels(xgrab,ygrab,readx,ready,GL_BGRA_EXT, GL_UNSIGNED_BYTE, img.m_txdata);
}
else
{
glReadPixels(xgrab,ygrab,readx,ready,GL_RGBA    , GL_UNSIGNED_BYTE, img.m_txdata);
}

img.expand(sx, sy); // make image power of 2 now (for texture generation)


if(!has_alpha) // no alpha: fix alpha bits by cookie color -> this is going to be really slow now
{
// pixels = 0x 80 00 ff 00 - BGRA
// pP     = 0x 00 ff 00 80 - ARGB (Little Endian on x86)
unsigned int cookie=GetTrueCookieColor();

// DrawPixel might mess this up - uh oh!
glBindTexture(GL_TEXTURE_2D, m_Texture[num].mipstate[0]);

unsigned int* pP = (unsigned int*)img.m_txdata, *pEnd = (unsigned int*)img.m_txdata + (sx*sy);

if(m_bSupportBGRA_ext)
{
// RGBA instead of BGRA
// little endian the cookie
cookie = (int)FromBigEndian((unsigned long)cookie);
// cookie &= 0x00ffffff;
do
{
if( ((*pP) & 0x00ffffff) == cookie)
{
*pP &= 0x00ffffff;
}
++pP;
}while(pP < pEnd);
}
else
{
if(GF_BIG_ENDIAN)
{
// 0xbbggrraa
do
{
if( ((*pP) & 0xffffff00) == cookie)
{
*pP &= 0xffffff00;
}
++pP;
}while(pP < pEnd);
}
else
{
// 0xaarrggbb
cookie >>= 8;
do
{
if( ((*pP) & 0x00ffffff) == cookie)
{
*pP &= 0x00ffffff;
}
++pP;
}while(pP < pEnd);
}
}
} // has_alpha


if(m_landscape)
{
for(int i=0; i<m_landscape; ++i)
img.rotate90right();
// img.rotate90right();

if(m_landscape==1 || m_landscape==3)
{
int swp=sx; sx=sy;sy=swp;
}
}

#if 1 // fix formats for gles
#ifdef PALM_PIXI
img.clip(wx,wy);
if(m_bSupportBGRA_ext) // deffo need rgba, not bgra here
img.swap_red_blue();
img.flipy();
MakeTexture(img, 0,0,wx,wy, &m_Texture[num].mipstate[0], NULL, false, false);
#else
GLenum format = GL_RGBA;
GLint  intformat = GL_RGBA8;
#if defined(HAVE_OPENGL_ES) || defined(EMSCRIPTEN)
intformat = GL_RGBA;
#endif
// OpenGL|ES does not have BGRA_EXT
if(m_bSupportBGRA_ext)
{
format = GL_BGRA_EXT;
}
glTexImage2D(GL_TEXTURE_2D, 0, intformat, sx,sy, 0, format, GL_UNSIGNED_BYTE, img.m_txdata);
#endif

#else
if(m_bSupportBGRA_ext)
{
glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, sx,sy, 0, GL_BGRA_EXT, GL_UNSIGNED_BYTE, img.m_txdata);
}
else
{
// must use RGBA, BGRA is not supported                       //GL_UNSIGNED_SHORT_5_5_5_1
glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, sx,sy, 0, GL_RGBA     , GL_UNSIGNED_BYTE, img.m_txdata);
}
#endif
}

OPENGL_CHECK_ERRORS();
return TRUE;
#endif
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::GrabSurface(int num)
{
#if defined(TINYGL) || defined(TRENKI3D)
Screen.SetDrawBuffer();
m_Surface[num].GrabFrom(0,0,Screen.getWidth(), Screen.getHeight(), m_CookieColor);
#else
#ifdef GLB_SURFACE_OLDSCHOOL
int	sx, sy = 0, tx, ty, wx, wy;
int	bmpx, bmpy;
int	max_tex;
// Maximum of one sprite for the surface
glGetIntegerv(GL_MAX_TEXTURE_SIZE, &max_tex);
bmpx = this->m_WND.width;
bmpy = this->m_WND.height;

// find minimum required texture size (new cards do 8000x8000, which is _sloooow_ then)
for(tx=128; tx<max(bmpx, bmpy) && tx<max_tex; tx*=2)
{}
max_tex = tx;

int bx=0, by=0;
tx=ty=0;
//	this->FreeSurface(num);

for (by=0; by<bmpy; by+=max_tex) //+64
{
for (bx=0; bx<bmpx; bx+=max_tex)
{
sx=max_tex;
sy=max_tex;
if(m_Surface[num].sizx[tx][ty] != sx || m_Surface[num].sizy[tx][ty]!=sy)
{
// This is specific to the binary format of the data read in.
glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
#if defined(HAVE_OPENGL) && !defined(EMSCRIPTEN)
glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);
#endif

// Now Bind the Texture to Memory
glGenTextures(1, &this->m_Surface[num].txt[tx][ty]);
glBindTexture(GL_TEXTURE_2D, this->m_Surface[num].txt[tx][ty]);
// Set Texture mapping parameters
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

#if 1 // fix formats for gles
GLenum format = GL_RGBA;
GLint  intformat = GL_RGBA8;
#if defined(HAVE_OPENGL_ES) || defined(EMSCRIPTEN)
intformat = GL_RGBA;
#endif
// OpenGL|ES does not have BGRA_EXT
if(m_bSupportBGRA_ext)
{
format = GL_BGRA_EXT;
}
glTexImage2D(GL_TEXTURE_2D, 0, intformat, sx,sy, 0, format, GL_UNSIGNED_BYTE, NULL);
#else
// #if defined(HAVE_OPENGL)
if(m_bSupportBGRA_ext)
{
glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, sx, sy, 0, GL_BGRA_EXT, GL_UNSIGNED_BYTE, NULL);
}
else
{
//#elif defined(HAVE_OPENGL_ES)
// must use RGBA, BGRA is not supported
glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, sx, sy, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);
}
// #endif
#endif
}
else
glBindTexture(GL_TEXTURE_2D, this->m_Surface[num].txt[tx][ty]);

wx = sx;
wy = sy;
if (bx+sx>bmpx) wx = bmpx-bx;
if (by+sy>bmpy) wy = bmpy-by;


if(m_bSupportBGRA_ext)
{
glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, bx, bmpy-by-wy, wx, wy);
}
else
{
static OPENGL_IMAGE img; // safes re-allocation a lot
img.resize(sx,sy);
// must use RGBA, BGRA is not supported
glReadPixels(0,0,sx,sy,GL_RGBA    , GL_UNSIGNED_BYTE, img.m_txdata);
glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, sx,sy, 0, GL_RGBA     , GL_UNSIGNED_BYTE, img.m_txdata);

}
#ifdef HAVE_OPENGL
#else
#endif
this->m_Surface[num].sizx[tx][ty]=sx;
this->m_Surface[num].sizy[tx][ty]=sy;
this->m_Surface[num].sizbx[tx][ty] = wx;
this->m_Surface[num].sizby[tx][ty] = wy;

tx++;
}

long from = bmpy-by-sy, to = bmpy-by;

this->m_Surface[num].usex=tx;
ty++; tx=0;
}
this->m_Surface[num].usey=ty;
#else // jus use a sprite
if(m_BackSurfaceSpriteID[num]==-1)
FreeSprite(m_BackSurfaceSpriteID[num]);
m_BackSurfaceSpriteID[num] = GenSprite();
GrabSprite(m_BackSurfaceSpriteID[num], 0,0,m_WND.virtw, m_WND.virth); // GF_TODO prescaler - I think it's not gonna work...
#endif
#endif



}

#ifdef EMSCRIPTEN
#define glReadBuffer(a) {} // bug in Firefox. Not required in HTML5?
#endif

// ------------------------------------------------------------- //
// Get a Pixel's color (approximately)
// ------------------------------------------------------------- //
COLORREF OpenGLRainbows::GetPixel(int x, int y)
{
Rot_Display2Screen(x, y, &x, &y);

#if defined(TINYGL) || defined(TRENKI3D)
return UnPackColor(Screen.GetPixel(x,y));
#else
unsigned char RGBA_pix[4] = {0,0,0,0xff};

GLenum format = GL_RGBA;
if(m_bSupportBGRA_ext) format = GL_BGRA_EXT;

#if defined(HAVE_OPENGL)
if(m_CurrentFBO>=0)
{
glReadBuffer(GL_COLOR_ATTACHMENT0_EXT);
glReadPixels(x, m_Texture[m_FBuffer[m_CurrentFBO].m_SpriteIndex].bh-y-1, 1,1, format, GL_UNSIGNED_BYTE, (void*)RGBA_pix);
}
else
{
glReadBuffer(GL_BACK); // Select BackBuffer for reading
glReadPixels(x, m_WND.height-y-1, 1,1, format, GL_UNSIGNED_BYTE, (void*)RGBA_pix);
}
#elif defined(HAVE_OPENGL_ES)
glReadPixels(x, m_WND.height-y-1, 1,1, format, GL_UNSIGNED_BYTE, (void*)RGBA_pix);
#endif

if(m_bSupportBGRA_ext)
{
return RGB(RGBA_pix[2], RGBA_pix[1], RGBA_pix[0]);
}
return RGB(RGBA_pix[0], RGBA_pix[1], RGBA_pix[2]);
#endif
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::DrawPixel(int sx, int sy, COLORREF col)
{
#if defined(TINYGL) || defined(TRENKI3D)
Screen.PutPixel((int)sx,(int)sy, PackColor(col));
#else
#if 1 // #ifdef HAVE_OPENGL_ES // other code is breaking or not really a speedup...
DrawRect(sx,sy,1,1,col);
return;
#else
if(this->m_WND.virtw != m_WND.virth)
{
DrawRect(sx,sy,1,1,col);
return;
}


glbColor4f(	(1.0f/255.0f)*(float)GetRValue(col),
(1.0f/255.0f)*(float)GetGValue(col),
(1.0f/255.0f)*(float)GetBValue(col),
col == m_CookieColor ? 0.0f : m_falpha);

// static int oldtex[3]; oldtex[0]=m_Texture3D[0]; oldtex[1]=m_Texture3D[1]; oldtex[2]=m_Texture3D[2];
SetTexture3D(-1, -1, 0);

#if 1 // always - old code crashes.
// int pts[] = {static_cast<int>((float)sx), static_cast<int>((float)sy)};
int pts[] = {sx, sy}; // static_cast<int>((float)sx), static_cast<int>((float)sy)};
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer( 2, GL_FLOAT, 0, (char*)pts);
glDrawArrays(GL_POINTS, 0, 1);
glDisableClientState( GL_VERTEX_ARRAY );
#else
// GF: 2015-Aug this crashes on my PC. (gfx card driver update?)
glMatrixMode(GL_PROJECTION); glPushMatrix(); glTranslatef(0.375, 0.375, 0); glMatrixMode(GL_MODELVIEW);
glBegin(GL_POINTS);
glVertex2i(sx, sy);
glEnd();
glMatrixMode(GL_PROJECTION); glPopMatrix(); glMatrixMode(GL_MODELVIEW);
#endif

glbColor4f(1.0f, 1.0f, 1.0f, m_falpha);
// Restore state
// SetTexture3D(oldtex[0], oldtex[1], oldtex[2]);
#endif

#endif
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::DrawLine(int sx, int sy, int ex, int ey, COLORREF col)
{
#if defined(TINYGL) || defined(TRENKI3D)
Screen.DrawLine((int)sx,(int)sy,(int)ex,(int)ey,PackColor(col));
#else
#if defined(HAVE_OPENGL_ES)
//glbEnable(GL_COLOR_MATERIAL);
SetTexture3D(-1, -1, 0);

glMatrixMode(GL_PROJECTION); glPushMatrix(); glTranslatef(0.375, 0.375, 0); glMatrixMode(GL_MODELVIEW);

unsigned char cols[8]= {(unsigned char)GetRValue(col),
(unsigned char)GetGValue(col),
(unsigned char)GetBValue(col),
static_cast<unsigned char>(col == m_CookieColor ? 0 : (unsigned char)(255.0f*m_falpha))};
cols[4]=cols[0];
cols[5]=cols[1];
cols[6]=cols[2];
cols[7]=cols[3];

float pts[] = {(float)sx,(float)sy,(float)ex,(float)ey};
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer( 2, GL_FLOAT, 0, (char*)pts);

glEnableClientState(GL_COLOR_ARRAY);
glColorPointer(4, GL_UNSIGNED_BYTE, 0, (char*)&cols[0]);

glDrawArrays(GL_LINES, 0, 2);

glDisableClientState( GL_VERTEX_ARRAY );
glDisableClientState( GL_COLOR_ARRAY );

glMatrixMode(GL_PROJECTION); glPopMatrix(); glMatrixMode(GL_MODELVIEW);
#else
glbColor4f(	(1.0f/255.0f)*(float)GetRValue(col),
(1.0f/255.0f)*(float)GetGValue(col),
(1.0f/255.0f)*(float)GetBValue(col),
col == m_CookieColor ? 0.0f : m_falpha);
// static int oldtex[3]; oldtex[0]=m_Texture3D[0]; oldtex[1]=m_Texture3D[1]; oldtex[2]=m_Texture3D[2];
SetTexture3D(-1, -1, 0);
glMatrixMode(GL_PROJECTION); glPushMatrix(); glTranslatef(0.375, 0.375, 0); glMatrixMode(GL_MODELVIEW);
glBegin(GL_LINES);
glVertex2i(sx, sy);
glVertex2i(ex, ey);
glEnd();
glBegin(GL_POINTS); glVertex2i(ex, ey); glEnd();
glMatrixMode(GL_PROJECTION); glPopMatrix(); glMatrixMode(GL_MODELVIEW);
glbColor4f(1.0f, 1.0f, 1.0f, m_falpha);
#endif

// Restore state
// SetTexture3D(oldtex[0], oldtex[1], oldtex[2]);
#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::DrawRect(int sx, int sy, int wx, int wy, COLORREF col)
{
// make wx, wy positive
if(wx<0){sx+=(wx+1); wx=-wx;}
if(wy<0){sy+=(wy+1); wy=-wy;}

#if defined(TINYGL) || defined(TRENKI3D)
Screen.PutRect((int)sx,(int)sy,(int)(wx), (int)(wy), PackColor(col));
#else
// Huh!? Polyvector is using glColor as well...?
#if 0 // defined(ANDROID) // polyvector workaround. May drivers don't allow glColor with polys
this->PolyStart(-1, 0);
this->PolyPoint(sx   , sy   , 0.0f, 0.0f, col);
this->PolyPoint(sx   , sy+wy, 0.0f, 0.0f, col);
this->PolyPoint(sx+wx, sy+wy, 0.0f, 0.0f, col);
this->PolyPoint(sx+wx, sy   , 0.0f, 0.0f, col);
this->PolyEnd();
return;
#else
glbColor4f(	(1.0f/255.0f)*(float)GetRValue(col),
(1.0f/255.0f)*(float)GetGValue(col),
(1.0f/255.0f)*(float)GetBValue(col),
col == m_CookieColor ? 0.0f : m_falpha);
SetTexture3D(-1, -1, 0);

float fsx=(float)sx;
float fsy=(float)sy;
float fex=(float)(sx+wx);
float fey=(float)(sy+wy);

// only required for lines and points
//		glMatrixMode(GL_PROJECTION); glPushMatrix(); glTranslatef(0.375f, 0.375f, 0.0f); glMatrixMode(GL_MODELVIEW);

float xyuv[]={	fsx,fey,0.0f,0.0f,
fex,fey,0.0f,0.0f,
fex,fsy,0.0f,0.0f,
fsx,fsy,0.0f,0.0f};

// alpha test/blending is handled by the user now. Default to blend, yes. test, no
// if(col == m_CookieColor) glbDisable(GL_ALPHA_TEST);
DrawQuad(xyuv);

//		glMatrixMode(GL_PROJECTION); glPopMatrix(); glMatrixMode(GL_MODELVIEW);
glbColor4f(1.0f, 1.0f, 1.0f, m_falpha);
// SetAlphaTesting(m_fAlphaTestingGTH);
#endif
#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::FreeSprite(int num)
{
if(num<0) return;

// #NPBUFFER
#if defined(TINYGL) || defined(TRENKI3D)
m_Sprite[num].Delete();
#else
#ifdef SPRITE_ALPHA_PIX_AS_VECTOR
SpritePix[num].Clear();
#else
if (SpritePix[num]) delete[] SpritePix[num];
SpritePix[num]=NULL;
#endif

this->SetTexture3D(-1, -1, 0); // make sure it's not bound
if (m_Texture[num].mipstate[0]) {glDeleteTextures(1, &m_Texture[num].mipstate[0]);}
if (m_Texture[num].mipstate[1]) {glDeleteTextures(1, &m_Texture[num].mipstate[1]);}
#endif
m_Texture[num].mipstate[0]=0;
m_Texture[num].mipstate[1]=0;
m_Texture[num].w=-1;
m_Texture[num].h=-1;
m_Texture[num].bw=0;
m_Texture[num].bh=0;
m_Texture[num].txx=1.0f;
m_Texture[num].txy=1.0f;
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::FreeSurface(int num)
{
if(num<0) return;
#if defined(TINYGL) || defined(TRENKI3D)
m_Surface[num].Delete();
#else

#ifdef GLB_SURFACE_OLDSCHOOL
for (int x=0; x<this->m_Surface[num].usex; x++)
{
for (int y=0; y<this->m_Surface[num].usey; y++)
{
if(m_Surface[num].txt[x][y])
glDeleteTextures(1, &m_Surface[num].txt[x][y]);
}
}
memset(&m_Surface[num], 0, sizeof(OPENGL_RAINBOWS_SURFACE));
#else // jus use a sprite
FreeSprite(m_BackSurfaceSpriteID[num]);
m_BackSurfaceSpriteID[num]=-1;
#endif


#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::FreeAll()
{
int	i;
for (i=0; i<GLR_MAX_TEXTURES; i++)	this->FreeSprite(i);
for (i=0; i<GLR_MAX_SURFACE; i++)	this->FreeSurface(i);
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
int OpenGLRainbows::GenSprite()
{
for(DGNat i=GLR_MAX_TEXTURES - GLR_MAX_FONT-1; i>=0; --i)
if(GetSpriteSize(i).cx == 0)
return i;
return -1;
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
int OpenGLRainbows::GenFont()
{
for(DGNat i=GLR_MAX_FONT - 1; i>=0; --i)
if(GetFontSize(i).cx == 0)
return i;
return -1;
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
int OpenGLRainbows::GenFBuffer()
{
for(DGNat i=GLR_MAX_FRAMEBUFFER - 1; i>=0; --i)
if(m_FBuffer[i].m_Width == 0 || m_FBuffer[i].m_SpriteIndex<0 )
return i;
return -1;
}


// ------------------------------------------------------------- //
// SAVE BMP FILE
// ------------------------------------------------------------- //
bool OpenGLRainbows::SaveBMPFile (const char* szFilename)
{
int id = GenSprite();
if(id==-1) return false;
if(!this->GrabSprite(id, 0,0,m_WND.width, m_WND.height))
return false;
bool ok = this->SaveBMPSprite(id, szFilename);
this->FreeSprite(id);
return ok;
}

// ------------------------------------------------------------- //
// get the sprite's texture (visible size)
// ------------------------------------------------------------- //
bool OpenGLRainbows::GetSpriteRGBA(int nSprite, OPENGL_IMAGE& img)
{
SIZE sz = GetSpriteSize(nSprite);
SIZE realsz = sz;
if(sz.cx==0 || sz.cy==0) return false;

#ifdef GLREAD_POWER_OF_2
int pw2sx=1, pw2sy=1;
do{pw2sx<<=1;} while(pw2sx < sz.cx);
do{pw2sy<<=1;} while(pw2sy < sz.cy);

sz.cx = pw2sx;
sz.cy = pw2sy;
#endif

img.resize((int)sz.cx, (int)sz.cy);
#if defined(TINYGL) || defined(TRENKI3D)
oBitmap& bmp = m_Sprite[nSprite];

unsigned char* pT = img.m_txdata;
for(int y=0; y<bmp.m_Height; ++y)
for(int x=0; x<bmp.m_Width; ++x)
{
unsigned short* pC = bmp.Pixels() + x + (sz.cy-1-y)*bmp.m_Width;
*pT++ = (unsigned char)GETB(*pC);
*pT++ = (unsigned char)GETG(*pC);
*pT++ = (unsigned char)GETR(*pC);
*pT++ = (*pC == bmp.m_colorkey) ? 0 : 255;
}
img.flipy();
#else
// Use a PBuffer and glReadPixels
if(m_CurrentFBO >=0)
FBO_end();

FBUFFER pbuffer;
if(pbuffer.Create(m_Texture[nSprite].w, m_Texture[nSprite].h, m_Texture[nSprite].mipstate[0], false))
{
pbuffer.Bind(); // bind mip-mapping texture
glReadPixels(0,0, (int)sz.cx, (int)sz.cy, GL_RGBA, GL_UNSIGNED_BYTE, &img.m_txdata[0] ); // #NEED hogs memory with GCC :(
pbuffer.Unbind();
img.clip((int)realsz.cx, (int)realsz.cy);
img.flipy();
}
#endif
return true;
}


// ------------------------------------------------------------- //
// Save the sprite's texture (visible size) as a bmp file
// ------------------------------------------------------------- //
bool OpenGLRainbows::SaveBMPSprite( int nSprite, const char* szFilename)
{
/*
bool flipy=false;
#if defined(TINYGL) || defined(TRENKI3D)
flipy=true;
oBitmap& bmp = m_Sprite[nSprite];

unsigned char* pPixl = new unsigned char [bmp.m_Width*bmp.m_Height*3];
unsigned char* pT = pPixl;
for(int y=0; y<bmp.m_Height; ++y)
for(int x=0; x<bmp.m_Width; ++x)
{
unsigned short* pC = bmp.Pixels() + x + y*bmp.m_Width;
*pT++ = (unsigned char)GETB(*pC);
*pT++ = (unsigned char)GETG(*pC);
*pT++ = (unsigned char)GETR(*pC);
}
#else
glBindTexture(GL_TEXTURE_2D, m_Texture[nSprite].mipstate[0]);
int sz = m_Texture[nSprite].w * m_Texture[nSprite].h * 3;
unsigned char* pPixl = new unsigned char [sz];

#if defined(HAVE_OPENGL)
glGetTexImage(GL_TEXTURE_2D, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE, pPixl);
#elif defined(HAVE_OPENGL_ES)
// #NEED
#endif
#endif
*/

OPENGL_IMAGE img;
if(!GetSpriteRGBA(nSprite, img))
return false;

bool rv = SaveImageFile(szFilename, img); // SaveMemoryToBMP(szFilename, pPixl, m_Texture[nSprite].bw, m_Texture[nSprite].bh, m_Texture[nSprite].w, m_Texture[nSprite].h, flipy); if (pPixl) delete [] pPixl;
return rv;
}



// ------------------------------------------------------------- //
// Save a memory buffer to a BMP file
// real_width/height = number of BGR tripples(pixels) width of written image
// width_of_buffer   = number of BGR tripples(pixels) for each line in the buffer
// flip_at_y         = is the first pixel upper left corner ? true : false
// ------------------------------------------------------------- //
bool OpenGLRainbows::SaveImageFile(	const char* szFilename, OPENGL_IMAGE& img)
{
#ifdef HAS_PNG_LIB
#define LOWR(c) (((c)>='A' && (c)<='Z') ? ((c)-'A'+'a') : ((c)))

// reverse to BGRA
int lng = (int)strlen(szFilename);
if (lng>4 &&
szFilename[lng-4] == '.' &&
((
LOWR(szFilename[lng-3]) == 'p' && 
LOWR(szFilename[lng-2]) == 'n' &&
LOWR(szFilename[lng-1]) == 'g'
)
||
(
LOWR(szFilename[lng-3]) == 'j' && 
LOWR(szFilename[lng-2]) == 'p' &&
LOWR(szFilename[lng-1]) == 'g'
))
)
{
// txdata = BGRA
int ok;
if(LOWR(szFilename[lng-3]) == 'j')
{
img.swap_red_blue();
ok = gf_write_jpeg(szFilename, img.m_txdata, img.m_sizex, img.m_sizey);
}
else
{
ok = gf_write_png(szFilename, img.m_txdata, img.m_sizex, img.m_sizey);
}

// delete[] txdata;
return ok?true:false;
}
#endif
//	img.flipy();

BITMAPFILEHEADER fh;
BITMAPINFOHEADER bi;
// Make sure its not a NULL filename
if(szFilename == NULL)
return false;

GFFileSystem gs;
if(!gs.OpenOut(szFilename)) return false;

// Get 4 byte aligned width
#define BITS_PER_PIXEL 24
#define DWORD_24BIT_WIDTHBYTES_ALIGN( width )  ((( (width )* (BITS_PER_PIXEL/8)) + 3) & ~3 )

// Buffer sizes
int Height, WidthBytes, line_offset;//, Pitch;
Height = img.m_sizey;
WidthBytes = DWORD_24BIT_WIDTHBYTES_ALIGN( img.m_sizex );
line_offset = WidthBytes - img.m_sizex*3;

//Write the file header
((char *)&(fh . bfType))[0] = 'B';
((char *)&(fh . bfType))[1] = 'M';
fh . bfSize = (long)(sizeof (BITMAPINFOHEADER)+sizeof (BITMAPFILEHEADER)+WidthBytes*Height); //Size in BYTES
fh . bfReserved1 = 0;
fh . bfReserved2 = 0;
fh . bfOffBits = sizeof (BITMAPINFOHEADER)+sizeof (BITMAPFILEHEADER);
bi . biSize = sizeof (BITMAPINFOHEADER);
bi . biWidth =img.m_sizex;
bi . biHeight =img.m_sizey;
bi . biPlanes = 1;
bi . biBitCount = BITS_PER_PIXEL;
bi . biCompression = BI_RGB;
bi . biSizeImage = 0;
bi . biXPelsPerMeter = 10000;
bi . biYPelsPerMeter = 10000;
bi . biClrUsed = 0;
bi . biClrImportant = 0;

// gs.Write((void *) &fh, sizeof (BITMAPFILEHEADER)); // byte alignment changed to 4 bytes on android!!!
gs.WriteWord(fh.bfType);
gs.WriteLong(fh.bfSize);
gs.WriteWord(fh.bfReserved1);
gs.WriteWord(fh.bfReserved2);
gs.WriteLong(fh.bfOffBits);

// gs.Write((void *) &bi, sizeof (BITMAPINFOHEADER));
gs.WriteLong(bi.biSize);
gs.WriteLong(bi.biWidth);
gs.WriteLong(bi.biHeight);
gs.WriteWord(bi.biPlanes);
gs.WriteWord(bi.biBitCount);
gs.WriteLong(bi.biCompression);
gs.WriteLong(bi.biSizeImage);
gs.WriteLong(bi.biXPelsPerMeter);
gs.WriteLong(bi.biYPelsPerMeter);
gs.WriteLong(bi.biClrUsed);
gs.WriteLong(bi.biClrImportant);

// txdata = BGR
BYTE* txdata = new BYTE[WidthBytes*Height + 4];

for(int y = 0; y<img.m_sizey; ++y)
{
for(int x=0; x<img.m_sizex; ++x)
{
int ps, pd;
//	ps = x*3 + (Height-y-1)*WidthBytes; // inverse Y coord for BMP format
ps = x*3 + y*WidthBytes; // inverse Y coord for BMP format
pd = x + (img.m_sizey-y-1)*img.m_sizex;

// Fix Cookie Color to default GLBasic Cookie Color
const unsigned char* pPixl = (const unsigned char*)&img.m_txdata[pd*4];
if(pPixl[3]<255)
{
txdata[ps  ] = 128; // BGR
txdata[ps+1] = 0;
txdata[ps+2] = 255;
}
else
{
txdata[ps  ] = pPixl[2];
txdata[ps+1] = pPixl[1];
txdata[ps+2] = pPixl[0];
}
}
}
gs.Write(txdata, WidthBytes*Height);
gs.Close();
if (txdata) delete[] txdata;
return true;
}





void OpenGLRainbows::ClearScreen(COLORREF col)
{
if(col == (COLORREF)-1)
{
m_bHasClearColor = false;
}
else
{
m_bHasClearColor = true;
#if defined(TINYGL) || defined(TRENKI3D)
Screen.SetClearColor(col);
Screen.Clear();
#else
float alpha=1.0f;
if(col == m_CookieColor)
alpha = 0.0f;

glClearColor(((BYTE) (col)) / 255.0f,
((BYTE) (((WORD) (col)) >> 8)) / 255.0f,
((BYTE) ((col) >> 16)) / 255.0f,
alpha
);
glClear(GL_COLOR_BUFFER_BIT);
#endif
}
}


void OpenGLRainbows::Rot_Screen2Display(int x, int y, int* pX, int* pY)const
{
switch(m_landscape)
{
default: // case 0:
*pX=x;               *pY=y; break;
case 1:
*pX=m_WND.width-1-y; *pY=x; break;
case 2:
*pX=m_WND.width-1-x; *pY=m_WND.height-1 - y; break;
case 3:
*pX=y;               *pY=m_WND.height-1 - x; break;
}
}

void OpenGLRainbows::Rot_Display2Screen(int x, int y, int* pX, int* pY)const
{
switch(m_landscape)
{
default: // case 0:
*pX=x;               *pY=y; break;
case 1:
*pX=y;               *pY=m_WND.width-1-x;break;
case 2:
*pX=m_WND.width-1-x; *pY=m_WND.height-1-y; break;
case 3:
*pX=m_WND.height-1-y;*pY=x;  break;
}
}

void OpenGLRainbows::Rot_Gravity2Display(int x, int y, int* pX, int* pY)const
{
switch(m_landscape)
{
default: // case 0:
*pX=x;  *pY=y;  break;
case 1:
*pX=-y;  *pY=x; break;
case 2:
*pX=-x; *pY=-y; break;
case 3:
*pX=y; *pY=-x;  break;
}
}



// rect: touch->screen (must be normalized)
void OpenGLRainbows::Rot_Screen2Display(int x, int y, int w, int h, int* pX, int* pY, int* pW, int* pH)const
{
Rot_Screen2Display(x,y,  pX, pY);
switch(m_landscape)
{
default:
*pW=w; *pH=h; break;
case 1:
*pW=-h; *pH=w; break;
case 2:
*pW=-w; *pH=-h; break;
case 3:
*pW=h; *pH=-w; break;
}
}
// rect: screen->touch (must be normalized)
void OpenGLRainbows::Rot_Display2Screen(int x, int y, int w, int h, int* pX, int* pY, int* pW, int* pH)const
{
Rot_Screen2Display(x,y,  pX, pY);
switch(m_landscape)
{
default:
*pW=w; *pH=h; break;
case 1:
*pW=h; *pH=-w; break;
case 2:
*pW=-w; *pH=-h; break;
case 3:
*pW=-h; *pH=w; break;
}
}


// ------------------------------------------------------------- //
// Start drawing in 2D
// x,y,w,h - pixels on the physical screen
// ------------------------------------------------------------- //
void OpenGLRainbows::Make2DViewport(int x, int y, int w, int h, float scale)
{
#if defined(TINYGL) || defined(TRENKI3D)
if(w<=0 || h<=0)
{
if(m_CurrentFBO==-1)
{
w=Screen.getWidth(); h=Screen.getHeight();
}
else
{
const oBitmap& obmp = m_Sprite[m_FBuffer[m_CurrentFBO].m_SpriteIndex];
w = obmp.m_Width; // width of sprite image
h = obmp.m_Height; // height of sprite image
}
}

if(m_CurrentFBO==-1)
{
if(x+w > Screen.getWidth())  w=Screen.getWidth()-x;
if(y+h > Screen.getHeight()) h=Screen.getHeight()-y;
if(w<1) {x=Screen.getWidth()-1;  w=1;}
if(h<1) {y=Screen.getHeight()-1; h=1;}
}
else
{
const oBitmap& obmp = m_Sprite[m_FBuffer[m_CurrentFBO].m_SpriteIndex];
int bw = obmp.m_Width; // width of sprite image
int bh = obmp.m_Height; // height of sprite image
if(x+w > bw)  w=bw-x;
if(y+h > bh)  h=bh-y;
if(w<1) {x=bw-1;  w=1;}
if(h<1) {y=bh-1;  h=1;}
}


m_WND.viewport.x=x; m_WND.viewport.y=y; m_WND.viewport.width=w; m_WND.viewport.height=h;
Screen.Viewport(x,y,w,h);

#ifdef TRENKI3D
tglCullFace(GL_FRONT);
tglLoadIdentity();
tglEnableDepthTest(0);
tglViewport(x,y, w,h);
tglOrtho(0, w, h,0, -1.0f, 1.0f); // Move to upper left corner 0,0
#endif
#else
// Set Viewport to window dimensions
if(m_WND.virth == 0)
{
m_WND.virth=m_WND.height;
m_WND.virtw=m_WND.width;
}

if(w<=0 || h<=0)
{
x=0; y=0;
if(m_CurrentFBO==-1)
{
if(m_landscape==1 || m_landscape==3)
{
w=m_WND.virth;
h=m_WND.virtw;
}
else
{
w=m_WND.virtw;
h=m_WND.virth;
}
}
else
{
w = m_FBuffer[m_CurrentFBO].m_Width;
h = m_FBuffer[m_CurrentFBO].m_Height;
}
}

// w,h is device size -> might need to rotate
if(m_CurrentFBO==-1)
{
glMatrixMode(GL_PROJECTION);
OPENGL_CHECK_ERRORS();
switch(m_landscape)
{
default:	
{
glLoadIdentity();
// float matrix[16] = {1,0,0,0, 0,1,0,0,  0,0,1,0,  0,0,0,1 };
// glLoadMatrixf(matrix);
break;
}
case 1:
{
float matrix[16] = {0,-1,0,0, 1,0,0,0,  0,0,1,0,  0,0,0,1 };
glLoadMatrixf(matrix);
// int swp=w; w=h; h=swp;
break;
}
case 2:
{
float matrix[16] = {-1,0,0,0, 0,-1,0,0,  0,0,1,0,  0,0,0,1 };
glLoadMatrixf(matrix);
break;
}
case 3:
{
float matrix[16] = {0, 1,0,0, -1,0,0,0,  0,0,1,0,  0,0,0,1 };
glLoadMatrixf(matrix);
// int swp=w; w=h; h=swp;
break;
}
}

int vpx, vpy;
Rot_Screen2Display(x, y, w, h, &vpx, &vpy, &w, &h);

// must normalize
if(w<0)
{
vpx=vpx+w+1; w=-w;
}
if(h<0)
{
vpy=vpy+h+1; h=-h;
}


glMatrixMode(GL_PROJECTION);
OPENGL_CHECK_ERRORS();
// glLoadIdentity();
// glRotatef(-90  ,0,0,1);
if(m_landscape == 1 || m_landscape==3)
{
glViewport(vpx, m_WND.height-h-vpy, w,h);
OPENGL_CHECK_ERRORS();
my_glOrtho(0.0f, (float)h, (float)w, 0,  -1.0f, 1.0f); // Move to upper left corner 0,0
OPENGL_CHECK_ERRORS();
}
else
{
glViewport(vpx, m_WND.height-h-vpy, w, h);
OPENGL_CHECK_ERRORS();
my_glOrtho(0.0f, (float)w, (float)h, 0,  -1.0f, 1.0f); // Move to upper left corner 0,0
OPENGL_CHECK_ERRORS();
}
/*
//		glViewport(m_WND.width-1 -y-h , m_WND.height-w-x, h, w);
glViewport(m_WND.width -y-h , m_WND.height-w-x, h, w);
glMatrixMode(GL_PROJECTION);
// glLoadIdentity();
// glRotatef(-90  ,0,0,1);
float matrix[16] = {0,-1,0,0, 1,0,0,0,  0,0,1,0,  0,0,0,1 };
glLoadMatrixf(matrix);

glOrtho(0.0f, w, h, 0,  -1.0f, 1.0f); // Move to upper left corner 0,0
*/


// screen coords now (not device)
if(m_landscape==1 || m_landscape==3)
{
int swp=w; w=h; h=swp;
}
}
else // on FBO
{
int height;
if(m_CurrentFBO==-1)
height = m_WND.height;
else
{
height = m_Texture[m_FBuffer[m_CurrentFBO].m_SpriteIndex].bh; // height of sprite image
}
glViewport(x, height-h-y, w, h);
OPENGL_CHECK_ERRORS();
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
glOrtho(0.0f, (float)w, (float)h, 0.0f,  -1.0f, 1.0f); // Move to upper left corner 0,0
OPENGL_CHECK_ERRORS();
}
OPENGL_CHECK_ERRORS();

m_WND.viewport.x=x; m_WND.viewport.y=y; m_WND.viewport.width=w; m_WND.viewport.height=h;

//	glTranslatef(0.375, 0.375, 0); // Do this in DRAWLINE and FILLRECT
glMatrixMode(GL_MODELVIEW);
glLoadIdentity();
if(scale != 1.0f && m_CurrentFBO==-1)
{
glScalef(scale, scale, scale);
}
#endif
}

// ------------------------------------------------------------- //
// Make Default OpenGL settings for 2D mode. Puts viewport to full screen
// ------------------------------------------------------------- //
void OpenGLRainbows::Make2DMode()
{
Make2DViewport();

#if defined (HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
// Options for 2D Mode:
glbUnEnableAll(); OPENGL_CHECK_ERRORS();

// Enable textureing
glbDisable(GL_DEPTH_TEST);	// Drawing Order=Z-Order!
OPENGL_CHECK_ERRORS();
glbDisable(GL_CULL_FACE);	// No culling by default (for 2D anyway)
glFrontFace(GL_CCW);		// Counter clock-wise polygons face out
OPENGL_CHECK_ERRORS();

glbColor4f(1.0f, 1.0f, 1.0f, 1.0f);
OPENGL_CHECK_ERRORS();
// glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // alpha bits are set(=!cookiecolor) -> use ClearScreen() instead

glbDisable(GL_FOG);
glbDisable(GL_LINE_SMOOTH);
glbDisable(GL_POINT_SMOOTH);
OPENGL_CHECK_ERRORS();

glbDisable(GL_STENCIL_TEST);
glbDisable(GL_NORMALIZE);
glbDisable(GL_LIGHTING);
OPENGL_CHECK_ERRORS();
// Disable Antialaising
glShadeModel(GL_FLAT);
glbDisable(GL_COLOR_MATERIAL);
glbDisable(GL_DITHER);
OPENGL_CHECK_ERRORS();

#if defined(HAVE_OPENGL) && !defined(EMSCRIPTEN)
glbDisable(GL_POLYGON_SMOOTH);
glbDisable(GL_POLYGON_OFFSET_POINT);
glbDisable(GL_AUTO_NORMAL);
#endif

#if defined(HAVE_OPENGL) && !defined(EMSCRIPTEN)
glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
OPENGL_CHECK_ERRORS();
glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);
#endif
OPENGL_CHECK_ERRORS();
#endif
SetSmoothShading(true);

// glbEnable(GL_TEXTURE_2D);
SetTexture3D(-1, -1, 0);					// No Texture

// Cookie Cut - new defaults
#ifdef TRENKI3D
SetAlphaTesting( 0.05f );
DoAlpha( 0.0f );
#else
SetAlphaTesting( 1.0f ); // 0.05f was old default
DoAlpha(-1.0f);
#endif
}




// ------------------------------------------------------------- //
// Make Default Font (5x6)
// ------------------------------------------------------------- //
void OpenGLRainbows::DefaultFont(int num)
{
m_FontScaling[num] = 4.0;
OPENGL_IMAGE img;
img.MakeDefFont();

#if 0
if (this->m_WND.width>=640) {img.ScaleX2();}
#endif

#if defined(TINYGL) || defined(TRENKI3D)
m_Font[num].CreateBy(img);
#else
int num_tex = num + GLR_MAX_TEXTURES-GLR_MAX_FONT;

GLR_TEXTURE& txtr = m_Texture[num_tex];
MakeTexture(img, 0,0,0,0, &txtr.mipstate[0], NULL, false, true);
txtr.w=img.m_sizex; // Set Size of Texture
txtr.h=img.m_sizey;
txtr.bw=img.m_sizex; // Set Size of BMP File
txtr.bh=img.m_sizey;
txtr.txx=(float)txtr.bw/txtr.w;
txtr.txy=(float)txtr.bh/txtr.h;

for(int ic = 0; ic<256; ++ic)
{
GLR_FONTKERNING& K = m_FontKerning[num][ic];
K.xoff  = 0;
K.width = img.m_sizex/16;
int cx = ((ic%16) * txtr.bw)/16;
K.txa   = ((float) cx)            / (float)txtr.w;
K.txe   = ((float)(cx + K.width)) / (float)txtr.w;
}
#endif
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
SIZE OpenGLRainbows::GetSpriteSize(int num)
{
#if defined(TINYGL) || defined(TRENKI3D)
SIZE s; s.cx=m_Sprite[num].m_Width; s.cy=m_Sprite[num].m_Height; return s;
#else
SIZE s; s.cx=m_Texture[num].bw; s.cy=m_Texture[num].bh; return s;
#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
SIZE OpenGLRainbows::GetFontSize(int num)
{
#if defined(TINYGL) || defined(TRENKI3D)
SIZE s; s.cx=m_Font[num].m_cwidth; s.cy=m_Font[num].m_cheight; return s;
#else
num += (GLR_MAX_TEXTURES-GLR_MAX_FONT);
SIZE s; s.cx=m_Texture[num].bw/16; s.cy=m_Texture[num].bh/8;
// 256 char set
if(m_Texture[num].bw < m_Texture[num].bh)
s.cy/=2;
return s;
#endif
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void OpenGLRainbows::ShowDemo(int xpos, float alpha)
{
#if defined(TINYGL) || defined(TRENKI3D)
#define DRWLINE(a,b,c,d,e) Screen.DrawLine((short)(a+xpos), (short)b,(short)(c+xpos),(short)(d),e)
Screen.Alphamode(255);
unsigned short c = PackColor(255,255,255), c2 = PackColor(0,255,128);
DRWLINE(0,0,4,4,c);
DRWLINE(0,0,0,9,c);
DRWLINE(0,9,4,4,c);

DRWLINE(5,0,9,0,c2);
DRWLINE(5,0,5,9,c2);
DRWLINE(5,9,9,9,c2);
DRWLINE(7,3,9,3,c2);
DRWLINE(7,6,9,6,c2);

DRWLINE(11,0,15,0,c);
DRWLINE(11,0,11,9,c);
DRWLINE(15,0,15,9,c);
DRWLINE(13,3,13,9,c);
DRWLINE(15,3,15,9,c);

DRWLINE(17,0,21,0,c);
DRWLINE(17,0,17,9,c);
DRWLINE(21,0,21,9,c);
DRWLINE(17,9,21,9,c);
#else
static BYTE tmap[1536] = {
59,72,209,56,68,196,51,63,182,47,59,169,44,54,155,40,49,141,36,44,128,32,39,114,28,34,100,24,30,87,20,24,73,16,20,59,12,15,46,8,10,32,4,6,18,0,1,5,
63,77,223,61,74,213,56,69,198,52,64,184,48,59,169,44,53,154,39,48,139,35,43,124,31,38,109,27,33,95,22,27,80,18,22,65,14,17,50,9,12,35,5,7,20,2,3,7,
63,77,215,68,80,201,97,106,199,95,103,189,96,103,178,88,95,164,85,91,153,82,87,143,79,83,133,76,80,123,73,76,112,73,75,105,70,72,95,65,67,83,44,45,56,13,13,17,
60,73,209,60,72,201,201,202,219,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,254,253,253,253,89,89,96,1,1,6,
57,70,202,57,70,202,102,110,196,253,253,253,253,253,253,254,254,254,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,253,194,194,197,6,7,20,1,1,6,
55,68,195,55,68,195,55,68,193,190,193,223,188,194,214,21,66,196,14,63,206,12,61,204,12,61,204,12,61,204,17,66,210,67,96,182,242,242,242,56,58,72,5,7,20,1,1,6,
53,65,187,53,65,187,53,65,187,84,92,184,247,247,248,77,107,197,0,57,224,0,57,224,0,57,224,0,57,224,1,55,212,182,190,212,148,148,156,10,12,36,5,7,20,1,1,6,
51,63,180,51,63,180,51,63,180,50,62,179,160,164,207,224,227,234,171,182,214,162,173,202,162,173,206,165,176,208,185,192,216,234,235,235,33,36,61,9,12,35,5,7,20,1,1,6,
49,60,172,49,60,172,49,60,172,49,60,172,59,69,170,225,226,235,165,204,196,59,207,176,55,211,178,73,204,176,240,241,241,134,136,151,14,17,50,9,12,35,5,7,20,1,1,6,
47,57,165,47,57,165,47,57,165,47,57,165,46,56,164,106,111,164,236,239,238,25,222,181,0,253,200,116,211,191,227,227,230,32,36,74,14,17,50,9,12,35,5,7,20,1,1,6,
45,55,158,45,55,158,45,55,158,45,55,158,45,55,158,43,52,148,184,185,198,184,223,214,121,206,188,242,242,242,110,112,139,18,22,65,14,17,50,9,12,35,5,7,20,1,1,6,
42,52,150,42,52,150,42,52,150,42,52,150,42,52,150,42,51,149,76,82,145,249,249,250,254,254,254,201,202,212,24,29,80,18,22,65,14,17,50,9,12,35,5,7,20,1,1,6,
40,50,143,40,50,143,40,50,143,40,50,143,40,50,143,40,50,143,39,48,138,161,163,188,244,244,244,68,73,116,22,27,80,18,22,65,14,17,50,9,12,35,5,7,20,1,1,6,
38,47,135,38,47,135,38,47,135,38,47,135,38,47,135,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,14,17,50,9,12,35,5,7,20,1,1,6,
36,44,128,36,44,128,36,44,128,36,44,128,36,44,128,255,255,255,36,44,128,36,44,124,36,42,110,27,33,95,22,27,80,255,255,255,14,17,50,9,12,35,5,7,20,1,1,6,
34,41,121,34,41,121,34,41,121,34,41,121,34,41,121,255,255,255,40,50,143,34,41,120,31,38,109,27,33,95,40,50,143,255,255,255,14,17,50,9,12,35,5,7,20,1,1,6,
32,39,113,32,39,113,32,39,113,32,39,113,32,39,113,40,50,143,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,40,50,143,14,17,50,9,12,35,5,7,20,1,1,6,
30,37,106,30,37,106,30,37,106,30,37,106,30,37,106,30,37,106,30,37,106,30,37,106,29,36,105,27,33,95,22,27,80,18,22,65,14,17,50,9,12,35,5,7,20,1,1,6,
28,34,98,28,34,98,28,34,98,28,34,98,28,34,98,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,14,17,50,9,12,35,5,7,20,1,1,6,
25,31,91,25,31,91,25,31,91,25,31,91,25,31,91,255,255,255,25,31,91,25,31,91,255,255,255,25,30,90,22,27,80,255,255,255,14,17,50,9,12,35,5,7,20,1,1,6,
23,29,84,23,29,84,23,29,84,23,29,84,23,29,84,255,255,255,23,29,84,23,29,84,23,29,84,23,29,83,22,27,79,255,255,255,14,17,50,9,12,35,5,7,20,1,1,6,
21,26,76,21,26,76,21,26,76,21,26,76,21,26,76,21,26,76,21,26,76,21,26,76,21,26,76,21,26,76,21,25,75,18,22,65,14,17,50,9,12,35,5,7,20,1,1,6,
19,24,69,19,24,69,19,24,69,19,24,69,19,24,69,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,14,17,50,9,12,35,5,7,20,1,1,6,
17,21,61,17,21,61,17,21,61,17,21,61,17,21,61,255,255,255,17,21,61,17,21,61,17,21,61,17,21,61,17,21,61,16,20,60,14,17,50,9,12,35,5,7,20,1,1,6,
15,18,54,15,18,54,15,18,54,15,18,54,15,18,54,255,255,255,255,255,255,255,255,255,255,255,255,15,18,54,15,18,54,15,18,54,13,16,49,9,12,35,5,7,20,1,1,6,
13,16,46,13,16,46,13,16,46,13,16,46,13,16,46,255,255,255,13,16,46,13,16,46,13,16,46,13,16,46,13,16,46,13,16,46,12,15,45,9,12,35,5,7,20,1,1,6,
10,13,39,10,13,39,10,13,39,10,13,39,10,13,39,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,10,13,39,9,11,34,5,7,20,1,1,6,
8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,11,32,8,10,31,5,7,20,1,1,6,
6,8,24,6,8,24,6,8,24,6,8,24,6,8,24,96,96,96,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,96,96,96,6,8,24,6,8,24,5,6,20,1,1,6,
4,5,17,4,5,17,4,5,17,4,5,17,4,5,17,255,255,255,96,96,96,4,5,17,4,5,17,4,5,17,96,96,96,255,255,255,4,5,17,4,5,17,3,4,16,1,1,6,
2,3,9,2,3,9,2,3,9,2,3,9,2,3,9,255,255,255,96,96,96,2,3,9,2,3,9,2,3,9,96,96,96,255,255,255,2,3,9,2,3,9,2,3,9,0,1,5,
0,0,2,0,0,2,0,0,2,0,0,2,0,0,2,96,96,96,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,96,96,96,0,0,2,0,0,2,0,0,2,0,0,1
};
static GLuint num=0;
if(num==0)
{
glGenTextures(1, &num);
glBindTexture(GL_TEXTURE_2D, num);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA , 16,32, 0, GL_RGB, GL_UNSIGNED_BYTE, tmap);
}
SetTexture3D(0, -1, 0);

glEnable(GL_TEXTURE_2D);
//glbEnable(GL_COLOR_MATERIAL);
glBindTexture(GL_TEXTURE_2D, num);
glbColor4f(1.0f, 1.0f, 1.0f, 1.0f);

DoAlpha(alpha);

float w, h;
if(m_WND.width>500)
{
w=160.0f; h=80.0f;
}
else
{
w=80.0f; h=40.0f;
}
float xyuv[] = {
w+float(xpos-100),     h, 1.0f, 1.0f,
w+float(xpos-100),  0.0f, 0.0f, 1.0f,
(float)(xpos-100),  0.0f, 0.0f, 0.0f,
(float)(xpos-100),     h, 1.0f, 0.0f
};
DrawQuad(xyuv);
// glDeleteTextures(1, &num);
DoAlpha(0);
#endif
}



/// EGL - Wrappers




#if defined(HAVE_OPENGL_ES) && !defined(_DEBUG)

// wrapper for EGL - otherwise code is totally unreadable
struct EGL_VECTOR
{
GLfloat x,y,z,w;
GLfloat u,v;
unsigned char r,g,b,a;
};
EGL_VECTOR	gState= {0.0f,0.0f,0.0f,0.0f,  0.0f,0.0f,  255,255,255,255};
Queue<EGL_VECTOR>	gEGLvecs;
int                 gEGLmode=0;
void eglBegin(int mode)
{
gEGLmode = mode;
gEGLvecs.Clear(false);
}
void eglVertex3fv(const float* pv)
{
gState.x=*pv++;
gState.y=*pv++;
gState.z=*pv;
gEGLvecs.Push(gState);
}
void eglVertex4fv(const float* pv)
{
gState.x=*pv++;
gState.y=*pv++;
gState.z=*pv++;
gState.w=*pv;
gEGLvecs.Push(gState);
}
void eglVertex4f(float x, float y, float z, float w)
{
gState.x=x;
gState.y=y;
gState.z=z;
gState.w=z;
gEGLvecs.Push(gState);
}

void eglEnd()
{
extern int g_nTexture; // the value you pass to X_MAKE3D(here, ...)

glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer( 4, GL_FLOAT, sizeof(EGL_VECTOR), (char*)&gEGLvecs[0].x);
if(g_nTexture>=0)
{
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(EGL_VECTOR), (char*)&gEGLvecs[0].u);
}

// Render stuff
switch(gEGLmode)
{
case GL_QUADS:
{
for(int i=0; i<(int)gEGLvecs.Size(); i+=4)
{
glDrawArrays(GL_TRIANGLE_FAN, i, 4);
}
break;
}
case GL_LINES:
{
glDisableClientState( GL_TEXTURE_COORD_ARRAY );				// Disable Texture Coord Arrays
glDrawArrays(GL_LINES, 0, (int)(gEGLvecs.Size()));
break;
}
case GL_POINTS:
{
glDisableClientState( GL_TEXTURE_COORD_ARRAY );				// Disable Texture Coord Arrays
glDrawArrays(GL_POINTS, 0, (int)gEGLvecs.Size());
break;
}
default:
glDrawArrays(gEGLmode, 0, gEGLvecs.Size());	// Draw All Of The Triangles At Once
}
// Disable Pointers
glDisableClientState( GL_VERTEX_ARRAY );					// Disable Vertex Arrays
glDisableClientState( GL_TEXTURE_COORD_ARRAY );				// Disable Texture Coord Arrays

gEGLvecs.Clear(false);
}
#define glBegin eglBegin
#define glVertex3fv eglVertex3fv
#define glVertex4fv eglVertex4fv
#define glVertex4f eglVertex4f
#define glEnd eglEnd
#endif

#else // console
void glb_rainbows_console_dummy() {};
#endif // GLB_CONSOLE

// Rainbows3D.cpp: Implementierung der Klasse Rainbows3D.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h" // #include "stdafx.h"

#ifndef GLB_CONSOLE

#include "rainbows3d.h" // #include "rainbows3d.h"
#include "openglrainbows.h" // #include "openglrainbows.h"

#include <math.h>			// sqrt
#include "gffilesystem.h" // #include "gffilesystem.h"


#if defined(HAVE_OPENGL) || (defined(HAVE_OPENGL_ES) && defined(_DEBUG))
// OpenGL extensions required
extern PFNGLACTIVETEXTUREARBPROC		glActiveTextureArb; // Texture Unit
extern PFNGLCLIENTACTIVETEXTUREARBPROC	glClientActiveTextureArb;  // Vertex Array Unit
extern PFNGLMULTITEXCOORD2FARBPROC		glMultiTexCoord2fArb;
// VBO Extension Function Pointers
extern PFNGLGENBUFFERSARBPROC			glGenBuffersArb;			// VBO Name Generation Procedure
extern PFNGLBINDBUFFERARBPROC			glBindBufferArb;			// VBO Bind Procedure
extern PFNGLBUFFERDATAARBPROC			glBufferDataArb;			// VBO Data Loading Procedure
extern PFNGLDELETEBUFFERSARBPROC		glDeleteBuffersArb;			// VBO Deletion Procedure
extern PFNGLMAPBUFFERARBPROC			glMapBufferArb;
extern PFNGLUNMAPBUFFERARBPROC			glUnmapBufferArb;
extern PFNGLGETBUFFERPARAMETERIVARBPROC	glGetBufferParameterivArb;

// GLSL
extern PFNGLCREATEPROGRAMOBJECTARBPROC     glCreateProgramObjectArb;
extern PFNGLDELETEOBJECTARBPROC            glDeleteObjectArb;
extern PFNGLCREATESHADEROBJECTARBPROC      glCreateShaderObjectArb;
extern PFNGLSHADERSOURCEARBPROC            glShaderSourceArb;
extern PFNGLCOMPILESHADERARBPROC           glCompileShaderArb;
extern PFNGLGETOBJECTPARAMETERIVARBPROC    glGetObjectParameterivArb;
extern PFNGLATTACHOBJECTARBPROC            glAttachObjectArb;
extern PFNGLGETINFOLOGARBPROC              glGetInfoLogArb;
extern PFNGLLINKPROGRAMARBPROC             glLinkProgramArb;
extern PFNGLUSEPROGRAMOBJECTARBPROC        glUseProgramObjectArb;
extern PFNGLGETUNIFORMLOCATIONARBPROC      glGetUniformLocationArb;
extern PFNGLUNIFORM1FARBPROC               glUniform1fArb;
extern PFNGLUNIFORM1IARBPROC               glUniform1iArb;
extern PFNGLGETATTRIBLOCATIONARBPROC       glGetAttribLocationArb;
extern PFNGLVERTEXATTRIB1FARBPROC          glVertexAttrib1fArb;
#endif


// GLOBALS
int				gCurObject=-1;		// For Creation



// ------------------------------------------------------------------ //
// Preapare a triangle VBO buffer for the objects
// created frron nodes, not xnodes!!
// ------------------------------------------------------------------ //
void MeshObjectX::PrepareTriangles()
{
POLY_NODE*	nods[3];
int i;
if (!m_Frames.Size()) return;

for (i=0; i<m_Frames.Size(); i++)
{
m_Frames.GetAt(i)->triangles.Clear(false);
m_Frames.GetAt(i)->triangles.AllocAtLeast(m_Frames.GetAt(i)->nodes.Size()/3);
long ndrawn=0; unsigned long mode=COL_NEW_TRI; unsigned long col;
long odd=0;
for (int j=0; j<m_Frames.GetAt(i)->nodes.Size(); j++)
{
POLY_FRAME& frm = m_Frames[i];
POLY_NODE& node = frm.nodes[j];
col = m_ColTable[node.icol];
switch (col)
{
case COL_NEW_TRI:  ndrawn=0; mode=COL_NEW_TRI;   continue;
case COL_NEW_STRIP:ndrawn=0; mode=COL_NEW_STRIP; odd=0; continue;
case COL_NEW_FAN:  ndrawn=0; mode=COL_NEW_FAN;   continue;
default:
;
// color is set to col
}
nods[ndrawn] = &frm.nodes[j];
// Uncompress(i, j, &nods[ndrawn]);
ndrawn++;
if (ndrawn>2)
{
m_Frames[i].triangles.Push(*nods[0]);
m_Frames[i].triangles.Push(*nods[1]);
m_Frames[i].triangles.Push(*nods[2]);
switch(mode)
{
case COL_NEW_TRI:  ndrawn=0; break;
case COL_NEW_STRIP:
/*
1    3     5

2    4     6

123
324
345
*/
ndrawn=2;
odd=1-odd;
if (odd)
{
nods[0]=nods[2];
}
else
{
nods[1]=nods[2];
}
break;
case COL_NEW_FAN:
ndrawn=2;
nods[1] = nods[2];
break;
}
}
}
}

m_tri_animation = m_Frames[0].triangles;
/*
m_tri_animation.Clear(false);
m_tri_animation.AllocAtLeast(m_Frames[0].triangles.Size());
for (i=0; i<m_Frames[0].triangles.Size(); i++)
m_tri_animation.Push(m_Frames[0].triangles[i]);
*/

// See if we need a color pointer, or just white
CheckIfColoringNeeded();


#if defined(TINYGL)
// Make a display list for TinyGL
m_glListIDs.SetSize(m_Frames.Size());
int liststart = glGenLists(m_Frames.Size());
for(i=0; i<m_Frames.Size(); ++i)
{
m_glListIDs[i] = liststart + i;
glNewList(m_glListIDs[i], GL_COMPILE);
glVertexPointer(3, GL_FLOAT, sizeof(POLY_NODE), m_Frames[i].triangles[0].pos);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_NODE), m_Frames[i].triangles[0].tex);
glColorPointer(3, GL_FLOAT, sizeof(POLY_NODE), m_Frames[i].triangles[0].fcol);
glDrawArrays(GL_TRIANGLES, 0, m_Frames[i].triangles.Size());
glEndList();
}
#elif defined(TRENKI3D)
// Make a display list for TinyGL
m_glListIDs.SetSize(m_Frames.Size());
int liststart = tglGenLists(m_Frames.Size());
struct VEC{
float xyz[3], n[3], uv[2];
unsigned char rgba[4];
};

VEC* pV = new VEC[m_Frames[0].triangles.Size()];
for(i=0; i<m_Frames.Size(); ++i)
{
m_glListIDs[i] = liststart + i;
int useRGBA = 0;
for(int it=0; it<(int)m_Frames[i].triangles.Size(); ++it)
{
pV[it].xyz[0] = m_Frames[i].triangles[it].pos[0];
pV[it].xyz[1] = m_Frames[i].triangles[it].pos[1];
pV[it].xyz[2] = m_Frames[i].triangles[it].pos[2];
pV[it].n[0] = m_Frames[i].triangles[it].normal[0];
pV[it].n[1] = m_Frames[i].triangles[it].normal[1];
pV[it].n[2] = m_Frames[i].triangles[it].normal[2];
pV[it].uv[0] = m_Frames[i].triangles[it].tex[0];
pV[it].uv[1] = m_Frames[i].triangles[it].tex[1];

pV[it].rgba[0] = (unsigned char)(m_Frames[i].triangles[it].dwcol>>16) & 0xff;
pV[it].rgba[1] = (unsigned char)(m_Frames[i].triangles[it].dwcol>> 8) & 0xff;
pV[it].rgba[2] = (unsigned char)(m_Frames[i].triangles[it].dwcol    ) & 0xff;
pV[it].rgba[3] = 255;
if(pV[it].rgba[0] != 255 || pV[it].rgba[1] != 255 || pV[it].rgba[2] != 255)
useRGBA = 1;
}

tglNewList(m_glListIDs[i]);
tglDrawArraysXYZ_UV_RGBA(GL_TRIANGLES, m_Frames[i].triangles.Size(), &pV[0].xyz[0], 1,1,1, useRGBA, 1);
tglEndList();
}
delete[] pV;
#endif
}

Queue<unsigned char> gCelShadeDate;
// --------------------------------------------------------------- //
// Set Cel Shading Policy
// --------------------------------------------------------------- //
void Rainbows3D::SetCelShades(unsigned char* pScales, int nscales)
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if(nscales<=0)
{
gCelShadeDate.SetSize(1);
gCelShadeDate[0]=255;
return;
}
gCelShadeDate.SetSize(nscales);
int i;
for(i=0; i<nscales; ++i)
{
gCelShadeDate[i] = *pScales++;
}
for(i=0; i<GLR_MAX_OBJECTS; ++i)
{
for(int j=0; j<(int)m_Objects[i].m_objects.Size(); ++j)
{
if(m_Objects[i].m_objects[j].obj.CelShadeTexture)
{
glDeleteTextures(1, &m_Objects[i].m_objects[j].obj.CelShadeTexture);
m_Objects[i].m_objects[j].obj.CelShadeTexture=0;
}
}
}
#endif
}

// --------------------------------------------------------------- //
// Make Cel-Shading Texture (for coloured objects and gray-scaling)
// --------------------------------------------------------------- //
void MeshObjectX::MakeCelShadeTexutre(bool bgra_ext)
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if(CelShadeTexture) return; // See also Clear() - I assume this is already done, here

int sy = m_ColTable.Size(), sx = 256;
// Create 2^n size
for (int exp=1; exp<32768; exp *= 2) if (exp >= sy){sy = exp; break;}
CelShadeColorScale = 1.0f/ (float)sy;

glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
#if defined(HAVE_OPENGL)
glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);
#endif
// Generate & Bind into Memory
glGenTextures(1, &CelShadeTexture);
glBindTexture(GL_TEXTURE_2D, CelShadeTexture);
// Set Texture mapping parameters
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); // GL_NEAREST); // too hard edges
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); // GL_NEAREST);
if(gCelShadeDate.Size()==0)
{
gCelShadeDate.SetSize(16);
gCelShadeDate[ 0]=100;
gCelShadeDate[ 1]=160;
gCelShadeDate[ 2]=160;
gCelShadeDate[ 3]=160;
gCelShadeDate[ 4]=160;
gCelShadeDate[ 5]=160;
gCelShadeDate[ 6]=160;
gCelShadeDate[ 7]=207;
gCelShadeDate[ 8]=255;
gCelShadeDate[ 9]=255;
gCelShadeDate[10]=255;
gCelShadeDate[11]=255;
gCelShadeDate[12]=255;
gCelShadeDate[13]=255;
gCelShadeDate[14]=255;
gCelShadeDate[15]=255;
}

sx=64;
while(sx < 4*gCelShadeDate.Size() && sx < 512)
{
sx*=2;
}

unsigned char* data = new unsigned char[sx*sy*4];
//	unsigned char CelShadeDate[16] = {0, 0, 140, 160, 160, 160, 160, 180, 255, 255, 255, 255, 255, 255, 255, 255};


for (int y=0; y<sy; ++y)
{
unsigned long r,g,b;
unsigned long col = *m_ColTable.GetAt(y<m_ColTable.Size() ? y : 0);
for(int x=0; x<sx; ++x)
{
if(col < COL_NEW_ANY)
{
r = (unsigned char) col;
g = (unsigned char) (((unsigned short) col) >> 8);
b = (unsigned char) (col >> 16);
}
else // New group - use white color
{
r=g=b=255;
}
int ix = (x * gCelShadeDate.Size()) / sx;

r*=gCelShadeDate[ix];
g*=gCelShadeDate[ix];
b*=gCelShadeDate[ix];
data[(x + y*sx)*4 + 0]=(unsigned char)(r/255);
data[(x + y*sx)*4 + 1]=(unsigned char)(g/255);
data[(x + y*sx)*4 + 2]=(unsigned char)(b/255);
data[(x + y*sx)*4 + 3]=255;
}
}

if(bgra_ext)
{
glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, sx, sy, 0, GL_BGRA_EXT, GL_UNSIGNED_BYTE, data);
}
else
{
glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, sx, sy, 0, GL_RGBA, GL_UNSIGNED_BYTE, data);
}
#if defined(HAVE_OPENGL)
#elif defined(HAVE_OPENGL_ES)
#endif
delete [] data;
#endif
}

// --------------------------------------------------- //
// Calculate max radius for sphere - for quick collision detection
// !!! Requires XNODES to be stored !!!
// relative to center_of_mass
// --------------------------------------------------- //
void MeshObjectX::CalcMaxRadius()
{
int i;
for (int j=0; j<m_Frames.Size(); j++)
{
// calc size of max radius + set for frame
float maxlen=0.0f;
float len;
float tmp[3];
POLY_FRAME* pFrm = m_Frames.GetAt(j);
pFrm->center_of_mass[0]=0; pFrm->center_of_mass[1]=0; pFrm->center_of_mass[2]=0;
for (i=0; i<pFrm->triangles.Size(); i++)
{
gAddVertex(pFrm->center_of_mass, pFrm->triangles.GetAt(i)->pos);
}
gMultVertex(pFrm->center_of_mass, 1.0f / (float)pFrm->triangles.Size());
for (i=0; i<pFrm->triangles.Size(); i++)
{
gDiffVertex(tmp, pFrm->center_of_mass, pFrm->triangles.GetAt(i)->pos);
len=::gGetLength(tmp);
if (len>maxlen)
maxlen=len;
}
pFrm->max_radius=(float)fabs(maxlen);
}

}

// --------------------------------------------------- //
// Create a list of edges and their neighbours
// for faster stencil shadow volume calculation
// --------------------------------------------------- //
void MeshObjectX::CreateEdges()
{
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if (m_Edges.Size()) return; // already got these
if (m_Frames.Size()==0) return;

POLY_FRAME* pFr = &m_Frames[0];

int num_tri = (int)pFr->triangles.Size()/3;
m_Edges.SetSize(num_tri*3);

//set the neighbour indices to be -1
int i;
for(i=0; i<num_tri*3; ++i)
{
m_Edges[i].neighbourIndex=-1;
}

int* indices=new int[num_tri*3];
// build an index list - we have to uncompress each node and
// compare it with the vertex of the triangle!
for(i=0; i<num_tri*3; ++i)
{
indices[i] = i;
float* pPos = pFr->triangles[i].pos;
for(int j=0; j<i; ++j)
{
float* pPosj = pFr->triangles[j].pos;
if(	fabs(pPosj[0] - pPos[0])<1e-5 &&
fabs(pPosj[1] - pPos[1])<1e-5 &&
fabs(pPosj[2] - pPos[2])<1e-5  )
{
indices[i] = j;
break;
}
}
}

//loop through triangles
for(i=0; i<num_tri-1; ++i)
{
//loop through edges on the first triangle
for(int edgeI=0; edgeI<3; ++edgeI)
{
//continue if this edge already has a neighbour set
if(m_Edges[i*3+edgeI].neighbourIndex!=-1)
continue;

//loop through triangles with greater indices than this one
for(int j=i+1; j<num_tri; ++j)
{
//loop through edges on triangle j
for(int edgeJ=0; edgeJ<3; ++edgeJ)
{
//get the vertex indices on each edge
int edgeI1=indices[i*3+edgeI];
int edgeI2=indices[i*3+(edgeI+1)%3];
int edgeJ1=indices[j*3+edgeJ];
int edgeJ2=indices[j*3+(edgeJ+1)%3];

//if these are the same (possibly reversed order), these faces are neighbours
if(		(edgeI1==edgeJ1 && edgeI2==edgeJ2)
||	(edgeI1==edgeJ2 && edgeI2==edgeJ1))
{
m_Edges[i*3+edgeI].neighbourIndex=j;
m_Edges[j*3+edgeJ].neighbourIndex=i;
}
}
}
}
}
delete[] indices;
#endif
}


void MeshObjectX::Scale(float sx,float sy, float sz)
{
int i;
for (int j=0; j<m_Frames.Size(); ++j)
{
#define SCV(v) v[0]*=sx; v[1]*=sy; v[2]*=sz;
#define SCNV(v) v[0]*=uni[0]; v[1]*=uni[1]; v[2]*=uni[2];
POLY_FRAME* pFrm = m_Frames.GetAt(j);
for (i=0; i<pFrm->triangles.Size(); ++i)
{
POLY_NODE *p = pFrm->triangles.GetAt(i);
SCV(p->pos);
SCV(p->normal);
SCV(p->binormal);
SCV(p->tangent);
}

float uni[3];
gSetVertex(uni, sx,sy,sz);
gUnify(uni);

for(i=0; i<pFrm->nodes.Size(); ++i)
{
POLY_NODE *p = pFrm->nodes.GetAt(i);
SCV(p->pos);
SCNV(p->normal);
SCNV(p->binormal);
SCNV(p->tangent);
}
#undef SCV
#undef SCNV
}
CalcMaxRadius();
}

// --------------------------------------------------- //
// calculate silhouette edges for stencil shadows
// --------------------------------------------------- //
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
void MeshObjectX::CalculateSilhouetteEdges(const POLY_NODE* pNodes, float* lightPosition)
{
//Calculate which faces face the light
unsigned int numTriangles = m_Frames[0].triangles.Size() / 3;
m_isTriFacingLight.SetSize(numTriangles);
unsigned int i;
for(i=0; i<numTriangles; i++)
{
/*
if(planeEquations[i].ClassifyPoint(lightPosition)==POINT_IN_FRONT_OF_PLANE)
isFacingLight[i]=true;
else
isFacingLight[i]=false;
*/
// i take just the 3 normals of the triangle
// and see if it's lit

float dir[3], dir2[3], dir3[3];
gDiffVertex(dir3, pNodes[i*3  ].pos, pNodes[i*3+1].pos);
gDiffVertex(dir2, pNodes[i*3+2].pos, pNodes[i*3+1].pos);
gCross(dir3, dir2, dir); // normal _direction_ to triangle

// we need the _direction_ triangle->light!
gCopyVertex(dir2, pNodes[i*3  ].pos);
gAddVertex(dir2, pNodes[i*3+1].pos);
gAddVertex(dir2, pNodes[i*3+2].pos);
gMultVertex(dir2, -1.0f/3.0f);
gAddVertex(dir2, lightPosition);

if(gDot(dir, dir2) >= 0)
m_isTriFacingLight[i]=true;
else
m_isTriFacingLight[i]=false;
}
//loop through edges
for(i=0; i<numTriangles*3; ++i)
{
// this face is facing the light
// if the neighbouring face is not facing the light, or there is no neighbouring face,
// then this is a silhouette edge
if(	m_isTriFacingLight[i/3] &&
(m_Edges[i].neighbourIndex==-1 || !m_isTriFacingLight[m_Edges[i].neighbourIndex]))
{
m_Edges[i].isSilhouetteEdge=true;
continue;
}
// if this face is not facing the light, not a silhouette edge
m_Edges[i].isSilhouetteEdge=false;
}
}
#endif


// --------------------------------------------------- //
// Draw the shadow volume object
// --------------------------------------------------- //
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
void MeshObjectX::DrawInfiniteShadowVolume(const POLY_NODE* pNodes, float* lightPosition, bool drawCaps)
{
// lightPosition -> mult with inverted modelview
unsigned int numTriangles = m_Frames[0].triangles.Size() / 3;

glbDisable(GL_CULL_FACE);
glDisable(GL_TEXTURE_2D);
glbDisable(GL_LIGHTING);
glDepthFunc(GL_LESS); // otherwise shadow on top of flat surfaces

for(int pass=0; pass<2; ++pass)
{
// zpass
switch (pass)
{
case 0:
glbEnable(GL_CULL_FACE);
glStencilFunc(GL_ALWAYS, 0, ~0);
glStencilOp(GL_KEEP, GL_KEEP, GL_INCR);
glCullFace(GL_BACK);
break;
case 1:
//Decrement stencil buffer for back face depth pass
glStencilOp(GL_KEEP, GL_KEEP, GL_DECR);
glCullFace(GL_FRONT);
break;
}

glBegin(GL_QUADS);
{
for(unsigned int i=0; i<numTriangles; ++i)
{
//if this face does not face the light, continue
if(!m_isTriFacingLight[i])
continue;

//Loop through edges on this face
for(int j=0; j<3; ++j)
{
//Draw the shadow volume "edge" if this is a silhouette edge
if(m_Edges[i*3+j].isSilhouetteEdge)
{
// float* vertex1=vertices[indices[i*3+j]].position;
// float* vertex2=vertices[indices[i*3+(j+1)%3]].position;

const float* vertex1 = pNodes[i*3+j].pos;
const float* vertex2 = pNodes[i*3+(j+1)%3].pos;

glVertex3fv(vertex2);
glVertex3fv(vertex1);
glVertex4f(	vertex1[0]-lightPosition[0],
vertex1[1]-lightPosition[1],
vertex1[2]-lightPosition[2],0.0f);
glVertex4f(	vertex2[0]-lightPosition[0],
vertex2[1]-lightPosition[1],
vertex2[2]-lightPosition[2],0.0f);
}
}
}
}
glEnd();

//Draw caps if required
if(drawCaps)
{
glBegin(GL_TRIANGLES);
{
for(unsigned int i=0; i<numTriangles; ++i)
{
for(int j=0; j<3; ++j)
{
// float* vertex=vertices[indices[i*3+j]].position;
const float* vertex = pNodes[i*3+j].pos;

if(m_isTriFacingLight[i])
{
glVertex3fv(vertex);
}
else
{
glVertex4f(	vertex[0]-lightPosition[0],
vertex[1]-lightPosition[1],
vertex[2]-lightPosition[2], 0.0f);
}
}
}
}
glEnd();
}
}
// glDepthFunc(GL_LESS);
}
#endif




void MeshObjectX::Clear(bool free_mem)
{
MeshObject::Clear(free_mem);

#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
m_Edges.Clear(free_mem);
m_isTriFacingLight.Clear(free_mem);

m_Edges.SetAllocSteps(64,64);
m_isTriFacingLight.SetAllocSteps(64,64);
#endif

#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
if (m_VBO_id && (long)glBindBufferArb)
{
glDeleteBuffersArb(1, &m_VBO_id);
}
if (m_VBO_id_morphing && (long)glBindBufferArb)
{
glDeleteBuffersArb(1, &m_VBO_id_morphing);
}
//	if (glCallList) glDeleteLists(glCallList, 1); glCallList=0;

if(CelShadeTexture) // See also MakeCelShadeTexture()
{
glDeleteTextures(1, &CelShadeTexture);
CelShadeTexture=0L;
}

m_VBO_id = 0;
m_VBO_id_morphing = 0;
#endif
}



//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

Rainbows3D::Rainbows3D(OpenGLRainbows* pR)
{
m_iCurObjFrame = 0;
m_LightsOn=0;
m_AutoNormalMode=2;
m_pRBOW = pR;
m_nTransformations=0;
m_shadowmode=false;

m_Objects.SetSize(GLR_MAX_OBJECTS);
#if defined(HAVE_OPENGL)
memset(&m_Shaders, 0, sizeof(m_Shaders));
#endif
pR->m_pRbow3D = this;
}

Rainbows3D::~Rainbows3D()
{
m_Objects.Clear(true);
#if defined(HAVE_OPENGL)
for(int i=0; i<MAX_SHADERS; ++i)
FreeShader(i);
#endif
}

void Rainbows3D::ClearZBuffer()
{
#ifdef TRENKI3D
Screen.ClearZBuffer();
#else
DoShadows(false);
glClear(GL_DEPTH_BUFFER_BIT);
#endif
}


// --------------------------------------------------------------- //
// Start / Draw Shadows
// --------------------------------------------------------------- //
void Rainbows3D::DoShadows(bool mode)
{
if (mode == m_shadowmode) return; // nothing to do
m_shadowmode = mode;

#if !defined(TINYGL) && !defined(TRENKI3D)
if(mode) // start drawing in stencil mode
{
glShadeModel(GL_FLAT);
glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE); // Don't draw r,g,b,a - only z

glbEnable(GL_STENCIL_TEST);
glDepthMask(GL_FALSE); // Do not write into depth buffer
glStencilFunc(GL_ALWAYS, 0, 0);
// Draw the whole model front+backfaces, always inverting the stencil buffer
// If only one face has been drawn, the buffer == -1, otherwise == 0
// Where 0, it's infront/behind the shadow
//		glbDisable(GL_CULL_FACE);
glStencilOp(GL_KEEP, GL_KEEP, GL_INVERT); // If visible, add one to the stencil
//		glCallList(SHADOWVOL);
//		glbEnable(GL_CULL_FACE);
}
else // finally draw the shadow
{
// Now turn everything back to normal
glCullFace(GL_BACK);
glDepthMask(GL_TRUE);
glDepthFunc(GL_LEQUAL);
glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
// Wherever stencil == -1, draw the shadow

//		glbEnable(GL_BLEND);
//		glBlendFunc(GL_SRC_COLOR, GL_DST_COLOR);


// We're doing a 2D viewport here!
glMatrixMode(GL_PROJECTION);
glPushMatrix();
glMatrixMode(GL_MODELVIEW);
glPushMatrix();
m_pRBOW->Make2DMode();
m_pRBOW->DoAlpha(-.5);

glbEnable(GL_STENCIL_TEST);
// glStencilFunc(GL_EQUAL, 1,1); glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP); // one pass method
glStencilFunc(GL_NOTEQUAL, 0, ~0); glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP); // two pass method
m_pRBOW->DrawRect(0, 0, m_pRBOW->m_WND.viewport.width, m_pRBOW->m_WND.viewport.height, m_BumpLight.dwcol);
m_pRBOW->DoAlpha(0);
glMatrixMode(GL_PROJECTION);
glPopMatrix();
glMatrixMode(GL_MODELVIEW);
glPopMatrix();

// glCallList(SHADOWVOL); // render the shadow volume(s) bounding surfaces
//		glbDisable(GL_BLEND);

// Reset to normal
glShadeModel(GL_SMOOTH);

this->SetDepthTesting(true);

glbDisable(GL_STENCIL_TEST);
glClear(GL_STENCIL_BUFFER_BIT);

glbEnable(GL_CULL_FACE);
glCullFace(GL_BACK);

// restore culling as set before shadows
CullMode(m_CullMode);
}
#endif
}



// ------------------------------------------------------------- //
// Make a Fog
// ------------------------------------------------------------- //
void Rainbows3D::Fog(unsigned long col, int exp_mode, float p1, float p2)
{
#if !defined(TINYGL) && !defined(TRENKI3D)
if(col==-1)
{
glbDisable(GL_FOG);
}
else
{
glbEnable(GL_FOG);
if(exp_mode)
{
// this fog is very silly to use
glFogf(GL_FOG_MODE, GL_EXP); glFogf(GL_FOG_DENSITY, p1);
}
else
{
// nice to use - but they claim it's ugly...
glFogf(GL_FOG_MODE, GL_LINEAR);
// 0,0 -> use znear, zfar
if(p1==0.0f && p2==0.0f)
{
p1 = m_Camera.znear;
p2 = m_Camera.zfar;
}
glFogf(GL_FOG_START, p1);
glFogf(GL_FOG_END, p2);
}

float fcl[4] = {GetRValue(col)/255.0f, GetGValue(col)/255.0f, GetBValue(col)/255.0f, 0.0f};
glFogfv(GL_FOG_COLOR, fcl);
}
#endif
}


//------------------------------------------------------------------//
// Build the current matrix in the stack
//------------------------------------------------------------------//
void Rainbows3D::BuildMatrix()
{
TRANSFORMATION& tr = m_Transformations[m_nTransformations];
if(tr.m_IsGoodMatrix)
return;

// for each tr in m_Transformations...
float* pM = tr.m_Matrix;
float m[16];

// Multiply
for (int i=0; i<tr.m_nMult; ++i)
{
// glMultMatrixf(tr.m_Mults[i]);
matmul4(pM, pM, tr.m_Mults[i]);
}

// Move
// glTranslatef(tr.m_Translate[0], tr.m_Translate[1], tr.m_Translate[2]);
float* pT = tr.m_Translate;
if(pT[0] || pT[1] || pT[2])
{
gIdentity(m);
m[12]=pT[0];
m[13]=pT[1];
m[14]=pT[2];
matmul4(pM, pM, m);
}

// Rotate
for (int i=tr.m_nRotate-1; i>=0; i--)
{
// glRotatef(tr.m_Rotate[i][0], tr.m_Rotate[i][1], tr.m_Rotate[i][2], tr.m_Rotate[i][3]);
float* pR = tr.m_Rotate[i];
matrix_rotate(pM, pR[0], pR[1], pR[2], pR[3]);
}

// Zoom
// glScalef(tr.m_Scale[0], tr.m_Scale[1], tr.m_Scale[2]);
if(tr.m_Scale[0]!=1.0f || tr.m_Scale[1]!=1.0f || tr.m_Scale[2]!=1.0)
{
gIdentity(m);
m[0]=tr.m_Scale[0]; m[5]=tr.m_Scale[1]; m[10]=tr.m_Scale[2];
matmul4(pM, pM, m);
}
tr.m_IsGoodMatrix=1;
}

//------------------------------------------------------------------//
// Rotate and Scale current Matrix
//------------------------------------------------------------------//
void Rainbows3D::TransformMatrix()
{
BuildMatrix();
#ifdef TRENKI3D
tglMultMatrixf(m_Transformations[m_nTransformations].m_Matrix);
#else
glMultMatrixf(m_Transformations[m_nTransformations].m_Matrix);
#endif
}


//------------------------------------------------------------------//
// Specify texture offset
//------------------------------------------------------------------//
void Rainbows3D::SetTextureOffset(float du, float dv)
{
m_TexOffset[0] = du; m_TexOffset[1] = dv;
}


//------------------------------------------------------------------//
// Render a model
//------------------------------------------------------------------//
void Rainbows3D::RenderAnim(int num, int from, int to, float percent, bool fullAnim)
{
X_WORLD& wld = m_Objects[num];
if(wld.is_multiworld)
{
for(int i=0; i<wld.m_objects.Size(); ++i)
{
X_WORLD::DATA& dat = wld.m_objects[i];
if(wld.m_textures.Size())
{
#ifdef TINYGL
RenderMD2_TinyGL(dat.obj, from, to, percent, fullAnim);
#elif defined(TRENKI3D)
RenderMD2_Trenki(dat.obj, from, to, percent, fullAnim);
#else
m_pRBOW->SetTexture3D(dat.gl_tex, dat.gl_tex2, 0, &wld.m_textures[0]);
RenderMD2(dat.obj, from, to, percent, fullAnim, &wld.m_textures[0]);
#endif
}
else
{
m_pRBOW->SetTexture3D(-1, -1, 0);
#ifdef TINYGL
RenderMD2_TinyGL(dat.obj, from, to, percent, fullAnim);
#elif defined(TRENKI3D)
RenderMD2_Trenki(dat.obj, from, to, percent, fullAnim);
#else
RenderMD2(dat.obj, from, to, percent, fullAnim, &wld.m_textures[0]);
#endif
}
}
}
else if(wld.m_objects.Size())
{
#ifdef TINYGL
RenderMD2_TinyGL(wld.m_objects[0].obj, from, to, percent, fullAnim);
#elif defined(TRENKI3D)
RenderMD2_Trenki(wld.m_objects[0].obj, from, to, percent, fullAnim);
#else
RenderMD2(wld.m_objects[0].obj, from, to, percent, fullAnim);
#endif
}
}



#ifdef _DEBUG
// #define _NO_VBO
#endif

//  #define _NO_VBO // Vertex arrays - no VBO

#ifdef TRENKI3D

void Rainbows3D::RenderMD2_Trenki(MeshObjectX& the_obj, int from, int to, float percent, bool fullAnim)
{
if(!the_obj.m_Frames.Size()) return;
tglPushMatrix();
TransformMatrix();
tglCallLists(the_obj.m_glListIDs[from],1);
Screen.SetZBufferUsed(1);
tglPopMatrix();
}

#else // TRENKI3D

// Render a Model
// Take care of texture state yourself before this call!
void Rainbows3D::RenderMD2_TinyGL(MeshObjectX& the_obj, int from, int to, float percent, bool fullAnim, GLuint* pTextures)
{
if(!the_obj.m_Frames.Size()) return;
#ifdef TINYGL
from = from + (int)((to-from)*percent);
if (from<0) from=0;
if (from>=the_obj.NumFrames()) from=the_obj.NumFrames()-1;

glEnableClientState( GL_VERTEX_ARRAY );

if(m_pRBOW->m_Texture3D[0]>=0)
{
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glbEnable(GL_TEXTURE_2D);
// int id = m_pRBOW->m_Texture[m_pRBOW->m_Texture3D[1]].mipstate[m_pRBOW->m_Texture3D[2]];
if(pTextures)
glBindTexture(GL_TEXTURE_2D, pTextures[m_pRBOW->m_Texture3D[0]]);
else
glBindTexture(GL_TEXTURE_2D, m_pRBOW->m_Texture[m_pRBOW->m_Texture3D[0]].mipstate[m_pRBOW->m_Texture3D[2]]);
}
if (the_obj.m_NeedColoring)
{
glEnableClientState(GL_COLOR_ARRAY);
}

//glbEnable(GL_COLOR_MATERIAL);
glPushMatrix();
TransformMatrix();
glCallList(the_obj.m_glListIDs[from]);
glPopMatrix();

glDisableClientState(GL_TEXTURE_COORD_ARRAY);
glDisableClientState(GL_COLOR_ARRAY);
glDisableClientState( GL_VERTEX_ARRAY );
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);
#endif
}


//------------------------------------------------------------------//
// Render a MD2 Object (with Dot3 Bump Mapping if required)
//------------------------------------------------------------------//
void Rainbows3D::RenderMD2(MeshObjectX& the_obj, int from, int to, float percent, bool fullAnim, GLuint* pTextures)
{
#ifndef TINYGL
if (the_obj.NumNodes(0)==0 || the_obj.NumFrames()==0) return;
POLY_FRAME				*cFrame, *nFrame;
POLY_NODE				*cNode, *nNode, *tNode, *tNodes_all;
int						index;
float					invM[16], lv0[3];
unsigned int			*pVBO_id;

pVBO_id = &the_obj.m_VBO_id_morphing;

// Find out the frames to be interpolated
if (fullAnim)
{
if(percent>1.0f || percent<0.0f) percent=fabsf(fmodf(percent, 1.0f));
float	pc;
pc=(float)from+(float)(to-from)*percent;
index=(int)pc;
if (to>from)
{
percent=1.0f - (pc-(float)index);
from=index;
to=index+1;
}
else if(to<from)
{
percent=pc-(float)index;
from=index+1;
to=index;
}
else // from and to are the same - no interpolation
{
percent=0.0f;
}
}
else
{
// this is soo stupid!! #NEED
int sw=from; from=to; to=sw;
}

// For safety reasons check range
if (from<0) from=0;
if (to<0) to=0;
if (to>=the_obj.NumFrames()) to=the_obj.NumFrames()-1;
if (from>=the_obj.NumFrames()) from=the_obj.NumFrames()-1;

//Get the current frame and gl command information
cFrame=the_obj.m_Frames.GetAt(from);
nFrame=the_obj.m_Frames.GetAt(to);


// Very quick object in view test to safe a lot of time
/*
if(m_nTransformations==0 && m_Transformations[0].m_nMult==0)
{
gCopyVertex(lv0, m_Transformations[0].m_Translate);
gAddVertex(lv0, cFrame->center_of_mass);

if(!gSphereInCone(	m_Camera.eye, m_Camera.lookat, m_Camera.tan_fov,
lv0,
cFrame->max_radius * max(m_Transformations[0].m_Scale[0], max(m_Transformations[0].m_Scale[1], m_Transformations[0].m_Scale[2]))))
return;
}
*/




BuildMatrix();
gCopyVertex(lv0,cFrame->center_of_mass);
gTransformVector(m_Transformations[m_nTransformations].m_Matrix, lv0);
float sx,sy,sz;
GetMatrixScalings(sx,sy,sz);

if(!SphereInFrustum(lv0[0], lv0[1], lv0[2],
cFrame->max_radius*max(sx,max(sy,sz)) ))
{
// never clip the shadow volume
if (! (m_BumpLight.active && m_BumpLight.type == 3))
return;
}

// Don't remove this!
// if(the_obj.m_NeedColoring || m_pRBOW->m_falpha!=1.0f)
{
// colour value might be wrong from last rendered model.
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);
glEnable(GL_COLOR_MATERIAL);
}

// Create Normals and Bump-Vertices if not done already
if(m_BumpLight.active) // now we need both of them
{
switch(m_BumpLight.type)
{
case 3:
the_obj.AutoNormalsAfterCompression(true, false, false);
the_obj.CreateEdges();
break;
case 2: // Cel Shading
the_obj.AutoNormalsAfterCompression(true, false, false);
the_obj.MakeCelShadeTexutre(m_pRBOW->m_bSupportBGRA_ext);
break;
case 1: // Bump mapping
the_obj.AutoNormalsAfterCompression(true, m_AutoNormalMode==2 ? true : false, true);
break;
}
}
// Not yet created triangles due to normal calculations?
if (the_obj.m_tri_animation.Size()==0)
the_obj.PrepareTriangles();

// Move, Rotate & Scale
tNodes_all = the_obj.m_tri_animation.GetAt(0);
// Modelview matrix and inverted light matrix
// -> modelspace light position
if (m_BumpLight.active)
{
gCopyMatrix(invM, m_Transformations[m_nTransformations].m_Matrix);
float inv2[16];
gCopyMatrix(inv2, invM);

// gInvertMatrix4x4(invM);
gInvertMatrix4x4_full(invM); // due to anisotrope scaling

gCopyVertex(lv0, m_BumpLight.pos);
// float ll = gGetLength(lv0);
gTransformVector(invM, lv0);
// gMultVertex(lv0, ll); // bad position
}
// No bumping, no animation, no spheremapping? Try pre-rendered Objects
else if (percent==0.0f && m_TexOffset[0]==0.0f && m_TexOffset[1]==0.0f)
{
tNodes_all = cFrame->triangles.GetAt(0);
if (from == 0) // First frame? Create/Render a AGP memory VBO!
{
pVBO_id = & the_obj.m_VBO_id;
}
goto just_draw;
}

// Prepare light normals + keyframe processing
float lv[3], tc[3];

cNode = cFrame->triangles.GetAt(0); // a bit quicker
tNode = the_obj.m_tri_animation.GetAt(0);
for (index=0; index<(int)the_obj.m_tri_animation.Size(); index++)
{
// cNode = cFrame->triangles.GetAt(index);
// tNode = the_obj.m_tri_animation.GetAt(index);

// Still frame or interpolation?
// Really interpolate
if (percent==0.0f)
{
*tNode = *cNode; // Copy static vertex to tri_animation
nNode = cNode;
}
else
{
nNode = nFrame->triangles.GetAt(index);
tNode->pos[0]=	(nNode->pos[0]+
(cNode->pos[0]-nNode->pos[0])*percent);

tNode->pos[1]=	(nNode->pos[1]+  // -2
(cNode->pos[1]-nNode->pos[1])*percent);

tNode->pos[2]=	(nNode->pos[2]+ // 1
(cNode->pos[2]-nNode->pos[2])*percent);
// Interpolate Normals
tNode->normal[0]=	(nNode->normal[0]+
(cNode->normal[0]-nNode->normal[0])*percent);

tNode->normal[1]=	(nNode->normal[1]+ // -2
(cNode->normal[1]-nNode->normal[1])*percent);

tNode->normal[2]=	(nNode->normal[2]+ // 1
(cNode->normal[2]-nNode->normal[2])*percent);
}

// Special light (Bump Mapping / Cel shading...)
if (m_BumpLight.active && ((void*)glMultiTexCoord2fArb)) // Has Light and extension provided
{
// lv = lightpos - vertex_triangle_point
gDiffVertex(lv, lv0, tNode->pos);
gUnify(lv);
switch(m_BumpLight.type)
{
case 1: // Dot 3 Bump Mapping
gCopyVertex(tc, tNode->pos);
lv[0]=(lv0[0]-tc[0]);
lv[1]=(lv0[1]-tc[1]);
lv[2]=(lv0[2]-tc[2]);
gUnify(lv);
// destryoing invM here -> need a temporary matrix
// for each vertex
invM[0]=nNode->tangent[0];
invM[1]=nNode->binormal[0];
invM[2]=tNode->normal[0];
invM[3]=nNode->tangent[1];
invM[4]=nNode->binormal[1];
invM[5]=tNode->normal[1];
invM[6]=nNode->tangent[2];
invM[7]=nNode->binormal[2];
invM[8]=tNode->normal[2];

// This is not a color, it's the displacement direction!
tNode->bump_light[0]=((lv[0]*invM[0])+(lv[1]*invM[3])+(lv[2]*invM[6]))*0.5f+0.5f;
tNode->bump_light[1]=((lv[0]*invM[1])+(lv[1]*invM[4])+(lv[2]*invM[7]))*0.5f+0.5f;
tNode->bump_light[2]=((lv[0]*invM[2])+(lv[1]*invM[5])+(lv[2]*invM[8]))*0.5f+0.5f;
break;
case 2: // Cel Shading
// y=color, x=shading position
tNode->binormal[1] = (float)((tNode->icol)+0.5f)*the_obj.CelShadeColorScale;

gDiffVertex(tc, tNode->pos, tNode->normal);
gUnify(tc);

// u = light' o Normal; light' = light x matrix
// tNode->binormal[0]=gDot(lv0, tNode->normal);
tNode->binormal[0]=min(0.95f, max(0.05f, gDot(lv, tc)));
// the texture at 1.0 has a bit of black from 0.0!?
break;
}
}

// Texture Offset
tNode->tex[0]+=m_TexOffset[0]; tNode->tex[1]+=m_TexOffset[1];


++cNode; // a big quicker - but does not work!
++tNode;
} // Next Vertex



// draw shadow volume of animated mesh
// then return
if (m_BumpLight.active && m_BumpLight.type == 3)
{
#if defined(HAVE_OPENGL)
glPushMatrix();
TransformMatrix();
the_obj.CalculateSilhouetteEdges(&cFrame->triangles[0], lv0);

m_pRBOW->SetTexture3D(-1, -1, 0); // no texture for shadow
//                               &cFrame->triangles[0]
the_obj.DrawInfiniteShadowVolume(the_obj.m_tri_animation.GetAt(0), lv0, true);
glPopMatrix();
#endif
return;
}



just_draw:

#ifdef _NO_VBO
glBindBufferArb = NULL;
#endif

#define BUFFER_OFFSET(i) (  ((void*)glBindBufferArb) ? /*NULL based*/ ((void*)((size_t)(i) - (size_t)(tNodes_all))) : /*real pointer*/ ((void*)(i))  )

if ((void*)glBindBufferArb)
{
// Use the morphing object here
int newsize = sizeof(POLY_NODE) * the_obj.m_tri_animation.Size();
if (*pVBO_id==0)
{
glGenBuffersArb(1, pVBO_id);
glBindBufferArb(GL_ARRAY_BUFFER_ARB, *pVBO_id);
glBufferDataArb(GL_ARRAY_BUFFER_ARB, newsize,
tNodes_all,
(pVBO_id==&the_obj.m_VBO_id_morphing) ? GL_STREAM_DRAW_ARB : GL_STATIC_DRAW_ARB);
}
// already there, but dynamic
else if(pVBO_id==&the_obj.m_VBO_id_morphing)
{
glBindBufferArb(GL_ARRAY_BUFFER_ARB, *pVBO_id);
glBufferDataArb(GL_ARRAY_BUFFER_ARB, newsize, tNodes_all, (GLenum)GL_STREAM_DRAW_ARB);
}
else // Static Object, already created
{
glBindBufferArb( GL_ARRAY_BUFFER_ARB, *pVBO_id);
}
}

glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer(  3, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->pos));
if (m_BumpLight.active && (void*)glClientActiveTextureArb) // bump mapping / cel shading
{
switch(m_BumpLight.type)
{
case 1: // bump mapping
#if defined(HAVE_OPENGL)
// Setup Blending Texture settings
glClientActiveTextureArb(GL_TEXTURE1_ARB);
glActiveTextureArb(GL_TEXTURE1_ARB);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->tex));

glClientActiveTextureArb(GL_TEXTURE0_ARB);
glActiveTextureArb(GL_TEXTURE0_ARB);
glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE_EXT);
glTexEnvf(GL_TEXTURE_ENV, GL_COMBINE_RGB_EXT,  GL_DOT3_RGB_EXT);
glTexEnvf(GL_TEXTURE_ENV, GL_SOURCE0_RGB_EXT,  GL_PRIMARY_COLOR_EXT);
glTexEnvf(GL_TEXTURE_ENV, GL_OPERAND0_RGB_EXT, GL_SRC_COLOR);
glTexEnvf(GL_TEXTURE_ENV, GL_SOURCE1_RGB_EXT,  GL_TEXTURE);
glTexEnvf(GL_TEXTURE_ENV, GL_OPERAND1_RGB_EXT, GL_SRC_COLOR);
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->tex));

glEnableClientState(GL_COLOR_ARRAY);
glColorPointer(3, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->bump_light));
#endif
break;
case 2: // cel shading
// Cel Shading Texture Unit
glClientActiveTextureArb(GL_TEXTURE1_ARB);
glActiveTextureArb(GL_TEXTURE1_ARB); // Textures
glBindTexture(GL_TEXTURE_2D, the_obj.CelShadeTexture);
glEnable(GL_TEXTURE_2D);
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->binormal));
glEnable(GL_TEXTURE_2D);

// restore default texture unit
glClientActiveTextureArb(GL_TEXTURE0_ARB);
glActiveTextureArb(GL_TEXTURE0_ARB); // Textures

// Image Texture
if(m_pRBOW->m_Texture3D[0]>=0)
{
glEnable(GL_TEXTURE_2D);
// #NPBUFFER
if(pTextures)
{
glBindTexture(GL_TEXTURE_2D, pTextures[m_pRBOW->m_Texture3D[0]]);
}
else
{
glBindTexture(GL_TEXTURE_2D, m_pRBOW->m_Texture[m_pRBOW->m_Texture3D[0]].mipstate[m_pRBOW->m_Texture3D[2]]);
}
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->tex));
}
break;
}
}
else // vanilla textured rendering
{
// has a texture set
if(m_pRBOW->m_Texture3D[0]>=0)
{
// has 2nd texture unit set? - Multitexturing
if(m_pRBOW->m_Texture3D[1]>=0 && (void*)glClientActiveTextureArb)
{
glClientActiveTextureArb(GL_TEXTURE1_ARB);
glActiveTextureArb(GL_TEXTURE1_ARB);
// #NPBUFFER
if(pTextures)
{
glBindTexture(GL_TEXTURE_2D, pTextures[m_pRBOW->m_Texture3D[1]]);
}
else
{
glBindTexture(GL_TEXTURE_2D, m_pRBOW->m_Texture[m_pRBOW->m_Texture3D[1]].mipstate[m_pRBOW->m_Texture3D[2]]);
}
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->tex));			
}

// do texture unit 0
if((void*)glClientActiveTextureArb)
{
glClientActiveTextureArb(GL_TEXTURE0_ARB); // tex coords
glActiveTextureArb(GL_TEXTURE0_ARB);       // tex unit
}
// #NPBUFFER
if(pTextures)
{
glBindTexture(GL_TEXTURE_2D, pTextures[m_pRBOW->m_Texture3D[0]]);
}
else
{
glBindTexture(GL_TEXTURE_2D, m_pRBOW->m_Texture[m_pRBOW->m_Texture3D[0]].mipstate[m_pRBOW->m_Texture3D[2]]);
}
glEnableClientState(GL_TEXTURE_COORD_ARRAY);
glTexCoordPointer(2, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(tNodes_all->tex));
}
if (the_obj.m_NeedColoring)
{
glEnableClientState(GL_COLOR_ARRAY);
glColorPointer(4, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(((BYTE*)&tNodes_all->fcol )));
}
}

//glbEnable(GL_COLOR_MATERIAL);
{glPushMatrix();
TransformMatrix();

if(m_LightsOn || m_SphereMapping)
{
glEnableClientState(GL_NORMAL_ARRAY);
glNormalPointer(GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(((BYTE*)&tNodes_all->normal)));
}

#if !defined(TINYGL) && !defined(TRENKI3D) && !defined(HAVE_OPENGL_ES)
if(m_SphereMapping)
{
glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
glbEnable(GL_TEXTURE_GEN_S); glbEnable(GL_TEXTURE_GEN_T);
}
#endif

//
// -= Render the Object itself =-
// Draw All Of The Triangles At Once
// 
//GL_TRIANGLES
glDrawArrays(GL_TRIANGLES, 0, the_obj.m_tri_animation.Size());

#if !defined(TINYGL) && !defined(TRENKI3D) && !defined(HAVE_OPENGL_ES)
if(m_SphereMapping)
{
glbDisable(GL_TEXTURE_GEN_S); glbDisable(GL_TEXTURE_GEN_T);
}
#endif

// Disable Pointers
glDisableClientState( GL_VERTEX_ARRAY );					// Disable Vertex Arrays
glDisableClientState( GL_TEXTURE_COORD_ARRAY );				// Disable Texture Coord Arrays
glDisableClientState( GL_COLOR_ARRAY  );					// Disable Color Arrays
glDisableClientState( GL_NORMAL_ARRAY );
if((void*)glBindBufferArb) // allow normal vertex arrays (POLYSPRITE)
glBindBufferArb( GL_ARRAY_BUFFER_ARB, 0);

///////////////////////////////////////////////////////////////
// Cel Shading: Outlines
///////////////////////////////////////////////////////////////
#if !defined(TINYGL) && !defined(TRENKI3D)
if(m_BumpLight.active && m_BumpLight.type==2 && m_CullMode!=0)
{
// blow up the vertices along their normals by given ratio

// get the distance camera -> object
// 'm' is inverse of camera
gCopyVertex(lv0, m_Camera.eye);
gTransformVector(invM, lv0);
gSubVertex(lv0, cFrame->center_of_mass);

// 0.003f = relative line width
float scale = m_Camera.tan_fov * gGetLength(lv0) * 0.003f;
// the scaling is a problem, since it get's rotated
// you have to scal*scal, since scaling is still active
// at this point, so we have to "undo" it twice
for(int i=0; i<=m_nTransformations; ++i)
{
// float matscale = m_Transformations[i].m_Scale[1]; // #NEED
float fsx,fsy,fsz;
if(GetMatrixScalings(fsx,fsy,fsz))
{
float matscale = (fsx+fsy+fsz)/3;
scale /= (matscale * matscale);
}
}
if(scale>cFrame->max_radius/2.0f) goto skip_outlines; // Object is too small - would be a black dot
if(scale<1E-7f) scale=1E-7f; // Limit for numerical problems otherwise

this->CullMode(-m_CullMode); // reverse
float norm[3];
for (int n=0; n<the_obj.m_tri_animation.Size(); ++n)
{
gCopyVertex(norm, the_obj.m_tri_animation.GetAt(n)->normal);
gMultVertex(norm, scale);
gAddVertex(the_obj.m_tri_animation.GetAt(n)->pos, norm);
}

if ((void*)glBindBufferArb)
{
// Use the morphing object here
pVBO_id = &the_obj.m_VBO_id_morphing;
int newsize = sizeof(POLY_NODE) * the_obj.m_tri_animation.Size();
if (*pVBO_id==0)
{
glGenBuffersArb(1, pVBO_id);
glBindBufferArb(GL_ARRAY_BUFFER_ARB, *pVBO_id);
glBufferDataArb(GL_ARRAY_BUFFER_ARB, newsize, &the_obj.m_tri_animation[0], GL_STREAM_DRAW_ARB);
}
else
{
// check data size in VBO is same as input array, if not return 0 and delete VBO
int bufferSize = 0;
glBindBufferArb(GL_ARRAY_BUFFER_ARB, *pVBO_id);
glBufferDataArb(GL_ARRAY_BUFFER_ARB, newsize, &the_obj.m_tri_animation[0], (GLenum)GL_STREAM_DRAW_ARB);
}
}

// goto skip_outlines;
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer(  3, GL_FLOAT, sizeof(POLY_NODE), BUFFER_OFFSET(the_obj.m_tri_animation.GetAt(0)->pos));


if((void*)glActiveTextureArb)
{
glActiveTextureArb(GL_TEXTURE1_ARB); // Texture unit
glDisable(GL_TEXTURE_2D);
glActiveTextureArb(GL_TEXTURE0_ARB);
glDisable(GL_TEXTURE_2D);
}
else
{
glDisable(GL_TEXTURE_2D);
}
glbDisable(GL_LIGHTING);
glbEnable(GL_COLOR_MATERIAL);
glbColor4f(0.0f,0.0f,0.0f,1.0f);
glDepthFunc(GL_LEQUAL);

// This looks much better, but is slow as hell!
//#define SMOOTH_LINES
#ifdef SMOOTH_LINES
glLineWidth(5);
glPolygonMode(GL_BACK, GL_LINE); // Backfacing polygons as lines
glPolygonMode(GL_FRONT, GL_LINE); // Backfacing polygons as lines
#endif
glDrawArrays(GL_TRIANGLES, 0, the_obj.m_tri_animation.Size());	// Draw All Of The Triangles At Once
#ifdef SMOOTH_LINES
glLineWidth(1);
glPolygonMode(GL_BACK, GL_FILL); // Backfacing polygons as lines
glPolygonMode(GL_FRONT, GL_FILL); // Backfacing polygons as lines
#endif

glDepthFunc(GL_LESS);
// Disable Pointers
glDisableClientState( GL_VERTEX_ARRAY );								// Disable Vertex Arrays
// no need to un-scale the vertices again. Vertices are only valid for this frame
m_pRBOW->SetTexture3D(m_pRBOW->m_Texture3D[0], m_pRBOW->m_Texture3D[1], m_pRBOW->m_Texture3D[2]);
this->CullMode(-m_CullMode); // re-reverse

if((void*)glBindBufferArb) // allow normal vertex arrays (POLYSPRITE)
glBindBufferArb( GL_ARRAY_BUFFER_ARB, 0);
}
skip_outlines:
#endif

// Reset blending modes for both textures
if ((void*)glActiveTextureArb)
{
glActiveTextureArb(GL_TEXTURE1_ARB);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
glActiveTextureArb(GL_TEXTURE0_ARB);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
}
glPopMatrix();}

// Debug Normals
#if defined(_DEBUG) && !defined(TINYGL) && !defined(TRENKI3D)
#define DEBUG_MODEL_NORMALS
#ifdef DEBUG_MODEL_NORMALS
glPushMatrix();
TransformMatrix();
glbDisable(GL_FOG);
// glbEnable(GL_COLOR_MATERIAL);
glDisable(GL_TEXTURE_2D);
glBegin(GL_LINES);
float sc=cFrame->max_radius/4.0f;
for (int i=0; i<the_obj.m_tri_animation.Size(); i++)
{
float v[3];
cNode = the_obj.m_tri_animation.GetAt(i);

// Add normal Vertex - red
glbColor4f(1,0,0,1);
glVertex3fv(cNode->pos);
gCopyVertex(v, cNode->normal); gMultVertex(v, sc); gAddVertex(v, cNode->pos);
glVertex3fv(v);
glbColor4f(1,1,1,1);
glVertex3fv(v);
gCopyVertex(v, cNode->normal); gMultVertex(v, sc*2); gAddVertex(v, cNode->pos);
glVertex3fv(v);

/*			// Add tangent Vertex - green
glbColor4f(0,1,0,1);
glVertex3fv(cNode->pos);
gCopyVertex(v, cNode->tangent); gMultVertex(v, sc); gAddVertex(v, cNode->pos);
glVertex3fv(v);

// Add binormal Vertex - blue
glbColor4f(0,0,1,1);
glVertex3fv(cNode->pos);
gCopyVertex(v, cNode->binormal); gMultVertex(v, sc); gAddVertex(v, cNode->pos);
glVertex3fv(v);
// Add bump-displacement Vertex - yellow
glbColor4f(1,1,0,1);
glVertex3fv(cNode->pos);
gCopyVertex(v, cNode->bump_light); gMultVertex(v, sc); gAddVertex(v, cNode->pos);
glVertex3fv(v);
*/
}
glEnd();
glEnable(GL_TEXTURE_2D);
glPopMatrix();
#endif
#endif

glDisable(GL_COLOR_MATERIAL);
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);
#endif // !TINYGL
}
#endif // TRENKI3D



// ------------------------------------------------------------- //
// do Frustum and store the matrix (EGL has no glGetFloatv(XX_MATRIX)
// ------------------------------------------------------------- //
void glbFrustum(float left, float right, float bottom, float top, float znear, float zfar, float m[16])
{
// float m [16];
float _2n = 2.0f * znear;
float _1over_rml = 1.0f / (right - left);
float _1over_fmn = 1.0f / (zfar - znear);
float _1over_tmb = 1.0f / (top - bottom);

m[0] = _2n * _1over_rml;
m[1] = 0.0f;
m[2] = 0.0f;
m[3] = 0.0f;

m[4] = 0.0f;
m[5] = _2n * _1over_tmb;
m[6] = 0.0f;
m[7] = 0.0f;

m[8] = (right + left) * _1over_rml;
m[9] = (top + bottom) * _1over_tmb;
m[10] = (-(zfar + znear)) * _1over_fmn;
m[11] = -1.0f;

m[12] = 0.0f;
m[13] = 0.0f;
m[14] = - _2n * zfar * _1over_fmn;
m[15] = 0.0f;

#if defined(HAVE_OPENGL)||defined(HAVE_OPENGL_ES)
// glLoadMatrixf(m);
glMultMatrixf(m);
#endif
}

void glbOrtho(float l, float r, float b, float t, float n, float f, float m[16])
{
m[0]=2/(r - l);
m[1]=0;
m[2]=0;
m[3]=-(r + l)/(r - l);
m[4]=0;
m[5]=2/(t - b);
m[6]=0;
m[7]=-(t + b)/(t - b);
m[8]=0;
m[9]=0;
m[10]= -2/(f - n);
m[11]=-(f + n)/(f - n);
m[12]=0;
m[13]=0;
m[14]=0;
m[15]=1;

#if defined(HAVE_OPENGL)||defined(HAVE_OPENGL_ES)
// glLoadMatrixf(m);
glMultMatrixf(m);
#endif
}


// ------------------------------------------------------------- //
// Toggle Z buffer
// ------------------------------------------------------------- //
void Rainbows3D::SetDepthTesting(bool enable)
{
#ifdef TRENKI3D
tglEnableDepthTest(enable ? 1:0);
#else
if(enable)
{
glbEnable(GL_DEPTH_TEST); glDepthFunc(GL_LESS);
}
else
{
glbDisable(GL_DEPTH_TEST);
}
#endif
}


// ------------------------------------------------------------- //
// Start a 3D Viewport
// ------------------------------------------------------------- //
void Rainbows3D::Make3DViewport(float zNear, float zFar, float fov)
{
int	height, width;
m_pRBOW->m_bDirtyZBuffer = true;

DoShadows(false); // draw shadow from last scene -> must be called in MAKE2D & SHOWSCREEN, too

width =m_pRBOW->m_WND.width;
height=m_pRBOW->m_WND.height;

if(height==0)										//Prevent a divide by zero (bad)
height=1;										//Making height equal one


m_Camera.tan_fov=tanf( (min(89.0f, fov+5.0f))*BOG_INV_F );// 5% difference due to fast sqrt, qtan is a bit inaccurate... add 5 degress to be sure
m_Camera.znear = zNear;
m_Camera.zfar=zFar;
m_Camera.up[0]=m_Camera.up[2]=0.0f; m_Camera.up[1]=1.0f;



#ifdef TRENKI3D
// float	aspect=(float)m_pRBOW->m_WND.viewport.width/(float)m_pRBOW->m_WND.viewport.height;
float	aspect=(float)width/(float)height;
tgluPerspective(fov, aspect, zNear, zFar);
tglLoadIdentity();

#else

/*
if(m_pRBOW->m_landscape && m_pRBOW->m_CurrentFBO==-1)
{
glViewport(	m_pRBOW->m_WND.width - 1 - m_pRBOW->m_WND.viewport.y -  m_pRBOW->m_WND.viewport.height,
m_pRBOW->m_WND.height-m_pRBOW->m_WND.viewport.width-m_pRBOW->m_WND.viewport.x,
m_pRBOW->m_WND.viewport.height,
m_pRBOW->m_WND.viewport.width);
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
glRotatef(-90  ,0,0,1);
}
else
{
glViewport(	m_pRBOW->m_WND.viewport.x,
m_pRBOW->m_WND.height-m_pRBOW->m_WND.viewport.height-m_pRBOW->m_WND.viewport.y,
m_pRBOW->m_WND.viewport.width,
m_pRBOW->m_WND.viewport.height);
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
}
*/


int x = m_pRBOW->m_WND.viewport.x;
int y = m_pRBOW->m_WND.viewport.y;
int w = m_pRBOW->m_WND.viewport.width;
int h = m_pRBOW->m_WND.viewport.height;

if(m_pRBOW->m_CurrentFBO==-1)
{
glMatrixMode(GL_PROJECTION);
switch(m_pRBOW->m_landscape)
{
default:	
glLoadIdentity();
break;
case 1:
{
float matrix[16] = {0,-1,0,0, 1,0,0,0,  0,0,1,0,  0,0,0,1 };
glLoadMatrixf(matrix);
break;
}
case 2:
{
float matrix[16] = {-1,0,0,0, 0,-1,0,0,  0,0,1,0,  0,0,0,1 };
glLoadMatrixf(matrix);
break;
}
case 3:
{
float matrix[16] = {0, 1,0,0, -1,0,0,0,  0,0,1,0,  0,0,0,1 };
glLoadMatrixf(matrix);
break;
}
}

int vpx, vpy;
m_pRBOW->Rot_Screen2Display(x, y, w, h, &vpx, &vpy, &w, &h);

if(m_pRBOW->m_landscape==1 || m_pRBOW->m_landscape==3)
{
int swp=w; w=h; h=swp;
}

glViewport(vpx, m_pRBOW->m_WND.height-h-vpy, w, h);
glMatrixMode(GL_PROJECTION);
}
else
{
int fb_height = m_pRBOW->m_Texture[m_pRBOW->m_FBuffer[m_pRBOW->m_CurrentFBO].m_SpriteIndex].bh;
glViewport(	m_pRBOW->m_WND.viewport.x,
fb_height-m_pRBOW->m_WND.viewport.height-m_pRBOW->m_WND.viewport.y,
m_pRBOW->m_WND.viewport.width,
m_pRBOW->m_WND.viewport.height);
glMatrixMode(GL_PROJECTION);
glLoadIdentity();
}

// float	aspect=(float)m_pRBOW->m_WND.viewport.width/(float)m_pRBOW->m_WND.viewport.height;
float	aspect=(float)w/(float)h;

// gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,1f,1000.0f);
// void GLAPIENTRY gluPerspective(GLdouble fov=45.0, GLdouble aspect, GLdouble zNear, GLdouble zFar)
// {
// GLdouble

float xmin, xmax, ymin, ymax;
if (fov>0.0f) // perspective view
{
ymax = zNear * qtan(fov * (PI_F) / 360.0f);
ymin = -ymax;
xmin = ymin * aspect;
xmax = ymax * aspect;
glbFrustum(xmin, xmax, ymin, ymax, zNear, zFar, m_ProjectionMatrix);
}
else // Ortho view
{
ymax = zNear * qtan(-fov * (PI_F) / 360.0f) * 100.0f;
ymin = -ymax;
xmin = ymin * aspect;
xmax = ymax * aspect;
glbOrtho(xmin, xmax, ymin, ymax, zNear, zFar, m_ProjectionMatrix);
m_Camera.tan_fov = tanf(89.0f*BOG_INV_F); // for clipping of objects + width of cartoon lines
}

glMatrixMode(GL_MODELVIEW);							//Select the modelview matrix
glLoadIdentity();									//Reset The modelview matrix

// Options for 3D Mode:
// -----------------------------------


glbEnable(GL_CULL_FACE);
glFrontFace(GL_CCW);	// Counter clock-wise polygons face out

glbDisable(GL_FOG);
glbDisable(GL_LINE_SMOOTH);
glbDisable(GL_POINT_SMOOTH);

#if defined(HAVE_OPENGL)
glbDisable(GL_POLYGON_SMOOTH); // Ugly slow otherwise!
glbDisable(GL_POLYGON_OFFSET_POINT);
glbDisable(GL_AUTO_NORMAL);
glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
#endif

glbDisable(GL_STENCIL_TEST);
glbDisable(GL_NORMALIZE);
glbDisable(GL_LIGHTING);
// Enable Antialaising
glShadeModel(GL_SMOOTH);
//glbEnable(GL_COLOR_MATERIAL);
glbEnable(GL_DITHER);
// glGetFloatv(GL_MODELVIEW_MATRIX, (float*)m_CameraMatrix); -> SetCamera does it

glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);
#endif


// Z-Buffer
this->SetDepthTesting(true);

m_SphereMapping=false;
m_BumpLight.active=false;
// clear transformations (if any)
while(PopTransformation()) {}

// Disable culling
CullMode(0);

SetTextureOffset(0,0);
m_pRBOW->SetTexture3D(-1, -1, 0);					// No Texture

SetCamera(0,0,0, 0,0,-1);
}





void LookAt( float eyex, float eyey, float eyez, float centerx, float centery, float centerz, float upx, float upy, float upz, float m[16])
{
#ifdef TRENKI3D
tglLookAt(eyex,eyey,eyez, centerx,centery,centerz, upx,upy,upz);
#else


// float m[16];
float x[3], y[3], z[3];
float mag;
// Make rotation matrix

// Z vector
z[0] = eyex - centerx;
z[1] = eyey - centery;
z[2] = eyez - centerz;
mag = (float)sqrt(z[0]*z[0] + z[1]*z[1] + z[2]*z[2]);

if (mag)
{ // mpichler, 19950515
z[0] /= mag;
z[1] /= mag;
z[2] /= mag;
}


// Up = 0, 1, 0
/*
// X vector = Y cross Z
x[0] = z[2];
x[1] = 0;
x[2] = -z[0];

y[0] =  z[1]*x[2];
y[1] = -z[0]*x[2] + z[2]*x[0];
y[2] = -z[1]*x[0];
*/

// otherwise:
// Y vector
y[0] = upx;
y[1] = upy;
y[2] = upz;

// X vector = Y cross Z
x[0] = y[1]*z[2] - y[2]*z[1];
x[1] = -y[0]*z[2] + y[2]*z[0];
x[2] = y[0]*z[1] - y[1]*z[0];

// Recompute Y = Z cross X
y[0] = z[1]*x[2] - z[2]*x[1];
y[1] = -z[0]*x[2] + z[2]*x[0];
y[2] = z[0]*x[1] - z[1]*x[0];
// end otherwise


// cross product gives area of parallelogram, which is < 1.0 for
// non-perpendicular unit-length vectors; so normalize x, y here
mag = (float)sqrt( x[0]*x[0] + x[1]*x[1] + x[2]*x[2] );
if (mag)
{
x[0] /= mag;
x[1] /= mag;
x[2] /= mag;
}

mag = (float)sqrt( y[0]*y[0] + y[1]*y[1] + y[2]*y[2] );
if (mag)
{
y[0] /= mag;
y[1] /= mag;
y[2] /= mag;
}


#if 0 // old way - we NEED the matrix in "m", mind!
float mrot[16] = {x[0],y[0],z[0],0,   x[1],y[1],z[1],0,   x[2],y[2],z[2],0,   0,0,0,1};
#define M(row,col) mrot[col*4 + row]
M(0,0) = x[0]; M(0,1) = x[1]; M(0,2) = x[2]; M(0,3) = 0.0;
M(1,0) = y[0]; M(1,1) = y[1]; M(1,2) = y[2]; M(1,3) = 0.0;
M(2,0) = z[0]; M(2,1) = z[1]; M(2,2) = z[2]; M(2,3) = 0.0;
M(3,0) = 0.0; M(3,1) = 0.0; M(3,2) = 0.0; M(3,3) = 1.0;
#undef M
glLoadIdentity();
glMultMatrixf( mrot );
glTranslatef(-eyex, -eyey, -eyez);
#else
float mrot[16] = {x[0],y[0],z[0],0,   x[1],y[1],z[1],0,   x[2],y[2],z[2],0,   0,0,0,1};

// Translate Eye to Origin
float mtrans[16] = {1,0,0,0,   0,1,0,0,  0,0,1,0,  -eyex,-eyey,-eyez,1};
matmul4(m, mrot, mtrans);

// glLoadIdentity();
glLoadMatrixf( m );
#endif


#endif
}


//------------------------------------------------------------------//
// Set Camera UP
//------------------------------------------------------------------//
void Rainbows3D::SetCameraUp(float x, float y, float z)
{
m_Camera.up[0]=x; m_Camera.up[1]=y; m_Camera.up[2]=z;
}


//------------------------------------------------------------------//
// Set & Point Camera - POSXYZ - PointToXYZ
//------------------------------------------------------------------//
void Rainbows3D::SetCamera(float px, float py, float pz, float rx, float ry, float rz)
{
m_Camera.eye[0]=px; m_Camera.eye[1]=py; m_Camera.eye[2]=pz;
m_Camera.lookat[0]=rx; m_Camera.lookat[1]=ry; m_Camera.lookat[2]=rz;
LookAt(px, py, pz, rx, ry, rz, m_Camera.up[0], m_Camera.up[1], m_Camera.up[2], m_ModelViewCameraMatrix);

while(PopTransformation()) {}

// prepare frustum culling
ExtractFrustum();
}

// ------------------------------------------------------------------//
// Create an ambient light
// ------------------------------------------------------------------//
void Rainbows3D::AmbientLt(int num, unsigned long col)
{
SpotLt(num, col, m_Camera.eye[0], m_Camera.eye[1], m_Camera.eye[2], 
-m_Camera.eye[0],-m_Camera.eye[1],-m_Camera.eye[2]
, 180, 0);
/*
num = num%8; // Just to be sure
GLfloat light_ambient[] = {	((BYTE) (col))/255.0f,
((BYTE) (((WORD) (col)) >> 8))/255.0f,
((BYTE) ((col) >> 16))/255.0f,
0.0f};
// Ambient Light Color
glLightfv(GL_LIGHT0+num, GL_AMBIENT, light_ambient);

// Lights ON
glbEnable(GL_LIGHT0+num);
glbEnable(GL_LIGHTING);
m_LightsOn |= (1<<num);
*/
}

// ------------------------------------------------------------------//
// Create a spotlight
// ------------------------------------------------------------------//
void Rainbows3D::SpotLt(int num, unsigned long col, float x, float y, float z, float dx, float dy, float dz, float cutoff, int ShowDebug)
{
#if !defined(TINYGL) && !defined(TRENKI3D)

// no bump mapping on ES
#if defined(HAVE_OPENGL_ES)
if(num==-1) return;
#endif

if (num<0)
{
m_BumpLight.active=(fabs(cutoff)<1e-5f ? false : true);

// store pos+colour for active light -> keep when turn off (for shadows)
if(m_BumpLight.active)
{
m_BumpLight.pos[0]=x;
m_BumpLight.pos[1]=y;
m_BumpLight.pos[2]=z;
m_BumpLight.dwcol = col;
}

switch(num)
{
case -1: // bump
m_BumpLight.type=1; break;
default:
case -2: // cartoon
m_BumpLight.type=2; break;
case -3: // shadow
m_BumpLight.type=3;
DoShadows(m_BumpLight.active);
break;
}
return;
}

num = num%8; // Just to be sure
if (cutoff==0.0f)
{
glDisable(GL_LIGHT0+num);
m_LightsOn &= ~(1<<num);
if(!m_LightsOn) glbDisable(GL_LIGHTING);
return;
}

// Color + Direction
static GLfloat light_off[]={0,0,0,1};
static GLfloat light_on[]={1,1,1,1};
GLfloat light_pos[] = { x,  y,  z, 1.0f/*fix*/}; // w=0.0: Directional light - position == direction(pretty stupid)
GLfloat light_dir[] = {dx, dy, dz, 0.0};
GLfloat light_diffuse[] = {	((BYTE) (col))/255.0f, // Red
((BYTE) (((WORD) (col)) >> 8))/255.0f, // Green
((BYTE) ((col) >> 16))/255.0f, // Blue
1.0f};
glbEnable(GL_LIGHTING);
glEnable(GL_LIGHT0+num);
m_LightsOn |= (1<<num);

//glbEnable(GL_COLOR_MATERIAL);
#if defined(HAVE_OPENGL)
glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
#endif

glMatrixMode(GL_MODELVIEW);
{glPushMatrix();
//		glLoadIdentity();
//	glLoadMatrixf(m_CameraMatrix);
// no direction, no pos
if (x==0 && y==0 && z==0 && dx==0 && dy==0 && dz==0)
{
float d[]={0,0,1,0};
glLightfv(GL_LIGHT0+num, GL_POSITION, d);

glLightfv(GL_LIGHT0+num, GL_DIFFUSE, light_diffuse);
glLightfv(GL_LIGHT0+num, GL_SPECULAR, light_off);
glLightf(GL_LIGHT0+num, GL_SPOT_CUTOFF, 180);
return;
}

if(cutoff==180) // parallel light (direction, no position)
{
glLightf (GL_LIGHT0+num, GL_SPOT_CUTOFF, 180);
gMultVertex(light_dir, -1);
gUnify(light_dir);
light_dir[3] = 0;
glLightfv(GL_LIGHT0+num, GL_POSITION, light_dir);
glLightfv(GL_LIGHT0+num, GL_DIFFUSE, light_diffuse);
glLightfv(GL_LIGHT0+num, GL_SPECULAR, light_off);
}
else if (cutoff <= 90) // spot light
{
glLightf (GL_LIGHT0+num, GL_SPOT_CUTOFF,    cutoff);
gUnify(light_dir);
glLightfv(GL_LIGHT0+num, GL_POSITION,       light_pos);
glLightfv(GL_LIGHT0+num, GL_SPOT_DIRECTION, light_dir);
glLightfv(GL_LIGHT0+num, GL_DIFFUSE, light_diffuse);
glLightfv(GL_LIGHT0+num, GL_SPECULAR, light_diffuse);
}
else // (360) point light
{
glLightf(GL_LIGHT0+num, GL_SPOT_CUTOFF, 180);
glLightfv(GL_LIGHT0+num, GL_POSITION, light_pos);
glLightfv(GL_LIGHT0+num, GL_DIFFUSE, light_diffuse);
glLightfv(GL_LIGHT0+num, GL_SPECULAR, light_diffuse);
}
}glPopMatrix();


if (ShowDebug)
{
DrawDot(light_pos, RGB(255,200,128), 40);
if (cutoff<=90)
{
float vec[3];
gCopyVertex(vec, light_dir);
gUnify(vec);
gMultVertex(vec, 500);
gAddVertex(vec, light_pos);
DrawLine(light_pos, vec, RGB(225,170,108), 3);
}
}
#endif
}





//------------------------------------------------------------------//
// Draw the Coord-Axis
//------------------------------------------------------------------//
void Rainbows3D::DrawCoordAxis(float x, float y, float z)
{
#if !defined(TINYGL) && !defined(TRENKI3D)
glPushMatrix();
glLoadMatrixf((const float*) m_ModelViewCameraMatrix);

//glbEnable(GL_COLOR_MATERIAL);
glbEnable( GL_LINE_SMOOTH );
if(m_pRBOW->m_Texture3D[0]>=0) glDisable(GL_TEXTURE_2D);
if(m_LightsOn) glbDisable(GL_LIGHTING);

// Move
glTranslatef(x, y, z);
float scale = 20.0f;
glScalef(scale,scale,scale);

glEnableClientState( GL_VERTEX_ARRAY );

// Draw
GLfloat coox[]={
0.0,  0.0,  0.0,
1.0,  0.0,  0.0,
0.75, 0.25, 0.0,
0.75,-0.25, 0.0,
1.0,  0.0,  0.0,
0.75, 0.0, 0.25,
0.75, 0.0,-0.25,
1.0,  0.0,  0.0};
GLfloat cooy[]={
0.0,   0.0,  0.00,
0.0,   1.0,  0.00,
0.0,   0.75, 0.25,
0.0,   0.75,-0.25,
0.0,   1.0,  0.00,
0.25,  0.75, 0.00,
-0.25, 0.75, 0.00,
0.0,   1.0,  0.00};
GLfloat cooz[]={
0.00, 0.00, 0.00,
0.00, 0.00, 1.00,
0.25, 0.00, 0.75,
0.25, 0.00, 0.75,
0.00, 0.00, 1.00,
0.00, 0.25, 0.75,
0.00,-0.25, 0.75,
0.00, 0.00, 1.00};


glbColor4f(1.0f, 0, 0, 1.0f);
glVertexPointer(  3, GL_FLOAT, 0, (char*)&coox[0]);
glDrawArrays(GL_LINE_STRIP, 0, sizeof(coox)/(3*sizeof(GLfloat)));

glbColor4f(0,     1.0f, 0, 1.0f);
glVertexPointer(  3, GL_FLOAT, 0, (char*)&cooy[0]);
glDrawArrays(GL_LINE_STRIP, 0, sizeof(cooy)/(3*sizeof(GLfloat)));

glbColor4f(0, 0, 1.0f,1.0f);
glVertexPointer(  3, GL_FLOAT, 0, (char*)&cooz[0]);
glDrawArrays(GL_LINE_STRIP, 0, sizeof(cooz)/(3*sizeof(GLfloat)));

glDisableClientState( GL_VERTEX_ARRAY );

if(m_LightsOn) glbEnable(GL_LIGHTING);

glbDisable( GL_LINE_SMOOTH );
glbDisable(GL_COLOR_MATERIAL);
if(m_pRBOW->m_Texture3D[0]>=0)
glEnable(GL_TEXTURE_2D);
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);

glPopMatrix();
#endif
}




//------------------------------------------------------------------//
// Start Creating a new 3D Object by hand-drawing it
//------------------------------------------------------------------//
void Rainbows3D::UserObjectStart(int num, int type)
{
m_iCurObjFrame = 0;
m_Objects[num].Clear(false);
m_Objects[num].m_objects.AllocAtLeast(1);

gCurObject=num;

POLY_FRAME	Frame;
m_Objects[num].m_objects.SetSize(1);
m_Objects[num].m_objects[0].obj.m_Frames.Push(Frame);

UserObjectSetNormal(0,0,1);

// New Object
UserObjectNewGroup(type);
}

//------------------------------------------------------------------//
// switch to another frame
//------------------------------------------------------------------//
void Rainbows3D::UserObjectSetFrame(int frm)
{
if(frm<0) return;

Queue<POLY_FRAME>& frames = m_Objects[gCurObject].m_objects[0].obj.m_Frames;

if(frames.Size() <= frm)
{
frames.SetSize(frm+1);
}

// if it's an empty frame, push the "group type" of the startobj call
if(frames[frm].nodes.Size() == 0)
{
frames[frm].nodes.Push(m_Objects[gCurObject].m_objects[0].obj.m_Frames[0].nodes[0] );
}

m_iCurObjFrame = frm;
}

//------------------------------------------------------------------//
// Restart new Stripe at Hand Drawing
//------------------------------------------------------------------//
void Rainbows3D::UserObjectNewGroup(int type)
{
// Determine how to start -> See also UserObjectNewGroup!
unsigned int col = COL_NEW_STRIP;
switch (type)
{
case 0: // Triangles
col=COL_NEW_TRI;
break;
case 1:
col=COL_NEW_STRIP;
break;
case 2:
col=COL_NEW_FAN;
break;
}
POLY_NODE	Node;
memset(&Node, 0, sizeof(Node));
Node.col(col);
m_Objects[gCurObject].m_objects[0].obj.m_Frames.GetAt(m_iCurObjFrame)->nodes.Push(Node);
}

//------------------------------------------------------------------//
// Add a Vertex to a Hand Drawing
//------------------------------------------------------------------//
void Rainbows3D::UserObjectAddVertex(float x, float y, float z, float tx, float ty, unsigned long col)
{
if (gCurObject!=-1)
{
POLY_NODE&	Node = m_UserObjectNode;
// And Store it
Node.pos[0]=x;
Node.pos[1]=y;
Node.pos[2]=z;
Node.tex[0]=  tx; // tx
Node.tex[1]= -ty; // ty  - texture flipped due to grab sprite compatibility
Node.col(col);
m_Objects[gCurObject].m_objects[0].obj.m_Frames.GetAt(m_iCurObjFrame)->nodes.Push(Node);
printf("%d %d\n", m_iCurObjFrame, m_Objects[gCurObject].m_objects[0].obj.m_Frames.GetAt(m_iCurObjFrame)->nodes.Size());
}
}

//------------------------------------------------------------------//
// Add a normal direction to a Hand Drawing with Autonormals 0
//------------------------------------------------------------------//
void Rainbows3D::UserObjectSetNormal(float x, float y, float z)
{
if (gCurObject!=-1)
{
POLY_NODE&	Node = m_UserObjectNode;
// And Store it
Node.normal[0]=x;
Node.normal[1]=y;
Node.normal[2]=z;
}
}


//------------------------------------------------------------------//
// Finish a Hand Drawing
//------------------------------------------------------------------//
void Rainbows3D::UserObjectEnd()
{
Queue <POLY_NODE>*	pN;
MeshObjectX& the_obj = m_Objects[gCurObject].m_objects[0].obj;
m_Objects[gCurObject].is_multiworld=false;
pN=&the_obj.m_Frames.GetAt(0)->nodes;

if(the_obj.m_Frames.Size()==0 || the_obj.m_Frames.GetAt(0)->nodes.Size()<3)
{
the_obj.Clear(true);
m_Objects[gCurObject].is_loaded = false;
}
else
{
bool bOK = true;

m_Objects[gCurObject].is_loaded=true;

int nof_nodes0 = the_obj.m_Frames[0].nodes.Size();
for(int f=0; f<the_obj.NumFrames(); ++f)
{
if(the_obj.m_Frames[f].nodes.Size() != nof_nodes0)
{
WIN32_ONLY( DEBUG(CGStr("Frame ")+DGNat(f)+CGStr(" has ")+DGNat(the_obj.m_Frames[f].nodes.Size())
+CGStr(" nodes, but must have (like frame 0) ") + DGNat(nof_nodes0) + CGStr(" nodes\n") ));
m_Objects[gCurObject].is_loaded=false;
bOK = false;
break;
}
}

// Compress Data
if(bOK)
{
the_obj.BuildColorTable();
switch (m_AutoNormalMode)
{
case 0: // No normals (or user defined)
break;
case 1: // Flat normals
the_obj.AutoNormalsAfterCompression(true, false, false);
break;
case 2: // smooth normals
the_obj.AutoNormalsAfterCompression(true, true, false);
break;
}
//		PreRenderObject(gCurObject);

// Not yet created triangles due to normal calculations?
if (the_obj.m_tri_animation.Size()==0)
the_obj.PrepareTriangles(); // For VBO rendering
the_obj.CalcMaxRadius();
}
}
gCurObject=-1;
}


#ifdef _DEBUG
// #define DEBUG_COLLISIONS -> glb3d does this for you if __DG_DEBUG
#endif


//------------------------------------------------------------------//
// Draw a Dot in World Coordinates
//------------------------------------------------------------------//
void Rainbows3D::DrawDot(const float *pos, unsigned long col, float size)
{
#if !defined(TINYGL) && !defined(TRENKI3D)
glPushMatrix();
// Do not gTransformMatrix()
glbEnable(GL_COLOR_MATERIAL);
glbColor4f(	   (col      &0xff)/ 255.0f,
((col>> 8) &0xff)/ 255.0f,
((col>> 16)&0xff)/ 255.0f, 1.0f);
glbEnable( GL_POINT_SMOOTH );
if(m_LightsOn) glbDisable(GL_LIGHTING);
m_pRBOW->SetTexture3D(-1, -1, 0);
glPointSize( size );

glBegin(GL_POINTS);
glVertex3fv(pos);
glEnd();

glPointSize( 1 );
glbDisable( GL_POINT_SMOOTH );
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);
glbDisable(GL_COLOR_MATERIAL);
if(m_LightsOn) glbEnable(GL_LIGHTING);
glPopMatrix();
#endif
}

//------------------------------------------------------------------//
// Draw a Line in World Coordinates
//------------------------------------------------------------------//
void Rainbows3D::DrawLine(const float* P1, const float* P2, unsigned long col, float width)
{
#if !defined(TINYGL) && !defined(TRENKI3D)
glPushMatrix();
glbEnable(GL_COLOR_MATERIAL); // Noo-hooo
// Do not gTransformMatrix()
glbColor4f(	 (col      &0xff)/ 255.0f,
((col>> 8) &0xff)/ 255.0f,
((col>> 16)&0xff)/ 255.0f, 1.0f);
if(m_LightsOn) glbDisable(GL_LIGHTING);
m_pRBOW->SetTexture3D(-1, -1, 0);

glLineWidth( width );
#if defined(HAVE_OPENGL_ES)
float pts[] = {P1[0], P1[1], P1[2], P2[0], P2[1], P2[2]};
glEnableClientState( GL_VERTEX_ARRAY );
glVertexPointer( 3, GL_FLOAT, 0, (char*)pts);
glDrawArrays(GL_LINES, 0, 2);
glDisableClientState( GL_VERTEX_ARRAY );
#else
glbEnable( GL_LINE_SMOOTH );
glBegin(GL_LINES);
glVertex3fv(P1); glVertex3fv(P2);
glEnd();
#endif
glLineWidth( 1 );

glbDisable( GL_LINE_SMOOTH );
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);
glbDisable(GL_COLOR_MATERIAL);
if(m_LightsOn) glbEnable(GL_LIGHTING);
glPopMatrix();
#endif
}

// --------------------------------------------------------------- //
// Subdivide an octahedron to match a sphere and draw it
// --------------------------------------------------------------- //
inline void SubdivideSphereGrid(float* org, float R, float* v1, float* v2, float* v3, int depth)
{
#if !defined(TINYGL) && !defined(TRENKI3D)
float v12[3], v23[3], v31[3];
if (depth == 0)
{
float tmp[3];
glBegin(GL_LINE_LOOP);
gCopyVertex(tmp, v1); gMultVertex(tmp, R); gAddVertex(tmp, org); glVertex3fv(tmp);
gCopyVertex(tmp, v2); gMultVertex(tmp, R); gAddVertex(tmp, org); glVertex3fv(tmp);
gCopyVertex(tmp, v3); gMultVertex(tmp, R); gAddVertex(tmp, org); glVertex3fv(tmp);
glEnd();
return;
}
gCopyVertex(v12, v1); gAddVertex(v12, v2);
gCopyVertex(v23, v2); gAddVertex(v23, v3);
gCopyVertex(v31, v3); gAddVertex(v31, v1);
gUnify(v12); gUnify(v23); gUnify(v31);

SubdivideSphereGrid(org,R, v1, v12, v31, depth-1);
SubdivideSphereGrid(org,R, v2, v23, v12, depth-1);
SubdivideSphereGrid(org,R, v3, v31, v23, depth-1);
SubdivideSphereGrid(org,R, v12,v23, v31, depth-1);
#endif
}

// --------------------------------------------------------------- //
// Draw a tesselated sphere
// --------------------------------------------------------------- //
void Rainbows3D::DrawSphereGrid(float* org, float R, unsigned long col, short width)
{
#if !defined(TINYGL) && !defined(TRENKI3D)
// User Constants
#define X .525731112119133606f
#define Z .850650808352039932f
static float vdata[12][3] = {    
{-X, 0.0, Z}, {X, 0.0, Z}, {-X, 0.0, -Z}, {X, 0.0, -Z},    
{0.0, Z, X}, {0.0, Z, -X}, {0.0, -Z, X}, {0.0, -Z, -X},    
{Z, X, 0.0}, {-Z, X, 0.0}, {Z, -X, 0.0}, {-Z, -X, 0.0} 
};
#undef X
#undef Y

static int tindices[20][3] = { 
{0,4,1}, {0,9,4}, {9,5,4}, {4,5,8}, {4,8,1},    
{8,10,1}, {8,3,10}, {5,3,8}, {5,2,3}, {2,7,3},    
{7,10,3}, {7,6,10}, {7,11,6}, {11,0,6}, {0,1,6}, 
{6,1,10}, {9,0,11}, {9,11,2}, {9,2,5}, {7,2,11} };


if(m_LightsOn) glbDisable(GL_LIGHTING);
m_pRBOW->SetTexture3D(-1, -1, 0);
glbDisable(GL_BLEND);
glbEnable(GL_COLOR_MATERIAL);
glLineWidth( width );
glPushMatrix();
glbColor4f(	((BYTE) (col)) / 255.0f,
((BYTE) (((WORD) (col)) >> 8)) / 255.0f,
((BYTE) ((col) >> 16)) / 255.0f, 1.0f);

for (long i=0; i<20; i++) 
{
float v1[3], v2[3], v3[3];
gCopyVertex(v1, vdata[tindices[i][0]]);
gCopyVertex(v2, vdata[tindices[i][1]]);
gCopyVertex(v3, vdata[tindices[i][2]]);
SubdivideSphereGrid(org,R, v1, v2, v3, 1); // depth -> [0; 5]
}
glLineWidth( 1 );
glbDisable(GL_COLOR_MATERIAL);
glPopMatrix();
if(m_LightsOn) glbEnable(GL_LIGHTING);
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);
#endif
}


// --------------------------------------------------------------- //
// Draw an AABB test object
// C1 = center of the AABB
// C2,3,4 are the direction vertices to 3 bounding plane's centers
// --------------------------------------------------------------- //
void Rainbows3D::DrawAABB(const float *C1, const float* C2, const float* C3, const float* C4, unsigned long col, short width)
{
#if !defined(TINYGL) && !defined(TRENKI3D)
float tmp[3], nC1[3], nC2[3], nC3[3], nC4[3];
m_pRBOW->SetTexture3D(-1, -1, 0);
glbDisable(GL_BLEND);
glbEnable(GL_COLOR_MATERIAL);
glLineWidth( width );
glPushMatrix();
// Do not gTransformMatrix()
glbColor4f(	((BYTE) (col)) / 255.0f,
((BYTE) (((WORD) (col)) >> 8)) / 255.0f,
((BYTE) ((col) >> 16)) / 255.0f, 1.0f);
if(m_LightsOn) glbDisable(GL_LIGHTING);


// nC1 = lower, left corner of box
gDiffVertex(nC1, C1 , C2); gSubVertex(nC1, C3); gSubVertex(nC1, C4);

gCopyVertex(nC2, C2); gMultVertex(nC2,2.0f);
gCopyVertex(nC3, C3); gMultVertex(nC3,2.0f);
gCopyVertex(nC4, C4); gMultVertex(nC4,2.0f);

glBegin(GL_LINES);
#define DLINE(from, delta, fac) glVertex3fv(from); gCopyVertex(tmp, delta); gMultVertex(tmp, fac); gAddVertex(tmp, from); glVertex3fv(tmp);
DLINE(nC1, C2, 2.0f);
DLINE(nC1, C3, 2.0f);
DLINE(nC1, C4, 2.0f);
gAddVertex(nC1, C2); gAddVertex(nC1, C2);
DLINE(nC1, C3, 2.0f);
DLINE(nC1, C4, 2.0f);
gAddVertex(nC1, C3); gAddVertex(nC1, C3);
DLINE(nC1, C2, -2.0f);
DLINE(nC1, C4,  2.0f);
gAddVertex(nC1, C4); gAddVertex(nC1, C4);
DLINE(nC1, C2, -2.0f);
DLINE(nC1, C3, -2.0f);
gSubVertex(nC1, C2); gSubVertex(nC1, C2);
DLINE(nC1, C3, -2.0f);
DLINE(nC1, C4, -2.0f);
gSubVertex(nC1, C3); gSubVertex(nC1, C3);
DLINE(nC1, C2, 2.0f);
glEnd();

glLineWidth( 1 );
glbDisable(GL_COLOR_MATERIAL);

glPopMatrix();
if(m_LightsOn) glbEnable(GL_LIGHTING);
glbColor4f(1.0f, 1.0f, 1.0f, m_pRBOW->m_falpha);
#endif
}

int g_CollisionTriangleIndex=-1; // index of the first triangle's vertex in the triangles list
int   CollisionGetLastCollisionTriangleIndex()
{
return g_CollisionTriangleIndex / 3; // Get the FACE index (3 triangles is one face.)
}


bool Rainbows3D::CollisionAABB(int id, int frame, const float *C1, const float* C2, const float* C3, const float* C4)
{
X_WORLD& wld = m_Objects[id];
for(int i=0; i<wld.m_objects.Size(); ++i)
if(CollisionAABB(wld.m_objects[i].obj, frame, C1, C2, C3, C4)) return true;
return false;
}
bool Rainbows3D::CollisionSphere(int id, int frame, float radius, float x, float y, float z)
{
X_WORLD& wld = m_Objects[id];
for(int i=0; i<wld.m_objects.Size(); ++i)
if(CollisionSphere(wld.m_objects[i].obj, frame, radius, x,y,z)) return true;
return false;
}
float Rainbows3D::CollisionRay(int id, int frame, float x, float y, float z, float dirx, float diry, float dirz)
{
X_WORLD& wld = m_Objects[id];
float rfac_neg = 0.0f, rfac_pos=0.0, fac;
for(int i=0; i<wld.m_objects.Size(); ++i)
{
fac=CollisionRay(wld.m_objects[i].obj, frame, x,y,z,dirx,diry,dirz);
if (fac!= 0.0f)
{
if(fac > 0.0f && (fac < rfac_pos || rfac_pos == 0.0f))
rfac_pos = fac; // found a better positive value
else
if(fac < 0.0f && (fac > rfac_neg || rfac_neg == 0.0f))
rfac_neg=fac; // found a better negative value
}
}
return rfac_pos == 0.0f ? rfac_neg : rfac_pos;
}



//------------------------------------------------------------------//
// Collision detection - axis aligned bounding box, object's triangles
// C1 = center of the AABB
// C2,3,4 are the direction vertices to 3 bounding plane's centers
//------------------------------------------------------------------//
bool Rainbows3D::CollisionAABB(MeshObjectX& the_obj, int frame, const float *C1, const float* C2, const float* C3, const float* C4)
{
g_CollisionTriangleIndex=-1;
if (the_obj.m_Frames.Size()<=frame) return false;
if (the_obj.m_Frames.GetAt(frame)->triangles.Size()<3) return false;

float	m[16];
float	nC1[3], nC2[3], nC3[3], nC4[3];
POLY_FRAME*	pFrm = the_obj.m_Frames.GetAt(frame);
// Shift & rotate the AABB into the model's position
// This way we don't have to transform each of the object's points
/*
glPushMatrix();
glLoadIdentity();
TransformMatrix();
glGetFloatv(GL_MODELVIEW_MATRIX, m);
glPopMatrix();
gInvertMatrix4x4(m);
*/
BuildMatrix();
gCopyMatrix(m, m_Transformations[m_nTransformations].m_Matrix);
gInvertMatrix4x4(m);

// This one is absolute
gCopyVertex(nC1, C1);
//gTransformVector(m_CameraMatrix, nC1);
gTransformVector(m, nC1);

// Make a very quick sphere-sphere test
gCopyVertex(nC2, C2); gAddVertex(nC2, C3); gAddVertex(nC2, C4);
// (gDot(a,a) = Squared length or radius
if(!IsPointInSphere(pFrm->center_of_mass, nC1, gDot(nC2, nC2) + SQUARE(pFrm->max_radius))) return false;

// These are realative to nC1 - we must transform an absolute point however!
//#define TRANSF(out, in) gCopyVertex(out, in); gAddVertex(out, C1); gTransformVector(m_CameraMatrix, out); gTransformVector(m, out); gSubVertex(out, nC1);
#define TRANSF(out, in) gCopyVertex(out, in); gAddVertex(out, C1); gTransformVector(m, out); gSubVertex(out, nC1);
TRANSF(nC2, C2); TRANSF(nC3, C3); TRANSF(nC4, C4);

int num_pts = (int)pFrm->triangles.Size();
for(int i=0; i<num_pts; i+=3)
{
if (	IntersectCuboidAndTriangle(nC1, nC2, nC3, nC4,	pFrm->triangles.GetAt(i)->pos,
pFrm->triangles.GetAt(i+1)->pos,
pFrm->triangles.GetAt(i+2)->pos))
{
g_CollisionTriangleIndex=i;	
return true;
}
}
return false;
}


//------------------------------------------------------------------//
// Collision detection - sphere, object's triangles
//------------------------------------------------------------------//
bool Rainbows3D::CollisionSphere(MeshObjectX& the_obj, int frame, float radius, float x, float y, float z)
{
g_CollisionTriangleIndex=-1;
if (the_obj.m_Frames.Size()<=frame) return false;
if (the_obj.m_Frames.GetAt(frame)->triangles.Size()<3) return false;
POLY_FRAME* pFrm = the_obj.m_Frames.GetAt(frame);

float	invM[16];
float sphere[3];
POLY_NODE*	pNode;
float	tri[3][3];
int		i;

// Shift & rotate the sphere into the model's position
// This way we don't have to transform each of the object's points
sphere[0]=x; sphere[1]=y; sphere[2]=z;
BuildMatrix();
gCopyMatrix(invM, m_Transformations[m_nTransformations].m_Matrix);
gInvertMatrix4x4(invM);
//	gTransformVector(m_CameraMatrix, sphere); // Move sphere to it's position due to camera
gTransformVector(invM, sphere);

// Quick test: Do the bounding spheres of the object and the test sphere collide?
if(!IsPointInSphere(pFrm->center_of_mass, sphere, SQUARE(radius + pFrm->max_radius))) return false;

// Special case: All triangles do not intersect, but lie completely inside sphere!
// Here we test only for the first node to be inside.
// This is very quick, so I do it at the very beginning
if(IsPointInSphere(pFrm->triangles.GetAt(0)->pos, sphere, SQUARE(radius))) return true;

for(i=0; i<(int)pFrm->triangles.Size(); )
{
pNode = pFrm->triangles.GetAt(i++);
tri[0][0]=pNode->pos[0];
tri[0][1]=pNode->pos[1];
tri[0][2]=pNode->pos[2];
pNode = pFrm->triangles.GetAt(i++);
tri[1][0]=pNode->pos[0];
tri[1][1]=pNode->pos[1];
tri[1][2]=pNode->pos[2];
pNode = pFrm->triangles.GetAt(i++);
tri[2][0]=pNode->pos[0];
tri[2][1]=pNode->pos[1];
tri[2][2]=pNode->pos[2];
if (::SpherePolygonCollision(tri, sphere, 3, radius) )
{
// Vizualize Hitting Triangle
#ifdef DEBUG_COLLISIONS
sphere[0]=x; sphere[1]=y; sphere[2]=z;
DrawSphereGrid(sphere, radius, RGB(255,0,0));
#endif
g_CollisionTriangleIndex=i-3;
return true;
}
}
#ifdef DEBUG_COLLISIONS
sphere[0]=x; sphere[1]=y; sphere[2]=z;
DrawSphereGrid(sphere, radius, RGB(0,255,0));
#endif
return false;
}

//------------------------------------------------------------------//
// Collision detection - ray, object's triangles
//------------------------------------------------------------------//
float Rainbows3D::CollisionRay(MeshObjectX& the_obj, int frame, float x, float y, float z, float dirx, float diry, float dirz)
{
int collision_pos=-1;
int collision_neg=-1;

if (the_obj.m_Frames.Size()<=frame) return false;
if (the_obj.m_Frames.GetAt(frame)->triangles.Size()<3) return false;
POLY_FRAME* pFrm = the_obj.m_Frames.GetAt(frame);

float		invM[16];
float		pt1[3], pt2[3];
POLY_NODE*	pNode;
float		tri[3][3];
int			i;

// Shift & rotate the line into the model's position
// This way we don't have to transform each of the object's points
pt1[0]=x; pt1[1]=y; pt1[2]=z;
pt2[0]=dirx; pt2[1]=diry; pt2[2]=dirz;
gUnify(pt2);
gAddVertex(pt2, pt1);
BuildMatrix();
gCopyMatrix(invM, m_Transformations[m_nTransformations].m_Matrix);
gInvertMatrix4x4(invM);
//	gTransformVector(m_CameraMatrix, pt1); // Move point to it's position due to camera
gTransformVector(invM, pt1);
//	gTransformVector(m_CameraMatrix, pt2);
gTransformVector(invM, pt2);

float rfac_neg = 0.0f, rfac_pos=0.0, fac;
for(i=0; i<(int)pFrm->triangles.Size(); i+=3)
{
pNode = pFrm->triangles.GetAt(i);
tri[0][0]=pNode->pos[0];
tri[0][1]=pNode->pos[1];
tri[0][2]=pNode->pos[2];
pNode = pFrm->triangles.GetAt(i+1);
tri[1][0]=pNode->pos[0];
tri[1][1]=pNode->pos[1];
tri[1][2]=pNode->pos[2];
pNode = pFrm->triangles.GetAt(i+2);
tri[2][0]=pNode->pos[0];
tri[2][1]=pNode->pos[1];
tri[2][2]=pNode->pos[2];
fac=::IntersectTriangleAndRay(tri, pt1, pt2);

if (fac!= 0.0f)
{
if(fac > 0.0f && (fac < rfac_pos || rfac_pos == 0.0f))
{
rfac_pos = fac; // found a better positive value
collision_pos=i;
}
else
if(fac < 0.0f && (fac > rfac_neg || rfac_neg == 0.0f))
{
rfac_neg=fac; // found a better negative value
collision_neg=i;
}
}

#ifdef DEBUG_COLLISIONS
if (fac!=0)
{
glbColor4f(1,0,0,1);
glbDisable(GL_BLEND);
glbEnable(GL_COLOR_MATERIAL);
glLineWidth( 5 );
glPushMatrix();
TransformMatrix();
glBegin(GL_TRIANGLES);//GL_LINE_STRIP);
glVertex3fv(tri[0]);
glVertex3fv(tri[1]);
glVertex3fv(tri[2]);
//glVertex3fv(tri[0]);
glEnd();
glPopMatrix();
glLineWidth( 1 );
glbDisable(GL_COLOR_MATERIAL);
}
#endif
}

if(rfac_pos == 0.0f)
{
g_CollisionTriangleIndex = collision_neg;
return rfac_neg;
}
g_CollisionTriangleIndex = collision_pos;
return rfac_pos;
}


//------------------------------------------------------------------//
// Collision detection - Cone, object's triangles
//------------------------------------------------------------------//
float Rainbows3D::CollisionCone(int id, int frame, float x, float y, float z, float dirx, float diry, float dirz, float angle)
{
X_WORLD& wld = m_Objects[id];
for(int i=0; i<wld.m_objects.Size(); ++i)
if(CollisionCone(wld.m_objects[i].obj, frame, x, y, z, dirx, diry, dirz, angle)) return true;
return false;
}


//------------------------------------------------------------------//
//------------------------------------------------------------------//
float Rainbows3D::CollisionCone(MeshObjectX& the_obj, int frame, float x, float y, float z, float dirx, float diry, float dirz, float angle)
{
float c_start[3], c_end[3];
c_start[0]=x; c_start[1]=y; c_start[2]=z;
c_end[0]=x+dirx*10000.0f; c_end[1]=y+diry*10000.0f; c_end[2]=z+dirz*10000.0f;

angle *= BOG_INV_F;

if (the_obj.m_Frames.Size()<=frame) return false;
if (the_obj.m_Frames.GetAt(frame)->triangles.Size()<3) return false;
POLY_FRAME* pFrm = the_obj.m_Frames.GetAt(frame);

if(::gSphereInCone(c_start, c_end, tanf(angle), pFrm->center_of_mass, pFrm->max_radius))
{
float		invM[16];
float		pt1[3], pt2[3];
POLY_NODE*	pNode;
float		tri[3][3];
int			i;

// Shift & rotate the line into the model's position
// This way we don't have to transform each of the object's points
pt1[0]=x; pt1[1]=y; pt1[2]=z;
pt2[0]=dirx; pt2[1]=diry; pt2[2]=dirz;
gUnify(pt2);
gAddVertex(pt2, pt1);
BuildMatrix();
gCopyMatrix(invM, m_Transformations[m_nTransformations].m_Matrix);
gInvertMatrix4x4(invM);
//	gTransformVector(m_CameraMatrix, pt1); // Move point to it's position due to camera
gTransformVector(invM, pt1);
//	gTransformVector(m_CameraMatrix, pt2);
gTransformVector(invM, pt2);


float cos_angle = cosf(angle);
float axis[3];
axis[0] = dirx; axis[1]=diry; axis[2]=dirz;
for(i=0; i<(int)pFrm->triangles.Size(); i+=3)
{
pNode = pFrm->triangles.GetAt(i);
tri[0][0]=pNode->pos[0];
tri[0][1]=pNode->pos[1];
tri[0][2]=pNode->pos[2];
pNode = pFrm->triangles.GetAt(i+1);
tri[1][0]=pNode->pos[0];
tri[1][1]=pNode->pos[1];
tri[1][2]=pNode->pos[2];
pNode = pFrm->triangles.GetAt(i+2);
tri[2][0]=pNode->pos[0];
tri[2][1]=pNode->pos[1];
tri[2][2]=pNode->pos[2];
if (TriangleAndCone(axis, c_start, cos_angle, tri))
return true;
}
}
return false;
}




// --------------------------------
// sphere/AABB collision. AABB in current matrix transformation
// --------------------------------
bool  Rainbows3D::CollisionSphereBox(float x, float y, float z, float r, float bx, float by, float bz)
{
float sphere[3], invM[16];

// Shift & rotate the sphere into the model's position
// This way we don't have to transform each of the object's points
sphere[0]=x; sphere[1]=y; sphere[2]=z;
BuildMatrix();
gCopyMatrix(invM, m_Transformations[m_nTransformations].m_Matrix);
gInvertMatrix4x4(invM);
//	gTransformVector(m_CameraMatrix, sphere); // Move sphere to it's position due to camera
gTransformVector(invM, sphere);

// Check for collision
return ::IntersectSphereBox(sphere, r*r, bx, by, bz);
}




//------------------------------------------------------------------//
// Load an Object in Rainbows-Format
//------------------------------------------------------------------//
extern bool Load_DDW(const char* filename, X_WORLD& world, COLORREF cookiecol);
bool Rainbows3D::LoadObject(const char* filename, int ID)
{
m_Objects[ID].Clear(true);
m_Objects[ID].is_loaded=false;
GFFileSystem fs;
if (fs.OpenIn(filename))
{
char type[4];
fs.Read(type, 4);
fs.Close();

if(type[0]==';' && type[1]=='D' && type[2]=='D' && type[3]=='W')
{
return Load_DDW(filename, m_Objects[ID], m_pRBOW->m_CookieColor);
}
}
else
return false; // can't read - no file no object

m_Objects[ID].m_objects.SetSize(1);
if (!m_Objects[ID].m_objects[0].obj.Load(filename))
{
m_Objects[ID].Clear(true);
return false;
}
if (m_Objects[ID].m_objects[0].obj.NumNodes(0)==0)
{
m_Objects[ID].Clear(true);
return false;
}
m_Objects[ID].is_loaded=true;
m_Objects[ID].is_multiworld=false;

m_Objects[ID].m_objects[0].obj.PrepareTriangles(); // For VBO rendering
//	PreRenderObject(ID);		// Display list
m_Objects[ID].m_objects[0].obj.CalcMaxRadius();
return true;
}

//------------------------------------------------------------------//
// Free RAM memory of large objects. Will no longer X_ANIM, nor X_COLxx
//------------------------------------------------------------------//
void Rainbows3D::FreeExtraObject(int id)
{
for(int i=0; i<m_Objects[id].m_objects.Size(); ++i)
{
MeshObjectX& obj = m_Objects[id].m_objects[i].obj;
obj.m_ColTable.Clear(true);
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
obj.m_Edges.Clear(true);
#endif
if(obj.m_Frames.Size())
{
POLY_FRAME fr;
fr = obj.m_Frames[0];
fr.nodes.SetSize(3);
fr.triangles.SetSize(1);

obj.m_Frames.Clear(true);
obj.m_Frames.SetAllocSteps(1,1);
obj.m_Frames.Push(fr);
}
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGL_ES)
obj.m_isTriFacingLight.Clear(true);
#endif
obj.m_tri_animation.Clear(true);
obj.m_tri_animation.SetSize(3);
}
}


//------------------------------------------------------------------//
// Save an Object in Rainbows-Format
//------------------------------------------------------------------//
bool Rainbows3D::SaveObject(const char* filename, int ID)
{
m_Objects[ID].m_objects[0].obj.Save(filename);
return true;
}


void Rainbows3D::CullMode(int mode)
{
#ifdef TRENKI3D
m_CullMode = (char)mode;
switch(mode)
{
case 0:
tglCullFace(GL_NONE);
break;
case -1:
tglCullFace(GL_FRONT);
break;
case 1:
tglCullFace(GL_BACK);
break;
}

#else
m_CullMode = (char)mode;
switch(mode)
{
case 0:
glbDisable(GL_CULL_FACE);
break;
case -1:
glbEnable(GL_CULL_FACE);
glFrontFace(GL_CCW);
break;
case 1:
glFrontFace(GL_CW);
glbEnable(GL_CULL_FACE);
break;
}
#endif
}


// --------------------------------
// GLSL Support
// --------------------------------
#if defined(HAVE_OPENGL)
void Rainbows3D::FreeShader(int index)
{
if(index<0 || index>=MAX_SHADERS || !glDeleteObjectArb) return;	
if(m_Shaders[index][0])
glDeleteObjectArb(m_Shaders[index][0]);
if(m_Shaders[index][1])
glDeleteObjectArb(m_Shaders[index][1]);
if(m_Shaders[index][2])
glDeleteObjectArb(m_Shaders[index][2]);
m_Shaders[index][0] = m_Shaders[index][1] = m_Shaders[index][2] = 0;
}

// --------------------------------
// Check to see if it compiled.
// --------------------------------
bool Rainbows3D::VerifyShader(GLhandleARB shader, bool compiler, void(*printout)(const char*) )
{
GLsizei compiled=0, length;
GLenum status =  GL_OBJECT_LINK_STATUS_ARB;
if(compiler)
status = GL_OBJECT_COMPILE_STATUS_ARB;
glGetObjectParameterivArb(shader, status, &compiled);
if (compiled == 0)
{
if(printout)
{
glGetObjectParameterivArb(shader, GL_OBJECT_INFO_LOG_LENGTH_ARB, &length);
GLcharARB* log = new GLcharARB[length];
glGetInfoLogArb(shader, length, &length, log);
printout(log);
delete[] log;
}
return FALSE;
}
return TRUE;
}

// --------------------------------
// --------------------------------
bool Rainbows3D::LoadShader(int index, const char* szVertex, const char* szFragment, void(*printout)(const char*) )
{
if(index<0 || index>=MAX_SHADERS)
return FALSE;
if(!glCreateShaderObjectArb || !glCompileShaderArb || !glLinkProgramArb)
{
static int no_shader = 1;
if (printout && no_shader)
{
no_shader = 0;
printout("No OpenGL 2.0 Shader Support");
}
return FALSE;
}
FreeShader(index);

bool good = false;
GFFileSystem fs;
char *pFrag=NULL, *pVert=NULL;
if(szVertex && fs.OpenIn(szVertex))
{
int len = (int)fs.GetSize();
pVert = new char[len+1];
if(fs.Read(pVert, len))
{
pVert[len]='\0';
m_Shaders[index][1] = glCreateShaderObjectArb(GL_VERTEX_SHADER_ARB);
const GLcharARB* pA = pVert;
glShaderSourceArb(m_Shaders[index][1], 1, &pA, NULL);
glCompileShaderArb(m_Shaders[index][1]);
if(!VerifyShader(m_Shaders[index][1], TRUE, printout))
{
if(printout)
{
printout("vertex shader failed");
}
good=false;
}
else
good=true;
}
}

if(szFragment && fs.OpenIn(szFragment))
{
int len = (int)fs.GetSize();
pFrag = new char[len+1];
if(fs.Read(pFrag, len))
{
pFrag[len]='\0';
m_Shaders[index][2] = glCreateShaderObjectArb(GL_FRAGMENT_SHADER_ARB);
const GLcharARB* pA = pFrag;
glShaderSourceArb(m_Shaders[index][2], 1, &pA, NULL);
glCompileShaderArb(m_Shaders[index][2]);
if(!VerifyShader(m_Shaders[index][2], TRUE, printout))
{
if(printout)
{
printout("fragment shader failed");
}
good=false;
}
else
good=true;
}
}

if(good && (m_Shaders[index][1] || m_Shaders[index][2]))
{
m_Shaders[index][0] = glCreateProgramObjectArb();
if(m_Shaders[index][1]) glAttachObjectArb(m_Shaders[index][0], m_Shaders[index][1]);
if(m_Shaders[index][2]) glAttachObjectArb(m_Shaders[index][0], m_Shaders[index][2]);
glLinkProgramArb(m_Shaders[index][0]);
if(!VerifyShader(m_Shaders[index][0], FALSE, printout))
{
if(printout)
{
printout("link shader failed");
}
good=false;
}
else
good=true;
}
if(pVert) delete[] pVert;
if(pFrag) delete[] pFrag;
return good;
}




// --------------------------------
// --------------------------------
void Rainbows3D::SetShader(int index)
{
if(!glUseProgramObjectArb) return;
if(index<0 || index>=MAX_SHADERS)
{
glUseProgramObjectArb(0);
m_BoundShaderIndex=-1;
return;	
}
m_BoundShaderIndex=index;
glUseProgramObjectArb(m_Shaders[index][0]);
}

// --------------------------------
// --------------------------------
void Rainbows3D::PutShaderUniform1f(const char* name, float val, void(*printout)(const char*))
{
if(!glGetUniformLocationArb) return;
if(m_BoundShaderIndex<0 || m_BoundShaderIndex>=MAX_SHADERS)
return;	
GLint pos = glGetUniformLocationArb(m_Shaders[m_BoundShaderIndex][0], name);
if(pos!=-1)
glUniform1fArb(pos, val);
else
{
if(printout)
{
printout("undefined uniform:");
printout(name);
}
}
}

// --------------------------------
// --------------------------------
void Rainbows3D::PutShaderUniform1i(const char* name, int val, void(*printout)(const char*))
{
if(!glGetUniformLocationArb) return;
if(m_BoundShaderIndex<0 || m_BoundShaderIndex>=MAX_SHADERS)
return;	
GLint pos = glGetUniformLocationArb(m_Shaders[m_BoundShaderIndex][0], name);
if(pos!=-1)
glUniform1iArb(pos, val);
else
{
if(printout)
{
printout("undefined uniform:");
printout(name);
}
}
}

// --------------------------------
// --------------------------------
void Rainbows3D::PutShaderAttrib1f(const char* name, float val, void(*printout)(const char*))
{
if(!glUseProgramObjectArb) return;
if(m_BoundShaderIndex<0 || m_BoundShaderIndex>=MAX_SHADERS)
return;	
GLint pos = glGetAttribLocationArb(m_Shaders[m_BoundShaderIndex][0], name);
if(pos!=-1)
glVertexAttrib1fArb(pos, val);
else
{
if(printout)
{
printout("undefined attrib:");
printout(name);
}
}
}

#endif // #if defined(HAVE_OPENGL)



// --------------------------------
// For Frustum Culling
// --------------------------------
void Rainbows3D::ExtractFrustum()
{
#ifndef TRENKI3D
float   proj[16];
float   modl[16];
float   clip[16];
float   t;

/* Get the current PROJECTION matrix from OpenGL */
gCopyMatrix(proj, m_ProjectionMatrix);
// glGetFloatv( GL_PROJECTION_MATRIX, proj );


/* Get the current MODELVIEW matrix from OpenGL */
// float m2[16], m3[16];
gCopyMatrix(modl, m_ModelViewCameraMatrix);
// gCopyMatrix(m3, this->GetFinalMatrix());
// glGetFloatv( GL_MODELVIEW_MATRIX, modl );


/* Combine the two matrices (multiply projection by modelview) */
clip[ 0] = modl[ 0] * proj[ 0] + modl[ 1] * proj[ 4] + modl[ 2] * proj[ 8] + modl[ 3] * proj[12];
clip[ 1] = modl[ 0] * proj[ 1] + modl[ 1] * proj[ 5] + modl[ 2] * proj[ 9] + modl[ 3] * proj[13];
clip[ 2] = modl[ 0] * proj[ 2] + modl[ 1] * proj[ 6] + modl[ 2] * proj[10] + modl[ 3] * proj[14];
clip[ 3] = modl[ 0] * proj[ 3] + modl[ 1] * proj[ 7] + modl[ 2] * proj[11] + modl[ 3] * proj[15];

clip[ 4] = modl[ 4] * proj[ 0] + modl[ 5] * proj[ 4] + modl[ 6] * proj[ 8] + modl[ 7] * proj[12];
clip[ 5] = modl[ 4] * proj[ 1] + modl[ 5] * proj[ 5] + modl[ 6] * proj[ 9] + modl[ 7] * proj[13];
clip[ 6] = modl[ 4] * proj[ 2] + modl[ 5] * proj[ 6] + modl[ 6] * proj[10] + modl[ 7] * proj[14];
clip[ 7] = modl[ 4] * proj[ 3] + modl[ 5] * proj[ 7] + modl[ 6] * proj[11] + modl[ 7] * proj[15];

clip[ 8] = modl[ 8] * proj[ 0] + modl[ 9] * proj[ 4] + modl[10] * proj[ 8] + modl[11] * proj[12];
clip[ 9] = modl[ 8] * proj[ 1] + modl[ 9] * proj[ 5] + modl[10] * proj[ 9] + modl[11] * proj[13];
clip[10] = modl[ 8] * proj[ 2] + modl[ 9] * proj[ 6] + modl[10] * proj[10] + modl[11] * proj[14];
clip[11] = modl[ 8] * proj[ 3] + modl[ 9] * proj[ 7] + modl[10] * proj[11] + modl[11] * proj[15];

clip[12] = modl[12] * proj[ 0] + modl[13] * proj[ 4] + modl[14] * proj[ 8] + modl[15] * proj[12];
clip[13] = modl[12] * proj[ 1] + modl[13] * proj[ 5] + modl[14] * proj[ 9] + modl[15] * proj[13];
clip[14] = modl[12] * proj[ 2] + modl[13] * proj[ 6] + modl[14] * proj[10] + modl[15] * proj[14];
clip[15] = modl[12] * proj[ 3] + modl[13] * proj[ 7] + modl[14] * proj[11] + modl[15] * proj[15];

/* Extract the numbers for the RIGHT plane */
m_frustum[0][0] = clip[ 3] - clip[ 0];
m_frustum[0][1] = clip[ 7] - clip[ 4];
m_frustum[0][2] = clip[11] - clip[ 8];
m_frustum[0][3] = clip[15] - clip[12];

/* Normalize the result */
t = sqrtf( m_frustum[0][0] * m_frustum[0][0] + m_frustum[0][1] * m_frustum[0][1] + m_frustum[0][2] * m_frustum[0][2] );
m_frustum[0][0] /= t;
m_frustum[0][1] /= t;
m_frustum[0][2] /= t;
m_frustum[0][3] /= t;

/* Extract the numbers for the LEFT plane */
m_frustum[1][0] = clip[ 3] + clip[ 0];
m_frustum[1][1] = clip[ 7] + clip[ 4];
m_frustum[1][2] = clip[11] + clip[ 8];
m_frustum[1][3] = clip[15] + clip[12];

/* Normalize the result */
t = sqrtf( m_frustum[1][0] * m_frustum[1][0] + m_frustum[1][1] * m_frustum[1][1] + m_frustum[1][2] * m_frustum[1][2] );
m_frustum[1][0] /= t;
m_frustum[1][1] /= t;
m_frustum[1][2] /= t;
m_frustum[1][3] /= t;

/* Extract the BOTTOM plane */
m_frustum[2][0] = clip[ 3] + clip[ 1];
m_frustum[2][1] = clip[ 7] + clip[ 5];
m_frustum[2][2] = clip[11] + clip[ 9];
m_frustum[2][3] = clip[15] + clip[13];

/* Normalize the result */
t = sqrtf( m_frustum[2][0] * m_frustum[2][0] + m_frustum[2][1] * m_frustum[2][1] + m_frustum[2][2] * m_frustum[2][2] );
m_frustum[2][0] /= t;
m_frustum[2][1] /= t;
m_frustum[2][2] /= t;
m_frustum[2][3] /= t;

/* Extract the TOP plane */
m_frustum[3][0] = clip[ 3] - clip[ 1];
m_frustum[3][1] = clip[ 7] - clip[ 5];
m_frustum[3][2] = clip[11] - clip[ 9];
m_frustum[3][3] = clip[15] - clip[13];

/* Normalize the result */
t = sqrtf( m_frustum[3][0] * m_frustum[3][0] + m_frustum[3][1] * m_frustum[3][1] + m_frustum[3][2] * m_frustum[3][2] );
m_frustum[3][0] /= t;
m_frustum[3][1] /= t;
m_frustum[3][2] /= t;
m_frustum[3][3] /= t;

/* Extract the FAR plane */
m_frustum[4][0] = clip[ 3] - clip[ 2];
m_frustum[4][1] = clip[ 7] - clip[ 6];
m_frustum[4][2] = clip[11] - clip[10];
m_frustum[4][3] = clip[15] - clip[14];

/* Normalize the result */
t = sqrtf( m_frustum[4][0] * m_frustum[4][0] + m_frustum[4][1] * m_frustum[4][1] + m_frustum[4][2] * m_frustum[4][2] );
m_frustum[4][0] /= t;
m_frustum[4][1] /= t;
m_frustum[4][2] /= t;
m_frustum[4][3] /= t;

/* Extract the NEAR plane */
m_frustum[5][0] = clip[ 3] + clip[ 2];
m_frustum[5][1] = clip[ 7] + clip[ 6];
m_frustum[5][2] = clip[11] + clip[10];
m_frustum[5][3] = clip[15] + clip[14];

/* Normalize the result */
t = sqrtf( m_frustum[5][0] * m_frustum[5][0] + m_frustum[5][1] * m_frustum[5][1] + m_frustum[5][2] * m_frustum[5][2] );
m_frustum[5][0] /= t;
m_frustum[5][1] /= t;
m_frustum[5][2] /= t;
m_frustum[5][3] /= t;
#endif
}

// --------------------------------
// Quick Frustum culling code
// --------------------------------
bool Rainbows3D::SphereInFrustum(float x, float y, float z, float radius )
{
#ifdef TRENKI3D
return true;
#else
if(m_frustum[0][0]*x + m_frustum[0][1]*y + m_frustum[0][2]*z + m_frustum[0][3] < -radius) return false;
if(m_frustum[1][0]*x + m_frustum[1][1]*y + m_frustum[1][2]*z + m_frustum[1][3] < -radius) return false;
if(m_frustum[2][0]*x + m_frustum[2][1]*y + m_frustum[2][2]*z + m_frustum[2][3] < -radius) return false;
if(m_frustum[3][0]*x + m_frustum[3][1]*y + m_frustum[3][2]*z + m_frustum[3][3] < -radius) return false;
if(m_frustum[4][0]*x + m_frustum[4][1]*y + m_frustum[4][2]*z + m_frustum[4][3] < -radius) return false;
if(m_frustum[5][0]*x + m_frustum[5][1]*y + m_frustum[5][2]*z + m_frustum[5][3] < -radius) return false;
return true;
#endif
}

#else // console
void glb_rainbows3d_console_dummy() {};
#endif // GLB_CONSOLE
//***********************************************************************//
//																		 //
//		- "Talk to me like I'm a 3 year old!" Programming Lessons -		 //
//                                                                       //
//		$Author:		DigiBen			DigiBen@GameTutorials.com		 //
//																		 //
//		$Program:		SpherePolygonCollision							 //
//																		 //
//		$Description:	This demonstrates sphere and polygon collision.	 //
//																		 //
//		$Date:			1/23/02											 //
//																		 //
//***********************************************************************//


#include "stdafx.h" // #include "stdafx.h"
#include <math.h>
#include "3dmath.h" // #include "3dmath.h"
#include "vectormath.h" // #include "vectormath.h"

#ifdef HAVE_OPENGL
#include <GL/gl.h>
#endif


#ifndef PI
#define PI 3.1415926535897932f
#endif

#define BEHIND		0
#define INTERSECTS	1
#define FRONT		2
#define FABS(a) ((a)<0 ? -(a) : (a))


/////////////////////////////////////// NORMAL \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
//          ID INDX
// Get 2 vectors from the polygon (2 sides), Remember the order!
// float[3] vVector1 = vPoly[2] - vPoly[0];
// float[3] vVector2 = vPoly[1] - vPoly[0];
inline void TriangleNormal(float* Vn, float Poly[][3])
{
float V1[3], V2[3];
V1[0]=Poly[2][0]-Poly[0][0];
V1[1]=Poly[2][1]-Poly[0][1];
V1[2]=Poly[2][2]-Poly[0][2];
V2[0]=Poly[1][0]-Poly[0][0];
V2[1]=Poly[1][1]-Poly[0][1];
V2[2]=Poly[1][2]-Poly[0][2];
gCross(V1, V2, Vn);
gUnify(Vn);
}


/////////////////////////////////// PLANE DISTANCE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
// Use the plane equation to find the distance (Ax + By + Cz + D = 0)  We want to find D.
// So, we come up with D = -(Ax + By + Cz)
// Basically, the negated dot product of the normal of the plane and the point.
#define PlaneDistance(Normal, Point) (- ((Normal[0] * Point[0]) + (Normal[1] * Point[1]) + (Normal[2] * Point[2])))


/////////////////////////////////// INTERSECTED PLANE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This checks to see if a line intersects a plane
inline bool IntersectedPlane(float vPoly[3][3], float vLine[3][3], float vNormal[3], float &originDistance)
{
float distance1, distance2;
TriangleNormal(vNormal, vPoly);							// We need to get the normal of our plane to go any further

// Let's find the distance our plane is from the origin.  We can find this value
// from the normal to the plane (polygon) and any point that lies on that plane (Any vertex)
originDistance = PlaneDistance(vNormal, vPoly[0]);

// Get the distance from point1 from the plane using: Ax + By + Cz + D = (The distance from the plane)
distance1 = ((vNormal[0] * vLine[0][0])  +					// Ax +
(vNormal[1] * vLine[0][1])  +					// Bx +
(vNormal[2] * vLine[0][2])) + originDistance;	// Cz + D

// Get the distance from point2 from the plane using Ax + By + Cz + D = (The distance from the plane)
distance2 = ((vNormal[0] * vLine[1][0])  +					// Ax +
(vNormal[1] * vLine[1][1])  +					// Bx +
(vNormal[2] * vLine[1][2])) + originDistance;	// Cz + D

// Now that we have 2 distances from the plane, if we times them together we either
// get a positive or negative number.  If it's a negative number, that means we collided!
// This is because the 2 points must be on either side of the plane (IE. -1 * 1 = -1).

if(distance1 * distance2 >= 0)			// Check to see if both point's distances are both negative or both positive
return false;						// Return false if each point has the same sign.  -1 and 1 would mean each point is on either side of the plane.  -1 -2 or 3 4 wouldn't...

return true;							// The line intersected the plane, Return TRUE
}


/////////////////////////////////// ANGLE BETWEEN VECTORS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This checks to see if a point is inside the ranges of a polygon
inline float AngleBetweenVectors(float Vector1[3], float Vector2[3])
{
float z = (gGetLength(Vector1) * gGetLength(Vector2));
if (z<=1E-8)
return 0;
return acosf( gDot(Vector1, Vector2)/z);
}


/////////////////////////////////// INTERSECTION POINT \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This returns the intersection point of the line that intersects the plane
void IntersectionPoint(float vPoint[3], float vNormal[3], float vLine[3][3], float distance)
{
float vLineDir[3];
float Numerator = 0.0, Denominator = 0.0, dist = 0.0;
vLineDir[0] = vLine[1][0] - vLine[0][0];		// Get the Vector of the line
vLineDir[1] = vLine[1][1] - vLine[0][1];		// Get the Vector of the line
vLineDir[2] = vLine[1][2] - vLine[0][2];		// Get the Vector of the line
gUnify(vLineDir);				// Normalize the lines vector
// distance from one of our points to the plane.
Numerator = - (vNormal[0] * vLine[0][0] +		// Use the plane equation with the normal and the line
vNormal[1] * vLine[0][1] +
vNormal[2] * vLine[0][2] + distance);
// 3) If we take the dot product between our line vector and the normal of the polygon,
Denominator = gDot(vNormal, vLineDir);			// Get the dot product of the line's vector and the normal of the plane

if( Denominator == 0.0)							// Check so we don't divide by zero
{
vPoint[0]=vLine[0][0];						// Return an arbitrary point on the line
vPoint[1]=vLine[0][1];
vPoint[2]=vLine[0][2];
return;
}
dist = Numerator / Denominator;				// Divide to get the multiplying (percentage) factor

// Now, like we said above, we times the dist by the vector, then add our arbitrary point.
vPoint[0] = (float)(vLine[0][0] + (vLineDir[0] * dist));
vPoint[1] = (float)(vLine[0][1] + (vLineDir[1] * dist));
vPoint[2] = (float)(vLine[0][2] + (vLineDir[2] * dist));
}


/////////////////////////////////// INSIDE POLYGON \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	This checks to see if a point is inside the ranges of a polygon
/////
/////////////////////////////////// INSIDE POLYGON \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*

bool InsidePolygon(float vIntersection[3], float Poly[3][3], long verticeCount)
{
const float MATCH_FACTOR = 0.99f;
float Angle = 0.0f;
float vA[3], vB[3];
int		n;

for (int i = 0; i < verticeCount; i++)		// Go in a circle to each vertex and get the angle between
{	
vA[0] = Poly[i][0] - vIntersection[0];			// Subtract the intersection point from the current vertex
vA[1] = Poly[i][1] - vIntersection[1];			// Subtract the intersection point from the current vertex
vA[2] = Poly[i][2] - vIntersection[2];			// Subtract the intersection point from the current vertex

n=(i + 1) % verticeCount;								// Subtract the point from the next vertex
vB[0] = Poly[n][0]-vIntersection[0];
vB[1] = Poly[n][1]-vIntersection[1];
vB[2] = Poly[n][2]-vIntersection[2];

Angle += AngleBetweenVectors(vA, vB);	// Find the angle between the 2 vectors and add them all up as we go along
}

if(Angle >= (MATCH_FACTOR * (2.0f * PI_F)) )	// If the angle is greater than 2 PI, (360 degrees)
return true;							// The point is inside of the polygon
return false;								// If you get here, it obviously wasn't inside the polygon, so Return FALSE
}


/////////////////////////////////// INTERSECTED POLYGON \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This checks if a line is intersecting a polygon
bool IntersectedPolygon(float vPoly[3][3], float vLine[3][3], int verticeCount)
{
float vNormal[3];
float originDistance = 0;

// First, make sure our line intersects the plane
// Reference   // Reference
if(!IntersectedPlane(vPoly, vLine,   vNormal,   originDistance))
return false;

// Now that we have our normal and distance passed back from IntersectedPlane(), 
// we can use it to calculate the intersection point.  
float vIntersection[3];
IntersectionPoint(vIntersection, vNormal, vLine, originDistance);

// Now that we have the intersection point, we need to test if it's inside the polygon.
if(InsidePolygon(vIntersection, vPoly, verticeCount))
return true;							// We collided!	  Return success

return false;								// There was no collision, so return false
}

////////////////////////////// CLOSEST POINT ON LINE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This returns the point on the line vA_vB that is closest to the point vPoint
inline static void ClosestPointOnLine(float vRes[3], float vA[3], float vB[3], float vPoint[3])
{
static float t, d;
// Create the vector from end point vA to our point vPoint.
static float vVector1[3];
vVector1[0] = vPoint[0] - vA[0];
vVector1[1] = vPoint[1] - vA[1];
vVector1[2] = vPoint[2] - vA[2];

// Create a normalized direction vector from end point vA to end point vB
static float vVector2[3];
vVector2[0] = vA[0] - vB[0];
vVector2[1] = vA[1] - vB[1];
vVector2[2] = vA[2] - vB[2];
gUnify(vVector2);

// Use the distance formula to find the distance of the line segment (or magnitude)
d = Distance(vA, vB);

// Point A and B are the same
if (d<1E-8)
{
vRes[0]=vA[0]; vRes[1]=vA[1]; vRes[2]=vA[2];
return;
}

// Using the dot product, we project the vVector1 onto the vector vVector2.
// This essentially gives us the distance from our projected vector from vA.
t = gDot(vVector2, vVector1)/d;

// If our projected distance from vA, "t", is less than or equal to 0, it must
// be closest to the end point vA.  We want to return this end point.
if (t <= 0)
{
vRes[0]=vA[0]; vRes[1]=vA[1]; vRes[2]=vA[2];
return;
}

// If our projected distance from vA, "t", is greater than or equal to the magnitude
// or distance of the line segment, it must be closest to the end point vB.  So, return vB.
if (t*t >= d) 
{
vRes[0]=vB[0]; vRes[1]=vB[1]; vRes[2]=vB[2];
return;
}

// To find the closest point on the line segment, we just add vVector3 to the original
// end point vA.  
vRes[0] = vA[0] + vVector2[0] * t;
vRes[1] = vA[1] + vVector2[1] * t;
vRes[2] = vA[2] + vVector2[2] * t;
}


///////////////////////////////// CLASSIFY SPHERE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This tells if a sphere is BEHIND, in FRONT, or INTERSECTS a plane, also it's distance
int ClassifySphere(float vCenter[3], float vNormal[3], float vPoint[3], float radius, float &distance)
{
float d = PlaneDistance(vNormal, vPoint);
distance = (vNormal[0] * vCenter[0] + vNormal[1] * vCenter[1] + vNormal[2] * vCenter[2] + d);

if(FABS(distance) < radius)
return INTERSECTS;
else if(distance > radius)
return FRONT;
return BEHIND;
}


///////////////////////////////// EDGE SPHERE COLLSIION \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This returns true if the sphere is intersecting any of the edges of the polygon
bool EdgeSphereCollision(float vCenter[3], float vPolygon[3][3], int vertexCount, float radiusSQ)
{
float vPoint[3];
for(int i = 0; i < vertexCount; i++)
{
ClosestPointOnLine(vPoint, vPolygon[i], vPolygon[(i + 1) % vertexCount], vCenter);
float distance = Distance(vPoint, vCenter);
if(distance < radiusSQ)
return true;
}
return false;
}


////////////////////////////// SPHERE POLYGON COLLISION \\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////	This returns true if our sphere collides with the polygon passed in
bool SpherePolygonCollision(float vPolygon[3][3], float* vCenter, int vertexCount, float radius)
{
float rvPolygon[3][3], rvCenter[3];
rvPolygon[0][0]=(float)vPolygon[0][0];
rvPolygon[1][0]=(float)vPolygon[1][0];
rvPolygon[2][0]=(float)vPolygon[2][0];
rvPolygon[0][1]=(float)vPolygon[0][1];
rvPolygon[1][1]=(float)vPolygon[1][1];
rvPolygon[2][1]=(float)vPolygon[2][1];
rvPolygon[0][2]=(float)vPolygon[0][2];
rvPolygon[1][2]=(float)vPolygon[1][2];
rvPolygon[2][2]=(float)vPolygon[2][2];
rvCenter[0]=(float)vCenter[0];
rvCenter[1]=(float)vCenter[1];
rvCenter[2]=(float)vCenter[2];

// Let's use our Normal() function to return us the normal to this polygon
static float vNormal[3];
TriangleNormal(vNormal, rvPolygon);
// This will store the distance our sphere is from the plane
static float distance;
static int classification;
static float vOffset[3], vPosition[3];
distance = 0.0f;
classification = ClassifySphere(rvCenter, vNormal, rvPolygon[0], radius, distance);
if(classification == INTERSECTS && distance<=radius) 
{
vOffset[0] = vNormal[0] * distance;
vOffset[1] = vNormal[1] * distance;
vOffset[2] = vNormal[2] * distance;
vPosition[0] = vCenter[0] - vOffset[0];
vPosition[1] = vCenter[1] - vOffset[1];
vPosition[2] = vCenter[2] - vOffset[2];

if(InsidePolygon(vPosition, rvPolygon, vertexCount))
return true;	// We collided!
else
{
if(EdgeSphereCollision(rvCenter, rvPolygon, vertexCount, radius))
{
return true;	// We collided! "And you doubted me..." - Sphere
}
}
}
// If we get here, there is obviously no collision happening up in this crib
return false;
}




/*
Cuboid + Triangle intersection

The theory is difficult to explain in details, but roughly it goes like this. If there is a plane where
the box is totally on one side of the plane while the triangle is totally on the other side of the plane,
then the plane separates the two objects and the objects do not intersect. If on the contrary, you cannot find
such a plane, then the objects intersect.

Of course, there is potentially an infinite number of planes that can separate a box and a triangle, but you
can reduce the number of planes to test to 13. It's proven somewhere, but it;s actually hard to prove.

The planes are also refered as 'separation axis', where the normal of the plane is the separation axis.

ok, so given a box
O,
A0, A1, A2,
a0, a1, a1

where O is the centre,
A0, A1, A2 are the direction of the faces (basically, A0=(1, 0, 0), A1=(0, 1, 0), A2=(0, 0, 1) for an axis aligned box),
and a0, a1, a2 are the extents of the box along the respective axes A0, A1, A2
(for a Min-Max type of box,a0=(MaxX-MinX)/2, a1=(MaxY-MinY)/2, ...).

and a triangle
V0, V1, V2
N (normal of the triangle, N=(V2-V1) x (V1-V0)).

the 13 separation axes are
N
A0
A1
A2
A0 x (V1-V0)
A0 x (V2-V1)
A0 x (V0-V2)
A1 x (V1-V0)
A1 x (V2-V1)
A1 x (V0-V2)
A2 x (V1-V0)
A2 x (V2-V1)
A2 x (V0-V2)

As you may see, it's a combination of plane normals, and edge dot products. That also relates
to collision detection where the main collisions you get from colliding two polygonal models are
either point-plane collision or edge-ege collisions. All other collisions are special cases of these
(point-edge, edge-plane, ....).

these vectors represent the normal of a potential separating axis. To decide if this axis is separating
the box and triangle, you 'project' the two objects along the axes and see if the intervals overlap,

S is the separation axis we are testing (one of the 13 options above).
'' is a vector dot product.
'x' is a vector cross product.
'|...|' is absolute value.

minb = OS - |A0S| * a0 + |A1S| * a1 + |A2S| * a2
maxb = OS + |A0S| * a0 + |A1S| * a1 + |A2S| * a2

mint = min(min(V0S, V1S), V2S)
maxt = max(max(V0S, V1S), V2S)

if (minb > maxt || maxb < mint), then the axis S is indeed separating the objects, and the objects do not intersect.

As soon as you found an axis as being a true separation axis, you can quit the test, safe in the
knowledge that the objects are spearated by a plane and therefore cannot intersect.

if the 13 tests all fail, then the two objects intersect.

so, no divisions, just dot products and cross products, so fast, and no worries of divisions by 0.

// GF:
Since the a0,a1,a2 values could be set to 1.0 and the Ax values might be scaled before,
I leave the ax values off here for more speed.
*/

bool IntersectCuboidAndTriangle(
const float* Org, const float* A0, const float* A1, const float* A2,
const float* V0, const float* V1, const float* V2)
{
float A0S_A1S_A2S, tmp[3], tmp2[3], V0S, V1S, V2S, OrgS;

const float* S;

#define DOCHECK													\
A0S_A1S_A2S=FABS(gDot(A0,S))+FABS(gDot(A1,S))+FABS(gDot(A2,S)); \
V0S = gDot(V0, S); V1S = gDot(V1, S); V2S = gDot(V2, S);		\
OrgS = gDot(Org, S);											\
if(OrgS - A0S_A1S_A2S > max(max(V0S, V1S),V2S)) return false;	\
if(OrgS + A0S_A1S_A2S < min(min(V0S, V1S),V2S)) return false;

S=A0; DOCHECK;
S=A1; DOCHECK;
S=A2; DOCHECK;
S=tmp2;
gCross(V1, V2, tmp2); DOCHECK;
gDiffVertex(tmp, V1, V0); gCross(A0, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V2, V1); gCross(A0, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V0, V2); gCross(A0, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V1, V0); gCross(A1, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V2, V1); gCross(A1, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V0, V2); gCross(A1, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V1, V0); gCross(A2, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V2, V1); gCross(A2, tmp, tmp2); DOCHECK;
gDiffVertex(tmp, V0, V2); gCross(A2, tmp, tmp2); DOCHECK;
return true;
}



static void invertMatrix(const float *m, float *out )
{
/* NB. OpenGL Matrices are COLUMN major. */
#define MAT(m,r,c) (m)[(c)*4+(r)]

/* Here's some shorthand converting standard (row,column) to index. */
#define m11 MAT(m,0,0)
#define m12 MAT(m,0,1)
#define m13 MAT(m,0,2)
#define m14 MAT(m,0,3)
#define m21 MAT(m,1,0)
#define m22 MAT(m,1,1)
#define m23 MAT(m,1,2)
#define m24 MAT(m,1,3)
#define m31 MAT(m,2,0)
#define m32 MAT(m,2,1)
#define m33 MAT(m,2,2)
#define m34 MAT(m,2,3)
#define m41 MAT(m,3,0)
#define m42 MAT(m,3,1)
#define m43 MAT(m,3,2)
#define m44 MAT(m,3,3)

float det;
float d12, d13, d23, d24, d34, d41;
float tmp[16]; /* Allow out == in. */

/* Inverse = adjoint / det. (See linear algebra texts.)*/

/* pre-compute 2x2 dets for last two rows when computing */
/* cofactors of first two rows. */
d12 = (m31*m42-m41*m32);
d13 = (m31*m43-m41*m33);
d23 = (m32*m43-m42*m33);
d24 = (m32*m44-m42*m34);
d34 = (m33*m44-m43*m34);
d41 = (m34*m41-m44*m31);

tmp[0] =  (m22 * d34 - m23 * d24 + m24 * d23);
tmp[1] = -(m21 * d34 + m23 * d41 + m24 * d13);
tmp[2] =  (m21 * d24 + m22 * d41 + m24 * d12);
tmp[3] = -(m21 * d23 - m22 * d13 + m23 * d12);

/* Compute determinant as early as possible using these cofactors. */
det = m11 * tmp[0] + m12 * tmp[1] + m13 * tmp[2] + m14 * tmp[3];

/* Run singularity test. */
if (det == 0.0)
{
gIdentity(out);
}
else
{
float invDet = 1.0f / det;
/* Compute rest of inverse. */
tmp[0] *= invDet;
tmp[1] *= invDet;
tmp[2] *= invDet;
tmp[3] *= invDet;

tmp[4] = -(m12 * d34 - m13 * d24 + m14 * d23) * invDet;
tmp[5] =  (m11 * d34 + m13 * d41 + m14 * d13) * invDet;
tmp[6] = -(m11 * d24 + m12 * d41 + m14 * d12) * invDet;
tmp[7] =  (m11 * d23 - m12 * d13 + m13 * d12) * invDet;

/* Pre-compute 2x2 dets for first two rows when computing */
/* cofactors of last two rows. */
d12 = m11*m22-m21*m12;
d13 = m11*m23-m21*m13;
d23 = m12*m23-m22*m13;
d24 = m12*m24-m22*m14;
d34 = m13*m24-m23*m14;
d41 = m14*m21-m24*m11;

tmp[8] =  (m42 * d34 - m43 * d24 + m44 * d23) * invDet;
tmp[9] = -(m41 * d34 + m43 * d41 + m44 * d13) * invDet;
tmp[10] =  (m41 * d24 + m42 * d41 + m44 * d12) * invDet;
tmp[11] = -(m41 * d23 - m42 * d13 + m43 * d12) * invDet;
tmp[12] = -(m32 * d34 - m33 * d24 + m34 * d23) * invDet;
tmp[13] =  (m31 * d34 + m33 * d41 + m34 * d13) * invDet;
tmp[14] = -(m31 * d24 + m32 * d41 + m34 * d12) * invDet;
tmp[15] =  (m31 * d23 - m32 * d13 + m33 * d12) * invDet;

memcpy(out, tmp, 16*sizeof(float));
}

#undef m11
#undef m12
#undef m13
#undef m14
#undef m21
#undef m22
#undef m23
#undef m24
#undef m31
#undef m32
#undef m33
#undef m34
#undef m41
#undef m42
#undef m43
#undef m44
#undef MAT
}

//////////////////////////////////////////////////////////////////////////////
static void GFgluMultMatricesf(const float a[16], const float b[16], float r[16])
{
for (int i = 0; i < 4; i++) {
r[i*4+0] = 	a[i*4+0]*b[0*4+0] +	a[i*4+1]*b[1*4+0] +	a[i*4+2]*b[2*4+0] +	a[i*4+3]*b[3*4+0];
r[i*4+1] = 	a[i*4+0]*b[0*4+1] +	a[i*4+1]*b[1*4+1] +	a[i*4+2]*b[2*4+1] +	a[i*4+3]*b[3*4+1];
r[i*4+2] = 	a[i*4+0]*b[0*4+2] +	a[i*4+1]*b[1*4+2] +	a[i*4+2]*b[2*4+2] +	a[i*4+3]*b[3*4+2];
r[i*4+3] = 	a[i*4+0]*b[0*4+3] +	a[i*4+1]*b[1*4+3] +	a[i*4+2]*b[2*4+3] +	a[i*4+3]*b[3*4+3];
}
}


//////////////////////////////////////////////////////////////////////////////
bool GFglu_Project(float objx, float objy, float objz,
float* winx, float* winy, float* winz, const int viewport[4], const float proj[16], const float model[16])
{
#ifndef GLB_CONSOLE
// static int viewport[4];
static float /*proj[16], model[16],*/ in[4], out[4];

// first load the matrices for the project call.
// glGetIntegerv( GL_VIEWPORT,         viewport );
// glGetFloatv  ( GL_PROJECTION_MATRIX, proj );
// glGetFloatv  ( GL_MODELVIEW_MATRIX,  model);
in[0]=objx; in[1]=objy; in[2]=objz; in[3]=1.0;

/*
#define dmat(mat) g_debug("[%s]=\n%5.1f %5.1f %5.1f %5.1f\n%5.1f %5.1f %5.1f %5.1f\n%5.1f %5.1f %5.1f %5.1f\n%5.1f %5.1f %5.1f %5.1f\n\n", #mat, \
mat[0], mat[1], mat[2], mat[3], mat[4], mat[5], mat[6], mat[7], mat[8], mat[9], mat[10], mat[11], mat[12], mat[13], mat[14], mat[15]);
#define dvec(mat) g_debug("[%s]=\n%5.1f %5.1f %5.1f %5.1f\n\n", #mat, \
mat[0], mat[1], mat[2], mat[3] );
dvec(in);
dmat(model);
*/
transform_point(out,model,in);
//	dvec(out);

//	dmat(proj);
transform_point(in,proj,out);
//	dvec(in);

if (in[3]==0.0F) return false;

// Normalize between -1 and 1 :
float one_over_in3 = 1.0f / in[3];
in[0]*=one_over_in3;in[1]*=one_over_in3;in[2]*=one_over_in3;

//	printf("Viewp: %d %d %d %d\n", viewport[0], viewport[1],viewport[2], viewport[3]);

// In screen coordinates :
*winx = viewport[0]+(1.0f+in[0])*viewport[2]/2.0f;
*winy = viewport[3] - (viewport[1]+(1.0f+in[1])*viewport[3] / 2.0f); // GLBasic origin = top, (+) goes down


/*
int viewport_real[4];
glGetIntegerv( GL_VIEWPORT,         viewport_real );
*winx = viewport_real[0]+(1+in[0])*viewport_real[2]/2;
*winy = viewport_real[3] - (viewport_real[1]+(1+in[1])*viewport_real[3]/2); // GLBasic origin = top, (+) goes down
*/

/* en coordonnees ecran */
// *winx = viewport[0] + (1 + in[0]) * viewport[2] / 2;
// *winy = viewport[1] + (1 + in[1]) * viewport[3] / 2;

// In z [-1,1] -> [0,1] :
*winz = (1.0f+in[2]) / 2.0f;
return true;
#else
return false;
#endif
}

//////////////////////////////////////////////////////////////////////////////
bool GFglu_UnProject(float winx, float winy, float winz, float *objx, float *objy, float *objz, const int viewport[4], const float proj[16], const float model[16])
{
#ifndef GLB_CONSOLE
//		static int viewport[4];
static float /*proj[16], model[16],*/ finalMatrix[16], in[4], out[4];

// first load the matrices for the project call.
// glGetIntegerv( GL_VIEWPORT,         viewport );
// glGetFloatv  ( GL_PROJECTION_MATRIX, (GLfloat*)proj );
// glGetFloatv  ( GL_MODELVIEW_MATRIX,  (GLfloat*)model);

GFgluMultMatricesf(model, proj, finalMatrix);
//  gInvertMatrix4x4(finalMatrix);
invertMatrix(finalMatrix, finalMatrix); // might be non-symetrical!
in[0]=winx;
in[1]=winy;
in[2]=winz;
in[3]=1.0;

/* Map x and y from window coordinates */
in[0] = (in[0] - viewport[0]) / viewport[2];
in[1] = (in[1] - viewport[1]) / viewport[3]; // flip y in GLBasic

/* Map to range -1 to 1 */
in[0] = in[0] * 2 - 1;
in[1] = in[1] * 2 - 1;
in[2] = in[2] * 2 - 1;

transform_point(out, finalMatrix, in);
if (out[3] == 0.0) return false;
out[0] /= out[3];
out[1] /= out[3];
out[2] /= out[3];
*objx = out[0];
*objy = out[1];
*objz = out[2];
return true;
#else
return false;
#endif
}

// intersect_RayTriangle(): intersect a ray with a 3D triangle
//    Input:  a ray R, and a triangle T
//    Output: *I = intersection point (when it exists)
//    Return: 0: No intersection, value = factor of distance R0->R1
float IntersectTriangleAndRay(const float tri[3][3], const float R0[3], const float R1[3])
{
float    u[3], v[3], n[3], I[3];             // triangle vectors
float    dir[3], w0[3], w[3];          // ray vectors
float    r, a, b;             // params to calc ray-plane intersect

// get triangle edge vectors and plane normal
gDiffVertex(u, tri[1], tri[0]);
// u = T.V1 - T.V0;
gDiffVertex(v, tri[2], tri[0]);
// v = T.V2 - T.V0;
gCross(u, v, n);
//n = u * v;             // cross product
if (n[0]==0 && n[1]==0 && n[2]==0)       // triangle is degenerate
return 0;                 // do not deal with this case

gDiffVertex(dir, R1, R0);
//dir = R.P1 - R.P0;             // ray direction vector
gDiffVertex(w0, R0, tri[0]);
//w0 = R.P0 - T.V0;
a = -gDot(n, w0);
b = gDot(n,dir);
// is ray parallel to triangle plane
if (fabs(b) == 0) return 0;

// get intersect point of ray with triangle plane
r = a / b;
// if r e[0; 1], point is on line segment

gCopyVertex(I, R0); gMultVertex(dir, r); gAddVertex(I, dir);
// *I = R.P0 + r * dir;           // intersect point of ray and plane

// is I inside T?
float    uu, uv, vv, wu, wv, D;
uu = gDot(u,u);
uv = gDot(u,v);
vv = gDot(v,v);
gDiffVertex(w, I, tri[0]);
// w = *I - T.V0;
wu = gDot(w,u);
wv = gDot(w,v);
D = uv * uv - uu * vv;

// get and test parametric coords (a=s, b=t)
a = (uv * wv - vv * wu) / D;
if (a < 0.0 || a > 1.0)        // I is outside T
return 0;
b = (uv * wu - uu * wv) / D;
if (b < 0.0 || (a + b) > 1.0)  // I is outside T
return 0;

return r;                      // I is in T
}


//----------------------------------------------------------------------------
bool TriangleAndCone(float* rkConeAxis, float* rkConeVertex, float rkConeCosAngle, float rkTriangleV[][3])
{
// triangle is <P0,P1,P2>, edges are E0 = P1-P0, E1=P2-P0
int iOnConeSide = 0;
float fP0Test = (float)0.0, fP1Test = (float)0.0, fP2Test = (float)0.0;
float fAdE, fEdE, fEdD, fC1, fC2;



float fCosSqr = rkConeCosAngle*rkConeCosAngle;

// test vertex P0
float kDiff0[3];
gDiffVertex(kDiff0, rkTriangleV[0], rkConeVertex);
float fAdD0 = gDot(rkConeAxis, kDiff0);
if (fAdD0 >= 0.0f)
{
// P0 is on cone side of plane
fP0Test = fAdD0*fAdD0 - fCosSqr * gDot(kDiff0, kDiff0);
if (fP0Test >= 0.0)
{
// P0 is inside the cone
return true;
}
else
{
// P0 is outside the cone, but on cone side of plane
iOnConeSide |= 1;
}
}
// else P0 is not on cone side of plane

// test vertex P1
float kEdge0[3]; gDiffVertex(kEdge0, rkTriangleV[1], rkTriangleV[0]);
float kDiff1[3]; gCopyVertex(kDiff1, kDiff0); gAddVertex(kDiff1, kEdge0);
float fAdD1 = gDot(rkConeAxis, kDiff1);
if (fAdD1 >= 0.0)
{
// P1 is on cone side of plane
fP1Test = fAdD1*fAdD1 - fCosSqr* gDot(kDiff1, kDiff1);
if (fP1Test >= 0.0)
{
// P1 is inside the cone
return true;
}
else
{
// P1 is outside the cone, but on cone side of plane
iOnConeSide |= 2;
}
}
// else P1 is not on cone side of plane

// test vertex P2
float kEdge1[3]; gDiffVertex(kEdge1, rkTriangleV[2], rkTriangleV[0]);
float kDiff2[3]; gCopyVertex(kDiff2, kDiff0); gAddVertex(kDiff2, kEdge1);
float fAdD2 = gDot(rkConeAxis, kDiff2);
if (fAdD2 >= 0.0)
{
// P2 is on cone side of plane
fP2Test = fAdD2*fAdD2 - fCosSqr* gDot(kDiff2, kDiff2);
if (fP2Test >= 0.0)
{
// P2 is inside the cone
return true;
}
else
{
// P2 is outside the cone, but on cone side of plane
iOnConeSide |= 4;
}
}
// else P2 is not on cone side of plane

// test edge <P0,P1> = E0
if (iOnConeSide & 3)
{
fAdE = fAdD1 - fAdD0;
fEdE = gDot(kEdge0, kEdge0);
fC2 = fAdE*fAdE - fCosSqr*fEdE;
if (fC2 < (float)0.0)
{
fEdD = gDot(kEdge0, kDiff0);
fC1 = fAdE*fAdD0 - fCosSqr*fEdD;
if (iOnConeSide & 1)
{
if (iOnConeSide & 2)
{
// <P0,P1> fully on cone side of plane, fC0 = fP0Test
if ((float)0.0 <= fC1 && fC1 <= -fC2
&&  fC1*fC1 >= fP0Test*fC2)
{
return true;
}
}
else
{
// P0 on cone side (Dot(A,P0-V) >= 0),
// P1 on opposite side (Dot(A,P1-V) <= 0)
// (Dot(A,E0) <= 0), fC0 = fP0Test
if ((float)0.0 <= fC1 && fC2*fAdD0 <= fC1*fAdE
&&  fC1*fC1 >= fP0Test*fC2)
{
return true;
}
}
}
else
{
// P1 on cone side (Dot(A,P1-V) >= 0),
// P0 on opposite side (Dot(A,P0-V) <= 0)
// (Dot(A,E0) >= 0), fC0 = fP0Test (needs calculating)
if (fC1 <= -fC2 && fC2*fAdD0 <= fC1*fAdE)
{
fP0Test = fAdD0*fAdD0 - fCosSqr*gDot(kDiff0, kDiff0);
if (fC1*fC1 >= fP0Test*fC2)
{
return true;
}
}
}
}
}
// else <P0,P1> does not intersect cone half space

// test edge <P0,P2> = E1
if (iOnConeSide & 5)
{
fAdE = fAdD2 - fAdD0;
fEdE = gDot(kEdge1, kEdge1);
fC2 = fAdE*fAdE - fCosSqr*fEdE;
if (fC2 < 0.0f)
{
fEdD = gDot(kEdge1, kDiff0);
fC1 = fAdE*fAdD0 - fCosSqr*fEdD;
if (iOnConeSide & 1)
{
if (iOnConeSide & 4)
{
// <P0,P2> fully on cone side of plane, fC0 = fP0Test
if (0.0f <= fC1 && fC1 <= -fC2
&&  fC1*fC1 >= fP0Test*fC2)
{
return true;
}
}
else
{
// P0 on cone side (Dot(A,P0-V) >= 0),
// P2 on opposite side (Dot(A,P2-V) <= 0)
// (Dot(A,E1) <= 0), fC0 = fP0Test
if (0.0f <= fC1 && fC2*fAdD0 <= fC1*fAdE
&&  fC1*fC1 >= fP0Test*fC2)
{
return true;
}
}
}
else
{
// P2 on cone side (Dot(A,P2-V) >= 0),
// P0 on opposite side (Dot(A,P0-V) <= 0)
// (Dot(A,E1) >= 0), fC0 = fP0Test (needs calculating)
if (fC1 <= -fC2 && fC2*fAdD0 <= fC1*fAdE)
{
fP0Test = fAdD0*fAdD0 - fCosSqr*gDot(kDiff0, kDiff0);
if (fC1*fC1 >= fP0Test*fC2)
{
return true;
}
}
}
}
}
// else <P0,P2> does not intersect cone half space

// test edge <P1,P2> = E1-E0 = E2
if (iOnConeSide & 6)
{
float kE2[3]; gDiffVertex(kE2, kEdge1, kEdge0);
fAdE = fAdD2 - fAdD1;
fEdE = gDot(kE2, kE2);
fC2 = fAdE*fAdE - fCosSqr*fEdE;
if (fC2 < 0.0f)
{
fEdD = gDot(kE2, kDiff1);
fC1 = fAdE*fAdD1 - fCosSqr*fEdD;
if (iOnConeSide & 2)
{
if (iOnConeSide & 4)
{
// <P1,P2> fully on cone side of plane, fC0 = fP1Test
if (0.0f <= fC1 && fC1 <= -fC2
&&  fC1*fC1 >= fP1Test*fC2)
{
return true;
}
}
else
{
// P1 on cone side (Dot(A,P1-V) >= 0),
// P2 on opposite side (Dot(A,P2-V) <= 0)
// (Dot(A,E2) <= 0), fC0 = fP1Test
if (0.0f <= fC1 && fC2*fAdD1 <= fC1*fAdE
&&  fC1*fC1 >= fP1Test*fC2)
{
return true;
}
}
}
else
{
// P2 on cone side (Dot(A,P2-V) >= 0),
// P1 on opposite side (Dot(A,P1-V) <= 0)
// (Dot(A,E2) >= 0), fC0 = fP1Test (needs calculating)
if (fC1 <= -fC2 && fC2*fAdD1 <= fC1*fAdE)
{
fP1Test = fAdD1*fAdD1 - fCosSqr*gDot(kDiff1, kDiff1);
if (fC1*fC1 >= fP1Test*fC2)
{
return true;
}
}
}
}
}
// else <P1,P2> does not intersect cone half space

// Test triangle <P0,P1,P2>.  It is enough to handle only the case when
// at least one Pi is on the cone side of the plane.  In this case and
// after the previous testing, if the triangle intersects the cone, the
// set of intersection must contain the point of intersection between
// the cone axis and the triangle.
float tmp[3];
if (iOnConeSide > 0)
{
float kN[3];  gCross(kEdge0, kEdge1, kN);
float fNdA    = gDot(kN, rkConeAxis);
float fNdD    = gDot(kN, kDiff0);
float kU[3]; gCopyVertex(kU, rkConeAxis); gMultVertex(kU, fNdD);
gCopyVertex(tmp, kDiff0); gMultVertex(tmp, fNdA); gSubVertex(kU, tmp);
float kNcU[3]; gCross(kN, kU, kNcU);

float fNcUdE0 = gDot(kNcU, kEdge0), fNcUdE1, fNcUdE2, fNdN;
if (fNdA >= 0.0f)
{
if (fNcUdE0 <= 0.0f)
{
fNcUdE1 = gDot(kNcU, kEdge1);
if (fNcUdE1 >= 0.0f)
{
fNcUdE2 = fNcUdE1 - fNcUdE0;
fNdN = gGetSQLength(kN);
if (fNcUdE2 <= fNdA*fNdN)
{
return true;
}
}
}
}
else
{
if (fNcUdE0 >= 0.0f)
{
fNcUdE1 = gDot(kNcU, kEdge1);
if (fNcUdE1 <= 0.0f)
{
fNcUdE2 = fNcUdE1 - fNcUdE0;
fNdN = gGetSQLength(kN);
if (fNcUdE2 >= fNdA*fNdN)
{
return true;
}
}
}
}
}

return false;
}


// Collision between a solid sphere and a solid AABB
// The bx,by,bz params are the (half) width of each axis
bool IntersectSphereBox(float* sphere, float radius_sq, float bx, float by, float bz)
{
float  dmin=0;
#define SQR(a) ((a)*(a))
// Solid Box - Solid Sphere
float* pC = sphere;
// X
if     ( *pC <-bx ) dmin += SQR( *pC + bx );
else if( *pC > bx ) dmin += SQR( *pC - bx );
++pC;
// Y
if     ( *pC <-by ) dmin += SQR( *pC + by );
else if( *pC > by ) dmin += SQR( *pC - by );
++pC;
// Z
if     ( *pC <-bz ) dmin += SQR( *pC + bz );
else if( *pC > bz ) dmin += SQR( *pC - bz );
#undef SQR

if( dmin <= radius_sq ) return true;
return false;
} 


#include "stdafx.h" // #include "stdafx.h"
#include "meshobject.h" // #include "meshobject.h"
#include "gffilesystem.h" // #include "gffilesystem.h"
#include "ddd_ascii.h" // #include "ddd_ascii.h"

#define	CURRENT_VERSION	2.00 // File Version

#ifndef min
#define min(a,b) ((a)<(b) ? (a) : (b))
#define max(a,b) ((a)>(b) ? (a) : (b))
#endif


// GLBasic .ddd file normals are indexed.
// Use avertexnormals[normalindex][x/y/z] and
// you'll have you normals.
float gAvertexnormals[NUMVERTEXNORMALS][3] = {
{-0.525731f, 0.000000f, 0.850651f},
{-0.442863f, 0.238856f, 0.864188f},
{-0.295242f, 0.000000f, 0.955423f},
{-0.309017f, 0.500000f, 0.809017f},
{-0.162460f, 0.262866f, 0.951056f},
{0.000000f, 0.000000f, 1.000000f},
{0.000000f, 0.850651f, 0.525731f},
{-0.147621f, 0.716567f, 0.681718f},
{0.147621f, 0.716567f, 0.681718f},
{0.000000f, 0.525731f, 0.850651f},
{0.309017f, 0.500000f, 0.809017f},
{0.525731f, 0.000000f, 0.850651f},
{0.295242f, 0.000000f, 0.955423f},
{0.442863f, 0.238856f, 0.864188f},
{0.162460f, 0.262866f, 0.951056f},
{-0.681718f, 0.147621f, 0.716567f},
{-0.809017f, 0.309017f, 0.500000f},
{-0.587785f, 0.425325f, 0.688191f},
{-0.850651f, 0.525731f, 0.000000f},
{-0.864188f, 0.442863f, 0.238856f},
{-0.716567f, 0.681718f, 0.147621f},
{-0.688191f, 0.587785f, 0.425325f},
{-0.500000f, 0.809017f, 0.309017f},
{-0.238856f, 0.864188f, 0.442863f},
{-0.425325f, 0.688191f, 0.587785f},
{-0.716567f, 0.681718f, -0.147621f},
{-0.500000f, 0.809017f, -0.309017f},
{-0.525731f, 0.850651f, 0.000000f},
{0.000000f, 0.850651f, -0.525731f},
{-0.238856f, 0.864188f, -0.442863f},
{0.000000f, 0.955423f, -0.295242f},
{-0.262866f, 0.951056f, -0.162460f},
{0.000000f, 1.000000f, 0.000000f},
{0.000000f, 0.955423f, 0.295242f},
{-0.262866f, 0.951056f, 0.162460f},
{0.238856f, 0.864188f, 0.442863f},
{0.262866f, 0.951056f, 0.162460f},
{0.500000f, 0.809017f, 0.309017f},
{0.238856f, 0.864188f, -0.442863f},
{0.262866f, 0.951056f, -0.162460f},
{0.500000f, 0.809017f, -0.309017f},
{0.850651f, 0.525731f, 0.000000f},
{0.716567f, 0.681718f, 0.147621f},
{0.716567f, 0.681718f, -0.147621f},
{0.525731f, 0.850651f, 0.000000f},
{0.425325f, 0.688191f, 0.587785f},
{0.864188f, 0.442863f, 0.238856f},
{0.688191f, 0.587785f, 0.425325f},
{0.809017f, 0.309017f, 0.500000f},
{0.681718f, 0.147621f, 0.716567f},
{0.587785f, 0.425325f, 0.688191f},
{0.955423f, 0.295242f, 0.000000f},
{1.000000f, 0.000000f, 0.000000f},
{0.951056f, 0.162460f, 0.262866f},
{0.850651f, -0.525731f, 0.000000f},
{0.955423f, -0.295242f, 0.000000f},
{0.864188f, -0.442863f, 0.238856f},
{0.951056f, -0.162460f, 0.262866f},
{0.809017f, -0.309017f, 0.500000f},
{0.681718f, -0.147621f, 0.716567f},
{0.850651f, 0.000000f, 0.525731f},
{0.864188f, 0.442863f, -0.238856f},
{0.809017f, 0.309017f, -0.500000f},
{0.951056f, 0.162460f, -0.262866f},
{0.525731f, 0.000000f, -0.850651f},
{0.681718f, 0.147621f, -0.716567f},
{0.681718f, -0.147621f, -0.716567f},
{0.850651f, 0.000000f, -0.525731f},
{0.809017f, -0.309017f, -0.500000f},
{0.864188f, -0.442863f, -0.238856f},
{0.951056f, -0.162460f, -0.262866f},
{0.147621f, 0.716567f, -0.681718f},
{0.309017f, 0.500000f, -0.809017f},
{0.425325f, 0.688191f, -0.587785f},
{0.442863f, 0.238856f, -0.864188f},
{0.587785f, 0.425325f, -0.688191f},
{0.688191f, 0.587785f, -0.425325f},
{-0.147621f, 0.716567f, -0.681718f},
{-0.309017f, 0.500000f, -0.809017f},
{0.000000f, 0.525731f, -0.850651f},
{-0.525731f, 0.000000f, -0.850651f},
{-0.442863f, 0.238856f, -0.864188f},
{-0.295242f, 0.000000f, -0.955423f},
{-0.162460f, 0.262866f, -0.951056f},
{0.000000f, 0.000000f, -1.000000f},
{0.295242f, 0.000000f, -0.955423f},
{0.162460f, 0.262866f, -0.951056f},
{-0.442863f, -0.238856f, -0.864188f},
{-0.309017f, -0.500000f, -0.809017f},
{-0.162460f, -0.262866f, -0.951056f},
{0.000000f, -0.850651f, -0.525731f},
{-0.147621f, -0.716567f, -0.681718f},
{0.147621f, -0.716567f, -0.681718f},
{0.000000f, -0.525731f, -0.850651f},
{0.309017f, -0.500000f, -0.809017f},
{0.442863f, -0.238856f, -0.864188f},
{0.162460f, -0.262866f, -0.951056f},
{0.238856f, -0.864188f, -0.442863f},
{0.500000f, -0.809017f, -0.309017f},
{0.425325f, -0.688191f, -0.587785f},
{0.716567f, -0.681718f, -0.147621f},
{0.688191f, -0.587785f, -0.425325f},
{0.587785f, -0.425325f, -0.688191f},
{0.000000f, -0.955423f, -0.295242f},
{0.000000f, -1.000000f, 0.000000f},
{0.262866f, -0.951056f, -0.162460f},
{0.000000f, -0.850651f, 0.525731f},
{0.000000f, -0.955423f, 0.295242f},
{0.238856f, -0.864188f, 0.442863f},
{0.262866f, -0.951056f, 0.162460f},
{0.500000f, -0.809017f, 0.309017f},
{0.716567f, -0.681718f, 0.147621f},
{0.525731f, -0.850651f, 0.000000f},
{-0.238856f, -0.864188f, -0.442863f},
{-0.500000f, -0.809017f, -0.309017f},
{-0.262866f, -0.951056f, -0.162460f},
{-0.850651f, -0.525731f, 0.000000f},
{-0.716567f, -0.681718f, -0.147621f},
{-0.716567f, -0.681718f, 0.147621f},
{-0.525731f, -0.850651f, 0.000000f},
{-0.500000f, -0.809017f, 0.309017f},
{-0.238856f, -0.864188f, 0.442863f},
{-0.262866f, -0.951056f, 0.162460f},
{-0.864188f, -0.442863f, 0.238856f},
{-0.809017f, -0.309017f, 0.500000f},
{-0.688191f, -0.587785f, 0.425325f},
{-0.681718f, -0.147621f, 0.716567f},
{-0.442863f, -0.238856f, 0.864188f},
{-0.587785f, -0.425325f, 0.688191f},
{-0.309017f, -0.500000f, 0.809017f},
{-0.147621f, -0.716567f, 0.681718f},
{-0.425325f, -0.688191f, 0.587785f},
{-0.162460f, -0.262866f, 0.951056f},
{0.442863f, -0.238856f, 0.864188f},
{0.162460f, -0.262866f, 0.951056f},
{0.309017f, -0.500000f, 0.809017f},
{0.147621f, -0.716567f, 0.681718f},
{0.000000f, -0.525731f, 0.850651f},
{0.425325f, -0.688191f, 0.587785f},
{0.587785f, -0.425325f, 0.688191f},
{0.688191f, -0.587785f, 0.425325f},
{-0.955423f, 0.295242f, 0.000000f},
{-0.951056f, 0.162460f, 0.262866f},
{-1.000000f, 0.000000f, 0.000000f},
{-0.850651f, 0.000000f, 0.525731f},
{-0.955423f, -0.295242f, 0.000000f},
{-0.951056f, -0.162460f, 0.262866f},
{-0.864188f, 0.442863f, -0.238856f},
{-0.951056f, 0.162460f, -0.262866f},
{-0.809017f, 0.309017f, -0.500000f},
{-0.864188f, -0.442863f, -0.238856f},
{-0.951056f, -0.162460f, -0.262866f},
{-0.809017f, -0.309017f, -0.500000f},
{-0.681718f, 0.147621f, -0.716567f},
{-0.681718f, -0.147621f, -0.716567f},
{-0.850651f, 0.000000f, -0.525731f},
{-0.688191f, 0.587785f, -0.425325f},
{-0.587785f, 0.425325f, -0.688191f},
{-0.425325f, 0.688191f, -0.587785f},
{-0.425325f, -0.688191f, -0.587785f},
{-0.587785f, -0.425325f, -0.688191f},
{-0.688191f, -0.587785f, -0.425325f},
};


MeshObject::MeshObject()
{
m_HasNormals=0;
m_HasBumpNormals=0;
}

MeshObject::~MeshObject()
{
this->Clear(true);
}

//------------------------------------------------------------------//
// Add the normal to the list
//------------------------------------------------------------------//
inline unsigned int AutoFindNormalIndex(unsigned long seekfor, Queue<POLY_NODE>& normals)
{
for(int j=(int)normals.Size()-1; j>=0; j--)
{
if (normals.GetAt(j)->dwcol == seekfor)
return j;
}

POLY_NODE	node;
memset(&node, 0, sizeof(node));
node.dwcol=seekfor;
normals.Push(node);
return normals.Size()-1;
}


//------------------------------------------------------------------//
// Auto-Calculate normal vectors for nodes
// Calls PrepareTriangles afterwards!
// this is done _after_ user creation of a model
//------------------------------------------------------------------//
void MeshObject::AutoNormalsAfterCompression(bool wantnormals, bool surfacenormals, bool wantbumpvertices)
{
// Check if there's work to do
if (m_Frames.Size()==0 || m_Frames.GetAt(0)->nodes.Size()==0) return;

if (wantnormals && m_HasNormals)			wantnormals=false;
if (wantbumpvertices && m_HasBumpNormals)	wantbumpvertices=false;
if (!wantnormals && !wantbumpvertices) return;

// Start building normals
unsigned int	nDrawn=0, nTotalDrawn=0;
int				i, num;
char			nFlip=0;
unsigned long	mode = COL_NEW_TRI;
unsigned long	lastseek[3];
float			normal[3];									 // Normal
float			tangent[3], binormal[3], LastTextures[3][2]; // Bump
POLY_NODE		*pNode;
POLY_FRAME		*pFrame;
Queue<POLY_NODE>normals;
Queue<POLY_NODE>pAllNodes;
float			LastVectors[3][3];
memset(LastTextures, 0, sizeof(LastTextures));
m_HasNormals=1;

// New Object
num = m_Frames.GetAt(0)->nodes.Size()+1;
pAllNodes.SetSize(num);
normals.AllocAtLeast(num);
for (num=0; num<m_Frames.Size(); num++)
{
nDrawn=0;
nFlip=0;
pFrame=m_Frames.GetAt(num);

// Calc normals for all points
for (i=0; i<pFrame->nodes.Size(); i++)
{
pNode = &pAllNodes[i];
*pNode = pFrame->nodes[i];
// Uncompress(num, i, pNode);
// New Group
if (pNode->col() >= COL_NEW_ANY)
{
mode = pNode->col();
pNode->dwcol=0; // Not to peek somewhere next time
nDrawn=0;
nTotalDrawn=0;
nFlip=0;
continue;
}
// Add Vertex
gCopyVertex(LastVectors[nDrawn], pNode->pos);
if (wantbumpvertices)
{
LastTextures[nDrawn][0] = pNode->tex[0];
LastTextures[nDrawn][1] = pNode->tex[1];
}


if(surfacenormals)
{
// Make unique integer from x,y,z of this vertex
lastseek[nDrawn] = (unsigned long)(256.0f*pNode->pos[0] + 256.0f*256.0f*pNode->pos[1] + 256.0f*256.0f*256.0f*pNode->pos[2]);
// pFrame->xnodes.GetAt(i)->pos[0] + 0x100*pFrame->xnodes.GetAt(i)->pos[1] + 0x10000*pFrame->xnodes.GetAt(i)->pos[2];
}
else
{
lastseek[nDrawn] = i; // Each vertex gets an unique normal
}
// Find a normal at that vertex-position( / index) index
// in the vertex-list
pNode->dwcol = AutoFindNormalIndex(lastseek[nDrawn], normals);

// Store quick normal list index in temp. color
// this way we can find the corresponding normal index
// later when setting the normal for it
lastseek[nDrawn] = pNode->dwcol;
nDrawn++;
nTotalDrawn++;

// Drawn another triangle. Calc Normals for all 3 nodes
if (nDrawn == 3)
{
bool flipnormal=false;
nDrawn=2;
nFlip=nFlip ? 0 : 1;
// nFlip++; nFlip %= 2;
if (mode == COL_NEW_TRI)
{
nFlip=0;
nDrawn=0; // Triangles
nTotalDrawn=0;
}
else if (mode == COL_NEW_STRIP && nFlip==0) // Must reverse direction
{
flipnormal=true;
}

if (wantnormals)
{
gComputeNormal(LastVectors, normal);

if(flipnormal)
gFlipVertex(normal);

gAddVertex(normals[(int)lastseek[2]].normal, normal);
gAddVertex(normals[(int)lastseek[1]].normal, normal);
gAddVertex(normals[(int)lastseek[0]].normal, normal);
}

if (wantbumpvertices)
{
gComputeTangentBasis(LastVectors, LastTextures, tangent, binormal);
gAddVertex(normals.GetAt((int)lastseek[2])->binormal, binormal);
gAddVertex(normals.GetAt((int)lastseek[1])->binormal, binormal);
gAddVertex(normals.GetAt((int)lastseek[0])->binormal, binormal);

gAddVertex(normals.GetAt((int)lastseek[2])->tangent, tangent);
gAddVertex(normals.GetAt((int)lastseek[1])->tangent, tangent);
gAddVertex(normals.GetAt((int)lastseek[0])->tangent, tangent);
LastTextures[0][0] = LastTextures[1][0];
LastTextures[0][1] = LastTextures[1][1];
LastTextures[1][0] = LastTextures[2][0];
LastTextures[1][1] = LastTextures[2][1];
}
// shift the left vertex away to use the other 2 for new triangle
lastseek[0]       = lastseek[1];
lastseek[1]       = lastseek[2];
gCopyVertex(LastVectors[0], LastVectors[1]);
gCopyVertex(LastVectors[1], LastVectors[2]);
}
}
// Normalize and set normals for each point

//	for (i=0; i<normals.Size(); ++i) gUnify(normals.GetAt(i)->normal);

/* xnode insertion (when writing to DDD old format)
if (wantnormals)
{
for (i=0; i<pFrame->xnodes.Size(); i++)
{
pFrame->xnodes[i].inormal=(unsigned char)gGetNormalIndex(normals[pAllNodes[i].dwcol].normal);
}
}
if (wantbumpvertices)
{
for (i=0; i<pFrame->xnodes.Size(); i++)
{
pFrame->xnodes[i].ibinormal=(unsigned char)gGetNormalIndex(normals[pAllNodes[i].dwcol].binormal);
pFrame->xnodes[i].itangent =(unsigned char)gGetNormalIndex(normals[pAllNodes[i].dwcol].tangent );
}
}
*/
for (i=0; i<pFrame->nodes.Size(); i++)
{
POLY_NODE& node = pFrame->nodes[i];
POLY_NODE& norm = normals[(int)pAllNodes[i].dwcol];

if (wantnormals)
{
gUnify(norm.normal);
node.normal[0] = norm.normal[0];
node.normal[1] = norm.normal[1];
node.normal[2] = norm.normal[2];
}
if (wantbumpvertices)
{
gUnify(norm.binormal);
gUnify(norm.tangent);
node.binormal[0] = norm.binormal[0];
node.binormal[1] = norm.binormal[1];
node.binormal[2] = norm.binormal[2];
node.tangent[0] =  norm.tangent[0];
node.tangent[1] =  norm.tangent[1];
node.tangent[2] =  norm.tangent[2];
}
}

if (wantbumpvertices)
m_HasBumpNormals = 1;
}
PrepareTriangles(); // For VBO rendering
}
/*
//------------------------------------------------------------------//
// Compress the poly system from nodes to xnodes (for saving)
//------------------------------------------------------------------//
void MeshObject::Compress(void)
{
POLY_FRAME*	pFrame;
POLY_NODE*	pNode;
XPOLY_NODE	xnode;
float		maxx[3], minx[3];
unsigned int	j, n, i, nFrame;
bool		isfirst;

this->m_Texture[0].Clear();
this->m_Texture[1].Clear();

xnode.ibinormal=0;
xnode.itangent=0;

for (nFrame=0; nFrame<this->m_Frames.Size(); nFrame++)
{
pFrame=m_Frames.GetAt(nFrame);
pFrame->xnodes.Clear(false);
maxx[0]=maxx[1]=maxx[2]=0.0f;
minx[0]=minx[1]=minx[2]=0.0f;
// X, Y, Z -> Get Move&Scale
for (i=0; i<3; i++)
{
// Move
isfirst=true;
for (n=0; n<pFrame->nodes.Size(); n++)
{
pNode=pFrame->nodes.GetAt(n);
if (pNode->col() >= COL_NEW_ANY) continue;
if (isfirst)
{
isfirst=false;
maxx[i]=pNode->pos[i];
minx[i]=pNode->pos[i];
}
else
{
maxx[i]=max(maxx[i], pNode->pos[i]);
minx[i]=min(minx[i], pNode->pos[i]);
}
}
pFrame->scale[i]=(maxx[i]-minx[i])/255.0f;
if (pFrame->scale[i]==0.0f) pFrame->scale[i]=1.0f;

pFrame->move[i]=-minx[i]/pFrame->scale[i];
}

// Compress every node
m_Texture[0].AllocAtLeast(pFrame->nodes.Size());
m_Texture[1].AllocAtLeast(pFrame->nodes.Size());
pFrame->xnodes.AllocAtLeast(pFrame->nodes.Size());
for (n=0; n<pFrame->nodes.Size(); n++)
{
pNode=pFrame->nodes.GetAt(n);

// Color
xnode.icol=(unsigned char)m_ColTable.Size();
for (j=0; j<m_ColTable.Size(); j++)
{
if (pNode->col()==*m_ColTable.GetAt(j))
{
xnode.icol=(unsigned char)j;
goto skipcolor;
}
}
m_ColTable.Push(pNode->col());
skipcolor:
#ifdef _DEBUG
xnode.pos[0] = xnode.pos[1] = xnode.pos[2] = 128;
#endif
if(pNode->col() < COL_NEW_ANY)
{
// Normal
xnode.inormal=(unsigned char)gGetNormalIndex(pNode->normal);
xnode.pos[0]=(unsigned char)min(pNode->pos[0]/pFrame->scale[0]+pFrame->move[0], 255);
xnode.pos[1]=(unsigned char)min(pNode->pos[1]/pFrame->scale[1]+pFrame->move[1], 255);
xnode.pos[2]=(unsigned char)min(pNode->pos[2]/pFrame->scale[2]+pFrame->move[2], 255);
// gotone:;
}
// Texture
if (nFrame==0)
{
m_Texture[0].Push(pNode->tex[0]);
m_Texture[1].Push(pNode->tex[1]);
}
// Vertex
pFrame->xnodes.Push(xnode);
}
pFrame->nodes.Clear(false);
}
m_HasNormals=0;
m_HasBumpNormals=0;
}
*/

//------------------------------------------------------------------//
// Clear the data, make object empty
//------------------------------------------------------------------//
void MeshObject::Clear(bool free_mem)
{
#if defined(TINYGL)
for(int i=0; i<(int)m_glListIDs.Size(); ++i)
{
glDeleteLists(m_glListIDs[i], 1);
}
m_glListIDs.Clear();
#endif

m_ColTable.Clear(free_mem);
m_tri_animation.Clear(free_mem);
for (int i=0; i<m_Frames.Size(); i++)
{
m_Frames.GetAt(i)->nodes.Clear(free_mem);
m_Frames.GetAt(i)->triangles.Clear(free_mem);
}
m_Frames.Clear(free_mem);	// Remove if already a List
m_HasNormals=0;
m_HasBumpNormals=0;
}


//------------------------------------------------------------------//
// Save an Object in GLBasic .ddd format (new format)
//------------------------------------------------------------------//
bool MeshObject::Save(const char* filename)
{
POLY_NODE*		pNode;
GFFileSystem	file;
int		i, j, filetype;
int		numNodes, numAnimations, numColors, numTextures;
double	version;

if(m_Frames.Size() == 0) return false;

if (!file.OpenOut(filename)) return false;

filetype=13021975;
version=CURRENT_VERSION;

numAnimations=max(0, m_Frames.Size());
numColors=max(0, m_ColTable.Size());
numTextures=max(0, m_Frames[0].nodes.Size());

file.WriteLong(filetype		);
file.WriteDbl (version		);
file.WriteLong(numAnimations);
file.WriteLong(numColors	);
file.WriteLong(numTextures	);

for(i=0; i<numColors; i++)
{
file.WriteLong(m_ColTable[i]);
}

for(i=0; i<numTextures; i++)
{
POLY_FRAME& frm = m_Frames[0];
file.WriteFlt(frm.nodes[i].tex[0]);
file.WriteFlt(frm.nodes[i].tex[1]);
}

for (j=0; j<numAnimations; j++)
{
POLY_FRAME& frm = *m_Frames.GetAt(j);
numNodes=frm.nodes.Size();
file.WriteLong(numNodes);

for(i=0; i<numNodes; i++)
{
pNode=frm.nodes.GetAt(i);
file.WriteFlt(pNode->pos[0]);
file.WriteFlt(pNode->pos[1]);
file.WriteFlt(pNode->pos[2]);

unsigned char uc[2];
uc[0] = gGetNormalIndex(pNode->normal);
uc[1] = pNode->icol;
file.Write((void*)&uc, 2);
}
}
file.Close();
return true;
}

//------------------------------------------------------------------//
// Build a Color Table for cel shading e.g.
//------------------------------------------------------------------//
void MeshObject::BuildColorTable()
{
m_ColTable.Clear(false);
for(int ifr=0; ifr<(int)m_Frames.Size(); ++ifr)
{
POLY_FRAME& frm = m_Frames[ifr];
for(int i=0; i<(int)frm.nodes.Size(); i++)
{
for(int k=0; k<(int)m_ColTable.Size(); k++)
{
if(frm.nodes[i].col() == m_ColTable[k] )
{
frm.nodes[i].icol = (unsigned char)k;
goto skipcolor;
}
}
// not found, add new
frm.nodes[i].icol = (unsigned char)m_ColTable.Size();
m_ColTable.Push(frm.nodes[i].col());

skipcolor:
{}
}
}
}


//------------------------------------------------------------------//
// Load an Object in .ddd / .dda -Format
//------------------------------------------------------------------//
bool MeshObject::Load(const char* filename, bool uncompress)
{
// Remove all
Clear(true);
XPOLY_NODE	Node;
GFFileSystem	file;
int			filetype, i, j;
int			numNodes=0, numAnimations=0, numColors=0, numTexture=0;
double		version;
unsigned long color;
bool			read_err=true; // if true: read error, false: malloc error
Queue<float> Texture[2];

if (!file.OpenIn(filename)) return false;

file.ReadLong(filetype);
// wrong filetype? - try loading a dda file
if (filetype!=13021975)
{
file.Close();
DDD_ascii import;
if(!import.Read(filename))
goto fail;
else
{
import.Make(*this);
return true;
}
}
file.ReadDbl(version);
file.ReadLong(numAnimations);

file.ReadLong(numColors);
file.ReadLong(numTexture);

if (version>CURRENT_VERSION ||version<1.02)
{
g_debug("Wrong .ddd version: %.2f. Can use 1.02-%.2f\n", version, CURRENT_VERSION);
goto fail;
}

m_ColTable.SetAllocSteps(1,1);
m_ColTable.AllocAtLeast(numColors);
for(i=0; i<numColors; i++)
{
file.ReadLong(color);
if(!m_ColTable.Push(color)) {read_err=false; goto fail;}
}


Texture[0].SetAllocSteps(1,1);
Texture[1].SetAllocSteps(1,1);
Texture[0].AllocAtLeast(numTexture);
Texture[1].AllocAtLeast(numTexture);
for(i=0; i<numTexture; i++)
{
float	flot;
file.ReadFlt(flot);
if(!Texture[0].Push(flot)) {read_err=false; goto fail;}
file.ReadFlt(flot);
if(!Texture[1].Push(flot)) {read_err=false; goto fail;}
}

if(version>=2.0)
{
m_Frames.SetSize(numAnimations);
for (j=0; j<numAnimations; j++)
{
POLY_FRAME& frm = *m_Frames.GetAt(j);
file.ReadLong(numNodes);
frm.nodes.SetSize(numNodes);
for(i=0; i<numNodes; i++)
{
POLY_NODE& node = frm.nodes[i];
file.Read(&node.pos[0], sizeof(float)*3);
if(GF_BIG_ENDIAN)
{
FlipFloat(node.pos[0]);
FlipFloat(node.pos[1]);
FlipFloat(node.pos[2]);
}

unsigned char uc[2];
file.Read((void*)&uc, 2);
memcpy(node.normal, gAvertexnormals[uc[0]], 3*sizeof(float));
node.icol = uc[1];
node.col(m_ColTable[uc[1]]);

node.tex[0] = Texture[0][i];
node.tex[1] = Texture[1][i];
}
}
}
else // old version (3 byte per xyz)
{
m_Frames.SetAllocSteps(1,1);
m_Frames.AllocAtLeast(numAnimations);
for (j=0; j<numAnimations; j++)
{
Queue<XPOLY_NODE>	xnodes;
float move[3], scale[3];
POLY_FRAME	Frame;
file.ReadLong(numNodes);
file.ReadFlt(move[0]); file.ReadFlt(move[1]); file.ReadFlt(move[2]);
file.ReadFlt(scale[0]);file.ReadFlt(scale[1]);file.ReadFlt(scale[2]);

xnodes.SetAllocSteps(1,1);
xnodes.AllocAtLeast(numNodes);
for(i=0; i<numNodes; i++)
{
// 5 members, each a char
unsigned char buf[8];
file.Read(buf, 5);

Node.pos[0] = buf[0];
Node.pos[1] = buf[1];
Node.pos[2] = buf[2];
Node.inormal= buf[3];
Node.icol   = buf[4];

Node.ibinormal=0;
Node.itangent=0;
if(!xnodes.Push(Node)) {read_err=false; goto fail;}
}
// uncompress to what we need
Uncompress(xnodes, &Texture[0][0], &Texture[1][0], move, scale, &Frame);

if(!m_Frames.Push(Frame)) {read_err=false; goto fail;}
}
}
m_HasNormals=1;
file.Close();
return true;

fail:
if(read_err)
{
g_debug("# read error\n");
}
else
{
g_debug("# malloc error\n");
#ifdef _WIN32_
::MessageBox(NULL, "Out of Memory", "GLBasic", MB_ICONERROR|MB_OK);
#endif
}
g_debug("%s\n", filename);
file.Close();
Clear(true);
return false;
}



// --------------------------------------------------------------- //
// POLY_FRAME - functions
// --------------------------------------------------------------- //
POLY_FRAME::POLY_FRAME()
{
}

POLY_FRAME::~POLY_FRAME()
{
}

POLY_FRAME& POLY_FRAME::operator = (const POLY_FRAME& f)
{
if(this == &f) return *this;

int i;
nodes.Clear(false); triangles.Clear(false);

// Don't allocate more than required on a copy
nodes.SetAllocSteps(1,1);
triangles.SetAllocSteps(1,1);
nodes.SetSize(f.nodes.Size());
triangles.SetSize(f.triangles.Size());

POLY_NODE* pN;
const POLY_NODE* pNf;
if(f.nodes.Size())
{
pN = &nodes[0];
pNf = &f.nodes[0];
for (i=0; i<f.nodes.Size(); i++)
{
*pN++ = *pNf++;
#ifdef _DEBUG
nodes.GetAt(i); f.nodes.GetAt(i);
#endif
}
}
if(f.triangles.Size())
{
pN = &triangles[0];
pNf= &f.triangles[0];
for (i=0; i<f.triangles.Size(); i++)
{
*pN++ = *pNf++;
#ifdef _DEBUG
triangles.GetAt(i); f.triangles.GetAt(i);
#endif
}
}
max_radius = f.max_radius;
center_of_mass[0] = f.center_of_mass[0];
center_of_mass[1] = f.center_of_mass[1];
center_of_mass[2] = f.center_of_mass[2];
return *this;
}

/*****************************************************************************
SLZ - SLZ (un)packer.            C. 1993 SilverFox SoftWare.
Written by Adisak Pochanayon     All Rights Reserved.

This program is a simple example of using SLZ compression
upon a file.  It will allow you to both pack and unpack a file
using SLZ compression.  The syntax for calling this program from
the CLI is:

SLZ  FLAG  SOURCE  DESTINATION
FLAG can be U - unpack  P - pack

*****************************************************************************/

#include "stdafx.h" // #include  "stdafx.h"
#include  <memory.h> // memcpy
#include "gfcompression.h" // #include  "gfcompression.h"

#ifdef _MSC_VER
#pragma warning(disable: 4311)
#pragma warning(disable: 4244)
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef NULL
#define NULL 0L
#endif

#ifdef hashing_on
#define CHASH(a,b,c)  ( ((((a&63)<<6)+(b&63))<<4)+c )
#endif

// ---------------------------------------------------------------- //
// Free Memory
// ---------------------------------------------------------------- //
void GFCompression::Clear()
{
if (m_outfile) delete [] m_outfile;
m_outfile=0L;
m_length=0;
m_lzhist_offset=0;

// Step 1: initialize the LZO library
//	if (lzo_init() != LZO_E_OK) TRACE("Cannot init LZO\n", "", "");
}

// ---------------------------------------------------------------- //
// Intern Stuff
// ---------------------------------------------------------------- //
void GFCompression::writechar(register unsigned char outchar)
{
// Need realloc?
if (m_length % 1024 == 0)
{
unsigned char* pBuffer = new unsigned char [(m_length/1024)*1024+1032];
if (m_outfile)
{
memcpy(pBuffer, m_outfile, m_length);
delete [] m_outfile;
}
m_outfile = pBuffer;
}
m_outfile[m_length++]=outchar;

m_LZ_history[m_lzhist_offset]=outchar; m_lzhist_offset=(m_lzhist_offset+1)&MASK_history;
}

// ---------------------------------------------------------------- //
// Unpack to a empty buffer. Delete Buffer afterwards!
// ---------------------------------------------------------------- //
long GFCompression::UnPack(const unsigned char *inbuffer, int len)
{
short myTAG, mycount, myoffset;
long int loop1;

Clear();

if (m_Method==1) // LZO
{
// decompress
len-=4; // header bytes;
lzo_uint	olen;
memcpy(&olen, inbuffer, 4); // length header
// TRACE("Uncompressed size should be: %d\n", olen, "");
m_outfile = new BYTE[olen];

int r = lzo1x_decompress_safe(inbuffer+4, len, m_outfile, &olen, NULL);
if (r == LZO_E_OK)
{
// TRACE("decompressed %lu bytes back into %lu bytes\n", (long) len, (long) m_length);
m_length = (long)olen;
return m_length;
}
else
{
// this should NEVER happen
// TRACE("internal error - decompression failed: %d\n", r, "");
return 0;
}
}
else // SLZ
{
for(;;)  // loop forever (until goto occurs to break out of loop)
{
myTAG=*inbuffer++;
for(loop1=0;(loop1!=8);loop1++)
{
if(myTAG&0x80)
{
if((mycount=*inbuffer++)==0)  // Check EXIT
{
goto jumpout;
}
else
{
myoffset=HISTORY_SIZE-(((MASK_upper&mycount)*SHIFT_UPPER)+(*inbuffer++));
mycount&=MASK_lower;
mycount+=2;
while(mycount!=0)
{
writechar(m_LZ_history[(m_lzhist_offset+myoffset)&MASK_history]);
mycount--;
}
}
}
else
{ writechar(*inbuffer++); }
myTAG+=myTAG;
}
}
}
jumpout:
return m_length;
}

#define HEAP_ALLOC(var,size) \
lzo_align_t __LZO_MMODEL var [ ((size) + (sizeof(lzo_align_t) - 1)) / sizeof(lzo_align_t) ]

static HEAP_ALLOC(g_wrkmem,LZO1X_1_MEM_COMPRESS);

// ---------------------------------------------------------------- //
// Pack a buffer to another buffer. Delete the buffer afterwards!
// ---------------------------------------------------------------- //
long GFCompression::Pack(const unsigned char *inbuffer, long length)
{
long int loop1,loop2, startvalue, endvalue=0, wherefound=0;
unsigned char outchars[MAX_COMP_LEN*10];
const unsigned char *a_buffer, *b_buffer;
short lenoutchars;
short myTAG=0, iter;
long done,found,temp;

Clear();


if (m_Method == 1) // LZO
{
// TRACE("Compressing\n", "", "");
int	maxlen = (int)length + (int)length / 64 + 16 + 3;
m_outfile = new BYTE [maxlen + 4]; // 4 for my length header
lzo_uint	olen;
int r = lzo1x_1_compress(inbuffer, (int)length, m_outfile+4, &olen, g_wrkmem);
if(r==LZO_E_OK)
{
olen+=4; // header bytes
memcpy(m_outfile, &length, 4); // original length header
m_length=(long)olen;
}
else
m_length = 0;
/*
if (m_length>maxlen) TRACE("Compress: Buffer overrun!\n", "", "");
if (r == LZO_E_OK)
{
// TRACE("compressed %lu bytes into %lu bytes\n", (long) length, (long) m_length);
}
else
{
// this should NEVER happen
// TRACE("internal error - compression failed: %d\n", r, "");
}
// check for an incompressible block
if ((long)olen >= length)
{
TRACE("This block contains incompressible data.\n", "", "");
}
*/
return m_length;
}
else // SLZ
{

#ifdef hashing_on
long *INHASH;
short HASHCHECK;

for(loop1=0;loop1!=65536;loop1++)
{
m_HASH_TABLE[loop1]=-1;
}
m_HASH_TABLE[CHASH(inbuffer[0],inbuffer[1],0)]=0;
#endif

loop1=1; loop2=length-1; iter=1;  // Always do a literal first byte
outchars[1]=inbuffer[0]; lenoutchars=2;
done=0;

while(! done)
{
myTAG=0;
while((iter<8)&&(! done))
{

/***--- This is the slowest part.  I should rewrite it in ASM ---***/

startvalue=loop1-MASK_history;
if (startvalue<0) startvalue=0;
found=0;

#ifdef hashing_on
INHASH=&m_HASH_TABLE[CHASH(inbuffer[loop1],inbuffer[loop1+1],0)];
HASHCHECK=16; // Scan for matches in HASH TABLE
while((HASHCHECK)&&((endvalue=*INHASH++)>=startvalue))
{
temp=0;
a_buffer=&inbuffer[loop1];
b_buffer=&inbuffer[endvalue];
while((*(a_buffer++) == *(b_buffer++))&&(temp<MAX_COMP_LEN))
{
temp++;
}
if(found<temp)
{
if ((temp+loop1)>length)
{
temp=length-loop1;
if(found<temp)
{
found=temp;
wherefound=endvalue;
}
}
else
{
found=temp;
wherefound=endvalue;
}
if (found==MAX_COMP_LEN) { goto skip1; }
}
HASHCHECK--;
}
#else
endvalue=loop1-1;
#endif

while(endvalue>=startvalue) // Scan for matches
{
temp=0;
a_buffer=&inbuffer[loop1];
b_buffer=&inbuffer[endvalue];
while((*(a_buffer++) == *(b_buffer++))&&(temp<MAX_COMP_LEN))
{
temp++;
}
if(found<temp)
{
if ((temp+loop1)>length)
{
temp=length-loop1;
if(found<temp)
{
found=temp;
wherefound=endvalue;
}
}
else
{
found=temp;
wherefound=endvalue;
}
if (found==MAX_COMP_LEN) { goto skip1; }
}
endvalue--;
}
skip1:

/***--- End of *SLOW* exhaustive history scan:( WHEW! ---***/


if(found>2) // Compression will now occur
{
myTAG|=(128>>iter);
endvalue=loop1-wherefound;
startvalue=((endvalue>>LSR_upper)&MASK_upper)+(found-2);
outchars[lenoutchars++]=(unsigned char)startvalue;
outchars[lenoutchars++]=(unsigned char)endvalue;
loop2-=found;
while(found!=0)
{
#ifdef hashing_on
ADDHASH(inbuffer[loop1],inbuffer[loop1+1],loop1);
#endif
loop1++; found--;
}
}
else // No Compression, copy literal byte
{
#ifdef hashing_on
ADDHASH(inbuffer[loop1],inbuffer[loop1+1],loop1);
#endif
outchars[lenoutchars++]=inbuffer[loop1++];
loop2--;
}
if(loop2<=0)
{
done=1;
if(loop2<0)
{// hmmm... Ooops!
return 0;
}
}
iter++;
}
if(! done)
{
outchars[0]=(unsigned char)myTAG;
for(startvalue=0;startvalue!=lenoutchars;startvalue++)          
{
//            writechar(outchars[startvalue],outfile);
writechar(outchars[startvalue]);
}
lenoutchars=1;
iter=0;
}
}
if(iter==8)
{
outchars[0]=(unsigned char)myTAG;
for(startvalue=0;startvalue!=lenoutchars;startvalue++)          
{
writechar(outchars[startvalue]);
}
writechar(255);
}
else
{
outchars[0]=myTAG|(128>>iter);
for(startvalue=0;startvalue!=lenoutchars;startvalue++)          
{
writechar(outchars[startvalue]);
}
writechar(0);
}
return m_length;
}
}


#ifdef hashing_on
// ---------------------------------------------------------------- //
// Add to Hash Table
// ---------------------------------------------------------------- //
void GFCompression::ADDHASH(long a,long b, long c)
{
long *INHASH,*BEFINHASH;
INHASH=&m_HASH_TABLE[CHASH(a,b,15)];
BEFINHASH=INHASH-1;
*(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--);
*(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--);
*(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--);
*(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--);
*(INHASH--)=*(BEFINHASH--); *(INHASH--)=*(BEFINHASH--); *(INHASH)=*(BEFINHASH);
*BEFINHASH=c;  
}
#endif

/* minilzo.c -- mini subset of the LZO real-time data compression library

This file is part of the LZO real-time data compression library.

Copyright (C) 2002 Markus Franz Xaver Johannes Oberhumer
Copyright (C) 2001 Markus Franz Xaver Johannes Oberhumer
Copyright (C) 2000 Markus Franz Xaver Johannes Oberhumer
Copyright (C) 1999 Markus Franz Xaver Johannes Oberhumer
Copyright (C) 1998 Markus Franz Xaver Johannes Oberhumer
Copyright (C) 1997 Markus Franz Xaver Johannes Oberhumer
Copyright (C) 1996 Markus Franz Xaver Johannes Oberhumer
All Rights Reserved.

The LZO library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

The LZO library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the LZO library; see the file COPYING.
If not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

Markus F.X.J. Oberhumer
<markus@oberhumer.com>
http://www.oberhumer.com/opensource/lzo/
*/

/*
* NOTE:
*   the full LZO package can be found at
*   http://www.oberhumer.com/opensource/lzo/
*/
#define LZO_NO_SYS_TYPES_H

#define __LZO_IN_MINILZO
#define LZO_BUILD

#ifdef MINILZO_HAVE_CONFIG_H
#  include <config.h>
#endif

#undef LZO_HAVE_CONFIG_H

#include "gfcompression.h" // #include "gfcompression.h"

#if !defined(MINILZO_VERSION) || (MINILZO_VERSION != 0x1080)
#  error "version mismatch in miniLZO source files"
#endif

#ifdef MINILZO_HAVE_CONFIG_H
#  define LZO_HAVE_CONFIG_H
#endif

#if !defined(LZO_NO_SYS_TYPES_H)
#  include <sys/types.h>
#endif
#include <stdio.h>

#ifndef __LZO_CONF_H
#define __LZO_CONF_H

#if !defined(__LZO_IN_MINILZO)
#  ifndef __LZOCONF_H
#    include <lzoconf.h>
#  endif
#endif

#if defined(__BOUNDS_CHECKING_ON)
#  include <unchecked.h>
#else
#  define BOUNDS_CHECKING_OFF_DURING(stmt)      stmt
#  define BOUNDS_CHECKING_OFF_IN_EXPR(expr)     (expr)
#endif

#if !defined(LZO_HAVE_CONFIG_H)
#  include <stddef.h>
#  include <string.h>
#  if !defined(NO_STDLIB_H)
#    include <stdlib.h>
#  endif
# ifndef HAVE_MEMCMP
#  define HAVE_MEMCMP
# endif
# ifndef HAVE_MEMCPY
#  define HAVE_MEMCPY
# endif
# ifndef HAVE_MEMMOVE
#  define HAVE_MEMMOVE
# endif
# ifndef HAVE_MEMSET
#  define HAVE_MEMSET
# endif
#else
#  include <sys/types.h>
#  if defined(HAVE_STDDEF_H)
#    include <stddef.h>
#  endif
#  if defined(STDC_HEADERS)
#    include <string.h>
#    include <stdlib.h>
#  endif
#endif

#if defined(__LZO_DOS16) || defined(__LZO_WIN16)
#  define HAVE_MALLOC_H
#  define HAVE_HALLOC
#endif

#undef NDEBUG
#if !defined(LZO_DEBUG)
#  define NDEBUG
#endif
#if defined(LZO_DEBUG) || !defined(NDEBUG)
#  if !defined(NO_STDIO_H)
#    include <stdio.h>
#  endif
#endif
#include <assert.h>

#if !defined(LZO_COMPILE_TIME_ASSERT)
#  define LZO_COMPILE_TIME_ASSERT(expr) \
{ typedef int __lzo_compile_time_assert_fail[1 - 2 * !(expr)]; }
#endif

#if !defined(LZO_UNUSED)
#  if 1
#    define LZO_UNUSED(var)     ((void)&var)
#  elif 0
#    define LZO_UNUSED(var)     { typedef int __lzo_unused[sizeof(var) ? 2: 1]; }
#  else
#    define LZO_UNUSED(parm)    (parm = parm)
#  endif
#endif

#if !defined(__inline__) && !defined(__GNUC__)
#  if defined(__cplusplus)
#    define __inline__      inline
#  else
#    define __inline__
#  endif
#endif

#if defined(NO_MEMCMP)
#  undef HAVE_MEMCMP
#endif

#if !defined(HAVE_MEMCMP)
#  undef memcmp
#  define memcmp    lzo_memcmp
#endif
#if !defined(HAVE_MEMCPY)
#  undef memcpy
#  define memcpy    lzo_memcpy
#endif
#if !defined(HAVE_MEMMOVE)
#  undef memmove
#  define memmove   lzo_memmove
#endif
#if !defined(HAVE_MEMSET)
#  undef memset
#  define memset    lzo_memset
#endif

#if 0
#  define LZO_BYTE(x)       ((unsigned char) (x))
#else
#  define LZO_BYTE(x)       ((unsigned char) ((x) & 0xff))
#endif

#define LZO_MAX(a,b)        ((a) >= (b) ? (a): (b))
#define LZO_MIN(a,b)        ((a) <= (b) ? (a): (b))
#define LZO_MAX3(a,b,c)     ((a) >= (b) ? LZO_MAX(a,c): LZO_MAX(b,c))
#define LZO_MIN3(a,b,c)     ((a) <= (b) ? LZO_MIN(a,c): LZO_MIN(b,c))

#define lzo_sizeof(type)    ((lzo_uint) (sizeof(type)))

#define LZO_HIGH(array)     ((lzo_uint) (sizeof(array)/sizeof(*(array))))

#define LZO_SIZE(bits)      (1u << (bits))
#define LZO_MASK(bits)      (LZO_SIZE(bits) - 1)

#define LZO_LSIZE(bits)     (1ul << (bits))
#define LZO_LMASK(bits)     (LZO_LSIZE(bits) - 1)

#define LZO_USIZE(bits)     ((lzo_uint) 1 << (bits))
#define LZO_UMASK(bits)     (LZO_USIZE(bits) - 1)

#define LZO_STYPE_MAX(b)    (((1l  << (8*(b)-2)) - 1l)  + (1l  << (8*(b)-2)))
#define LZO_UTYPE_MAX(b)    (((1ul << (8*(b)-1)) - 1ul) + (1ul << (8*(b)-1)))

#if !defined(SIZEOF_UNSIGNED)
#  if (UINT_MAX == 0xffff)
#    define SIZEOF_UNSIGNED         2
#  elif (UINT_MAX == LZO_0xffffffffL)
#    define SIZEOF_UNSIGNED         4
#  elif (UINT_MAX >= LZO_0xffffffffL)
#    define SIZEOF_UNSIGNED         8
#  else
#    error "SIZEOF_UNSIGNED"
#  endif
#endif

#if !defined(SIZEOF_UNSIGNED_LONG)
#  if (ULONG_MAX == LZO_0xffffffffL)
#    define SIZEOF_UNSIGNED_LONG    4
#  elif (ULONG_MAX >= LZO_0xffffffffL)
#    define SIZEOF_UNSIGNED_LONG    8
#  else
#    error "SIZEOF_UNSIGNED_LONG"
#  endif
#endif

#if !defined(SIZEOF_SIZE_T)
#  define SIZEOF_SIZE_T             SIZEOF_UNSIGNED
#endif
#if !defined(SIZE_T_MAX)
#  define SIZE_T_MAX                LZO_UTYPE_MAX(SIZEOF_SIZE_T)
#endif

#if 1 && defined(__LZO_i386) && (UINT_MAX == LZO_0xffffffffL)
#  if !defined(LZO_UNALIGNED_OK_2) && (USHRT_MAX == 0xffff)
#    define LZO_UNALIGNED_OK_2
#  endif
#  if !defined(LZO_UNALIGNED_OK_4) && (LZO_UINT32_MAX == LZO_0xffffffffL)
#    define LZO_UNALIGNED_OK_4
#  endif
#endif

#if defined(LZO_UNALIGNED_OK_2) || defined(LZO_UNALIGNED_OK_4)
#  if !defined(LZO_UNALIGNED_OK)
#    define LZO_UNALIGNED_OK
#  endif
#endif

#if defined(__LZO_NO_UNALIGNED)
#  undef LZO_UNALIGNED_OK
#  undef LZO_UNALIGNED_OK_2
#  undef LZO_UNALIGNED_OK_4
#endif

#if defined(LZO_UNALIGNED_OK_2) && (USHRT_MAX != 0xffff)
#  error "LZO_UNALIGNED_OK_2 must not be defined on this system"
#endif
#if defined(LZO_UNALIGNED_OK_4) && (LZO_UINT32_MAX != LZO_0xffffffffL)
#  error "LZO_UNALIGNED_OK_4 must not be defined on this system"
#endif

#if defined(__LZO_NO_ALIGNED)
#  undef LZO_ALIGNED_OK_4
#endif

#if defined(LZO_ALIGNED_OK_4) && (LZO_UINT32_MAX != LZO_0xffffffffL)
#  error "LZO_ALIGNED_OK_4 must not be defined on this system"
#endif

#define LZO_LITTLE_ENDIAN       1234
#define LZO_BIG_ENDIAN          4321
#define LZO_PDP_ENDIAN          3412

#if !defined(LZO_BYTE_ORDER)
#  if defined(MFX_BYTE_ORDER)
#    define LZO_BYTE_ORDER      MFX_BYTE_ORDER
#  elif defined(__LZO_i386)
#    define LZO_BYTE_ORDER      LZO_LITTLE_ENDIAN
#  elif defined(BYTE_ORDER)
#    define LZO_BYTE_ORDER      BYTE_ORDER
#  elif defined(__BYTE_ORDER)
#    define LZO_BYTE_ORDER      __BYTE_ORDER
#  endif
#endif

#if defined(LZO_BYTE_ORDER)
#  if (LZO_BYTE_ORDER != LZO_LITTLE_ENDIAN) && \
(LZO_BYTE_ORDER != LZO_BIG_ENDIAN)
#    error "invalid LZO_BYTE_ORDER"
#  endif
#endif

#if defined(LZO_UNALIGNED_OK) && !defined(LZO_BYTE_ORDER)
#  error "LZO_BYTE_ORDER is not defined"
#endif

#define LZO_OPTIMIZE_GNUC_i386_IS_BUGGY

#if defined(NDEBUG) && !defined(LZO_DEBUG) && !defined(__LZO_CHECKER)
#  if defined(__GNUC__) && defined(__i386__)
#    if !defined(LZO_OPTIMIZE_GNUC_i386_IS_BUGGY)
#      define LZO_OPTIMIZE_GNUC_i386
#    endif
#  endif
#endif

__LZO_EXTERN_C int __lzo_init_done;
__LZO_EXTERN_C const lzo_byte __lzo_copyright[];
LZO_EXTERN(const lzo_byte *) lzo_copyright(void);
__LZO_EXTERN_C const lzo_uint32 _lzo_crc32_table[256];

#define _LZO_STRINGIZE(x)           #x
#define _LZO_MEXPAND(x)             _LZO_STRINGIZE(x)

#define _LZO_CONCAT2(a,b)           a ## b
#define _LZO_CONCAT3(a,b,c)         a ## b ## c
#define _LZO_CONCAT4(a,b,c,d)       a ## b ## c ## d
#define _LZO_CONCAT5(a,b,c,d,e)     a ## b ## c ## d ## e

#define _LZO_ECONCAT2(a,b)          _LZO_CONCAT2(a,b)
#define _LZO_ECONCAT3(a,b,c)        _LZO_CONCAT3(a,b,c)
#define _LZO_ECONCAT4(a,b,c,d)      _LZO_CONCAT4(a,b,c,d)
#define _LZO_ECONCAT5(a,b,c,d,e)    _LZO_CONCAT5(a,b,c,d,e)

#if 0

#define __LZO_IS_COMPRESS_QUERY(i,il,o,ol,w)    ((lzo_voidp)(o) == (w))
#define __LZO_QUERY_COMPRESS(i,il,o,ol,w,n,s) \
(*ol = (n)*(s), LZO_E_OK)

#define __LZO_IS_DECOMPRESS_QUERY(i,il,o,ol,w)  ((lzo_voidp)(o) == (w))
#define __LZO_QUERY_DECOMPRESS(i,il,o,ol,w,n,s) \
(*ol = (n)*(s), LZO_E_OK)

#define __LZO_IS_OPTIMIZE_QUERY(i,il,o,ol,w)    ((lzo_voidp)(o) == (w))
#define __LZO_QUERY_OPTIMIZE(i,il,o,ol,w,n,s) \
(*ol = (n)*(s), LZO_E_OK)

#endif

#ifndef __LZO_PTR_H
#define __LZO_PTR_H

#ifdef __cplusplus
extern "C" {
#endif

#if defined(__LZO_DOS16) || defined(__LZO_WIN16)
#  include <dos.h>
#  if 1 && defined(__WATCOMC__)
#    include <i86.h>
__LZO_EXTERN_C unsigned char _HShift;
#    define __LZO_HShift    _HShift
#  elif 1 && defined(_MSC_VER)
__LZO_EXTERN_C unsigned short __near _AHSHIFT;
#    define __LZO_HShift    ((unsigned) &_AHSHIFT)
#  elif defined(__LZO_WIN16)
#    define __LZO_HShift    3
#  else
#    define __LZO_HShift    12
#  endif
#  if !defined(_FP_SEG) && defined(FP_SEG)
#    define _FP_SEG         FP_SEG
#  endif
#  if !defined(_FP_OFF) && defined(FP_OFF)
#    define _FP_OFF         FP_OFF
#  endif
#endif

#if !defined(lzo_ptrdiff_t)
#  if (UINT_MAX >= LZO_0xffffffffL)
typedef ptrdiff_t          lzo_ptrdiff_t;
#  else
typedef long               lzo_ptrdiff_t;
#  endif
#endif

#if !defined(__LZO_HAVE_PTR_T)
#  if defined(lzo_ptr_t)
#    define __LZO_HAVE_PTR_T
#  endif
#endif
#if !defined(__LZO_HAVE_PTR_T)
#  if defined(SIZEOF_CHAR_P) && defined(SIZEOF_UNSIGNED_LONG)
#    if (SIZEOF_CHAR_P == SIZEOF_UNSIGNED_LONG)
typedef unsigned long    lzo_ptr_t;
typedef long             lzo_sptr_t;
#      define __LZO_HAVE_PTR_T
#    endif
#  endif
#endif
#if !defined(__LZO_HAVE_PTR_T)
#  if defined(SIZEOF_CHAR_P) && defined(SIZEOF_UNSIGNED)
#    if (SIZEOF_CHAR_P == SIZEOF_UNSIGNED)
typedef unsigned int     lzo_ptr_t;
typedef int              lzo_sptr_t;
#      define __LZO_HAVE_PTR_T
#    endif
#  endif
#endif
#if !defined(__LZO_HAVE_PTR_T)
#  if defined(SIZEOF_CHAR_P) && defined(SIZEOF_UNSIGNED_SHORT)
#    if (SIZEOF_CHAR_P == SIZEOF_UNSIGNED_SHORT)
typedef unsigned short   lzo_ptr_t;
typedef short            lzo_sptr_t;
#      define __LZO_HAVE_PTR_T
#    endif
#  endif
#endif
#if !defined(__LZO_HAVE_PTR_T)
#  if defined(LZO_HAVE_CONFIG_H) || defined(SIZEOF_CHAR_P)
#    error "no suitable type for lzo_ptr_t"
#  else
typedef unsigned long      lzo_ptr_t;
typedef long               lzo_sptr_t;
#    define __LZO_HAVE_PTR_T
#  endif
#endif

#if defined(__LZO_DOS16) || defined(__LZO_WIN16)
#define PTR(a)              ((lzo_bytep) (a))
#define PTR_ALIGNED_4(a)    ((_FP_OFF(a) & 3) == 0)
#define PTR_ALIGNED2_4(a,b) (((_FP_OFF(a) | _FP_OFF(b)) & 3) == 0)
#else
#define PTR(a)              ((lzo_ptr_t) (a))
#define PTR_LINEAR(a)       PTR(a)
#define PTR_ALIGNED_4(a)    ((PTR_LINEAR(a) & 3) == 0)
#define PTR_ALIGNED_8(a)    ((PTR_LINEAR(a) & 7) == 0)
#define PTR_ALIGNED2_4(a,b) (((PTR_LINEAR(a) | PTR_LINEAR(b)) & 3) == 0)
#define PTR_ALIGNED2_8(a,b) (((PTR_LINEAR(a) | PTR_LINEAR(b)) & 7) == 0)
#endif

#define PTR_LT(a,b)         (PTR(a) < PTR(b))
#define PTR_GE(a,b)         (PTR(a) >= PTR(b))
#define PTR_DIFF(a,b)       ((lzo_ptrdiff_t) (PTR(a) - PTR(b)))
#define pd(a,b)             ((lzo_uint) ((a)-(b)))

LZO_EXTERN(lzo_ptr_t)
__lzo_ptr_linear(const lzo_voidp ptr);

typedef union LZO_FULL_ALIGN_T
{
char            a_char;
unsigned char   a_uchar;
short           a_short;
unsigned short  a_ushort;
int             a_int;
unsigned int    a_uint;
long            a_long;
unsigned long   a_ulong;
lzo_int         a_lzo_int;
lzo_uint        a_lzo_uint;
lzo_int32       a_lzo_int32;
lzo_uint32      a_lzo_uint32;
ptrdiff_t       a_ptrdiff_t;
lzo_ptrdiff_t   a_lzo_ptrdiff_t;
lzo_ptr_t       a_lzo_ptr_t;
lzo_voidp       a_lzo_voidp;
void *          a_void_p;
lzo_bytep       a_lzo_bytep;
lzo_bytepp      a_lzo_bytepp;
lzo_uintp       a_lzo_uintp;
lzo_uint *      a_lzo_uint_p;
lzo_uint32p     a_lzo_uint32p;
lzo_uint32 *    a_lzo_uint32_p;
unsigned char * a_uchar_p;
char *          a_char_p;
}
lzo_full_align_t;

#ifdef __cplusplus
}
#endif

#endif

#define LZO_DETERMINISTIC

#define LZO_DICT_USE_PTR
#if defined(__LZO_DOS16) || defined(__LZO_WIN16) || defined(__LZO_STRICT_16BIT)
#  undef LZO_DICT_USE_PTR
#endif

#if defined(LZO_DICT_USE_PTR)
#  define lzo_dict_t    const lzo_bytep
#  define lzo_dict_p    lzo_dict_t __LZO_MMODEL *
#else
#  define lzo_dict_t    lzo_uint
#  define lzo_dict_p    lzo_dict_t __LZO_MMODEL *
#endif

#if !defined(lzo_moff_t)
#define lzo_moff_t      lzo_uint
#endif

#endif

LZO_PUBLIC(lzo_ptr_t)
__lzo_ptr_linear(const lzo_voidp ptr)
{
lzo_ptr_t p;

#if defined(__LZO_DOS16) || defined(__LZO_WIN16)
p = (((lzo_ptr_t)(_FP_SEG(ptr))) << (16 - __LZO_HShift)) + (_FP_OFF(ptr));
#else
p = PTR_LINEAR(ptr);
#endif

return p;
}

LZO_PUBLIC(unsigned)
__lzo_align_gap(const lzo_voidp ptr, lzo_uint size)
{
lzo_ptr_t p, s, n;

assert(size > 0);

p = __lzo_ptr_linear(ptr);
s = (lzo_ptr_t) (size - 1);
#if 0
assert((size & (size - 1)) == 0);
n = ((p + s) & ~s) - p;
#else
n = (((p + s) / size) * size) - p;
#endif

assert((long)n >= 0);
assert(n <= s);

return (unsigned)n;
}

#ifndef __LZO_UTIL_H
#define __LZO_UTIL_H

#ifndef __LZO_CONF_H
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if 1 && defined(HAVE_MEMCPY)
#if !defined(__LZO_DOS16) && !defined(__LZO_WIN16)

#define MEMCPY8_DS(dest,src,len) \
memcpy(dest,src,len); \
dest += len; \
src += len

#endif
#endif

#if 0 && !defined(MEMCPY8_DS)

#define MEMCPY8_DS(dest,src,len) \
{ do { \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
len -= 8; \
} while (len > 0); }

#endif

#if !defined(MEMCPY8_DS)

#define MEMCPY8_DS(dest,src,len) \
{ register lzo_uint __l = (len) / 8; \
do { \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
*dest++ = *src++; \
} while (--__l > 0); }

#endif

#define MEMCPY_DS(dest,src,len) \
do *dest++ = *src++; \
while (--len > 0)

#define MEMMOVE_DS(dest,src,len) \
do *dest++ = *src++; \
while (--len > 0)

#if 0 && defined(LZO_OPTIMIZE_GNUC_i386)

#define BZERO8_PTR(s,l,n) \
__asm__ __volatile__( \
"movl  %0,%%eax \n"             \
"movl  %1,%%edi \n"             \
"movl  %2,%%ecx \n"             \
"cld \n"                        \
"rep \n"                        \
"stosl %%eax,(%%edi) \n"        \
:               \
:"g" (0),"g" (s),"g" (n)        \
:"eax","edi","ecx", "memory", "cc" \
)

#elif (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMSET)

#if 1
#define BZERO8_PTR(s,l,n)   memset((s),0,(lzo_uint)(l)*(n))
#else
#define BZERO8_PTR(s,l,n)   memset((lzo_voidp)(s),0,(lzo_uint)(l)*(n))
#endif

#else

#define BZERO8_PTR(s,l,n) \
lzo_memset((lzo_voidp)(s),0,(lzo_uint)(l)*(n))

#endif

#if 0
#if defined(__GNUC__) && defined(__i386__)

unsigned char lzo_rotr8(unsigned char value, int shift);
extern __inline__ unsigned char lzo_rotr8(unsigned char value, int shift)
{
unsigned char result;

__asm__ __volatile__ ("movb %b1, %b0; rorb %b2, %b0"
: "=a"(result): "g"(value), "c"(shift));
return result;
}

unsigned short lzo_rotr16(unsigned short value, int shift);
extern __inline__ unsigned short lzo_rotr16(unsigned short value, int shift)
{
unsigned short result;

__asm__ __volatile__ ("movw %b1, %b0; rorw %b2, %b0"
: "=a"(result): "g"(value), "c"(shift));
return result;
}

#endif
#endif

#ifdef __cplusplus
}
#endif

#endif

LZO_PUBLIC(lzo_bool)
lzo_assert(int expr)
{
return (expr) ? 1: 0;
}

/* If you use the LZO library in a product, you *must* keep this
* copyright string in the executable of your product.
*/

const lzo_byte __lzo_copyright[] =
#if !defined(__LZO_IN_MINLZO)
LZO_VERSION_STRING;
#else
"\n\n\n"
"LZO real-time data compression library.\n"
"Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002 Markus Franz Xaver Johannes Oberhumer\n"
"<markus.oberhumer@jk.uni-linz.ac.at>\n"
"http://www.oberhumer.com/opensource/lzo/\n"
"\n"
"LZO version: v" LZO_VERSION_STRING ", " LZO_VERSION_DATE "\n"
"LZO build date: " __DATE__ " " __TIME__ "\n\n"
"LZO special compilation options:\n"
#ifdef __cplusplus
" __cplusplus\n"
#endif
#if defined(__PIC__)
" __PIC__\n"
#elif defined(__pic__)
" __pic__\n"
#endif
#if (UINT_MAX < LZO_0xffffffffL)
" 16BIT\n"
#endif
#if defined(__LZO_STRICT_16BIT)
" __LZO_STRICT_16BIT\n"
#endif
#if (UINT_MAX > LZO_0xffffffffL)
" UINT_MAX=" _LZO_MEXPAND(UINT_MAX) "\n"
#endif
#if (ULONG_MAX > LZO_0xffffffffL)
" ULONG_MAX=" _LZO_MEXPAND(ULONG_MAX) "\n"
#endif
#if defined(LZO_BYTE_ORDER)
" LZO_BYTE_ORDER=" _LZO_MEXPAND(LZO_BYTE_ORDER) "\n"
#endif
#if defined(LZO_UNALIGNED_OK_2)
" LZO_UNALIGNED_OK_2\n"
#endif
#if defined(LZO_UNALIGNED_OK_4)
" LZO_UNALIGNED_OK_4\n"
#endif
#if defined(LZO_ALIGNED_OK_4)
" LZO_ALIGNED_OK_4\n"
#endif
#if defined(LZO_DICT_USE_PTR)
" LZO_DICT_USE_PTR\n"
#endif
#if defined(__LZO_QUERY_COMPRESS)
" __LZO_QUERY_COMPRESS\n"
#endif
#if defined(__LZO_QUERY_DECOMPRESS)
" __LZO_QUERY_DECOMPRESS\n"
#endif
#if defined(__LZO_IN_MINILZO)
" __LZO_IN_MINILZO\n"
#endif
"\n\n"
"$Id: LZO " LZO_VERSION_STRING " built " __DATE__ " " __TIME__
#if defined(__GNUC__) && defined(__VERSION__)
" by gcc " __VERSION__
#elif defined(__BORLANDC__)
" by Borland C " _LZO_MEXPAND(__BORLANDC__)
#elif defined(_MSC_VER)
" by Microsoft C " _LZO_MEXPAND(_MSC_VER)
#elif defined(__PUREC__)
" by Pure C " _LZO_MEXPAND(__PUREC__)
#elif defined(__SC__)
" by Symantec C " _LZO_MEXPAND(__SC__)
#elif defined(__TURBOC__)
" by Turbo C " _LZO_MEXPAND(__TURBOC__)
#elif defined(__WATCOMC__)
" by Watcom C " _LZO_MEXPAND(__WATCOMC__)
#endif
" $\n"
"$Copyright: LZO (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002 Markus Franz Xaver Johannes Oberhumer $\n";
#endif

LZO_PUBLIC(const lzo_byte *)
lzo_copyright(void)
{
return __lzo_copyright;
}

LZO_PUBLIC(unsigned)
lzo_version(void)
{
return LZO_VERSION;
}

LZO_PUBLIC(const char *)
lzo_version_string(void)
{
return LZO_VERSION_STRING;
}

LZO_PUBLIC(const char *)
lzo_version_date(void)
{
return LZO_VERSION_DATE;
}

LZO_PUBLIC(const lzo_charp)
_lzo_version_string(void)
{
return LZO_VERSION_STRING;
}

LZO_PUBLIC(const lzo_charp)
_lzo_version_date(void)
{
return LZO_VERSION_DATE;
}

#define LZO_BASE 65521u
#define LZO_NMAX 5552

#define LZO_DO1(buf,i)  {s1 += buf[i]; s2 += s1;}
#define LZO_DO2(buf,i)  LZO_DO1(buf,i); LZO_DO1(buf,i+1);
#define LZO_DO4(buf,i)  LZO_DO2(buf,i); LZO_DO2(buf,i+2);
#define LZO_DO8(buf,i)  LZO_DO4(buf,i); LZO_DO4(buf,i+4);
#define LZO_DO16(buf,i) LZO_DO8(buf,i); LZO_DO8(buf,i+8);

LZO_PUBLIC(lzo_uint32)
lzo_adler32(lzo_uint32 adler, const lzo_byte *buf, lzo_uint len)
{
lzo_uint32 s1 = adler & 0xffff;
lzo_uint32 s2 = (adler >> 16) & 0xffff;
int k;

if (buf == NULL)
return 1;

while (len > 0)
{
k = len < LZO_NMAX ? (int) len: LZO_NMAX;
len -= k;
if (k >= 16) do
{
LZO_DO16(buf,0);
buf += 16;
k -= 16;
} while (k >= 16);
if (k != 0) do
{
s1 += *buf++;
s2 += s1;
} while (--k > 0);
s1 %= LZO_BASE;
s2 %= LZO_BASE;
}
return (s2 << 16) | s1;
}

LZO_PUBLIC(int)
lzo_memcmp(const lzo_voidp s1, const lzo_voidp s2, lzo_uint len)
{
#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMCMP)
return memcmp(s1,s2,len);
#else
const lzo_byte *p1 = (const lzo_byte *) s1;
const lzo_byte *p2 = (const lzo_byte *) s2;
int d;

if (len > 0) do
{
d = *p1 - *p2;
if (d != 0)
return d;
p1++;
p2++;
}
while (--len > 0);
return 0;
#endif
}

LZO_PUBLIC(lzo_voidp)
lzo_memcpy(lzo_voidp dest, const lzo_voidp src, lzo_uint len)
{
#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMCPY)
return memcpy(dest,src,len);
#else
lzo_byte *p1 = (lzo_byte *) dest;
const lzo_byte *p2 = (const lzo_byte *) src;

if (len <= 0 || p1 == p2)
return dest;
do
*p1++ = *p2++;
while (--len > 0);
return dest;
#endif
}

LZO_PUBLIC(lzo_voidp)
lzo_memmove(lzo_voidp dest, const lzo_voidp src, lzo_uint len)
{
#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMMOVE)
return memmove(dest,src,len);
#else
lzo_byte *p1 = (lzo_byte *) dest;
const lzo_byte *p2 = (const lzo_byte *) src;

if (len <= 0 || p1 == p2)
return dest;

if (p1 < p2)
{
do
*p1++ = *p2++;
while (--len > 0);
}
else
{
p1 += len;
p2 += len;
do
*--p1 = *--p2;
while (--len > 0);
}
return dest;
#endif
}

LZO_PUBLIC(lzo_voidp)
lzo_memset(lzo_voidp s, int c, lzo_uint len)
{
#if (LZO_UINT_MAX <= SIZE_T_MAX) && defined(HAVE_MEMSET)
return memset(s,c,len);
#else
lzo_byte *p = (lzo_byte *) s;

if (len > 0) do
*p++ = LZO_BYTE(c);
while (--len > 0);
return s;
#endif
}

#if 0
#  define IS_SIGNED(type)       (((type) (1ul << (8 * sizeof(type) - 1))) < 0)
#  define IS_UNSIGNED(type)     (((type) (1ul << (8 * sizeof(type) - 1))) > 0)
#else
#  define IS_SIGNED(type)       (((type) (-1)) < ((type) 0))
#  define IS_UNSIGNED(type)     (((type) (-1)) > ((type) 0))
#endif

#define IS_POWER_OF_2(x)        (((x) & ((x) - 1)) == 0)

static lzo_bool schedule_insns_bug(void);
static lzo_bool strength_reduce_bug(int *);

#if 0 || defined(LZO_DEBUG)
#include <stdio.h>
static lzo_bool __lzo_assert_fail(const char *s, unsigned line)
{
#if defined(__palmos__)
printf("LZO assertion failed in line %u: '%s'\n",line,s);
#else
fprintf(stderr,"LZO assertion failed in line %u: '%s'\n",line,s);
#endif
return 0;
}
#  define __lzo_assert(x)   ((x) ? 1: __lzo_assert_fail(#x,__LINE__))
#else
#  define __lzo_assert(x)   ((x) ? 1: 0)
#endif

#undef COMPILE_TIME_ASSERT
#if 0
#  define COMPILE_TIME_ASSERT(expr)     r &= __lzo_assert(expr)
#else
#  define COMPILE_TIME_ASSERT(expr)     LZO_COMPILE_TIME_ASSERT(expr)
#endif

static lzo_bool basic_integral_check(void)
{
lzo_bool r = 1;

COMPILE_TIME_ASSERT(CHAR_BIT == 8);
COMPILE_TIME_ASSERT(sizeof(char) == 1);
COMPILE_TIME_ASSERT(sizeof(short) >= 2);
COMPILE_TIME_ASSERT(sizeof(long) >= 4);
COMPILE_TIME_ASSERT(sizeof(int) >= sizeof(short));
COMPILE_TIME_ASSERT(sizeof(long) >= sizeof(int));

COMPILE_TIME_ASSERT(sizeof(lzo_uint) == sizeof(lzo_int));
COMPILE_TIME_ASSERT(sizeof(lzo_uint32) == sizeof(lzo_int32));

COMPILE_TIME_ASSERT(sizeof(lzo_uint32) >= 4);
COMPILE_TIME_ASSERT(sizeof(lzo_uint32) >= sizeof(unsigned));
#if defined(__LZO_STRICT_16BIT)
COMPILE_TIME_ASSERT(sizeof(lzo_uint) == 2);
#else
COMPILE_TIME_ASSERT(sizeof(lzo_uint) >= 4);
COMPILE_TIME_ASSERT(sizeof(lzo_uint) >= sizeof(unsigned));
#endif

#if (USHRT_MAX == 65535u)
COMPILE_TIME_ASSERT(sizeof(short) == 2);
#elif (USHRT_MAX == LZO_0xffffffffL)
COMPILE_TIME_ASSERT(sizeof(short) == 4);
#elif (USHRT_MAX >= LZO_0xffffffffL)
COMPILE_TIME_ASSERT(sizeof(short) > 4);
#endif
#if (UINT_MAX == 65535u)
COMPILE_TIME_ASSERT(sizeof(int) == 2);
#elif (UINT_MAX == LZO_0xffffffffL)
COMPILE_TIME_ASSERT(sizeof(int) == 4);
#elif (UINT_MAX >= LZO_0xffffffffL)
COMPILE_TIME_ASSERT(sizeof(int) > 4);
#endif
#if (ULONG_MAX == 65535ul)
COMPILE_TIME_ASSERT(sizeof(long) == 2);
#elif (ULONG_MAX == LZO_0xffffffffL)
COMPILE_TIME_ASSERT(sizeof(long) == 4);
#elif (ULONG_MAX >= LZO_0xffffffffL)
COMPILE_TIME_ASSERT(sizeof(long) > 4);
#endif

#if defined(SIZEOF_UNSIGNED)
COMPILE_TIME_ASSERT(SIZEOF_UNSIGNED == sizeof(unsigned));
#endif
#if defined(SIZEOF_UNSIGNED_LONG)
COMPILE_TIME_ASSERT(SIZEOF_UNSIGNED_LONG == sizeof(unsigned long));
#endif
#if defined(SIZEOF_UNSIGNED_SHORT)
COMPILE_TIME_ASSERT(SIZEOF_UNSIGNED_SHORT == sizeof(unsigned short));
#endif
#if !defined(__LZO_IN_MINILZO)
#if defined(SIZEOF_SIZE_T)
COMPILE_TIME_ASSERT(SIZEOF_SIZE_T == sizeof(size_t));
#endif
#endif

COMPILE_TIME_ASSERT(IS_UNSIGNED(unsigned char));
COMPILE_TIME_ASSERT(IS_UNSIGNED(unsigned short));
COMPILE_TIME_ASSERT(IS_UNSIGNED(unsigned));
COMPILE_TIME_ASSERT(IS_UNSIGNED(unsigned long));
COMPILE_TIME_ASSERT(IS_SIGNED(short));
COMPILE_TIME_ASSERT(IS_SIGNED(int));
COMPILE_TIME_ASSERT(IS_SIGNED(long));

COMPILE_TIME_ASSERT(IS_UNSIGNED(lzo_uint32));
COMPILE_TIME_ASSERT(IS_UNSIGNED(lzo_uint));
COMPILE_TIME_ASSERT(IS_SIGNED(lzo_int32));
COMPILE_TIME_ASSERT(IS_SIGNED(lzo_int));

COMPILE_TIME_ASSERT(INT_MAX    == LZO_STYPE_MAX(sizeof(int)));
COMPILE_TIME_ASSERT(UINT_MAX   == LZO_UTYPE_MAX(sizeof(unsigned)));
COMPILE_TIME_ASSERT(LONG_MAX   == LZO_STYPE_MAX(sizeof(long)));
COMPILE_TIME_ASSERT(ULONG_MAX  == LZO_UTYPE_MAX(sizeof(unsigned long)));
COMPILE_TIME_ASSERT(SHRT_MAX   == LZO_STYPE_MAX(sizeof(short)));
COMPILE_TIME_ASSERT(USHRT_MAX  == LZO_UTYPE_MAX(sizeof(unsigned short)));
COMPILE_TIME_ASSERT(LZO_UINT32_MAX == LZO_UTYPE_MAX(sizeof(lzo_uint32)));
COMPILE_TIME_ASSERT(LZO_UINT_MAX   == LZO_UTYPE_MAX(sizeof(lzo_uint)));
#if !defined(__LZO_IN_MINILZO)
COMPILE_TIME_ASSERT(SIZE_T_MAX     == LZO_UTYPE_MAX(sizeof(size_t)));
#endif

r &= __lzo_assert(LZO_BYTE(257) == 1);

return r;
}

static lzo_bool basic_ptr_check(void)
{
lzo_bool r = 1;

COMPILE_TIME_ASSERT(sizeof(char *) >= sizeof(int));
COMPILE_TIME_ASSERT(sizeof(lzo_byte *) >= sizeof(char *));

COMPILE_TIME_ASSERT(sizeof(lzo_voidp) == sizeof(lzo_byte *));
COMPILE_TIME_ASSERT(sizeof(lzo_voidp) == sizeof(lzo_voidpp));
COMPILE_TIME_ASSERT(sizeof(lzo_voidp) == sizeof(lzo_bytepp));
COMPILE_TIME_ASSERT(sizeof(lzo_voidp) >= sizeof(lzo_uint));

COMPILE_TIME_ASSERT(sizeof(lzo_ptr_t) == sizeof(lzo_voidp));
COMPILE_TIME_ASSERT(sizeof(lzo_ptr_t) == sizeof(lzo_sptr_t));
COMPILE_TIME_ASSERT(sizeof(lzo_ptr_t) >= sizeof(lzo_uint));

COMPILE_TIME_ASSERT(sizeof(lzo_ptrdiff_t) >= 4);
COMPILE_TIME_ASSERT(sizeof(lzo_ptrdiff_t) >= sizeof(ptrdiff_t));

COMPILE_TIME_ASSERT(sizeof(ptrdiff_t) >= sizeof(size_t));
COMPILE_TIME_ASSERT(sizeof(lzo_ptrdiff_t) >= sizeof(lzo_uint));

#if defined(SIZEOF_CHAR_P)
COMPILE_TIME_ASSERT(SIZEOF_CHAR_P == sizeof(char *));
#endif
#if defined(SIZEOF_PTRDIFF_T)
COMPILE_TIME_ASSERT(SIZEOF_PTRDIFF_T == sizeof(ptrdiff_t));
#endif

COMPILE_TIME_ASSERT(IS_SIGNED(ptrdiff_t));
COMPILE_TIME_ASSERT(IS_UNSIGNED(size_t));
COMPILE_TIME_ASSERT(IS_SIGNED(lzo_ptrdiff_t));
COMPILE_TIME_ASSERT(IS_SIGNED(lzo_sptr_t));
COMPILE_TIME_ASSERT(IS_UNSIGNED(lzo_ptr_t));
COMPILE_TIME_ASSERT(IS_UNSIGNED(lzo_moff_t));

return r;
}

static lzo_bool ptr_check(void)
{
lzo_bool r = 1;
int i;
char _wrkmem[10 * sizeof(lzo_byte *) + sizeof(lzo_full_align_t)];
lzo_bytep wrkmem;
lzo_bytepp dict;
unsigned char x[4 * sizeof(lzo_full_align_t)];
long d;
lzo_full_align_t a;
lzo_full_align_t u;

for (i = 0; i < (int) sizeof(x); i++)
x[i] = LZO_BYTE(i);

wrkmem = LZO_PTR_ALIGN_UP((lzo_byte *)_wrkmem,sizeof(lzo_full_align_t));

#if 0
dict = (lzo_bytepp) wrkmem;
#else

u.a_lzo_bytep = wrkmem; dict = u.a_lzo_bytepp;
#endif

d = (long) ((const lzo_bytep) dict - (const lzo_bytep) _wrkmem);
r &= __lzo_assert(d >= 0);
r &= __lzo_assert(d < (long) sizeof(lzo_full_align_t));

memset(&a,0,sizeof(a));
r &= __lzo_assert(a.a_lzo_voidp == NULL);

memset(&a,0xff,sizeof(a));
r &= __lzo_assert(a.a_ushort == USHRT_MAX);
r &= __lzo_assert(a.a_uint == UINT_MAX);
r &= __lzo_assert(a.a_ulong == ULONG_MAX);
r &= __lzo_assert(a.a_lzo_uint == LZO_UINT_MAX);
r &= __lzo_assert(a.a_lzo_uint32 == LZO_UINT32_MAX);

if (r == 1)
{
for (i = 0; i < 8; i++)
r &= __lzo_assert((const lzo_voidp) (&dict[i]) == (const lzo_voidp) (&wrkmem[i * sizeof(lzo_byte *)]));
}

memset(&a,0,sizeof(a));
r &= __lzo_assert(a.a_char_p == NULL);
r &= __lzo_assert(a.a_lzo_bytep == NULL);
r &= __lzo_assert(NULL == (void *)0);
if (r == 1)
{
for (i = 0; i < 10; i++)
dict[i] = wrkmem;
BZERO8_PTR(dict+1,sizeof(dict[0]),8);
r &= __lzo_assert(dict[0] == wrkmem);
for (i = 1; i < 9; i++)
r &= __lzo_assert(dict[i] == NULL);
r &= __lzo_assert(dict[9] == wrkmem);
}

if (r == 1)
{
unsigned k = 1;
const unsigned n = (unsigned) sizeof(lzo_uint32);
lzo_byte *p0;
lzo_byte *p1;

k += __lzo_align_gap(&x[k],n);
p0 = (lzo_bytep) &x[k];
#if defined(PTR_LINEAR)
r &= __lzo_assert((PTR_LINEAR(p0) & (n-1)) == 0);
#else
r &= __lzo_assert(n == 4);
r &= __lzo_assert(PTR_ALIGNED_4(p0));
#endif

r &= __lzo_assert(k >= 1);
p1 = (lzo_bytep) &x[1];
r &= __lzo_assert(PTR_GE(p0,p1));

r &= __lzo_assert(k < 1+n);
p1 = (lzo_bytep) &x[1+n];
r &= __lzo_assert(PTR_LT(p0,p1));

if (r == 1)
{
lzo_uint32 v0, v1;
#if 0
v0 = * (lzo_uint32 *) &x[k];
v1 = * (lzo_uint32 *) &x[k+n];
#else

u.a_uchar_p = &x[k];
v0 = *u.a_lzo_uint32_p;
u.a_uchar_p = &x[k+n];
v1 = *u.a_lzo_uint32_p;
#endif
r &= __lzo_assert(v0 > 0);
r &= __lzo_assert(v1 > 0);
}
}

return r;
}

LZO_PUBLIC(int)
_lzo_config_check(void)
{
lzo_bool r = 1;
int i;
union {
lzo_uint32 a;
unsigned short b;
lzo_uint32 aa[4];
unsigned char x[4*sizeof(lzo_full_align_t)];
} u;

COMPILE_TIME_ASSERT( (int) ((unsigned char) ((signed char) -1)) == 255);
COMPILE_TIME_ASSERT( (((unsigned char)128) << (int)(8*sizeof(int)-8)) < 0);

#if 0
r &= __lzo_assert((const void *)&u == (const void *)&u.a);
r &= __lzo_assert((const void *)&u == (const void *)&u.b);
r &= __lzo_assert((const void *)&u == (const void *)&u.x[0]);
r &= __lzo_assert((const void *)&u == (const void *)&u.aa[0]);
#endif

r &= basic_integral_check();
r &= basic_ptr_check();
if (r != 1)
return LZO_E_ERROR;

u.a = 0; u.b = 0;
for (i = 0; i < (int) sizeof(u.x); i++)
u.x[i] = LZO_BYTE(i);

#if defined(LZO_BYTE_ORDER)
if (r == 1)
{
#  if (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
lzo_uint32 a = (lzo_uint32) (u.a & LZO_0xffffffffL);
unsigned short b = (unsigned short) (u.b & 0xffff);
r &= __lzo_assert(a == 0x03020100L);
r &= __lzo_assert(b == 0x0100);
#  elif (LZO_BYTE_ORDER == LZO_BIG_ENDIAN)
lzo_uint32 a = u.a >> (8 * sizeof(u.a) - 32);
unsigned short b = u.b >> (8 * sizeof(u.b) - 16);
r &= __lzo_assert(a == 0x00010203L);
r &= __lzo_assert(b == 0x0001);
#  else
#    error "invalid LZO_BYTE_ORDER"
#  endif
}
#endif

#if defined(LZO_UNALIGNED_OK_2)
COMPILE_TIME_ASSERT(sizeof(short) == 2);
if (r == 1)
{
unsigned short b[4];

for (i = 0; i < 4; i++)
b[i] = * (const unsigned short *) &u.x[i];

#  if (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
r &= __lzo_assert(b[0] == 0x0100);
r &= __lzo_assert(b[1] == 0x0201);
r &= __lzo_assert(b[2] == 0x0302);
r &= __lzo_assert(b[3] == 0x0403);
#  elif (LZO_BYTE_ORDER == LZO_BIG_ENDIAN)
r &= __lzo_assert(b[0] == 0x0001);
r &= __lzo_assert(b[1] == 0x0102);
r &= __lzo_assert(b[2] == 0x0203);
r &= __lzo_assert(b[3] == 0x0304);
#  endif
}
#endif

#if defined(LZO_UNALIGNED_OK_4)
COMPILE_TIME_ASSERT(sizeof(lzo_uint32) == 4);
if (r == 1)
{
lzo_uint32 a[4];

for (i = 0; i < 4; i++)
a[i] = * (const lzo_uint32 *) &u.x[i];

#  if (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
r &= __lzo_assert(a[0] == 0x03020100L);
r &= __lzo_assert(a[1] == 0x04030201L);
r &= __lzo_assert(a[2] == 0x05040302L);
r &= __lzo_assert(a[3] == 0x06050403L);
#  elif (LZO_BYTE_ORDER == LZO_BIG_ENDIAN)
r &= __lzo_assert(a[0] == 0x00010203L);
r &= __lzo_assert(a[1] == 0x01020304L);
r &= __lzo_assert(a[2] == 0x02030405L);
r &= __lzo_assert(a[3] == 0x03040506L);
#  endif
}
#endif

#if defined(LZO_ALIGNED_OK_4)
COMPILE_TIME_ASSERT(sizeof(lzo_uint32) == 4);
#endif

COMPILE_TIME_ASSERT(lzo_sizeof_dict_t == sizeof(lzo_dict_t));

#if defined(__LZO_IN_MINLZO)
if (r == 1)
{
lzo_uint32 adler;
adler = lzo_adler32(0, NULL, 0);
adler = lzo_adler32(adler, lzo_copyright(), 200);
r &= __lzo_assert(adler == 0xc76f1751L);
}
#endif

if (r == 1)
{
r &= __lzo_assert(!schedule_insns_bug());
}

if (r == 1)
{
static int x[3];
static unsigned xn = 3;
unsigned j;

for (j = 0; j < xn; j++)
x[j] = (int)j - 3;
r &= __lzo_assert(!strength_reduce_bug(x));
}

if (r == 1)
{
r &= ptr_check();
}

return r == 1 ? LZO_E_OK: LZO_E_ERROR;
}

static lzo_bool schedule_insns_bug(void)
{
#if defined(__LZO_CHECKER)
return 0;
#else
const int clone[] = {1, 2, 0};
const int *q;
q = clone;
return (*q) ? 0: 1;
#endif
}

static lzo_bool strength_reduce_bug(int *x)
{
return x[0] != -3 || x[1] != -2 || x[2] != -1;
}

#undef COMPILE_TIME_ASSERT

int __lzo_init_done = 0;

LZO_PUBLIC(int)
__lzo_init2(unsigned v, int s1, int s2, int s3, int s4, int s5,
int s6, int s7, int s8, int s9)
{
int r;

__lzo_init_done = 1;

if (v == 0)
return LZO_E_ERROR;

r = (s1 == -1 || s1 == (int) sizeof(short)) &&
(s2 == -1 || s2 == (int) sizeof(int)) &&
(s3 == -1 || s3 == (int) sizeof(long)) &&
(s4 == -1 || s4 == (int) sizeof(lzo_uint32)) &&
(s5 == -1 || s5 == (int) sizeof(lzo_uint)) &&
(s6 == -1 || s6 == (int) lzo_sizeof_dict_t) &&
(s7 == -1 || s7 == (int) sizeof(char *)) &&
(s8 == -1 || s8 == (int) sizeof(lzo_voidp)) &&
(s9 == -1 || s9 == (int) sizeof(lzo_compress_t));
if (!r)
return LZO_E_ERROR;

r = _lzo_config_check();
if (r != LZO_E_OK)
return r;

return r;
}

#if !defined(__LZO_IN_MINILZO)

LZO_EXTERN(int)
__lzo_init(unsigned v,int s1,int s2,int s3,int s4,int s5,int s6,int s7);

LZO_PUBLIC(int)
__lzo_init(unsigned v,int s1,int s2,int s3,int s4,int s5,int s6,int s7)
{
if (v == 0 || v > 0x1010)
return LZO_E_ERROR;
return __lzo_init2(v,s1,s2,s3,s4,s5,-1,-1,s6,s7);
}

#endif

#define do_compress         _lzo1x_1_do_compress

#define LZO_NEED_DICT_H
#define D_BITS          14
#define D_INDEX1(d,p)       d = DM((0x21*DX3(p,5,5,6)) >> 5)
#define D_INDEX2(d,p)       d = (d & (D_MASK & 0x7ff)) ^ (D_HIGH | 0x1f)

#ifndef __LZO_CONFIG1X_H
#define __LZO_CONFIG1X_H

#if !defined(LZO1X) && !defined(LZO1Y) && !defined(LZO1Z)
#  define LZO1X
#endif

#if !defined(__LZO_IN_MINILZO)
#include <lzo1x.h>
#endif

#define LZO_EOF_CODE
#undef LZO_DETERMINISTIC

#define M1_MAX_OFFSET   0x0400
#ifndef M2_MAX_OFFSET
#define M2_MAX_OFFSET   0x0800
#endif
#define M3_MAX_OFFSET   0x4000
#define M4_MAX_OFFSET   0xbfff

#define MX_MAX_OFFSET   (M1_MAX_OFFSET + M2_MAX_OFFSET)

#define M1_MIN_LEN      2
#define M1_MAX_LEN      2
#define M2_MIN_LEN      3
#ifndef M2_MAX_LEN
#define M2_MAX_LEN      8
#endif
#define M3_MIN_LEN      3
#define M3_MAX_LEN      33
#define M4_MIN_LEN      3
#define M4_MAX_LEN      9

#define M1_MARKER       0
#define M2_MARKER       64
#define M3_MARKER       32
#define M4_MARKER       16

#ifndef MIN_LOOKAHEAD
#define MIN_LOOKAHEAD       (M2_MAX_LEN + 1)
#endif

#if defined(LZO_NEED_DICT_H)

#ifndef LZO_HASH
#define LZO_HASH            LZO_HASH_LZO_INCREMENTAL_B
#endif
#define DL_MIN_LEN          M2_MIN_LEN

#ifndef __LZO_DICT_H
#define __LZO_DICT_H

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(D_BITS) && defined(DBITS)
#  define D_BITS        DBITS
#endif
#if !defined(D_BITS)
#  error "D_BITS is not defined"
#endif
#if (D_BITS < 16)
#  define D_SIZE        LZO_SIZE(D_BITS)
#  define D_MASK        LZO_MASK(D_BITS)
#else
#  define D_SIZE        LZO_USIZE(D_BITS)
#  define D_MASK        LZO_UMASK(D_BITS)
#endif
#define D_HIGH          ((D_MASK >> 1) + 1)

#if !defined(DD_BITS)
#  define DD_BITS       0
#endif
#define DD_SIZE         LZO_SIZE(DD_BITS)
#define DD_MASK         LZO_MASK(DD_BITS)

#if !defined(DL_BITS)
#  define DL_BITS       (D_BITS - DD_BITS)
#endif
#if (DL_BITS < 16)
#  define DL_SIZE       LZO_SIZE(DL_BITS)
#  define DL_MASK       LZO_MASK(DL_BITS)
#else
#  define DL_SIZE       LZO_USIZE(DL_BITS)
#  define DL_MASK       LZO_UMASK(DL_BITS)
#endif

#if (D_BITS != DL_BITS + DD_BITS)
#  error "D_BITS does not match"
#endif
#if (D_BITS < 8 || D_BITS > 18)
#  error "invalid D_BITS"
#endif
#if (DL_BITS < 8 || DL_BITS > 20)
#  error "invalid DL_BITS"
#endif
#if (DD_BITS < 0 || DD_BITS > 6)
#  error "invalid DD_BITS"
#endif

#if !defined(DL_MIN_LEN)
#  define DL_MIN_LEN    3
#endif
#if !defined(DL_SHIFT)
#  define DL_SHIFT      ((DL_BITS + (DL_MIN_LEN - 1)) / DL_MIN_LEN)
#endif

#define LZO_HASH_GZIP                   1
#define LZO_HASH_GZIP_INCREMENTAL       2
#define LZO_HASH_LZO_INCREMENTAL_A      3
#define LZO_HASH_LZO_INCREMENTAL_B      4

#if !defined(LZO_HASH)
#  error "choose a hashing strategy"
#endif

#if (DL_MIN_LEN == 3)
#  define _DV2_A(p,shift1,shift2) \
(((( (lzo_uint32)((p)[0]) << shift1) ^ (p)[1]) << shift2) ^ (p)[2])
#  define _DV2_B(p,shift1,shift2) \
(((( (lzo_uint32)((p)[2]) << shift1) ^ (p)[1]) << shift2) ^ (p)[0])
#  define _DV3_B(p,shift1,shift2,shift3) \
((_DV2_B((p)+1,shift1,shift2) << (shift3)) ^ (p)[0])
#elif (DL_MIN_LEN == 2)
#  define _DV2_A(p,shift1,shift2) \
(( (lzo_uint32)(p[0]) << shift1) ^ p[1])
#  define _DV2_B(p,shift1,shift2) \
(( (lzo_uint32)(p[1]) << shift1) ^ p[2])
#else
#  error "invalid DL_MIN_LEN"
#endif
#define _DV_A(p,shift)      _DV2_A(p,shift,shift)
#define _DV_B(p,shift)      _DV2_B(p,shift,shift)
#define DA2(p,s1,s2) \
(((((lzo_uint32)((p)[2]) << (s2)) + (p)[1]) << (s1)) + (p)[0])
#define DS2(p,s1,s2) \
(((((lzo_uint32)((p)[2]) << (s2)) - (p)[1]) << (s1)) - (p)[0])
#define DX2(p,s1,s2) \
(((((lzo_uint32)((p)[2]) << (s2)) ^ (p)[1]) << (s1)) ^ (p)[0])
#define DA3(p,s1,s2,s3) ((DA2((p)+1,s2,s3) << (s1)) + (p)[0])
#define DS3(p,s1,s2,s3) ((DS2((p)+1,s2,s3) << (s1)) - (p)[0])
#define DX3(p,s1,s2,s3) ((DX2((p)+1,s2,s3) << (s1)) ^ (p)[0])
#define DMS(v,s)        ((lzo_uint) (((v) & (D_MASK >> (s))) << (s)))
#define DM(v)           DMS(v,0)

#if (LZO_HASH == LZO_HASH_GZIP)
#  define _DINDEX(dv,p)     (_DV_A((p),DL_SHIFT))

#elif (LZO_HASH == LZO_HASH_GZIP_INCREMENTAL)
#  define __LZO_HASH_INCREMENTAL
#  define DVAL_FIRST(dv,p)  dv = _DV_A((p),DL_SHIFT)
#  define DVAL_NEXT(dv,p)   dv = (((dv) << DL_SHIFT) ^ p[2])
#  define _DINDEX(dv,p)     (dv)
#  define DVAL_LOOKAHEAD    DL_MIN_LEN

#elif (LZO_HASH == LZO_HASH_LZO_INCREMENTAL_A)
#  define __LZO_HASH_INCREMENTAL
#  define DVAL_FIRST(dv,p)  dv = _DV_A((p),5)
#  define DVAL_NEXT(dv,p) \
dv ^= (lzo_uint32)(p[-1]) << (2*5); dv = (((dv) << 5) ^ p[2])
#  define _DINDEX(dv,p)     ((0x9f5f * (dv)) >> 5)
#  define DVAL_LOOKAHEAD    DL_MIN_LEN

#elif (LZO_HASH == LZO_HASH_LZO_INCREMENTAL_B)
#  define __LZO_HASH_INCREMENTAL
#  define DVAL_FIRST(dv,p)  dv = _DV_B((p),5)
#  define DVAL_NEXT(dv,p) \
dv ^= p[-1]; dv = (((dv) >> 5) ^ ((lzo_uint32)(p[2]) << (2*5)))
#  define _DINDEX(dv,p)     ((0x9f5f * (dv)) >> 5)
#  define DVAL_LOOKAHEAD    DL_MIN_LEN

#else
#  error "choose a hashing strategy"
#endif

#ifndef DINDEX
#define DINDEX(dv,p)        ((lzo_uint)((_DINDEX(dv,p)) & DL_MASK) << DD_BITS)
#endif
#if !defined(DINDEX1) && defined(D_INDEX1)
#define DINDEX1             D_INDEX1
#endif
#if !defined(DINDEX2) && defined(D_INDEX2)
#define DINDEX2             D_INDEX2
#endif

#if !defined(__LZO_HASH_INCREMENTAL)
#  define DVAL_FIRST(dv,p)  ((void) 0)
#  define DVAL_NEXT(dv,p)   ((void) 0)
#  define DVAL_LOOKAHEAD    0
#endif

#if !defined(DVAL_ASSERT)
#if defined(__LZO_HASH_INCREMENTAL) && !defined(NDEBUG)
static void DVAL_ASSERT(lzo_uint32 dv, const lzo_byte *p)
{
lzo_uint32 df;
DVAL_FIRST(df,(p));
assert(DINDEX(dv,p) == DINDEX(df,p));
}
#else
#  define DVAL_ASSERT(dv,p) ((void) 0)
#endif
#endif

#if defined(LZO_DICT_USE_PTR)
#  define DENTRY(p,in)                          (p)
#  define GINDEX(m_pos,m_off,dict,dindex,in)    m_pos = dict[dindex]
#else
#  define DENTRY(p,in)                          ((lzo_uint) ((p)-(in)))
#  define GINDEX(m_pos,m_off,dict,dindex,in)    m_off = dict[dindex]
#endif

#if (DD_BITS == 0)

#  define UPDATE_D(dict,drun,dv,p,in)       dict[ DINDEX(dv,p) ] = DENTRY(p,in)
#  define UPDATE_I(dict,drun,index,p,in)    dict[index] = DENTRY(p,in)
#  define UPDATE_P(ptr,drun,p,in)           (ptr)[0] = DENTRY(p,in)

#else

#  define UPDATE_D(dict,drun,dv,p,in)   \
dict[ DINDEX(dv,p) + drun++ ] = DENTRY(p,in); drun &= DD_MASK
#  define UPDATE_I(dict,drun,index,p,in)    \
dict[ (index) + drun++ ] = DENTRY(p,in); drun &= DD_MASK
#  define UPDATE_P(ptr,drun,p,in)   \
(ptr) [ drun++ ] = DENTRY(p,in); drun &= DD_MASK

#endif

#if defined(LZO_DICT_USE_PTR)

#define LZO_CHECK_MPOS_DET(m_pos,m_off,in,ip,max_offset) \
(m_pos == NULL || (m_off = (lzo_moff_t) (ip - m_pos)) > max_offset)

#define LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,max_offset) \
(BOUNDS_CHECKING_OFF_IN_EXPR( \
(PTR_LT(m_pos,in) || \
(m_off = (lzo_moff_t) PTR_DIFF(ip,m_pos)) <= 0 || \
m_off > max_offset) ))

#else

#define LZO_CHECK_MPOS_DET(m_pos,m_off,in,ip,max_offset) \
(m_off == 0 || \
((m_off = (lzo_moff_t) ((ip)-(in)) - m_off) > max_offset) || \
(m_pos = (ip) - (m_off), 0) )

#define LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,max_offset) \
((lzo_moff_t) ((ip)-(in)) <= m_off || \
((m_off = (lzo_moff_t) ((ip)-(in)) - m_off) > max_offset) || \
(m_pos = (ip) - (m_off), 0) )

#endif

#if defined(LZO_DETERMINISTIC)
#  define LZO_CHECK_MPOS    LZO_CHECK_MPOS_DET
#else
#  define LZO_CHECK_MPOS    LZO_CHECK_MPOS_NON_DET
#endif

#ifdef __cplusplus
}
#endif

#endif

#endif

#endif

#define DO_COMPRESS     lzo1x_1_compress

static
lzo_uint do_compress     ( const lzo_byte *in , lzo_uint  in_len,
lzo_byte *out, lzo_uintp out_len,
lzo_voidp wrkmem )
{
#if 0 && defined(__GNUC__) && defined(__i386__)
register const lzo_byte *ip __asm__("%esi");
#else
const lzo_byte *ip;
#endif
lzo_byte *op;
const lzo_byte * const in_end = in + in_len;
const lzo_byte * const ip_end = in + in_len - M2_MAX_LEN - 5;
const lzo_byte *ii;
lzo_dict_p const dict = (lzo_dict_p) wrkmem;

op = out;
ip = in;
ii = ip;

ip += 4;
for (;;)
{
#if 0 && defined(__GNUC__) && defined(__i386__)
register const lzo_byte *m_pos __asm__("%edi");
#else
const lzo_byte *m_pos;
#endif
lzo_moff_t m_off;
lzo_uint m_len;
lzo_uint dindex;

DINDEX1(dindex,ip);
GINDEX(m_pos,m_off,dict,dindex,in);
if (LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,M4_MAX_OFFSET))
goto literal;
#if 1
if (m_off <= M2_MAX_OFFSET || m_pos[3] == ip[3])
goto try_match;
DINDEX2(dindex,ip);
#endif
GINDEX(m_pos,m_off,dict,dindex,in);
if (LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,M4_MAX_OFFSET))
goto literal;
if (m_off <= M2_MAX_OFFSET || m_pos[3] == ip[3])
goto try_match;
goto literal;

try_match:
#if 1 && defined(LZO_UNALIGNED_OK_2)
if (* (const lzo_ushortp) m_pos != * (const lzo_ushortp) ip)
#else
if (m_pos[0] != ip[0] || m_pos[1] != ip[1])
#endif
{
}
else
{
if (m_pos[2] == ip[2])
{
#if 0
if (m_off <= M2_MAX_OFFSET)
goto match;
if (lit <= 3)
goto match;
if (lit == 3)
{
assert(op - 2 > out); op[-2] |= LZO_BYTE(3);
*op++ = *ii++; *op++ = *ii++; *op++ = *ii++;
goto code_match;
}
if (m_pos[3] == ip[3])
#endif
goto match;
}
else
{
#if 0
#if 0
if (m_off <= M1_MAX_OFFSET && lit > 0 && lit <= 3)
#else
if (m_off <= M1_MAX_OFFSET && lit == 3)
#endif
{
register lzo_uint t;

t = lit;
assert(op - 2 > out); op[-2] |= LZO_BYTE(t);
do *op++ = *ii++; while (--t > 0);
assert(ii == ip);
m_off -= 1;
*op++ = LZO_BYTE(M1_MARKER | ((m_off & 3) << 2));
*op++ = LZO_BYTE(m_off >> 2);
ip += 2;
goto match_done;
}
#endif
}
}

literal:
UPDATE_I(dict,0,dindex,ip,in);
++ip;
if (ip >= ip_end)
break;
continue;

match:
UPDATE_I(dict,0,dindex,ip,in);
if (pd(ip,ii) > 0)
{
lzo_uint t = pd(ip,ii);

if (t <= 3)
{
assert(op - 2 > out);
op[-2] |= LZO_BYTE(t);
}
else if (t <= 18)
*op++ = LZO_BYTE(t - 3);
else
{
lzo_uint tt = t - 18;

*op++ = 0;
while (tt > 255)
{
tt -= 255;
*op++ = 0;
}
assert(tt > 0);
*op++ = LZO_BYTE(tt);
}
do *op++ = *ii++; while (--t > 0);
}

assert(ii == ip);
ip += 3;
if (m_pos[3] != *ip++ || m_pos[4] != *ip++ || m_pos[5] != *ip++ ||
m_pos[6] != *ip++ || m_pos[7] != *ip++ || m_pos[8] != *ip++
#ifdef LZO1Y
|| m_pos[ 9] != *ip++ || m_pos[10] != *ip++ || m_pos[11] != *ip++
|| m_pos[12] != *ip++ || m_pos[13] != *ip++ || m_pos[14] != *ip++
#endif
)
{
--ip;
m_len = (int)(ip - ii);
assert(m_len >= 3); assert(m_len <= M2_MAX_LEN);

if (m_off <= M2_MAX_OFFSET)
{
m_off -= 1;
#if defined(LZO1X)
*op++ = LZO_BYTE(((m_len - 1) << 5) | ((m_off & 7) << 2));
*op++ = LZO_BYTE(m_off >> 3);
#elif defined(LZO1Y)
*op++ = LZO_BYTE(((m_len + 1) << 4) | ((m_off & 3) << 2));
*op++ = LZO_BYTE(m_off >> 2);
#endif
}
else if (m_off <= M3_MAX_OFFSET)
{
m_off -= 1;
*op++ = LZO_BYTE(M3_MARKER | (m_len - 2));
goto m3_m4_offset;
}
else
#if defined(LZO1X)
{
m_off -= 0x4000;
assert(m_off > 0); assert(m_off <= 0x7fff);
*op++ = LZO_BYTE(M4_MARKER |
((m_off & 0x4000) >> 11) | (m_len - 2));
goto m3_m4_offset;
}
#elif defined(LZO1Y)
goto m4_match;
#endif
}
else
{
{
const lzo_byte *end = in_end;
const lzo_byte *m = m_pos + M2_MAX_LEN + 1;
while (ip < end && *m == *ip)
m++, ip++;
m_len = (int)(ip - ii);
}
assert(m_len > M2_MAX_LEN);

if (m_off <= M3_MAX_OFFSET)
{
m_off -= 1;
if (m_len <= 33)
*op++ = LZO_BYTE(M3_MARKER | (m_len - 2));
else
{
m_len -= 33;
*op++ = M3_MARKER | 0;
goto m3_m4_len;
}
}
else
{
#if defined(LZO1Y)
m4_match:
#endif
m_off -= 0x4000;
assert(m_off > 0); assert(m_off <= 0x7fff);
if (m_len <= M4_MAX_LEN)
*op++ = LZO_BYTE(M4_MARKER |
((m_off & 0x4000) >> 11) | (m_len - 2));
else
{
m_len -= M4_MAX_LEN;
*op++ = LZO_BYTE(M4_MARKER | ((m_off & 0x4000) >> 11));
m3_m4_len:
while (m_len > 255)
{
m_len -= 255;
*op++ = 0;
}
assert(m_len > 0);
*op++ = LZO_BYTE(m_len);
}
}

m3_m4_offset:
*op++ = LZO_BYTE((m_off & 63) << 2);
*op++ = LZO_BYTE(m_off >> 6);
}

#if 0
match_done:
#endif
ii = ip;
if (ip >= ip_end)
break;
}

*out_len = (int)(op - out);
return pd(in_end,ii);
}

LZO_PUBLIC(int)
DO_COMPRESS      ( const lzo_byte *in , lzo_uint  in_len,
lzo_byte *out, lzo_uintp out_len,
lzo_voidp wrkmem )
{
lzo_byte *op = out;
lzo_uint t;

#if defined(__LZO_QUERY_COMPRESS)
if (__LZO_IS_COMPRESS_QUERY(in,in_len,out,out_len,wrkmem))
return __LZO_QUERY_COMPRESS(in,in_len,out,out_len,wrkmem,D_SIZE,lzo_sizeof(lzo_dict_t));
#endif

if (in_len <= M2_MAX_LEN + 5)
t = in_len;
else
{
t = do_compress(in,in_len,op,out_len,wrkmem);
op += *out_len;
}

if (t > 0)
{
const lzo_byte *ii = in + in_len - t;

if (op == out && t <= 238)
*op++ = LZO_BYTE(17 + t);
else if (t <= 3)
op[-2] |= LZO_BYTE(t);
else if (t <= 18)
*op++ = LZO_BYTE(t - 3);
else
{
lzo_uint tt = t - 18;

*op++ = 0;
while (tt > 255)
{
tt -= 255;
*op++ = 0;
}
assert(tt > 0);
*op++ = LZO_BYTE(tt);
}
do *op++ = *ii++; while (--t > 0);
}

*op++ = M4_MARKER | 1;
*op++ = 0;
*op++ = 0;

*out_len = (int)(op - out);
return LZO_E_OK;
}

#undef do_compress
#undef DO_COMPRESS
#undef LZO_HASH

#undef LZO_TEST_DECOMPRESS_OVERRUN
#undef LZO_TEST_DECOMPRESS_OVERRUN_INPUT
#undef LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT
#undef LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND
#undef DO_DECOMPRESS
#define DO_DECOMPRESS       lzo1x_decompress

#if defined(LZO_TEST_DECOMPRESS_OVERRUN)
#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_INPUT)
#    define LZO_TEST_DECOMPRESS_OVERRUN_INPUT       2
#  endif
#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT)
#    define LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT      2
#  endif
#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
#    define LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND
#  endif
#endif

#undef TEST_IP
#undef TEST_OP
#undef TEST_LOOKBEHIND
#undef NEED_IP
#undef NEED_OP
#undef HAVE_TEST_IP
#undef HAVE_TEST_OP
#undef HAVE_NEED_IP
#undef HAVE_NEED_OP
#undef HAVE_ANY_IP
#undef HAVE_ANY_OP

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_INPUT)
#  if (LZO_TEST_DECOMPRESS_OVERRUN_INPUT >= 1)
#    define TEST_IP             (ip < ip_end)
#  endif
#  if (LZO_TEST_DECOMPRESS_OVERRUN_INPUT >= 2)
#    define NEED_IP(x) \
if ((lzo_uint)(ip_end - ip) < (lzo_uint)(x))  goto input_overrun
#  endif
#endif

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT)
#  if (LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT >= 1)
#    define TEST_OP             (op <= op_end)
#  endif
#  if (LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT >= 2)
#    undef TEST_OP
#    define NEED_OP(x) \
if ((lzo_uint)(op_end - op) < (lzo_uint)(x))  goto output_overrun
#  endif
#endif

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
#  define TEST_LOOKBEHIND(m_pos,out)    if (m_pos < out) goto lookbehind_overrun
#else
#  define TEST_LOOKBEHIND(m_pos,op)     ((void) 0)
#endif

#if !defined(LZO_EOF_CODE) && !defined(TEST_IP)
#  define TEST_IP               (ip < ip_end)
#endif

#if defined(TEST_IP)
#  define HAVE_TEST_IP
#else
#  define TEST_IP               1
#endif
#if defined(TEST_OP)
#  define HAVE_TEST_OP
#else
#  define TEST_OP               1
#endif

#if defined(NEED_IP)
#  define HAVE_NEED_IP
#else
#  define NEED_IP(x)            ((void) 0)
#endif
#if defined(NEED_OP)
#  define HAVE_NEED_OP
#else
#  define NEED_OP(x)            ((void) 0)
#endif

#if defined(HAVE_TEST_IP) || defined(HAVE_NEED_IP)
#  define HAVE_ANY_IP
#endif
#if defined(HAVE_TEST_OP) || defined(HAVE_NEED_OP)
#  define HAVE_ANY_OP
#endif

#undef __COPY4
#define __COPY4(dst,src)    * (lzo_uint32p)(dst) = * (const lzo_uint32p)(src)

#undef COPY4
#if defined(LZO_UNALIGNED_OK_4)
#  define COPY4(dst,src)    __COPY4(dst,src)
#elif defined(LZO_ALIGNED_OK_4)
#  define COPY4(dst,src)    __COPY4((lzo_ptr_t)(dst),(lzo_ptr_t)(src))
#endif

#if defined(DO_DECOMPRESS)
LZO_PUBLIC(int)
DO_DECOMPRESS  ( const lzo_byte *in , lzo_uint  in_len,
lzo_byte *out, lzo_uintp out_len,
lzo_voidp wrkmem )
#endif
{
lzo_byte *op;
const lzo_byte *ip;
lzo_uint t;
#if defined(COPY_DICT)
lzo_uint m_off;
const lzo_byte *dict_end;
#else
const lzo_byte *m_pos;
#endif

const lzo_byte * const ip_end = in + in_len;
#if defined(HAVE_ANY_OP)
lzo_byte * const op_end = out + *out_len;
#endif
#if defined(LZO1Z)
lzo_uint last_m_off = 0;
#endif

LZO_UNUSED(wrkmem);

#if defined(__LZO_QUERY_DECOMPRESS)
if (__LZO_IS_DECOMPRESS_QUERY(in,in_len,out,out_len,wrkmem))
return __LZO_QUERY_DECOMPRESS(in,in_len,out,out_len,wrkmem,0,0);
#endif

#if defined(COPY_DICT)
if (dict)
{
if (dict_len > M4_MAX_OFFSET)
{
dict += dict_len - M4_MAX_OFFSET;
dict_len = M4_MAX_OFFSET;
}
dict_end = dict + dict_len;
}
else
{
dict_len = 0;
dict_end = NULL;
}
#endif

*out_len = 0;

op = out;
ip = in;

if (*ip > 17)
{
t = *ip++ - 17;
if (t < 4)
goto match_next;
assert(t > 0); NEED_OP(t); NEED_IP(t+1);
do *op++ = *ip++; while (--t > 0);
goto first_literal_run;
}

while (TEST_IP && TEST_OP!=0)
{
t = *ip++;
if (t >= 16)
goto match;
if (t == 0)
{
NEED_IP(1);
while (*ip == 0)
{
t += 255;
ip++;
NEED_IP(1);
}
t += 15 + *ip++;
}
assert(t > 0); NEED_OP(t+3); NEED_IP(t+4);
#if defined(LZO_UNALIGNED_OK_4) || defined(LZO_ALIGNED_OK_4)
#if !defined(LZO_UNALIGNED_OK_4)
if (PTR_ALIGNED2_4(op,ip))
{
#endif
COPY4(op,ip);
op += 4; ip += 4;
if (--t > 0)
{
if (t >= 4)
{
do {
COPY4(op,ip);
op += 4; ip += 4; t -= 4;
} while (t >= 4);
if (t > 0) do *op++ = *ip++; while (--t > 0);
}
else
do *op++ = *ip++; while (--t > 0);
}
#if !defined(LZO_UNALIGNED_OK_4)
}
else
#endif
#endif
#if !defined(LZO_UNALIGNED_OK_4)
{
*op++ = *ip++; *op++ = *ip++; *op++ = *ip++;
do *op++ = *ip++; while (--t > 0);
}
#endif

first_literal_run:

t = *ip++;
if (t >= 16)
goto match;
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off = (1 + M2_MAX_OFFSET) + (t << 6) + (*ip++ >> 2);
last_m_off = m_off;
#else
m_off = (1 + M2_MAX_OFFSET) + (t >> 2) + (*ip++ << 2);
#endif
NEED_OP(3);
t = 3; COPY_DICT(t,m_off)
#else
#if defined(LZO1Z)
t = (1 + M2_MAX_OFFSET) + (t << 6) + (*ip++ >> 2);
m_pos = op - t;
last_m_off = t;
#else
m_pos = op - (1 + M2_MAX_OFFSET);
m_pos -= t >> 2;
m_pos -= *ip++ << 2;
#endif
TEST_LOOKBEHIND(m_pos,out); NEED_OP(3);
*op++ = *m_pos++; *op++ = *m_pos++; *op++ = *m_pos;
#endif
goto match_done;

while (TEST_IP && TEST_OP!=0)
{
match:
if (t >= 64)
{
#if defined(COPY_DICT)
#if defined(LZO1X)
m_off = 1 + ((t >> 2) & 7) + (*ip++ << 3);
t = (t >> 5) - 1;
#elif defined(LZO1Y)
m_off = 1 + ((t >> 2) & 3) + (*ip++ << 2);
t = (t >> 4) - 3;
#elif defined(LZO1Z)
m_off = t & 0x1f;
if (m_off >= 0x1c)
m_off = last_m_off;
else
{
m_off = 1 + (m_off << 6) + (*ip++ >> 2);
last_m_off = m_off;
}
t = (t >> 5) - 1;
#endif
#else
#if defined(LZO1X)
m_pos = op - 1;
m_pos -= (t >> 2) & 7;
m_pos -= *ip++ << 3;
t = (t >> 5) - 1;
#elif defined(LZO1Y)
m_pos = op - 1;
m_pos -= (t >> 2) & 3;
m_pos -= *ip++ << 2;
t = (t >> 4) - 3;
#elif defined(LZO1Z)
{
lzo_uint off = t & 0x1f;
m_pos = op;
if (off >= 0x1c)
{
assert(last_m_off > 0);
m_pos -= last_m_off;
}
else
{
off = 1 + (off << 6) + (*ip++ >> 2);
m_pos -= off;
last_m_off = off;
}
}
t = (t >> 5) - 1;
#endif
TEST_LOOKBEHIND(m_pos,out); assert(t > 0); NEED_OP(t+3-1);
goto copy_match;
#endif
}
else if (t >= 32)
{
t &= 31;
if (t == 0)
{
NEED_IP(1);
while (*ip == 0)
{
t += 255;
ip++;
NEED_IP(1);
}
t += 31 + *ip++;
}
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off = 1 + (ip[0] << 6) + (ip[1] >> 2);
last_m_off = m_off;
#else
m_off = 1 + (ip[0] >> 2) + (ip[1] << 6);
#endif
#else
#if defined(LZO1Z)
{
lzo_uint off = 1 + (ip[0] << 6) + (ip[1] >> 2);
m_pos = op - off;
last_m_off = off;
}
#elif defined(LZO_UNALIGNED_OK_2) && (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
m_pos = op - 1;
m_pos -= (* (const lzo_ushortp) ip) >> 2;
#else
m_pos = op - 1;
m_pos -= (ip[0] >> 2) + (ip[1] << 6);
#endif
#endif
ip += 2;
}
else if (t >= 16)
{
#if defined(COPY_DICT)
m_off = (t & 8) << 11;
#else
m_pos = op;
m_pos -= (t & 8) << 11;
#endif
t &= 7;
if (t == 0)
{
NEED_IP(1);
while (*ip == 0)
{
t += 255;
ip++;
NEED_IP(1);
}
t += 7 + *ip++;
}
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off += (ip[0] << 6) + (ip[1] >> 2);
#else
m_off += (ip[0] >> 2) + (ip[1] << 6);
#endif
ip += 2;
if (m_off == 0)
goto eof_found;
m_off += 0x4000;
#if defined(LZO1Z)
last_m_off = m_off;
#endif
#else
#if defined(LZO1Z)
m_pos -= (ip[0] << 6) + (ip[1] >> 2);
#elif defined(LZO_UNALIGNED_OK_2) && (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
m_pos -= (* (const lzo_ushortp) ip) >> 2;
#else
m_pos -= (ip[0] >> 2) + (ip[1] << 6);
#endif
ip += 2;
if (m_pos == op)
goto eof_found;
m_pos -= 0x4000;
#if defined(LZO1Z)
last_m_off = op - m_pos;
#endif
#endif
}
else
{
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off = 1 + (t << 6) + (*ip++ >> 2);
last_m_off = m_off;
#else
m_off = 1 + (t >> 2) + (*ip++ << 2);
#endif
NEED_OP(2);
t = 2; COPY_DICT(t,m_off)
#else
#if defined(LZO1Z)
t = 1 + (t << 6) + (*ip++ >> 2);
m_pos = op - t;
last_m_off = t;
#else
m_pos = op - 1;
m_pos -= t >> 2;
m_pos -= *ip++ << 2;
#endif
TEST_LOOKBEHIND(m_pos,out); NEED_OP(2);
*op++ = *m_pos++; *op++ = *m_pos;
#endif
goto match_done;
}

#if defined(COPY_DICT)

NEED_OP(t+3-1);
t += 3-1; COPY_DICT(t,m_off)

#else

TEST_LOOKBEHIND(m_pos,out); assert(t > 0); NEED_OP(t+3-1);
#if defined(LZO_UNALIGNED_OK_4) || defined(LZO_ALIGNED_OK_4)
#if !defined(LZO_UNALIGNED_OK_4)
if (t >= 2 * 4 - (3 - 1) && PTR_ALIGNED2_4(op,m_pos))
{
assert((op - m_pos) >= 4);
#else
if (t >= 2 * 4 - (3 - 1) && (op - m_pos) >= 4)
{
#endif
COPY4(op,m_pos);
op += 4; m_pos += 4; t -= 4 - (3 - 1);
do {
COPY4(op,m_pos);
op += 4; m_pos += 4; t -= 4;
} while (t >= 4);
if (t > 0) do *op++ = *m_pos++; while (--t > 0);
}
else
#endif
{
copy_match:
*op++ = *m_pos++; *op++ = *m_pos++;
do *op++ = *m_pos++; while (--t > 0);
}

#endif

match_done:
#if defined(LZO1Z)
t = ip[-1] & 3;
#else
t = ip[-2] & 3;
#endif
if (t == 0)
break;

match_next:
assert(t > 0); NEED_OP(t); NEED_IP(t+1);
do *op++ = *ip++; while (--t > 0);
t = *ip++;
}
}

#if defined(HAVE_TEST_IP) || defined(HAVE_TEST_OP)
*out_len = op - out;
return LZO_E_EOF_NOT_FOUND;
#endif

eof_found:
assert(t == 1);
*out_len = (int)(op - out);
return (ip == ip_end ? LZO_E_OK:
(ip < ip_end  ? LZO_E_INPUT_NOT_CONSUMED: LZO_E_INPUT_OVERRUN));

#if defined(HAVE_NEED_IP)
input_overrun:
*out_len = op - out;
return LZO_E_INPUT_OVERRUN;
#endif

#if defined(HAVE_NEED_OP)
output_overrun:
*out_len = op - out;
return LZO_E_OUTPUT_OVERRUN;
#endif

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
lookbehind_overrun:
*out_len = op - out;
return LZO_E_LOOKBEHIND_OVERRUN;
#endif
}

#define LZO_TEST_DECOMPRESS_OVERRUN
#undef DO_DECOMPRESS
#define DO_DECOMPRESS       lzo1x_decompress_safe

#if defined(LZO_TEST_DECOMPRESS_OVERRUN)
#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_INPUT)
#    define LZO_TEST_DECOMPRESS_OVERRUN_INPUT       2
#  endif
#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT)
#    define LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT      2
#  endif
#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
#    define LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND
#  endif
#endif

#undef TEST_IP
#undef TEST_OP
#undef TEST_LOOKBEHIND
#undef NEED_IP
#undef NEED_OP
#undef HAVE_TEST_IP
#undef HAVE_TEST_OP
#undef HAVE_NEED_IP
#undef HAVE_NEED_OP
#undef HAVE_ANY_IP
#undef HAVE_ANY_OP

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_INPUT)
#  if (LZO_TEST_DECOMPRESS_OVERRUN_INPUT >= 1)
#    define TEST_IP             (ip < ip_end)
#  endif
#  if (LZO_TEST_DECOMPRESS_OVERRUN_INPUT >= 2)
#    define NEED_IP(x) \
if ((lzo_uint)(ip_end - ip) < (lzo_uint)(x))  goto input_overrun
#  endif
#endif

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT)
#  if (LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT >= 1)
#    define TEST_OP             (op <= op_end)
#  endif
#  if (LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT >= 2)
#    undef TEST_OP
#    define NEED_OP(x) \
if ((lzo_uint)(op_end - op) < (lzo_uint)(x))  goto output_overrun
#  endif
#endif

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
#  define TEST_LOOKBEHIND(m_pos,out)    if (m_pos < out) goto lookbehind_overrun
#else
#  define TEST_LOOKBEHIND(m_pos,op)     ((void) 0)
#endif

#if !defined(LZO_EOF_CODE) && !defined(TEST_IP)
#  define TEST_IP               (ip < ip_end)
#endif

#if defined(TEST_IP)
#  define HAVE_TEST_IP
#else
#  define TEST_IP               1
#endif
#if defined(TEST_OP)
#  define HAVE_TEST_OP
#else
#  define TEST_OP               1
#endif

#if defined(NEED_IP)
#  define HAVE_NEED_IP
#else
#  define NEED_IP(x)            ((void) 0)
#endif
#if defined(NEED_OP)
#  define HAVE_NEED_OP
#else
#  define NEED_OP(x)            ((void) 0)
#endif

#if defined(HAVE_TEST_IP) || defined(HAVE_NEED_IP)
#  define HAVE_ANY_IP
#endif
#if defined(HAVE_TEST_OP) || defined(HAVE_NEED_OP)
#  define HAVE_ANY_OP
#endif

#undef __COPY4
#define __COPY4(dst,src)    * (lzo_uint32p)(dst) = * (const lzo_uint32p)(src)

#undef COPY4
#if defined(LZO_UNALIGNED_OK_4)
#  define COPY4(dst,src)    __COPY4(dst,src)
#elif defined(LZO_ALIGNED_OK_4)
#  define COPY4(dst,src)    __COPY4((lzo_ptr_t)(dst),(lzo_ptr_t)(src))
#endif

#if defined(DO_DECOMPRESS)
LZO_PUBLIC(int)
DO_DECOMPRESS  ( const lzo_byte *in , lzo_uint  in_len,
lzo_byte *out, lzo_uintp out_len,
lzo_voidp wrkmem )
#endif
{
lzo_byte *op;
const lzo_byte *ip;
lzo_uint t;
#if defined(COPY_DICT)
lzo_uint m_off;
const lzo_byte *dict_end;
#else
const lzo_byte *m_pos;
#endif

const lzo_byte * const ip_end = in + in_len;
#if defined(HAVE_ANY_OP)
lzo_byte * const op_end = out + *out_len;
#endif
#if defined(LZO1Z)
lzo_uint last_m_off = 0;
#endif

LZO_UNUSED(wrkmem);

#if defined(__LZO_QUERY_DECOMPRESS)
if (__LZO_IS_DECOMPRESS_QUERY(in,in_len,out,out_len,wrkmem))
return __LZO_QUERY_DECOMPRESS(in,in_len,out,out_len,wrkmem,0,0);
#endif

#if defined(COPY_DICT)
if (dict)
{
if (dict_len > M4_MAX_OFFSET)
{
dict += dict_len - M4_MAX_OFFSET;
dict_len = M4_MAX_OFFSET;
}
dict_end = dict + dict_len;
}
else
{
dict_len = 0;
dict_end = NULL;
}
#endif

*out_len = 0;

op = out;
ip = in;

if (*ip > 17)
{
t = *ip++ - 17;
if (t < 4)
goto match_next;
assert(t > 0); NEED_OP(t); NEED_IP(t+1);
do *op++ = *ip++; while (--t > 0);
goto first_literal_run;
}

while (TEST_IP && TEST_OP)
{
t = *ip++;
if (t >= 16)
goto match;
if (t == 0)
{
NEED_IP(1);
while (*ip == 0)
{
t += 255;
ip++;
NEED_IP(1);
}
t += 15 + *ip++;
}
assert(t > 0); NEED_OP(t+3); NEED_IP(t+4);
#if defined(LZO_UNALIGNED_OK_4) || defined(LZO_ALIGNED_OK_4)
#if !defined(LZO_UNALIGNED_OK_4)
if (PTR_ALIGNED2_4(op,ip))
{
#endif
COPY4(op,ip);
op += 4; ip += 4;
if (--t > 0)
{
if (t >= 4)
{
do {
COPY4(op,ip);
op += 4; ip += 4; t -= 4;
} while (t >= 4);
if (t > 0) do *op++ = *ip++; while (--t > 0);
}
else
do *op++ = *ip++; while (--t > 0);
}
#if !defined(LZO_UNALIGNED_OK_4)
}
else
#endif
#endif
#if !defined(LZO_UNALIGNED_OK_4)
{
*op++ = *ip++; *op++ = *ip++; *op++ = *ip++;
do *op++ = *ip++; while (--t > 0);
}
#endif

first_literal_run:

t = *ip++;
if (t >= 16)
goto match;
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off = (1 + M2_MAX_OFFSET) + (t << 6) + (*ip++ >> 2);
last_m_off = m_off;
#else
m_off = (1 + M2_MAX_OFFSET) + (t >> 2) + (*ip++ << 2);
#endif
NEED_OP(3);
t = 3; COPY_DICT(t,m_off)
#else
#if defined(LZO1Z)
t = (1 + M2_MAX_OFFSET) + (t << 6) + (*ip++ >> 2);
m_pos = op - t;
last_m_off = t;
#else
m_pos = op - (1 + M2_MAX_OFFSET);
m_pos -= t >> 2;
m_pos -= *ip++ << 2;
#endif
TEST_LOOKBEHIND(m_pos,out); NEED_OP(3);
*op++ = *m_pos++; *op++ = *m_pos++; *op++ = *m_pos;
#endif
goto match_done;

while (TEST_IP && TEST_OP)
{
match:
if (t >= 64)
{
#if defined(COPY_DICT)
#if defined(LZO1X)
m_off = 1 + ((t >> 2) & 7) + (*ip++ << 3);
t = (t >> 5) - 1;
#elif defined(LZO1Y)
m_off = 1 + ((t >> 2) & 3) + (*ip++ << 2);
t = (t >> 4) - 3;
#elif defined(LZO1Z)
m_off = t & 0x1f;
if (m_off >= 0x1c)
m_off = last_m_off;
else
{
m_off = 1 + (m_off << 6) + (*ip++ >> 2);
last_m_off = m_off;
}
t = (t >> 5) - 1;
#endif
#else
#if defined(LZO1X)
m_pos = op - 1;
m_pos -= (t >> 2) & 7;
m_pos -= *ip++ << 3;
t = (t >> 5) - 1;
#elif defined(LZO1Y)
m_pos = op - 1;
m_pos -= (t >> 2) & 3;
m_pos -= *ip++ << 2;
t = (t >> 4) - 3;
#elif defined(LZO1Z)
{
lzo_uint off = t & 0x1f;
m_pos = op;
if (off >= 0x1c)
{
assert(last_m_off > 0);
m_pos -= last_m_off;
}
else
{
off = 1 + (off << 6) + (*ip++ >> 2);
m_pos -= off;
last_m_off = off;
}
}
t = (t >> 5) - 1;
#endif
TEST_LOOKBEHIND(m_pos,out); assert(t > 0); NEED_OP(t+3-1);
goto copy_match;
#endif
}
else if (t >= 32)
{
t &= 31;
if (t == 0)
{
NEED_IP(1);
while (*ip == 0)
{
t += 255;
ip++;
NEED_IP(1);
}
t += 31 + *ip++;
}
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off = 1 + (ip[0] << 6) + (ip[1] >> 2);
last_m_off = m_off;
#else
m_off = 1 + (ip[0] >> 2) + (ip[1] << 6);
#endif
#else
#if defined(LZO1Z)
{
lzo_uint off = 1 + (ip[0] << 6) + (ip[1] >> 2);
m_pos = op - off;
last_m_off = off;
}
#elif defined(LZO_UNALIGNED_OK_2) && (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
m_pos = op - 1;
m_pos -= (* (const lzo_ushortp) ip) >> 2;
#else
m_pos = op - 1;
m_pos -= (ip[0] >> 2) + (ip[1] << 6);
#endif
#endif
ip += 2;
}
else if (t >= 16)
{
#if defined(COPY_DICT)
m_off = (t & 8) << 11;
#else
m_pos = op;
m_pos -= (t & 8) << 11;
#endif
t &= 7;
if (t == 0)
{
NEED_IP(1);
while (*ip == 0)
{
t += 255;
ip++;
NEED_IP(1);
}
t += 7 + *ip++;
}
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off += (ip[0] << 6) + (ip[1] >> 2);
#else
m_off += (ip[0] >> 2) + (ip[1] << 6);
#endif
ip += 2;
if (m_off == 0)
goto eof_found;
m_off += 0x4000;
#if defined(LZO1Z)
last_m_off = m_off;
#endif
#else
#if defined(LZO1Z)
m_pos -= (ip[0] << 6) + (ip[1] >> 2);
#elif defined(LZO_UNALIGNED_OK_2) && (LZO_BYTE_ORDER == LZO_LITTLE_ENDIAN)
m_pos -= (* (const lzo_ushortp) ip) >> 2;
#else
m_pos -= (ip[0] >> 2) + (ip[1] << 6);
#endif
ip += 2;
if (m_pos == op)
goto eof_found;
m_pos -= 0x4000;
#if defined(LZO1Z)
last_m_off = op - m_pos;
#endif
#endif
}
else
{
#if defined(COPY_DICT)
#if defined(LZO1Z)
m_off = 1 + (t << 6) + (*ip++ >> 2);
last_m_off = m_off;
#else
m_off = 1 + (t >> 2) + (*ip++ << 2);
#endif
NEED_OP(2);
t = 2; COPY_DICT(t,m_off)
#else
#if defined(LZO1Z)
t = 1 + (t << 6) + (*ip++ >> 2);
m_pos = op - t;
last_m_off = t;
#else
m_pos = op - 1;
m_pos -= t >> 2;
m_pos -= *ip++ << 2;
#endif
TEST_LOOKBEHIND(m_pos,out); NEED_OP(2);
*op++ = *m_pos++; *op++ = *m_pos;
#endif
goto match_done;
}

#if defined(COPY_DICT)

NEED_OP(t+3-1);
t += 3-1; COPY_DICT(t,m_off)

#else

TEST_LOOKBEHIND(m_pos,out); assert(t > 0); NEED_OP(t+3-1);
#if defined(LZO_UNALIGNED_OK_4) || defined(LZO_ALIGNED_OK_4)
#if !defined(LZO_UNALIGNED_OK_4)
if (t >= 2 * 4 - (3 - 1) && PTR_ALIGNED2_4(op,m_pos))
{
assert((op - m_pos) >= 4);
#else
if (t >= 2 * 4 - (3 - 1) && (op - m_pos) >= 4)
{
#endif
COPY4(op,m_pos);
op += 4; m_pos += 4; t -= 4 - (3 - 1);
do {
COPY4(op,m_pos);
op += 4; m_pos += 4; t -= 4;
} while (t >= 4);
if (t > 0) do *op++ = *m_pos++; while (--t > 0);
}
else
#endif
{
copy_match:
*op++ = *m_pos++; *op++ = *m_pos++;
do *op++ = *m_pos++; while (--t > 0);
}

#endif

match_done:
#if defined(LZO1Z)
t = ip[-1] & 3;
#else
t = ip[-2] & 3;
#endif
if (t == 0)
break;

match_next:
assert(t > 0); NEED_OP(t); NEED_IP(t+1);
do *op++ = *ip++; while (--t > 0);
t = *ip++;
}
}

#if defined(HAVE_TEST_IP) || defined(HAVE_TEST_OP)
*out_len = (int)(op - out);
return LZO_E_EOF_NOT_FOUND;
#endif

eof_found:
assert(t == 1);
*out_len = (int)(op - out);
return (ip == ip_end ? LZO_E_OK:
(ip < ip_end  ? LZO_E_INPUT_NOT_CONSUMED: LZO_E_INPUT_OVERRUN));

#if defined(HAVE_NEED_IP)
input_overrun:
*out_len = (int)(op - out);
return LZO_E_INPUT_OVERRUN;
#endif

#if defined(HAVE_NEED_OP)
output_overrun:
*out_len = (int)(op - out);
return LZO_E_OUTPUT_OVERRUN;
#endif

#if defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
lookbehind_overrun:
*out_len = (int)(op - out);
return LZO_E_LOOKBEHIND_OVERRUN;
#endif
}

/***** End of minilzo.c *****/






/*----------------------------------------------------------------------------
astarplanner.cpp
Implementation for AStarPlanner class.

Copyright (C) 2003 Ted Cipicchio <ted@thereisnospork.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
----------------------------------------------------------------------------*/

#include "stdafx.h" // #include "stdafx.h"
#include "astarplanner.h" // #include "astarplanner.h"

// Compute heuristic weight of node based on rough distance calculation.
#define COMPUTE_DIST(CURR_X, CURR_Y, DEST_X, DEST_Y) \
(float(abs((DEST_X) - (CURR_X)) + abs((DEST_Y) - (CURR_Y))))


// Check the specified node against the open and closed lists and add to open.
#define CHECK_ADD_PRE(X, Y, MAP_IDX)  \
do                                                           \
{                                                            \
/* Make sure we're not off the map. */                   \
if ((X) < 0 || (X) >= (int)width || (Y) < 0 || (Y) >= (int)height) \
break;                                               \
\
/* Check for wall. */                                    \
float map_val = themap[MAP_IDX];                         \
if (map_val == PLANNER_WALL)                             \
break;


#define CHECK_ADD_POST(X, Y) \
/* Check closed list. */                                 \
Node *ptest = closed_iter.find(X, Y);                    \
if (ptest)                                               \
{                                                        \
/* Check if found node is better than our node. */   \
Node &rtest = *ptest;                                \
if (rtest.cost <= cost)                              \
break;                                           \
\
/* This node is better, so replace the other. */     \
closed_iter.remove();                                \
rtest.pParent = pnode;                               \
rtest.x = (X);                                       \
rtest.y = (Y);                                       \
rtest.cost = cost;                                   \
float heuristic = COMPUTE_DIST(X, Y, end_x, end_y);  \
rtest.weight = (heuristic - cost) * heuristic_weight \
+ cost;                                          \
SortedInsert(open, ptest);                           \
\
break;                                               \
}                                                        \
\
/* Check open list. */                                   \
unsigned int i = open.size();                            \
bool bstop = false;                                      \
while (i--)                                              \
{                                                        \
Node &rcurr = *open[i];                              \
if ((X) != rcurr.x || (Y) != rcurr.y)                \
continue;                                        \
\
/* Gonna stop either way... */                       \
bstop = true;                                        \
\
/* Found a node, is it better? */                    \
if (rcurr.cost <= cost)                              \
break;                                           \
\
/* This node is better, so replace the other. */     \
open.remove(i);                                      \
rcurr.pParent = pnode;                               \
rcurr.x = (X);                                       \
rcurr.y = (Y);                                       \
rcurr.cost = cost;                                   \
float heuristic = COMPUTE_DIST(X, Y, end_x, end_y);  \
rcurr.weight = (heuristic - cost) * heuristic_weight \
+ cost;                                          \
SortedInsert(open, &rcurr);                          \
\
break;                                               \
}                                                        \
if (bstop)                                               \
break;                                               \
\
/* Not in either list, so it should be added. */         \
Node *pchild = factory.fetch();                          \
Node &rchild = *pchild;                                  \
rchild.pParent = pnode;                                  \
rchild.x = (X);                                          \
rchild.y = (Y);                                          \
rchild.cost = cost;                                      \
float heuristic = COMPUTE_DIST(X, Y, end_x, end_y);      \
rchild.weight = (heuristic - cost) * heuristic_weight    \
+ cost;                                              \
SortedInsert(open, pchild);                              \
} while(false);

#define CHECK_ADD_NORM(X, Y, MAP_IDX)     \
CHECK_ADD_PRE(X, Y, MAP_IDX)          \
float cost = node_cost + map_val; \
CHECK_ADD_POST(X, Y)

#define CHECK_ADD_DIAG(X, Y, MAP_IDX)                 \
if(mt_description.can_walk_diagonally){           \
CHECK_ADD_PRE(X, Y, MAP_IDX)                      \
float cost = node_cost + map_val * diag_cost; \
CHECK_ADD_POST(X, Y)  }

static void SortedInsert (FixedDeque<Node *> &nodeDeque, Node *pNode)
{
unsigned int lo = 0;
unsigned int hi = nodeDeque.size();
while (lo < hi)
{
unsigned int mid = (lo + hi) >> 1;  // (lo + hi) / 2
Node *ptest = nodeDeque[mid];
if (pNode->weight < ptest->weight)
{
lo = mid + 1;
continue;
}
hi = mid;
}
//	ASSERT(lo == hi);
nodeDeque.insert(lo, pNode);
}


//----------------------------------------------------------------------------
// Public Methods
//----------------------------------------------------------------------------

// Initialize the path-finding algorithm.
void AStarPlanner::initialize ()
{
// Base class initialize()...
Planner::initialize();

// Get node for starting point and put into queue.
Node *pnode = mt_nodeFactory.fetch();
pnode->pParent = 0;
pnode->x = mt_description.startX;
pnode->y = mt_description.startY;
pnode->cost = 0;
mt_open.pushBack(pnode);
}


#if 0
bool AStarPlanner::run ()
{
return false;
}

#else
// Run a single time slice of the path-finding algorithm.
bool AStarPlanner::run ()
{
// Increment run count.
mt_numSlices++;

// Get some useful variables.
int end_x = mt_description.endX;
int end_y = mt_description.endY;
unsigned int width  = mt_description.width;
unsigned int height = mt_description.height;
float *themap = mt_map;
FixedDeque<Node *> &open = mt_open;
NodeHashTable &closed = mt_closed;
NodeHashIterator closed_iter(&closed);
NodeFactory &factory = mt_nodeFactory;
//	unsigned int slice_time = 0; //mt_description.sliceTime;
float diag_cost = (mt_description.bDiagonalCost ? 1.4142136f : 1.0f);
float heuristic_weight = mt_description.heuristicWeight;

// Create a timer and start it.
//	Timer timer; timer.start();

// Cycle through open nodes.
while (!open.isEmpty())
{
// Get the next node to examine.
Node *pnode = open.back();
open.popBack();
Node &rnode = *pnode;
int x = rnode.x;
int y = rnode.y;

// Check if the node is the end node.
if (x == end_x && y == end_y)
{
closed.add(pnode);
mt_pGoal = pnode;
//			timer.stop();
//			mt_runningTime += timer.get();
mt_bDone = true;
return true;
}

// More information...
int map_idx = x + y * width;
float node_cost = rnode.cost;

// Add this node's children to the open list.
int child_x = x - 1;
int child_y = y - 1;

#if !(defined(POCKETPC) && defined(_DEBUG))
CHECK_ADD_DIAG(child_x, child_y, map_idx - width - 1)
child_x++;
CHECK_ADD_NORM(child_x, child_y, map_idx - width)
child_x++;
CHECK_ADD_DIAG(child_x, child_y, map_idx - width + 1)
child_y++;
CHECK_ADD_NORM(child_x, child_y, map_idx + 1)
child_x -= 2;
CHECK_ADD_NORM(child_x, child_y, map_idx - 1)
child_y++;
CHECK_ADD_DIAG(child_x, child_y, map_idx + width - 1)
child_x++;
CHECK_ADD_NORM(child_x, child_y, map_idx + width)
child_x++;
CHECK_ADD_DIAG(child_x, child_y, map_idx + width + 1)
#endif

// Add the node to the closed list.
closed.add(pnode);

// Check if we've run out of time for this slice.
//		if (slice_time && timer.get() > slice_time) break;
}

//	timer.stop();
//	mt_runningTime += timer.get();
mt_bDone = open.isEmpty();
return mt_bDone;
}

#endif
/*----------------------------------------------------------------------------
node.cpp
Implementation for NodeFactory.

Copyright (C) 2003 Ted Cipicchio <ted@thereisnospork.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
----------------------------------------------------------------------------*/
#include "stdafx.h" // #include "stdafx.h"
#include "node.h" // #include "node.h"

//----------------------------------------------------------------------------
// Construction/Destruction
//----------------------------------------------------------------------------

/// Constructor.
/**
@remarks  Node factories are created with an empty pool.  Nodes have to be
allocated after factory creation using the allocate() method.

@see allocate()
*/
NodeFactory::NodeFactory ()
: mv_nodePoolSize(0), mv_nodePool(0),
mv_nodeTopIdx(0)
{
}


/// Destructor.
NodeFactory::~NodeFactory ()
{
// Delete nodes?
if (mv_nodePool)
{
while (mv_nodePoolSize--)
if(mv_nodePool[mv_nodePoolSize]) delete mv_nodePool[mv_nodePoolSize];
delete [] mv_nodePool;
}
mv_nodePool=0;
}


//----------------------------------------------------------------------------
// Public Methods
//----------------------------------------------------------------------------

/// Allocate a pool of nodes.
/**
Nodes need to be allocated before the node factory can be used.  The node
factory will only give out as many nodes as it has allocated (no additional
nodes will be allocated automatically).

@param size  Number of nodes to allocate.

@return  True if successful, false if not.

@pre @c size must be at least 1.

@note  Calling allocate() after nodes have already been allocated will cause
the old nodes to be deleted, so make sure your application is not
using any previously fetched nodes from a factory once allocate() is
called on it again.
*/
bool NodeFactory::allocate (unsigned int size)
{
// Ignore sizes of 0.
if (!size)
return false;

// Delete old nodes?
if (mv_nodePool)
{
while (mv_nodePoolSize--)
if(mv_nodePool[mv_nodePoolSize]) delete mv_nodePool[mv_nodePoolSize];
delete [] mv_nodePool;
}

mv_nodeTopIdx = 0;
// Allocate new nodes.
mv_nodePool = new Node * [size];
if(mv_nodePool)
{
for (unsigned int i = 0; i < size; i++)
mv_nodePool[i] = new Node;
// Store new size and prepare stack index.
mv_nodePoolSize = size;
}
else return false;
return true;
}
/*----------------------------------------------------------------------------
nodehashtable.cpp
Implementation for NodeHashTable class.

Copyright (C) 2003 Ted Cipicchio <ted@thereisnospork.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
----------------------------------------------------------------------------*/
#include "stdafx.h" // #include "stdafx.h"
#include "nodehashtable.h" // #include "nodehashtable.h"

//#include <cstring>
#include "node.h" // #include "node.h"

//----------------------------------------------------------------------------
// Construction/Destruction
//----------------------------------------------------------------------------

/// Constructor.
/**
This will create the hash table with a default size of 1 element.  You'll
more than likely want to create a new one with better precision using the
create() method.

@see create()
*/
NodeHashTable::NodeHashTable ()
: mv_nodeHashSize(0)
{
// Create hash table with 0 bits precision (1 element).
mv_nodeHash = new Node * [1];
mv_nodeHash[0] = 0;
}


/// Copy constructor.
/**
Creates a copy of another object.

@param src  Source object to copy from.
*/
NodeHashTable::NodeHashTable (const NodeHashTable &src)
{
// Set this object's values.
v_set(src);
}


/// Destructor.
NodeHashTable::~NodeHashTable ()
{
// Free up memory.
v_free();
}


//----------------------------------------------------------------------------
// Public Methods
//----------------------------------------------------------------------------

/// Create the hash table.
/**
This will create a hash table using the specified bits of precision.  Any
existing hash table will be destroyed.

The size of the table in memory will be 2^precision elements.

@param bits  Bits of precision to use.

@return  Precision the hash table created.

@pre  @c bits must be an even number less than or equal to 24.  Invalid
values will be rounded down to the nearest valid value.
*/
unsigned int NodeHashTable::create (unsigned int bits)
{
// Adjust bit value to valid value if necessary (even number less than or
// equal to 24).
bits = (bits > 24 ? 24 : (bits & 0x1 ? bits & ~0x1 : bits));

// Clear out existing table.
delete [] mv_nodeHash;

// Create new table.
mv_nodeHash = new Node * [1 << bits];
memset(mv_nodeHash, 0, sizeof(Node *) * (1 << bits));

// Set new table size.
mv_nodeHashSize = bits;

return bits;
}


/// Add a node to the table.
/**
@param pNode  Node to add.

@note  Null pointers are ignored.
*/
bool NodeHashTable::add (Node *pNode)
{
// Check for null pointer.
if (!pNode)
return false;

// Get the hash value for this node.
unsigned int hash_val = hash(pNode->x, pNode->y);

// GF: Don't add if already inside!
for(Node *pcurr = mv_nodeHash[hash_val]; pcurr; pcurr = pcurr->pNext)
{
if(pcurr == pNode) return false;
}

// Insert this node into the list at the location in the table given by
// the node's hash value.
Node *&rpdest = mv_nodeHash[hash_val];
pNode->pNext = rpdest;
rpdest = pNode;
return true;
}


/// Get the number of nodes in the hash table.
/**
@return  Number of nodes in the hash table.
*/
unsigned int NodeHashTable::size () const
{
// Start count at 0...
unsigned int count = 0;

// Loop through each array element.
unsigned int arr_size = 1U << mv_nodeHashSize;
while (arr_size--)
{
// Start at the beginning of the list.
Node *pcurr = mv_nodeHash[arr_size];
while (pcurr)
{
// Node here, so increment count.
count++;

// Continue onto next node.
pcurr = pcurr->pNext;
}
}

return count;
}


/// Empty the hash table.
/**
This will empty out all entries in the hash table.  No memory is deleted or
nodes released when doing so.

If you want to empty out the table and release all nodes at the same time,
use the releaseAll() method.

@see releaseAll()
*/
void NodeHashTable::empty ()
{
memset(mv_nodeHash, 0, sizeof(Node *) * (1 << mv_nodeHashSize));
}


/// Release all nodes in the hash table.
/**
This will empty out all entries in the hash table and release all nodes back
into the specified node factory.  No memory is deleted when doing so.

If you want to empty out the table without releasing nodes, use the empty()
method.

@param factory  Factory to release nodes back into.

@see empty()
*/
void NodeHashTable::releaseAll (NodeFactory &factory)
{
// Cycle through each entry in the table.
unsigned int idx = 1 << mv_nodeHashSize;
while (idx--)
{
// Release all nodes in the current list.
Node *pnode = mv_nodeHash[idx];
while (pnode)
{
Node *pnext = pnode->pNext;
factory.release(pnode);
pnode = pnext;
}
}

// Clear out the array.
memset(mv_nodeHash, 0, sizeof(Node *) * (1 << mv_nodeHashSize));
}


/// Node hash function.
/**
This calculates the hash value of a node with the specified coordinates.

This is mainly used internally, but is available publicly in case one wants
to play with it.

@param x  X-coordinate of the node.
@param y  Y-coordinate of the node.

@return  Hash code for the node.

@remarks  The hash table makes use of the coordinates of the node to
calculate the node's hash value.  The lower-order bits of each
coordinate are combined to get the resulting hash code for the
node.  The number of bits used depends on the precision of the
table created (i.e. a 16-bit table will use the lower 8-bits of
each coordinate).
*/
unsigned int NodeHashTable::hash (int x, int y) const
{
// Generate and return code.
unsigned int half_size = mv_nodeHashSize >> 1;
int mask = (1 << half_size) - 1;
return (x & mask) | ((y & mask) << half_size);
}


/// Assignment operator.
/**
Copies data from one object into this one.

@param src  Source object to copy from.

@return  Reference to this object.
*/
NodeHashTable &NodeHashTable::operator = (const NodeHashTable &src)
{
// Make sure we aren't trying to copy ourself.
if (this != &src)
{
// Free old data and copy.
v_free();
v_set(src);
}

return *this;
}


//----------------------------------------------------------------------------
// Private Methods
//----------------------------------------------------------------------------

/// Set object data based on data from another object.
/**
@param src  Source object to copy from.
*/
void NodeHashTable::v_set (const NodeHashTable &src)
{
// Get size of table.
mv_nodeHashSize = src.mv_nodeHashSize;

// Allocate memory for table and copy.
mv_nodeHash = new Node * [1 << mv_nodeHashSize];
memcpy(mv_nodeHash, src.mv_nodeHash, 1 << mv_nodeHashSize);
}


/// Free allocated memory.
void NodeHashTable::v_free ()
{
// Delete hash table.
if(mv_nodeHash)delete [] mv_nodeHash;
}
/*----------------------------------------------------------------------------
nodehashtable-iterator.cpp
Implementation for NodeHashIterator class.

Copyright (C) 2003 Ted Cipicchio <ted@thereisnospork.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
----------------------------------------------------------------------------*/
#include "stdafx.h" // #include "stdafx.h"
#include "nodehashtable.h" // #include "nodehashtable.h"
#include "node.h" // #include "node.h"


//----------------------------------------------------------------------------
// Construction/Destruction
//----------------------------------------------------------------------------

/// Constructor.
/**
@param pTable  Pointer to hash table to initially attach to.
(default = none)

@note  The iterator will not be on any node to begin with, regardless of
whether or not a table is initially specified.  Use the begin() or
find() methods to place the iterator on a node.
*/
NodeHashIterator::NodeHashIterator (NodeHashTable *pTable)
: mv_pTable(pTable),
mv_index(0),
mv_pNode(0),
mv_ppHolder(0)
{
}


//----------------------------------------------------------------------------
// Public Methods
//----------------------------------------------------------------------------

/// Attach this iterator to a hash table.
/**
This will assign a hash table for this iterator to begin monitoring.

The iterator will not be on any node to begin with.  The iterator can either
start at the beginning of the table using the begin() method, or start at a
node with a specific location using the find() method.

You can also choose to detach the iterator from any hash table by passing a
null pointer as the parameter.

@param pTable  Table to attach the iterator to.

@see begin(), find()
*/
void NodeHashIterator::attach (NodeHashTable *pTable)
{
// Store the table pointer and zero out other values.
mv_pTable = pTable;
mv_index = 0;
mv_pNode = 0;
mv_ppHolder = 0;
}


/// Remove the node at the current location from the table.
/**
@return  A pointer to the node removed from the list, or null if no pointer
was removed.

@remarks  This will leave the iterator invalid, and will need to be
revalidated again after removing (either by using begin() or
find()).  removeValid() does the same as remove(), but sets the
iterator to the next available value (if one exists).  It is
somewhat slower, but the iterator will still be valid as long as
nodes are left in the table.

@see removeValid()
*/
Node *NodeHashIterator::remove ()
{
// Check if we even have a node.
if (!mv_pNode)
return 0;

// Remove the node from the list.
*mv_ppHolder = mv_pNode->pNext;

// Return removed node.
return mv_pNode;
}


/// Remove the current node from the table, keeping the iterator valid.
/**
This will remove the current node from the table and readjust the iterator
to the next available node.  This way the iterator can still be used to
iterate from where if left off.

@return  A pointer to the node removed from the list, or null if no pointer
was removed.

@remarks  If you want to remove a node, but do not care if the iterator is
no longer valid afterward, use remove().  remove() is somewhat
faster since the iterator does not need to be readjusted.

@see remove()
*/
Node *NodeHashIterator::removeValid ()
{
// Check if we even have a node.
if (!mv_pNode)
return 0;

// Make a copy of the current node pointer and holder (so we still have
// them after adjusting the iterator).
Node *pold = mv_pNode;
Node **ppholder = mv_ppHolder;

// Set iterator to next node.
next();

// Remove old node from the list.
*ppholder = pold->pNext;

// Return removed node.
return pold;
}


/// Return to the beginning of the table.
/**
@return  A pointer to the node, or null if table is empty or no table is
attached.
*/
Node *NodeHashIterator::begin ()
{
// Check if a table is even attached.
if (!mv_pTable)
return 0;

// Find first node in the table.
unsigned int arr_size = 1 << mv_pTable->mv_nodeHashSize;
Node **node_hash = mv_pTable->mv_nodeHash;
for (unsigned int i = 0; i < arr_size; i++)
{
// Check if there are any nodes in the current list.
Node *pcurr = node_hash[i];
if (!pcurr)
continue;

// Adjust iterator values and return new current node.
mv_pNode = pcurr;
mv_ppHolder = &node_hash[i];
mv_index = i;

return pcurr;
}

// Table is empty, no current node.
mv_pNode = 0;

return 0;
}


/// Find the node at the specified location in the table.
/**
This finds the first available node with the specified coordinates in the
hash table and sets the iterator to the node found.

@param x  X-coordinate of node to find.
@param y  Y-coordinate of node to find.

@return  The found node, or null if no node found or no table attached.

@note  Regardless of whether or not the node is found, any node information
in the iterator prior to the search will be changed to whatever
results from the search.  If no node is found, the iterator will no
longer point to any node.
*/
Node *NodeHashIterator::find (int x, int y)
{
// If no table, no node is to be found.
if (!mv_pTable)
return 0;

// Calculate the hash value of the node requested.
unsigned int hash_val = mv_pTable->hash(x, y);

// Scan through nodes in the list at the table location given by the hash
// value.
Node **node_hash = mv_pTable->mv_nodeHash;
Node **ppholder = &node_hash[hash_val];
Node *pnode = *ppholder;
while (pnode && (pnode->x != x || pnode->y != y))
{
ppholder = &pnode->pNext;
pnode = *ppholder;
}

// Store result of search.
mv_index = hash_val;
mv_ppHolder = ppholder;
mv_pNode = pnode;

return pnode;
}


/// Proceed to the next node in the table.
/**
@return  A pointer to the new current node, or null if the end of the table
has been reached or there is no table attached.
*/
Node *NodeHashIterator::next ()
{
// If we have no current node, we have no next node.
if (!mv_pNode)
return 0;

// Check the next node in the list.
if (mv_pNode->pNext)
{
// Use next node in the list.
mv_ppHolder = &mv_pNode->pNext;
mv_pNode = *mv_ppHolder;

return mv_pNode;
}

// No more nodes in the current list, so we must check nodes in later
// lists.
unsigned int arr_size = 1 << mv_pTable->mv_nodeHashSize;
Node **node_hash = mv_pTable->mv_nodeHash;
for (unsigned int i = mv_index + 1; i < arr_size; i++)
{
// Check if there are any nodes in the current list.
Node *pcurr = node_hash[i];
if (!pcurr)
continue;

// Adjust iterator values and return new current node.
mv_pNode = pcurr;
mv_ppHolder = &node_hash[i];
mv_index = i;

return pcurr;
}

// No more nodes, so next node is null.
mv_pNode = 0;

return 0;
}
/*----------------------------------------------------------------------------
planner.cpp
Implementation for Planner class.

Copyright (C) 2003 Ted Cipicchio <ted@thereisnospork.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
----------------------------------------------------------------------------*/
#include "stdafx.h" // #include "stdafx.h"
#include "planner.h" // #include "planner.h"


// Maximum value for color values (3 * 255).
// #define COLORVAL_MAX 765


//----------------------------------------------------------------------------
// Construction/Destruction
//----------------------------------------------------------------------------

/// Constructor.
Planner::Planner ()
: mt_bDone(true), mt_map(0), mt_numSlices(0), mt_runningTime(0),
mt_pGoal(0)
{
// Whoosh...
memset(&mt_description, 0, sizeof(Description));
}


/// Destructor.
Planner::~Planner ()
{
// Make sure path info is cleaned up.
cleanup();

// Clear out old data.
if (mt_map)
delete [] mt_map;
}


//----------------------------------------------------------------------------
// Construction/Destruction
//----------------------------------------------------------------------------

/// Create a map to use for plotting.
/**
@param image    BMP image to use as map.
@param descrip  Description of how to interpret the map and how to set up
the algorithm.

@return  True if successful, false if failed (no map set up).
*/
bool Planner::createMap(const Description &descrip)
{
// Make sure the start and end locations are valid.
if (descrip.startX < 0 || descrip.startX >= (int)descrip.width ||
descrip.startY < 0 || descrip.startY >= (int)descrip.height ||
descrip.endX < 0 || descrip.endX >= (int)descrip.width ||
descrip.endY < 0 || descrip.endY >= (int)descrip.height)
return false;

// Make sure start and end locations are not the same.
if (descrip.startX == descrip.endX && descrip.startY == descrip.endY)
return false;

// Make sure the threshold for walls is reasonable.
// if (descrip.wallThreshold < 0 || descrip.wallThreshold >= COLORVAL_MAX - 1) return false;

// Make sure multiplier for ground weighting is not negative.
// if (descrip.weightMultiplier < 0.0f) return false;

// Unload the old map.
unloadMap();

// Create the array for our map.
mt_map = new float [(descrip.width) * (descrip.height)];

// Read in values from double-array.
long idx = 0;
float val, maxval = -1.0;
for (unsigned long y = 0; y < descrip.height; y++)
{
for (unsigned long x = 0; x < descrip.width; x++)
{
val = (float) *(descrip.pMapData + x + descrip.width * y);
// Negative value? -> Becomes impermiable
if (val <= 0.0f)
{
mt_map[idx++] = -1.0f;
continue;
}
if(x==0 && y==0) maxval = val; // first value
if (val>maxval) maxval=val;
mt_map[idx++] = val;
}
}

// Normalize to values from 1.0 to 2.0 OR -1.0 for solid
if (maxval>0)
{
for (unsigned long y=0; y<descrip.width * descrip.height; y++)
if(mt_map[y]>0)
{
mt_map[y] = mt_map[y]/maxval + 1.0f;
}
}
else return false;

// Allocate nodes in factory.
mt_nodeFactory.allocate(descrip.factorySize
? descrip.factorySize
: descrip.width * descrip.height);

// Allocate deque memory.
mt_open.allocate(descrip.openDequeSize
? descrip.openDequeSize
: descrip.width * descrip.height);

// Initialize hash table for closed nodes.
mt_closed.create(descrip.hashPrecision);

// No goal node yet...
mt_pGoal = 0;

// Store description...
mt_description = descrip;
mt_description.width = descrip.width;
mt_description.height = descrip.height;

// Ensure heuristic weight given is within the range [0, 1].
if (mt_description.heuristicWeight < 0.0f)
mt_description.heuristicWeight = 0.0f;
else if (mt_description.heuristicWeight > 1.0f)
mt_description.heuristicWeight = 1.0f;

// Reset number of slices run to 0.
mt_numSlices = 0;

// No time run so far.
mt_runningTime = 0;

// Say we're "done" so path-planning isn't run before calling
// initialize().
mt_bDone = true;

return true;
}


/// Unload any currently loaded map.
void Planner::unloadMap ()
{
// Check if a map even exists.
if (!mt_map)
return;

// Delete the map.
delete [] mt_map;
mt_map = 0;

// Zero out number of slices.
mt_numSlices = 0;

// No goal.
mt_pGoal = 0;

// Clear out description.
memset(&mt_description, 0, sizeof(Description));
}


/// Initialize the path-finding algorithm.
/**
This sets up the state of varables needed to begin path finding.

The default implementation of this function unsets the "done" state and sets
the current number of slices run to 0.  Overrides of this function should be
sure to call the base class version.

@note  If a path algorithm is to be executed multiple times on the same
data, cleanup() should be called before calling initialize().

@see run(), cleanup()
*/
void Planner::initialize ()
{
// Not done.
mt_bDone = false;

// No slices yet...
mt_numSlices = 0;

// No goal (how many times am I gonna set this to 0?).
mt_pGoal = 0;
}


/// Clean up nodes in use.
/**
This empties out the open and closed lists and makes sure the nodes are
released back into the factory.  This is necessary to ensure nodes are
properly deleted upon destruction.

The default implementation of this function removes and frees all the nodes
from the open and closed lists, and clears out the path list.  The path is
assumed to represent nodes within the closed list, and as such its nodes are
not released.  Overrides of this function should be sure to call the base
class version.

@see initialize(), run()
*/
void Planner::cleanup ()
{
// Release open nodes.
for (unsigned int i = 0; i < mt_open.size(); i++)
{
Node* pN = mt_open[i];
mt_nodeFactory.release(pN);
}
mt_open.clear();

// Release closed nodes.
mt_closed.releaseAll(mt_nodeFactory);

// Clear path list.
mt_pGoal = 0;

// Set done state to keep from accidentally running again.
mt_bDone = true;
}


/// Get path cost.
/**
This gets the cost of the final path, if one exists.  The cost is pulled
from the cost stored in the last node of the path.

@return  The final path cost, or -1 if no path.
*/
float Planner::getPathCost () const
{
// Check for a path.
if (!mt_pGoal)
return -1.0f;

return mt_pGoal->cost;
}


/// Get the size of the path list.
/**
@return  Number of nodes currently in the path list.
*/
unsigned int Planner::getPathSize () const
{
// Count the size.
unsigned int path_size = 0;
Node *pnode = mt_pGoal;
while (pnode)
{
path_size++;
pnode = pnode->pParent;
}

return path_size;
}


/// Get the size of the open list.
/**
@return  Number of nodes currently in the open list.
*/
unsigned int Planner::getOpenSize () const
{
return mt_open.size();
}


/// Get the size of the closed list.
/**
@return  Number of nodes currently in the closed list.
*/
unsigned int Planner::getClosedSize () const
{
return mt_closed.size();
}

/*
HawkThreads thread module
Copyright (C) 2003-2004 Phil Frisbie, Jr. (phil@hawksoft.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Or go to http://www.gnu.org/copyleft/lgpl.html
*/

#include "htinternal.h" // #include "htinternal.h"

#ifdef _MSC_VER
#pragma warning(disable: 4311)
#endif

#ifdef HT_WIN_THREADS

typedef struct {
void *(*func) (void *);
void *arg;
} ThreadParms;

static unsigned  __stdcall threadfunc(void *arg)
{
void *(*func) (void *);
void *args;

func = ((ThreadParms *)arg)->func;
args = ((ThreadParms *)arg)->arg;
free(arg);

return (unsigned)(void*)((*func)(args));
}


// #if defined (_WIN32_WCE)
#define _beginthreadex(security, \
stack_size, \
start_proc, \
arg, \
flags, \
pid) \
CreateThread(security, \
stack_size, \
(LPTHREAD_START_ROUTINE) start_proc, \
arg, \
flags, \
pid)
// #else /* !(_WIN32_WCE) */
// #include <process.h>
// #endif /* !(_WIN32_WCE) */



#else /* !HT_WIN_THREADS */
/* POSIX systems */
#include <pthread.h>
#include <sched.h>
#endif /* !HT_WIN_THREADS */

#ifndef HL_WINDOWS_APP
#include <unistd.h>
#endif /* HL_WINDOWS_APP */

HL_EXP HThreadID HL_APIENTRY htThreadCreate(HThreadFunc func, void *data, int joinable)
{
/* Windows threads */
#ifdef HT_WIN_THREADS
HANDLE          h;
unsigned        tid;
ThreadParms     *p;

p = (ThreadParms *)malloc(sizeof(ThreadParms));
if(p == NULL)
{
SetLastError((DWORD)ENOMEM);
return (HThreadID)HT_INVALID;
}
p->func = func;
p->arg = data;
h = (HANDLE)_beginthreadex(NULL, 0, threadfunc, p, 0, (DWORD*)&tid);
if(h == (HANDLE)(0))
{
return (HThreadID)HT_INVALID;
}
if(joinable == HT_FALSE)
{
(void)CloseHandle(h);
return NULL;
}
return (HThreadID)h;

/* POSIX systems */
#else
pthread_attr_t  attr;
pthread_t       tid;
int             result;

(void)pthread_attr_init(&attr);
if(joinable == HT_FALSE)
{
(void)pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
}
else
{
(void)pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
}
result = pthread_create(&tid, &attr, func, data);
(void)pthread_attr_destroy(&attr);
if(result != 0)
{
#ifdef HL_WINDOWS_APP
SetLastError((DWORD)result);
#endif
return (HThreadID)HT_INVALID;
}
if(joinable == HT_FALSE)
{
return NULL;
}
return (HThreadID)tid;
#endif
}

HL_EXP void HL_APIENTRY htThreadYield(void)
{
/* Windows threads */
#ifdef HT_WIN_THREADS
Sleep((DWORD)0);

/* POSIX systems */
#else
(void)sched_yield();

#endif
}

HL_EXP int HL_APIENTRY htThreadJoin(HThreadID threadID, void **status)
{
#ifdef HT_WIN_THREADS
/* Windows threads */
if(WaitForSingleObject((HANDLE)threadID, INFINITE) == WAIT_FAILED)
{
return EINVAL;
}
if(status != NULL)
{
(void)GetExitCodeThread((HANDLE)threadID, (LPDWORD)status);
}
(void)CloseHandle((HANDLE)threadID);
return 0;

#else
/* POSIX systems */
return pthread_join((pthread_t)threadID, status);
#endif
}

HL_EXP void HL_APIENTRY htThreadSleep(int mseconds)
{
#ifdef HL_WINDOWS_APP
Sleep((DWORD)mseconds);
#else /* !HL_WINDOWS_APP */
struct timespec     tv;

tv.tv_sec = mseconds / 1000;
tv.tv_nsec = (mseconds % 1000) * 1000;

(void)nanosleep(&tv, NULL);
#endif /* !HL_WINDOWS_APP */
/* can use usleep if nanosleep is not supported on your platform */
/*    (void)usleep(mseconds*1000); */
}


/*
HawkThreads mutex module
Copyright (C) 2003-2004 Phil Frisbie, Jr. (phil@hawksoft.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Or go to http://www.gnu.org/copyleft/lgpl.html
*/

#include "htinternal.h" // #include "htinternal.h"

#ifdef HT_WIN_THREADS

struct ht_mutex_t
{
CRITICAL_SECTION  mutex;
DWORD             thread;
};
#else /* !HT_WIN_THREADS */
#include <pthread.h>
#ifndef HL_WINDOWS_APP
#include <errno.h> // used to be <sys/errno.h>?
#endif /* HL_WINDOWS_APP */


struct ht_mutex_t
{
pthread_mutex_t   mutex;
};
#endif /* HT_WIN_THREADS */

HL_EXP int HL_APIENTRY htMutexInit(HTmutex *mutex)
{
if(mutex == NULL)
{
return EINVAL;
}
else
{
HTmutex mx;
#ifdef HT_WIN_THREADS
/* native Windows */

mx = (HTmutex)malloc(sizeof(struct ht_mutex_t));
if(mx == NULL)
{
return ENOMEM;
}
InitializeCriticalSection(&mx->mutex);
mx->thread = 0;
#else
/* POSIX */
pthread_mutexattr_t attr;
int                 result;

mx = (HTmutex)malloc(sizeof(struct ht_mutex_t));
if(mx == NULL)
{
return ENOMEM;
}
(void)pthread_mutexattr_init(&attr);
#if defined Macintosh
/* GUSI is not fully POSIX compliant, and does not define PTHREAD_MUTEX_ERRORCHECK */
(void)pthread_mutexattr_settype(&attr, NULL);
#else
(void)pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_ERRORCHECK);
#endif
result = pthread_mutex_init((pthread_mutex_t *)&mx->mutex, &attr);
(void)pthread_mutexattr_destroy(&attr);
if(result != 0)
{
return result;
}
#endif
*mutex = mx;
}
return 0;
}

HL_EXP int HL_APIENTRY htMutexLock(HTmutex *mutex)
{
if(mutex == NULL)
{
return EINVAL;
}
if(*mutex == NULL)
{
return EINVAL;
}
else
{
HTmutex mx = *mutex;
#ifdef HT_WIN_THREADS
DWORD threadid = GetCurrentThreadId();

/* native Windows */
/* this call will not stop recursion on a single thread */
EnterCriticalSection(&mx->mutex); // _Releases_lock_(mx->mutex) at function 'htMutexUnlock'.
/* check for recursion */
if(mx->thread == threadid)
{
/* must call LeaveCriticalSection for each EnterCriticalSection */
/* so this nullifies the above call to EnterCriticalSection*/
LeaveCriticalSection(&mx->mutex);
return EDEADLK;
}
else
{
mx->thread = threadid;
}
return 0;
#else
/* POSIX */
return pthread_mutex_lock((pthread_mutex_t *)&mx->mutex);
#endif
}
}

HL_EXP int HL_APIENTRY htMutexUnlock(HTmutex *mutex)
{
if(mutex == NULL)
{
return EINVAL;
}
if(*mutex == NULL)
{
return EINVAL;
}
else
{
HTmutex mx = *mutex;
#ifdef HT_WIN_THREADS
DWORD threadid = GetCurrentThreadId();

/* native Windows */
if((mx->thread == 0) ||(mx->thread != threadid))
{
return EPERM;
}
mx->thread = 0;
LeaveCriticalSection(&mx->mutex);
return 0;
#else
/* POSIX */
return pthread_mutex_unlock((pthread_mutex_t *)&mx->mutex);
#endif
}
}

HL_EXP int HL_APIENTRY htMutexDestroy(HTmutex *mutex)
{
if(mutex == NULL)
{
return EINVAL;
}
if(*mutex == NULL)
{
return EINVAL;
}
else
{
HTmutex mx = *mutex;
int     result = 0;
#ifdef HT_WIN_THREADS
/* native Windows */
DeleteCriticalSection(&mx->mutex);
#else
/* POSIX */
result = pthread_mutex_destroy((pthread_mutex_t *)&mx->mutex);
#endif
free(*mutex);
*mutex = NULL;
return result;
}
}

/*
HawkThreads condition module
Copyright (C) 2003-2004 Phil Frisbie, Jr. (phil@hawksoft.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Or go to http://www.gnu.org/copyleft/lgpl.html
*/

#include "htinternal.h" // #include "htinternal.h"

#ifdef HT_WIN_THREADS

enum {
SIGNAL = 0,
BROADCAST = 1,
MAX_EVENTS = 2
};

struct ht_cond_t
{
HANDLE events_[MAX_EVENTS];
};

#else /* !HT_WIN_THREADS */

#include <sys/timeb.h>

#ifdef HL_WINDOWS_APP
#define timeb _timeb
#define ftime _ftime
#else
/* Windows CE does not have time.h functions */
#if defined (_WIN32_WCE)
#ifndef TIME_T
#define TIME_T
time_t time(time_t *timer);
#endif
#else
#include <sys/time.h>
#endif
#endif /* HL_WINDOWS_APP */

#include <pthread.h>
struct ht_cond_t
{
pthread_cond_t    cond;
pthread_mutex_t   mutex;
};

#endif /* !HT_WIN_THREADS */

HL_EXP int HL_APIENTRY htCondInit(HTcond *cond)
{
if(cond == NULL)
{
return EINVAL;
}
else
{
#ifdef HT_WIN_THREADS
HTcond cv = NULL;

cv = (HTcond)malloc(sizeof(struct ht_cond_t));
if(cv == NULL)
{
return ENOMEM;
}
cv->events_[SIGNAL] = CreateEvent(NULL, FALSE, FALSE, NULL);
cv->events_[BROADCAST] = CreateEvent(NULL, TRUE, FALSE, NULL);
#else
int         result;
HTcond   cv = NULL;

cv = (HTcond)malloc(sizeof(struct ht_cond_t));
if(cv == NULL)
{
return ENOMEM;
}

result = pthread_cond_init((pthread_cond_t *)&cv->cond, NULL);
if(result != 0)
{
free(cv);
return result;
}
result = pthread_mutex_init((pthread_mutex_t *)&cv->mutex, NULL);
if(result != 0)
{
(void)pthread_cond_destroy((pthread_cond_t *)&cv->cond);
free(cv);
return result;
}
#endif
*cond = cv;
}
return 0;
}

HL_EXP int HL_APIENTRY htCondWait(HTcond *cond, int timeout)
{
if(cond == NULL)
{
return EINVAL;
}
if(*cond == NULL)
{
return EINVAL;
}
if(timeout <= 0)
{
HTcond cv = *cond;

#ifdef HT_WIN_THREADS
DWORD result;

result = WaitForMultipleObjects (2,cv->events_, FALSE, INFINITE);
if(result == WAIT_FAILED)
{
return EINVAL;
}
#else
int result = 0;

(void)pthread_mutex_lock((pthread_mutex_t *)&cv->mutex);
result = pthread_cond_wait((pthread_cond_t *)&cv->cond, (pthread_mutex_t *)&cv->mutex);
if(result != 0)
{
return result;
}
(void)pthread_mutex_unlock((pthread_mutex_t *)&cv->mutex);
#endif
}
else
{
HTcond cv = *cond;

#ifdef HT_WIN_THREADS
DWORD result;

result = WaitForMultipleObjects (2, cv->events_, FALSE, (DWORD)timeout);
if(result == WAIT_FAILED)
{
return EINVAL;
}
else if(result == (DWORD)WAIT_TIMEOUT)
{
return (int)ETIMEDOUT;
}
}
#else
int                 result = 0;
struct timespec     tv;
struct timeb        t;
long                ms;

/* convert timeout to an absolute time */
ftime(&t);
ms = t.millitm + timeout;
tv.tv_sec = t.time + (ms / 1000);
tv.tv_nsec = (ms % 1000) * 1000000;

pthread_mutex_lock((pthread_mutex_t *)&cv->mutex);
result = pthread_cond_timedwait((pthread_cond_t *)&cv->cond,
(pthread_mutex_t *)&cv->mutex, &tv);
if(result == ETIMEDOUT)
{
pthread_mutex_unlock((pthread_mutex_t *)&cv->mutex);
return ETIMEDOUT;
}
else if(result != 0)
{
return result;
}
pthread_mutex_unlock((pthread_mutex_t *)&cv->mutex);
}
#endif
return 0;
}

HL_EXP int HL_APIENTRY htCondSignal(HTcond *cond)
{
HTcond cv;

if(cond == NULL)
{
return EINVAL;
}
if(*cond == NULL)
{
return EINVAL;
}
else
{
#ifdef HT_WIN_THREADS
cv = *cond;
if(PulseEvent(cv->events_[SIGNAL]) == 0)
{
return EINVAL;
}
#else
int result;

cv = *cond;
result = pthread_cond_signal((pthread_cond_t *)&cv->cond);
if(result != 0)
{
return result;
}
#endif
}
return 0;
}

HL_EXP int HL_APIENTRY htCondBroadcast(HTcond *cond)
{
if(cond == NULL)
{
return EINVAL;
}
if(*cond == NULL)
{
return EINVAL;
}
else
{
HTcond  cv = *cond;

#ifdef HT_WIN_THREADS
if(PulseEvent(cv->events_[BROADCAST]) == 0)
{
return EINVAL;
}
return 0;
#else
return pthread_cond_broadcast((pthread_cond_t *)&cv->cond);
#endif
}
}

HL_EXP int HL_APIENTRY htCondDestroy(HTcond *cond)
{
if(cond == NULL)
{
return EINVAL;
}
if(*cond == NULL)
{
return EINVAL;
}
else
{
HTcond cv = *cond;
int result = 0;

#ifdef HT_WIN_THREADS
(void)CloseHandle(cv->events_[SIGNAL]);
(void)CloseHandle(cv->events_[BROADCAST]);
#else
result = pthread_cond_destroy((pthread_cond_t *)&cv->cond);
#endif
free(*cond);
*cond = NULL;
return result;
}
}


#include "stdafx.h" // #include "stdafx.h"
#include <stdio.h> // sprintf


#if defined(WIN32) && (_WIN32_WINNT >= 0x0501)
#define GFNET_USE_ADDRINFO
#elif defined(ANDROID)
#define GFNET_USE_ADDRINFO
#define GFNET_USE_IOCTL
#elif defined(POSIX)
#define GFNET_USE_GETIFADDRS
#endif

#define NET_REAL_NONBLOCKING // use real nonblocking sockets instead of select() stuff
// select does not seem to work on iphone when recv'ing



/*

UDP:
- only one "bind()" per port! or you get a port-busy msg.
- must bind() to "listen" to a port. Otherwise packages dropped.
- must provide sockaddr_in in send_to where desitnation IP+port is stored.

conclusion:
must hold a list of udp connections for each local upd port to "read" from.

*/




// #include "gffilesystem.h" // g_debug -> remove!!



#if defined(WIN32) || defined(WIN64)
#define NET_WIN_APP

#define WIN32_LEAN_AND_MEAN
#ifdef _WIN32_WCE
#include <winsock.h>
#include <sys/wcenetwork.h>
#define WSAAPI FAR PASCAL
#else
#include <winsock2.h>
#include <ws2tcpip.h>
#endif
#include <tchar.h>


// these might differ if already defined on Win32!
#ifdef EINPROGRESS
#undef EINPROGRESS
#undef EWOULDBLOCK
#undef ECONNRESET
#undef ENOMEM
#endif

// Windows error codes differ from these - I want them to have the right error string for debugging
#define EINPROGRESS		WSAEINPROGRESS
#define EWOULDBLOCK		WSAEWOULDBLOCK
#define ECONNRESET		WSAECONNRESET
#define ENOMEM			ERROR_NOT_ENOUGH_MEMORY
//	#define EAFNOSUPPORT	WSAEAFNOSUPPORT


#define net_errno WSAGetLastError()
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <sys/ioctl.h>
#include <errno.h>

#include <arpa/inet.h>

#ifndef INVALID_SOCKET
#define INVALID_SOCKET (-1)
#endif
#ifndef SOCKET_ERROR 
#define SOCKET_ERROR  (-1)
#endif

#ifndef SOCKET
typedef int SOCKET;
#endif

inline int closesocket(int sock) {return close(sock);} // unix way
#ifndef TCHAR
#ifdef _UNICODE
typedef wchar_t TCHAR;
#define TEXT(a) L##a
#define _stprintf wsprintf
#else
typedef char TCHAR;
#define TEXT(a) a
#define _stprintf sprintf
#endif
#endif

#define net_errno errno

#endif

#ifdef PALM_WEBOS
extern "C" int PDL_SetFirewallPortStatus(int port, int Open);
#endif






#include "gf_sockets.h" // #include "gf_sockets.h" // hopefully sockaddr_storage is defined, here


//// START gf_inet_ntop //////

/* This is from the BIND 4.9.4 release, modified to compile by itself */

/* Copyright (c) 1996 by Internet Software Consortium.
*
* Permission to use, copy, modify, and distribute this software for any
* purpose with or without fee is hereby granted, provided that the above
* copyright notice and this permission notice appear in all copies.
*
* THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
* ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
* OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
* CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
* DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
* PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
* ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
* SOFTWARE.
*/

#define	IN6ADDRSZ	16
#define	INT16SZ		 2


/*
* WARNING: Don't even consider trying to compile this on a system where
* sizeof(int) < 4.  sizeof(int) > 4 is fine; all the world's not a VAX.
*/

/* const char *
* inet_ntop4(src, dst, size)
*	format an IPv4 address, more or less like inet_ntoa()
* return:
*	`dst' (as a const)
* notes:
*	(1) uses no statics
*	(2) takes a u_char* not an in_addr as input
* author:
*	Paul Vixie, 1996.
*/
static const char *
gf_inet_ntop4(
const u_char *src,
char *dst,
size_t size)
{
sprintf(dst, "%u.%u.%u.%u", src[0], src[1], src[2], src[3]);
return (dst);
}

/* const char *
* inet_ntop6(src, dst, size)
*	convert IPv6 binary address into presentation (printable) format
* author:
*	Paul Vixie, 1996.
*/
static const char *
gf_inet_ntop6(
const u_char *src,
char *dst,
size_t size)
{
/*
* Note that int32_t and int16_t need only be "at least" large enough
* to contain a value of the specified size.  On some systems, like
* Crays, there is no such thing as an integer variable with 16 bits.
* Keep this in mind if you think this function should have been coded
* to use pointer overlays.  All the world's not a VAX.
*/
struct { int base, len; } best, cur;
u_int words[IN6ADDRSZ / INT16SZ];

/*
* Preprocess:
*	Copy the input (bytewise) array into a wordwise array.
*	Find the longest run of 0x00's in src[] for :: shorthanding.
*/
memset(words, 0, sizeof words);
for (int i = 0; i < IN6ADDRSZ; i++)
words[i / 2] |= (src[i] << ((1 - (i % 2)) << 3));
best.base = -1;
cur.base = -1;
for (int i = 0; i < (IN6ADDRSZ / INT16SZ); i++) {
if (words[i] == 0) {
if (cur.base == -1)
cur.base = i, cur.len = 1;
else
cur.len++;
} else {
if (cur.base != -1) {
if (best.base == -1 || cur.len > best.len)
best = cur;
cur.base = -1;
}
}
}
if (cur.base != -1) {
if (best.base == -1 || cur.len > best.len)
best = cur;
}
if (best.base != -1 && best.len < 2)
best.base = -1;

/*
* Format the result.
*/
char* tp = dst;
for(int i = 0; i < (IN6ADDRSZ / INT16SZ); i++) {
/* Are we inside the best run of 0x00's? */
if (best.base != -1 && i >= best.base &&
i < (best.base + best.len)) {
if (i == best.base)
*tp++ = ':';
continue;
}
/* Are we following an initial run of 0x00s or any real hex? */
if (i != 0)
*tp++ = ':';
/* Is this address an encapsulated IPv4? */
if (i == 6 && best.base == 0 &&
(best.len == 6 || (best.len == 5 && words[5] == 0xffff))) {
if (!gf_inet_ntop4(src+12, tp, sizeof dst - (tp - dst)))
return (NULL);
tp += strlen(tp);
break;
}
sprintf(tp, "%x", words[i]);
tp += strlen(tp);
}
/* Was it a trailing run of 0x00's? */
if (best.base != -1 && (best.base + best.len) == (IN6ADDRSZ / INT16SZ))
*tp++ = ':';
*tp++ = '\0';

return (dst);
}

/* char *
* inet_ntop(af, src, dst, size)
*	convert a network format address to presentation format.
* return:
*	pointer to presentation format address (`dst'), or NULL (see errno).
* author:
*	Paul Vixie, 1996.
*/
const char *
gf_inet_ntop(
int af,
const void *src,
char *dst,
size_t size)
{
if(af == AF_INET6) {
return (gf_inet_ntop6((const u_char *)src, dst, size));
}
return (gf_inet_ntop4((const u_char *)src, dst, size));
}
//// END gf_inet_ntop //////



















/*
What I've learned:
sockaddr - and variations
-------------------------
sockaddr is the generic term for a variety of sockaddr_xx.
As such, a "struct sockaddr" isn't really something you would declare (or "instantiate").
Declare your address to be of type "struct sockaddr_in" and cast its 
address into a "struct sockaddr *" when you need the latter.
Note that a "struct sockaddr" is *not* a union of all "struct sockaddr_xx"s
*/


static int gNumInit = 0;
static int gNetIPversion = AF_INET; // AF_INET(=2): IPv4, AF_INET6(=23): IPv6

// track errors at given positions
static int gNetErrNo = 0;
inline void netStoErr()
{
gNetErrNo = net_errno;
}

void netStoErr(int err)
{
gNetErrNo = err;
// g_debug("net last err: %s\n", netLastError());
}



#define MAX_NET_SOCKS	1024
struct NET_SOCKS
{
NET_SOCKS() {sock = INVALID_SOCKET;}
SOCKET			sock;
//	sockaddr_in		addr; // IPv4 remote IP+port (in network format)
sockaddr_storage addr; // IPv4+IPv6 storage structure (in network format)

void* get_ip() const
{
if(addr.ss_family == AF_INET6)
{
return &((sockaddr_in6*)&addr)->sin6_addr;
}
else
{
return &((sockaddr_in*)&addr)->sin_addr;
}
}
unsigned short get_port() const
{
if(addr.ss_family == AF_INET6)
{
return ((sockaddr_in6*)&addr)->sin6_port;
}
else
{
return ((sockaddr_in*)&addr)->sin_port;
}
}


bool			udp;
#ifndef NET_REAL_NONBLOCKING
bool			blocking;
#endif
} gNetSocks[MAX_NET_SOCKS];


// ----------------------------------------- //
// NETaddress :: get_family_ofIPv
// ----------------------------------------- //
int NETaddress::get_family_ofIPv(int v)
{
if(v == 6)
return AF_INET6;
return AF_INET;
}

// ----------------------------------------- //
// NETaddress :: assign
// ----------------------------------------- //
void NETaddress::assign(int iFamily, const void* pIP, unsigned short port_hostmachine_format)
{
m_ipFamily=iFamily;
m_port=htons(port_hostmachine_format);
if(pIP)
{
if(iFamily == AF_INET6)
{
memcpy(m_ip, pIP, 16);
}
else
{
memcpy(m_ip, pIP, 4);
}
}
else
{
memset(m_ip, 0, sizeof(m_ip));
}
}


// ----------------------------------------- //
// NETaddress :: assign
// ----------------------------------------- //
void NETaddress::assign(LP_SOCKADDR_STORAGE ptr_sockaddr_storage)
{
if(((sockaddr_storage*)ptr_sockaddr_storage)->ss_family == AF_INET6)
{
sockaddr_in6* pin = (sockaddr_in6*)ptr_sockaddr_storage;

m_ipFamily = pin->sin6_family;
memcpy(m_ip, &pin->sin6_addr, 16);
m_port = pin->sin6_port;
}
else
{
sockaddr_in* pin = (sockaddr_in*)ptr_sockaddr_storage;

m_ipFamily = pin->sin_family;
memcpy(m_ip, &pin->sin_addr, 4);
m_port = pin->sin_port;
}

}


// ----------------------------------------- //
// NETaddress :: fill_sockaddr_storage
// ----------------------------------------- //
void NETaddress::fill_sockaddr_storage(LP_SOCKADDR_STORAGE ptr_sockaddr_storage)const
{
if(m_ipFamily == AF_INET6)
{
sockaddr_in6* pin = (sockaddr_in6*)ptr_sockaddr_storage;
memset(pin, 0, sizeof(*pin));

pin->sin6_family = AF_INET6;
memcpy(&pin->sin6_addr, m_ip, 16);
pin->sin6_port = m_port;
}
else
{
sockaddr_in* pin = (sockaddr_in*)ptr_sockaddr_storage;
memset(pin, 0, sizeof(*pin));

pin->sin_family = AF_INET;
memcpy(&pin->sin_addr, m_ip, 4);
pin->sin_port = m_port;
}

}



// ----------------------------------------- //
// ----------------------------------------- //
NETsocket net_internGetFreeSocket()
{
for(NETsocket i=0; i<MAX_NET_SOCKS; ++i)
{
if(gNetSocks[i].sock == INVALID_SOCKET)
return i;
}

netStoErr(ENOMEM);
return NET_INVALID;
}

#ifdef POSIX
void sigpipe_handler(int)
{
// g_debug("SIGPIPE caught\n");
}
#endif

// ----------------------------------------- //
// ----------------------------------------- //
bool netInit()
{
#ifdef NET_WIN_APP
WSADATA wsaData;
if(!gNumInit)
{
if(WSAStartup(MAKEWORD(1, 1), &wsaData) != 0)
{
netStoErr();
return false;
}
}
#endif

#ifdef SIGPIPE
// instal sigpipe handler
signal(SIGPIPE,sigpipe_handler);
#endif

// clear all sockets at frist start
if(!gNumInit)
{
memset(gNetSocks, 0, sizeof(gNetSocks));
for(int i=0; i<MAX_NET_SOCKS; ++i)
{
gNetSocks[i].sock = INVALID_SOCKET;
}
}
++gNumInit;
netStoErr();
return true;
}

// ----------------------------------------- //
// Set IPv4 or IPv6 mode
// only accepted values are 4: IPv4 and 6: IPv6
// ----------------------------------------- //
void netSetVersion(int iv)
{
#ifdef AF_INET6
switch(iv)
{
case 6:  gNetIPversion = AF_INET6; break;
default: gNetIPversion = AF_INET;  break;
}
#endif
}

// ----------------------------------------- //
// ----------------------------------------- //
void netShutdown()
{
--gNumInit;
if(gNumInit<=0)
{
// clear all other sockets, too
for(int i=0; i<MAX_NET_SOCKS; ++i)
{
if(gNetSocks[i].sock != INVALID_SOCKET)
{
netCloseSocket(i);
}
}
gNumInit=0;

#ifdef NET_WIN_APP
WSACleanup();
#endif
netStoErr();
}
}


// ----------------------------------------- //
// ADDRESS
// ----------------------------------------- //
NETaddress netAddress(const char* server, unsigned short port)
{
bool bWantIPv6 = (gNetIPversion == AF_INET6)?true:false;

hostent* hostentry = NULL;
if(server && server[0] != '\0')
{
#ifdef GFNET_USE_ADDRINFO
struct addrinfo hints, *res=NULL;
int status;

memset(&hints, 0, sizeof(hints));
// TODO(gf) IPv6
hints.ai_family = gNetIPversion; // AF_INET (IPv4) or AF_INET6 (IPv6) to force version
hints.ai_family = bWantIPv6 ? AF_INET6 : AF_UNSPEC; // ip4 or ip6 - no care
hints.ai_socktype = SOCK_STREAM;
hints.ai_protocol = IPPROTO_TCP;

if ((status = getaddrinfo(server, NULL, &hints, &res)) != 0)
{
netStoErr();

const char* pErr = netLastError();
return NET_ADDR_INVALID;
}


NETaddress na_ret = NET_ADDR_INVALID;
for(struct addrinfo* ptr=res; ptr != NULL; ptr=ptr->ai_next)
{
sockaddr_storage storage;
memset(&storage, 0, sizeof(storage));
switch (ptr->ai_family)
{
case AF_INET:
na_ret.assign((LP_SOCKADDR_STORAGE)ptr->ai_addr);
na_ret.m_port = htons(port);
if(!bWantIPv6)
return na_ret;
break;
case AF_INET6:
na_ret.assign((LP_SOCKADDR_STORAGE)ptr->ai_addr);
na_ret.m_port = htons(port);
if(bWantIPv6)
return na_ret;
break;
}
}
return na_ret;

#else
hostentry = gethostbyname(server);
if(hostentry != NULL)
{
NETaddress addr;
addr.assign(gNetIPversion, hostentry->h_addr_list[0], port);

// addr.m_port = htons(port);
// addr.ip = *(unsigned long*)hostentry->h_addr_list[0]; // network format
return addr;
}
#endif
}
else // get a localhost IP
{
// this fails on linux
/*
hostentry = gethostbyname("localhost");
*/
int count=0;
const char* pHostName = netGetLocalIPs(&count, "\n");
if(count && pHostName)
{
char tmp[1024];
strncpy(tmp, pHostName, 1023);
tmp[1023] = '\0';
for(int i=0; i<1023; ++i)
{
if (tmp[i]=='\n')
{
tmp[i]='\0';
break;
}
}
return netAddress(tmp, port);
// hostentry = gethostbyname(tmp);
}

NETaddress addr;
addr = bWantIPv6 ? netAddress("::1", port) : netAddress("127.0.0.1", port);
if(addr != NET_ADDR_INVALID)
return addr;
addr =netAddress("localhost.local", port);
if(addr != NET_ADDR_INVALID)
return addr;
addr =netAddress("localhost", port);
return addr;
}

netStoErr();
return NET_ADDR_INVALID;
}

// ----------------------------------------- //
// ----------------------------------------- //
NETaddress netAddressIP4(unsigned char ip1, unsigned char ip2, unsigned char ip3, unsigned char ip4, unsigned short port)
{
NETaddress addr;
unsigned char ipv4[4]; ipv4[0]=ip1; ipv4[1]=ip2; ipv4[2]=ip3; ipv4[3]=ip4;

unsigned long ipV4 = htonl(*(unsigned long*)ipv4);
addr.assign(AF_INET, &ipV4, port);

return addr;
}

// ----------------------------------------- //
// Find remote connection (or last UDP recv)
// ----------------------------------------- //
NETaddress netGetRemoteAddress(NETsocket isock)
{
NET_SOCKS& s = gNetSocks[isock];
if(s.sock != INVALID_SOCKET)
{
NETaddress addr;

addr.assign(s.addr.ss_family, s.get_ip(), (unsigned short)ntohl(s.get_port()) );
// addr.ip =   s.addr.sin_addr.s_addr;
// addr.port = s.addr.sin_port;
return addr;
}
return NET_ADDR_INVALID;
}


// ----------------------------------------- //
// ----------------------------------------- //
void netSetBlocking(NETsocket isock, bool block)
{
#ifdef NET_REAL_NONBLOCKING
if(gNetSocks[isock].sock != INVALID_SOCKET)
{
// If iCtlMode != 0, non-blocking mode is enabled.
unsigned long iCtlMode = block ? 0 : 1;
#ifdef NET_WIN_APP
ioctlsocket(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
#else
ioctl(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
#endif
}
netStoErr();
#else
gNetSocks[isock].blocking = block;
#endif

#if defined(SO_NOSIGPIPE)
int set = 1;
setsockopt(gNetSocks[isock].sock, SOL_SOCKET, SO_NOSIGPIPE, (void *)&set, sizeof(int));
#endif
}

// ----------------------------------------- //
// create a socket that listens to a port
// returns socket index, or NET_INVALID if error
// ----------------------------------------- //
NETsocket netListen(unsigned short port)
{
// create a wrapper socket
NETsocket isock = net_internGetFreeSocket();
if (isock<0)
{
return NET_INVALID;
}

SOCKET sockfd;
// make a socket, bind it, and listen on it:
sockfd = socket(gNetIPversion, SOCK_STREAM, IPPROTO_TCP);
if(sockfd == INVALID_SOCKET)
{
netStoErr();
return NET_INVALID;
}


// The sockaddr_in structure specifies the address family,
// IP address, and port for the socket that is being bound.
// sockaddr_in service; // IPv4
sockaddr_storage service; // IPv4 and IPv6 storage

NETaddress na_service = NET_ADDR_ANY; // TODO(gf) optionally use an IP address here, to decide what network card to use (tunnel, wifi, 3G, ..)
na_service.m_port = htons(port);
na_service.m_ipFamily = gNetIPversion;
na_service.fill_sockaddr_storage(&service);

/*
memset(&service, 0, sizeof(service));
service.sin_family = gNetIPversion;
service.sin_addr.s_addr = INADDR_ANY; // (unsigned long)htonl(0x7f000001); // = inet_addr("127.0.0.1");
service.sin_port = htons(port);
*/

// ignore if that port is still open from an old session
const int reuse=1;
setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, (const char*)&reuse, sizeof(reuse));

#ifdef PALM_WEBOS
PDL_SetFirewallPortStatus(port, 1);
#endif

// bind to ip/port (what device and port to use for next listen/connect call)
if(bind(sockfd, (sockaddr*)&service, sizeof(service)) == SOCKET_ERROR)
{
netStoErr();
closesocket(sockfd);
return NET_INVALID;
}

// listen
if(listen(sockfd, 10) == SOCKET_ERROR)
{
netStoErr();
closesocket(sockfd);
return NET_INVALID;
}

gNetSocks[isock].sock = sockfd;
memcpy(&gNetSocks[isock].addr, &service, sizeof(service));
gNetSocks[isock].udp  = false;

netSetBlocking(isock, false);
return isock;
}

// ----------------------------------------- //
// ----------------------------------------- //
NETsocket netAccept(NETsocket isock, NETaddress* pAddress)
{
if(gNetSocks[isock].udp)
{
netStoErr(0); // #NEED better error
return NET_INVALID; // only for tcp streams
}

#ifndef NET_REAL_NONBLOCKING
int n = netSelect(isock);
if(n!=1) return NET_INVALID;
#endif

// sockaddr_in addr; // IPv4
sockaddr_storage addr; // IPv6 compatible
socklen_t szadd = sizeof(addr);

SOCKET sock = accept(gNetSocks[isock].sock, (sockaddr*)&addr, &szadd);
netStoErr();

if (sock != INVALID_SOCKET)
{
netStoErr(ENOMEM);
NETsocket iFree = net_internGetFreeSocket();
if(iFree == -1)
{
closesocket(sock);
return NET_INVALID;
}
gNetSocks[iFree] = gNetSocks[isock];

gNetSocks[iFree].sock = sock;
memcpy(&gNetSocks[iFree].addr, &addr, sizeof(addr)); // [isock] - war falsch, oder?

if(pAddress)
{
pAddress->assign(&addr);
/*
pAddress->ip   = addr.sin_addr.s_addr;
pAddress->port = addr.sin_port;
*/
}

netSetBlocking(iFree, false);
return iFree;
}
return NET_INVALID;
}


// ----------------------------------------- //
// returns socket index, or -1 if error
// ----------------------------------------- //
NETsocket netConnect(const NETaddress& server, int timeout_ms)
{
if(server == NET_ADDR_INVALID) return NET_INVALID;

// create a wrapper socket
NETsocket isock = net_internGetFreeSocket();
netStoErr();
if (isock<0)
{
return NET_INVALID;
}


// make a socket:
SOCKET sockfd;
sockfd = socket(server.m_ipFamily, SOCK_STREAM, IPPROTO_TCP);
if(sockfd == INVALID_SOCKET)
{
netStoErr();
return NET_INVALID;
}

// sockaddr_in service; // IPv4
sockaddr_storage service; // IPv6 compatible
server.fill_sockaddr_storage(&service);
/*
memset(&service, 0, sizeof(service));
service.sin_family      = gNetIPversion;
service.sin_addr.s_addr = (int)server.ip;
service.sin_port        = server.port;
*/
// no need to bind.
// we only care where we are going. The system will assign a local port for us.
gNetSocks[isock].sock = sockfd;
memcpy(&gNetSocks[isock].addr, &service, sizeof(service) );
gNetSocks[isock].udp  = false;

#if defined(_WIN32_WCE)
// This call will return immediately, coz our socket is non-blocking
int Ret = connect(sockfd, (const sockaddr*)&service, sizeof(service));

if(Ret == SOCKET_ERROR)
{
netStoErr();
// g_debug("connect rv:%d - %s\n", Ret, netLastError());
// g_debug("%s:%d, sock=%d\n", netGetIPstr(server), netGetPort(server), (int)sockfd);

netCloseSocket(isock);
return NET_INVALID;
}
netSetBlocking(isock, false);
return isock;
#else
;

// we need a real non-blocking socket here!
// If iCtlMode != 0, non-blocking mode is enabled.
unsigned long iCtlMode = 1;
#ifdef NET_WIN_APP
ioctlsocket(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
#else
ioctl(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
#endif

int ok=0;

// This call will return immediately, coz our socket is non-blocking
int Ret = connect(sockfd, (const sockaddr*)&service, sizeof(service));

// If connected, it will return 0, or error
if (Ret == SOCKET_ERROR)
{
int iErr = net_errno;

// Check if the error was WSAEWOULDBLOCK, where we'll wait.
if (iErr == EWOULDBLOCK || iErr==EINPROGRESS)
{
// g_debug("\nConnect() returned WSAEWOULDBLOCK. Need to Wait..");
fd_set  fdWrite, fdErr;
timeval Timeout;

FD_ZERO(&fdWrite);
FD_ZERO(&fdErr);
FD_SET(sockfd, &fdWrite);
FD_SET(sockfd, &fdErr);

if (timeout_ms <= 0 || timeout_ms>30000)
timeout_ms = 30000;
Timeout.tv_sec  = timeout_ms/1000;
Timeout.tv_usec = timeout_ms * 1000 - (timeout_ms/1000) * 1000000; // your timeout

Ret = select((int)sockfd+1, NULL, &fdWrite, &fdErr, &Timeout);
if (Ret == 0)
{
netCloseSocket(isock);
netStoErr(EINPROGRESS);
// g_debug("\nConnect Timeout (%d ms).", timeout_ms);
return NET_INVALID;
}
else
{
if (FD_ISSET(sockfd, &fdWrite))
{
// g_debug("\nConnected...");
netStoErr();
ok = 1;
}
if (FD_ISSET(sockfd, &fdErr))
{
// g_debug("\nSelect() Error.");
}
}
}
else
{
// g_debug("\nConnect Error %d\n", iErr);
}
}
else
{
// printf("\nWoooo!! got connected with NO Waiting!!");
ok = 1;
}

if(ok)
{
// restore blocking mode, for the virtual nonblocking mode
iCtlMode = 0;
#ifdef NET_WIN_APP
ioctlsocket(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
#else
ioctl(gNetSocks[isock].sock, FIONBIO, &iCtlMode);
#endif

// set nonblocking as implemented for default sockets
netSetBlocking(isock, false);
return isock;
}

netStoErr();
netCloseSocket(isock);
return NET_INVALID;
#endif
}



// ----------------------------------------- //
// convert network style address to IP string
// ----------------------------------------- //
static void sprintf_IP4(char* str, in_addr* addr)
{
int split[4];
unsigned long ip;
unsigned long *x = (unsigned long*)addr;

// TODO(gf) IPv6
ip = ntohl(*x);
split[0] = (ip & 0xff000000) >> 24;
split[1] = (ip & 0x00ff0000) >> 16;
split[2] = (ip & 0x0000ff00) >> 8;
split[3] = (ip & 0x000000ff);
sprintf(str, "%d.%d.%d.%d", split[0], split[1], split[2], split[3]);
}



// for better debugging
const char* netGetIPstr(const NETaddress& address)
{
#ifdef AF_INET6
static char tmp[128];
#ifdef _DEBUG
if(address.m_ipFamily == AF_INET6)
{
sockaddr_storage addr;
addr.ss_family = address.m_ipFamily;
// fe80::d64:c6d0:8271:6d28%20
memcpy(&((sockaddr_in6*)&addr)->sin6_addr, address.m_ip, sizeof(((sockaddr_in6*)&addr)->sin6_addr) );
int pause=1;
}
else
{
sockaddr_storage addr;
addr.ss_family = address.m_ipFamily;
memcpy(&((sockaddr_in*)&addr)->sin_addr, address.m_ip, sizeof(((sockaddr_in*)&addr)->sin_addr));
int pause=1;
}
#endif
gf_inet_ntop(address.m_ipFamily, (void*)address.m_ip, tmp, sizeof(tmp));
return tmp;
#else
static char tmp[32];
sprintf_IP4(tmp, (in_addr*) &address);
return tmp;
#endif
}

// TODO(gf)
/*
unsigned long  netGetIP (const NETaddress& address) // in host format
{
return ntohl(address.ip);
}
*/

unsigned short netGetPort(const NETaddress& address) // in local format
{
return ntohs(address.m_port);
}



// ----------------------------------------- //
// Create a new socket, used to send and receive to/from another
// computer.
// ----------------------------------------- //
NETsocket netSocketUdp(unsigned short port)
{
int isock = net_internGetFreeSocket();
if(isock<0) return NET_INVALID;

#ifdef PALM_WEBOS
PDL_SetFirewallPortStatus(port, 1);
#endif


NET_SOCKS& mysock = gNetSocks[isock];
NETaddress na_any = NET_ADDR_ANY;
na_any.m_port = htons(port);
na_any.m_ipFamily = gNetIPversion;
na_any.fill_sockaddr_storage(&mysock.addr);

mysock.udp = true;
/*
mysock.addr.sin_family      = gNetIPversion;
mysock.addr.sin_addr.s_addr = INADDR_ANY;
mysock.addr.sin_port        = htons(port);
*/



SOCKET sock = socket(gNetIPversion, SOCK_DGRAM, IPPROTO_UDP);
netStoErr();
if(sock == INVALID_SOCKET)
{
return NET_INVALID;
}
mysock.sock = sock;

// ignore if that port is still open from an old session
const int reuse=1;
setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (const char*)&reuse, sizeof(reuse));

// bind to port
if(port >  0 && bind(sock, (sockaddr*)&mysock.addr, sizeof(mysock.addr)) == SOCKET_ERROR)
{
netStoErr();
closesocket(sock);
return NET_INVALID;
}

// remove "red button saftety cap" for broadcasts
const int broadcast = 1;
if (setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (const char*) &broadcast, sizeof(broadcast) ) == SOCKET_ERROR)
{
// Beej suggests this might be neccessary sometimes!?
char cbroadcast = '1';
setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (const char*) &cbroadcast, sizeof(cbroadcast) );
}

netSetBlocking(isock, false);
return isock;
}


// ----------------------------------------- //
// Close the cocket, if it is no UDP socket
// 0 = OK, SOCKET_ERROR = failed.
// ----------------------------------------- //
int netCloseSocket(NETsocket isock)
{
SOCKET sock = gNetSocks[isock].sock;
gNetSocks[isock].sock = INVALID_SOCKET; // set unusable, also UDP "sockets", but not "the" UDP sock

//	if(gNetSocks[isock].udp) return 0; // OK, don't close my UDP socket, I just have one.

//	#if !defined(EMSCRIPTEN)
linger ling;
ling.l_linger = 0;
ling.l_onoff = 0;
setsockopt(sock, SOL_SOCKET, SO_LINGER, (const char*)&ling, sizeof(ling));
//	#endif

shutdown(sock, 0x02); // SD_BOTH=0x02
int rv = closesocket(sock);
netStoErr();
return rv;
}


// ----------------------------------------- //
// -1 : error
//  n,0: ok, sent all.
// ----------------------------------------- //
int netSend(NETsocket isock, const char* buf, int len, NETaddress* pUDPtarget)
{
NET_SOCKS& nsock = gNetSocks[isock];
int total = 0; // how many bytes we've sent
int bytesleft = len; // how many we have left to send
int n;

// sockaddr_in addr; // IPv4
sockaddr_storage addr; // IPv6+IPv4
if(gNetSocks[isock].udp)
{
if(!pUDPtarget || *pUDPtarget == NET_ADDR_INVALID)
return -1;

memcpy(&addr, &nsock.addr, sizeof(nsock.addr));
pUDPtarget->fill_sockaddr_storage(&addr);

/*
addr.sin_addr.s_addr = (int)pUDPtarget->ip;
addr.sin_port        = pUDPtarget->port;
*/
}

while(total < len)
{
if(gNetSocks[isock].udp)
{
// sock - information: where does this send come from (IP+port)
// addr - information: where to send that package to  (IP+port)
n = (int)sendto(nsock.sock, buf+total, bytesleft, 0, (sockaddr*)&addr, sizeof(nsock.addr));
}
else
{
n = (int)send  (nsock.sock, buf+total, bytesleft, 0);
}
netStoErr();
if (n < 0)
{
// non blocking not ready -> wait until you can write it all
if(net_errno == EWOULDBLOCK)
{
continue;
}
return -1;
}
total += n;
bytesleft -= n;
}
return total; // return -1 on failure, number sent on success
}


// ----------------------------------------- //
// See if the socket is ready to read
// Returns:
//  1: ok
// -1: error
// -2: would block
// ----------------------------------------- //
int netSelect(NETsocket isock)
{
const NET_SOCKS& nsock = gNetSocks[isock];
timeval timevalInfo;
timevalInfo.tv_sec = 0;
timevalInfo.tv_usec = 0;
//made fd_set struct
fd_set Sockets = {1, nsock.sock}; // contains list of sockets for select

// not all compilers have that
// Sockets.fd_count = 1; // one socket
// Sockets.fd_array[0] = nsock.sock; // add it
// call select to determine readability of function
int readycount = select((int)(nsock.sock+1), &Sockets, NULL, NULL, &timevalInfo);

if(readycount < 0)
{
netStoErr();
return -1;
}
else if(readycount == 0) // time expired
return -2;

#if !defined(_WIN32_WCE)
// ok, seems to be ready.
if (FD_ISSET(nsock.sock, &Sockets))
return 1; // yes, data is there
#endif

return -2; // no data to read
}

// ----------------------------------------- //
// -2 : EWOULDBLOCK -> just ignore for non blocking reads
// -1 : error
//  0 : sender quit
//  n : ok, recieved "n" bytes.
// ----------------------------------------- //
int netRecv(NETsocket isock, char* buf, int len, bool force_read_all)
{
NET_SOCKS& nsock = gNetSocks[isock];
int n;

if(nsock.udp)
{
NETaddress na_any = NET_ADDR_ANY;
na_any.m_ipFamily = gNetIPversion;
na_any.fill_sockaddr_storage(&nsock.addr);

/*
nsock.addr.sin_addr.s_addr = INADDR_ANY;
nsock.addr.sin_port = 0;
*/
}

#ifndef NET_REAL_NONBLOCKING
if(!nsock.blocking)
{
n = netSelect(isock);
if(n!=1) return n;
}
#endif


if(force_read_all)
{
int nread=len;
while(len > 0)
{
if(nsock.udp)
{
// UDP - remote IP
socklen_t szadd = sizeof(nsock.addr);
n = (int)recvfrom(nsock.sock, buf, len, 0, (sockaddr*)&nsock.addr, &szadd);
}
else
{
n = (int)recv(nsock.sock, buf, len, 0);
}

netStoErr();
if (n>0) // positive read
{
len-=n;
buf+=n;
}
else if(n<0)
{
if(net_errno == EWOULDBLOCK)
{
// no data to read, and not started to read, yet
if(len == nread)
{
return -2;
}
continue;
}
if(net_errno == ECONNRESET)
return 0;
// real error
return -1;
}
else if (n==0) // connection closed
{
return 0;
}
}
return nread;
}
else
{
if(nsock.udp)
{
socklen_t szadd = sizeof(nsock.addr);
n = (int)recvfrom(nsock.sock, buf, len, 0, (sockaddr*)&nsock.addr, &szadd);
}
else
{
n = (int)recv(nsock.sock, buf, len, 0);
}
netStoErr();

if(n<0)
{
int iErr = net_errno;
switch(net_errno)
{
case ECONNRESET:
return 0;
case EWOULDBLOCK:
return -2;
default:
return n;
}
}
return n;
}
}

#ifdef GFNET_USE_GETIFADDRS
#include <ifaddrs.h>
#include <arpa/inet.h>
void netGetLocalIPs_getifaddrs(char* pOut, int* count, const char* delimiter)
{
int has_loopback = 0;
*pOut='\0';
*count=0;
struct ifaddrs *interfaces = NULL;
struct ifaddrs *temp_addr = NULL;
int success = 0;

// retrieve the current interfaces - returns 0 on success
success = getifaddrs(&interfaces);
if (success == 0)
{
// Loop through linked list of interfaces
temp_addr = interfaces;
while(temp_addr != NULL)
{
if( temp_addr->ifa_addr // can be NULL!!
&& temp_addr->ifa_addr->sa_family == gNetIPversion)
{
// Check if interface is en0 which is the wifi connection on the iPhone
// -> you can't be sure!!
// if([[NSString stringWithUTF8String:temp_addr->ifa_name] isEqualToString:@"en0"])
{
// const char* pIP = inet_ntoa(((struct sockaddr_in *)temp_addr->ifa_addr)->sin_addr);
char buffer[512];
gf_inet_ntop(gNetIPversion, &temp_addr->ifa_addr, buffer, sizeof(buffer));
const char* pIP = buffer;
if(strcmp(pIP, "127.0.0.1")==0 || strcmp(pIP, "0:0:0:0:0:0:0:1")==0 || strcmp(pIP, "::1")==0 )
has_loopback=1;
else if(pIP)
{
strcat(pOut, pIP);
strcat(pOut, delimiter);
(*count)++;
}
}
}
temp_addr = temp_addr->ifa_next;
}
}
else
{
netStoErr();
}

// make that the last one
if(has_loopback)
{
strcat(pOut, "127.0.0.1");
strcat(pOut, delimiter);
(*count) ++;
}
// printf("alternative: %d %s\n", (int)*count, pOut);
// Free memory
freeifaddrs(interfaces);
}
#endif


// Using ioctl instead of getifaddrs
#ifdef GFNET_USE_IOCTL
#include <sys/socket.h>
#include <netinet/in.h>
#include <linux/if.h>
#include <linux/sockios.h>
#include <arpa/inet.h>
void netGetLocalIPs_ioclt(char* pOut, int* count, const char* delimiter)
{
// here PF_INET instead of AF_INET should be used, but they are a relict and have the same value.
SOCKET fd = socket(gNetIPversion, SOCK_STREAM, IPPROTO_TCP);

#ifdef _AIX
int cmd = CSIOCGIFCONF;
#else
int cmd = SIOCGIFCONF;
#endif
ifconf ifc;
int numaddrs = 10;
int old_ifc_len = 0;

// Need to call ioctl multiple times since we do not know up front
// how many addresses there will be, and thus how large a buffer we need.
// We keep increasing the buffer size until subsequent calls return
// the same length, meaning we have all the addresses.
while(true)
{
int bufsize = numaddrs * sizeof(ifreq);
ifc.ifc_len = bufsize;
ifc.ifc_buf = new char[bufsize];
int rs = ioctl(fd, cmd, &ifc);
if(rs == SOCKET_ERROR)
{
netStoErr();
delete[] ifc.ifc_buf;
closesocket(fd);
return;
}
else if(ifc.ifc_len == old_ifc_len)
{
// Returned same length twice in a row, finished.
// (sufficient memory allocated)
break;
}
else
{
old_ifc_len = ifc.ifc_len;
}
// allocation was insufficient
numaddrs += 10;
delete[] ifc.ifc_buf;
}

numaddrs = ifc.ifc_len / sizeof(ifreq);
ifreq* ifr = ifc.ifc_req;

bool has_loopback=false;
for(int i = 0; i < numaddrs; ++i)
{
if(ifr[i].ifr_addr.sa_family == gNetIPversion && !(ifr[i].ifr_flags & IFF_LOOPBACK))
{
struct sockaddr_in* addr = reinterpret_cast<struct sockaddr_in*>(&ifr[i].ifr_addr);
if(addr->sin_addr.s_addr != 0)
{
// const char* pIP = inet_ntoa(( addr )->sin_addr);
char buffer[512];
gf_inet_ntop(gNetIPversion, &( addr )->sin_addr, buffer, sizeof(buffer));
const char* pIP = buffer;


if(strcmp(pIP, "127.0.0.1")==0 || strcmp(pIP, "0:0:0:0:0:0:0:1")==0 || strcmp(pIP, "::1")==0 )
has_loopback=1;
else if(pIP)
{
strcat(pOut, pIP);
strcat(pOut, delimiter);
(*count)++;
}
}
}
}

// make that the last one
if(has_loopback)
{
#ifdef AF_INET6
if(gNetIPversion == AF_INET6)
{
strcat(pOut, "0:0:0:0:0:0:0:1");
}
else
#endif
{
strcat(pOut, "127.0.0.1");
}
strcat(pOut, delimiter);
(*count) ++;
}
delete[] ifc.ifc_buf;
closesocket(fd);
return;
}
#endif

// ----------------------------------------- //
// ----------------------------------------- //
const char* netGetLocalIPs(int* count, const char* delimiter)
{
#define MAXHOSTNAMELEN 128 // 64+1 on linux
*count = 0;

const int max_length=MAXHOSTNAMELEN * 16;
static char alladdr[max_length];
alladdr[0]='\0';

// Try the better methods first
#ifdef GFNET_USE_GETIFADDRS
netGetLocalIPs_getifaddrs(alladdr, count, delimiter);
if (count) return alladdr;
#endif

#ifdef GFNET_USE_IOCTL
netGetLocalIPs_ioclt(alladdr, count, delimiter);
if(count) return alladdr;
#endif


#ifdef GFNET_USE_ADDRINFO
struct addrinfo hints, *res=NULL;
int status;
// TODO(gf) IPv6
if(gethostname(alladdr, MAXHOSTNAMELEN) == SOCKET_ERROR)
{
netStoErr();
return NULL;
}

memset(&hints, 0, sizeof(hints));
// TODO(gf) IPv6
hints.ai_family = gNetIPversion; // AF_INET (IPv4) or AF_INET6 (IPv6) to force version
hints.ai_socktype = SOCK_STREAM;

if ((status = getaddrinfo(alladdr, NULL, &hints, &res)) != 0)
{
netStoErr();
return NULL;
}
#else
if(gethostname(alladdr, MAXHOSTNAMELEN) == SOCKET_ERROR)
{
netStoErr();
return NULL;
}
alladdr[MAXHOSTNAMELEN - 1] = '\0';

hostent* local = gethostbyname(alladdr);
netStoErr();
if(local == NULL)
{
return NULL;
}
#endif

// fill in the addresses
alladdr[0] = '\0';
char tmp[256];
int curlen = 0;
int delimlen=(int)strlen(delimiter);
bool has_loopback=false;

#ifdef GFNET_USE_ADDRINFO
for(struct addrinfo *p = res;p != NULL; p = p->ai_next)
{
sockaddr_storage* sain = (sockaddr_storage*)p->ai_addr;

NETaddress nad;
nad.assign(sain);
strcpy(tmp, netGetIPstr(nad));

// sprintf_IP4(tmp, &sain->sin_addr);
#else
for(int i=0; local->h_addr_list[i] != NULL; ++i)
{
// TODO(gf) IPv6
sprintf_IP4(tmp, (in_addr*)local->h_addr_list[i]);
#endif
int addlen = (int)strlen(tmp) + delimlen;
if(curlen + addlen >= max_length)
break;
curlen += addlen;
// skip 127.xxx address, that's not of any interest

if(strcmp(tmp, "127.0.0.1")==0  || strcmp(tmp, "0:0:0:0:0:0:0:1")==0 || strcmp(tmp, "::1")==0 )
{
has_loopback=true;
continue;
}
(*count)++;
strcat(alladdr, tmp);
strcat(alladdr, delimiter);
}
#ifdef GFNET_USE_ADDRINFO
freeaddrinfo(res);
#endif

// make that the last one
if(has_loopback)
{
(*count) ++;
if(gNetIPversion == AF_INET6)
strcat(alladdr, "::1");
else
strcat(alladdr, "127.0.0.1");
strcat(alladdr, delimiter);
}
return alladdr;
}


// Get the error and a description
const char* netLastError()
{
#ifdef NET_WIN_APP
#ifndef _UNICODE
TCHAR errmsg[512];
static TCHAR fullerr[512];
int err = gNetErrNo;
if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,0,err,0,errmsg,511,NULL))
{
sprintf(fullerr, "%d %s", err, errmsg);
return fullerr;
}
#endif
return "";
#else
static char fullerr[512];
sprintf(fullerr, "%d %s", gNetErrNo, strerror(gNetErrNo));
return fullerr;
#endif
}

int netLastErrNum(){ return gNetErrNo;}
// blowfish.cpp   C++ class implementation of the BLOWFISH encryption algorithm
// _THE BLOWFISH ENCRYPTION ALGORITHM_
// by Bruce Schneier
// Revised code--3/20/94
// Converted to C++ class 5/96, Jim Conger

#include "stdafx.h" // #include "stdafx.h"
#include "blowfish.h" // #include "blowfish.h"
#include "blowfish.h2.h" // #include "blowfish.h2.h" // Random numbers

// ------------------------------------------------------------- //


// ------------------------------------------------------------- //
CBlowFish::CBlowFish ()
// ------------------------------------------------------------- //
{
PArray = new DWORD [18] ;
SBoxes = new DWORD [4][256] ;
}

// ------------------------------------------------------------- //
CBlowFish::~CBlowFish ()
// ------------------------------------------------------------- //
{
delete PArray ;
delete [] SBoxes ;
}

// the low level (private) encryption function
// ------------------------------------------------------------- //
void CBlowFish::Blowfish_encipher (DWORD *xl, DWORD *xr)
// ------------------------------------------------------------- //
{
union aword  Xl, Xr ;

Xl.dword = *xl ;
Xr.dword = *xr ;

Xl.dword ^= PArray [0];
Round (Xr, Xl, 1) ;  Round (Xl, Xr, 2) ;
Round (Xr, Xl, 3) ;  Round (Xl, Xr, 4) ;
Round (Xr, Xl, 5) ;  Round (Xl, Xr, 6) ;
Round (Xr, Xl, 7) ;  Round (Xl, Xr, 8) ;
Round (Xr, Xl, 9) ;  Round (Xl, Xr, 10) ;
Round (Xr, Xl, 11) ; Round (Xl, Xr, 12) ;
Round (Xr, Xl, 13) ; Round (Xl, Xr, 14) ;
Round (Xr, Xl, 15) ; Round (Xl, Xr, 16) ;
Xr.dword ^= PArray [17] ;

*xr = Xl.dword ;
*xl = Xr.dword ;
}

// the low level (private) decryption function
// ------------------------------------------------------------- //
void CBlowFish::Blowfish_decipher (DWORD *xl, DWORD *xr)
// ------------------------------------------------------------- //
{
union aword  Xl ;
union aword  Xr ;

Xl.dword = *xl ;
Xr.dword = *xr ;

Xl.dword ^= PArray [17] ;
Round (Xr, Xl, 16) ;  Round (Xl, Xr, 15) ;
Round (Xr, Xl, 14) ;  Round (Xl, Xr, 13) ;
Round (Xr, Xl, 12) ;  Round (Xl, Xr, 11) ;
Round (Xr, Xl, 10) ;  Round (Xl, Xr, 9) ;
Round (Xr, Xl, 8) ;   Round (Xl, Xr, 7) ;
Round (Xr, Xl, 6) ;   Round (Xl, Xr, 5) ;
Round (Xr, Xl, 4) ;   Round (Xl, Xr, 3) ;
Round (Xr, Xl, 2) ;   Round (Xl, Xr, 1) ;
Xr.dword ^= PArray[0];

*xl = Xr.dword;
*xr = Xl.dword;
}


// constructs the enctryption sieve
// ------------------------------------------------------------- //
void CBlowFish::Initialize (const BYTE key[], int keybytes)
// ------------------------------------------------------------- //
{
int  		i, j ;
DWORD  		data, datal, datar ;
union aword temp ;

// first fill arrays from data tables
for (i = 0 ; i < 18 ; i++)
{
PArray [i] = bf_P [i] ;
}

for (i = 0 ; i < 4 ; i++)
{
for (j = 0 ; j < 256 ; j++)
SBoxes [i][j] = bf_S [i][j] ;
}


j = 0 ;
for (i = 0 ; i < NPASS + 2 ; ++i)
{
temp.dword = 0 ;
temp.w.byte0 = key[j];
temp.w.byte1 = key[(j+1) % keybytes] ;
temp.w.byte2 = key[(j+2) % keybytes] ;
temp.w.byte3 = key[(j+3) % keybytes] ;
data = temp.dword ;
PArray [i] ^= data ;
j = (j + 4) % keybytes ;
}

datal = 0 ;
datar = 0 ;

for (i = 0 ; i < NPASS + 2 ; i += 2)
{
Blowfish_encipher (&datal, &datar) ;
PArray [i] = datal ;
PArray [i + 1] = datar ;
}

for (i = 0 ; i < 4 ; ++i)
{
for (j = 0 ; j < 256 ; j += 2)
{
Blowfish_encipher (&datal, &datar) ;
SBoxes [i][j] = datal ;
SBoxes [i][j + 1] = datar ;
}
}
}

// get output length, which must be even MOD 8
// ------------------------------------------------------------- //
DWORD CBlowFish::GetOutputLength (DWORD lInputLong)
// ------------------------------------------------------------- //
{
DWORD 	lVal ;

lVal = lInputLong % 8 ;	// find out if uneven number of bytes at the end
if (lVal != 0)
return lInputLong + 8 - lVal ;
else
return lInputLong ;
}

// Encode pIntput into pOutput.  Input length in lSize.  Returned value
// is length of output which will be even MOD 8 bytes.  Input buffer and
// output buffer can be the same, but be sure buffer length is even MOD 8.
#ifdef BLOWFISH_ALLOW_ENCODE
// ------------------------------------------------------------- //
DWORD CBlowFish::Encode (BYTE * pInput, BYTE * pOutput, DWORD lSize)
// ------------------------------------------------------------- //
{
DWORD 	lCount, lOutSize, lGoodBytes ;
BYTE	*pi, *po ;
int		i, j ;
int		SameDest = (pInput == pOutput ? 1 : 0) ;

lOutSize = GetOutputLength (lSize) ;
for (lCount = 0 ; lCount < lOutSize ; lCount += 8)
{
if (SameDest)	// if encoded data is being written into input buffer
{
if (lCount < lSize - 7)	// if not dealing with uneven bytes at end
{
Blowfish_encipher ((DWORD *) pInput,
(DWORD *) (pInput + 4)) ;
}
else		// pad end of data with null bytes to complete encryption
{
po = pInput + lSize ;	// point at byte past the end of actual data
j = (int) (lOutSize - lSize) ;	// number of bytes to set to null
for (i = 0 ; i < j ; i++)
*po++ = 0 ;
Blowfish_encipher ((DWORD *) pInput,
(DWORD *) (pInput + 4)) ;
}
pInput += 8 ;
}
else 			// output buffer not equal to input buffer, so must copy
{               // input to output buffer prior to encrypting
if (lCount < lSize - 7)	// if not dealing with uneven bytes at end
{
pi = pInput ;
po = pOutput ;
for (i = 0 ; i < 8 ; i++) // copy bytes to output
*po++ = *pi++ ;
Blowfish_encipher ((DWORD *) pOutput,	// now encrypt them
(DWORD *) (pOutput + 4)) ;
}
else		// pad end of data with null bytes to complete encryption
{
lGoodBytes = lSize - lCount ;	// number of remaining data bytes
po = pOutput ;
for (i = 0 ; i < (int) lGoodBytes ; i++)
*po++ = *pInput++ ;
for (j = i ; j < 8 ; j++)
*po++ = 0 ;
Blowfish_encipher ((DWORD *) pOutput,
(DWORD *) (pOutput + 4)) ;
}
pInput += 8 ;
pOutput += 8 ;
}
}
return lOutSize ;
}
#endif //#ifdef BLOWFISH_ALLOW_ENCODE


// Decode pIntput into pOutput.  Input length in lSize.  Input buffer and
// output buffer can be the same, but be sure buffer length is even MOD 8.
// ------------------------------------------------------------- //
void CBlowFish::Decode (BYTE * pInput, BYTE * pOutput, DWORD lSize)
// ------------------------------------------------------------- //
{
DWORD 	lCount ;
BYTE	*pi, *po ;
int		i ;
int		SameDest = (pInput == pOutput ? 1 : 0) ;

for (lCount = 0 ; lCount < lSize ; lCount += 8)
{
if (SameDest)	// if encoded data is being written into input buffer
{
Blowfish_decipher ((DWORD *) pInput,
(DWORD *) (pInput + 4)) ;
pInput += 8 ;
}
else 			// output buffer not equal to input buffer
{               // so copy input to output before decoding
pi = pInput ;
po = pOutput ;
for (i = 0 ; i < 8 ; i++)
*po++ = *pi++ ;
Blowfish_decipher ((DWORD *) pOutput,
(DWORD *) (pOutput + 4)) ;
pInput += 8 ;
pOutput += 8 ;
}
}
}

#ifdef BLOWFISH_ALLOW_ENCODE
#ifdef _AFX
// ------------------------------------------------------------- //
CString CBlowFish::EasyEncode(LPCTSTR mail)
// ------------------------------------------------------------- //
{
int len;
CString	as, pw;
int		brc=0;
len=strlen(mail);
len+=(len%8);
BYTE* text=new BYTE[len*4+64];
BYTE code[32];

memset(text, 0, len*4+64);
memcpy(text, mail, strlen(mail));
memcpy(text, mail, strlen(mail));

memset(code, 0, 32);
memcpy(code, "d9~R.E+", 9);

this->Initialize(code, 9);
len=this->Encode(text, text, len);

pw="";
for (int i=0; i<len; i++)
{
as.Format("%.2X", text[i]);
pw+=as;
brc++;
if(brc==10)
{
brc=0; pw+="\r\n";
}
}

delete [] text;
return pw;
}
#endif
#endif // #ifdef BLOWFISH_ALLOW_ENCODE



#ifdef _AFX
// ------------------------------------------------------------- //
CString CBlowFish::EasyDecode(LPCTSTR BFcode)
// ------------------------------------------------------------- //
{
int len;
CString	as, pw;
int		brc=0, i, j, n;

as=BFcode;
as.MakeUpper();
as.Replace(" ", "");
as.Replace("-", "");
as.Replace("\n", "");
as.Replace("\r", "");
as.Replace("\t", "");
len=as.GetLength()/2;
len+=(len%8);
BYTE* text=new BYTE[len*4+64];
BYTE* code=new BYTE[32];

char	hex[17]="0123456789ABCDEF";

memset(text, 0, len*4+64);
for(i=0; i<as.GetLength()/2; i++)
{
n=0;
for (j=0; j<16; j++)
{
if (as.GetAt(i*2)==hex[j])
n+=(j*16);
if (as.GetAt(i*2+1)==hex[j])
n+=j;
}
text[i]=(BYTE)n;
}
memset(code, 0, 32);
memcpy(code, "d9~R.E+", 9);

this->Initialize(code, 9);
this->Decode(text, text, len);

pw=(LPCTSTR)text;

delete [] text;
delete [] code;
return pw;
}
#endif
// Implementation of GLBasic commands

#include "stdafx.h" // #include "stdafx.h"

#ifdef MACOSX
typedef int BOOL;
extern "C" BOOL NSApplicationLoad();
#endif

#if !defined( WANT_SDL)
#ifdef WIN32
#define VC_EXTRALEAN
#define _NO_OLDNAMES // Allow _yn() but not yn() in Math.h
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Video playback
#define NOMMREG
#define NOMSACM
#ifndef GLB_CONSOLE
#include <vfw.h>
#pragma comment(lib, "VFW32.lib")
#endif
#define strlen	lstrlen // winAPI instead of stdlib
#endif
#else
//	#include <process.h> // system() -> stdio.h / stdlib.h??
#ifndef GLB_CONSOLE
#pragma comment (lib, "SDL.lib")
#pragma comment (lib, "SDL_mixer.lib")
#pragma comment (lib, "SDLmain.lib")
//	#pragma comment (lib, "mikmod.lib")
//	#pragma comment (lib, "native_midi.lib")
//	#pragma comment (lib, "ogg_static.lib")
//	#pragma comment (lib, "timidity.lib")
//	#pragma comment (lib, "vorbis_static.lib")
//	#pragma comment (lib, "vorbisfile_static.lib")
#endif
#endif

#ifdef WANT_SDL_MIXER
#ifndef GLB_CONSOLE
#pragma comment (lib, "SDL_mixer.lib")
#endif
#endif


#ifdef GLB_CONSOLE
#ifdef WIN32
#include <conio.h>
static unsigned long __g_ConsoleCP, __g_ConsoleCPOut;
#else
// must fake _getch()
#include <termios.h>
#include <unistd.h>
#endif
#endif

//#ifndef WANT_SDL_MIXER
//	#include <process.h>
//#endif

#include <math.h>
#ifndef GLB_CONSOLE
#include "dxsound.h" // #include "dxsound.h"
#include "dxinput.h" // #include "dxinput.h"
#include "openglrainbows.h" // #include "openglrainbows.h"
#include "rainbows3d.h" // #include "rainbows3d.h"
// #include "openglfont.h"
#endif
#include "gffilesystem.h" // #include "gffilesystem.h"
#include "gfqueue.h" // #include "gfqueue.h"


//#include <stdio.h> // sprintf
#include "gfrand.h" // #include "gfrand.h"

#include "glb.h" // #include "glb.h"

#ifdef WANT_SHOEBOX
#include "gfshoebox.h" // #include "gfshoebox.h"
extern GFShoeBox *__g_ShoeBox_Data;
extern GFShoeBox *__g_ShoeBox_Media;
#endif


#ifdef GF_DEBUG_NEW
// This must delete after all d'tors have been deleted
AllocList allocList; // stdafx.h
#endif

// Networking
#include "network/clientserver.h" // #include "network/clientserver.h"

#if defined(POSIX)
void Sleep(unsigned long mssec) {msleep((int)mssec);}
/*
#include <time.h>
#include <errno.h>

void Sleep(unsigned long mmsec)
{
struct timespec     tv;
tv.tv_sec = mmsec / 1000;
tv.tv_nsec = (mmsec % 1000) * 1000;
nanosleep(&tv, NULL);
}
*/
#endif


#define MAX_FONTS		16


namespace __GLBASIC__
{
// GLOBAL OBJECTS
#ifndef GLB_CONSOLE
DXInput*		pDXin=NULL;
SFXSound*		pDXsnd=NULL;
SFXSoundBuffer*	DXwav=NULL;
extern OpenGLRainbows*	__g_pRbow;
extern Rainbows3D*		__g_pRbow3D;
#endif
extern GFHawkNetwork*	pGFNet;

extern int				__nCurFont;
extern DGInt			__g_FirstTime;	// The time the program has started
extern DGInt			__g_LastTime;	// To get the time elapsed within the SHOWSCREEN cmds
extern DGInt			__g_ThisTime;	// To get the time elapsed within the SHOWSCREEN cmds

DGNat			__g_debugfile;
extern DGNat			__g_debugline;
extern DGNat			__g_error;
extern DGNat			__g_errorline;
static int		__IsDemoVersion=FALSE;
int				__g_HadBreakPoint=0; // had a breakpoint -> force window to top on SHOWSCREEN
int				__DG_SCHOOLVER;
DGInt			__HR;

extern int			__g_AllowEscape;
extern int			__g_paused;
extern int			__g_allowPause;


DGStr&			__g_Caption(){static DGStr cap; return cap;}
bool			__g_Did3D=false;
bool			__g_DidNET=false;

#define __g_LicenseBits	OpenGLRainbows10FreeMemoriesEiiiii // harder to find in HTML5
int				__g_LicenseBits; // replaced by: "XVSDVS%d", g_ProgramFeature (==3,2)
// g_allow3D =(nfeature & 1) ? 1 : 0;
// g_allowNET=(nfeature & 2) ? 1 : 0;


#if defined(TARGET_OS_IPHONE)
extern "C"
{
extern void* gpGLB_MainWnd;
}
#endif


HWND		__hWnd=NULL;
#if !defined(WANT_SDL) && defined(WIN32)
HINSTANCE	__hInstance=NULL;
#endif

#ifndef WANT_SDL_MIXER
#ifndef GLB_CONSOLE
HWND		wnd_mp3=NULL;
#endif
#endif

void __SetDemoVersion()
{
__IsDemoVersion = TRUE;
}

extern "C" void glb_do_pause(int pause);
extern "C" int glb_allow_escape();

BOOL glb_prepare_reading_file(DGStr& filename);


void* GLBASIC_HWND() {return (void*)__hWnd;}


// ------------------------------------------------------------- //
// __EndProgram
// ------------------------------------------------------------- //
extern "C" void __GLB_close_all_filehandles();


extern "C" void __ShutDownGLBasic()
{
static int washere=0;
if(!washere)
{
washere=1;
CALLBYNAME(DGStr("GLB_ON_QUIT"));
}



#ifndef GLB_CONSOLE

if(!__g_pRbow) return; // already shut down.
g_debug("Shut down GLB\n");

#endif
STOPMUSIC();


#if defined(WIN32) && !defined(POCKETPC)
// restore start directory - for profiler output
DGStr exe;
GFFileSystem::GetExeDir(exe.getbuffer(1024));
exe.releasebuffer();
GFFileSystem::SetCurrentDir(exe.c_str());
#endif

__GLB_close_all_filehandles(); // write profiler output

// shutdown network, quickly - iPhone must release sockets
if (pGFNet) delete pGFNet;			pGFNet=NULL;

// be safe to really, really shut down the network commands
for(int safe=0; safe<16; ++safe)
{
netShutdown();
}

#ifdef GLB_CONSOLE
#ifdef WIN32
// restore console code pages
SetConsoleCP(__g_ConsoleCP);
SetConsoleOutputCP(__g_ConsoleCPOut);
#endif
#endif

#if !defined(WANT_SDL) && defined (WIN32)
// timeEndPeriod(1);
#endif

#ifdef WANT_SDL
#ifndef GLB_CONSOLE
#ifndef ANDROID
SDL_WM_GrabInput(SDL_GRAB_OFF);
#endif
// SDL_Quit(); in endprogram - AFTER PDL_Quit()
#endif
#endif
#ifndef GLB_CONSOLE
if (pDXin) delete pDXin;			pDXin=NULL;
if (DXwav) delete[] DXwav;			DXwav=NULL;
if (pDXsnd)delete pDXsnd;			pDXsnd=NULL;
if (__g_pRbow) delete __g_pRbow;	__g_pRbow=NULL;
if (__g_pRbow3D) delete __g_pRbow3D;__g_pRbow3D=NULL;
#endif

if (__g_ShoeBox_Media) delete __g_ShoeBox_Media;	__g_ShoeBox_Media=NULL;
if (__g_ShoeBox_Data) delete __g_ShoeBox_Data;		__g_ShoeBox_Data=NULL;
#if !defined(WANT_SDL) && defined(WIN32)
#ifndef GLB_CONSOLE
if(__hWnd) DestroyWindow(__hWnd);	__hWnd=NULL;
#endif
#endif
g_debug("glb is shut down\n");
}

// !!!! DIRECT SHOW WORKS NOW !!
/*
#include <dshow.h>

void DoPlay(LPCTSTR szFileName)
{
IGraphBuilder *pGraphBuilder;
IMediaControl *pMediaControl;
IMediaSeeking *pMediaSeeking;
IMediaEventEx *pMediaEventEx;

HRESULT hr;

// Get an instance of the graph builder
CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (void**)&pGraphBuilder);

if (!pGraphBuilder)
{
MessageBox(NULL, "Critical error, unable to create graph builder", "Error", MB_OK);
}

// Get the references to interfaces
hr = pGraphBuilder->QueryInterface(IID_IMediaControl, (void **)&pMediaControl);
hr = pGraphBuilder->QueryInterface(IID_IMediaSeeking, (void**)&pMediaSeeking);
hr = pGraphBuilder->QueryInterface(IID_IMediaEventEx, (void**)&pMediaEventEx);

if (!pMediaControl || !pMediaSeeking || !pMediaEventEx)
{
MessageBox(NULL, "Critical error, error getting references", "Error", MB_OK);
}



WCHAR wFileName[1024];
char totalTime[1024];
LONGLONG lDuration100NanoSecs = 0;
long temporary;

// convert file name to wide char
mbstowcs(wFileName, szFileName, 1024);

// create the filter graph
pGraphBuilder->RenderFile(wFileName, NULL);

// get the time in units of 100 ns
pMediaSeeking->GetDuration(&lDuration100NanoSecs);

// hOwner stores the handle to the dialog
hOwner = owner;

// initialise is called everytime that a user selects a media file, so by set this button to Pause
SetWindowText(GetDlgItem(hOwner, IDC_PLAYPAUSE), PAUSE);

totalDuration = 0;
timeElapsed = 0;

// set our dialog to receive events from graph manager
pMediaEventEx->SetNotifyWindow((OAHWND)hOwner, WM_GRAPHNOTIFY, 0);

}
*/


// ------------------------------------------------------------- //
void __dLn	(int nfile, int num)
// ------------------------------------------------------------- //
{
//	printf("\r%d,%d,", nfile, num);
__g_debugfile=nfile;
__g_debugline=num;
}


#if !defined( WANT_SDL) && defined(WIN32)
#ifndef GLB_CONSOLE


// *** Windows 8 WM_POITNER mutlitouch messages ***
#ifndef WM_POINTERUP
#define WM_POINTERUPDATE              0x0245
#define WM_POINTERDOWN                0x0246
#define WM_POINTERUP                  0x0247
typedef enum tagPOINTER_INPUT_TYPE { 
PT_POINTER   = 0x00000001,
PT_TOUCH     = 0x00000002,
PT_PEN       = 0x00000003,
PT_MOUSE     = 0x00000004,
PT_TOUCHPAD  = 0x00000005
} POINTER_INPUT_TYPE;
typedef enum _POINTER_BUTTON_CHANGE_TYPE { 
POINTER_CHANGE_NONE               = 0,
POINTER_CHANGE_FIRSTBUTTON_DOWN  , // might be wrong - enum was broken in MSDN
POINTER_CHANGE_FIRSTBUTTON_UP    ,
POINTER_CHANGE_SECONDBUTTON_DOWN ,
POINTER_CHANGE_SECONDBUTTON_UP   ,
POINTER_CHANGE_THIRDBUTTON_DOWN  ,
POINTER_CHANGE_THIRDBUTTON_UP    ,
POINTER_CHANGE_FOURTHBUTTON_DOWN ,
POINTER_CHANGE_FOURTHBUTTON_UP   ,
POINTER_CHANGE_FIFTHBUTTON_DOWN  ,
POINTER_CHANGE_FIFTHBUTTON_UP    
} POINTER_BUTTON_CHANGE_TYPE;

typedef struct tagPOINTER_INFO {
POINTER_INPUT_TYPE         pointerType;
UINT32                     pointerId;
UINT32                     frameId;
UINT32 /* ? */              pointerFlags;
HANDLE                     sourceDevice;
HWND                       hwndTarget;
POINT                      ptPixelLocation;
POINT                      ptHimetricLocation;
POINT                      ptPixelLocationRaw;
POINT                      ptHimetricLocationRaw;
DWORD                      dwTime;
UINT32                     historyCount;
INT32                      inputData;
DWORD                      dwKeyStates;
UINT64                     PerformanceCount;
POINTER_BUTTON_CHANGE_TYPE ButtonChangeType;
} POINTER_INFO;
typedef struct tagPOINTER_TOUCH_INFO {
POINTER_INFO pointerInfo;
UINT32 /*Touch Flags*/  touchFlags;
UINT32 /*Touch Mask */  touchMask;
RECT         rcContact;
RECT         rcContactRaw;
UINT32       orientation;
UINT32       pressure;
} POINTER_TOUCH_INFO;
#define GET_POINTERID_WPARAM(wParam) (LOWORD (wParam))
#define GET_X_LPARAM(lp)                        ((int)(short)LOWORD(lp))
#define GET_Y_LPARAM(lp)                        ((int)(short)HIWORD(lp))
#define IS_POINTER_FLAG_SET_WPARAM(wParam, flag) (((DWORD)HIWORD (wParam) &(flag)) == (flag))
#define IS_POINTER_PRIMARY_WPARAM(wParam) IS_POINTER_FLAG_SET_WPARAM (wParam, POINTER_MESSAGE_FLAG_PRIMARY)
#define IS_POINTER_FIRSTBUTTON_WPARAM(wParam) IS_POINTER_FLAG_SET_WPARAM (wParam, POINTER_MESSAGE_FLAG_FIRSTBUTTON)
#define IS_POINTER_SECONDBUTTON_WPARAM(wParam) IS_POINTER_FLAG_SET_WPARAM (wParam, POINTER_MESSAGE_FLAG_SECONDBUTTON)
#endif

struct Win32_TouchPos // Windows 8+ WM_POINTERUP messages for multitouch/multiple mice
{
Win32_TouchPos() {m_X=0; m_Y=0; m_Down=0; m_id=0;}
int m_X, m_Y, m_Down; // m_Down 1=left/touch |2=right |4=middle
int m_id;
}
gWin32_TouchPos[32];

extern "C" void win32_get_touches(int id, int* mx, int* my, int* b1)
{
*mx=gWin32_TouchPos[id].m_X;
*my=gWin32_TouchPos[id].m_Y;
*b1=gWin32_TouchPos[id].m_Down;
}


DECLARE(GetPointerTouchInfo, "user32.dll", (UINT32, POINTER_TOUCH_INFO*), BOOL);


// iDirection: 1 down, -1 up, 0 mode
void HandleWM_POINTER(int iDirection, WPARAM wParam, LPARAM lParam)
{
int pointerId = GET_POINTERID_WPARAM(wParam);

if(pointerId==0)
return;

POINTER_TOUCH_INFO info;
GetPointerTouchInfo(pointerId, &info);

for(int i=0; i<32 * 2; ++i)
{
if((i<32 && gWin32_TouchPos[i].m_id == pointerId) // update
|| ( i>=32 && gWin32_TouchPos[i-32].m_id == 0)) // new pointer down
{
if(i>=32) i-=32; // had to use an empty slot instead of an update.

int button=0;
if(info.pointerInfo.pointerFlags & 0x00000010) // POINTER_FLAG_FIRSTBUTTON)
button |=1;
if(info.pointerInfo.pointerFlags & 0x00000020) // POINTER_FLAG_SECONDBUTTON)
button |=2;
if(info.pointerInfo.pointerFlags & 0x00000040) // POINTER_FLAG_THIRDBUTTON)
button |=4;

switch(iDirection)
{
case 0: // update
gWin32_TouchPos[i].m_Down = button;
break;
case 1:
gWin32_TouchPos[i].m_Down |= button;
gWin32_TouchPos[i].m_id = pointerId; break;
case -1:
gWin32_TouchPos[i].m_Down &= button;
gWin32_TouchPos[i].m_id = 0; break;
}
::ScreenToClient((HWND)GLBASIC_HWND(), &info.pointerInfo.ptPixelLocation);
gWin32_TouchPos[i].m_X = info.pointerInfo.ptPixelLocation.x;
gWin32_TouchPos[i].m_Y = info.pointerInfo.ptPixelLocation.y;

break; // !! must
}
}
}


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
LRESULT CALLBACK __WndProc_(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
switch (message)
{
// Screensaver
case WM_SYSCOMMAND:
if((wParam&0xFFF0)==SC_SCREENSAVE || (wParam&0xFFF0)==SC_MONITORPOWER)
return 0L;
if((wParam&0xFFF0)==SC_CLOSE)
{
PostQuitMessage(0);
}
break;
case WM_SYSKEYUP:
return 0; // ignore Sysmenu on F10/LAlt
break;
case WM_CLOSE:
__EndProgram();
DestroyWindow(hWnd);
PostQuitMessage(0);
case WM_ACTIVATE:
{
switch(wParam & 0xffff)
{
case WA_ACTIVE: case WA_CLICKACTIVE:
if(!__DG_DEBUG)
{
glb_do_pause(false);
if(!__g_paused && __g_allowPause)
::SetWindowText(__hWnd, __g_Caption().c_str());
}
break;
case WA_INACTIVE:
if(!__DG_DEBUG)
{
glb_do_pause(true);
if(__g_paused && __g_allowPause)
::SetWindowText(__hWnd, (__g_Caption() + CGStr(" <pause>")).c_str());
}
break;
}
}
return 0L;
case WM_ERASEBKGND:
return 1;
//	case WM_MOVE: case WM_CREATE: case WM_SIZE:
//		::InvalidateRect(0, NULL, TRUE);

//		return 0L;


case WM_POINTERUP:
HandleWM_POINTER(-1, wParam, lParam);
break;
case WM_POINTERDOWN:
HandleWM_POINTER(1, wParam, lParam);
break;
case WM_POINTERUPDATE:
HandleWM_POINTER(0, wParam, lParam);
break;


break;
}
return (DefWindowProc(hWnd, message, wParam, lParam));
}
#endif
#endif


// ------------------------------------------------------------- //
// __AllocConsole - allocate a console
// ------------------------------------------------------------- //

#ifndef GLB_CONSOLE
extern "C" int _open_osfhandle(int, int);
void __AllocConsole()
{
#if defined (WIN32) && !defined(POCKETPC)
int hCrtIn, hCrtOut;
FILE *conIn, *conOut;
AllocConsole();
#pragma warning(disable: 4311)
hCrtIn  = _open_osfhandle ((long)(GetStdHandle((DWORD)STD_INPUT_HANDLE)), 0x4000);
hCrtOut = _open_osfhandle ((long) GetStdHandle((DWORD)STD_OUTPUT_HANDLE), 0x4000);
conIn = _fdopen( hCrtIn, "r" );
conOut = _fdopen( hCrtOut, "w" );
*stdin = *conIn;
*stdout = *conOut;
#endif
}
#else

#ifdef WIN32
HWND GetConsoleHwnd()
{
#define MY_BUFSIZE 1024
HWND hwndFound;
char pszNewWindowTitle[MY_BUFSIZE];
char pszOldWindowTitle[MY_BUFSIZE];
GetConsoleTitle(pszOldWindowTitle, MY_BUFSIZE);
wsprintf(pszNewWindowTitle,"%d/%d/%d",
GetTickCount(),
GetCurrentProcessId(), (int)RND(32767));
SetConsoleTitle(pszNewWindowTitle);
Sleep(40);
hwndFound=FindWindow(NULL, pszNewWindowTitle);
SetConsoleTitle(pszOldWindowTitle);
return hwndFound;
}
#endif

#endif


/*
// Demo char sequence - replaced by GLBasic IDE if not demo anymore
static char _g_glb_prtc[16]="DvSDVsdVS0e7"; // don't make it const - can't replace in binary otherwise
// replaced by: "XVSDVS%d", g_ProgramFeature (==3,2)

#define MAKE_DEMO_VARIABLE() {volatile int fake = 0; if(fake==0){++fake;} ++fake; __IsDemoVersion= _g_glb_prtc[0]=='B'+fake ? TRUE : __IsDemoVersion;}
*/

#define PrepLic	OpenGLRainbows10AllocMemoriesEiii // harder to find in HTML5
void PrepLic();

#if defined( WIN32) && !defined(_WIN32_WCE)
DECLARE(EnableMouseInPointer, "User32.dll", (BOOL), BOOL );
#endif
// ------------------------------------------------------------- //
// __GlobalInit - Create and handle Window Stuff
// ------------------------------------------------------------- //
extern "C" int __GlobalInit(HINSTANCE hInst, int nCmdShow, const char* Caption)
{
/*
char force_demo_ok[1024];
strcpy(force_demo_ok, _g_glb_prtc);
sprintf(force_demo_ok, "%s", _g_glb_prtc);
*/
g_deldebug();


#ifdef MACOSX
#ifndef GLB_CONSOLE
::NSApplicationLoad();
#endif
#endif

#ifdef _DEBUG
#ifndef GLB_CONSOLE
__AllocConsole();
#endif
#endif


#if defined(WANT_SDL) || defined(WANT_SDL_MIXER)
Uint32 flags = 0;
#if defined(WANT_SDL_MIXER)
flags |= SDL_INIT_AUDIO;
#endif

if(!SDL_Init(SDL_INIT_JOYSTICK|SDL_INIT_TIMER |SDL_INIT_VIDEO | flags) ) // segfault w/o SDL_VIDEO on RaspberryPi
{
g_debug("Can't init SDL.\n%s\n", (const char*)SDL_GetError());
}
#endif



__g_allowPause=true;
PrepLic();

// must reset. Win8 loads a DLL at runtime
__g_Did3D = false;
__g_DidNET= false;


#if (!defined(WIN32) && !defined(LINUX) && !defined(MACOSX)) || defined(_WIN32_WCE)
if((__g_LicenseBits & 2) == 0) // need NET for other platforms
__SetDemoVersion();
#endif




#ifndef _DEBUG
#ifndef WIN32
atexit(__EndProgram);
#endif

#else
//	__IsDemoVersion=FALSE;
//	__g_LicenseBits= 0xff;
#endif

// before Rbow
g_debug("timer\n");
SetupAccurateTimer();

g_debug("rbow\n");

// Create window
#ifndef GLB_CONSOLE
__g_pRbow = new OpenGLRainbows;

// SPACE FRACTAL :: Removed ANDROID define, needs calling -1 on Android to fix the Orientation
#if defined(TARGET_OS_IPHONE) || defined(PALM_WEBOS) || (defined(_DEBUG) && defined(HAVE_OPENGL_ES))
if(__DG_RESX>__DG_RESY)
{
__g_pRbow->m_landscape=1; // 90 CCW
}
#endif

g_debug("rbow init\n");
if(__g_pRbow->Init(	hInst,
(unsigned int)__DG_RESX,
(unsigned int)__DG_RESY, 0, 
(unsigned int)__DG_FRAMERATE,
(int)__DG_MULTISAMPLE,
__DG_FULLSCREEN?true:false)
)
{
#if !defined( WANT_SDL) && defined(WIN32)
__hWnd = __g_pRbow->m_WND.hwnd;
SetWindowText(__hWnd, Caption);
#endif

#if defined(TARGET_OS_IPHONE)
__hWnd = (HWND)gpGLB_MainWnd;
#endif
}
else
{
return 0;
}
#else
#ifdef WIN32
// __hWnd = ::GetConsoleWindow(); 2k,xp,Vista - only
__hWnd = GetConsoleHwnd();
#endif
#endif

g_debug("Cptn\n");
__g_Caption() = CGStr(Caption);

#ifdef _DEBUG
GFsrand(1);
//	__DG_FULLSCREEN=FALSE;
#else
GFsrand((long)GETTIMERALL());
#endif
g_debug("Network\n");
pGFNet=new GFHawkNetwork;

// Allocate Memory on heap:
#ifndef GLB_CONSOLE
__g_pRbow3D = new Rainbows3D(__g_pRbow);

g_debug("Input\n");
pDXin=new  DXInput;

g_debug("Window mode\n");
if(__DG_FULLSCREEN)
__g_pRbow->DoFullscreen();
else
__g_pRbow->DoWindowed();

g_debug("Create DXin\n");
#ifdef WANT_SDL
pDXin->CreateDInput(0L, 0L, __DG_WANTMOUSE ? true : false);
#ifndef ANDROID
SDL_WM_SetCaption(Caption, "");
if (__DG_WANTMOUSE)
{
g_debug("sdl_grab\n");
SDL_WM_GrabInput(SDL_GRAB_ON);
}
#endif
#else
pDXin->CreateDInput((HWND)__hWnd, hInst, __DG_WANTMOUSE ? true : false);
#endif

#if defined( WANT_SDL) && !defined(GP2X) && !defined(GPHWIZ)
pDXin->m_AccelerationNativeLandscape = __g_pRbow->m_physical_device_screen_is_landscape?true:false;
#endif

// Set Window pointers again - just to be sure
#if defined(WIN32) && !defined(WANT_SDL) && !defined(POCKETPC)
g_debug("reptr\n");
pDXin->SetWindow(__g_pRbow->m_WND.hwnd);
#endif
#endif

__nCurFont=0;
DGStr exepath;

// Set current dir for Linux when double clicking with KDE
// The same for Win32 when associated with a file extension
g_debug("getexe\n");
GFFileSystem::GetExeDir(exepath.getbuffer(1024));
exepath.releasebuffer();
g_debug("cd\n");
GFFileSystem::SetCurrentDir(exepath.c_str());
g_debug("exepath=curdir= %s\n", exepath.c_str() );

#ifdef MACOSX
exepath += CGStr("/Contents/Resources");
GFFileSystem::SetCurrentDir( exepath.c_str());
g_debug("curdir= %s\n", exepath.c_str() );
#endif


#ifdef WANT_SHOEBOX
__g_ShoeBox_Media = new GFShoeBox;
__g_ShoeBox_Data  = new GFShoeBox;
#endif

// Set .exe = default ShoeBox
g_debug("shoeboxing...\n" );
GFFileSystem::GetExePath(exepath.getbuffer(1024) );
exepath.releasebuffer();
SETSHOEBOX(exepath, exepath);


g_debug("init gettimer\n" );
__g_FirstTime=__g_LastTime=__g_ThisTime=AccurateTime();
#ifndef GLB_CONSOLE
g_debug("clear screen\n" );
CLEARSCREEN();

g_debug("flip\n" );
__g_pRbow->FlipScreens();
g_debug("mk2D\n" );
__g_pRbow->Make2DMode();

#define CENTER(a, y) PRINT(DGStr(a), (sx-LEN(CGStr(a))*fx)/2, y);
DGInt sx, sy, fx, fy;
__g_pRbow->DefaultFont(0); // default font
GETSCREENSIZE(sx, sy);
GETFONTSIZE(fx, fy);
if(__DG_SCHOOLVER)
{
int paused=0;
for(DGInt alpha=0.01f; alpha<=2; alpha+=.039f)
{
ALPHAMODE(alpha<1 ? alpha : 2.1-alpha);
if(alpha>=1 && !paused)
{
paused=1;
ALPHAMODE(0);
}
CENTER("School License", (sy-fy)/2)
CENTER("www.GLBasic.com", sy-fy);
SHOWSCREEN();
SLEEP(20);
if(paused==1)
{
paused=2;
SLEEP(500);
}
}
ALPHAMODE(0);
CLEARSCREEN();
}

//if(!android_copy_asset_done())
//{
//	DGStr waiting = "ooooooo";
//	int iwait = 0;
//	do
//	{
//		iwait = (1+iwait)%waiting.len();
//		waiting = LCASE_Str(waiting);
//		waiting[iwait] = 'O';
//		GETSCREENSIZE(sx, sy);
//		CENTER(waiting, (sy-fy)/2)
//		SHOWSCREEN();
//		SLEEP(250);
//	} while (!android_copy_asset_done());
//}
//#endif
//#undef CENTER


// load smalfont.bmp / smalfont.png
g_debug("finding font...\n" );

DGStr files[4];
files[0] = "Media/smalfont.png";
files[1] = "Media/smalfont.bmp";
files[2] = "smalfont.png";
files[3] = "smalfont.bmp";

for(int i=0; i<3; ++i)
{
if(glb_prepare_reading_file(files[i]))
{
LOADFONT(files[i].c_str(), 0);
break;
}
}
SETFONT(0);
#else // console
if(__DG_SCHOOLVER)
{
printf("School License\n\n");
}
if(__IsDemoVersion)
{
printf("DEMO version\n...waiting 5 seconds.\n");
SLEEP(4959);
}
#endif



__g_paused=FALSE;

#if !defined( WANT_SDL) && defined(WIN32)
// timeBeginPeriod(1);
SetCursor((HCURSOR)LoadCursor(hInst, IDC_ARROW));
#endif
__g_FirstTime=__g_LastTime=__g_ThisTime=AccurateTime();


// Set Priority: - causes trouble and trouble!
/*
if (!__DG_DEBUG)
{
HANDLE hProc=GetCurrentProcess(); // ChokeXP
::SetPriorityClass(hProc, 0x00008000); // ABOVE_NORMAL_PRIORITY_CLASS - Never ever try realtime on NT systems
}
*/	

// Hide if desired (for creation of DLLs, e.g.)
#ifndef GLB_CONSOLE
#ifdef WIN32
if(nCmdShow == SW_HIDE)
{
__g_pRbow->HideWindow();
ShowWindow(__hWnd, SW_HIDE);
}	
#endif

pDXin->SystemPointer(!__DG_WANTMOUSE);

#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
system("killall -9 gp2xmenu"); // WIZ has menu in background?
#endif
#else // Set console codepage to ansi
#ifdef WIN32
__g_ConsoleCP = ::GetConsoleCP();
__g_ConsoleCPOut = ::GetConsoleOutputCP();
SetConsoleCP(1252);
SetConsoleOutputCP(1252);
#endif
#endif

DLL_DELAY_LOAD_NOW();


#if defined( WIN32) && !defined(_WIN32_WCE) && !defined(GLB_CONSOLE)
if(EnableMouseInPointer)
{
g_debug("Win8+ mouse as pointer\n");
EnableMouseInPointer(TRUE);
}
else
{
STDERR(DGStr("!!! EnableMouseInPointer() not found in user32.dll. If this is >=Win8, you get no mouse messages.\n") );
}
#endif


// Mac loads sound dll later
// Don't change order of sound+buffers!
#ifndef GLB_CONSOLE
pDXsnd=new SFXSound;
DXwav=new  SFXSoundBuffer[MAX_WAV_SAMPLES];
pDXsnd->Create(__hWnd);

// Set the main window pointers again.
#if defined(WIN32) && !defined(WANT_SDL_MIXER)
pDXsnd->SetWindow(__g_pRbow->m_WND.hwnd);
#endif
#endif

#if defined(ANDROID) // Space Fractal - Added few things to prevent crash
GFFileSystem::SetCurrentDir("files");
int okfolder=CREATEDIR(CGStr("Media"));
SETORIENTATION(-1);
#endif

g_debug("Init Finalized\n");
return 0;
}


#if defined(WIN32) && !defined(WANT_SDL_MIXER)
#ifndef GLB_CONSOLE
DGInt gMusicRepeat=0;

UINT_PTR gTimerIndex = 0;
#define EVENT_TIMER_MP3_LOOP	(WM_USER+132)
VOID CALLBACK MusicTimer(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
MCIWndSeek(wnd_mp3, MCIWND_START);
MCIWndPlay(wnd_mp3);
}
#endif
#endif



#ifdef WIN32
#define GLB_WIN32_MSG "GLB_WIN32_MSG"
void PeekMessageCallback()
{
typedef DGInt (*a_sub)();
static a_sub mysub = (a_sub)GETSUBADDRESS(GLB_WIN32_MSG);
if(mysub) mysub();
}
#endif


// ------------------------------------------------------------- //
#ifndef GLB_CONSOLE
void(*gpWinMsgCallback)() = NULL;

inline unsigned int _WinMSG(bool allow_to_sleep)
{
#if defined(WIN32) && !defined(WANT_SDL_MIXER)
if(gMusicRepeat > 0) // loop music, not paused
{
DGInt time = AccurateTime();
if(time >= gMusicRepeat)
{
MCIWndSetTimeFormat(wnd_mp3, "ms");
UINT milliseconds = max(500, MCIWndGetLength(wnd_mp3));
gMusicRepeat = AccurateTime() + milliseconds;

MCIWndPlay(wnd_mp3);
MCIWndSeek(wnd_mp3, MCIWND_START);
MCIWndPlay(wnd_mp3);
}
}

static int bHasCallBack= -1;
if(bHasCallBack == -1)
{
if(GETSUBADDRESS(GLB_WIN32_MSG))
{
bHasCallBack=1;
gpWinMsgCallback = (void(*)())GETSUBADDRESS(GLB_WIN32_MSG);
}
else
bHasCallBack=0;
}

return __g_pRbow->WinMessages(gpWinMsgCallback, allow_to_sleep);
#else
return __g_pRbow->WinMessages(gpWinMsgCallback, allow_to_sleep);
#endif
}
#endif



unsigned int gKeyStatusCounter = 0;


// ------------------------------------------------------------- //
#if defined(ANDROID)
extern "C" int AndroidScancode(int);
#endif

DGNat	KEY(DGNat key)
{
#if defined(ANDROID)
return AndroidScancode(key);
#else
#ifndef GLB_CONSOLE
if(++gKeyStatusCounter > 128)
{	
gKeyStatusCounter=0;
pDXin->GetKeyboardStatus();
}
return (DGNat)(pDXin->GetKey((unsigned char)key));
#else
return 0;
#endif
#endif
}




// GFX-FUNCTIONS

#if defined(TARGET_OS_IPHONE)
extern "C" void iPhonePlayMovie(const char* pMoviePath);
#endif

// ------------------------------------------------------------- //
DGNat PlayVideo(const DGStr& filename, int loop)
{
#ifndef GLB_CONSOLE
#if !defined( WANT_SDL) && defined(WIN32)
HWND	wnd_video=NULL;
DGStr s(filename);
if(!__g_ShoeBox_Media->FindOrExtract(filename.c_str(), s.getbuffer(1024), false))
return CMP_NO_FILE;
s.releasebuffer();
wnd_video = MCIWndCreate(__hWnd, __hInstance, WS_CHILD | WS_VISIBLE | MCIWNDF_NOMENU |
MCIWNDF_NOPLAYBAR | MCIWNDF_NOERRORDLG |
MCIWNDF_NOAUTOSIZEMOVIE | MCIWNDF_NOAUTOSIZEWINDOW
, s.c_str());
if (wnd_video)
{
long end = MCIWndGetStart(wnd_video) + MCIWndGetLength(wnd_video);

// Fullscreen
RECT	r2, rect;
MCIWndGetSource(wnd_video, &r2);
::GetClientRect(__hWnd, &rect);

double sc1, sc2;
sc1 = (double)(rect.right-rect.left) / (double)(r2.right-r2.left);
sc2 = (double)(rect.bottom-rect.top)/ (double)(r2.bottom-r2.top);
sc1=MIN(sc1, sc2);
r2.right=(LONG)((r2.right-r2.left) *sc1);
r2.left = 0;
r2.bottom = rect.top + (LONG)((r2.bottom-r2.top)*sc1);
r2.top = 0;
OffsetRect(&rect, -rect.left, -rect.top);
OffsetRect(&r2, (rect.right-r2.right)/2, (rect.bottom-r2.bottom)/2);
MCIWndPutDest(wnd_video, &r2); // new RECT
SetWindowPos(wnd_video,           // window to resize
NULL,                          // z-order: don't care
r2.left, r2.top, r2.right-r2.left, r2.bottom-r2.top,
SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
// Fullscreen - end
while (pDXin->AnyKey() || pDXin->AnyMouse()) ;

if (MCIWndPlay(wnd_video)==0)
{
long cpos = 0;

while(cpos<end)
{
cpos = MCIWndGetPosition(wnd_video);
if(pDXin->AnyKey() || pDXin->AnyMouse())
break;
if (!_WinMSG(false)) __EndProgram();
if (loop && cpos>=end)
{
MCIWndHome(wnd_video);
MCIWndPlay(wnd_video);
cpos = -1;
}
}
}
MCIWndStop(wnd_video);
MCIWndDestroy(wnd_video);
}
else
return CMP_NO_FILE;
return CMP_OK;

#elif defined(TARGET_OS_IPHONE)
iPhonePlayMovie(filename.c_str());
return CMP_OK;
#else
printf("PLAYMOVIE + LOOPMOVIE only on Win32 so far...\n");
return CMP_OK;
#endif

#else
return 0;
#endif
}


// ------------------------------------------------------------- //
void	PLAYMOVIE(const DGStr& s)
{
PlayVideo(s, 0);
}

// ------------------------------------------------------------- //
void	LOOPMOVIE(const DGStr& s)
{
PlayVideo(s, 1);
}

#ifdef WANT_SDL_MIXER

#ifdef PALM_WEBOS
extern "C" int PDL_NotifyMusicPlaying(SDL_bool MusicPlaying);
#endif

#ifndef GLB_CONSOLE
Mix_Music*	g_pMixMusic=NULL;
#endif
#endif

DGInt gMusicVolume=-1;

// ------------------------------------------------------------- //
void	PLAYMUSIC(const DGStr& s, DGNat bLoop)
{
__Error(CMP_OK);
#ifndef GLB_CONSOLE
STOPMUSIC();
static DGStr filename;
filename = s;
if(!glb_prepare_reading_file(filename)) // Space Fractal :: Forgotten for this command as well.
{	__Error(CMP_NO_FILE);
return;
}

#if !defined(WANT_SDL_MIXER) && defined(WIN32)

// Make a window for MCI
/*
wnd_mp3 = MCIWndCreate(__hWnd, __hInstance, 
WS_CHILD | WS_VISIBLE | MCIWNDF_NOMENU |
MCIWNDF_NOPLAYBAR | MCIWNDF_NOERRORDLG |
MCIWNDF_NOAUTOSIZEMOVIE | MCIWNDF_NOAUTOSIZEWINDOW| MCIWNDF_NOTIFYPOS,
filename.c_str());
*/
bool systemptr = pDXin->IsSystemPointer();
pDXin->SystemPointer(false);
wnd_mp3 = MCIWndCreate(NULL, NULL, WS_POPUP| // 
MCIWNDF_NOERRORDLG |
MCIWNDF_NOPLAYBAR|MCIWNDF_NOMENU
, filename.c_str());


MCIWndSetTimeFormat(wnd_mp3, "ms");
UINT milliseconds = max(500, MCIWndGetLength(wnd_mp3));

//	gTimerIndex = ::SetTimer(__hWnd, EVENT_TIMER_MP3_LOOP, milliseconds, MusicTimer);
if(bLoop)
gMusicRepeat = AccurateTime() + milliseconds;
else
gMusicRepeat = 0;

/*
UpdateWindow(wnd_mp3);
ShowWindow(wnd_mp3, SW_SHOW);
RECT r2 = {0,-30,100,-1};
MCIWndPutDest(wnd_mp3, &r2); // new RECT

SetWindowPos(wnd_mp3,           // window to resize
NULL,                          // z-order: don't care
r2.left, r2.top, r2.right-r2.left, r2.bottom-r2.top,
SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);

//	EnableWindow(wnd_mp3, FALSE);
*/
MCIWndSeek(wnd_mp3, MCIWND_START);
MCIWndPlay(wnd_mp3);
::SetFocus(__hWnd);

pDXin->SystemPointer(systemptr);
#elif defined(WANT_SDL_MIXER)
#ifdef PALM_WEBOS
PDL_NotifyMusicPlaying(SDL_TRUE);
#endif
g_pMixMusic = Mix_LoadMUS(filename.c_str());

if (g_pMixMusic)
{
Mix_PlayMusic(g_pMixMusic, bLoop ? -1 : 1);
Mix_VolumeMusic(SDL_MIX_MAXVOLUME);
}
else
{
g_debug("PLAYMUSIC: %s\n", Mix_GetError());
}
#elif defined(APPLE_COREAUDIO)

iPhonePlayMusic(filename.c_str(), bLoop);

#endif
MUSICVOLUME(1.0);

glb_do_pause(FALSE);
if(!pDXin->IsSystemPointer())
{
pDXin->SystemPointer(true);
pDXin->SystemPointer(false);
}
#endif // console
}

DGNat	ISMUSICPLAYING()
{
#ifndef GLB_CONSOLE
#if !defined(WANT_SDL_MIXER) && defined(WIN32)
if(wnd_mp3)
{
if(gMusicRepeat>0) return TRUE; // loops, so, yes, plays
LONG pos = MCIWndGetPosition(wnd_mp3);
if (pos >= MCIWndGetEnd(wnd_mp3))
return FALSE;
return TRUE;
}
return FALSE;
#elif defined(WANT_SDL_MIXER)
return Mix_PlayingMusic() ? TRUE : FALSE;
#elif defined(TARGET_OS_IPHONE)
return iPhoneIsMusicPlaying();
#endif
#else
return 0;
#endif
}

void PAUSEMUSIC(DGNat bPause)
{
#ifndef GLB_CONSOLE
#if !defined(WANT_SDL_MIXER) && defined(WIN32)
static DGInt pause_time=0;
if(wnd_mp3)
{
if(bPause)
{
if(gMusicRepeat>0)
{
pause_time=AccurateTime();
gMusicRepeat = -gMusicRepeat;
}
MCIWndPause(wnd_mp3);
}
else
{
if(gMusicRepeat < 0)
{
gMusicRepeat = -gMusicRepeat;
gMusicRepeat += (AccurateTime() - pause_time);
}
MCIWndResume(wnd_mp3);
}
}
#elif defined(WANT_SDL_MIXER)
if(bPause)
{
if( Mix_PlayingMusic() ) Mix_PauseMusic();
}
else
{
Mix_ResumeMusic();
}
#elif defined(TARGET_OS_IPHONE)
iPhonePauseMusic(bPause ? true:false);
#endif
#endif
}


// ------------------------------------------------------------- //
void MUSICVOLUME(DGInt volume)
{
#ifndef GLB_CONSOLE
if(gMusicVolume == volume) return;
gMusicVolume=volume;
#if !defined(WANT_SDL_MIXER) && defined(WIN32)
if(wnd_mp3)
{
MCIWndSetVolume(wnd_mp3, (LONG)(1000.0 * volume));
}
#elif defined(WANT_SDL_MIXER)
Mix_VolumeMusic( (int)(SDL_MIX_MAXVOLUME * volume));
#elif defined(TARGET_OS_IPHONE)
iPhoneMusicVolume(volume);
#endif
#endif
}


// ------------------------------------------------------------- //
void	STOPMUSIC()
{
#ifndef GLB_CONSOLE
gMusicVolume=-1;
#if !defined(WANT_SDL_MIXER) && defined(WIN32)
//	if(gTimerIndex) ::KillTimer(__hWnd, EVENT_TIMER_MP3_LOOP); gTimerIndex=0;
gMusicRepeat=0;
MCIWndStop(wnd_mp3);
MCIWndDestroy(wnd_mp3);
wnd_mp3=NULL;
#elif defined(WANT_SDL_MIXER)
#ifdef PALM_WEBOS
PDL_NotifyMusicPlaying(SDL_FALSE);
#endif

if(g_pMixMusic)
{
Mix_HaltMusic();
Mix_FreeMusic(g_pMixMusic);
}
g_pMixMusic=NULL;
#elif defined(TARGET_OS_IPHONE)
iPhoneStopMusic();
#endif
#endif
}

// ------------------------------------------------------------- //
void	SETSCREEN(DGNat w, DGNat h, DGNat fs)
{
#ifndef GLB_CONSOLE
#ifdef TARGET_OS_IPHONE
fs=1;
#endif

#if !defined(GPHWIZ) && !defined(GP2X) && !defined(CAANOO)
__DG_RESX = (int)w;
__DG_RESY = (int)h;
__DG_FULLSCREEN = (int)fs;
__g_pRbow->SetScreen(__DG_RESX, __DG_RESY, 0, __DG_FULLSCREEN);
pDXin->SystemPointer( pDXin->IsSystemPointer() );
#endif

#if defined(WIN32) && !defined(WANT_SDL) && !defined(POCKETPC)
pDXin->SetWindow(__g_pRbow->m_WND.hwnd);
// hwnd might have changed!
__hWnd = __g_pRbow->m_WND.hwnd;
#endif
#if defined(WIN32) && !defined(WANT_SDL_MIXER)
pDXsnd->SetWindow(__g_pRbow->m_WND.hwnd);
#endif
// otherwise no window
for(int i=0; i<5; ++i)
{SHOWSCREEN();}
#endif
}

extern void X_MIPMAPPING(DGNat state);




// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void DemoWatermark()
{
#ifndef GLB_CONSOLE
if (__IsDemoVersion)
{
static	int _dmx=0, _dmy=0;
#define DEMO_DURATION (60000*5) // 5 minutes
static DGInt _demo_end = 0;
static DGInt _demo_start = 0;

if(_demo_end == 0)
{
_demo_end = AccurateTime() + DEMO_DURATION;
_demo_start = AccurateTime();
}
DGInt timeall = AccurateTime();
// factor of demo time (1.0 ... 0.0)
DGInt percent = (_demo_end - timeall) / DEMO_DURATION;
DGInt fade=-1;
//if(percent<0.875 && percent>0.128)
fade = COS(percent * DEMO_DURATION/60000 * 4 * 360);

// Blinking DEMO
if(fade<0)
{
_dmx = (int)((timeall - _demo_start)/10);
if(_dmx>100) _dmx=100;
__g_pRbow->Make2DMode();

#if defined(TINYGL) || defined(TRENKI3D)
__g_pRbow->ShowDemo((int)((_dmx>>2) - 32), (float)fade);
const int logoy=14;
#else
__g_pRbow->ShowDemo((int)_dmx, (float)fade);
const int logoy=84;
#endif

if(percent<0)
{
ALPHAMODE(0);
DRAWRECT(0,logoy,64,8,RGB(255,255,255));
DRAWRECT(1,logoy+1,62,6,RGB(255,0,0));
__g_pRbow->FlipScreens(gpWinMsgCallback);
SLEEP(1000);
__EndProgram();
}

ALPHAMODE(fade);
DRAWRECT(0,logoy, 64,8,RGB(0,0,0));
DRAWRECT(0,logoy, (DGNat)(1+64*percent),8,RGB((DGNat)MIN(255.0,MAX(0.0,256-percent*512)),(DGNat)MIN(255.0, MAX(0.0,percent*512)),0));

DRAWLINE(0, logoy,  64,logoy  ,RGB(255,255,255));
DRAWLINE(0, logoy,   0,logoy+8,RGB(255,255,255));
DRAWLINE(0 ,logoy+8,64,logoy+8,RGB(255,255,255));
DRAWLINE(64,logoy,  64,logoy+8,RGB(255,255,255));
ALPHAMODE(0);
}
}
#endif
}



const int MIN_FRAMES_BEFORE_HIBERNATE = 30; // 30x SHOWSCREEN, then allow first try to hibernate -> more fluid experience
static int __g_nFlipSinceHibernate = 0; // number of SHOWSCREENS since last HIBERNATE -> make more responsive for a short time after a mousemove


// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void    glb_showscreen_finish_frame()
{
if(__g_Did3D  && ((__g_LicenseBits & 1) == 0)) __SetDemoVersion();
if(__g_DidNET && ((__g_LicenseBits & 2) == 0)) __SetDemoVersion();

#ifndef GLB_CONSOLE
DemoWatermark();

// don't activate the window with every ondebug
// makes debugging less flickering
#if defined(WIN32) && !defined(POCKETPC)
if(__g_HadBreakPoint)
{
printf("activate\n");
// BringWintowToFront has a "flash taskbar/prevent steal focus" issue
// Here's the fix
//Attach foreground window thread
//to our thread
HWND hwnd = (HWND)GLBASIC_HWND();
DWORD nfore = GetWindowThreadProcessId(::GetForegroundWindow(),NULL);
DWORD nmine = GetCurrentThreadId();
if( nfore != nmine)
{
AttachThreadInput(nfore,nmine,TRUE);
::ShowWindow(hwnd, SW_SHOW);
::BringWindowToTop(hwnd);
::SetActiveWindow(hwnd);
//Detach the attached thread
AttachThreadInput(nfore, nmine,FALSE);
}
else
{
::ShowWindow(hwnd, SW_SHOW);
::BringWindowToTop(hwnd);
::SetActiveWindow(hwnd);
}
printf("ok\n");

__g_HadBreakPoint=FALSE;
}
#endif

__g_LastTime = __g_ThisTime; __g_ThisTime = AccurateTime();

// Repeat Music
while(__g_paused)
{
__g_nFlipSinceHibernate = MIN_FRAMES_BEFORE_HIBERNATE+1; // allow hibernation
HIBERNATE();
}

#if !defined(ANDROID) // Space Fractal, Not doing this on Android. Using Java system instead.
gKeyStatusCounter = 0;
pDXin->GetKeyboardStatus(); // Update keyboard status for next frames
#endif
pDXin->RefreshMouseXY();

// #if defined(HAVE_OPENGL_ES) && defined(WANT_SDL)
//	SDL_Delay(1); // will wait 10 ms, maybe? Yikes!
// #endif

if ((__g_AllowEscape
&& (pDXin->GetKey(129) || pDXin->GetKey(1 /*DIK_ESCAPE*/ )) ) // ESC
#ifdef MACOSX
|| (pDXin->GetKey(219) && pDXin->GetKey(16))                  // Command+Q
#else
|| (pDXin->GetKey(56) && pDXin->GetKey(62))                   // ALT-F4
#endif
) // ESC | Alt+F4
goto eXit;

__g_pRbow3D->DoShadows(false); // finish shadows if any

_WinMSG(false); // at least do it once, so you have music repeating

if(!__g_pRbow->FlipScreens(gpWinMsgCallback))
goto eXit;

return;
eXit:
__Error(CMP_OK);
__EndProgram();
#endif
}

// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void    glb_showscreen_init_next_frame()
{
#ifndef GLB_CONSOLE
VIEWPORT(0,0,0,0); // this calls the prescaler // __g_pRbow->Make2DMode();
__g_pRbow->PrepareBackbuffer(); // only prepare as if showscreen was done

__g_pRbow->SetAlphaTesting(1.0f); // no testing
__g_pRbow->DoAlpha(-1.0f);

// __g_pRbow->PasteSurface(0);

X_MIPMAPPING(0);
__g_pRbow3D->SetShader(-1);

// SPACEFRACTAL_SEE_HERE - you deleted this line?
pDXin->m_QueryCount = 100000; // reset keyboard counter on next KEY() call

++__g_nFlipSinceHibernate;
#endif
}

// *** SPACE FRACTAL FIXES 2017.3.1 ****
#ifdef ANDROID
extern "C"
{ 	void pausemode();
}
#endif

#ifdef TARGET_OS_IPHONE
extern "C" // **** Space Fractal :: few extern functions is required.
{ 	int iPhonePausemode();
int iPhonePauseresume();
int isIphone();
}
#endif
// ------------------------------------------------------------- //
// ------------------------------------------------------------- //
void	SHOWSCREEN()
{
#if !defined(EMSCRIPTEN) || defined(TRENKI3D) // don't manually flip in WebGL
glb_showscreen_finish_frame();
glb_showscreen_init_next_frame();
#endif
#if defined(ANDROID) // Space Fractal :: Fixes for the HIBERNATE issue. Pausemode cannot directly been called from Java, which might crash Virtual Machine instead.
pausemode(); 
#else // Space Fractal :: HIBERNATE can also cause some platforms to crash when called from a thread. To prevent it, uses __g_paused_safe=1 for FALSE and __g_paused_safe=2 for TRUE instead.

int __g_paused_safe=0;

#ifdef TARGET_OS_IPHONE
__g_paused_safe=iPhonePausemode();
if (isIphone()==3) SETORIENTATION(-1);
#endif

if(__g_paused_safe>0)
{	
if (__g_paused_safe==2) glb_do_pause(TRUE);
__g_paused_safe=0;
}
#endif
}		

// ------------------------------------------------------------- //
void BUSY()
{
__g_nFlipSinceHibernate = 0; // next few frames will not hibernate
}

// ------------------------------------------------------------- //
void	HIBERNATE()
{
#ifndef GLB_CONSOLE
// one message loop is a must -> some use while(KEY(123)){HIBERNATE(); }
if (!_WinMSG(false))
{
g_debug("end since WinMSG()==0\n");
__EndProgram();
}


// do nothing more if the last action (mousemove, key, ...) was not long ago
if(__g_nFlipSinceHibernate < MIN_FRAMES_BEFORE_HIBERNATE)
{
return;
}


DGNat oldmouse[4];
DGNat v1,v2,v3,v4;
int   nj;
MOUSESTATE(oldmouse[0], oldmouse[1], oldmouse[2], oldmouse[3]);
for(int nt=0; nt<100; ++nt) // see sleep below -> loop 1 sec w/o updating the display
{
if (!_WinMSG(true)) // here you are allowed to sleep until the next message arrives
{
g_debug("end since WinMSG()==0\n");
__EndProgram();
}

// Stop in pause mode
if(__g_paused)
{
g_debug("pause loop in showscreen/hibernate\n");
while(__g_paused && !__g_HadBreakPoint)
{
SLEEP(500);
if (!_WinMSG(true))
{
g_debug("end since WinMSG()==0\n");
__Error(CMP_OK); __EndProgram();
}
#if defined(ANDROID)
pausemode(); // Space Fractal - This reequired to get it resumed.
#endif
#if defined(TARGET_OS_IPHONE) // Space Fractal - Required to wake up app from a freeze: ******
int gl_resume=iPhonePauseresume();
__g_paused=1;
if (gl_resume==1) __g_paused=0;
#endif
SLEEP(500);
CALLBYNAME(DGStr("GLB_ON_HIDE"));
}
g_debug("pause loop ended\n");
CALLBYNAME(DGStr("GLB_ON_RESUME"));
__g_paused=0;
//return;
}

pDXin->RefreshMouseXY();
if (__g_AllowEscape && (pDXin->GetKey(129) || pDXin->GetKey(1 /*DIK_ESCAPE*/ )) ) __EndProgram();

// KEYS
for(nj=0; nj<255; ++nj)
{
if(KEY(nj))
{
__g_nFlipSinceHibernate = 0;
return;
}
}

// MOUSE
MOUSESTATE(v1, v2, v3, v4);
if(v1!=oldmouse[0] || v2!=oldmouse[1] || v3!=0 || v4!=0 /*hover=no sleep*/)
{
oldmouse[0]=v1;
oldmouse[1]=v2;
oldmouse[2]=v3;
oldmouse[3]=v4;
__g_nFlipSinceHibernate = 0;
return;
}

// JOYSTYX
#if 0
#if !defined(ANDROID) && !defined(PALM_WEBOS) && !defined(PALM_PIXI) && !defined(TARGET_OS_IPHONE)
nj = (int)GETNUMJOYSTICKS();
bool bAction=false;
for(--nj; nj>=0 && !bAction; --nj)
{
for(i=0; i<32 && !bAction; ++i)
{
if(GETJOYBUTTON(nj, i)) bAction=true;
}
if(ABS(GETJOYX(nj))>0.1) bAction=true;
if(ABS(GETJOYY(nj))>0.1) bAction=true;
if(ABS(GETJOYZ(nj))>0.1) bAction=true;
if(GETDIGIX(nj))         bAction=true;
if(GETDIGIY(nj))         bAction=true;
}
if(bAction)
{
__g_nFlipSinceHibernate = 0;
return;
}
#endif
#endif

// really PAUSE
SLEEP(10);
}
#endif
}


// INPUT/OUTPUT
// ------------------------------------------------------------- //
void	INPUT(DGStr& s, DGNat x, DGNat y, DGNat bKerning)
{
#ifndef GLB_CONSOLE
DGStr	str=s, show;
char	c[3];
int		sleeper=0;
int		blink=0;
c[0]=0; c[1]=0; c[2]=0;
__g_pRbow->GrabSurface(3);
__g_pRbow->PasteSurface(3);
__g_pRbow->Text2D(__nCurFont, s.c_str(), (float)x, (float)y, 0.0f, bKerning, TRUE);
//	pFnt[__nCurFont].Print(s.c_str(), (int)x, (int)y);
SHOWSCREEN();
while(true)
{
pDXin->GetKeyboardStatus();
c[0]=pDXin->GetKeyChar();
if (c[0]=='\0')
{
sleeper++; if (sleeper>20) {sleeper=0; blink=1-blink;}
}
else if (c[0]=='\r' || c[0]=='\n')
break; // Return|Enter|ESC
else if (c[0]==0x08) // Back
{
if (s.len()>0) s.left(s.len()-1);
}
else
{
s+=c;
}
__g_pRbow->PasteSurface(3);
show=s;
if (blink) show+="_";
PRINT(show, x, y, bKerning);
SHOWSCREEN();
}
__g_pRbow->FreeSurface(3);
#endif
}

// ------------------------------------------------------------- //
void	INPUT(DGInt& s, DGNat x, DGNat y, DGNat bKerning) {DGStr	str; INPUT(str, x, y, bKerning); s=str;}
void	INPUT(DGNat& s, DGNat x, DGNat y, DGNat bKerning) {DGStr	str; INPUT(str, x, y, bKerning); s=str;}




// ------------------------------------------------------------- //
#ifdef GLB_CONSOLE


static char mygetch()
{
#ifdef WIN32
if(!_kbhit()) return '\0'; // no key pressed -> don't freeze program.

char rv = (char)_getch();
if (rv == 3) // Ctrl+C
{
END();
}
return rv;
#else


// GF: not cleanly defined sometimes
struct gf_termios {
tcflag_t c_iflag;
tcflag_t c_oflag;
tcflag_t c_cflag;
tcflag_t c_lflag;
cc_t c_cc[NCCS];
speed_t c_ispeed;
speed_t c_ospeed;
};

gf_termios oldt, newt;
char ch=0;
tcgetattr( STDIN_FILENO, (termios*)&oldt );
newt = oldt;
newt.c_lflag &= ~( ICANON | ECHO );
tcsetattr( STDIN_FILENO, TCSANOW, (termios*)&newt );
ch = (char)getchar();
tcsetattr( STDIN_FILENO, TCSANOW, (termios*)&oldt );
return ch;
#endif
}
#endif



// ------------------------------------------------------------- //
#ifndef GLB_CONSOLE
void DXinp_push_inkey(char ic)
{
if(!ic) return;

if(ic==13) ic=10; // \r is \n for me

if(ic < 32 && ic>0) // special chars
{
if(ic!=8 && ic!=9 && ic!=10) // back tab \n
return;
}

// avoid buffer overflow -> ingore new chars when old ones are there
if(pDXin->m_inkey_chars.Size() < 16)
pDXin->m_inkey_chars.Push(ic);
}
#endif


// ------------------------------------------------------------- //
DGStr	INKEY_Str()
{
#ifndef GLB_CONSOLE
char	c[2];
DGStr	str;
c[0]=pDXin->GetKeyChar();
c[1]='\0';
str=(const char*)c;
return str;
#else
char str[4];
str[1]='\0';
str[0] = mygetch();

if(str[0]==(char)0xE0)
{
str[2]='\0';
str[0]=(char)0xE0;
str[1]=mygetch();
}

return DGStr(str);
#endif
}

void	JOYSTATE(DGNat& jx, DGNat& jy, DGNat& b1, DGNat& b2)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, 0);
jx=(DGNat) (int)(js.lX/30000.0f);
jy=(DGNat) (int)(js.lY/30000.0f);
b1=(DGNat) js.rgbButtons[0];
b2=(DGNat) js.rgbButtons[1];
#endif
}

// ------------------------------------------------------------- //
void	JOYSTATE(DGInt& jx, DGInt& jy, DGInt& b1, DGInt& b2)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, 0);
jx=(DGInt) (int)(js.lX/30000.0);
jy=(DGInt) (int)(js.lY/30000.0);
b1=(DGInt) js.rgbButtons[0];
b2=(DGInt) js.rgbButtons[1];
#endif
}

#if defined (TARGET_OS_IPHONE) || defined(ANDROID) || defined(PALM_WEBOS)
#define JOY_AXIS_LIMIT 10.0 // 10x "g"
#else
#define JOY_AXIS_LIMIT 1.0  // joystick range
#endif

DGInt	GETJOYX(DGNat nJoy)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);

// ICADE - do _not_ rotate the controller - just the screen
#ifdef TARGET_OS_IPHONE
if(nJoy>0) return MAX(-JOY_AXIS_LIMIT, MIN(JOY_AXIS_LIMIT, js.lX/32767.0f));
#endif
__g_pRbow->Rot_Gravity2Display((int)js.lX, (int)js.lY, (int*)&js.lX, (int*)&js.lY);

return MAX(-JOY_AXIS_LIMIT, MIN(JOY_AXIS_LIMIT, js.lX/32767.0f));
#else
return 0;
#endif
}

DGInt	GETJOYY(DGNat nJoy)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);

// ICADE - do _not_ rotate the controller - just the screen
#ifdef TARGET_OS_IPHONE
if(nJoy>0) return MAX(-JOY_AXIS_LIMIT, MIN(JOY_AXIS_LIMIT, js.lY/32767.0));
#endif

__g_pRbow->Rot_Gravity2Display((int)js.lX, (int)js.lY, (int*)&js.lX, (int*)&js.lY);
return MAX(-JOY_AXIS_LIMIT, MIN(JOY_AXIS_LIMIT, js.lY/32767.0f));
#else
return 0;
#endif
}

DGInt	GETJOYZ(DGNat nJoy)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);
return MAX(-JOY_AXIS_LIMIT, MIN(JOY_AXIS_LIMIT, js.lZ/32767.0f));
#else
return 0;
#endif
}
DGInt	GETJOYRX(DGNat nJoy)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);
__g_pRbow->Rot_Gravity2Display((int)js.lRx, (int)js.lRy, (int*)&js.lRx, (int*)&js.lRy);
return MAX(-1.0, MIN(1.0, js.lRx/32767.0f));
#else
return 0;
#endif
}
DGInt	GETJOYRY(DGNat nJoy)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);
__g_pRbow->Rot_Gravity2Display((int)js.lRx, (int)js.lRy, (int*)&js.lRx, (int*)&js.lRy);
return MAX(-1.0, MIN(1.0, js.lRy/32767.0f));
#else
return 0;
#endif
}
DGInt	GETJOYRZ(DGNat nJoy)
{
#ifndef GLB_CONSOLE
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);
return MAX(-1.0, MIN(1.0, js.lRz/32767.0f));
#else
return 0;
#endif
}

DGNat	GETDIGIX(DGNat nJoy)
{
#ifndef GLB_CONSOLE
int rx=0, ry=0;

DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);
switch(js.rgdwPOV[0])
{
case  4500:
case  9000:
case 13500:
rx=1; break;
case 31500:
case 22500:
case 27000:
rx=-1; break;
}
__g_pRbow->Rot_Display2Screen(rx, ry, &rx, &ry);
return rx;
#else
return 0;
#endif
}

DGNat	GETDIGIY(DGNat nJoy)
{
#ifndef GLB_CONSOLE
int rx=0, ry=0;
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);
switch(js.rgdwPOV[0])
{
case 31500:
case  4500:
case 0: ry=-1; break;

case 13500:
case 22500:
case 18000: ry=1;break;
}
__g_pRbow->Rot_Display2Screen(rx, ry, &rx, &ry);
return ry;
#else
return 0;
#endif
}

DGNat	GETJOYBUTTON(DGNat nJoy, DGNat Button)
{
#ifndef GLB_CONSOLE
if (Button<0 || Button>=32) return 0;
DIJOYSTATE	js;
pDXin->GetJoystickData(&js, (int)nJoy);
return js.rgbButtons[(int)Button];
#else
return 0;
#endif
}

DGStr	GETJOYNAME_Str(DGNat nJoy)
{
#ifndef GLB_CONSOLE
DGStr	str;
pDXin->GetJoyName(str.getbuffer(522), (int)nJoy);
str.releasebuffer();
return str;
#else
return 0;
#endif
}

DGNat	GETNUMJOYSTICKS()
{
#ifndef GLB_CONSOLE
return pDXin->GetNumJoysticks();
#else
return 0;
#endif
}

void	FORCEFEEDBACK(DGNat nJoy, DGInt duration, DGInt x_motor, DGInt y_motor)
{
#ifndef GLB_CONSOLE
pDXin->ffRumble((int)nJoy, 1, (float)duration, (float)x_motor, (float)y_motor);
#endif
}

DGNat	GETMOUSECOUNT()
{
#ifndef GLB_CONSOLE
return pDXin->GetNumMice();
#else
return 0;
#endif
}
void	SETACTIVEMOUSE(DGNat i)
{
#ifndef GLB_CONSOLE
int imax = pDXin->GetNumMice();
if (i>=imax) i=0;
pDXin->SetActiveMouse(i);
#endif
}


DGNat MOUSEAXIS(DGNat nAxis)
{
#ifndef GLB_CONSOLE
DIMOUSEDATA	di;
pDXin->GetMouseData(&di, false);

int acx, acy;
__g_pRbow->Rot_Display2Screen(di.mAccX, di.mAccY, &acx, &acy);
switch(nAxis)
{
case 0: return (DGNat)(acx);
case 1: return (DGNat)(acy);
case 2: return (DGNat)di.mMouseWheel;
case 3: return di.mButton1 ? 1 : 0;
case 4: return di.mButton2 ? 1 : 0;
case 5: return di.mButton3 ? 1 : 0;
}
return 0;
#else
return 0;
#endif
}

// ------------------------------------------------------------- //
void	MOUSESTATE(DGInt& jx, DGInt& jy, DGInt& b1, DGInt& b2)
{
#ifndef GLB_CONSOLE
DGNat a,b,c,d;
MOUSESTATE(a,b,c,d);
jx=(DGInt)a; jy=(DGInt)b; b1=(DGInt)c; b2=(DGInt)d;
#endif
}

void	MOUSESTATE(DGNat& jx, DGNat& jy, DGNat& b1, DGNat& b2)
{
#ifndef GLB_CONSOLE
DIMOUSEDATA	di;
pDXin->GetMouseData(&di, true);

b1=di.mButton1 ? 1 : 0;
b2=di.mButton2 ? 1 : 0;

DXInput::MousePos& mps = pDXin->GetCurMousePos();
jx=(DGNat)mps.m_MouseX;
jy=(DGNat)mps.m_MouseY;

// rotate to screen coords
__g_pRbow->Rot_Display2Screen(jx, jy, &jx, &jy);


// clip
DGNat scx, scy;

// GETSCREENSIZE(scx, scy); <- might be offscreen size
if(__g_pRbow->m_landscape==1 || __g_pRbow->m_landscape==3)
{
scy = (DGNat)__g_pRbow->m_WND.width;
scx = (DGNat)__g_pRbow->m_WND.height;
}
else
{
scx = (DGNat)__g_pRbow->m_WND.width;
scy = (DGNat)__g_pRbow->m_WND.height;
}

if(jx<0) jx=0;
if(jy<0) jy=0;
if(jx>=scx) jx=scx;
if(jy>=scy) jy=scy;

if(__g_CurrentScreen == -1 && __g_Prescaler.scale != 0.0f)
{
jx-=__g_Prescaler.offx;
jy-=__g_Prescaler.offy;
jx=(DGNat)((float)jx/__g_Prescaler.scale);
jy=(DGNat)((float)jy/__g_Prescaler.scale);
}



// rotate back into mouse coords for clipping
// __g_pRbow->Rot_Screen2Display(jx, jy, &mps.m_MouseX, &mps.m_MouseY);

#endif
}

void	SYSTEMPOINTER(DGInt onoff)
{
#ifndef GLB_CONSOLE
pDXin->SystemPointer(onoff ? true:false);
#endif
}


// ------------------------------------------------------------- //
void	SETMOUSE(DGNat mx, DGNat my)
{
#ifndef GLB_CONSOLE

int scx=mx, scy=my;
__g_pRbow->Rot_Screen2Display(mx, my, &scx, &scy);

pDXin->SetMouse((int)scx, (int)scy);
#endif
}

// ------------------------------------------------------------- //
void	MOUSEWAIT()
{
#ifndef GLB_CONSOLE
__g_nFlipSinceHibernate = MIN_FRAMES_BEFORE_HIBERNATE+1; // allow to hibernate
while(pDXin->AnyMouse()) {HIBERNATE();}

while(pDXin->AnyMouse() == 0)
{
// pDXin->GetKeyboardStatus(); if (__g_AllowEscape && (pDXin->GetKey(129) || pDXin->GetKey(1 /*DIK_ESCAPE*/ )) ) __EndProgram();
HIBERNATE();
}
while(pDXin->AnyMouse()) {HIBERNATE();} // wait for release
__g_nFlipSinceHibernate = 0; // no hibernate for a short time
#endif
}

// ------------------------------------------------------------- //
void	KEYWAIT()
{
#if defined( TARGET_OS_IPHONE )
MOUSEWAIT();
return;
#endif
#ifndef GLB_CONSOLE
__g_nFlipSinceHibernate = MIN_FRAMES_BEFORE_HIBERNATE+1; // allow to hibernate


int iwait=-1;
while(iwait==-1)
{
pDXin->GetKeyboardStatus(true);
for (int i = 1; i <= 255; i++)
{
if(KEY(i))
{ iwait = i; break; }
}
__g_pRbow->WinMessages(NULL, true);
}
pDXin->GetKeyboardStatus(true);
while (KEY(iwait) != 0)
{
SLEEP(100);
__g_pRbow->WinMessages(NULL, false);
pDXin->GetKeyboardStatus(true);
}


__g_nFlipSinceHibernate = 0; // no hibernate for a short time

#else // Console
char rv = (char)_getch();
if (rv == 3) // Ctrl+C
{
END();
}
#endif
}



// ------------------------------------------------------------- //
DGNat	GENSOUND()
{
CLEARERROR();
#ifndef GLB_CONSOLE
for(DGNat i=MAX_WAV_SAMPLES-1; i>=0; --i)
{
if( !DXwav[i].IsLoaded() )
return i;
}
#endif
__Error(CMP_OUT_OF_MEMORY);
return -1;
}

// ------------------------------------------------------------- //
void	LOADSOUND(const DGStr& s, DGNat num, DGNat buffers)
{
CLEARERROR();
#ifndef GLB_CONSOLE
// Buffer check = Internal
if(num < 0 || num >= (DGNat)MAX_WAV_SAMPLES)
{
__Error(CMP_OUT_OF_MEMORY);
return;
}

DGStr file(s);
if(!glb_prepare_reading_file(file))
{
__Error(CMP_NO_FILE);
return;
}

// No error, just free mem
if (!DXwav[(int)num].Load(pDXsnd, file.c_str(), (int)buffers))
{
__Error(CMP_NO_FILE);
}
#endif
}

// ------------------------------------------------------------- //
DGNat	PLAYSOUND(DGNat num, DGInt fade, DGInt volume)
{
#ifndef GLB_CONSOLE
if(num<0 || num>=MAX_WAV_SAMPLES)
{
__Error(CMP_OUT_OF_MEMORY);
return 0;
}
fade =MAX(-1.0, MIN(fade, 1.0));
int ivolume= (int)(MAX(0, MIN(100.0*volume, 100.0)));
int ifade   =(int)(fade*(abs(DXSOUND_PAN_RIGHT)));
DGNat rv;

rv = (DGNat)DXwav[(int)num].Play(ifade, ivolume);
return rv<0 ? rv : (num << 8) + rv; // low byte = channel, above is sound index
#else
return 0;
#endif
}

// ------------------------------------------------------------- //
DGNat	SOUNDPLAYING(DGNat channel)
{
#ifndef GLB_CONSOLE
int iwav, n;

n = (int)channel;
iwav = n >> 8;
if(iwav<0 || iwav>=MAX_WAV_SAMPLES)
{
__Error(CMP_OUT_OF_MEMORY);
return FALSE;
}
return DXwav[iwav].IsPlaying( n & 0xff );
#else
return 0;
#endif
}

// ------------------------------------------------------------- //
void STOPSOUND(DGNat channel)
{
#ifndef GLB_CONSOLE
int iwav, n;

if(channel<0) return;
n = (int)channel;
iwav = n >> 8;
DXwav[iwav].Stop( n & 0xff );
#endif
}


// ------------------------------------------------------------- //
void	HUSH()
{
#ifndef GLB_CONSOLE
for (int i=0; i<MAX_WAV_SAMPLES; i++) {DXwav[i].Stop();}
#endif
}

// ------------------------------------------------------------- //
#if defined(ANDROID) // Space Fractal, this one disable the Back button, require a Java Call
extern "C" int AndroidEscape(int);
#endif

void	ALLOWESCAPE(DGNat i)
{	
#if defined(ANDROID)
AndroidEscape(i);
#endif
__g_AllowEscape = i ? TRUE : FALSE;
}


// ------------------------------------------------------------- //
DGStr	FILEREQUEST_Str(DGNat open, const DGStr& filter)
// ------------------------------------------------------------- //
{
DGStr			retstr;
#if !defined(WANT_SDL) && defined(WIN32)
int				i;
char			filt[1024];
char			dir[1024];
char			file[1024];
OPENFILENAME	ofn;
memset(&ofn, 0, sizeof(ofn));

memset(file, 0, 1024);
memset(dir,  0, 1024);
memset(filt, 0, 1024);

strcpy(filt, filter.c_str());
for (i=0; i<(int)filter.len(); i++)
{
if (filt[i]=='|')
{
filt[i]='\0';
}
}
filt[filter.len()]='\0';
ofn.lpstrFilter=filt;

// Get CurDir
::GetCurrentDirectory(1024, dir);
ofn.lpstrInitialDir=dir;

ofn.lStructSize=sizeof(ofn);
ofn.hwndOwner=(HWND)GLBASIC_HWND();
ofn.lpstrFile=file;
ofn.nMaxFile=1024;
ofn.Flags=OFN_HIDEREADONLY|OFN_EXPLORER;
//	if (open)
//		ofn.Flags|=OFN_FILEMUSTEXIST;

#ifndef GLB_CONSOLE
__g_pRbow->HideWindow();
#endif

BOOL ok=FALSE;
if (open)
{
ok=GetOpenFileName(&ofn);
}
else
{
ok=GetSaveFileName(&ofn);
}

::SetCurrentDirectory(dir);
#ifndef GLB_CONSOLE
if (__DG_FULLSCREEN)
{
SETSCREEN(__DG_RESX, __DG_RESY, TRUE);
}
else
{
__g_pRbow->DoWindowed();
}
#endif

retstr=(const char*)ofn.lpstrFile;
if (!ok || retstr[0]=='\0')
retstr="NO_FILE";
else
{
for (i=0; i<strlen(retstr.c_str()); i++)
{
if (retstr[i]=='\\') retstr[i]= '/';
}
}
#else // SDL-Version - Doh!!
retstr = "File:";
INPUT(retstr, 0, 100);
#endif
return retstr;
}


// --------------------------------------------------------------- //
// Stop process and hand over to debugger
// --------------------------------------------------------------- //
#ifdef WIN32
#pragma comment(lib, "kernel32.lib")
extern "C" int __stdcall IsDebuggerPresent();
#endif
void __PauseAndDebug(void* paddress)
{
#ifdef WIN32


#ifndef _DEBUG
if (!IsDebuggerPresent())
{
return;
}

char s[32];
for(int i=0; i<32; ++i) s[i]=0;
s[0]='B'; s[1]='P';
#pragma warning(disable: 4311)
_itoa(reinterpret_cast<int>(paddress), s+2, 16);

// Set manually to make debugable in VC
// __g_dbg.firsttime=0;
#ifndef GLB_CONSOLE
pDXin->UnaquireMouse();
//			::ShowWindow(__hWnd, SW_HIDE);
#endif

::OutputDebugStringA(s);

#ifndef GLB_CONSOLE
/*
::ShowWindow(__hWnd, SW_SHOW);
::BringWindowToTop(__hWnd);
::SetActiveWindow(__hWnd);
*/
__g_paused = FALSE;
pDXin->GetKeyboardStatus();
pDXin->RefreshMouseXY();
#endif

__g_HadBreakPoint=TRUE; // force window to top next time you do a SHOWSCREEN
#endif
#endif
}


}; // namespace

#ifdef PALM_WEBOS
extern "C" void PDL_Quit();
#endif



// Called in any case the PRG will be stopped
extern "C" void __EndProgram()
{
static char ending=0; if(ending)return;	ending=1; // might be called recursively. Bad!

if(__DG_DEBUG)
{
g_debug("-End On Line\n");
g_debug("%d\n", (int)__g_error);
g_debug("%d\n", (int)__g_errorline -1 );
g_debug("%d\n", (int)__g_debugline);
g_debug("%d\n", (int)__g_debugfile);
}
else
{
//		g_deldebug();
}

#if defined(POSIX)
if(__g_error != CMP_OK)
{
printf("GLB Error: %x\n", __g_error);
}
#endif

__ShutDownGLBasic();

#ifdef PALM_WEBOS
// crashes like mad
printf("PDL_Quit\n");
PDL_Quit(); // before SDL_Quit
printf("</PDL_Quit>\n");
#endif

#ifdef WANT_SDL
SDL_Quit();
#endif



#if !defined(WANT_SDL) && defined(WIN32)
#ifndef GLB_CONSOLE
// PostQuitMessage(0);
::InvalidateRect(0, NULL, TRUE);
#endif
#endif



#if defined(_DEBUG) && (defined(GF_WANT_DEBUG_NEW) || defined(MSVC_DEBUG_NEW_USED))
class DD{public: DD()
{}
~DD()
{
#ifdef GF_WANT_DEBUG_NEW
__debug_new_DumpUnfreed();
#endif
#ifdef _MSC_VER
_CrtDumpMemoryLeaks();
#endif
}
};

static DD __dd__;
#endif

#if defined(GLB_CONSOLE) || defined(POSIX)
fflush( stdout );
#endif


#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
// sync the written data to the disk
system("sync");


/*
// use a script instead to be safe
DGStr exepath;
GFFileSystem::GetExeDir(exepath.getbuffer(1024));
exepath.releasebuffer();
GFFileSystem::SetCurrentDir(exepath.c_str());

if(GFFileSystem::DoesFileExist("gp2xmenu.gpe"))
execl("gp2xmenu.pge","gp2xmenu.gpe",NULL);
if(GFFileSystem::DoesFileExist("gp2xmenu.gpu"))
execl("gp2xmenu.pgu","gp2xmenu.gpu",NULL);
if(GFFileSystem::DoesFileExist("gp2xmenu"))
execl("gp2xmenu","gp2xmenu",NULL);

chdir("/usr/gp2x");
execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
*/
fflush( stdout );
SLEEP(500);
#endif
printf("exit\n");

#if defined(EMSCRIPTEN)
SETLOOPSUB("");
printf("Exit with *(int*)0=0 - sorry\n");
int* pNull1 = NULL;
*pNull1=0;
#endif

exit(0);

//printf("Exit with *(int*)0=0 - sorry\n");
//int* pNull = NULL;
//*pNull=0;
// ExitProcess(0); // fails with memory exception
}
/*
#ifndef DIRECTINPUT_VERSION
#define DIRECTINPUT_VERSION 0x0500
#endif
*/
#if !defined(WANT_SDL) && defined(WIN32) && !defined(_WIN32_WCE)

#include <dinput.h>

/* This is a replacement for microsofts dxguid.lib and parts of dinput.lib. */
#undef DEFINE_GUID
#define DEFINE_GUID(n,a,b,c,d,e,f,g,h,i,j,k) const GUID n = {a,b,c,{d,e,f,g,h,i,j,k}}


// Inserted for compatibility #GF
DEFINE_GUID(GF_GUID_NULL,0,0,0,0,0,0,0,0,0,0,0);



/* d3rmobj.h */
DEFINE_GUID(CLSID_CDirect3DRMDevice,        0x4fa3568e, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMViewport,      0x4fa3568f, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMFrame,         0x4fa35690, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMMesh,          0x4fa35691, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMMeshBuilder,   0x4fa35692, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMFace,          0x4fa35693, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMLight,         0x4fa35694, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMTexture,       0x4fa35695, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMWrap,          0x4fa35696, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMMaterial,      0x4fa35697, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMAnimation,     0x4fa35698, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMAnimationSet,  0x4fa35699, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMUserVisual,    0x4fa3569a, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMShadow,        0x4fa3569b, 0x623f, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(CLSID_CDirect3DRMViewportInterpolator, 
0xde9eaa1, 0x3b84, 0x11d0, 0x9b, 0x6d, 0x0, 0x0, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRMFrameInterpolator, 
0xde9eaa2, 0x3b84, 0x11d0, 0x9b, 0x6d, 0x0, 0x0, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRMMeshInterpolator, 
0xde9eaa3, 0x3b84, 0x11d0, 0x9b, 0x6d, 0x0, 0x0, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRMLightInterpolator, 
0xde9eaa6, 0x3b84, 0x11d0, 0x9b, 0x6d, 0x0, 0x0, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRMMaterialInterpolator, 
0xde9eaa7, 0x3b84, 0x11d0, 0x9b, 0x6d, 0x0, 0x0, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRMTextureInterpolator, 
0xde9eaa8, 0x3b84, 0x11d0, 0x9b, 0x6d, 0x0, 0x0, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRMProgressiveMesh, 0x4516ec40, 0x8f20, 0x11d0, 0x9b, 0x6d, 0x00, 0x00, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRMClippedVisual,   0x5434e72d, 0x6d66, 0x11d1, 0xbb, 0xb, 0x0, 0x0, 0xf8, 0x75, 0x86, 0x5a);

/* d3rmwin.h */
DEFINE_GUID(IID_IDirect3DRMWinDevice,   0xc5016cc0, 0xd273, 0x11ce, 0xac, 0x48, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);

/* dplay.h */
/*
DEFINE_GUID(IID_IDirectPlay2, 0x2b74f7c0, 0x9154, 0x11cf, 0xa9, 0xcd, 0x0, 0xaa, 0x0, 0x68, 0x86, 0xe3);
DEFINE_GUID(IID_IDirectPlay2A,0x9d460580, 0xa822, 0x11cf, 0x96, 0xc, 0x0, 0x80, 0xc7, 0x53, 0x4e, 0x82);

DEFINE_GUID(IID_IDirectPlay3, 0x133efe40, 0x32dc, 0x11d0, 0x9c, 0xfb, 0x0, 0xa0, 0xc9, 0xa, 0x43, 0xcb);
DEFINE_GUID(IID_IDirectPlay3A,0x133efe41, 0x32dc, 0x11d0, 0x9c, 0xfb, 0x0, 0xa0, 0xc9, 0xa, 0x43, 0xcb);

DEFINE_GUID(IID_IDirectPlay4, 0xab1c530, 0x4745, 0x11d1, 0xa7, 0xa1, 0x0, 0x0, 0xf8, 0x3, 0xab, 0xfc);
DEFINE_GUID(IID_IDirectPlay4A,0xab1c531, 0x4745, 0x11d1, 0xa7, 0xa1, 0x0, 0x0, 0xf8, 0x3, 0xab, 0xfc);

DEFINE_GUID(CLSID_DirectPlay,0xd1eb6d20, 0x8923, 0x11d0, 0x9d, 0x97, 0x0, 0xa0, 0xc9, 0xa, 0x43, 0xcb);

DEFINE_GUID(DPSPGUID_IPX, 0x685bc400, 0x9d2c, 0x11cf, 0xa9, 0xcd, 0x0, 0xaa, 0x0, 0x68, 0x86, 0xe3);
DEFINE_GUID(DPSPGUID_TCPIP, 0x36E95EE0, 0x8577, 0x11cf, 0x96, 0xc, 0x0, 0x80, 0xc7, 0x53, 0x4e, 0x82);
DEFINE_GUID(DPSPGUID_SERIAL, 0xf1d6860, 0x88d9, 0x11cf, 0x9c, 0x4e, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPSPGUID_MODEM, 0x44eaa760, 0xcb68, 0x11cf, 0x9c, 0x4e, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(IID_IDirectPlay, 0x5454e9a0, 0xdb65, 0x11ce, 0x92, 0x1c, 0x00, 0xaa, 0x00, 0x6c, 0x49, 0x72);
*/

/* dplobby.h */
/*
DEFINE_GUID(IID_IDirectPlayLobby, 0xaf465c71, 0x9588, 0x11cf, 0xa0, 0x20, 0x0, 0xaa, 0x0, 0x61, 0x57, 0xac);
DEFINE_GUID(IID_IDirectPlayLobbyA, 0x26c66a70, 0xb367, 0x11cf, 0xa0, 0x24, 0x0, 0xaa, 0x0, 0x61, 0x57, 0xac);
DEFINE_GUID(IID_IDirectPlayLobby2, 0x194c220, 0xa303, 0x11d0, 0x9c, 0x4f, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(IID_IDirectPlayLobby2A, 0x1bb4af80, 0xa303, 0x11d0, 0x9c, 0x4f, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(IID_IDirectPlayLobby3, 0x2db72490, 0x652c, 0x11d1, 0xa7, 0xa8, 0x0, 0x0, 0xf8, 0x3, 0xab, 0xfc);
DEFINE_GUID(IID_IDirectPlayLobby3A, 0x2db72491, 0x652c, 0x11d1, 0xa7, 0xa8, 0x0, 0x0, 0xf8, 0x3, 0xab, 0xfc);
DEFINE_GUID(CLSID_DirectPlayLobby, 0x2fe8f810, 0xb2a5, 0x11d0, 0xa7, 0x87, 0x0, 0x0, 0xf8, 0x3, 0xab, 0xfc);
DEFINE_GUID(DPLPROPERTY_MessagesSupported, 0x762ccda1, 0xd916, 0x11d0, 0xba, 0x39, 0x0, 0xc0, 0x4f, 0xd7, 0xed, 0x67);
DEFINE_GUID(DPLPROPERTY_LobbyGuid, 0xf56920a0, 0xd218, 0x11d0, 0xba, 0x39, 0x0, 0xc0, 0x4f, 0xd7, 0xed, 0x67);
DEFINE_GUID(DPLPROPERTY_PlayerGuid, 0xb4319322, 0xd20d, 0x11d0, 0xba, 0x39, 0x0, 0xc0, 0x4f, 0xd7, 0xed, 0x67);
DEFINE_GUID(DPLPROPERTY_PlayerScore, 0x48784000, 0xd219, 0x11d0, 0xba, 0x39, 0x0, 0xc0, 0x4f, 0xd7, 0xed, 0x67);
DEFINE_GUID(DPAID_TotalSize, 0x1318f560, 0x912c, 0x11d0, 0x9d, 0xaa, 0x0, 0xa0, 0xc9, 0xa, 0x43, 0xcb);
DEFINE_GUID(DPAID_ServiceProvider, 0x7d916c0, 0xe0af, 0x11cf, 0x9c, 0x4e, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPAID_LobbyProvider, 0x59b95640, 0x9667, 0x11d0, 0xa7, 0x7d, 0x0, 0x0, 0xf8, 0x3, 0xab, 0xfc);
DEFINE_GUID(DPAID_Phone, 0x78ec89a0, 0xe0af, 0x11cf, 0x9c, 0x4e, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPAID_PhoneW, 0xba5a7a70, 0x9dbf, 0x11d0, 0x9c, 0xc1, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPAID_Modem, 0xf6dcc200, 0xa2fe, 0x11d0, 0x9c, 0x4f, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPAID_ModemW, 0x1fd92e0, 0xa2ff, 0x11d0, 0x9c, 0x4f, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPAID_INet, 0xc4a54da0, 0xe0af, 0x11cf, 0x9c, 0x4e, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPAID_INetW, 0xe63232a0, 0x9dbf, 0x11d0, 0x9c, 0xc1, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
DEFINE_GUID(DPAID_INetPort, 0xe4524541, 0x8ea5, 0x11d1, 0x8a, 0x96, 0x0, 0x60, 0x97, 0xb0, 0x14, 0x11);
DEFINE_GUID(DPAID_MaxMessageSize, 0xf5d09980, 0xf0c4, 0x11d1, 0x83, 0x26, 0x0, 0x60, 0x97, 0xb0, 0x14, 0x11);
DEFINE_GUID(DPAID_ComPort, 0xf2f0ce00, 0xe0af, 0x11cf, 0x9c, 0x4e, 0x0, 0xa0, 0xc9, 0x5, 0x42, 0x5e);
*/

/* dxfile.h */
DEFINE_GUID(CLSID_CDirectXFile, 0x4516ec43, 0x8f20, 0x11d0, 0x9b, 0x6d, 0x00, 0x00, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(IID_IDirectXFile, 0x3d82ab40, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(IID_IDirectXFileEnumObject, 0x3d82ab41, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(IID_IDirectXFileSaveObject, 0x3d82ab42, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(IID_IDirectXFileObject, 0x3d82ab43, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(IID_IDirectXFileData, 0x3d82ab44, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(IID_IDirectXFileDataReference, 0x3d82ab45, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(IID_IDirectXFileBinary, 0x3d82ab46, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_DXFILEHeader, 0x3d82ab43, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);

/* rmxguid.h */
DEFINE_GUID(TID_D3DRMInfo, 0x2b957100, 0x9e9a, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMMesh, 0x3d82ab44, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMVector, 0x3d82ab5e, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMMeshFace, 0x3d82ab5f, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMMaterial, 0x3d82ab4d, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMMaterialArray, 0x35ff44e1, 0x6c7c, 0x11cf, 0x8F, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMFrame, 0x3d82ab46, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMFrameTransformMatrix, 0xf6f23f41, 0x7686, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMMeshMaterialList, 0xf6f23f42, 0x7686, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMMeshTextureCoords, 0xf6f23f40, 0x7686, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMMeshNormals, 0xf6f23f43, 0x7686, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMCoords2d, 0xf6f23f44, 0x7686, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMMatrix4x4, 0xf6f23f45, 0x7686, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMAnimation, 0x3d82ab4f, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMAnimationSet, 0x3d82ab50, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMAnimationKey, 0x10dd46a8, 0x775b, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xA3);
DEFINE_GUID(TID_D3DRMFloatKeys, 0x10dd46a9, 0x775b, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xA3);
DEFINE_GUID(TID_D3DRMMaterialAmbientColor, 0x01411840, 0x7786, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xA3);
DEFINE_GUID(TID_D3DRMMaterialDiffuseColor, 0x01411841, 0x7786, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xA3);
DEFINE_GUID(TID_D3DRMMaterialSpecularColor, 0x01411842, 0x7786, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xA3);
DEFINE_GUID(TID_D3DRMMaterialEmissiveColor, 0xd3e16e80, 0x7835, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMMaterialPower, 0x01411843, 0x7786, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xA3);
DEFINE_GUID(TID_D3DRMColorRGBA, 0x35ff44e0, 0x6c7c, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xA3);
DEFINE_GUID(TID_D3DRMColorRGB, 0xd3e16e81, 0x7835, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMGuid, 0xa42790e0, 0x7810, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMTextureFilename, 0xa42790e1, 0x7810, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMTextureReference, 0xa42790e2, 0x7810, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMIndexedColor, 0x1630b820, 0x7842, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMMeshVertexColors, 0x1630b821, 0x7842, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMMaterialWrap, 0x4885ae60, 0x78e8, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMBoolean, 0x537da6a0, 0xca37, 0x11d0, 0x94, 0x1c, 0x0, 0x80, 0xc8, 0xc, 0xfa, 0x7b);
DEFINE_GUID(TID_D3DRMMeshFaceWraps, 0xed1ec5c0, 0xc0a8, 0x11d0, 0x94, 0x1c, 0x0, 0x80, 0xc8, 0xc, 0xfa, 0x7b);
DEFINE_GUID(TID_D3DRMBoolean2d, 0x4885ae63, 0x78e8, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMTimedFloatKeys, 0xf406b180, 0x7b3b, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMAnimationOptions, 0xe2bf56c0, 0x840f, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMFramePosition, 0xe2bf56c1, 0x840f, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMFrameVelocity, 0xe2bf56c2, 0x840f, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMFrameRotation, 0xe2bf56c3, 0x840f, 0x11cf, 0x8f, 0x52, 0x0, 0x40, 0x33, 0x35, 0x94, 0xa3);
DEFINE_GUID(TID_D3DRMLight, 0x3d82ab4a, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMCamera, 0x3d82ab51, 0x62da, 0x11cf, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMAppData, 0xe5745280, 0xb24f, 0x11cf, 0x9d, 0xd5, 0x0, 0xaa, 0x0, 0xa7, 0x1a, 0x2f);
DEFINE_GUID(TID_D3DRMLightUmbra, 0xaed22740, 0xb31f, 0x11cf, 0x9d, 0xd5, 0x0, 0xaa, 0x0, 0xa7, 0x1a, 0x2f);
DEFINE_GUID(TID_D3DRMLightRange, 0xaed22742, 0xb31f, 0x11cf, 0x9d, 0xd5, 0x0, 0xaa, 0x0, 0xa7, 0x1a, 0x2f);
DEFINE_GUID(TID_D3DRMLightPenumbra, 0xaed22741, 0xb31f, 0x11cf, 0x9d, 0xd5, 0x0, 0xaa, 0x0, 0xa7, 0x1a, 0x2f);
DEFINE_GUID(TID_D3DRMLightAttenuation, 0xa8a98ba0, 0xc5e5, 0x11cf, 0xb9, 0x41, 0x0, 0x80, 0xc8, 0xc, 0xfa, 0x7b);
DEFINE_GUID(TID_D3DRMInlineData, 0x3a23eea0, 0x94b1, 0x11d0, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMUrl, 0x3a23eea1, 0x94b1, 0x11d0, 0xab, 0x39, 0x0, 0x20, 0xaf, 0x71, 0xe4, 0x33);
DEFINE_GUID(TID_D3DRMProgressiveMesh, 0x8A63C360, 0x997D, 0x11d0, 0x94, 0x1C, 0x0, 0x80, 0xC8, 0x0C, 0xFA, 0x7B);
DEFINE_GUID(TID_D3DRMExternalVisual, 0x98116AA0, 0xBDBA, 0x11d1, 0x82, 0xC0, 0x00, 0xA0, 0xC9, 0x69, 0x72, 0x71);
DEFINE_GUID(TID_D3DRMStringProperty, 0x7f0f21e0, 0xbfe1, 0x11d1, 0x82, 0xc0, 0x0, 0xa0, 0xc9, 0x69, 0x72, 0x71);
DEFINE_GUID(TID_D3DRMPropertyBag, 0x7f0f21e1, 0xbfe1, 0x11d1, 0x82, 0xc0, 0x0, 0xa0, 0xc9, 0x69, 0x72, 0x71);
DEFINE_GUID(TID_D3DRMRightHanded, 0x7f5d5ea0, 0xd53a, 0x11d1, 0x82, 0xc0, 0x0, 0xa0, 0xc9, 0x69, 0x72, 0x71);

/* d3drm.h */
DEFINE_GUID(IID_IDirect3DRM, 0x2bc49361, 0x8327, 0x11cf, 0xac, 0x4a, 0x0, 0x0, 0xc0, 0x38, 0x25, 0xa1);
DEFINE_GUID(IID_IDirect3DRM2, 0x4516ecc8, 0x8f20, 0x11d0, 0x9b, 0x6d, 0x00, 0x00, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(IID_IDirect3DRM3, 0x4516ec83, 0x8f20, 0x11d0, 0x9b, 0x6d, 0x00, 0x00, 0xc0, 0x78, 0x1b, 0xc3);
DEFINE_GUID(CLSID_CDirect3DRM, 0x4516ec41, 0x8f20, 0x11d0, 0x9b, 0x6d, 0x00, 0x00, 0xc0, 0x78, 0x1b, 0xc3);

/* dvp.h */
DEFINE_GUID(IID_IDDVideoPortContainer, 0x6C142760, 0xA733, 0x11CE, 0xA5, 0x21, 0x00, 0x20, 0xAF, 0x0B, 0xE5, 0x60);
DEFINE_GUID(IID_IDirectDrawVideoPort, 0xB36D93E0, 0x2B43, 0x11CF, 0xA2, 0xDE, 0x00, 0xAA, 0x00, 0xB9, 0x33, 0x56);
DEFINE_GUID(DDVPTYPE_E_HREFH_VREFH, 0x54F39980L, 0xDA60, 0x11CF, 0x9B, 0x06, 0x00, 0xA0, 0xC9, 0x03, 0xA3, 0xB8);
DEFINE_GUID(DDVPTYPE_E_HREFH_VREFL, 0x92783220L, 0xDA60, 0x11CF, 0x9B, 0x06, 0x00, 0xA0, 0xC9, 0x03, 0xA3, 0xB8);
DEFINE_GUID(DDVPTYPE_E_HREFL_VREFH, 0xA07A02E0L, 0xDA60, 0x11CF, 0x9B, 0x06, 0x00, 0xA0, 0xC9, 0x03, 0xA3, 0xB8);
DEFINE_GUID(DDVPTYPE_E_HREFL_VREFL, 0xE09C77E0L, 0xDA60, 0x11CF, 0x9B, 0x06, 0x00, 0xA0, 0xC9, 0x03, 0xA3, 0xB8);
DEFINE_GUID(DDVPTYPE_CCIR656, 0xFCA326A0L, 0xDA60, 0x11CF, 0x9B, 0x06, 0x00, 0xA0, 0xC9, 0x03, 0xA3, 0xB8);
DEFINE_GUID(DDVPTYPE_BROOKTREE, 0x1352A560L, 0xDA61, 0x11CF, 0x9B, 0x06, 0x00, 0xA0, 0xC9, 0x03, 0xA3, 0xB8);
DEFINE_GUID(DDVPTYPE_PHILIPS, 0x332CF160L, 0xDA61, 0x11CF, 0x9B, 0x06, 0x00, 0xA0, 0xC9, 0x03, 0xA3, 0xB8);

/* dmusicc.h */
DEFINE_GUID(IID_IReferenceClock, 0x56a86897, 0x0ad4, 0x11ce, 0xb0, 0x3a, 0x00, 0x20, 0xaf, 0x0b, 0xa7, 0x70);
DEFINE_GUID(CLSID_DirectMusic, 0x636b9f10, 0x0c7d, 0x11d1, 0x95, 0xb2, 0x00, 0x20, 0xaf, 0xdc, 0x74, 0x21);
DEFINE_GUID(CLSID_DirectMusicCollection, 0x480ff4b0, 0x28b2, 0x11d1, 0xbe, 0xf7, 0x0, 0xc0, 0x4f, 0xbf, 0x8f, 0xef);
DEFINE_GUID(CLSID_DirectMusicSynth, 0x58C2B4D0, 0x46E7, 0x11D1, 0x89, 0xAC, 0x00, 0xA0, 0xC9, 0x05, 0x41, 0x29);
DEFINE_GUID(IID_IDirectMusic, 0xd2ac2876, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicBuffer, 0xd2ac2878, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicPort, 0x55e2edd8, 0xcd7c, 0x11d1, 0xa7, 0x6f, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(IID_IDirectMusicThru, 0xced153e7, 0x3606, 0x11d2, 0xb9, 0xf9, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);

DEFINE_GUID(IID_IDirectMusicPortDownload, 0xd2ac287a, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicDownload, 0xd2ac287b, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicCollection, 0xd2ac287c, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicInstrument, 0xd2ac287d, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicDownloadedInstrument, 0xd2ac287e, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);

DEFINE_GUID(IID_IDirectMusic2,0x6fc2cae1, 0xbc78, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);

DEFINE_GUID(GUID_DMUS_PROP_GM_Hardware, 0x178f2f24, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(GUID_DMUS_PROP_GS_Hardware, 0x178f2f25, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(GUID_DMUS_PROP_XG_Hardware, 0x178f2f26, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);

DEFINE_GUID(GUID_DMUS_PROP_XG_Capable,  0x6496aba1, 0x61b0, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(GUID_DMUS_PROP_GS_Capable,  0x6496aba2, 0x61b0, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);

DEFINE_GUID(GUID_DMUS_PROP_DLS1, 0x178f2f27, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(GUID_DMUS_PROP_DLS2,        0xf14599e5, 0x4689, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(GUID_DMUS_PROP_INSTRUMENT2, 0x865fd372, 0x9f67, 0x11d2, 0x87, 0x2a, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);

DEFINE_GUID(GUID_DMUS_PROP_SynthSink_DSOUND, 0xaa97844, 0xc877, 0x11d1, 0x87, 0xc, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_DMUS_PROP_SynthSink_WAVE, 0xaa97845, 0xc877, 0x11d1, 0x87, 0xc, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_DMUS_PROP_SampleMemorySize, 0x178f2f28, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(GUID_DMUS_PROP_SamplePlaybackRate, 0x2a91f713, 0xa4bf, 0x11d2, 0xbb, 0xdf, 0x0, 0x60, 0x8, 0x33, 0xdb, 0xd8);
DEFINE_GUID(GUID_DMUS_PROP_WriteLatency,0x268a0fa0, 0x60f2, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(GUID_DMUS_PROP_WritePeriod,0x268a0fa1, 0x60f2, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);

DEFINE_GUID(GUID_DMUS_PROP_MemorySize, 0x178f2f28, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(GUID_DMUS_PROP_WavesReverb,0x4cb5622, 0x32e5, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(GUID_DMUS_PROP_Effects, 0xcda8d611, 0x684a, 0x11d2, 0x87, 0x1e, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_DMUS_PROP_LegacyCaps,0xcfa7cdc2, 0x00a1, 0x11d2, 0xaa, 0xd5, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(GUID_DMUS_PROP_Volume, 0xfedfae25L, 0xe46e, 0x11d1, 0xaa, 0xce, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);

/* dmusici.h */
DEFINE_GUID(CLSID_DirectMusicPerformance, 0xd2ac2881, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSegment, 0xd2ac2882, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSegmentState, 0xd2ac2883, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicGraph, 0xd2ac2884, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicTempoTrack, 0xd2ac2885, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSeqTrack, 0xd2ac2886, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicCurveTrack, 0xc51f3861, 0xf9a6, 0x11d1, 0xbc, 0x95, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(CLSID_DirectMusicSysExTrack, 0xd2ac2887, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicTimeSigTrack, 0xd2ac2888, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicStyle, 0xd2ac288a, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicChordTrack, 0xd2ac288b, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicCommandTrack, 0xd2ac288c, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicStyleTrack, 0xd2ac288d, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicMotifTrack, 0xd2ac288e, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicChordMap,0xd2ac288f, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicComposer, 0xd2ac2890, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicSignPostTrack, 0xf17e8672, 0xc3b4, 0x11d1, 0x87, 0xb, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicLoader, 0xd2ac2892, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicBandTrack,0xd2ac2894, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicBand, 0x79ba9e00, 0xb6ee, 0x11d1, 0x86, 0xbe, 0x0, 0xc0, 0x4f, 0xbf, 0x8f, 0xef);
DEFINE_GUID(CLSID_DirectMusicChordMapTrack,0xd2ac2896, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(CLSID_DirectMusicMuteTrack, 0xd2ac2898, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_DirectMusicAllTypes, 0xd2ac2893, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_NOTIFICATION_SEGMENT, 0xd2ac2899, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_NOTIFICATION_PERFORMANCE,0x81f75bc5, 0x4e5d, 0x11d2, 0xbc, 0xc7, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_NOTIFICATION_MEASUREANDBEAT, 0xd2ac289a, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_NOTIFICATION_CHORD, 0xd2ac289b, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_NOTIFICATION_COMMAND, 0xd2ac289c, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_CommandParam,0xd2ac289d, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_CommandParam2, 0x28f97ef7, 0x9538, 0x11d2, 0x97, 0xa9, 0x0, 0xc0, 0x4f, 0xa3, 0x6e, 0x58);
DEFINE_GUID(GUID_ChordParam,0xd2ac289e, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_RhythmParam,0xd2ac289f, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_IDirectMusicStyle,0xd2ac28a1, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_TimeSignature,0xd2ac28a4, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_TempoParam,0xd2ac28a5, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_IDirectMusicBand,0xd2ac28ac, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_IDirectMusicChordMap,0xd2ac28ad, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_MuteParam,0xd2ac28af, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_Download,0xd2ac28a7, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_Unload,0xd2ac28a8, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_ConnectToDLSCollection, 0x1db1ae6b, 0xe92e, 0x11d1, 0xa8, 0xc5, 0x0, 0xc0, 0x4f, 0xa3, 0x72, 0x6e);
DEFINE_GUID(GUID_Enable_Auto_Download,0xd2ac28a9, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_Clear_All_Bands,0xd2ac28ab, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_StandardMIDIFile, 0x6621075, 0xe92e, 0x11d1, 0xa8, 0xc5, 0x0, 0xc0, 0x4f, 0xa3, 0x72, 0x6e);
DEFINE_GUID(GUID_DisableTimeSig, 0x45fc707b, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_EnableTimeSig, 0x45fc707c, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_DisableTempo, 0x45fc707d, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_EnableTempo, 0x45fc707e, 0x1db4, 0x11d2, 0xbc, 0xac, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_SeedVariations, 0x65b76fa5, 0xff37, 0x11d2, 0x81, 0x4e, 0x0, 0xc0, 0x4f, 0xa3, 0x6e, 0x58);
DEFINE_GUID(GUID_PerfMasterTempo,0xd2ac28b0, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_PerfMasterVolume,0xd2ac28b1, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_PerfMasterGrooveLevel,0xd2ac28b2, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(GUID_PerfAutoDownload, 0xfb09565b, 0x3631, 0x11d2, 0xbc, 0xb8, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(GUID_DefaultGMCollection, 0xf17e8673, 0xc3b4, 0x11d1, 0x87, 0xb, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicLoader, 0x2ffaaca2, 0x5dca, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(IID_IDirectMusicGetLoader,0x68a04844, 0xd13d, 0x11d1, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(IID_IDirectMusicObject,0xd2ac28b5, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicSegment, 0xf96029a2, 0x4282, 0x11d2, 0x87, 0x17, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicSegmentState, 0xa3afdcc7, 0xd3ee, 0x11d1, 0xbc, 0x8d, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(IID_IDirectMusicTrack, 0xf96029a1, 0x4282, 0x11d2, 0x87, 0x17, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicPerformance,0x7d43d03, 0x6523, 0x11d2, 0x87, 0x1d, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicTool,0xd2ac28ba, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicGraph,0x2befc277, 0x5497, 0x11d2, 0xbc, 0xcb, 0x0, 0xa0, 0xc9, 0x22, 0xe6, 0xeb);
DEFINE_GUID(IID_IDirectMusicStyle,0xd2ac28bd, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicChordMap,0xd2ac28be, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicComposer,0xd2ac28bf, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicBand,0xd2ac28c0, 0xb39b, 0x11d1, 0x87, 0x4, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);
DEFINE_GUID(IID_IDirectMusicPerformance2,0x6fc2cae0, 0xbc78, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(IID_IDirectMusicSegment2, 0xd38894d1, 0xc052, 0x11d2, 0x87, 0x2f, 0x0, 0x60, 0x8, 0x93, 0xb1, 0xbd);

/* d3d.h */
DEFINE_GUID(IID_IDirect3D, 0x3BBA0080, 0x2421, 0x11CF, 0xA3, 0x1A, 0x00, 0xAA, 0x00, 0xB9, 0x33, 0x56);
DEFINE_GUID(IID_IDirect3D2, 0x6aae1ec1, 0x662a, 0x11d0, 0x88, 0x9d, 0x00, 0xaa, 0x00, 0xbb, 0xb7, 0x6a);
DEFINE_GUID(IID_IDirect3D3, 0xbb223240, 0xe72b, 0x11d0, 0xa9, 0xb4, 0x00, 0xaa, 0x00, 0xc0, 0x99, 0x3e);
DEFINE_GUID( IID_IDirect3D7, 0xf5049e77,0x4861,0x11d2,0xa4,0x7,0x0,0xa0,0xc9,0x6,0x29,0xa8);
DEFINE_GUID(IID_IDirect3DRampDevice, 0xF2086B20, 0x259F, 0x11CF, 0xA3, 0x1A, 0x00, 0xAA, 0x00, 0xB9, 0x33, 0x56);
DEFINE_GUID(IID_IDirect3DRGBDevice, 0xA4665C60, 0x2673, 0x11CF, 0xA3, 0x1A, 0x00, 0xAA, 0x00, 0xB9, 0x33, 0x56);
DEFINE_GUID(IID_IDirect3DHALDevice, 0x84E63dE0, 0x46AA, 0x11CF, 0x81, 0x6F, 0x00, 0x00, 0xC0, 0x20, 0x15, 0x6E);
DEFINE_GUID(IID_IDirect3DMMXDevice, 0x881949a1, 0xd6f3, 0x11d0, 0x89, 0xab, 0x00, 0xa0, 0xc9, 0x05, 0x41, 0x29);
DEFINE_GUID(IID_IDirect3DRefDevice, 0x50936643, 0x13e9, 0x11d1, 0x89, 0xaa, 0x0, 0xa0, 0xc9, 0x5, 0x41, 0x29);
DEFINE_GUID(IID_IDirect3DNullDevice, 0x8767df22, 0xbacc, 0x11d1, 0x89, 0x69, 0x0, 0xa0, 0xc9, 0x6, 0x29, 0xa8);
DEFINE_GUID( IID_IDirect3DTnLHalDevice, 0xf5049e78, 0x4861, 0x11d2, 0xa4, 0x7, 0x0, 0xa0, 0xc9, 0x6, 0x29, 0xa8);
DEFINE_GUID(IID_IDirect3DDevice, 0x64108800, 0x957d, 0X11d0, 0x89, 0xab, 0x00, 0xa0, 0xc9, 0x05, 0x41, 0x29);
DEFINE_GUID(IID_IDirect3DDevice2, 0x93281501, 0x8cf8, 0x11d0, 0x89, 0xab, 0x0, 0xa0, 0xc9, 0x5, 0x41, 0x29);
DEFINE_GUID(IID_IDirect3DDevice3, 0xb0ab3b60, 0x33d7, 0x11d1, 0xa9, 0x81, 0x0, 0xc0, 0x4f, 0xd7, 0xb1, 0x74);
DEFINE_GUID( IID_IDirect3DDevice7,  0xf5049e79, 0x4861, 0x11d2, 0xa4, 0x7, 0x0, 0xa0, 0xc9, 0x6, 0x29, 0xa8);
DEFINE_GUID(IID_IDirect3DTexture2, 0x93281502, 0x8cf8, 0x11d0, 0x89, 0xab, 0x0, 0xa0, 0xc9, 0x5, 0x41, 0x29);
DEFINE_GUID(IID_IDirect3DLight, 0x4417C142, 0x33AD, 0x11CF, 0x81, 0x6F, 0x00, 0x00, 0xC0, 0x20, 0x15, 0x6E);
DEFINE_GUID(IID_IDirect3DMaterial, 0x4417C144, 0x33AD, 0x11CF, 0x81, 0x6F, 0x00, 0x00, 0xC0, 0x20, 0x15, 0x6E);
DEFINE_GUID(IID_IDirect3DMaterial2, 0x93281503, 0x8cf8, 0x11d0, 0x89, 0xab, 0x0, 0xa0, 0xc9, 0x5, 0x41, 0x29);
DEFINE_GUID(IID_IDirect3DMaterial3, 0xca9c46f4, 0xd3c5, 0x11d1, 0xb7, 0x5a, 0x0, 0x60, 0x8, 0x52, 0xb3, 0x12);
DEFINE_GUID(IID_IDirect3DExecuteBuffer, 0x4417C145, 0x33AD, 0x11CF, 0x81, 0x6F, 0x00, 0x00, 0xC0, 0x20, 0x15, 0x6E);
DEFINE_GUID(IID_IDirect3DViewport, 0x4417C146, 0x33AD, 0x11CF, 0x81, 0x6F, 0x00, 0x00, 0xC0, 0x20, 0x15, 0x6E);
DEFINE_GUID(IID_IDirect3DViewport2, 0x93281500, 0x8cf8, 0x11d0, 0x89, 0xab, 0x0, 0xa0, 0xc9, 0x5, 0x41, 0x29);
DEFINE_GUID(IID_IDirect3DViewport3, 0xb0ab3b61, 0x33d7, 0x11d1, 0xa9, 0x81, 0x0, 0xc0, 0x4f, 0xd7, 0xb1, 0x74);
DEFINE_GUID(IID_IDirect3DVertexBuffer, 0x7a503555, 0x4a83, 0x11d1, 0xa5, 0xdb, 0x0, 0xa0, 0xc9, 0x3, 0x67, 0xf8);
DEFINE_GUID( IID_IDirect3DVertexBuffer7, 0xf5049e7d, 0x4861, 0x11d2, 0xa4, 0x7, 0x0, 0xa0, 0xc9, 0x6, 0x29, 0xa8);

/* dsound.h */
DEFINE_GUID(CLSID_DirectSound, 0x47d4d946, 0x62e8, 0x11cf, 0x93, 0xbc, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0);
DEFINE_GUID(CLSID_DirectSoundCapture, 0xb0210780, 0x89cd, 0x11d0, 0xaf, 0x8, 0x0, 0xa0, 0xc9, 0x25, 0xcd, 0x16);
DEFINE_GUID(IID_IDirectSound, 0x279AFA83, 0x4981, 0x11CE, 0xA5, 0x21, 0x00, 0x20, 0xAF, 0x0B, 0xE5, 0x60);
DEFINE_GUID(IID_IDirectSoundBuffer, 0x279AFA85, 0x4981, 0x11CE, 0xA5, 0x21, 0x00, 0x20, 0xAF, 0x0B, 0xE5, 0x60);
DEFINE_GUID(IID_IDirectSound3DListener, 0x279AFA84, 0x4981, 0x11CE, 0xA5, 0x21, 0x00, 0x20, 0xAF, 0x0B, 0xE5, 0x60);
DEFINE_GUID(IID_IDirectSound3DBuffer, 0x279AFA86, 0x4981, 0x11CE, 0xA5, 0x21, 0x00, 0x20, 0xAF, 0x0B, 0xE5, 0x60);
DEFINE_GUID(IID_IDirectSoundCapture, 0xb0210781, 0x89cd, 0x11d0, 0xaf, 0x8, 0x0, 0xa0, 0xc9, 0x25, 0xcd, 0x16);
DEFINE_GUID(IID_IDirectSoundCaptureBuffer, 0xb0210782, 0x89cd, 0x11d0, 0xaf, 0x8, 0x0, 0xa0, 0xc9, 0x25, 0xcd, 0x16);
DEFINE_GUID(IID_IDirectSoundNotify, 0xb0210783, 0x89cd, 0x11d0, 0xaf, 0x8, 0x0, 0xa0, 0xc9, 0x25, 0xcd, 0x16);
DEFINE_GUID(IID_IKsPropertySet, 0x31efac30, 0x515c, 0x11d0, 0xa9, 0xaa, 0x00, 0xaa, 0x00, 0x61, 0xbe, 0x93);

DEFINE_GUID(DS3DALG_NO_VIRTUALIZATION, 0xc241333f, 0x1c1b, 0x11d2, 0x94, 0xf5, 0x0, 0xc0, 0x4f, 0xc2, 0x8a, 0xca);
DEFINE_GUID(DS3DALG_HRTF_FULL, 0xc2413340, 0x1c1b, 0x11d2, 0x94, 0xf5, 0x0, 0xc0, 0x4f, 0xc2, 0x8a, 0xca);
DEFINE_GUID(DS3DALG_HRTF_LIGHT, 0xc2413342, 0x1c1b, 0x11d2, 0x94, 0xf5, 0x0, 0xc0, 0x4f, 0xc2, 0x8a, 0xca);

/* ddraw.h */
DEFINE_GUID( CLSID_DirectDraw,			0xD7B70EE0,0x4340,0x11CF,0xB0,0x63,0x00,0x20,0xAF,0xC2,0xCD,0x35 );
DEFINE_GUID( CLSID_DirectDraw7,                 0x3c305196,0x50db,0x11d3,0x9c,0xfe,0x00,0xc0,0x4f,0xd9,0x30,0xc5 );
DEFINE_GUID( CLSID_DirectDrawClipper,           0x593817A0,0x7DB3,0x11CF,0xA2,0xDE,0x00,0xAA,0x00,0xb9,0x33,0x56 );
DEFINE_GUID( IID_IDirectDraw,			0x6C14DB80,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
DEFINE_GUID( IID_IDirectDraw2,                  0xB3A6F3E0,0x2B43,0x11CF,0xA2,0xDE,0x00,0xAA,0x00,0xB9,0x33,0x56 );
DEFINE_GUID( IID_IDirectDraw4, 			0x9c59509a,0x39bd,0x11d1,0x8c,0x4a,0x00,0xc0,0x4f,0xd9,0x30,0xc5 );
DEFINE_GUID( IID_IDirectDraw7,                  0x15e65ec0,0x3b9c,0x11d2,0xb9,0x2f,0x00,0x60,0x97,0x97,0xea,0x5b );
DEFINE_GUID( IID_IDirectDrawSurface,		0x6C14DB81,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
DEFINE_GUID( IID_IDirectDrawSurface2,		0x57805885,0x6eec,0x11cf,0x94,0x41,0xa8,0x23,0x03,0xc1,0x0e,0x27 );
DEFINE_GUID( IID_IDirectDrawSurface3,           0xDA044E00,0x69B2,0x11D0,0xA1,0xD5,0x00,0xAA,0x00,0xB8,0xDF,0xBB );
DEFINE_GUID(IID_IDirectDrawSurface4, 		0x0B2B8630,0xAD35,0x11D0,0x8E,0xA6,0x00,0x60,0x97,0x97,0xEA,0x5B );
DEFINE_GUID( IID_IDirectDrawSurface7,           0x06675a80,0x3b9b,0x11d2,0xb9,0x2f,0x00,0x60,0x97,0x97,0xea,0x5b );

DEFINE_GUID( IID_IDirectDrawPalette,		0x6C14DB84,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
DEFINE_GUID( IID_IDirectDrawClipper,		0x6C14DB85,0xA733,0x11CE,0xA5,0x21,0x00,0x20,0xAF,0x0B,0xE5,0x60 );
DEFINE_GUID( IID_IDirectDrawColorControl, 	0x4B9F0EE0,0x0D7E,0x11D0,0x9B,0x06,0x00,0xA0,0xC9,0x03,0xA3,0xB8 );
DEFINE_GUID(IID_IDirectDrawGammaControl, 	0x69C11C3E,0xB46B,0x11D1,0xAD,0x7A,0x00,0xC0,0x4F,0xC2,0x9B,0x4E );

/* dls2.h */

DEFINE_GUID(DLSID_GMInHardware, 0x178f2f24, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(DLSID_GSInHardware, 0x178f2f25, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(DLSID_XGInHardware, 0x178f2f26, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(DLSID_SupportsDLS1, 0x178f2f27, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(DLSID_SupportsDLS2, 0xf14599e5, 0x4689, 0x11d2, 0xaf, 0xa6, 0x0, 0xaa, 0x0, 0x24, 0xd8, 0xb6);
DEFINE_GUID(DLSID_SampleMemorySize, 0x178f2f28, 0xc364, 0x11d1, 0xa7, 0x60, 0x00, 0x00, 0xf8, 0x75, 0xac, 0x12);
DEFINE_GUID(DLSID_ManufacturersID, 0xb03e1181, 0x8095, 0x11d2, 0xa1, 0xef, 0x0, 0x60, 0x8, 0x33, 0xdb, 0xd8);
DEFINE_GUID(DLSID_ProductID, 0xb03e1182, 0x8095, 0x11d2, 0xa1, 0xef, 0x0, 0x60, 0x8, 0x33, 0xdb, 0xd8);
DEFINE_GUID(DLSID_SamplePlaybackRate, 0x2a91f713, 0xa4bf, 0x11d2, 0xbb, 0xdf, 0x0, 0x60, 0x8, 0x33, 0xdb, 0xd8);


/* dinputd.h */

DEFINE_GUID(IID_IDirectInputEffectDriver,   0x02538130,0x898F,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(IID_IDirectInputJoyConfig,      0x1DE12AB1,0xC9F5,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInputPIDDriver,      0xEEC6993A,0xB3FD,0x11D2,0xA9,0x16,0x00,0xC0,0x4F,0xB9,0x86,0x38);

DEFINE_GUID(GUID_KeyboardClass, 0x4D36E96B,0xE325,0x11CE,0xBF,0xC1,0x08,0x00,0x2B,0xE1,0x03,0x18);
DEFINE_GUID(GUID_MediaClass,    0x4D36E96C,0xE325,0x11CE,0xBF,0xC1,0x08,0x00,0x2B,0xE1,0x03,0x18);
DEFINE_GUID(GUID_MouseClass,    0x4D36E96F,0xE325,0x11CE,0xBF,0xC1,0x08,0x00,0x2B,0xE1,0x03,0x18);
DEFINE_GUID(GUID_HIDClass,      0x745A17A0,0x74D3,0x11D0,0xB6,0xFE,0x00,0xA0,0xC9,0x0F,0x57,0xDA);

/* dinput.h */
DEFINE_GUID(CLSID_DirectInput,       0x25E609E0,0xB259,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(CLSID_DirectInputDevice, 0x25E609E1,0xB259,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(CLSID_DirectInput8,      0x25E609E4,0xB259,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(CLSID_DirectInputDevice8,0x25E609E5,0xB259,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);

DEFINE_GUID(IID_IDirectInputA,     0x89521360,0xAA8A,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInputW,     0x89521361,0xAA8A,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInput2A,    0x5944E662,0xAA8A,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInput2W,    0x5944E663,0xAA8A,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInput7A,    0x9A4CB684,0x236D,0x11D3,0x8E,0x9D,0x00,0xC0,0x4F,0x68,0x44,0xAE);
DEFINE_GUID(IID_IDirectInput7W,    0x9A4CB685,0x236D,0x11D3,0x8E,0x9D,0x00,0xC0,0x4F,0x68,0x44,0xAE);
DEFINE_GUID(IID_IDirectInput8A,    0xBF798030,0x483A,0x4DA2,0xAA,0x99,0x5D,0x64,0xED,0x36,0x97,0x00);
DEFINE_GUID(IID_IDirectInput8W,    0xBF798031,0x483A,0x4DA2,0xAA,0x99,0x5D,0x64,0xED,0x36,0x97,0x00);
DEFINE_GUID(IID_IDirectInputDeviceA, 0x5944E680,0xC92E,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInputDeviceW, 0x5944E681,0xC92E,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInputDevice2A,0x5944E682,0xC92E,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInputDevice2W,0x5944E683,0xC92E,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(IID_IDirectInputDevice7A,0x57D7C6BC,0x2356,0x11D3,0x8E,0x9D,0x00,0xC0,0x4F,0x68,0x44,0xAE);
DEFINE_GUID(IID_IDirectInputDevice7W,0x57D7C6BD,0x2356,0x11D3,0x8E,0x9D,0x00,0xC0,0x4F,0x68,0x44,0xAE);
DEFINE_GUID(IID_IDirectInputDevice8A,0x54D41080,0xDC15,0x4833,0xA4,0x1B,0x74,0x8F,0x73,0xA3,0x81,0x79);
DEFINE_GUID(IID_IDirectInputDevice8W,0x54D41081,0xDC15,0x4833,0xA4,0x1B,0x74,0x8F,0x73,0xA3,0x81,0x79);
DEFINE_GUID(IID_IDirectInputEffect,  0xE7E1F7C0,0x88D2,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);


DEFINE_GUID(GUID_XAxis,   0xA36D02E0,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_YAxis,   0xA36D02E1,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_ZAxis,   0xA36D02E2,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_RxAxis,  0xA36D02F4,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_RyAxis,  0xA36D02F5,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_RzAxis,  0xA36D02E3,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_Slider,  0xA36D02E4,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);


DEFINE_GUID(GUID_Button,  0xA36D02F0,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_Key,     0x55728220,0xD33C,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);

DEFINE_GUID(GUID_POV,     0xA36D02F2,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);

DEFINE_GUID(GUID_Unknown, 0xA36D02F3,0xC9F3,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);

DEFINE_GUID(GUID_SysMouse,   0x6F1D2B60,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_SysKeyboard,0x6F1D2B61,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_Joystick   ,0x6F1D2B70,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_SysMouseEm, 0x6F1D2B80,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_SysMouseEm2,0x6F1D2B81,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_SysKeyboardEm, 0x6F1D2B82,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);
DEFINE_GUID(GUID_SysKeyboardEm2,0x6F1D2B83,0xD5A0,0x11CF,0xBF,0xC7,0x44,0x45,0x53,0x54,0x00,0x00);

DEFINE_GUID(GUID_ConstantForce,0x13541C20,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_RampForce,    0x13541C21,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_Square,       0x13541C22,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_Sine,         0x13541C23,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_Triangle,     0x13541C24,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_SawtoothUp,   0x13541C25,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_SawtoothDown, 0x13541C26,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_Spring,       0x13541C27,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_Damper,       0x13541C28,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_Inertia,      0x13541C29,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_Friction,     0x13541C2A,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);
DEFINE_GUID(GUID_CustomForce,  0x13541C2B,0x8E33,0x11D0,0x9A,0xD0,0x00,0xA0,0xC9,0xA0,0x6E,0x35);

/*
// GF: Weg, weil sonst Fehler bei GCC
DIOBJECTDATAFORMAT rgodf_c_dfDIKeyboard[] = {
{&GUID_Key, 0, -2147483636, 0},
{&GUID_Key, 1, -2147483380, 0},
{&GUID_Key, 2, -2147483124, 0},
{&GUID_Key, 3, -2147482868, 0},
{&GUID_Key, 4, -2147482612, 0},
{&GUID_Key, 5, -2147482356, 0},
{&GUID_Key, 6, -2147482100, 0},
{&GUID_Key, 7, -2147481844, 0},
{&GUID_Key, 8, -2147481588, 0},
{&GUID_Key, 9, -2147481332, 0},
{&GUID_Key, 10, -2147481076, 0},
{&GUID_Key, 11, -2147480820, 0},
{&GUID_Key, 12, -2147480564, 0},
{&GUID_Key, 13, -2147480308, 0},
{&GUID_Key, 14, -2147480052, 0},
{&GUID_Key, 15, -2147479796, 0},
{&GUID_Key, 16, -2147479540, 0},
{&GUID_Key, 17, -2147479284, 0},
{&GUID_Key, 18, -2147479028, 0},
{&GUID_Key, 19, -2147478772, 0},
{&GUID_Key, 20, -2147478516, 0},
{&GUID_Key, 21, -2147478260, 0},
{&GUID_Key, 22, -2147478004, 0},
{&GUID_Key, 23, -2147477748, 0},
{&GUID_Key, 24, -2147477492, 0},
{&GUID_Key, 25, -2147477236, 0},
{&GUID_Key, 26, -2147476980, 0},
{&GUID_Key, 27, -2147476724, 0},
{&GUID_Key, 28, -2147476468, 0},
{&GUID_Key, 29, -2147476212, 0},
{&GUID_Key, 30, -2147475956, 0},
{&GUID_Key, 31, -2147475700, 0},
{&GUID_Key, 32, -2147475444, 0},
{&GUID_Key, 33, -2147475188, 0},
{&GUID_Key, 34, -2147474932, 0},
{&GUID_Key, 35, -2147474676, 0},
{&GUID_Key, 36, -2147474420, 0},
{&GUID_Key, 37, -2147474164, 0},
{&GUID_Key, 38, -2147473908, 0},
{&GUID_Key, 39, -2147473652, 0},
{&GUID_Key, 40, -2147473396, 0},
{&GUID_Key, 41, -2147473140, 0},
{&GUID_Key, 42, -2147472884, 0},
{&GUID_Key, 43, -2147472628, 0},
{&GUID_Key, 44, -2147472372, 0},
{&GUID_Key, 45, -2147472116, 0},
{&GUID_Key, 46, -2147471860, 0},
{&GUID_Key, 47, -2147471604, 0},
{&GUID_Key, 48, -2147471348, 0},
{&GUID_Key, 49, -2147471092, 0},
{&GUID_Key, 50, -2147470836, 0},
{&GUID_Key, 51, -2147470580, 0},
{&GUID_Key, 52, -2147470324, 0},
{&GUID_Key, 53, -2147470068, 0},
{&GUID_Key, 54, -2147469812, 0},
{&GUID_Key, 55, -2147469556, 0},
{&GUID_Key, 56, -2147469300, 0},
{&GUID_Key, 57, -2147469044, 0},
{&GUID_Key, 58, -2147468788, 0},
{&GUID_Key, 59, -2147468532, 0},
{&GUID_Key, 60, -2147468276, 0},
{&GUID_Key, 61, -2147468020, 0},
{&GUID_Key, 62, -2147467764, 0},
{&GUID_Key, 63, -2147467508, 0},
{&GUID_Key, 64, -2147467252, 0},
{&GUID_Key, 65, -2147466996, 0},
{&GUID_Key, 66, -2147466740, 0},
{&GUID_Key, 67, -2147466484, 0},
{&GUID_Key, 68, -2147466228, 0},
{&GUID_Key, 69, -2147465972, 0},
{&GUID_Key, 70, -2147465716, 0},
{&GUID_Key, 71, -2147465460, 0},
{&GUID_Key, 72, -2147465204, 0},
{&GUID_Key, 73, -2147464948, 0},
{&GUID_Key, 74, -2147464692, 0},
{&GUID_Key, 75, -2147464436, 0},
{&GUID_Key, 76, -2147464180, 0},
{&GUID_Key, 77, -2147463924, 0},
{&GUID_Key, 78, -2147463668, 0},
{&GUID_Key, 79, -2147463412, 0},
{&GUID_Key, 80, -2147463156, 0},
{&GUID_Key, 81, -2147462900, 0},
{&GUID_Key, 82, -2147462644, 0},
{&GUID_Key, 83, -2147462388, 0},
{&GUID_Key, 84, -2147462132, 0},
{&GUID_Key, 85, -2147461876, 0},
{&GUID_Key, 86, -2147461620, 0},
{&GUID_Key, 87, -2147461364, 0},
{&GUID_Key, 88, -2147461108, 0},
{&GUID_Key, 89, -2147460852, 0},
{&GUID_Key, 90, -2147460596, 0},
{&GUID_Key, 91, -2147460340, 0},
{&GUID_Key, 92, -2147460084, 0},
{&GUID_Key, 93, -2147459828, 0},
{&GUID_Key, 94, -2147459572, 0},
{&GUID_Key, 95, -2147459316, 0},
{&GUID_Key, 96, -2147459060, 0},
{&GUID_Key, 97, -2147458804, 0},
{&GUID_Key, 98, -2147458548, 0},
{&GUID_Key, 99, -2147458292, 0},
{&GUID_Key, 100, -2147458036, 0},
{&GUID_Key, 101, -2147457780, 0},
{&GUID_Key, 102, -2147457524, 0},
{&GUID_Key, 103, -2147457268, 0},
{&GUID_Key, 104, -2147457012, 0},
{&GUID_Key, 105, -2147456756, 0},
{&GUID_Key, 106, -2147456500, 0},
{&GUID_Key, 107, -2147456244, 0},
{&GUID_Key, 108, -2147455988, 0},
{&GUID_Key, 109, -2147455732, 0},
{&GUID_Key, 110, -2147455476, 0},
{&GUID_Key, 111, -2147455220, 0},
{&GUID_Key, 112, -2147454964, 0},
{&GUID_Key, 113, -2147454708, 0},
{&GUID_Key, 114, -2147454452, 0},
{&GUID_Key, 115, -2147454196, 0},
{&GUID_Key, 116, -2147453940, 0},
{&GUID_Key, 117, -2147453684, 0},
{&GUID_Key, 118, -2147453428, 0},
{&GUID_Key, 119, -2147453172, 0},
{&GUID_Key, 120, -2147452916, 0},
{&GUID_Key, 121, -2147452660, 0},
{&GUID_Key, 122, -2147452404, 0},
{&GUID_Key, 123, -2147452148, 0},
{&GUID_Key, 124, -2147451892, 0},
{&GUID_Key, 125, -2147451636, 0},
{&GUID_Key, 126, -2147451380, 0},
{&GUID_Key, 127, -2147451124, 0},
{&GUID_Key, 128, -2147450868, 0},
{&GUID_Key, 129, -2147450612, 0},
{&GUID_Key, 130, -2147450356, 0},
{&GUID_Key, 131, -2147450100, 0},
{&GUID_Key, 132, -2147449844, 0},
{&GUID_Key, 133, -2147449588, 0},
{&GUID_Key, 134, -2147449332, 0},
{&GUID_Key, 135, -2147449076, 0},
{&GUID_Key, 136, -2147448820, 0},
{&GUID_Key, 137, -2147448564, 0},
{&GUID_Key, 138, -2147448308, 0},
{&GUID_Key, 139, -2147448052, 0},
{&GUID_Key, 140, -2147447796, 0},
{&GUID_Key, 141, -2147447540, 0},
{&GUID_Key, 142, -2147447284, 0},
{&GUID_Key, 143, -2147447028, 0},
{&GUID_Key, 144, -2147446772, 0},
{&GUID_Key, 145, -2147446516, 0},
{&GUID_Key, 146, -2147446260, 0},
{&GUID_Key, 147, -2147446004, 0},
{&GUID_Key, 148, -2147445748, 0},
{&GUID_Key, 149, -2147445492, 0},
{&GUID_Key, 150, -2147445236, 0},
{&GUID_Key, 151, -2147444980, 0},
{&GUID_Key, 152, -2147444724, 0},
{&GUID_Key, 153, -2147444468, 0},
{&GUID_Key, 154, -2147444212, 0},
{&GUID_Key, 155, -2147443956, 0},
{&GUID_Key, 156, -2147443700, 0},
{&GUID_Key, 157, -2147443444, 0},
{&GUID_Key, 158, -2147443188, 0},
{&GUID_Key, 159, -2147442932, 0},
{&GUID_Key, 160, -2147442676, 0},
{&GUID_Key, 161, -2147442420, 0},
{&GUID_Key, 162, -2147442164, 0},
{&GUID_Key, 163, -2147441908, 0},
{&GUID_Key, 164, -2147441652, 0},
{&GUID_Key, 165, -2147441396, 0},
{&GUID_Key, 166, -2147441140, 0},
{&GUID_Key, 167, -2147440884, 0},
{&GUID_Key, 168, -2147440628, 0},
{&GUID_Key, 169, -2147440372, 0},
{&GUID_Key, 170, -2147440116, 0},
{&GUID_Key, 171, -2147439860, 0},
{&GUID_Key, 172, -2147439604, 0},
{&GUID_Key, 173, -2147439348, 0},
{&GUID_Key, 174, -2147439092, 0},
{&GUID_Key, 175, -2147438836, 0},
{&GUID_Key, 176, -2147438580, 0},
{&GUID_Key, 177, -2147438324, 0},
{&GUID_Key, 178, -2147438068, 0},
{&GUID_Key, 179, -2147437812, 0},
{&GUID_Key, 180, -2147437556, 0},
{&GUID_Key, 181, -2147437300, 0},
{&GUID_Key, 182, -2147437044, 0},
{&GUID_Key, 183, -2147436788, 0},
{&GUID_Key, 184, -2147436532, 0},
{&GUID_Key, 185, -2147436276, 0},
{&GUID_Key, 186, -2147436020, 0},
{&GUID_Key, 187, -2147435764, 0},
{&GUID_Key, 188, -2147435508, 0},
{&GUID_Key, 189, -2147435252, 0},
{&GUID_Key, 190, -2147434996, 0},
{&GUID_Key, 191, -2147434740, 0},
{&GUID_Key, 192, -2147434484, 0},
{&GUID_Key, 193, -2147434228, 0},
{&GUID_Key, 194, -2147433972, 0},
{&GUID_Key, 195, -2147433716, 0},
{&GUID_Key, 196, -2147433460, 0},
{&GUID_Key, 197, -2147433204, 0},
{&GUID_Key, 198, -2147432948, 0},
{&GUID_Key, 199, -2147432692, 0},
{&GUID_Key, 200, -2147432436, 0},
{&GUID_Key, 201, -2147432180, 0},
{&GUID_Key, 202, -2147431924, 0},
{&GUID_Key, 203, -2147431668, 0},
{&GUID_Key, 204, -2147431412, 0},
{&GUID_Key, 205, -2147431156, 0},
{&GUID_Key, 206, -2147430900, 0},
{&GUID_Key, 207, -2147430644, 0},
{&GUID_Key, 208, -2147430388, 0},
{&GUID_Key, 209, -2147430132, 0},
{&GUID_Key, 210, -2147429876, 0},
{&GUID_Key, 211, -2147429620, 0},
{&GUID_Key, 212, -2147429364, 0},
{&GUID_Key, 213, -2147429108, 0},
{&GUID_Key, 214, -2147428852, 0},
{&GUID_Key, 215, -2147428596, 0},
{&GUID_Key, 216, -2147428340, 0},
{&GUID_Key, 217, -2147428084, 0},
{&GUID_Key, 218, -2147427828, 0},
{&GUID_Key, 219, -2147427572, 0},
{&GUID_Key, 220, -2147427316, 0},
{&GUID_Key, 221, -2147427060, 0},
{&GUID_Key, 222, -2147426804, 0},
{&GUID_Key, 223, -2147426548, 0},
{&GUID_Key, 224, -2147426292, 0},
{&GUID_Key, 225, -2147426036, 0},
{&GUID_Key, 226, -2147425780, 0},
{&GUID_Key, 227, -2147425524, 0},
{&GUID_Key, 228, -2147425268, 0},
{&GUID_Key, 229, -2147425012, 0},
{&GUID_Key, 230, -2147424756, 0},
{&GUID_Key, 231, -2147424500, 0},
{&GUID_Key, 232, -2147424244, 0},
{&GUID_Key, 233, -2147423988, 0},
{&GUID_Key, 234, -2147423732, 0},
{&GUID_Key, 235, -2147423476, 0},
{&GUID_Key, 236, -2147423220, 0},
{&GUID_Key, 237, -2147422964, 0},
{&GUID_Key, 238, -2147422708, 0},
{&GUID_Key, 239, -2147422452, 0},
{&GUID_Key, 240, -2147422196, 0},
{&GUID_Key, 241, -2147421940, 0},
{&GUID_Key, 242, -2147421684, 0},
{&GUID_Key, 243, -2147421428, 0},
{&GUID_Key, 244, -2147421172, 0},
{&GUID_Key, 245, -2147420916, 0},
{&GUID_Key, 246, -2147420660, 0},
{&GUID_Key, 247, -2147420404, 0},
{&GUID_Key, 248, -2147420148, 0},
{&GUID_Key, 249, -2147419892, 0},
{&GUID_Key, 250, -2147419636, 0},
{&GUID_Key, 251, -2147419380, 0},
{&GUID_Key, 252, -2147419124, 0},
{&GUID_Key, 253, -2147418868, 0},
{&GUID_Key, 254, -2147418612, 0},
{&GUID_Key, 255, -2147418356, 0}
};


DIDATAFORMAT c_dfDIKeyboard = {24,
16,
2,
256,
256,
rgodf_c_dfDIKeyboard};

DIOBJECTDATAFORMAT rgodf_c_dfDIMouse[] = {
{&GUID_XAxis, 0, 16776963, 0},
{&GUID_YAxis, 4, 16776963, 0},
{&GUID_ZAxis, 8, -2130706685, 0},
{0, 12, 16776972, 0},
{0, 13, 16776972, 0},
{0, 14, -2130706676, 0},
{0, 15, -2130706676, 0}};
DIDATAFORMAT c_dfDIMouse = {24,
16,
2,
16,
7,
rgodf_c_dfDIMouse};

DIOBJECTDATAFORMAT rgodf_c_dfDIMouse2[] = {
{&GUID_XAxis, 0, 16776963, 0},
{&GUID_YAxis, 4, 16776963, 0},
{&GUID_ZAxis, 8, -2130706685, 0},
{0, 12, 16776972, 0},
{0, 13, 16776972, 0},
{0, 14, -2130706676, 0},
{0, 15, -2130706676, 0},
{0, 16, -2130706676, 0},
{0, 17, -2130706676, 0},
{0, 18, -2130706676,0},
{0, 19, -2130706676, 0}};
DIDATAFORMAT c_dfDIMouse2 = {24,
16,
2,
20,
11,
rgodf_c_dfDIMouse2};

DIOBJECTDATAFORMAT rgodf_c_dfDIJoystick[] = {
{&GUID_XAxis, 0, -2130706685, 256},
{&GUID_YAxis, 4, -2130706685, 256},
{&GUID_ZAxis, 8, -2130706685, 256},
{&GUID_RxAxis, 12, -2130706685, 256},
{&GUID_RyAxis, 16, -2130706685, 256},
{&GUID_RzAxis, 20, -2130706685, 256},
{&GUID_Slider, 24, -2130706685, 256},
{&GUID_Slider, 28, -2130706685, 256},
{&GUID_POV, 32, -2130706672, 0},
{&GUID_POV, 36, -2130706672, 0},
{&GUID_POV, 40, -2130706672, 0},
{&GUID_POV, 44, -2130706672, 0},
{0, 48, -2130706676, 0},
{0, 49, -2130706676, 0},
{0, 50, -2130706676, 0},
{0, 51, -2130706676, 0},
{0, 52, -2130706676, 0},
{0, 53, -2130706676, 0},
{0, 54, -2130706676, 0},
{0, 55, -2130706676, 0},
{0, 56, -2130706676, 0},
{0, 57, -2130706676, 0},
{0, 58, -2130706676, 0},
{0, 59, -2130706676, 0},
{0, 60, -2130706676, 0},
{0, 61, -2130706676, 0},
{0, 62, -2130706676, 0},
{0, 63, -2130706676, 0},
{0, 64, -2130706676, 0},
{0, 65, -2130706676, 0},
{0, 66, -2130706676, 0},
{0, 67, -2130706676, 0},
{0, 68, -2130706676, 0},
{0, 69, -2130706676, 0},
{0, 70, -2130706676, 0},
{0, 71, -2130706676, 0},
{0, 72, -2130706676, 0},
{0, 73, -2130706676, 0},
{0, 74, -2130706676, 0},
{0, 75, -2130706676, 0},
{0, 76, -2130706676, 0},
{0, 77, -2130706676, 0},
{0, 78, -2130706676, 0},
{0, 79, -2130706676, 0}};
DIDATAFORMAT c_dfDIJoystick = {24,
16,
1,
80,
44,
rgodf_c_dfDIJoystick};

DIOBJECTDATAFORMAT rgodf_c_dfDIJoystick2[] = {
{&GUID_XAxis, 0, -2130706685, 256},
{&GUID_YAxis, 4, -2130706685, 256},
{&GUID_ZAxis, 8, -2130706685, 256},
{&GUID_RxAxis, 12, -2130706685, 256},
{&GUID_RyAxis, 16, -2130706685, 256},
{&GUID_RzAxis, 20, -2130706685, 256},
{&GUID_Slider, 24, -2130706685, 256},
{&GUID_Slider, 28, -2130706685, 256},
{&GUID_POV, 32, -2130706672, 0},
{&GUID_POV, 36, -2130706672, 0},
{&GUID_POV, 40, -2130706672, 0},
{&GUID_POV, 44, -2130706672, 0},
{0, 48, -2130706676, 0},
{0, 49, -2130706676, 0},
{0, 50, -2130706676, 0},
{0, 51, -2130706676, 0},
{0, 52, -2130706676, 0},
{0, 53, -2130706676, 0},
{0, 54, -2130706676, 0},
{0, 55, -2130706676, 0},
{0, 56, -2130706676, 0},
{0, 57, -2130706676, 0},
{0, 58, -2130706676, 0},
{0, 59, -2130706676, 0},
{0, 60, -2130706676, 0},
{0, 61, -2130706676, 0},
{0, 62, -2130706676, 0},
{0, 63, -2130706676, 0},
{0, 64, -2130706676, 0},
{0, 65, -2130706676, 0},
{0, 66, -2130706676, 0},
{0, 67, -2130706676, 0},
{0, 68, -2130706676, 0},
{0, 69, -2130706676, 0},
{0, 70, -2130706676, 0},
{0, 71, -2130706676, 0},
{0, 72, -2130706676, 0},
{0, 73, -2130706676, 0},
{0, 74, -2130706676, 0},
{0, 75, -2130706676, 0},
{0, 76, -2130706676, 0},
{0, 77, -2130706676, 0},
{0, 78, -2130706676, 0},
{0, 79, -2130706676, 0},
{0, 80, -2130706676, 0},
{0, 81, -2130706676, 0},
{0, 82, -2130706676, 0},
{0, 83, -2130706676, 0},
{0, 84, -2130706676, 0},
{0, 85, -2130706676, 0},
{0, 86, -2130706676, 0},
{0, 87, -2130706676, 0},
{0, 88, -2130706676, 0},
{0, 89, -2130706676, 0},
{0, 90, -2130706676, 0},
{0, 91, -2130706676, 0},
{0, 92, -2130706676, 0},
{0, 93, -2130706676, 0},
{0, 94, -2130706676, 0},
{0, 95, -2130706676, 0},
{0, 96, -2130706676, 0},
{0, 97, -2130706676, 0},
{0, 98, -2130706676, 0},
{0, 99, -2130706676, 0},
{0, 100, -2130706676, 0},
{0, 101, -2130706676, 0},
{0, 102, -2130706676, 0},
{0, 103, -2130706676, 0},
{0, 104, -2130706676, 0},
{0, 105, -2130706676, 0},
{0, 106, -2130706676, 0},
{0, 107, -2130706676, 0},
{0, 108, -2130706676, 0},
{0, 109, -2130706676, 0},
{0, 110, -2130706676, 0},
{0, 111, -2130706676, 0},
{0, 112, -2130706676, 0},
{0, 113, -2130706676, 0},
{0, 114, -2130706676, 0},
{0, 115, -2130706676, 0},
{0, 116, -2130706676, 0},
{0, 117, -2130706676, 0},
{0, 118, -2130706676, 0},
{0, 119, -2130706676, 0},
{0, 120, -2130706676, 0},
{0, 121, -2130706676, 0},
{0, 122, -2130706676, 0},
{0, 123, -2130706676, 0},
{0, 124, -2130706676, 0},
{0, 125, -2130706676, 0},
{0, 126, -2130706676, 0},
{0, 127, -2130706676, 0},
{0, 128, -2130706676, 0},
{0, 129, -2130706676, 0},
{0, 130, -2130706676, 0},
{0, 131, -2130706676, 0},
{0, 132, -2130706676, 0},
{0, 133, -2130706676, 0},
{0, 134, -2130706676, 0},
{0, 135, -2130706676, 0},
{0, 136, -2130706676, 0},
{0, 137, -2130706676, 0},
{0, 138, -2130706676, 0},
{0, 139, -2130706676, 0},
{0, 140, -2130706676, 0},
{0, 141, -2130706676, 0},
{0, 142, -2130706676, 0},
{0, 143, -2130706676, 0},
{0, 144, -2130706676, 0},
{0, 145, -2130706676, 0},
{0, 146, -2130706676, 0},
{0, 147, -2130706676, 0},
{0, 148, -2130706676, 0},
{0, 149, -2130706676, 0},
{0, 150, -2130706676, 0},
{0, 151, -2130706676, 0},
{0, 152, -2130706676, 0},
{0, 153, -2130706676, 0},
{0, 154, -2130706676, 0},
{0, 155, -2130706676, 0},
{0, 156, -2130706676, 0},
{0, 157, -2130706676, 0},
{0, 158, -2130706676, 0},
{0, 159, -2130706676, 0},
{0, 160, -2130706676, 0},
{0, 161, -2130706676, 0},
{0, 162, -2130706676, 0},
{0, 163, -2130706676, 0},
{0, 164, -2130706676, 0},
{0, 165, -2130706676, 0},
{0, 166, -2130706676, 0},
{0, 167, -2130706676, 0},
{0, 168, -2130706676, 0},
{0, 169, -2130706676, 0},
{0, 170, -2130706676, 0},
{0, 171, -2130706676, 0},
{0, 172, -2130706676, 0},
{0, 173, -2130706676, 0},
{0, 174, -2130706676, 0},
{0, 175, -2130706676, 0},
{&GUID_XAxis, 176, -2130706685, 512},
{&GUID_YAxis, 180, -2130706685, 512},
{&GUID_ZAxis, 184, -2130706685, 512},
{&GUID_RxAxis, 188, -2130706685, 512},
{&GUID_RyAxis, 192, -2130706685, 512},
{&GUID_RzAxis, 196, -2130706685, 512},
{&GUID_Slider, 24, -2130706685, 512},
{&GUID_Slider, 28, -2130706685, 512},
{&GUID_XAxis, 208, -2130706685, 768},
{&GUID_YAxis, 212, -2130706685, 768},
{&GUID_ZAxis, 216, -2130706685, 768},
{&GUID_RxAxis, 220, -2130706685, 768},
{&GUID_RyAxis, 224, -2130706685, 768},
{&GUID_RzAxis, 228, -2130706685, 768},
{&GUID_Slider, 24, -2130706685, 768},
{&GUID_Slider, 28, -2130706685, 768},
{&GUID_XAxis, 240, -2130706685, 1024},
{&GUID_YAxis, 244, -2130706685, 1024},
{&GUID_ZAxis, 248, -2130706685, 1024},
{&GUID_RxAxis, 252, -2130706685, 1024},
{&GUID_RyAxis, 256, -2130706685, 1024},
{&GUID_RzAxis, 260, -2130706685, 1024},
{&GUID_Slider, 24, -2130706685, 1024},
{&GUID_Slider, 28, -2130706685, 1024}};
DIDATAFORMAT c_dfDIJoystick2 = {24,
16,
1,
272,
164,
rgodf_c_dfDIJoystick2};
*/

#else // non-Windows
int dxguid_dummy; // suppress warnings

#endif // WANT_SDL

// --- DXInput.cpp

#include "stdafx.h" // #include "stdafx.h"


#if !defined(GLB_CONSOLE)

const int MIN_QUERY_COUNT = 100;

#include "gfqueue.h" // #include "gfqueue.h"

#if !defined(WANT_SDL) && defined(WIN32)
#include <mmsystem.h> // NT-Joystick
#pragma comment(lib, "dinput8.lib")
#pragma comment(lib, "winmm.lib")
#endif
#include "dxinput.h" // #include "dxinput.h"

#if defined(GP2X) || defined(GPHWIZ)
#include <sys/mman.h>
#include <fcntl.h>
#endif

#if defined(GP2X) || defined(GPHWIZ)
#include <sys/time.h>
#endif

#if defined(CAANOO)
extern "C" void caanoo_sensor_poll(int* ax, int* ay, int* az);
extern "C" void caanoo_sensor_deinit(void);
extern "C" void caanoo_sensor_init();
#endif

#if defined(EMSCRIPTEN)
// function glb_get_multitouch_info(imouse, int_ptr)
extern "C" void glb_init_multitouch();
extern "C" int  glb_get_multitouch_info(int imouse, int* p_X_Y_Button);
extern "C" int  glb_get_gravity(float* pXYZ); // return 1/0 if gravity is available. FF26 returns 1 - bug
#endif


#if defined(TARGET_OS_IPHONE)
extern "C"
{
void iPhoneGetAcceleration(float* x, float* y, float* z);
int  iPhoneGetMaxMice();
void iPhoneGetMouseData(int iMouse, int* x, int* y, int* button);
int iPhoneIsICadeAttached();
unsigned int iPhoneGetICadeInfo();
}
#endif


#include "gffilesystem.h" // #include "gffilesystem.h"


//////////////////////////////////////////////////////////////////////////////////
// EnumJoystick
//////////////////////////////////////////////////////////////////////////////////

#if !defined(WANT_SDL) && defined(WIN32) && !defined(POCKETPC)
struct GF_JoyEnum
{
int				CurDev;
#if DIRECTINPUT_VERSION > 0x0700
LPDIRECTINPUT8A	pDI;
LPDIRECTINPUTDEVICE8A	lpDIDJoystick[DXIN_MAX_JOYSTICKS];
#else
LPDIRECTINPUT	pDI;
LPDIRECTINPUTDEVICE		lpDIDJoystick[DXIN_MAX_JOYSTICKS];
#endif
TCHAR			Names[DXIN_MAX_JOYSTICKS][MAX_PATH*2+2];
HWND			hWnd;
};


BOOL CALLBACK g_EnumJoystick(LPCDIDEVICEINSTANCE pdinst, LPVOID pvRef)
{
HRESULT		hr = DI_OK;
GF_JoyEnum* pJoy = (GF_JoyEnum*)pvRef;

if (pJoy->CurDev>=DXIN_MAX_JOYSTICKS) return DIENUM_STOP;
if(pJoy->pDI->CreateDevice(pdinst->guidInstance, &pJoy->lpDIDJoystick[pJoy->CurDev], NULL) != DI_OK)
return DIENUM_CONTINUE;

if (pJoy->lpDIDJoystick[pJoy->CurDev]==NULL) return DIENUM_CONTINUE;
pJoy->lpDIDJoystick[pJoy->CurDev]->SetDataFormat(&c_dfDIJoystick);
pJoy->lpDIDJoystick[pJoy->CurDev]->SetCooperativeLevel(pJoy->hWnd, DISCL_EXCLUSIVE | DISCL_FOREGROUND);

// Set the X-axis range (-1000 to +1000)
DIPROPRANGE diprg;
diprg.diph.dwSize = sizeof(diprg);
diprg.diph.dwHeaderSize = sizeof(diprg.diph);
diprg.diph.dwObj = DIJOFS_X;
diprg.diph.dwHow = DIPH_BYOFFSET;
diprg.lMin = -32768;
diprg.lMax = +32768; // 1000

pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_RANGE, &diprg.diph);
diprg.diph.dwObj = DIJOFS_Y;
pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_RANGE, &diprg.diph);
diprg.diph.dwObj = DIJOFS_Z;
pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_RANGE, &diprg.diph);
diprg.diph.dwObj = DIJOFS_RX;
pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_RANGE, &diprg.diph);
diprg.diph.dwObj = DIJOFS_RY;
pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_RANGE, &diprg.diph);
diprg.diph.dwObj = DIJOFS_RZ;
pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_RANGE, &diprg.diph);

// Set X axis dead zone to 10%
DIPROPDWORD dipdw;
dipdw.diph.dwSize = sizeof(dipdw);
dipdw.diph.dwHeaderSize = sizeof(dipdw.diph);
dipdw.diph.dwObj = DIJOFS_X;
dipdw.diph.dwHow = DIPH_BYOFFSET;
dipdw.dwData = 0; //1000

if(pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_DEADZONE, &dipdw.diph) != DI_OK)
return DIENUM_CONTINUE;

// Set Y axis dead zone to 10%
dipdw.diph.dwObj = DIJOFS_Y;
if(pJoy->lpDIDJoystick[pJoy->CurDev]->SetProperty(DIPROP_DEADZONE, &dipdw.diph) != DI_OK)
return DIENUM_CONTINUE;
hr = pJoy->lpDIDJoystick[pJoy->CurDev]->Acquire();

strcpy(pJoy->Names[pJoy->CurDev], pdinst->tszInstanceName);
strcat(pJoy->Names[pJoy->CurDev], ", ");
strcat(pJoy->Names[pJoy->CurDev], pdinst->tszProductName);

pJoy->CurDev++;
return DIENUM_CONTINUE;
}
#endif // !WANT_SDL


//---------------------------------------------------------------//
// --- constructor ---
//---------------------------------------------------------------//
DXInput::DXInput()
{
m_QueryCount = 0;
m_iCurMouse=0;
m_MousePos.SetAllocSteps(1,4);
m_MousePos.SetSize(1);

m_SystemPointer=false;
NumJoysticks=0;

#if defined(EMSCRIPTEN)
glb_init_multitouch();

#elif defined(GP2X) || defined(GPHWIZ)
device=-1;
dev_touchscreen = -1;
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
#elif defined(WANT_SDL)
m_AccelerationNativeLandscape = false;
// SDL-port
memset(m_pJoys, 0, sizeof(SDL_Joystick*) * DXIN_MAX_JOYSTICKS);

#else // Win32
m_HWND=NULL;
g_lpDID			=NULL;
lpDInput		=NULL;
lpDIDKeyboard	=NULL;
lpDIDMouse		=NULL;
for(int i=0; i<DXIN_MAX_JOYSTICKS; i++)
lpDIDJoystick[i]=NULL;
#endif
}

//---------------------------------------------------------------//
// --- destructor --
//---------------------------------------------------------------//
DXInput::~DXInput()
{
SystemPointer(true);
#if defined(GP2X) || defined(GPHWIZ) // GP2X
if(device>=0) close(device);
#if defined(GP2X)
if(dev_touchscreen>=0) close(dev_touchscreen);
#endif
device=-1;
dev_touchscreen=-1;
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
#elif defined(WANT_SDL) // SDL

#ifdef CAANOO
caanoo_sensor_deinit();
#endif


for (long i=0; i<min(DXIN_MAX_JOYSTICKS, SDL_NumJoysticks()); i++)
{
#if SDL_VERSION_ATLEAST(2,0,0)
if(m_pJoys[i])
{
SDL_JoystickClose(m_pJoys[i]);
m_pJoys[i] = NULL;
}
#else
if(SDL_JoystickOpened(i) && m_pJoys[i])
SDL_JoystickClose(m_pJoys[i]);
#endif
}
#else // Win32
if (lpDIDMouse)
{
lpDIDMouse->Unacquire();
lpDIDMouse->Release();
}
if(lpDIDKeyboard)
{
lpDIDKeyboard->Unacquire();		// kein zugriff aufs keyboard
lpDIDKeyboard->Release();		// keyboard object lschen
}
for (int i=0; i<DXIN_MAX_JOYSTICKS; i++)
if (lpDIDJoystick[i])
{
lpDIDJoystick[i]->Unacquire();
lpDIDJoystick[i]->Release();
}
if (lpDInput)	lpDInput->Release();
#endif
}



#if defined(GP2X)
/*
* The F-200 uses tslib data for it's touchscreen (although no modules).
* I've ripped the basic (linear) code directly into here.
*/

// Set default a touchscreen calibration
static int ts_cal[7] = {6203, 0, -1501397, 0, -4200, 16132680, 65536};
// WIZ: -155 -21777 21672896 16368 -36 -563220 655366


static void read_calibration()
{
struct stat sbuf;
int pcal_fd;
char pcalbuf[200];
int index;
char *tokptr;
char *calfile = "/etc/pointercal";

if (stat(calfile,&sbuf) == 0) {
pcal_fd = open(calfile,O_RDONLY);
read(pcal_fd,pcalbuf, 200);
ts_cal[0] = atoi(strtok(pcalbuf," "));
index = 1;
while (index < 7) {
tokptr = strtok(NULL," ");
if (*tokptr != '\0') {
ts_cal[index] = atoi(tokptr);
index++;
}
}
close(pcal_fd);
};
}
#endif


//---------------------------------------------------------------//
// --- create DXInput objects ---
//---------------------------------------------------------------//
#ifndef WIN32
unsigned long DXInput::CreateDInput(HWND hWnd, HINSTANCE hInstance, bool WantMouse)
#else
HRESULT DXInput::CreateDInput(HWND hWnd, HINSTANCE hInstance, bool WantMouse)
#endif
{
m_iCurMouse=0;

// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ)
NumJoysticks = 1;
device = open("/dev/GPIO", O_RDWR | O_NDELAY );
if (device < 0)
{
printf("GPIO device not present");
}
keystate=0;

#ifdef GP2X
#define DEV_TOUCHSCREEN	"/dev/touchscreen/wm97xx"
dev_touchscreen=open( DEV_TOUCHSCREEN, O_RDONLY | O_NOCTTY); // | O_NDELAY
if(dev_touchscreen<0)
{
printf("touchscreen device not present\n");
}
else
{
read_calibration();
}
#else
m_SystemPointer=false;
SDL_ShowCursor(false);
dev_touchscreen = 1;
#endif
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
NumJoysticks = 2; // 0: acceleration, 1: iCade
return 0;
// -------- SDL --------
#elif defined(WANT_SDL)

// SDL_Init(SDL_INIT_JOYSTICK); - global call now
#if !defined(EMSCRIPTEN)
#if SDL_MAJOR_VERSION>1 || SDL_MINOR_VERSION >= 3
SDL_StartTextInput();
#else
SDL_EnableUNICODE(1);
#endif
#endif

#if defined(PANDORA)
/* http://blogs.distant-earth.com/wp/?p=293
On the OpenPandora we need to work around an SDL assumption that 
returns relative mouse coordinates when you get to the screen 
edges using the touchscreen and a custom surface for the cursor. 
The workaround is to set a blank SDL cursor and NOT disable it 
(Hackish I know).

The root issues lies in the Windows Manager GRAB code in SDL. 
That is why the issue is not seen on framebuffer devices like the 
GP2X (there is no X window manager  ). 
*/ 
SDL_ShowCursor(SDL_ENABLE); 
uint8_t hiddenCursorData = 0; 
SDL_Cursor *hiddenCursor = SDL_CreateCursor(&hiddenCursorData, &hiddenCursorData, 8, 1, 0, 0); 
SDL_SetCursor(hiddenCursor);
#endif


this->DXtoVK(false);
m_SystemPointer=false;

#if !defined( PALM_WEBOS) && !defined(PANDORA)
SDL_ShowCursor(false);
#endif

NumJoysticks = min(DXIN_MAX_JOYSTICKS, SDL_NumJoysticks());
for (long i=0; i<NumJoysticks; i++)
{
m_pJoys[i]=SDL_JoystickOpen(i);
}

#ifdef CAANOO
g_debug("caanoo sensor init\n");
caanoo_sensor_init();
g_debug("caanoo sensor initalized\n");
NumJoysticks = 2; // 0: dpad, 1: acceleration
#endif

return 0;

// -------- WIN32 --------
#else
HRESULT		ret;
HRESULT		hr;

ret=(HRESULT)DINPUT_OK;
/*
#define DIRECTINPUT_VERSION_7 0x700
hr = DirectInputCreateEx(hInstance, DIRECTINPUT_VERSION_7, IID_IDirectInput7, (void **)&lpDInput, NULL);
*/
// hr=DirectInput8Create(hInstance, 0x0800/*DIRECTINPUT_VERSION*/, &lpDInput, NULL);
#if DIRECTINPUT_VERSION > 0x0700
hr = DirectInput8Create(hInstance, DIRECTINPUT_VERSION, IID_IDirectInput8A, (void**)&lpDInput, NULL);
#else
#define DIRECTINPUT_VERSION_7 0x0700
hr = DirectInputCreate(hInstance, DIRECTINPUT_VERSION_7, &lpDInput, NULL);
#endif

if(FAILED(hr))
{
g_debug("No DX_Input\n");
ret=CANT_CREATE_DINPUT;
}

m_HWND=hWnd;

// Get cursor pos and save use it in the future
POINT pt;
::GetCursorPos(&pt);
::ScreenToClient(hWnd, &pt);
MousePos& mps = GetCurMousePos();
mps.m_MouseX=pt.x; mps.m_MouseY=pt.y;
mps.m_VirtualX=pt.x; mps.m_VirtualY=pt.y;
memset(m_KeyBuffer, 0, sizeof(m_KeyBuffer));

// --- keyboard ---
if (ret==(HRESULT)DINPUT_OK)
{
hr=lpDInput->CreateDevice(GUID_SysKeyboard, &lpDIDKeyboard, NULL);
if (SUCCEEDED(hr))
{
lpDIDKeyboard->SetDataFormat(&c_dfDIKeyboard);
hr = lpDIDKeyboard->SetCooperativeLevel(hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND); // DISCL_EXCLUSIVE | <- No Alt-TAB/Alt-Print
if(SUCCEEDED(hr))	// Prg. mu im Vordergrund laufen
{
hr=lpDIDKeyboard->Acquire();
if(FAILED(hr))
{
g_debug("can't aquire keyboard - first try\n");
}
/*
if(FAILED(hr))
{
g_debug("No DX_KB\n");
ret=NO_ACCESS_ON_KEYBOARD;
}
*/
} // NT Cannot Create DX Keyboard
}
this->DXtoVK(lpDIDKeyboard!=NULL ? true : false);

// --- mouse ---
m_SystemPointer=false;
if(WantMouse)
{
hr=lpDInput->CreateDevice(GUID_SysMouse, &lpDIDMouse,NULL);
if (SUCCEEDED(hr))
{
lpDIDMouse->SetDataFormat(&c_dfDIMouse);
#ifdef _DEBUG
m_MouseCooLevel = DISCL_NONEXCLUSIVE | DISCL_FOREGROUND; // DISCL_EXCLUSIVE|;
#else
m_MouseCooLevel = DISCL_EXCLUSIVE|DISCL_FOREGROUND;
#endif
if(SUCCEEDED(lpDIDMouse->SetCooperativeLevel(hWnd, m_MouseCooLevel)))
{
hr=lpDIDMouse->Acquire();
if(FAILED(hr))
{
g_debug("can't aquire mouse - first try\n");
}
}
if(FAILED(hr))
{
g_debug("No DX_Mouse\n");
ret=NO_ACCESS_ON_MOUSE;
}
}
}
else
SystemPointer(true);
// --- joystick ---
GF_JoyEnum	joy;
memset(&joy, 0, sizeof(joy));
joy.hWnd=hWnd;
joy.pDI=lpDInput;
// #define DI8DEVCLASS_GAMECTRL        4
hr = lpDInput->EnumDevices(	4 ,
g_EnumJoystick,
(LPDIRECTINPUT) &joy,
(long unsigned int)DIEDFL_ATTACHEDONLY);
if(SUCCEEDED(hr))
{
NumJoysticks=joy.CurDev;
for (int i=0; i<NumJoysticks; i++)
{
lpDIDJoystick[i]=joy.lpDIDJoystick[i];
strcpy(JoyNames[i], joy.Names[i]);
}
}
}
else // NT-Patch
{
NumJoysticks=joyGetNumDevs();
lpDIDJoystick[0]=lpDIDJoystick[1]=NULL;
JOYCAPS	jc;
for (int i=0; i<NumJoysticks; i++)
{
joyGetDevCaps(i, &jc, sizeof(jc));
strcpy(JoyNames[i], jc.szPname);
}
this->DXtoVK(false);
}
return ret;
#endif

}

//---------------------------------------------------------------//
//---------------------------------------------------------------//
void DXInput::GetJoyName(char* pName, int num)
{
if (num<0 || num>=NumJoysticks)
{
pName[0]=0;

#ifdef ANDROID
if(num == NumJoysticks)
{
strcpy(pName, "Gamepad"); // Android gamepad using KEY() - spacefractal
}
#endif
}
else
{
// -------- GP2X --------
#if defined(GP2X)
strcpy(pName, "GP2X");
#elif defined(GPHWIZ)
strcpy(pName, "WIZ");

#elif defined(CAANOO)
if(num==1)
strcpy(pName, "Accelerometer");
else
strcpy(pName, "CAANOO");

// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE) || defined(PALM_WEBOS) || defined(EMSCRIPTEN)
// -------- SDL --------
switch(num)
{
case 0:
strcpy(pName, "Accelerometer");
break;
case 1:
strcpy(pName, "iCade");
break;
default:
pName[0]='\0';
}
#elif defined(WANT_SDL)
#if SDL_VERSION_ATLEAST(2,0,0)
strcpy(pName, SDL_JoystickName(m_pJoys[num]));
#else
strcpy(pName, SDL_JoystickName(num));
#endif
// -------- WIN32 --------
#else
strcpy(pName, JoyNames[num]);
#endif
} // endif
}


//---------------------------------------------------------------//
//---------------------------------------------------------------//
int DXInput::GetNumJoysticks() // Get Numer of Found Devices
{
#if defined(EMSCRIPTEN)
NumJoysticks = 1; // tilt GF_TODO icade
#endif

// iCade "joystick" gets attached once you pressed a valid button
#ifdef TARGET_OS_IPHONE
if(NumJoysticks == 1 && iPhoneIsICadeAttached())
NumJoysticks = 2;
#endif

#ifdef ANDROID
return 1+NumJoysticks; // last = Android Joypad
#endif

return NumJoysticks;
}

//---------------------------------------------------------------//
// --- get keyboard status ---
//---------------------------------------------------------------//
void DXInput::GetKeyboardStatus(bool bForcePolling)
{
if(bForcePolling ||++m_QueryCount > MIN_QUERY_COUNT)
m_QueryCount = 0;
else
return;

// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ)
keystate = 0;
if (read(device, &keystate, 4) != 4)
{
printf("GPIO READ ERROR\n");
}
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
// -------- SDL --------
#elif defined(WANT_SDL)
SDL_PumpEvents();

// -------- WIN32 --------
#else
HRESULT		hr=0;

if(::GetActiveWindow() != m_HWND) return;
memset(&m_KeyBuffer, 0, sizeof(m_KeyBuffer) );
if (lpDIDKeyboard)
{
//Keyboardbuffer lschen (beep)
if(GetInputState())
{
// avoid some "beeeeep" when you have too much input
// This will make inkey$ broken!!
// MSG msg; while(PeekMessage(&msg, m_HWND,WM_KEYFIRST,WM_KEYLAST,PM_REMOVE)) {}
}

hr=lpDIDKeyboard->Acquire();
if FAILED(hr)
{
lpDIDKeyboard->SetDataFormat(&c_dfDIKeyboard);				// BYTE
lpDIDKeyboard->SetCooperativeLevel(m_HWND,	// Prg. mu im Vordergrund
DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);		// laufen!!
// DISCL_EXCLUSIVE | <- No Alt-TAB/Alt-Print
lpDIDKeyboard->Acquire();
}
lpDIDKeyboard->GetDeviceState(sizeof(m_KeyBuffer), m_KeyBuffer);
}
else
::GetKeyboardState(m_KeyBuffer);
#endif
}


//---------------------------------------------------------------//
//---------------------------------------------------------------//
bool DXInput::AnyKey()
{
if (GetKeyChar()!='\0')
return true;
return false;
}


//---------------------------------------------------------------//
//---------------------------------------------------------------//
bool DXInput::AnyMouse()
{
DIMOUSEDATA	md;
RefreshMouseXY();
this->GetMouseData(&md, false);
return (md.mButton1 || md.mButton2 || md.mButton3) ? 1:0;
}


#if defined(GP2X)
typedef struct {
long secs;
long usecs;
} TIMEVAL;

typedef struct {
unsigned short pressure;
unsigned short x;
unsigned short y;
unsigned short pad;
TIMEVAL  stamp;
} TS_EVENT;

inline int ReadTSData(int dev_touchscreen, TS_EVENT* ts_event)
{
int rv = read(dev_touchscreen, ts_event, sizeof(TS_EVENT));
// always returns "8" ?
// #need returens fales all the time!?
if(rv >= sizeof(short)*3) return sizeof(TS_EVENT); else return 0;

return rv>0 ? sizeof(TS_EVENT) : 0;
}
#endif

#if defined(GPHWIZ)
typedef struct {
unsigned short pressure;
unsigned short x;
unsigned short y;
unsigned short pad;

/*		TIMEVAL  stamp;
*/
} TS_EVENT;

// use SDL instead of tslib
inline int ReadTSData(int dev, TS_EVENT* ts_event)
{
SDL_PumpEvents();
int	px, py, btn;
btn = SDL_GetMouseState(&px, &py);
ts_event->pressure = (btn & SDL_BUTTON(1)) ? 40000 : 0;

ts_event->x = px;
ts_event->y = py;
}
#endif



#if defined(ANDROID)
extern "C" int  android_get_mousecount();
extern "C" void android_get_mouse(int id, int* mx, int* my, int* b1);
#endif
#if defined(WIN32)
extern "C" void win32_get_touches(int id, int* mx, int* my, int* b1);
#endif


//---------------------------------------------------------------//
// return multi-mouse count
//---------------------------------------------------------------//
int DXInput::GetNumMice()
{
int num = 1;
#if defined(EMSCRIPTEN)
return 10;

// -------- GP2X --------
#elif defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)

// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
num= iPhoneGetMaxMice();

#elif defined(PALM_WEBOS)
num= 5;

#elif defined(ANDROID)
num= android_get_mousecount();

// -------- SDL --------
#elif defined(WANT_SDL)
// -------- WIN32 --------
#elif defined(WIN32)
static int bIsWindows8orLater =-1;

if(bIsWindows8orLater == -1)
{
OSVERSIONINFO osvi;
ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
GetVersionEx(&osvi);

g_debug("Win: %d, %d\n", (int)osvi.dwMajorVersion, (int)osvi.dwMinorVersion );

bIsWindows8orLater = 
( (osvi.dwMajorVersion > 6) ||
( (osvi.dwMajorVersion == 6) && (osvi.dwMinorVersion >= 2) ));
}
if(bIsWindows8orLater)
num = 32;
#endif

return num;
}


//---------------------------------------------------------------//
// select one of the multiple mice (iPhone only, so far)
//---------------------------------------------------------------//
void DXInput::SetActiveMouse(int i)
{
int num_mc = GetNumMice();
m_iCurMouse = min(i, num_mc-1);

if( m_iCurMouse >= (int)m_MousePos.Size())
m_MousePos.SetSize( num_mc );
}


//---------------------------------------------------------------//
// --- get mousedata ---
// touch position for current mouse. false if not touched(clicked)
// pX, pY -> in last touch position. out new touch pos.
// RV = 1|2|4:  buttons 1,2,3 pressed
//      0:      no touch -> pX,pY is untouched
//     -1:      error
//---------------------------------------------------------------//
int DXInput::GetTouchPos(int* pX, int* pY, int* pWheel)
{
*pWheel = 0;

#if defined(EMSCRIPTEN)
int st[4] = {0,0,0,0}; // x,y,mb1
int count = glb_get_multitouch_info(m_iCurMouse, &st[0]);
if(count <= m_iCurMouse)
return 0;
*pX = st[0];
*pY = st[1];
*pWheel = 0;
return st[2];



// -------- GP2X (F200) --------
#elif defined(GP2X) || defined(GPHWIZ)
struct HISTORY
{
long x,y;
};
struct LASTSTATE
{
int x,y,b;
};

#ifdef GP2X
#define MINPRESSURE 35000 // soft touch on GP2X causes terrible jitter
#define MAX_HISTORY	7 // number of points in history before you start shifting them

#define MAX_ERROR	3 // number of big-step reads to see it's true
#define MAX_JITTER 16 // big step jitter value
#define MIN_HISTORY 3 // minimum number of reads to get a safe x/y position
#else
/* +/- 1 pixel, quite good
#define MINPRESSURE 0 // WIZ just returns 1 or 0
#define MAX_HISTORY	15 // number of points in history before you start shifting them
#define MAX_ERROR	 4
#define MAX_JITTER  16
#define MIN_HISTORY 12
*/

#define MINPRESSURE 0 // WIZ just returns 1 or 0
#define MAX_HISTORY	15 // number of points in history before you start shifting them
#define MAX_ERROR	 8
#define MAX_JITTER  16
#define MIN_HISTORY 12

#endif
#if MIN_HISTORY >= MAX_HISTORY
#error Incorrect history size in __FILE__ __LINE__
#endif

static HISTORY hist[MAX_HISTORY+1], errhist[MAX_HISTORY+1];
static int num_hist=0;
TS_EVENT ts_event;

// only poll every 30th of a second
static LASTSTATE sLastState = {0,0,0};
static unsigned int sNextTime = 0;

// GETTIMERALL()
timeval now;
gettimeofday(&now, NULL);
unsigned int thistime = (now.tv_sec)*1000+(now.tv_usec/1000);

if(thistime < sNextTime)
{
*pX = sLastState.x; *pY=sLastState.y;
return sLastState.b;
}
sNextTime = thistime+6;

if(dev_touchscreen>=0)
{
int errors = 0;
repeat_reading:
int nread = ReadTSData(dev_touchscreen, &ts_event);

if(nread < sizeof(TS_EVENT) )
{
return 0;
}

int bPressed = 0;
if(ts_event.pressure>MINPRESSURE)
{
bPressed=1;
int dx, dy;

#ifdef GP2X
dx = (ts_event.x * ts_cal[0] + ts_cal[2]) >> 16;
dy = (ts_event.y * ts_cal[4] + ts_cal[5]) >> 16;
#else
// what tslib does:
/*
int xtemp = ts_event.x; int ytemp = ts_event.y;
dx = 	( ts_cal[2] + ts_cal[0]*xtemp + ts_cal[1]*ytemp ) / ts_cal[6];
dy =	( ts_cal[5] + ts_cal[3]*xtemp + ts_cal[4]*ytemp ) / ts_cal[6];
*/
dx = ts_event.x;
dy = ts_event.y;
#endif
if (dx<0 || dx>319 || dy<0 || dy>239) // bad read
{
*pX = sLastState.x; *pY=sLastState.y;
return sLastState.b;
}

// put current read in history
hist[num_hist].x = dx;
hist[num_hist].y = dy;
++num_hist;

// slow movement
if(abs(dx-sLastState.x)<MAX_JITTER && abs(dy-sLastState.y)<MAX_JITTER)
{
stable_move:
// has more than one value, interpolate for stable results
if(num_hist > MIN_HISTORY) // best to have some values at least
{
// shift all histroy one back. (cyclic buffer would be faster)
if(num_hist>MAX_HISTORY-1)
{
for(int i=0; i<MAX_HISTORY-1; ++i)
{
hist[i]=hist[i+1];
}
num_hist = MAX_HISTORY-1;
}

int factor;
int accux=0, accuy=0, scaler=0;

// senquack, SDL, GP2X
//  1->2->3->4->5->6->7->8->7->6->5->4->3->2->1

int emphasis[]={8,7,6,5,4,3,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

for(int i=0; i<num_hist; ++i)
{
factor=emphasis[num_hist - i -1];
accux+=(factor * hist[i].x);
accuy+=(factor * hist[i].y);
scaler+=factor;
}
// interpolate new dx,dy from history
dx = ((accux<<8)/scaler)>>8;
dy = ((accuy<<8)/scaler)>>8;
}
else
{
goto repeat_reading;
}
}
else
{
// big jitter
errhist[errors].x = dx;
errhist[errors].y = dy;
++errors;

if(errors>MAX_ERROR) // too many errors -> must be real.
{
for(int i=0; i<errors; ++i)
{
hist[i] = errhist[i];
}
num_hist=errors;

// take these errors as valid input
}
else
{
goto repeat_reading;
}
}

// ok, use that as position
*pX = dx;
*pY = dy;
sLastState.x=dx;
sLastState.y=dy;
}
else // not pressed
{
num_hist=0; // pen released
bPressed = 0;
}

sLastState.b=bPressed;
return bPressed;
}

return 0; // uh oh - no touchscreen device


// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
int button=0;
iPhoneGetMouseData(m_iCurMouse, pX, pY, &button);
return button ? 1:0;

// -------- Android --------
#elif defined(ANDROID)
int button=0;
android_get_mouse(m_iCurMouse, pX, pY, &button);
return button ? 1:0;


// -------- SDL --------
#elif defined(WANT_SDL)
SDL_PumpEvents();
Uint8 buttons;

// Android: SDL 1.3 w/o multitouch :/
#if defined (ANDROID) // #NEED multitouch?
#define SDL_GetRelativeMouseState(i,x,y)	SDL_GetRelativeMouseState(x,y)
#define SDL_GetMouseState(i,x,y)			SDL_GetMouseState(x,y)
#endif

// Absolute Movement - touches or systempointer!
if(1) // IsSystemPointer() )
{
#if defined(PALM_WEBOS)
buttons = SDL_GetMultiMouseState(m_iCurMouse, pX, pY); // mouse index -> Mutimouse support
#else
#if 0 // SDL_MAJOR_VERSION>1 || SDL_MINOR_VERSION >= 3
buttons = SDL_GetMouseState(m_iCurMouse, pX, pY);
#else
buttons = SDL_GetMouseState(pX, pY);
#endif
#endif
}
else // Relative movement - no systempointer (when pointer goes out of window, you have to move a long way to get it back to 0)
{
int	ix=0, iy=0;
#if defined(PALM_WEBOS)
buttons = SDL_GetRelativeMultiMouseState(m_iCurMouse, &ix, &iy); // mouse index -> Mutimouse support
#else
#if 0 // SDL_MAJOR_VERSION>1 || SDL_MINOR_VERSION >= 3
// SDL_GetNumMice(void);
// SDL_SelectMouse(int index); index==-1 -> Query current
buttons = SDL_GetRelativeMouseState(m_iCurMouse, &ix, &iy); // mouse index -> Mutimouse support
#else
buttons = SDL_GetRelativeMouseState(&ix, &iy);
#endif
#endif
*pX +=ix;
*pY +=iy;
}

// The trick is the wheel-up event is reported as button 4 and the wheel-down event is reported as mouse button 5.
/*
/etc/X11/XF86Config-4:
Section "InputDevice"
Identifier      "Configured Mouse"
Driver          "mouse"
Option          "Device"                "/dev/psaux"
Option          "Protocol"              "PS/2"
Option          "ZAxisMapping"          "4 5"  # ADD THIS LINE!!!
EndSection
*/
if (buttons & SDL_BUTTON(4)) *pWheel = 1;
else if (buttons & SDL_BUTTON(5)) *pWheel = -1;

// Buttons
int retv = 0;
if (buttons & SDL_BUTTON(1)) retv|=1; // Left
if (buttons & SDL_BUTTON(3)) retv|=2; // Right
if (buttons & SDL_BUTTON(2)) retv|=4; // Middle
return retv;

// -------- WIN32 --------
#else

if(GetNumMice() > 1 && IsSystemPointer()) // Win8 WM_POINTER API
{
int button=0;
win32_get_touches(m_iCurMouse, pX, pY, &button);
return button;
}
else
{
int rv = 0;
POINT p;
if (lpDIDMouse)
{
HRESULT			hr;
DIMOUSESTATE	Mouse;
hr=lpDIDMouse->GetDeviceState(sizeof(DIMOUSESTATE), &Mouse);
if(FAILED(hr))
{
hr = lpDIDMouse->Acquire();
if(FAILED(hr))
{
hr = lpDIDMouse->SetDataFormat(&c_dfDIMouse);
hr = lpDIDMouse->SetCooperativeLevel(m_HWND, m_MouseCooLevel);
hr = lpDIDMouse->Acquire();
return 0; // Uh-oh
}
hr=lpDIDMouse->GetDeviceState(sizeof(DIMOUSESTATE), &Mouse);
}
if(SUCCEEDED(hr))
{
*pWheel = Mouse.lZ>0 ? 1 : (Mouse.lZ<0 ? -1 : 0); // Mousewheel
if( m_SystemPointer)
{
// true position
::GetCursorPos(&p);
::ScreenToClient(m_HWND, &p);
*pX = p.x;
*pY = p.y;
}
else
{
// movement
*pX += Mouse.lX;
*pY += Mouse.lY;
}
if(Mouse.rgbButtons[0]) rv|=1;
if(Mouse.rgbButtons[1]) rv|=2;
if(Mouse.rgbButtons[2]) rv|=4;
}
}
// NT PATCH
else
{
if(m_SystemPointer)
{
::GetCursorPos(&p);
::ScreenToClient(m_HWND, &p);
*pX = p.x;
*pY = p.y;
}
else
{
::GetCursorPos(&p);
::SetCursorPos(200, 200);
*pX += (p.x-200);
*pY += (p.y-200);
}
if(GetAsyncKeyState(VK_LBUTTON) & 0x8000) rv|=1;
if(GetAsyncKeyState(VK_RBUTTON) & 0x8000) rv|=2;
if(GetAsyncKeyState(VK_MBUTTON) & 0x8000) rv|=4;
}

// Clip mouse coords to screen
RECT rect;
::GetWindowRect(m_HWND, &rect);
if(*pX<0) *pX = 0;
if(*pY<0) *pY = 0;
if(*pX> rect.right-rect.left) *pX = rect.right-rect.left;
if(*pY> rect.bottom-rect.top) *pY = rect.bottom-rect.top;

return rv;
} // not Win8
#endif
return 0;
}

//---------------------------------------------------------------//
// --- get mousedata ---
//---------------------------------------------------------------//
void DXInput::GetMouseData(DIMOUSEDATA *Data, bool bUpdateXY)
{
MousePos& mps = GetCurMousePos();
int tx = mps.m_MouseX;
int ty = mps.m_MouseY; // #need multitouch coords for Systempointer(false)!!
int wheel=0;
int buttons = 0;
if(IsSystemPointer())
{
tx = mps.m_MouseX;
ty = mps.m_MouseY;
buttons = GetTouchPos(&tx, &ty, &wheel);
Data->mAccX = tx - mps.m_MouseX;
Data->mAccY = ty - mps.m_MouseY;
}
else
{
tx = mps.m_VirtualX;
ty = mps.m_VirtualY;
buttons = GetTouchPos(&tx, &ty, &wheel);
mps.m_VirtualX = tx;
mps.m_VirtualY = ty;
Data->mAccX = mps.m_VirtualX - mps.m_MouseX;
Data->mAccY = mps.m_VirtualY - mps.m_MouseY;
}
mps.m_MouseWheel += wheel;
Data->mMouseWheel = mps.m_MouseWheel;

Data->mButton1 = (buttons & 1) ? 1:0;
Data->mButton2 = (buttons & 2) ? 1:0;
Data->mButton3 = (buttons & 4) ? 1:0;

if(bUpdateXY)
{
if(IsSystemPointer())
{
mps.m_MouseX = mps.m_VirtualX = tx;
mps.m_MouseY = mps.m_VirtualY = ty;
}
else
{
mps.m_MouseX = mps.m_VirtualX;
mps.m_MouseY = mps.m_VirtualY;
}
mps.m_MouseWheel = 0;
}
}

#if defined (ANDROID)
extern "C" int AndroidScancode(int);
#endif


//---------------------------------------------------------------//
//---------------------------------------------------------------//
bool DXInput::GetJoystickData(DIJOYSTATE* Data, int num)
{
#if defined (EMSCRIPTEN)
float xyz[3] = {0.0f, 0.0f, 0.0f};
int ok = glb_get_gravity(xyz);
if(ok)
{
Data->lX= (long)(xyz[0] * 32767.0f);
Data->lY= (long)(xyz[1] * 32767.0f);
Data->lZ= (long)(xyz[2] * 32767.0f);
return true;
}
return false;

// -------- GP2X --------
#elif defined(GP2X) || defined(GPHWIZ)
// Bit Mask
#define GP2X_VK_UP              (1 <<  0)
#define GP2X_VK_UP_LEFT         (1 <<  1)
#define GP2X_VK_LEFT            (1 <<  2)
#define GP2X_VK_DOWN_LEFT       (1 <<  3)
#define GP2X_VK_DOWN            (1 <<  4)
#define GP2X_VK_DOWN_RIGHT      (1 <<  5)
#define GP2X_VK_RIGHT           (1 <<  6)
#define GP2X_VK_UP_RIGHT        (1 <<  7)
#define GP2X_VK_START           (1 <<  8)
#define GP2X_VK_SELECT          (1 <<  9)
#define GP2X_VK_FL              (1 << 10)
#define GP2X_VK_FR              (1 << 11)
#define GP2X_VK_FA              (1 << 12)
#define GP2X_VK_FB              (1 << 13)
#define GP2X_VK_FX              (1 << 14)
#define GP2X_VK_FY              (1 << 15)
#define GP2X_VK_VOL_UP          (1 << 16)
#define GP2X_VK_VOL_DOWN        (1 << 17)
#define GP2X_VK_TAT             (1 << 18)
#define GPK(a) ((keystate & (GP2X_VK_ ##a)) ? 1:0)
#define GPKq(a) (keystate & (GP2X_VK_ ##a))

Data->lX = (GPK(RIGHT)|GPK(UP_RIGHT)|GPK(DOWN_RIGHT)) - (GPK(UP_LEFT) | GPK(LEFT) | GPK(DOWN_LEFT) );
Data->lY = (GPK(DOWN_LEFT) | GPK(DOWN) | GPK(DOWN_RIGHT) ) - (GPK(UP)|GPK(UP_RIGHT)|GPK(UP_LEFT));

// diagonal?
// If you're on the NNW positions, remove the minor fraction part.
// But allow for the DPad Mod
if(Data->lX && Data->lY)
{
if( (GPKq(UP) || GPKq(DOWN)) && !(GPKq(LEFT) || GPKq(RIGHT)) )
Data->lX = 0;
if( (GPKq(LEFT) || GPKq(RIGHT)) && !(GPKq(UP) | GPKq(DOWN)) )
Data->lY = 0;
}

Data->lRx= (GPK(FR) - GPK(FL));
Data->lRz= (GPK(VOL_DOWN) - GPK(VOL_UP));
Data->rgbButtons[0] = GPK(FA);
Data->rgbButtons[1] = GPK(FB);
Data->rgbButtons[2] = GPK(FX);
Data->rgbButtons[3] = GPK(FY);
Data->rgbButtons[4] = GPK(TAT);
Data->rgbButtons[5] = GPK(START);
Data->rgbButtons[6] = GPK(SELECT);
Data->rgbButtons[7] = GPK(VOL_DOWN);
Data->rgbButtons[8] = GPK(VOL_UP);
Data->rgbButtons[9] = GPK(FL);
Data->rgbButtons[10]= GPK(FR);

// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
memset(Data, 0, sizeof(DIJOYSTATE));
if(num==0) // acceleration
{
float x,y,z;
iPhoneGetAcceleration(&x, &y, &z);
Data->lX= (float)(x * 32767.0f); // Space Fractal, NO LONG
Data->lY= (float)(y * 32767.0f); // Space Fractal, NO LONG
Data->lZ= (float)(z * 32767.0f); // Space Fractal, NO LONG
// #NEED get rx,ry,rz values for gyro? (takes lots of battery)
}
else
{
/*
The iCADE button layout is:
0 2 4 6
1 3 5 7

Button mapping on iCade and iControlPad:
iCADE       iControlPad
0           START
1           B
2           SELECT
3           Y
4           RIGHT SHOULDER
5           LEFT SHOULDER
6           A
7           X
*/

if(this->GetNumJoysticks() > 1)
{
unsigned int icade = iPhoneGetICadeInfo();

#define ICADE(butn, code, value) if( (icade & (unsigned int)(code)) != 0 ) {butn=value;}
ICADE(Data->lX           , 0x0008, -32767);
ICADE(Data->lX           , 0x0002,  32767);
ICADE(Data->lY           , 0x0001, -32767);
ICADE(Data->lY           , 0x0004,  32767);
ICADE(Data->rgbButtons[0], 0x0010,  1);
ICADE(Data->rgbButtons[1], 0x0020,  1);
ICADE(Data->rgbButtons[2], 0x0040,  1);
ICADE(Data->rgbButtons[3], 0x0080,  1);
ICADE(Data->rgbButtons[4], 0x0100,  1);
ICADE(Data->rgbButtons[5], 0x0200,  1);
ICADE(Data->rgbButtons[6], 0x0400,  1);
ICADE(Data->rgbButtons[7], 0x0800,  1);
#undef ICADE
}
}


// -------- SDL --------
#elif defined(WANT_SDL)
memset(Data, 0, sizeof(DIJOYSTATE));
int numJ = NumJoysticks;

#ifdef ANDROID
++numJ; // Gamepad after acceleration
#endif

if(num>=0 && num<numJ)
{
#if defined(CAANOO)
if(num > 0) // acceleration
{
int ax, ay, az;
caanoo_sensor_poll(&ax, &ay, &az);
Data->lX=-ax;
Data->lY=-ay;
Data->lZ=-az;
return true;
}
#endif


Data->lX=SDL_JoystickGetAxis(m_pJoys[num], 0);
Data->lY=SDL_JoystickGetAxis(m_pJoys[num], 1);
Data->lZ=SDL_JoystickGetAxis(m_pJoys[num], 2);

Data->lRx=SDL_JoystickGetAxis(m_pJoys[num], 3);
Data->lRy=SDL_JoystickGetAxis(m_pJoys[num], 4);
Data->lRz=SDL_JoystickGetAxis(m_pJoys[num], 5);

#if defined(PALM_WEBOS) || defined(PALM_PIXI)
// 1G = 32768 SDL for WebOS

Data->lY = -Data->lY; // swap Y for the Palm Pre to match iPhone
// HP touchpad - turned again
if(m_AccelerationNativeLandscape)
{
long swp = Data->lX; Data->lX = -Data->lY; Data->lY =swp;
}
return true; // no buttons on acceleration
#endif

#if defined(ANDROID)
// HTC Wildfire2
// SDL2 already returns values in G factored
if(num == 0)
{
Data->lX= -Data->lX;
Data->lY= -Data->lY;
Data->lZ= -Data->lZ;
}

if(num == NumJoysticks) // 0 = acceleration
{
// iControlPad HID Joystick Mode (=Default) (X-Button+Start)
//      Sel=L2 104    Start=R2 105
//          96          Y 109
// DPAD: 98 -- 97   A 108    B 106
//          99          X 110
//    L 104               R 105

// analog nubs:
//   258      266
// 256 257  260 261
//   259      267
// http://developer.android.com/reference/android/view/KeyEvent.html#KEYCODE_BUTTON_A


// Android joypads are sent using an keycode
Data->lX            = 32767 * (AndroidScancode( 257 ) - AndroidScancode( 256 )); // nub1
Data->lY            = 32767 * (AndroidScancode( 258 ) - AndroidScancode( 259 )); // nub1
Data->lRx           = 32767 * (AndroidScancode( 261 ) - AndroidScancode( 260 )); // nub2
Data->lRy           = 32767 * (AndroidScancode( 266 ) - AndroidScancode( 267 )); // nub2
Data->rgbButtons[0] = AndroidScancode(  14 ); // A
Data->rgbButtons[1] = AndroidScancode(  15 ); // B
Data->rgbButtons[2] = AndroidScancode(  16 ); // X
Data->rgbButtons[3] = AndroidScancode( 17 ); // Y
Data->rgbButtons[4] = AndroidScancode( 18 ); // L1
Data->rgbButtons[5] = AndroidScancode( 19 ); // R1
Data->rgbButtons[6] = AndroidScancode( 54 ); // Start
Data->rgbButtons[7] = AndroidScancode( 55 ); // Select


Data->rgdwPOV[0] = -1; // Center
int dx = AndroidScancode( 11 ) - AndroidScancode( 10 );
int dy = AndroidScancode( 13 ) - AndroidScancode( 12 );
switch(dx + 8*dy)
{
//    x      y
case -1 + 8*-1: Data->rgdwPOV[0] = 4500; break;
case  0 + 8*-1: Data->rgdwPOV[0] =    0; break;
case  1 + 8*-1: Data->rgdwPOV[0] = 31500; break;

case -1 + 8* 1: Data->rgdwPOV[0] = 13500; break;
case  0 + 8* 1: Data->rgdwPOV[0] = 18000; break;
case  1 + 8* 1: Data->rgdwPOV[0] = 22500; break;

case -1 + 8* 0: Data->rgdwPOV[0] =  9000; break;
case  1 + 8* 0: Data->rgdwPOV[0] = 27000; break;
}		


// remapping in GameControllers.java
/*
public int onKeyRemap(int keyCode)
{	switch(keyCode){
case 21:  return 10; // DPAD LEFT
case 22:  return 11; // DPAD RIGHT
case 19:  return 12; // DPAD UP
case 20:  return 13; // DPAD DOWN
case 96:  return 14; // A BUTTON
case 97:  return 15; // B BUTTON (Back in menues)
case 99:  return 16; // X BUTTON
case 100: return 17; // Y BUTTON
case 102: return 18; // LEFT SHOULDER
case 103: return 19; // RIGHT SHOULDER
case 106: return 20; // LEFT STICK BUTTON
case 107: return 21; // RIGHT STICK BUTTON
case 108: return 54; // PAUSE/BACK
case 109: return 55; // SELECT
default: return 0; // NOT A KNOWN BUTTON
}
*/
}
return true;
#endif

#ifndef CAANOO // any Joystick device
int numj = min(32, SDL_JoystickNumButtons(m_pJoys[num]));
for (long i=0; i<numj; i++)
Data->rgbButtons[i]=(unsigned char)SDL_JoystickGetButton(m_pJoys[num], i);
#else
Data->rgbButtons[0]=(unsigned char)SDL_JoystickGetButton(m_pJoys[num], 0);
Data->rgbButtons[1]=(unsigned char)SDL_JoystickGetButton(m_pJoys[num], 1);
Data->rgbButtons[2]=(unsigned char)SDL_JoystickGetButton(m_pJoys[num], 2);
Data->rgbButtons[3]=(unsigned char)SDL_JoystickGetButton(m_pJoys[num], 3);
Data->rgbButtons[4]=(unsigned char)SDL_JoystickGetButton(m_pJoys[num], 10); // tap DPad

// Caanoo fix
// helpI, helpII (Menu+Select on Wiz, Select+Home on GP2X)
Data->rgbButtons[5] = (unsigned char)SDL_JoystickGetButton(m_pJoys[num], 8);
Data->rgbButtons[6] = (unsigned char)SDL_JoystickGetButton(m_pJoys[num], 9);
// vol+-
// Can only press both "volume" buttons -> ESC
Data->rgbButtons[7] = (unsigned char)SDL_JoystickGetButton(m_pJoys[num], 6);
Data->rgbButtons[8] = Data->rgbButtons[7];
// front
Data->rgbButtons[9] = (unsigned char)SDL_JoystickGetButton(m_pJoys[num], 4);
Data->rgbButtons[10]= (unsigned char)SDL_JoystickGetButton(m_pJoys[num], 5);
#endif
}
// -------- WIN32 --------
#else

if (num<0 || num>=NumJoysticks){ return false; }

if (lpDIDJoystick[num])
{
LPDIRECTINPUTDEVICE8A pJoy = lpDIDJoystick[num];
HRESULT hr = pJoy->Poll();
if(FAILED(hr)) //  == DIERR_INPUTLOST || hr == DIERR_NOTACQUIRED)
{
pJoy->SetDataFormat(&c_dfDIJoystick);
pJoy->SetCooperativeLevel(m_HWND, DISCL_EXCLUSIVE | DISCL_FOREGROUND);
pJoy->Acquire();
hr = pJoy->Poll();
}
if(FAILED(hr))
{
memset(Data, 0, sizeof(DIJOYSTATE));
}
else
{
pJoy->GetDeviceState(sizeof(DIJOYSTATE), Data);
}
}
else // NT PATCH
{
if (num>1) return false;
JOYINFOEX	ji;
memset(&ji, 0, sizeof(JOYINFOEX));
ji.dwSize=sizeof(JOYINFOEX);
ji.dwFlags=JOY_RETURNALL;
MMRESULT	res;
if (num==0) res=joyGetPosEx(JOYSTICKID1, &ji);
else        res=joyGetPosEx(JOYSTICKID2, &ji);
if (res==JOYERR_NOERROR)
{
Data->lX=ji.dwXpos;
Data->lY=ji.dwYpos;
Data->lZ=ji.dwZpos;
Data->rgbButtons[0]=(BYTE)(ji.dwButtons&JOY_BUTTON1);
Data->rgbButtons[1]=(BYTE)(ji.dwButtons&JOY_BUTTON2);
Data->rgbButtons[2]=(BYTE)(ji.dwButtons&JOY_BUTTON3);
Data->rgbButtons[3]=(BYTE)(ji.dwButtons&JOY_BUTTON4);
Data->rgbButtons[4]=(BYTE)(ji.dwButtons&JOY_BUTTON5);
Data->rgbButtons[5]=(BYTE)(ji.dwButtons&JOY_BUTTON6);
Data->rgbButtons[6]=(BYTE)(ji.dwButtons&JOY_BUTTON7);
Data->rgbButtons[7]=(BYTE)(ji.dwButtons&JOY_BUTTON8);
Data->rgdwPOV[0]=ji.dwPOV;
}
else
{
memset(Data, 0, sizeof(DIJOYSTATE));
}
}
#endif

/*
// -10000 -> +10000
#define LIMP 24000
#define LIMIT(a) if (a>LIMP)a=LIMP;else if(a<-LIMP) a=-LIMP; a*=10; a/=(LIMP/1000);
LIMIT(Data->lX);
LIMIT(Data->lY);
LIMIT(Data->lZ);
*/
return true;
}

#if defined(TARGET_OS_IPHONE)
extern "C" void iPhoneRumble();
#endif

// Force Feedback
void DXInput::ffRumble(int ndevice, int count, float duration, float x_motor, float y_motor)
{
// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)

// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
iPhoneRumble();

// -------- SDL --------
#elif defined(WANT_SDL)
// -------- WIN32 --------
#else
LPDIRECTINPUTDEVICE8A device = lpDIDJoystick[ndevice];
if (!device)
return;

//DIJOYSTATE Data;
//	if(device->GetDeviceState(sizeof(Data), &Data) == (DIERR_INPUTLOST | DIERR_NOTACQUIRED))
device->Acquire();

DIDEVCAPS caps;
caps.dwSize = sizeof(DIDEVCAPS);
device->GetCapabilities(&caps);
if (! (caps.dwFlags & DIDC_FORCEFEEDBACK)) return; // that device is too cheap

// Reset Force Feedback
if(device) device->SendForceFeedbackCommand(DISFFC_RESET);

/*
* Create a constant "rumbling" effect with the specified parameters
* Note that on joysticks that support "real" force feedback this will
* probably just feel like a constant pressure.
*/
DICONSTANTFORCE constantForce;

/* This is about consistent with the relative strength of the motors
* in the Logitech Cordless Rumblepad, which seems to be what the Linux
* FF_RUMBLE API (which bzflag's is patterned after) was designed for.
*/

if(x_motor>1.0f) x_motor=1.0;
if(x_motor<-1.0f) x_motor=-1.0f;
if(y_motor>1.0f) y_motor=1.0;
if(y_motor<-1.0f) y_motor=-1.0f;

constantForce.lMagnitude = (LONG)(DI_FFNOMINALMAX * (x_motor*x_motor+y_motor*y_motor)/2.0f);
/*
* Build the actual effect
*/
DWORD axes[3] = {DIJOFS_X, DIJOFS_Y, DIJOFS_Z};
LONG  dir[3] = {(LONG)(x_motor*32767), (LONG)(y_motor*32767), 32767};

LPDIRECTINPUTEFFECT createdEffect;

DIEFFECT effect;
effect.dwSize = sizeof(DIEFFECT);
// coordinate system really doesn't matter for rumbles but we need to specify it.
effect.dwFlags = DIEFF_OBJECTOFFSETS | DIEFF_CARTESIAN;
// duration
effect.dwDuration = (DWORD)(duration * (DI_SECONDS / 1000));
// defaults
effect.dwSamplePeriod = 0;
effect.dwGain = DI_FFNOMINALMAX;
effect.dwTriggerButton = DIEB_NOTRIGGER;
effect.dwTriggerRepeatInterval = 0;
// all axes
effect.cAxes = 2;
effect.rgdwAxes = &axes[0];
// direction doesn't matter
effect.rglDirection = &dir[0];
// no envelope
effect.lpEnvelope = NULL;
// use the constant force data
effect.cbTypeSpecificParams = sizeof(DICONSTANTFORCE);
effect.lpvTypeSpecificParams = &constantForce;
// start delay
#if(DIRECTINPUT_VERSION >= 0x0600)
effect.dwStartDelay = (DWORD)(/*delay*/ 0 * DI_SECONDS);
#endif

// create the effect
HRESULT hr = device->CreateEffect(GUID_ConstantForce, &effect, &createdEffect, NULL);
// play the thing
hr = createdEffect->Start(count, 0);
#endif
}


Queue<char> g_inkey_last_ascii_keydown;

//---------------------------------------------------------------//
// WHAT KEY IS PRESSED (INKEY$)
//---------------------------------------------------------------//
char DXInput::GetKeyChar(void)
{
#if defined( WANT_SDL ) || defined( WIN32) || defined(TARGET_OS_IPHONE)
int count = m_inkey_chars.Size();

char c='\0';
if(count)
{
char* pC = &m_inkey_chars[0];
c = *pC;

// shift backwards
while(count>1)
{
*pC = pC[1];
++pC;
--count;
}
m_inkey_chars.Pop();

if(c=='\r') c='\n';
}
return c;
#else
static	char lastpressed='\0';
char asc_unshift='\0';
this->GetKeyboardStatus();

unsigned char asc='\0', i;
for (i=0; i<255; i++) // A-Z
{
if(this->GetKey(i))
{
asc = this->Scan2Ascii(i);
asc_unshift=asc;
if(asc>='A' && asc<='Z') {asc_unshift = asc - 'A' + 'a';}
if(asc!='\0')
{
if( (GetKey(42) || GetKey(54)) &&
(
(asc>='a' && asc<='z')
)
)
{
asc-=32; // Capital Letters
}
break;
}
}
}
if(lastpressed==asc_unshift)
{
asc='\0';
}
else
{
lastpressed=asc_unshift;
}
if(asc=='\r') asc='\n';
return asc;
#endif
}




//---------------------------------------------------------------//
// convert dx to ascii
// -> only used for INKEY$ function
//---------------------------------------------------------------//
char DXInput::Scan2Ascii(DWORD scancode)
{
char ch;
switch(scancode)
{
case 0x0E:				// Backsp
ch=0x08; break;
case 0x1C: case 0x9C:	// Return
ch=0x0A; break;
case 69: case 58: case 42: case 54: case 29: case 56: case 221: // NUM-Lock, ShiftGR, ShiftL, ShiftR, CtrlL, Alt, Menu
ch='\0'; break;
default:				// Any other key

// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
ch=scancode;
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)
return '\0';

// -------- SDL --------
#elif defined(WANT_SDL)
ch=(unsigned char)m_MapBuffer[scancode%256];
// -------- WIN32 --------
#else
// with this method, we get even different keyboard layouts
static HKL layout=GetKeyboardLayout(0);
static unsigned char State[256];
static DWORD lastkey=0xffff;
unsigned short result;

if (::GetKeyboardState(State)==FALSE)
return 0;

lastkey = scancode;
UINT vk=MapVirtualKeyEx(scancode,1,layout);
int rv = ToAsciiEx(vk,scancode, State,&result,0,layout);
ch = (char) result;
if (!rv) ch='\0';
#endif
}
if (ch>0 && ch<0x20 && ch!=0x08 && ch!=0x0A) // backsp & return
ch='\0';
return ch;
}


// ------------------------------------------------------------- //
void DXInput::DXtoVK(bool DXActive)
// ------------------------------------------------------------- //
{
#ifndef DXINPUT_HAVE_NO_KEYS
// -------- GP2X --------
#if defined(GP2X) || defined(GPHWIZ) || defined(CAANOO)
// -------- iPhone --------
#elif defined(TARGET_OS_IPHONE)

// -------- SDL --------
#elif defined(WANT_SDL)

#if SDL_VERSION_ATLEAST(2,0,0)
// These key constants were renamed for clarity or consistency. 
#define SDLK_KP0 SDLK_KP_0
#define SDLK_KP1 SDLK_KP_1
#define SDLK_KP2 SDLK_KP_2
#define SDLK_KP3 SDLK_KP_3
#define SDLK_KP4 SDLK_KP_4
#define SDLK_KP5 SDLK_KP_5
#define SDLK_KP6 SDLK_KP_6
#define SDLK_KP7 SDLK_KP_7
#define SDLK_KP8 SDLK_KP_8
#define SDLK_KP9 SDLK_KP_9
#define SDLK_NUMLOCK SDLK_NUMLOCKCLEAR
#define SDLK_SCROLLOCK SDLK_SCROLLLOCK
#define SDLK_PRINT SDLK_PRINTSCREEN
#define SDLK_LMETA SDLK_LGUI
#define SDLK_RMETA SDLK_RGUI
#endif



#ifndef DIK_ESCAPE
#define DIK_ESCAPE          0x01
#endif
#define DIK_1               0x02
#define DIK_2               0x03
#define DIK_3               0x04
#define DIK_4               0x05
#define DIK_5               0x06
#define DIK_6               0x07
#define DIK_7               0x08
#define DIK_8               0x09
#define DIK_9               0x0A
#define DIK_0               0x0B
#define DIK_MINUS           0x0C    /* - on main keyboard */
#define DIK_EQUALS          0x0D
#define DIK_BACK            0x0E    /* backspace */
#define DIK_TAB             0x0F
#define DIK_Q               0x10
#define DIK_W               0x11
#define DIK_E               0x12
#define DIK_R               0x13
#define DIK_T               0x14
#define DIK_Y               0x15
#define DIK_U               0x16
#define DIK_I               0x17
#define DIK_O               0x18
#define DIK_P               0x19
#define DIK_LBRACKET        0x1A
#define DIK_RBRACKET        0x1B
#define DIK_RETURN          0x1C    /* Enter on main keyboard */
#define DIK_LCONTROL        0x1D
#define DIK_A               0x1E
#define DIK_S               0x1F
#define DIK_D               0x20
#define DIK_F               0x21
#define DIK_G               0x22
#define DIK_H               0x23
#define DIK_J               0x24
#define DIK_K               0x25
#define DIK_L               0x26
#define DIK_SEMICOLON       0x27
#define DIK_APOSTROPHE      0x28
#define DIK_GRAVE           0x29    /* accent grave */
#define DIK_LSHIFT          0x2A
#define DIK_BACKSLASH       0x2B
#define DIK_Z               0x2C
#define DIK_X               0x2D
#define DIK_C               0x2E
#define DIK_V               0x2F
#define DIK_B               0x30
#define DIK_N               0x31
#define DIK_M               0x32
#define DIK_COMMA           0x33
#define DIK_PERIOD          0x34    /* . on main keyboard */
#define DIK_SLASH           0x35    /* / on main keyboard */
#define DIK_RSHIFT          0x36
#define DIK_MULTIPLY        0x37    /* * on numeric keypad */
#define DIK_LMENU           0x38    /* left Alt */
#define DIK_SPACE           0x39
#define DIK_CAPITAL         0x3A
#define DIK_F1              0x3B
#define DIK_F2              0x3C
#define DIK_F3              0x3D
#define DIK_F4              0x3E
#define DIK_F5              0x3F
#define DIK_F6              0x40
#define DIK_F7              0x41
#define DIK_F8              0x42
#define DIK_F9              0x43
#define DIK_F10             0x44
#define DIK_NUMLOCK         0x45
#define DIK_SCROLL          0x46    /* Scroll Lock */
#define DIK_NUMPAD7         0x47
#define DIK_NUMPAD8         0x48
#define DIK_NUMPAD9         0x49
#define DIK_SUBTRACT        0x4A    /* - on numeric keypad */
#define DIK_NUMPAD4         0x4B
#define DIK_NUMPAD5         0x4C
#define DIK_NUMPAD6         0x4D
#define DIK_ADD             0x4E    /* + on numeric keypad */
#define DIK_NUMPAD1         0x4F
#define DIK_NUMPAD2         0x50
#define DIK_NUMPAD3         0x51
#define DIK_NUMPAD0         0x52
#define DIK_DECIMAL         0x53    /* . on numeric keypad */
#define DIK_OEM_102         0x56    /* < > | on UK/Germany keyboards */
#define DIK_F11             0x57
#define DIK_F12             0x58

#define DIK_F13             0x64    /*                     (NEC PC98) */
#define DIK_F14             0x65    /*                     (NEC PC98) */
#define DIK_F15             0x66    /*                     (NEC PC98) */

#define DIK_KANA            0x70    /* (Japanese keyboard)            */
#define DIK_ABNT_C1         0x73    /* / ? on Portugese (Brazilian) keyboards */
#define DIK_CONVERT         0x79    /* (Japanese keyboard)            */
#define DIK_NOCONVERT       0x7B    /* (Japanese keyboard)            */
#define DIK_YEN             0x7D    /* (Japanese keyboard)            */
#define DIK_ABNT_C2         0x7E    /* Numpad . on Portugese (Brazilian) keyboards */
#define DIK_NUMPADEQUALS    0x8D    /* = on numeric keypad (NEC PC98) */
#define DIK_PREVTRACK       0x90    /* Previous Track (DIK_CIRCUMFLEX on Japanese keyboard) */
#define DIK_AT              0x91    /*                     (NEC PC98) */
#define DIK_COLON           0x92    /*                     (NEC PC98) */
#define DIK_UNDERLINE       0x93    /*                     (NEC PC98) */
#define DIK_KANJI           0x94    /* (Japanese keyboard)            */
#define DIK_STOP            0x95    /*                     (NEC PC98) */
#define DIK_AX              0x96    /*                     (Japan AX) */
#define DIK_UNLABELED       0x97    /*                        (J3100) */
#define DIK_NEXTTRACK       0x99    /* Next Track */
#define DIK_NUMPADENTER     0x9C    /* Enter on numeric keypad */
#define DIK_RCONTROL        0x9D
#define DIK_MUTE            0xA0    /* Mute */
#define DIK_CALCULATOR      0xA1    /* Calculator */
#define DIK_PLAYPAUSE       0xA2    /* Play / Pause */
#define DIK_MEDIASTOP       0xA4    /* Media Stop */
#define DIK_VOLUMEDOWN      0xAE    /* Volume - */
#define DIK_VOLUMEUP        0xB0    /* Volume + */
#define DIK_WEBHOME         0xB2    /* Web home */
#define DIK_NUMPADCOMMA     0xB3    /* , on numeric keypad (NEC PC98) */
#define DIK_DIVIDE          0xB5    /* / on numeric keypad */
#define DIK_SYSRQ           0xB7
#define DIK_RMENU           0xB8    /* right Alt */
#define DIK_PAUSE           0xC5    /* Pause */
#define DIK_HOME            0xC7    /* Home on arrow keypad */
#define DIK_UP              0xC8    /* UpArrow on arrow keypad */
#define DIK_PRIOR           0xC9    /* PgUp on arrow keypad */
#define DIK_LEFT            0xCB    /* LeftArrow on arrow keypad */
#define DIK_RIGHT           0xCD    /* RightArrow on arrow keypad */
#define DIK_END             0xCF    /* End on arrow keypad */
#define DIK_DOWN            0xD0    /* DownArrow on arrow keypad */
#define DIK_NEXT            0xD1    /* PgDn on arrow keypad */
#define DIK_INSERT          0xD2    /* Insert on arrow keypad */
#define DIK_DELETE          0xD3    /* Delete on arrow keypad */
#define DIK_LWIN            0xDB    /* Left Windows key */
#define DIK_RWIN            0xDC    /* Right Windows key */
#define DIK_APPS            0xDD    /* AppMenu key */
#define DIK_POWER           0xDE    /* System Power */
#define DIK_SLEEP           0xDF    /* System Sleep */
#define DIK_WAKE            0xE3    /* System Wake */
#define DIK_WEBSEARCH       0xE5    /* Web Search */
#define DIK_WEBFAVORITES    0xE6    /* Web Favorites */
#define DIK_WEBREFRESH      0xE7    /* Web Refresh */
#define DIK_WEBSTOP         0xE8    /* Web Stop */
#define DIK_WEBFORWARD      0xE9    /* Web Forward */
#define DIK_WEBBACK         0xEA    /* Web Back */
#define DIK_MYCOMPUTER      0xEB    /* My Computer */
#define DIK_MAIL            0xEC    /* Mail */
#define DIK_MEDIASELECT     0xED    /* Media Select */

long i;
for(i=0; i<MAX_KEYS_DINPUT; i++)
m_MapBuffer[i]=255;

/* Defined DIK_* constants */
m_MapBuffer[DIK_ESCAPE] = SDLK_ESCAPE;
m_MapBuffer[DIK_1] = SDLK_1;
m_MapBuffer[DIK_2] = SDLK_2;
m_MapBuffer[DIK_3] = SDLK_3;
m_MapBuffer[DIK_4] = SDLK_4;
m_MapBuffer[DIK_5] = SDLK_5;
m_MapBuffer[DIK_6] = SDLK_6;
m_MapBuffer[DIK_7] = SDLK_7;
m_MapBuffer[DIK_8] = SDLK_8;
m_MapBuffer[DIK_9] = SDLK_9;
m_MapBuffer[DIK_0] = SDLK_0;
m_MapBuffer[DIK_MINUS] = SDLK_MINUS;
m_MapBuffer[DIK_EQUALS] = SDLK_EQUALS;
m_MapBuffer[DIK_BACK] = SDLK_BACKSPACE;
m_MapBuffer[DIK_TAB] = SDLK_TAB;
m_MapBuffer[DIK_Q] = SDLK_q;
m_MapBuffer[DIK_W] = SDLK_w;
m_MapBuffer[DIK_E] = SDLK_e;
m_MapBuffer[DIK_R] = SDLK_r;
m_MapBuffer[DIK_T] = SDLK_t;
m_MapBuffer[DIK_Y] = SDLK_y;
m_MapBuffer[DIK_U] = SDLK_u;
m_MapBuffer[DIK_I] = SDLK_i;
m_MapBuffer[DIK_O] = SDLK_o;
m_MapBuffer[DIK_P] = SDLK_p;
m_MapBuffer[DIK_LBRACKET] = SDLK_LEFTBRACKET;
m_MapBuffer[DIK_RBRACKET] = SDLK_RIGHTBRACKET;
m_MapBuffer[DIK_RETURN] = SDLK_RETURN;
m_MapBuffer[DIK_LCONTROL] = SDLK_LCTRL;
m_MapBuffer[DIK_A] = SDLK_a;
m_MapBuffer[DIK_S] = SDLK_s;
m_MapBuffer[DIK_D] = SDLK_d;
m_MapBuffer[DIK_F] = SDLK_f;
m_MapBuffer[DIK_G] = SDLK_g;
m_MapBuffer[DIK_H] = SDLK_h;
m_MapBuffer[DIK_J] = SDLK_j;
m_MapBuffer[DIK_K] = SDLK_k;
m_MapBuffer[DIK_L] = SDLK_l;
m_MapBuffer[DIK_SEMICOLON] = SDLK_SEMICOLON;
m_MapBuffer[DIK_APOSTROPHE] = SDLK_QUOTE;
m_MapBuffer[DIK_GRAVE] = SDLK_BACKQUOTE;
m_MapBuffer[DIK_LSHIFT] = SDLK_LSHIFT;
m_MapBuffer[DIK_BACKSLASH] = SDLK_BACKSLASH;
m_MapBuffer[DIK_OEM_102] = SDLK_BACKSLASH;
m_MapBuffer[DIK_Z] = SDLK_z;
m_MapBuffer[DIK_X] = SDLK_x;
m_MapBuffer[DIK_C] = SDLK_c;
m_MapBuffer[DIK_V] = SDLK_v;
m_MapBuffer[DIK_B] = SDLK_b;
m_MapBuffer[DIK_N] = SDLK_n;
m_MapBuffer[DIK_M] = SDLK_m;
m_MapBuffer[DIK_COMMA] = SDLK_COMMA;
m_MapBuffer[DIK_PERIOD] = SDLK_PERIOD;
m_MapBuffer[DIK_SLASH] = SDLK_SLASH;
m_MapBuffer[DIK_RSHIFT] = SDLK_RSHIFT;
m_MapBuffer[DIK_MULTIPLY] = SDLK_KP_MULTIPLY;
m_MapBuffer[DIK_LMENU] = SDLK_LALT;
m_MapBuffer[DIK_SPACE] = SDLK_SPACE;
m_MapBuffer[DIK_CAPITAL] = SDLK_CAPSLOCK;
m_MapBuffer[DIK_F1] = SDLK_F1;
m_MapBuffer[DIK_F2] = SDLK_F2;
m_MapBuffer[DIK_F3] = SDLK_F3;
m_MapBuffer[DIK_F4] = SDLK_F4;
m_MapBuffer[DIK_F5] = SDLK_F5;
m_MapBuffer[DIK_F6] = SDLK_F6;
m_MapBuffer[DIK_F7] = SDLK_F7;
m_MapBuffer[DIK_F8] = SDLK_F8;
m_MapBuffer[DIK_F9] = SDLK_F9;
m_MapBuffer[DIK_F10] = SDLK_F10;
m_MapBuffer[DIK_NUMLOCK] = SDLK_NUMLOCK;
m_MapBuffer[DIK_SCROLL] = SDLK_SCROLLOCK;
m_MapBuffer[DIK_NUMPAD7] = SDLK_KP7;
m_MapBuffer[DIK_NUMPAD8] = SDLK_KP8;
m_MapBuffer[DIK_NUMPAD9] = SDLK_KP9;
m_MapBuffer[DIK_SUBTRACT] = SDLK_KP_MINUS;
m_MapBuffer[DIK_NUMPAD4] = SDLK_KP4;
m_MapBuffer[DIK_NUMPAD5] = SDLK_KP5;
m_MapBuffer[DIK_NUMPAD6] = SDLK_KP6;
m_MapBuffer[DIK_ADD] = SDLK_KP_PLUS;
m_MapBuffer[DIK_NUMPAD1] = SDLK_KP1;
m_MapBuffer[DIK_NUMPAD2] = SDLK_KP2;
m_MapBuffer[DIK_NUMPAD3] = SDLK_KP3;
m_MapBuffer[DIK_NUMPAD0] = SDLK_KP0;
m_MapBuffer[DIK_DECIMAL] = SDLK_KP_PERIOD;
m_MapBuffer[DIK_F11] = SDLK_F11;
m_MapBuffer[DIK_F12] = SDLK_F12;

m_MapBuffer[DIK_F13] = SDLK_F13;
m_MapBuffer[DIK_F14] = SDLK_F14;
m_MapBuffer[DIK_F15] = SDLK_F15;
m_MapBuffer[DIK_NUMPADEQUALS] = SDLK_KP_EQUALS;
m_MapBuffer[DIK_NUMPADENTER] = SDLK_KP_ENTER;
m_MapBuffer[DIK_RCONTROL] = SDLK_RCTRL;
m_MapBuffer[DIK_DIVIDE] = SDLK_KP_DIVIDE;
m_MapBuffer[DIK_SYSRQ] = SDLK_SYSREQ;
m_MapBuffer[DIK_RMENU] = SDLK_RALT;
m_MapBuffer[DIK_PAUSE] = SDLK_PAUSE;
m_MapBuffer[DIK_HOME] = SDLK_HOME;
m_MapBuffer[DIK_UP] = SDLK_UP;
m_MapBuffer[DIK_PRIOR] = SDLK_PAGEUP;
m_MapBuffer[DIK_LEFT] = SDLK_LEFT;
m_MapBuffer[DIK_RIGHT] = SDLK_RIGHT;
m_MapBuffer[DIK_END] = SDLK_END;
m_MapBuffer[DIK_DOWN] = SDLK_DOWN;
m_MapBuffer[DIK_NEXT] = SDLK_PAGEDOWN;
m_MapBuffer[DIK_INSERT] = SDLK_INSERT;
m_MapBuffer[DIK_DELETE] = SDLK_DELETE;
m_MapBuffer[DIK_LWIN] = SDLK_LMETA;
m_MapBuffer[DIK_RWIN] = SDLK_RMETA;
m_MapBuffer[DIK_APPS] = SDLK_MENU;
// -------- WIN32 --------
#else
unsigned short i;
if (DXActive==true)
{
for (i=0; i<MAX_KEYS_DINPUT; i++) m_MapBuffer[i]=i; // Preset
return;
}

lpDIDKeyboard=NULL;

for (i=0; i<MAX_KEYS_DINPUT; i++) m_MapBuffer[i]=255; // Preset
m_MapBuffer[0x00]=0x0D;
m_MapBuffer[0x01]=0x1B;
m_MapBuffer[0x01]=0x1B;
m_MapBuffer[0x02]=0x31;
m_MapBuffer[0x03]=0x32;
m_MapBuffer[0x04]=0x33;
m_MapBuffer[0x05]=0x34;
m_MapBuffer[0x06]=0x35;
m_MapBuffer[0x07]=0x36;
m_MapBuffer[0x08]=0x37;
m_MapBuffer[0x09]=0x38;
m_MapBuffer[0x0A]=0x39;
m_MapBuffer[0x0B]=0x30;
m_MapBuffer[0x0C]=0xDB;
m_MapBuffer[0x0D]=0xDD;
m_MapBuffer[0x0E]=0x08;
m_MapBuffer[0x0F]=0x09;
m_MapBuffer[0x10]=0x51;
m_MapBuffer[0x11]=0x57;
m_MapBuffer[0x12]=0x45;
m_MapBuffer[0x13]=0x52;
m_MapBuffer[0x14]=0x54;
m_MapBuffer[0x15]=0x5A;
m_MapBuffer[0x16]=0x55;
m_MapBuffer[0x17]=0x49;
m_MapBuffer[0x18]=0x4F;
m_MapBuffer[0x19]=0x50;
m_MapBuffer[0x1A]=0xBA;
m_MapBuffer[0x1B]=0xBB;
m_MapBuffer[0x1C]=0x0D;
m_MapBuffer[0x1D]=0x11;
m_MapBuffer[0x1E]=0x41;
m_MapBuffer[0x1F]=0x53;
m_MapBuffer[0x20]=0x44;
m_MapBuffer[0x21]=0x46;
m_MapBuffer[0x22]=0x47;
m_MapBuffer[0x23]=0x48;
m_MapBuffer[0x24]=0x4A;
m_MapBuffer[0x25]=0x4B;
m_MapBuffer[0x26]=0x4C;
m_MapBuffer[0x27]=0xC0;
m_MapBuffer[0x28]=0xDE;
m_MapBuffer[0x29]=0xDC;
m_MapBuffer[0x2A]=0x10;
m_MapBuffer[0x2B]=0xBF;
m_MapBuffer[0x2C]=0x59;
m_MapBuffer[0x2D]=0x58;
m_MapBuffer[0x2E]=0x43;
m_MapBuffer[0x2F]=0x56;
m_MapBuffer[0x30]=0x42;
m_MapBuffer[0x31]=0x4E;
m_MapBuffer[0x32]=0x4D;
m_MapBuffer[0x33]=0xBC;
m_MapBuffer[0x34]=0xBE;
m_MapBuffer[0x35]=0xBD;
m_MapBuffer[0x36]=0x10;
m_MapBuffer[0x37]=0x6A;
m_MapBuffer[0x38]=0x12;
m_MapBuffer[0x39]=0x20;
m_MapBuffer[0x3A]=0x00;
m_MapBuffer[0x3B]=0x70;
m_MapBuffer[0x3B]=0x70;
m_MapBuffer[0x3C]=0x71;
m_MapBuffer[0x3C]=0x71;
m_MapBuffer[0x3D]=0x72;
m_MapBuffer[0x3E]=0x73;
m_MapBuffer[0x3F]=0x74;
m_MapBuffer[0x40]=0x75;
m_MapBuffer[0x41]=0x76;
m_MapBuffer[0x42]=0x77;
m_MapBuffer[0x43]=0x78;
m_MapBuffer[0x44]=0x79;
m_MapBuffer[0x45]=0x90;
m_MapBuffer[0x46]=0x91;
m_MapBuffer[0x46]=0x91;
m_MapBuffer[0x47]=0x24;
m_MapBuffer[0x48]=0x26;
m_MapBuffer[0x49]=0x21;
m_MapBuffer[0x4A]=0x6D;
m_MapBuffer[0x4B]=0x25;
m_MapBuffer[0x4C]=0x0C;
m_MapBuffer[0x4D]=0x27;
m_MapBuffer[0x4E]=0x6B;
m_MapBuffer[0x4F]=0x23;
m_MapBuffer[0x50]=0x28;
m_MapBuffer[0x51]=0x22;
m_MapBuffer[0x52]=0x2D;
m_MapBuffer[0x53]=0x2E;
m_MapBuffer[0x56]=0xE2;
m_MapBuffer[0x57]=0x7A;
m_MapBuffer[0x58]=0x7B;
// Num-Enter!?
m_MapBuffer[0x9C]=0x1C;
m_MapBuffer[0x9D]=0x11;
m_MapBuffer[0xB5]=0x6F;
m_MapBuffer[0xB8]=0x12;
m_MapBuffer[0xC7]=0x24;
m_MapBuffer[0xC8]=0x26;
m_MapBuffer[0xC9]=0x21;
m_MapBuffer[0xCB]=0x25;
m_MapBuffer[0xCD]=0x27;
m_MapBuffer[0xCF]=0x23;
m_MapBuffer[0xD0]=0x28;
m_MapBuffer[0xD1]=0x22;
m_MapBuffer[0xD2]=0x2D;
m_MapBuffer[0xD3]=0x2E;
m_MapBuffer[0xDB]=0x5B;
m_MapBuffer[0xDC]=0x5C;
m_MapBuffer[0xDD]=0x5D;
// Numpad
m_MapBuffer[0x47]=0x67;
m_MapBuffer[0x48]=0x68;
m_MapBuffer[0x49]=0x69;
m_MapBuffer[0x4B]=0x64;
m_MapBuffer[0x4C]=0x65;
m_MapBuffer[0x4D]=0x66;
m_MapBuffer[0x4F]=0x61;
m_MapBuffer[0x50]=0x62;
m_MapBuffer[0x51]=0x63;
m_MapBuffer[0x52]=0x60;
m_MapBuffer[0x53]=0x6E;
#endif

#endif // DXINPUT_HAVE_NO_KEYS
}


#else // console
void glb_dxinput_console_dummy() {};
#endif // !GLB_CONSOLE

#include "stdafx.h" // #include "stdafx.h"
#include "dxsound.h" // #include "dxsound.h"
#include "gffilesystem.h" // #include "gffilesystem.h"

#ifdef GPHWIZ
#include <linux/soundcard.h>
#endif

#if defined(WIN32) && !defined(WANT_SDL_MIXER)
#pragma comment(lib, "DSound.lib")

#pragma pack(1)
struct Waveheader
{
DWORD RIFF; // BYTE        RIFF[4];          // "RIFF"=0x52494646
DWORD       dwSize;           // Size of data to follow
DWORD WAVE; // BYTE        WAVE[4];          // "WAVE"=0x57415645
};
struct SubChunk1
{
DWORD ID; // BYTE        fmt_[4];          // "fmt " = 0x666D7420
DWORD       Subchunk1Size;    // usually 16. Number of bytes between 'fmt ' and 'data' text tags (usually 16)
};

struct FmtChunk
{
WORD        AudioFormat;      // 1=PCM
WORD        wChnls;           // Number of Channels
DWORD       dwSRate;          // Sample Rate
DWORD       BytesPerSec;      // Sample Rate [hz]
WORD        wBlkAlign;        // 1
WORD        BitsPerSample;    // Sample size
};
#pragma pack()


// -------------------------------------------- //
// SFXSound Constructor
// -------------------------------------------- //
SFXSound::SFXSound()
{
m_lpDS=NULL;
}


SFXSound::~SFXSound()
{
if (m_lpDS != NULL)
{
m_lpDS -> Release();	
}
m_lpDS=NULL;
}


// -------------------------------------------- //
// Create DirectSound Object
// -------------------------------------------- //
// COM must be intitialized!
BOOL SFXSound::Create (HWND hwnd)
{
HRESULT       hr;
hr = DirectSoundCreate(NULL, &m_lpDS, NULL);
if (hr != DS_OK) return FALSE;

hr = m_lpDS->SetCooperativeLevel(hwnd, DSSCL_PRIORITY);
if (hr != DS_OK) return FALSE;

// Get the primary buffer 
LPDIRECTSOUNDBUFFER pDSBPrimary = NULL;
DSBUFFERDESC dsbd;
ZeroMemory( &dsbd, sizeof(DSBUFFERDESC) );
dsbd.dwSize        = sizeof(DSBUFFERDESC);
dsbd.dwFlags       = DSBCAPS_PRIMARYBUFFER;
dsbd.dwBufferBytes = 0;
dsbd.lpwfxFormat   = NULL;

if( FAILED( hr = m_lpDS->CreateSoundBuffer( &dsbd, &pDSBPrimary, NULL ) ) )
return FALSE;

// Set primary buffer format to 22kHz and 16-bit output.
WAVEFORMATEX wfx;
ZeroMemory( &wfx, sizeof(WAVEFORMATEX) ); 
wfx.wFormatTag      = WAVE_FORMAT_PCM; 
wfx.nChannels       = 2; // Stereo
wfx.nSamplesPerSec  = 22050;
wfx.wBitsPerSample  = 16;
wfx.nBlockAlign     = wfx.wBitsPerSample / 8 * wfx.nChannels;
wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;

if( FAILED( hr = pDSBPrimary->SetFormat(&wfx) ) )
return FALSE;

RELEASE(pDSBPrimary);
GetCaps();
return TRUE;
}// Create

void SFXSound::SetWindow(HWND hwnd)
{
if(m_lpDS)
m_lpDS->SetCooperativeLevel(hwnd, DSSCL_PRIORITY);
}



// -------------------------------------------- //
// Get Capabilities of Sound Device
// -------------------------------------------- //
BOOL SFXSound::GetCaps(void)
{
HRESULT hr;
if(!m_lpDS) return FALSE;
m_DSCaps.dwSize = sizeof(DSCAPS); 
hr = m_lpDS->GetCaps(&m_DSCaps); 

if (hr != DS_OK) return FALSE;
return true;
}


// -------------------------------------------- //
// SFXSoundBuffer Constructor
// -------------------------------------------- //
SFXSoundBuffer::SFXSoundBuffer(void)
{
m_pDS = NULL;
for (int i=0; i<4; i++)
m_lpDSB[i] = NULL;
m_Current = 0;
m_nBuffers = 0;
}

// -------------------------------------------- //
// SFXSoundBuffer Destructor
// -------------------------------------------- //
SFXSoundBuffer::~SFXSoundBuffer(void)
{
FreeBuffer();
}

void SFXSoundBuffer::FreeBuffer(void)
{
this->Stop();
for(int i = 0; i<m_nBuffers; i++)
{
RELEASE(m_lpDSB[i]);
m_lpDSB[i] = NULL;
}
m_Current = 0;
m_nBuffers = 0;
}


void SFXSoundBuffer::Init(void)
{m_nBuffers=m_Current=0; m_Filename=NULL; m_pDS=NULL;}

// -------------------------------------------- //
// SFXSoundBuffer CreateSoundBuffer
// -------------------------------------------- //
BOOL SFXSoundBuffer::CreateSoundBuffer(DWORD dwBufSize, DWORD dwFreq, DWORD dwBitsPerSample, DWORD dwBlkAlign, BOOL bStereo)
{
PCMWAVEFORMAT pcmwf;
DSBUFFERDESC dsbdesc;

// Set up wave format structure.
memset(&pcmwf, 0, sizeof(PCMWAVEFORMAT));
pcmwf.wf.wFormatTag         = WAVE_FORMAT_PCM;      
pcmwf.wf.nChannels          = bStereo ? 2 : 1;
pcmwf.wf.nSamplesPerSec     = dwFreq;
pcmwf.wf.nBlockAlign        = (WORD)dwBlkAlign;
pcmwf.wf.nAvgBytesPerSec    = pcmwf.wf.nSamplesPerSec * pcmwf.wf.nBlockAlign;
pcmwf.wBitsPerSample        = (WORD)dwBitsPerSample;

// Set up DSBUFFERDESC structure.
memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));
dsbdesc.dwSize              = sizeof(DSBUFFERDESC);
dsbdesc.dwFlags             = DSBCAPS_STATIC | DSBCAPS_GETCURRENTPOSITION2
|DSBCAPS_CTRLPAN|DSBCAPS_CTRLVOLUME;
dsbdesc.dwBufferBytes       = dwBufSize; 
dsbdesc.lpwfxFormat         = (LPWAVEFORMATEX)&pcmwf;

if (m_pDS->m_lpDS->CreateSoundBuffer(&dsbdesc, &m_lpDSB[0], NULL)!=DS_OK)
{
dsbdesc.dwFlags = DSBCAPS_STATIC | DSBCAPS_GETCURRENTPOSITION2; // No PAN, Vol..
if (m_pDS->m_lpDS->CreateSoundBuffer(&dsbdesc, &m_lpDSB[0], NULL)!=DS_OK)
{
m_pDS=NULL;
return FALSE;
}
}

return TRUE;
}

// -------------------------------------------- //
// SFXSoundBuffer ReadData
// -------------------------------------------- //
BOOL SFXSoundBuffer::ReadData(GFFileSystem& fp, DWORD dwSize, DWORD dwPos)
{
// Seek to correct position in file (if necessary)
if (dwPos != 0xffffffff) 
{
if (!fp.SeekTo(dwPos)) return FALSE;
}

// Lock data in buffer for writing
LPVOID pData1;
DWORD  dwData1Size;
LPVOID pData2;
DWORD  dwData2Size;
HRESULT rval;

rval = m_lpDSB[0]->Lock(0, dwSize, &pData1, &dwData1Size, &pData2, &dwData2Size, DSBLOCK_FROMWRITECURSOR);
if (rval != DS_OK)
{
return FALSE;
}

// Read in first chunk of data
if (dwData1Size > 0) 
{
if (!fp.Read(pData1, dwData1Size))
{
return FALSE;
}
}

// Read in second chunk if necessary
if (dwData2Size > 0) 
{
if (!fp.Read(pData2, dwData2Size))
return FALSE;
}

// Unlock data in buffer
rval = m_lpDSB[0]->Unlock(pData1, dwData1Size, pData2, dwData2Size);
if (rval != DS_OK) return FALSE;

return TRUE;
}

// -------------------------------------------- //
// SFXSoundBuffer GetFreeBuffer
// -------------------------------------------- //
LPDIRECTSOUNDBUFFER SFXSoundBuffer::GetFreeBuffer(void)
{
DWORD				Status;
HRESULT				rval;
LPDIRECTSOUNDBUFFER	Buffer;
if(m_lpDSB == NULL) return NULL;
if(Buffer = m_lpDSB[m_Current])
{
rval = Buffer->GetStatus(&Status);
if(rval < 0) Status = 0;
if((Status & DSBSTATUS_PLAYING) == DSBSTATUS_PLAYING)
{
if(m_nBuffers > 1)
{
if (++m_Current >= m_nBuffers) m_Current = 0;
Buffer = m_lpDSB[m_Current];
rval = Buffer->GetStatus(&Status);
if((rval >= 0) && (Status & DSBSTATUS_PLAYING) == DSBSTATUS_PLAYING)
{
Buffer->Stop();
Buffer->SetCurrentPosition(0);
}
}
else
{
Buffer = NULL;
}
}
if(Buffer && (Status & DSBSTATUS_BUFFERLOST))
{
if((Buffer->Restore() < 0))
{
Buffer = NULL;
}
}
}
return Buffer;
}

// -------------------------------------------- //
// SFXSoundBuffer LoadFromFile
// http://www.sonicspot.com/guide/wavefiles.html <-- FINALLY!
// -------------------------------------------- //
bool SFXSoundBuffer::LoadFromFile(void)
{
// Open the wave file       
GFFileSystem	file;
if (!file.OpenIn(m_Filename)) return false;
// FILE* fp = fopen(m_Filename, "rb"); if (fp == NULL) return false;

// Read in the wave header          
Waveheader Wavhdr;
if (!file.Read(&Wavhdr, sizeof(Wavhdr)))
{
file.Close();
return false;
}
if(Wavhdr.RIFF!=0x46464952) return false;
if(Wavhdr.WAVE!=0x45564157) return false;

// read sub1 chunks, try to find a "FMT" chunk
SubChunk1 ch1;
while(file.Read(&ch1, sizeof(ch1)) && ch1.ID!=0x20746D66)
{
file.SeekTo(ch1.Subchunk1Size, GFFileSystem::seek_current);
}
if(ch1.ID!=0x20746D66)
return false;
FmtChunk fmt;
if(!file.Read(&fmt, sizeof(fmt)))
return false;
// skip extra fmt bytes
if(ch1.Subchunk1Size>16)
{
file.SeekTo(ch1.Subchunk1Size - 16, GFFileSystem::seek_current);
}

// find the DATA chunk
while(file.Read(&ch1, sizeof(ch1)) && ch1.ID!=0x61746164)
{
file.SeekTo(ch1.Subchunk1Size, GFFileSystem::seek_current);
}
if(ch1.ID!=0x61746164)
return false;

// Is this a stereo or mono file?
BOOL bStereo = fmt.wChnls > 1 ? TRUE : FALSE;
// Create the sound buffer for the wave file
if (!CreateSoundBuffer(ch1.Subchunk1Size, fmt.dwSRate, fmt.BitsPerSample, fmt.wBlkAlign, bStereo))
{
// Close the file
file.Close();
return false;
}

// Read the data for the wave file into the sound buffer
if (!ReadData(file, ch1.Subchunk1Size, 0xffffffff)) 
{
file.Close();
return false;
}
// Close out the wave file
file.Close();
return true;
}

// -------------------------------------------- //
// SFXSoundBuffer Clear
// -------------------------------------------- //
void SFXSoundBuffer::Clear()
{
FreeBuffer();
Init();
}

// -------------------------------------------- //
// SFXSoundBuffer Load
// -------------------------------------------- //
bool SFXSoundBuffer::Load(SFXSound* pDS, const char *Filename, int Num)
{
// Free before reload
Clear();

m_pDS = pDS;
if (Num<1) Num=1;
if (Num>4) Num=4;
m_nBuffers = Num;
m_Filename = Filename;

if(!m_pDS || !m_pDS->m_lpDS || !LoadFromFile()) // Try Load to buffer[0]
{
m_nBuffers=0;
m_Filename=NULL;
return false;
}

// Try duplicating if possible
for(int i = 1; i < m_nBuffers; i++)
{
m_pDS->m_lpDS->DuplicateSoundBuffer(m_lpDSB[0], &m_lpDSB[i]);
}
return true;
}

// -------------------------------------------- //
// SFXSoundBuffer Play
// volume : 0..100 (%) - linear
// -------------------------------------------- //
long SFXSoundBuffer::Play(int Pan, int volume, DWORD dwFlags)
{
if(!m_pDS || m_nBuffers==0 || !m_pDS->m_lpDS)
{
return -1;
}
HRESULT rval;
LPDIRECTSOUNDBUFFER Buffer = NULL;

Buffer = GetFreeBuffer();
if(Buffer == NULL)
{
return -1;
}

int vol_db = -10000; // silent == DSBVOLUME_MIN
if (volume > 0)
vol_db = (int)(20.0 * 100.0 * log10((double)volume/100.0));

// int vol = ((DSBVOLUME_MAX-DSBVOLUME_MIN) / 100) * volume  + DSBVOLUME_MIN;

Buffer->SetVolume( vol_db );
Buffer->SetPan(Pan);

rval = Buffer->Play(0, 0, dwFlags);
if(rval != DS_OK) return -1;
return m_Current;
}

// -------------------------------------------- //
// SFXSoundBuffer IsPlaying
// -------------------------------------------- //
bool SFXSoundBuffer::IsPlaying(long channel)
{
if (channel<0 || channel>=m_nBuffers) return false;

LPDIRECTSOUNDBUFFER	Buffer;
DWORD				Status;
HRESULT				rval;
Buffer = m_lpDSB[channel];
rval = Buffer->GetStatus(&Status);
if(rval < 0) Status = 0;
if((Status & DSBSTATUS_PLAYING) == DSBSTATUS_PLAYING)
{
return true;
}
return false;
}


// -------------------------------------------- //
// SFXSoundBuffer Stop
// -------------------------------------------- //
BOOL SFXSoundBuffer::Stop(int channel)
{
if(!m_pDS || m_nBuffers==0 || !m_pDS->m_lpDS) return FALSE;
HRESULT rval;

if(channel<0 || channel>=m_nBuffers)
{
for(int i = 0; i < m_nBuffers; i++)
{
rval = m_lpDSB[i]->Stop();
if(rval != DS_OK) return false;

rval = m_lpDSB[i]->SetCurrentPosition(0);
if(rval != DS_OK) return false;
}
}
else
{
rval = m_lpDSB[channel]->Stop();
if(rval != DS_OK) return false;

rval = m_lpDSB[channel]->SetCurrentPosition(0);
if(rval != DS_OK) return false;
}
return true;
}

// -------------------------------------------- //
// SFXSoundBuffer SetVolume
// -------------------------------------------- //
void SFXSoundBuffer::SetVolume(LONG Volume)
{
double vol = (double)DSBVOLUME_MAX * (double) Volume / 100.0;

if(!m_pDS || m_nBuffers==0 || !m_pDS->m_lpDS) return;
for(int i = 0; i < m_nBuffers; i++)
m_lpDSB[i]->SetVolume((LONG)vol);
}


#elif defined(WANT_SDL_MIXER)
//////////////////////////////////////////////////////////////////////////////////
//             S D L
//////////////////////////////////////////////////////////////////////////////////

SFXSound::SFXSound()
{
/*
#if defined(GPHWIZ)

#define SEE(a) printf("#define %-20s 0x%x\n", #a, a);

SEE( SNDCTL_DSP_SETFMT      );
SEE( SNDCTL_DSP_GETBLKSIZE  );
SEE( SNDCTL_DSP_CHANNELS    );
SEE( SNDCTL_DSP_SPEED       );
SEE( SNDCTL_DSP_SAMPLESIZE  );
SEE( SNDCTL_DSP_STEREO      );
SEE( SOUND_PCM_READ_BITS    );
SEE( AFMT_S16_NE    );


#endif

*/

m_IsSetup=0L;
/*
SDL_AudioSpec format;
memset(&sounds, 0, sizeof(NOW_PLAYING)*NUM_SOUNDS);

// Format: 16 Bit, stereo, 22 KHz
format.freq = 22050;
format.format = AUDIO_S16;
format.channels = 2;
format.samples = 512;        // good val
format.callback = mixeAudio;
format.userdata = NULL;
*/

int channels = 2;
int buffers=4096;
int frequency = 44100;
short format = MIX_DEFAULT_FORMAT;


#if defined(GP2X)
frequency = 22050;
buffers=256;
format = AUDIO_U8;
#endif

#if defined(GPHWIZ)
buffers=256;
frequency = 22050;
format = MIX_DEFAULT_FORMAT; // AUDIO_U16SYS;
#endif

#if defined(CAANOO)
buffers=256;
frequency = 22050;
format = MIX_DEFAULT_FORMAT; // AUDIO_U16SYS;
#endif

#if defined(PALM_WEBOS) || defined(PALM_PIXI)
frequency = 44100;
buffers = 1024;
//channels=1;
format = MIX_DEFAULT_FORMAT;
#endif

#if defined(ANDROID)
frequency = 44100;
// 512 makes SFXR sounds sound distorted!
buffers = 1024; // 512; // 1024 - the higher, the longer the pause. Oh, bad!
//channels=1;
format = MIX_DEFAULT_FORMAT;
#endif

if(Mix_OpenAudio(frequency, format, channels, buffers)==0)
{
#if !defined(EMSCRIPTEN)
Mix_Volume(-1, MIX_MAX_VOLUME);
#endif
Mix_VolumeMusic(MIX_MAX_VOLUME/2);
Mix_AllocateChannels(16);
//	SDL_PauseAudio(0);
m_IsSetup=1;
g_debug("open sound: %d Hz %d chan, buffers %d, format %d\n", frequency, channels, buffers, format);
}
else
{
printf("Can't init audio\n");
}
}


SFXSound::~SFXSound()
{
Mix_CloseAudio();
}

SFXSoundBuffer::SFXSoundBuffer(void)
{
m_cvt=NULL;
}
SFXSoundBuffer::~SFXSoundBuffer(void)
{
FreeBuffer();
}

void SFXSoundBuffer::Init(void)
{
FreeBuffer();
}

// -------------------------------------------- //
// SFXSoundBuffer Clear
// -------------------------------------------- //
void SFXSoundBuffer::Clear()
{
FreeBuffer();
Init();
}


bool SFXSoundBuffer::Load(SFXSound* pDS, const char* Filename, int Num)
{
Clear();
m_cvt = Mix_LoadWAV(Filename);
// Mix_LoadWAV_RW(SDL_RWops *src, int freesrc); <-- from memory block
return m_cvt ? true : false;
}

// -------------------------------------------- //
// SFXSoundBuffer IsPlaying
// -------------------------------------------- //
bool SFXSoundBuffer::IsPlaying(long channel)
{
if (!m_cvt) return false;
if(channel==-1) return false;
return Mix_Playing(channel) ? true:false;
}

long SFXSoundBuffer::Play(int Pan, int Volume, unsigned long dwFlags)
{
if (!m_cvt)
{
printf("play: m_cvt=NULL\n");
return -1;
}
Mix_VolumeChunk(m_cvt, (Volume*MIX_MAX_VOLUME)/100);
long channel = Mix_PlayChannel(-1, m_cvt, 0);
return channel;
}

long SFXSoundBuffer::Stop(int channel)
{
if (!m_cvt) return TRUE;
int rv = Mix_HaltChannel(channel); // -1 is all
return TRUE;
}

void SFXSoundBuffer::FreeBuffer()
{
if (m_cvt)
Mix_FreeChunk(m_cvt);
m_cvt=NULL;
}

// ################################################
#elif defined(_WIN32_WCE)

/*
[DllImport("aygshell.dll")]

internal static extern uint SndPlaySync(LPCTSTR file, DWORD flags);
internal static extern uint SndOpen(LPCTSTR file, int* phSound);
internal static extern uint SndPlayAsync(int* hSound, DWORD flags);
internal static extern uint SndClose(int* hSound);
internal static extern uint SndStop(int SoundScope, int* hSound);
*/

static HINSTANCE ghDLL=NULL;
#define LINK(name,import) name = m_hDll ? (PFN##name)GetProcAddress( m_hDll, TEXT(import) ) : NULL;

#define TYPDEF(rv, name, args) typedef rv ( __stdcall* PFN##name) args; PFN##name name = NULL;

TYPDEF(DWORD,SndPlaySync, (LPCTSTR file, DWORD flags));
TYPDEF(DWORD,SndOpen,     (LPCTSTR file, int* phSound));
TYPDEF(DWORD,SndPlayAsync,(int* hSound, DWORD flags));
TYPDEF(DWORD,SndClose,    (int* hSound));
TYPDEF(DWORD,SndStop,     (int SoundScope, int* hSound));
TYPDEF(HRESULT,SndGetWaitHandle, (int* hSound, HANDLE* phDoneEvent));

BOOL SFXSound::Create(HWND hwnd)
{
if(!ghDLL)
{
ghDLL = LoadLibrary(TEXT("aygshell.dll"));
if(!ghDLL) return FALSE;
LINK(SndPlaySync, "SndPlaySync");
LINK(SndOpen,     "SndOpen");
LINK(SndPlayAsync,"SndPlayAsync");
LINK(SndClose,    "SndClose");
LINK(SndStop,     "SndStop");
}
return TRUE;
}


BOOL SFXSound::GetCaps(void)
{
return SndOpen ? TRUE:FALSE;
}

SFXSoundBuffer::SFXSoundBuffer(void){m_pSound=NULL;}
SFXSoundBuffer::~SFXSoundBuffer(void)
{
if(m_pSound) SndClose(m_pSound);
m_psound=NULL;
}

void SFXSoundBuffer::Init(void)
{
if(m_pSound) SndClose(m_pSound);
m_psound=NULL;
}

void SFXSoundBuffer::Clear()
{
Init();
}

bool SFXSoundBuffer::Load(SFXSound* pDS, const char* Filename, int Num)
{
char fullpath[512];
GFFileSystem::MakeAbsolutePathCE(Filename, fullpath);
wchar_t path[512];
mbstowcs(path, fullpath, strlen(fullpath)+1);
// SndOpen
return false;
}
long SFXSoundBuffer::Play(int Pan = 0, int Volume=100, unsigned long dwFlags = 0);
bool SFXSoundBuffer::IsPlaying(long channel);
long SFXSoundBuffer::Stop(void);


#elif defined(APPLE_COREAUDIO)

#ifdef MACOSX

enum {
kSoundEngineErrUnitialized                      = 1,
kSoundEngineErrInvalidID                        = 2,
kSoundEngineErrFileNotFound                     = 3,
kSoundEngineErrInvalidFileFormat        = 4,
kSoundEngineErrDeviceNotFound           = 5
};
#include "glb.h" // #include "glb.h"
#include <CoreAudio/CoreAudioTypes.h>
#define DYLIB "SoundEngine.dylib"
DECLARE_C(glbSoundEngine_Initialize, DYLIB, (Float32 inMixerOutputRate), OSStatus );
DECLARE_C(glbSoundEngine_Teardown, DYLIB, (), OSStatus );
DECLARE_C(glbSoundEngine_SetMasterVolume, DYLIB, (Float32 inValue), OSStatus );
DECLARE_C(glbSoundEngine_SetListenerPosition, DYLIB, (Float32 inX, Float32 inY, Float32 inZ), OSStatus );
DECLARE_C(glbSoundEngine_SetListenerGain, DYLIB, (Float32 inValue), OSStatus );
DECLARE_C(glbSoundEngine_LoadBackgroundMusicTrack, DYLIB, (const char* inPath, Boolean inAddToQueue, Boolean inLoadAtOnce), OSStatus );
DECLARE_C(glbSoundEngine_UnloadBackgroundMusicTrack, DYLIB, (), OSStatus );
DECLARE_C(glbSoundEngine_StartBackgroundMusic, DYLIB, (), OSStatus );
DECLARE_C(glbSoundEngine_IsBackgroundMusicPlaying, DYLIB, (), int );
DECLARE_C(glbSoundEngine_StopBackgroundMusic, DYLIB, (Boolean inStopAtEnd), OSStatus );
DECLARE_C(glbSoundEngine_PauseBackgroundMusic, DYLIB, (Boolean bPause), void );
DECLARE_C(glbSoundEngine_SetBackgroundMusicVolume, DYLIB, (Float32 inValue), OSStatus );
DECLARE_C(glbSoundEngine_LoadLoopingEffect, DYLIB, (const char* inLoopFilePath, const char* inAttackFilePath, const char* inDecayFilePath, UInt32* outEffectID), OSStatus );
DECLARE_C(glbSoundEngine_LoadEffect, DYLIB, (const char* inPath, UInt32* outEffectID), OSStatus );
DECLARE_C(glbSoundEngine_UnloadEffect, DYLIB, (UInt32 inEffectID), OSStatus );
DECLARE_C(glbSoundEngine_StartEffect, DYLIB, (UInt32 inEffectID), OSStatus );
DECLARE_C(glbSoundEngine_IsEffectPlaying, DYLIB, (UInt32 inEffectID), int );
DECLARE_C(glbSoundEngine_StopEffect, DYLIB, (UInt32 inEffectID, Boolean inDoDecay), OSStatus );
DECLARE_C(glbSoundEngine_SetEffectPitch, DYLIB, (UInt32 inEffectID, Float32 inValue), OSStatus );
DECLARE_C(glbSoundEngine_SetEffectLevel, DYLIB, (UInt32 inEffectID, Float32 inValue), OSStatus );
DECLARE_C(glbSoundEngine_SetEffectPosition, DYLIB, (UInt32 inEffectID, Float32 inX, Float32 inY, Float32 inZ), OSStatus );
DECLARE_C(glbSoundEngine_SetEffectsVolume, DYLIB, (Float32 inValue), OSStatus );
DECLARE_C(glbSoundEngine_SetMaxDistance, DYLIB, (Float32 inValue), OSStatus );
DECLARE_C(glbSoundEngine_SetReferenceDistance, DYLIB, (Float32 inValue), OSStatus );

#else
#include "iphonesoundengine.h" // #include "iphonesoundengine.h"
#endif

SFXSound::SFXSound(void)
{
glbSoundEngine_Initialize(0);
glbSoundEngine_SetListenerPosition(0.0, 0.0, 0.0f);
}
SFXSound::~SFXSound(void)
{
glbSoundEngine_Teardown();
}
BOOL SFXSound::Create(HWND hwnd)	{return TRUE;}
BOOL SFXSound::GetCaps(void)		{return TRUE;}

SFXSoundBuffer::SFXSoundBuffer()		{for(int i=0; i<GLB_OPENAL_BUFFERS; ++i) effects[i]=0; }
SFXSoundBuffer::~SFXSoundBuffer()		{Clear();}
void SFXSoundBuffer::Init(void)			{Clear();}

void SFXSoundBuffer::Clear()
{
for(int i=0; i<GLB_OPENAL_BUFFERS; ++i)
if(effects[i])
{
glbSoundEngine_UnloadEffect(effects[i]);
effects[i]=0;
}
}

bool SFXSoundBuffer::Load(SFXSound* pDS, const char* Filename, int Num)
{
Clear();
if(Num>GLB_OPENAL_BUFFERS) Num=GLB_OPENAL_BUFFERS;
for(int i=0; i<Num; ++i)
{
OSStatus rv = glbSoundEngine_LoadEffect(Filename, &effects[i]);
printf("loadeffect - i: %d eff[i]: %d\n", i, (int)effects[i]);
if(rv != noErr )
{
g_debug("Can' init audio. Retcode: %d\n", (int)rv);
Clear();
return false;
}
}
return true;
}

long SFXSoundBuffer::Play(int Pan, int Volume, unsigned long dwFlags)
{
for(int i=0; i<GLB_OPENAL_BUFFERS; ++i)
{
if(effects[i] && !glbSoundEngine_IsEffectPlaying(effects[i]))
{
glbSoundEngine_SetEffectLevel(effects[i], (float)Volume / 100.0f);
glbSoundEngine_SetEffectPosition(effects[i], (float)Pan / (float)DXSOUND_PAN_RIGHT, 0.0f, 0.0f);
glbSoundEngine_StartEffect(effects[i]);
// printf("play - i: %d eff[i]: %d\n", i, effects[i]);
return i; // buffer index
}
else
{
// printf("no play2 - i: %d eff[i]: %d (isply: %d)\n", i, effects[i], glbSoundEngine_IsEffectPlaying(effects[i]));
}
}
return -1; // no free buffer
}

bool SFXSoundBuffer::IsPlaying(long channel)
{
if(channel<0 || channel>=GLB_OPENAL_BUFFERS) return false;
return glbSoundEngine_IsEffectPlaying(effects[channel]) ? true:false;
}
long SFXSoundBuffer::Stop(int channel)
{
if(channel<0 || channel>=GLB_OPENAL_BUFFERS) return 1;
glbSoundEngine_StopEffect(effects[channel], false);
return 1;
}


bool iPhonePlayMusic(const char* pFilename, bool bLoop)
{
glbSoundEngine_UnloadBackgroundMusicTrack(); // full stop

glbSoundEngine_UnloadBackgroundMusicTrack(); // just quit it and reset the position when you re-create the instance
int rv = (noErr == glbSoundEngine_LoadBackgroundMusicTrack(pFilename, false, false)
&& noErr == glbSoundEngine_StartBackgroundMusic());
if(rv && !bLoop)
glbSoundEngine_StopBackgroundMusic(true); // only play once
if(rv) return true;
return false;
}

void iPhonePauseMusic(bool bPause)
{
glbSoundEngine_PauseBackgroundMusic(bPause);
}
bool iPhoneIsMusicPlaying()
{
return glbSoundEngine_IsBackgroundMusicPlaying();
}
void iPhoneStopMusic()
{
glbSoundEngine_UnloadBackgroundMusicTrack(); // full stop
}
void iPhoneMusicVolume(float vol)
{
glbSoundEngine_SetBackgroundMusicVolume(vol);
}



#elif defined(WANT_SDL_WAVSOUND)


#include <SDL/SDL.h>

#define NUM_CHANNELS 8				     /* max number of sounds we can play at once */

void audioCallback(void *userdata, Uint8 * stream, int len);

struct
{
/* channel array holds information about currently playing sounds */
struct
{
Uint8 *position;        /* what is the current position in the buffer of this sound ? */
Uint32 remaining;       /* how many bytes remaining before we're done playing the sound ? */
Uint32 timestamp;       /* when did this sound start playing ? */
} channels[NUM_CHANNELS];
SDL_AudioSpec outputSpec;   /* what audio format are we using for output? */
int numSoundsPlaying;       /* how many sounds are currently playing */
} mixer;


SFXSound::SFXSound(void)
{
SDL_memset(&mixer, 0, sizeof(mixer));
}

SFXSound::~SFXSound(void)
{

}



BOOL SFXSound::Create(HWND hwnd)
{
// if (SDL_Init(SDL_INIT_AUDIO) < 0) - global call now

/* initialize the mixer */
SDL_memset(&mixer, 0, sizeof(mixer));
/* setup output format */
mixer.outputSpec.freq = 22050;
mixer.outputSpec.format = AUDIO_S16LSB;
mixer.outputSpec.channels = 2;
mixer.outputSpec.samples = 256;
mixer.outputSpec.callback = audioCallback;
mixer.outputSpec.userdata = NULL;

/* open audio for output */
if (SDL_OpenAudio(&mixer.outputSpec, NULL) != 0)
{
printf("Opening audio failed\n");
return FALSE;
}
}
BOOL SFXSound::GetCaps(void)
{
return TRUE;
}



SFXSoundBuffer::SFXSoundBuffer()
{
buffer=NULL; length=0;
}

SFXSoundBuffer::~SFXSoundBuffer()
{
if(buffer) Clear();
}

void SFXSoundBuffer::Init(void)
{
if(buffer) Clear();
}

void SFXSoundBuffer::Clear()
{
SDL_LockAudio();
if(buffer)
{
SDL_free(buffer);
}
buffer=NULL; length=0;
SDL_UnlockAudio();
}

bool SFXSoundBuffer::Load(SFXSound* pDS, const char* Filename, int Num)
{
Init();
SDL_AudioSpec spec;         /* the audio format of the .wav file */
SDL_AudioCVT cvt;           /* used to convert .wav to output format when formats differ */
int result;
if (SDL_LoadWAV(Filename, &spec, &this->buffer, &this->length) == NULL)
{
printf("could not load .wav %s\n", Filename);
return false;
}
/* build the audio converter */
result = SDL_BuildAudioCVT(&cvt, spec.format, spec.channels, spec.freq,
mixer.outputSpec.format,
mixer.outputSpec.channels,
mixer.outputSpec.freq);
if (result == -1)
{
printf("could not build audio CVT\n");
return false;
}
else if (result != 0)
{
/* 
this happens when the .wav format differs from the output format.
we convert the .wav buffer here
*/
cvt.buf = (Uint8 *) SDL_malloc(this->length * cvt.len_mult);       /* allocate conversion buffer */
cvt.len = this->length;    /* set conversion buffer length */
SDL_memcpy(cvt.buf, this->buffer, this->length);      /* copy sound to conversion buffer */
if (SDL_ConvertAudio(&cvt) == -1)
{     /* convert the sound */
printf("could not convert .wav %s\n", Filename);
}
SDL_free(this->buffer);    /* free the original (unconverted) buffer */
this->buffer = cvt.buf;    /* point sound buffer to converted buffer */
this->length = cvt.len_cvt;        /* set sound buffer's new length */
}
return true;
}

long SFXSoundBuffer::Play(int Pan, int Volume, unsigned long dwFlags)
{
SDL_LockAudio();
/*
find an empty channel to play on.
if no channel is available, use oldest channel
*/
int i;
int selected_channel = -1;
int oldest_channel = 0;

if (mixer.numSoundsPlaying == 0) {
/* we're playing a sound now, so start audio callback back up */
SDL_PauseAudio(0);
}

/* find a sound channel to play the sound on */
for (i = 0; i < NUM_CHANNELS; i++)
{
if (mixer.channels[i].position == NULL) {
/* if no sound on this channel, select it */
selected_channel = i;
break;
}
/* if this channel's sound is older than the oldest so far, set it to oldest */
if (mixer.channels[i].timestamp <
mixer.channels[oldest_channel].timestamp)
oldest_channel = i;
}

/* no empty channels, take the oldest one */
if (selected_channel == -1)
selected_channel = oldest_channel;
else
mixer.numSoundsPlaying++;

/* point channel data to wav data */
mixer.channels[selected_channel].position = this->buffer;
mixer.channels[selected_channel].remaining = this->length;
mixer.channels[selected_channel].timestamp = SDL_GetTicks();
SDL_UnlockAudio();

return selected_channel;
}

bool SFXSoundBuffer::IsPlaying(long channel)
{
int rv=0;
SDL_LockAudio();
if(	channel>0 && channel<NUM_CHANNELS
&& mixer.numSoundsPlaying && mixer.channels[channel].position)
rv=1;
SDL_UnlockAudio();
return rv;
}


long SFXSoundBuffer::Stop(int channel)
{
SDL_LockAudio();
if(	channel>0 && channel<NUM_CHANNELS && mixer.numSoundsPlaying && mixer.channels[channel].position)
{
mixer.channels[channel].position = NULL;
--mixer.numSoundsPlaying;
}
else
{
for (int i = 0; i < NUM_CHANNELS; i++)
{
mixer.channels[i].position = NULL;
}
mixer.numSoundsPlaying=0;
}
SDL_UnlockAudio();
}



/* 
Called from SDL's audio system.  Supplies sound input with data by mixing together all
currently playing sound effects.
*/
void audioCallback(void *userdata, Uint8 * stream, int len)
{
int i;
int copy_amt;
SDL_memset(stream, mixer.outputSpec.silence, len);  /* initialize buffer to silence */
/* for each channel, mix in whatever is playing on that channel */
for (i = 0; i < NUM_CHANNELS; i++) {
if (mixer.channels[i].position == NULL) {
/* if no sound is playing on this channel */
continue;           /* nothing to do for this channel */
}

/* copy len bytes to the buffer, unless we have fewer than len bytes remaining */
copy_amt =
mixer.channels[i].remaining <
len ? mixer.channels[i].remaining : len;

/* mix this sound effect with the output */
SDL_MixAudioFormat(stream, mixer.channels[i].position,
mixer.outputSpec.format, copy_amt, 150);

/* update buffer position in sound effect and the number of bytes left */
mixer.channels[i].position += copy_amt;
mixer.channels[i].remaining -= copy_amt;

/* did we finish playing the sound effect ? */
if (mixer.channels[i].remaining == 0) {
mixer.channels[i].position = NULL;  /* indicates no sound playing on channel anymore */
mixer.numSoundsPlaying--;
if (mixer.numSoundsPlaying == 0) {
/* if no sounds left playing, pause audio callback */
SDL_PauseAudio(1);
}
}
}
}



#else // no sound engine (console)
void glb_dxsound_console_dummy() {};

#endif

